/*  Module Name: @(#)ACSE.h	7.1
    Version: 11/15/96
    Author: Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description: DBV-OSI II API code to gain information from the ACSE 
	configuration file 
 
*/

#ifndef ACSE_H
#define ACSE_H

#include "z3950_includes.h"


/* Used within this ACSE module only! */
DbvBool DBVbSR, DBVbZ3950;

int DBVDoesFileExist(DbvError **ppsError);
int DBVGetACNAtTarget( char **ppcContext, DbvAssociationState eAssociationState,
	DbvError **ppsError);
int DBVGetACN(char **ppcContext, DbvAssociationState eAssociationState,
	DBVOriginOrTarget eOorT, DbvError **ppsError);
int DBVReadACNs(TBL InTBL, char **ppcContext, DbvAssociationState
	eAssociationState, DBVOriginOrTarget eOorT, DbvError **ppsError);
int DBVValidateACN(char **ppcACNs, DbvAssociationState eAssociationState,
	DBVOriginOrTarget eOorT, DbvError **ppsError);
char *DBVConvertToOID(char *pcTempContext);

#ifndef NO_OSI
int DBVGetPCDL(struct PSAPctxlist *psPresentationContextList,
	DbvAssociationState eAssociationState, DbvError **ppsError);
int DBVReadPCDLs(TBL InTbl, struct PSAPctxlist *psPresentationContextList,
	DbvAssociationState eAssociationState, DbvError **ppsError);

int DBVAddTheApplicationContexts(struct PSAPctxlist *psPresentationContextList,
        DbvError **ppsError);
#endif

void DBVGetSupportedContexts(DbvBool *bSR, DbvBool *bZ3950);

int DBVMatchPresentationContext(char *pcProposedContext, DbvBool *pbMatched,
        DbvError **ppsError);
int DBVComparePC(TBL InTbl, char *pcPropsedContext, DbvBool *pbMatched,
        DbvError **ppsError);

char *DBVGetFieldTypeString(int dFieldType);

#endif

