/*  Module Name: @(#)address_by_name.h	7.1
    Version: 11/15/96
    Author: John Hough/Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description: DBV-OSI II API Functions used to read in the file
        target_names.tbl and map a given name onto a complete address

 
*/

#ifndef ADDRESS_BY_NAME_H
#define ADDRESS_BY_NAME_H

#include "z3950_includes.h"
#include "tbl.h"

extern char DBVErrorBuffer[];

#define DBV_OSI_NAME 3

/* The main function. Called in DbvAssociateRequest to find and complete
	an address. */
int DBVConvertNameToAddress(char *pcTargetName,
	DbvTargetInformation **ppsTargetInformation, DbvError **ppsError);

int DBVCompleteAddress(DbvTargetInformation **ppsTargetInformation, TBL InTbl,
	TBL_Return T_Return,DbvError **ppsError);

#ifndef NO_OSI
int DBVCheckISOENTITIESFile(char *pcTargetName, DbvTargetInformation
	**ppsTargetInformation, DbvBool *plFinished, DbvError **ppsError);
#endif

char *DBVGetStringField(TBL Table, TBL_Return T_Return, DbvError **ppsError);

char *DBVGetCharField(TBL Table, TBL_Return T_Return, DbvError **ppsError);


#endif

