#include "api_shared_close.h"


int fill_close_request(DbvCloseReq *psCloseReq)
{
        char *test_reference_id = "close request reference id";
	char *test_resrepformat = ISO_RESOURCE_REPORT_2;

        int choice = 0;
        char choice_string[100];
 
        /* Compulsory fields */
 
        /* eCloseReason */
        psCloseReq->eCloseReason = CR_Resources;
 

        /* Optional fields */
        /* Reference id */
        psCloseReq->psReferenceId = (DbvOctetString *) DbvAlloc(sizeof(DbvOctetString));
        fill_dbv_octet_string(psCloseReq->psReferenceId, test_reference_id);
 
     
	/* psDiagnosticInformation */
	psCloseReq->psDiagnosticInformation = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psCloseReq->psDiagnosticInformation, "close request diagnostic information");

	/* pcResourceReportFormat */
	psCloseReq->pcResourceReportFormat = (DbvObjectIdentifier) DbvAlloc (strlen(test_resrepformat) + 1);
	memcpy(psCloseReq->pcResourceReportFormat, test_resrepformat, strlen(test_resrepformat));


	/* psResourceReport */
	psCloseReq->psResourceReport = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));
        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter psResourceReport choice: DbvResourceReport1 (1), DbvResourceReport2 (2): ");
                choice = (atol(gets(choice_string)));
        }
 

        switch (choice) {
        case 1:
                fill_dbv_resrep1_external(psCloseReq->psResourceReport);
                break;
        case 2:
                fill_dbv_resrep2_external(psCloseReq->psResourceReport);
                break;
	}


        /* OtherInformation */
        psCloseReq->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc(sizeof(DbvOtherInformation *) * 3);
        psCloseReq->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
        psCloseReq->ppsOtherInformation[1] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
 
        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter psOtherInformation type (for 2 list nodes): char (1), bin (2), ext (3), other (4): ");
                choice = (atol(gets(choice_string)));
        }
 
        switch (choice) {
        case 1:
                fill_closereq_othinfo_char(psCloseReq->ppsOtherInformation[0]);
                fill_closereq_othinfo_char(psCloseReq->ppsOtherInformation[1]);
                break;
        case 2:
                fill_closereq_othinfo_bin(psCloseReq->ppsOtherInformation[0]);
                fill_closereq_othinfo_bin(psCloseReq->ppsOtherInformation[1]);
                break;
        case 3:
                fill_closereq_othinfo_ext(psCloseReq->ppsOtherInformation[0]);
                fill_closereq_othinfo_ext(psCloseReq->ppsOtherInformation[1]);
                break;
        case 4:
                fill_closereq_othinfo_obj(psCloseReq->ppsOtherInformation[0]);
                fill_closereq_othinfo_obj(psCloseReq->ppsOtherInformation[1]);
                break;
        }
}
 
 
 
int fill_closereq_othinfo_char(DbvOtherInformation *psOtherInformation)
{
 
        char oid[100];
        char charinfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 27;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(charinfo, "this is my close request otherinfo char field");
 
        fill_dbv_otherinfo_char(psOtherInformation, want_infocat, oid, catvalue, charinfo);
}
 
 
 
int fill_closereq_othinfo_bin(DbvOtherInformation *psOtherInformation)
{
        char oid[100];
        char bininfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 33;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my close request otherinfo bin field");
 
        fill_dbv_otherinfo_bin(psOtherInformation, want_infocat, oid, catvalue, bininfo);
}
 
 

int fill_closereq_othinfo_ext(DbvOtherInformation *psOtherInformation)
{
        char oid[100];
        char bininfo[100];
        char sutrs_string[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 47;
        DbvASN1External *external = NULL;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my close request otherinfo bin field");
        strcpy(sutrs_string, "this is my sutrs string - Delete Request");
 
        fill_dbv_otherinfo_ext(psOtherInformation, want_infocat, oid, catvalue);
 
        /* Set up a sutrs external */
        external = psOtherInformation->uInformation.psExternallyDefinedInfo;
        fill_dbv_sutrs_external(external, sutrs_string);
}
 
 
 
int fill_closereq_othinfo_obj(DbvOtherInformation *psOtherInformation)
{
        char infooid[100];
        char otheroid[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 47;
 
        strcpy(infooid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(otheroid, ANSI_UNSTRUCTURED_TEXT_RECORD);
 
        fill_dbv_otherinfo_obj(psOtherInformation, want_infocat, infooid, catvalue, otheroid);
}
 
 

