
#include "api_target_explain_pres.h"

/* zraw prefix to avoid clash with cip pseudo explain database functions */
/* o = optional */
/* c = compulsory */



/* zraw_fill_DbvExplainRecord() is equivalent to 
   load_example_explain_database() in main.c */

void zraw_fill_DbvExplainRecord(DbvExplainRecord *psExplainRecord)
{
	int choice = -1;

        zraw_print_structure_menu();
	choice = get_menu_choice();
	do_chosen_option(choice, psExplainRecord);
}
	



void
zraw_print_structure_menu()
{
        printf("\n");
        printf("Choose Explain Structure\n");
        printf("===================\n");
        printf("  1) TargetInfo\n");
        printf("  2) DatabaseInfo\n");
        printf("  3) SchemaInfo\n");
        printf("  4) TagSetInfo\n");
        printf("  5) RecordSyntaxInfo\n");
        printf("  6) AttributeSetInfo\n");
        printf("  7) TermListInfo\n");
        printf("  8) ExtendedServicesInfo\n");
        printf("  9) AttributeDetails\n");
        printf(" 10) TermListDetails\n");
        printf(" 11) ElementSetDetails\n");
        printf(" 12) RetrievalRecordDetails\n");
        printf(" 13) SortDetails\n");
        printf(" 14) ProcessingInformation\n");
        printf(" 15) VariantSetInfo\n");
        printf(" 16) UnitInfo\n");
        printf(" 17) CategoryList\n");
        printf("\n");
        printf("Enter choice: ");
} 



int get_menu_choice(void)
{
        char resp[100];
        int rv = 0;

	rv = atoi(gets(resp));
        while (rv < 1 || rv > 17) {
                zraw_print_structure_menu();
                rv = atoi(gets(resp));
                printf("\n");
	}

	return rv;
}



void do_chosen_option(int choice, DbvExplainRecord *psExplainRecord)
{
	switch (choice) {

	/* DbvTargetInfo */
	case 1:
		zraw_setup_DbvTargetInfo(psExplainRecord);
		break;

	/* DbvDatabaseInfo */
	case 2:
		zraw_setup_DbvDatabaseInfo(psExplainRecord);
		break;

	/* DbvSchemaInfo */
	case 3:
		zraw_setup_DbvSchemaInfo(psExplainRecord);
		break;

	/* DbvTagSetInfo */
	case 4:
		zraw_setup_DbvTagSetInfo(psExplainRecord);
		break;

	/* DbvRecordSyntaxInfo */
	case 5:
		zraw_setup_DbvRecordSyntaxInfo(psExplainRecord);
		break;

	/* DbvAttributeSetInfo */
	case 6:
		zraw_setup_DbvAttributeSetInfo(psExplainRecord);
		break;

	/* DbvTermListInfo */
	case 7:
		zraw_setup_DbvTermListInfo(psExplainRecord);
		break;

	/* DbvExtendedServicesInfo */
	case 8:
		zraw_setup_DbvExtendedServicesInfo(psExplainRecord);
		break;

	/* DbvAttributeDetails */
	case 9:
		zraw_setup_DbvAttributeDetails(psExplainRecord);
		break;

	/* DbvTermListDetails */
	case 10:
		zraw_setup_DbvTermListDetails(psExplainRecord);
		break;

	/* DbvElementSetDetails */
	case 11:
		zraw_setup_DbvElementSetDetails(psExplainRecord);
		break;

	/* DbvRetrievalRecordDetails */
	case 12:
		zraw_setup_DbvRetrievalRecordDetails(psExplainRecord);
		break;

	/* DbvSortDetails */
	case 13:
		zraw_setup_DbvSortDetails(psExplainRecord);
		break;

	/* DbvProcessingInformation */
	case 14:
		zraw_setup_DbvProcessingInformation(psExplainRecord);
		break;

	/* DbvVariantSetInfo */
	case 15:
		zraw_setup_DbvVariantSetInfo(psExplainRecord);
		break;

	/* DbvUnitInfo */
	case 16:
		zraw_setup_DbvUnitInfo(psExplainRecord);
		break;

	/* DbvCategoryList */
	case 17:
		zraw_setup_DbvCategoryList(psExplainRecord);
		break;
	}
}



/*-------------------------- DbvTargetInfo ----------------------*/

void zraw_setup_DbvTargetInfo(DbvExplainRecord *psExplainRecord)
{
        DbvTargetInfo *psTargetInfo = NULL;

      	psTargetInfo = (DbvTargetInfo*) DbvAlloc(sizeof(DbvTargetInfo));

	zraw_fill_DbvTargetInfo(psTargetInfo);

	/* Assign the explain record formed to the Dbv structure */
	psExplainRecord->eExplainRecordType = ERT_TargetInfo;

	psExplainRecord->uExplainRecord.psTargetInfo = psTargetInfo;
}



void zraw_fill_DbvTargetInfo(DbvTargetInfo *psTargetInfo)
{
	/* o */
	psTargetInfo->psCommonInfo = zraw_fill_DbvCommonInfo();

	/* c */
	fill_dbv_inter_string(&psTargetInfo->sName, "targetinfo database name");

	/* o */
	psTargetInfo->ppsRecentNews = zraw_fill_DbvHumanString_list();

	/* o */
	psTargetInfo->ppsIcon = zraw_fill_DbvIconObject_list();

	/* c */
	psTargetInfo->fNamedResultSets = DBV_FALSE;

	/* c */
	psTargetInfo->fMultipleDBSearch = DBV_TRUE;

	/* o */
	psTargetInfo->pulMaxResultSets = zraw_fill_Ulong();

	/* o */
	psTargetInfo->pulMaxResultSize = zraw_fill_Ulong();

	/* o */
	psTargetInfo->pulMaxTerms = zraw_fill_Ulong();

	/* o */
	psTargetInfo->psTimeoutInterval = zraw_fill_DbvIntUnit();

	/* o */
	psTargetInfo->ppsWelcomeMessage = zraw_fill_DbvHumanString_list();

	/* o */
	psTargetInfo->psContactInfo = zraw_fill_DbvContactInfo();

	/* o */
	psTargetInfo->ppsDescription = zraw_fill_DbvHumanString_list();

	/* o */
	psTargetInfo->ppsNicknames = zraw_fill_DbvInternationalString_list();

	/* o */
	psTargetInfo->ppsUsageRest = zraw_fill_DbvHumanString_list();

	/* o */
	psTargetInfo->ppsPaymentAddr = zraw_fill_DbvHumanString_list();

	/* o */
	psTargetInfo->ppsHours = zraw_fill_DbvHumanString_list();

	/* o */
	psTargetInfo->ppsDbCombinations = zraw_fill_DbvDatabaseList();

	/* o */
	psTargetInfo->ppsAddresses = zraw_fill_dbv_networkaddr();

	/* o */
	psTargetInfo->ppsLanguages = zraw_fill_DbvInternationalString_list();

	/* o */
	psTargetInfo->psCommonAccessInfo = zraw_fill_DbvAccessInfo();

}



DbvCommonInfo *	
zraw_fill_DbvCommonInfo(void)
{
	DbvCommonInfo *psCommonInfo = NULL;
	


	psCommonInfo = (DbvCommonInfo *)DbvAlloc(sizeof(DbvCommonInfo));


	/* o */
	psCommonInfo->pcDateAdded = zraw_fill_DbvGeneralizedTime("121212");

	/* o */
	psCommonInfo->pcDateChanged = zraw_fill_DbvGeneralizedTime("3434");

	/* o */
	psCommonInfo->pcExpiry = zraw_fill_DbvGeneralizedTime("56565656");

	/* o */
	psCommonInfo->psHumanStringLanguage = zraw_fill_DbvInternationalString("human string language");

	/* o */
	psCommonInfo->ppsOtherInformation = zraw_fill_DbvOtherInformation_list();


	return psCommonInfo;
}



DbvGeneralizedTime
zraw_fill_DbvGeneralizedTime(char *s)
{
	DbvGeneralizedTime pcGenTime;

	pcGenTime = (DbvGeneralizedTime )DbvAlloc(strlen(s) + 1);
	strcpy(pcGenTime, s);

	return pcGenTime;
}



DbvInternationalString *
zraw_fill_DbvInternationalString(char *s)
{
	DbvInternationalString *psInter;

	psInter = (DbvInternationalString *)DbvAlloc(sizeof(DbvInternationalString));
	fill_dbv_inter_string(psInter, s);

	return psInter;
}



DbvOtherInformation ** 
zraw_fill_DbvOtherInformation_list(void)
{
	int i = 0;

	DbvOtherInformation **ppsOtherInformation = NULL;

	ppsOtherInformation = (DbvOtherInformation **) DbvAlloc (sizeof(DbvOtherInformation *) * 5);

	for (i = 0; i < 5; i++)
		ppsOtherInformation[i] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));

	/* terminate the list */
	ppsOtherInformation[4] = NULL;

	/* 4 otherinformation nodes - all different */
       	zraw_fill_DbvOtherInformation_char(ppsOtherInformation[0]);
       	zraw_fill_DbvOtherInformation_bin(ppsOtherInformation[1]);
       	zraw_fill_DbvOtherInformation_ext(ppsOtherInformation[2]);
       	zraw_fill_DbvOtherInformation_obj(ppsOtherInformation[3]);


	return ppsOtherInformation;
}



void 
zraw_fill_DbvOtherInformation_char(DbvOtherInformation *psOtherInformation)
{
 
        char oid[100];
        char charinfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 27;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(charinfo, "this is an otherinfo char field");
 
        fill_dbv_otherinfo_char(psOtherInformation, want_infocat, oid, catvalue, charinfo);
}
 


void 
zraw_fill_DbvOtherInformation_bin(DbvOtherInformation *psOtherInformation)
{
        char oid[100];
        char bininfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 33;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is an otherinfo bin field");
 
        fill_dbv_otherinfo_bin(psOtherInformation, want_infocat, oid, catvalue, bininfo);
}



void 
zraw_fill_DbvOtherInformation_ext(DbvOtherInformation *psOtherInformation)
{
        char oid[100];
        char bininfo[100];
        char sutrs_string[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 47;
        DbvASN1External *external = NULL;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is an otherinfo bin field");
        strcpy(sutrs_string, "sutrs string");
 
        fill_dbv_otherinfo_ext(psOtherInformation, want_infocat, oid, catvalue);
 
        /* Set up a sutrs external */
        external = psOtherInformation->uInformation.psExternallyDefinedInfo;
        fill_dbv_sutrs_external(external, sutrs_string);
}
 


void 
zraw_fill_DbvOtherInformation_obj(DbvOtherInformation *psOtherInformation)
{
        char infooid[100];
        char otheroid[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 47;
 
        strcpy(infooid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(otheroid, ANSI_UNSTRUCTURED_TEXT_RECORD);
 
        fill_dbv_otherinfo_obj(psOtherInformation, want_infocat, infooid, catvalue, otheroid);
}



DbvHumanString **
zraw_fill_DbvHumanString_list(void)
{
	DbvHumanString **ppsHumanString = NULL, 
			*psHumanString = NULL,
			**start = NULL;

	char *lang1 = "language 1", *s1 = "string 1";
	char *lang2 = "language 2", *s2 = "string 2" ;


	/* 2 nodes  0, 1 \0 */
	ppsHumanString = start = (DbvHumanString **)DbvAlloc(sizeof(DbvHumanString *) * 3);

	/* first node */
	psHumanString = (DbvHumanString *)DbvAlloc(sizeof(DbvHumanString));
	*ppsHumanString = psHumanString;

	/* o */
	psHumanString->psLanguage = (DbvLanguageCode *)DbvAlloc(strlen(lang1)+1);
	fill_dbv_inter_string(psHumanString->psLanguage, lang1);

	/* c */
	fill_dbv_inter_string(&psHumanString->sText, s1);


	ppsHumanString++;

	/* second node */
	psHumanString = (DbvHumanString *)DbvAlloc(sizeof(DbvHumanString));
	*ppsHumanString = psHumanString;

	/* o */
	psHumanString->psLanguage = (DbvLanguageCode *)DbvAlloc(strlen(lang2)+1);
	fill_dbv_inter_string(psHumanString->psLanguage, lang2);

	/* c */
	fill_dbv_inter_string(&psHumanString->sText, s2);

	/* Terminate the list (not really needed because we used
	   DbvAlloc) */
	ppsHumanString[2] = NULL;

	return start;
}



DbvIconObject **
zraw_fill_DbvIconObject_list(void)
{
	DbvIconObject **ppsIconObject = NULL, 
			**start = NULL, 		
			*psIconObject = NULL;

	ppsIconObject = start = (DbvIconObject **)DbvAlloc(sizeof(DbvIconObject *) * 4);

	/* first node */
	psIconObject = (DbvIconObject *)DbvAlloc(sizeof(DbvIconObject));
	*ppsIconObject = psIconObject;

	/* c */
	zraw_fill_DbvBodyType(&psIconObject->sBodyType, BTT_IanaType);

	/* c */
	fill_dbv_octet_string(&psIconObject->sContent, "first icon octet");

	ppsIconObject++;


	/* second node */
	psIconObject = (DbvIconObject *)DbvAlloc(sizeof(DbvIconObject));
	*ppsIconObject = psIconObject;

	/* c */
	zraw_fill_DbvBodyType(&psIconObject->sBodyType, BTT_Z3950Type);

	/* c */
	fill_dbv_octet_string(&psIconObject->sContent, "second icon octet");

	ppsIconObject++;

	/* third node */
	psIconObject = (DbvIconObject *)DbvAlloc(sizeof(DbvIconObject));
	*ppsIconObject = psIconObject;

	/* c */
	zraw_fill_DbvBodyType(&psIconObject->sBodyType, BTT_OtherType);

	/* c */
	fill_dbv_octet_string(&psIconObject->sContent, "third icon octet");

	ppsIconObject++;

	/* terminate the list */
	start[3] = NULL;


	return start;
}



void 
zraw_fill_DbvBodyType(DbvBodyType *psBodyType, DbvBodyTypeType eBodyTypeType)
{
	switch (eBodyTypeType) {
	case BTT_IanaType:
		psBodyType->eBodyTypeType = BTT_IanaType;
		psBodyType->uBodyType.psIanaType = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
		fill_dbv_inter_string(psBodyType->uBodyType.psIanaType, "IanaType string");
		break;
	case BTT_Z3950Type:
		psBodyType->eBodyTypeType = BTT_Z3950Type;
		psBodyType->uBodyType.psZ3950Type = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
		fill_dbv_inter_string(psBodyType->uBodyType.psZ3950Type, "Z3950Type string");
		break;
	case BTT_OtherType:
		psBodyType->eBodyTypeType = BTT_OtherType;
		psBodyType->uBodyType.psOtherType = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
		fill_dbv_inter_string(psBodyType->uBodyType.psOtherType, "OtherType string");
		break;
	}
}



Ulong *
zraw_fill_Ulong(void)
{
	Ulong *ptr;

	ptr = (Ulong *) DbvAlloc(sizeof(Ulong));

	/* arbitrary value */
	*ptr = 333;

	return ptr;
}



DbvIntUnit *
zraw_fill_DbvIntUnit(void)
{
	DbvIntUnit *psDbvIntUnit = NULL;

	psDbvIntUnit = (DbvIntUnit *) DbvAlloc (sizeof (DbvIntUnit));

	/* c */
        psDbvIntUnit->ulValue = 55;

	/* c */
        psDbvIntUnit->sUnitUsed = *(zraw_fill_DbvUnit());

	return psDbvIntUnit;
}



DbvContactInfo *
zraw_fill_DbvContactInfo(void)
{
	DbvContactInfo *psContactInfo;

	psContactInfo = (DbvContactInfo *)DbvAlloc(sizeof(DbvContactInfo));

	/* o */
	psContactInfo->psName = (DbvInternationalString *)DbvAlloc(sizeof(DbvInternationalString));
	fill_dbv_inter_string(psContactInfo->psName, "contact info name");

	/* o */
	psContactInfo->ppsDescription = zraw_fill_DbvHumanString_list();

	/* o */
	psContactInfo->psEmail = (DbvInternationalString *)DbvAlloc(sizeof(DbvInternationalString));
	fill_dbv_inter_string(psContactInfo->psEmail, "email info");

	/* o */
	psContactInfo->psPhone = (DbvInternationalString *)DbvAlloc(sizeof(DbvInternationalString));
	fill_dbv_inter_string(psContactInfo->psPhone, "phone number");

	return psContactInfo;
}



DbvInternationalString **
zraw_fill_DbvInternationalString_list(void)
{
	DbvInternationalString **ppsInnerDatabases = NULL;

	ppsInnerDatabases = (DbvInternationalString **) DbvAlloc(sizeof(DbvInternationalString *) * 3);

	ppsInnerDatabases[0] = (DbvInternationalString *) DbvAlloc(sizeof(DbvInternationalString));
	ppsInnerDatabases[1] = (DbvInternationalString *) DbvAlloc(sizeof(DbvInternationalString));
	ppsInnerDatabases[2] = NULL;

	/* c */
	fill_dbv_inter_string(ppsInnerDatabases[0], "first inner databases");
	fill_dbv_inter_string(ppsInnerDatabases[1], "second inner databases");


	return ppsInnerDatabases;
}



DbvDatabaseList **
zraw_fill_DbvDatabaseList(void)
{	

	DbvDatabaseList **ppsDbCombinations = NULL;

	ppsDbCombinations = (DbvDatabaseList **) DbvAlloc(sizeof(DbvDatabaseList *) * 3);


	ppsDbCombinations[0] = (DbvDatabaseList *) DbvAlloc (sizeof (DbvDatabaseList));

	ppsDbCombinations[1] = (DbvDatabaseList *) DbvAlloc (sizeof (DbvDatabaseList));
	ppsDbCombinations[2] = NULL;

	ppsDbCombinations[0]->ppsInnerDatabases = zraw_fill_DbvInternationalString_list();
	ppsDbCombinations[1]->ppsInnerDatabases = zraw_fill_DbvInternationalString_list();


	return ppsDbCombinations;
}





DbvNetworkAddress **
zraw_fill_dbv_networkaddr(void)
{
	DbvNetworkAddress **ppsNetwork = NULL, **start = NULL;

	/* 5 nodes - 0, 1, 2, 3, \0 */
	ppsNetwork = start = (DbvNetworkAddress **)DbvAlloc(5 * (sizeof (DbvNetworkAddress*)));

	/* an internet address  - node 0 */
	*ppsNetwork = zraw_fill_dbv_internet_networkaddr();

	/* an osi address - node 1 */
	++ppsNetwork;
	*ppsNetwork = zraw_fill_dbv_osi_networkaddr();

	/* an other address  - node 2 */
	++ppsNetwork;
	*ppsNetwork = zraw_fill_dbv_other_networkaddr();

	/* list terminator - node 3 */
	++ppsNetwork;
	*ppsNetwork = NULL;

	return start;
}



DbvNetworkAddress *
zraw_fill_dbv_internet_networkaddr(void)
{
	DbvNetworkAddress *psNetwork = NULL;
	DbvInterAddress *psInter = NULL;

	psNetwork = (DbvNetworkAddress *)DbvAlloc(sizeof(DbvNetworkAddress));
	psNetwork->eNetworkAddressType = NAT_InternetAddress;


	psInter = (DbvInterAddress *)DbvAlloc(sizeof(DbvInterAddress));
	psNetwork->uNetworkAddress.psInternetAddress = psInter;

	/* c */
	fill_dbv_inter_string(&psInter->sHostAddress, "pm@parl.uk");

	/* c */
	psInter->ulPort = 987;

	return psNetwork;
}




DbvNetworkAddress *
zraw_fill_dbv_osi_networkaddr(void)
{
	DbvNetworkAddress *psNetwork = NULL;
	DbvOsiPresentationAddress *psOsi = NULL;

	psNetwork = (DbvNetworkAddress *)DbvAlloc(sizeof(DbvNetworkAddress));

	psNetwork->eNetworkAddressType = NAT_OsiPresentationAddress;


	psOsi = (DbvOsiPresentationAddress *)DbvAlloc(sizeof(DbvOsiPresentationAddress));
	psNetwork->uNetworkAddress.psOsiPresentationAddress = psOsi;


	/* c Psel */
	fill_dbv_inter_string(&psOsi->sPsel, "psel value");

	/* o SSel */
	psOsi->psSSel = (DbvInternationalString *)DbvAlloc(sizeof(DbvInternationalString));
	fill_dbv_inter_string(psOsi->psSSel, "ssel value");

	/* o TSel */
	psOsi->psTSel = (DbvInternationalString *)DbvAlloc(sizeof(DbvInternationalString));
	fill_dbv_inter_string(psOsi->psTSel, "tsel value");
	
	/* c NSap */
	fill_dbv_inter_string(&psOsi->sNSap, "nsap value");


	return psNetwork;
}





DbvNetworkAddress *
zraw_fill_dbv_other_networkaddr(void)
{
	DbvNetworkAddress *psNetwork = NULL;
	DbvOtherAddress *psOther = NULL;

	psNetwork = (DbvNetworkAddress *)DbvAlloc(sizeof(DbvNetworkAddress));

	psNetwork->eNetworkAddressType = NAT_OtherAddress;


	psOther = (DbvOtherAddress *)DbvAlloc(sizeof(DbvOtherAddress));
	psNetwork->uNetworkAddress.psOtherAddress = psOther;

	/* c Type */
	fill_dbv_inter_string(&psOther->sType, "other address - type");

	/* c Address */
	fill_dbv_inter_string(&psOther->sAddress, "other address - address");


	return psNetwork;
}





DbvAccessInfo *
zraw_fill_DbvAccessInfo(void)
{
	DbvAccessInfo *psCommonAccessInfo = NULL;

	psCommonAccessInfo = (DbvAccessInfo *) DbvAlloc (sizeof (DbvAccessInfo));

	/* o */	
	psCommonAccessInfo->ppsQueryTypesSupported = zraw_fill_DbvQueryTypeDetails();
	/* o */
	psCommonAccessInfo->ppcDiagnosticsSets = zraw_fill_DbvObjectIdentifier_list();
	/* o */
	psCommonAccessInfo->ppcAttributeSetIds = zraw_fill_DbvObjectIdentifier_list();
	/* o */
	psCommonAccessInfo->ppcSchemas = zraw_fill_DbvObjectIdentifier_list();
	/* o */
	psCommonAccessInfo->ppcRecordSyntaxes = zraw_fill_DbvObjectIdentifier_list();
	/* o */
	psCommonAccessInfo->ppcResourceChallenges = zraw_fill_DbvObjectIdentifier_list();
	
	/* o */
	psCommonAccessInfo->ppsRestrictedAccess = zraw_fill_DbvAccessRestrictions_list();
	/* o */
	psCommonAccessInfo->psCostInfo = zraw_fill_DbvCosts();
	
	/* o */
	psCommonAccessInfo->ppcVariantSets = zraw_fill_DbvObjectIdentifier_list();

	/* o */
	psCommonAccessInfo->ppsElementSetNames = zraw_fill_DbvInternationalString_list();

	/* c */
	psCommonAccessInfo->ppsUnitSystems = zraw_fill_DbvInternationalString_list();


	return psCommonAccessInfo;
}



DbvQueryTypeDetails **
zraw_fill_DbvQueryTypeDetails(void)
{
	int i = 0;
	DbvQueryTypeDetails **ppsQueryTypesSupported = NULL;

	/* 7: 0 -> 6 */
	ppsQueryTypesSupported = (DbvQueryTypeDetails **) DbvAlloc(sizeof(DbvQueryTypeDetails *) * 7);

	for (i = 0; i < 6; i++) 
		ppsQueryTypesSupported[i] = (DbvQueryTypeDetails *) DbvAlloc(sizeof(DbvQueryTypeDetails));
	ppsQueryTypesSupported[6] = NULL;

	ppsQueryTypesSupported[0]->eQueryTypeDetailsType = QTDT_Private;
	ppsQueryTypesSupported[0]->uQueryTypeDetails.psPrivate = zraw_fill_DbvPrivateCapabilities();


	ppsQueryTypesSupported[1]->eQueryTypeDetailsType = QTDT_Rpn;
	ppsQueryTypesSupported[1]->uQueryTypeDetails.psRpn = zraw_fill_DbvRpnCapabilities();

	ppsQueryTypesSupported[2]->eQueryTypeDetailsType = QTDT_Iso8777;
	ppsQueryTypesSupported[2]->uQueryTypeDetails.psIso8777 = zraw_fill_DbvIso8777Capabilities();

	ppsQueryTypesSupported[3]->eQueryTypeDetailsType = QTDT_Z39_58;
	ppsQueryTypesSupported[3]->uQueryTypeDetails.ppsZ39_58 = zraw_fill_DbvHumanString_list();

	ppsQueryTypesSupported[4]->eQueryTypeDetailsType = QTDT_Erpn;
	ppsQueryTypesSupported[4]->uQueryTypeDetails.psErpn = zraw_fill_DbvRpnCapabilities();


	ppsQueryTypesSupported[5]->eQueryTypeDetailsType = QTDT_RankedList;
	ppsQueryTypesSupported[5]->uQueryTypeDetails.ppsRankedList = zraw_fill_DbvHumanString_list();


	return ppsQueryTypesSupported;
}



DbvPrivateCapabilities *
zraw_fill_DbvPrivateCapabilities(void)
{
	DbvPrivateCapabilities *psPrivate = NULL;
	
	psPrivate = (DbvPrivateCapabilities *) DbvAlloc (sizeof(DbvPrivateCapabilities));

	/* o */
	psPrivate->ppsOperators = zraw_fill_DbvOperators_list();
	
	/* o */
	psPrivate->ppsSearchKeys = zraw_fill_DbvSearchKey_list();

	/* o */
	psPrivate->ppsDescription = zraw_fill_DbvHumanStringSeq_list();


	return psPrivate;
}



DbvOperators **
zraw_fill_DbvOperators_list(void)
{
	DbvOperators **ppsOperators = NULL;

	ppsOperators = (DbvOperators **) DbvAlloc (sizeof (DbvOperators *) * 3);

	ppsOperators[0] = (DbvOperators *) DbvAlloc (sizeof (DbvOperators));
	ppsOperators[1] = (DbvOperators *) DbvAlloc (sizeof (DbvOperators));
	
	/* first node */
	/* c */
	fill_dbv_inter_string(&ppsOperators[0]->sOperator, "operators inter string");

	/* o */
	ppsOperators[0]->ppsDescription = zraw_fill_DbvHumanString_list();


	/* second node */
	/* c */
	fill_dbv_inter_string(&ppsOperators[1]->sOperator, "operators inter string");

	/* o */
	ppsOperators[1]->ppsDescription = zraw_fill_DbvHumanString_list();


	return ppsOperators;
}



DbvSearchKey **
zraw_fill_DbvSearchKey_list(void)
{
	DbvSearchKey **ppsSearchKeys = NULL;

	ppsSearchKeys = (DbvSearchKey **) DbvAlloc (sizeof (DbvSearchKey *) * 3);

	ppsSearchKeys[0] = (DbvSearchKey *) DbvAlloc (sizeof (DbvSearchKey));
	ppsSearchKeys[1] = (DbvSearchKey *) DbvAlloc (sizeof (DbvSearchKey));
	
	/* c */
	fill_dbv_inter_string(&ppsSearchKeys[0]->sSearchKey, "first search key");
	
	/* o */
	ppsSearchKeys[0]->ppsDescription = zraw_fill_DbvHumanString_list();


	/* c */
	fill_dbv_inter_string(&ppsSearchKeys[1]->sSearchKey, "second search key");
	
	/* o */
	ppsSearchKeys[1]->ppsDescription = zraw_fill_DbvHumanString_list();


	return ppsSearchKeys;
}



DbvHumanStringSeq **
zraw_fill_DbvHumanStringSeq_list(void)
{
	DbvHumanStringSeq **ppsDescription = NULL;

	/* 0, 1, \0 */
	ppsDescription = (DbvHumanStringSeq **) DbvAlloc (sizeof (DbvHumanStringSeq *) * 3);

	ppsDescription[0] = (DbvHumanStringSeq *) DbvAlloc (sizeof (DbvHumanStringSeq));

	ppsDescription[1] = (DbvHumanStringSeq *) DbvAlloc (sizeof (DbvHumanStringSeq));

	/* for completeness set node 2 to NULL... */
	ppsDescription[2] = NULL;

	/* c, c */
	ppsDescription[0]->ppsHumanString = zraw_fill_DbvHumanString_list();
	ppsDescription[1]->ppsHumanString = zraw_fill_DbvHumanString_list();


	return ppsDescription;
}



DbvRpnCapabilities *
zraw_fill_DbvRpnCapabilities(void)
{
	DbvRpnCapabilities *psRpn = NULL;

	psRpn = (DbvRpnCapabilities *) DbvAlloc (sizeof (DbvRpnCapabilities));


	/* o */
	psRpn->ppulOperators = zraw_fill_Ulong_list();

	/* c */
	psRpn->fResultSetAsOperandSupported = DBV_FALSE;

	/* c */
	psRpn->fRestrictionOperandSupported = DBV_TRUE;

	/* o */
	psRpn->psProximity = zraw_fill_DbvProximitySupport_list();

	return psRpn;
}



Ulong **
zraw_fill_Ulong_list(void)
{
	Ulong **ppulOperators = NULL;

	ppulOperators = (Ulong **) DbvAlloc (sizeof (Ulong *) * 3);

	ppulOperators[0] = (Ulong *) DbvAlloc (sizeof (Ulong));
	ppulOperators[1] = (Ulong *) DbvAlloc (sizeof (Ulong));

	/* ppulOperators[2] set to NULL by DbvAlloc. If we wanted to be
	   pedantic we could use ppulOperators[2] = NULL */

	*ppulOperators[0] = 33;
	*ppulOperators[1] = 34;


	return ppulOperators;
}



DbvProximitySupport *
zraw_fill_DbvProximitySupport_list(void)
{
	DbvProximitySupport *psProximity = NULL;

	psProximity = (DbvProximitySupport *) DbvAlloc (sizeof (DbvProximitySupport));
	
	/* c */
	psProximity->fAnySupport = DBV_TRUE;
	

	/* o */
	psProximity->ppsUnitsSupported = zraw_fill_DbvUnitsSupported_list();


	return psProximity;
}



DbvUnitsSupported **
zraw_fill_DbvUnitsSupported_list(void)
{
	DbvUnitsSupported **ppsUnitsSupported = NULL;

	ppsUnitsSupported = (DbvUnitsSupported **) DbvAlloc (sizeof (DbvUnitsSupported *) * 3);

	ppsUnitsSupported[0] = (DbvUnitsSupported *) DbvAlloc (sizeof (DbvUnitsSupported));
	ppsUnitsSupported[1] = (DbvUnitsSupported *) DbvAlloc (sizeof (DbvUnitsSupported));
	ppsUnitsSupported[2] = NULL;


	/* first node */
	ppsUnitsSupported[0]->eUnitsSupportedType = UST_Known;
	ppsUnitsSupported[0]->uUnitsSupported.ulKnown = 987;


	/* second node */
	ppsUnitsSupported[1]->eUnitsSupportedType = UST_Private;
	ppsUnitsSupported[1]->uUnitsSupported.psPrivate = zraw_fill_DbvPrivate();


	return ppsUnitsSupported;
}


DbvPrivate *
zraw_fill_DbvPrivate(void)
{
	DbvPrivate *psPrivate = NULL;

	psPrivate = (DbvPrivate *) DbvAlloc (sizeof (DbvPrivate));

	/* c */
	psPrivate->ulUnit = 543;


	/* o */
	psPrivate->ppsDescription = zraw_fill_DbvHumanString_list();


	return psPrivate;
}



DbvIso8777Capabilities *
zraw_fill_DbvIso8777Capabilities(void)
{
	DbvIso8777Capabilities *psIso8777 = NULL;

	psIso8777 = (DbvIso8777Capabilities *) DbvAlloc (sizeof (DbvIso8777Capabilities));

	/* c */
	psIso8777->ppsSearchKeys = zraw_fill_DbvSearchKey_list();

	/* o */
	psIso8777->ppsRestrictions = zraw_fill_DbvHumanString_list();

	return psIso8777;
}



DbvObjectIdentifier *
zraw_fill_DbvObjectIdentifier_list(void)
{
	char *oid1 = ANSI_ATTRIBUTE_SET_BIB_1;
	char *oid2 = ISO_DIAGNOSTIC_SET_BIB_1;

	DbvObjectIdentifier *ppcDiagnosticsSets = NULL;

	/* DbvObjectIdentifier is a typedefed 'char *' */
	ppcDiagnosticsSets = (DbvObjectIdentifier *) DbvAlloc (sizeof (DbvObjectIdentifier) * 3);

	ppcDiagnosticsSets[0] = (DbvObjectIdentifier) DbvAlloc (strlen(oid1) + 1);

	ppcDiagnosticsSets[1] = (DbvObjectIdentifier) DbvAlloc (strlen(oid2) + 1);
	ppcDiagnosticsSets[2] = NULL;

	
	memcpy(ppcDiagnosticsSets[0], oid1, strlen(oid1));
	memcpy(ppcDiagnosticsSets[1], oid2, strlen(oid2));

	
	return ppcDiagnosticsSets;
}


DbvAccessRestrictions **
zraw_fill_DbvAccessRestrictions_list(void)
{
	DbvAccessRestrictions **ppsRestrictedAccess = NULL;

	ppsRestrictedAccess = (DbvAccessRestrictions **) DbvAlloc (sizeof (DbvAccessRestrictions *) * 3);

	ppsRestrictedAccess[0] = (DbvAccessRestrictions *) DbvAlloc (sizeof(DbvAccessRestrictions));
	ppsRestrictedAccess[1] = (DbvAccessRestrictions *) DbvAlloc (sizeof(DbvAccessRestrictions));
	ppsRestrictedAccess[2] = NULL;


	/* c, o, o */
	ppsRestrictedAccess[0]->eAccessType = AT_ExtendedServices;
	ppsRestrictedAccess[0]->ppsAccessText = zraw_fill_DbvHumanString_list();
	ppsRestrictedAccess[0]->ppcAccessChallenges = zraw_fill_DbvObjectIdentifier_list();


	/* c, o, o */
	ppsRestrictedAccess[1]->eAccessType = AT_Search;
	ppsRestrictedAccess[1]->ppsAccessText = zraw_fill_DbvHumanString_list();
	ppsRestrictedAccess[1]->ppcAccessChallenges = zraw_fill_DbvObjectIdentifier_list();
	


	return ppsRestrictedAccess;
}



DbvCosts *
zraw_fill_DbvCosts(void)
{
	DbvCosts *psCostInfo = NULL;

	psCostInfo = (DbvCosts *) DbvAlloc (sizeof (DbvCosts));

	/* o */
	psCostInfo->psConnectCharge = zraw_fill_DbvCharge();

	/* o */
	psCostInfo->psConnectTime = zraw_fill_DbvCharge();

	/* o */
	psCostInfo->psDisplayCharge = zraw_fill_DbvCharge();

	/* o */
	psCostInfo->psSearchCharge = zraw_fill_DbvCharge();

	/* o */
	psCostInfo->psSubscriptCharge = zraw_fill_DbvCharge();

	/* o */
	psCostInfo->ppsOtherCharge = zraw_fill_DbvOtherCharge_list();

	return psCostInfo;

}



DbvCharge *
zraw_fill_DbvCharge(void)
{
	DbvCharge *psConnectCharge = NULL;
	DbvIntUnit *psDbvIntUnit = NULL;

	psConnectCharge = (DbvCharge *) DbvAlloc (sizeof(DbvCharge));

	/* c */
	psDbvIntUnit = zraw_fill_DbvIntUnit();
	psConnectCharge->sCost = *psDbvIntUnit;

	/* o */
	psConnectCharge->psPerWhat = zraw_fill_DbvUnit();

	/* o */	
	psConnectCharge->ppsText = zraw_fill_DbvHumanString_list();


	return psConnectCharge;
}



DbvUnit *
zraw_fill_DbvUnit(void)
{
        DbvUnit *psUnit = NULL;
 
        psUnit = (DbvUnit *) DbvAlloc (sizeof(DbvUnit));
 
        /* o */
        psUnit->psUnitSystem = zraw_fill_DbvInternationalString("unit unitsystem");
        /* o */
        psUnit->psUnitType = zraw_fill_DbvStringOrNumeric(SNT_String);
  
        /* o */
        psUnit->psUnit = zraw_fill_DbvStringOrNumeric(SNT_Numeric);

        /* o */
        psUnit->pulScaleFactor = zraw_fill_Ulong();

        return psUnit;
}



DbvStringOrNumeric *
zraw_fill_DbvStringOrNumeric(DbvStringOrNumericType eStringOrNumeric)
{
        char *test_string = "explain string or numeric test string";
        unsigned long test_numeric = 666;

        DbvStringOrNumeric *psUnitType;

        psUnitType = (DbvStringOrNumeric *) DbvAlloc (sizeof(DbvStringOrNumeric));

        switch (eStringOrNumeric) {
        case SNT_String:

                psUnitType->eStringOrNumeric = SNT_String;
                psUnitType->uStringOrNumeric.psString = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
                fill_dbv_inter_string(psUnitType->uStringOrNumeric.psString, test_string);
                break;
        case SNT_Numeric:

                psUnitType->eStringOrNumeric = SNT_Numeric;
                psUnitType->uStringOrNumeric.ulNumeric = test_numeric;
                break;
        }


        return psUnitType;

}



DbvOtherCharge **
zraw_fill_DbvOtherCharge_list(void)
{
	DbvOtherCharge **ppsOtherCharge = NULL;
	DbvCharge *psConnectCharge = NULL;


	ppsOtherCharge = (DbvOtherCharge **) DbvAlloc (sizeof (DbvOtherCharge *) * 3);

	ppsOtherCharge[0] = (DbvOtherCharge *) DbvAlloc (sizeof (DbvOtherCharge));
	ppsOtherCharge[1] = (DbvOtherCharge *) DbvAlloc (sizeof (DbvOtherCharge));


	/* node 0 - c, c */
	ppsOtherCharge[0]->ppsForWhat = zraw_fill_DbvHumanString_list();
	psConnectCharge = zraw_fill_DbvCharge();
	ppsOtherCharge[0]->sCharge = *psConnectCharge;


	/* node 1 - c, c */
	ppsOtherCharge[1]->ppsForWhat = zraw_fill_DbvHumanString_list();
	psConnectCharge = zraw_fill_DbvCharge();
	ppsOtherCharge[1]->sCharge = *psConnectCharge;


	ppsOtherCharge[2] = NULL;


	return ppsOtherCharge;
}



/*-------------------------- DbvDatabaseInfo ----------------------*/

void zraw_setup_DbvDatabaseInfo(DbvExplainRecord *psExplainRecord)
{
        DbvDatabaseInfo *psDatabaseInfo = NULL;

      	psDatabaseInfo = (DbvDatabaseInfo *)DbvAlloc(sizeof(DbvDatabaseInfo));

	zraw_fill_DbvDatabaseInfo(psDatabaseInfo);

	/* Assign the explain record formed to the Dbv structure */
	psExplainRecord->eExplainRecordType = ERT_DatabaseInfo;
	psExplainRecord->uExplainRecord.psDatabaseInfo = psDatabaseInfo;
}





void zraw_fill_DbvDatabaseInfo(DbvDatabaseInfo *psDatabaseInfo)
{
	/* o */
	psDatabaseInfo->psCommonInfo = zraw_fill_DbvCommonInfo();

	/* c */
	fill_dbv_inter_string(&psDatabaseInfo->sName, "databaseinfo name");

	/* o Set to NULL or 1 alloced byte */
	psDatabaseInfo->pvExplainDatabase = (DbvNull *)DbvAlloc (1);

	/* o */
	psDatabaseInfo->ppsNicknames = zraw_fill_DbvInternationalString_list();

	/* o */ 
	psDatabaseInfo->ppsIcon = zraw_fill_DbvIconObject_list();

	/* c */
	psDatabaseInfo->fUserFee = DBV_FALSE;

	/* c */
	psDatabaseInfo->fAvailable = DBV_FALSE;

	/* o */
	psDatabaseInfo->ppsTitleString = zraw_fill_DbvHumanString_list();

	/* o */
	psDatabaseInfo->ppsKeywords = zraw_fill_DbvDataBaseInfoSeq_list();

	/* o */
	psDatabaseInfo->ppsDescription = zraw_fill_DbvHumanString_list();
	
	/* o */
	psDatabaseInfo->ppsAssociatedDbs = zraw_fill_DbvInternationalString_list();
	/* o */
	psDatabaseInfo->ppsSubDbs = zraw_fill_DbvInternationalString_list();

	/* o */
	psDatabaseInfo->ppsDisclaimers = zraw_fill_DbvHumanString_list();

	/* o */
	psDatabaseInfo->ppsNews = zraw_fill_DbvHumanString_list();

	/* o */
	psDatabaseInfo->psRecordCount = zraw_fill_DbvRecordCount();

	/* o */
	psDatabaseInfo->ppsDefaultOrder = zraw_fill_DbvHumanString_list();

	/* o */
	psDatabaseInfo->pulAvRecordSize = zraw_fill_Ulong();

	/* o */
	psDatabaseInfo->pulMaxRecordSize = zraw_fill_Ulong();

	/* o */
	psDatabaseInfo->ppsHours = zraw_fill_DbvHumanString_list();

	/* o */
	psDatabaseInfo->ppsBestTime = zraw_fill_DbvHumanString_list();

	/* o */
	psDatabaseInfo->pcLastUpdate = zraw_fill_DbvGeneralizedTime("343434");

	/* o */
	psDatabaseInfo->psUpdateInterval = zraw_fill_DbvIntUnit();

	/* o */
	psDatabaseInfo->ppsCoverage = zraw_fill_DbvHumanString_list();

	/* o */
	psDatabaseInfo->pfProprietary = zraw_fill_DbvBool();

	/* o */ 
	psDatabaseInfo->ppsCopyrightText = zraw_fill_DbvHumanString_list();

	/* o */
	psDatabaseInfo->ppsCopyrightNotice = zraw_fill_DbvHumanString_list();

	/* o */
	psDatabaseInfo->psProducerContactInfo = zraw_fill_DbvContactInfo();

	/* o */
	psDatabaseInfo->psSupplierContactInfo = zraw_fill_DbvContactInfo();

	/* o */
	psDatabaseInfo->psSubmissionContactInfo = zraw_fill_DbvContactInfo();

	/* o */
	psDatabaseInfo->psAccessInfo = zraw_fill_DbvAccessInfo();

}



DbvDataBaseInfoSeq **
zraw_fill_DbvDataBaseInfoSeq_list(void)
{
	DbvDataBaseInfoSeq **ppsKeywords = NULL;

	ppsKeywords = (DbvDataBaseInfoSeq **) DbvAlloc (sizeof(DbvDataBaseInfoSeq *)* 3);
	ppsKeywords[0] = (DbvDataBaseInfoSeq *) DbvAlloc (sizeof (DbvDataBaseInfoSeq));
	ppsKeywords[1] = (DbvDataBaseInfoSeq *) DbvAlloc (sizeof (DbvDataBaseInfoSeq));
	ppsKeywords[2] = NULL;

	/* c */
	ppsKeywords[0]->ppsDataBaseInfo = zraw_fill_DbvHumanString_list();
	ppsKeywords[1]->ppsDataBaseInfo = zraw_fill_DbvHumanString_list();


	return ppsKeywords;
}



DbvRecordCount *
zraw_fill_DbvRecordCount(void)
{
	DbvRecordCount *psRecordCount = NULL;

	int choice = 0;
	char choice_string[100];

	psRecordCount = (DbvRecordCount *) DbvAlloc (sizeof (DbvRecordCount));
	choice = 0;
        while (choice < 1 || choice > 2) {
                printf("Enter eRecordCountType type: RCT_ActualNumber (1), RCT_ApproxNumber (2): ");
                choice = (atol(gets(choice_string)));
        }

	switch (choice) {
	case RCT_ActualNumber:
		psRecordCount->eRecordCountType = RCT_ActualNumber;
		psRecordCount->uRecordCount.ulActualNumber = 76;
		break;

	case RCT_ApproxNumber:
		psRecordCount->eRecordCountType = RCT_ApproxNumber;
		psRecordCount->uRecordCount.ulActualNumber = 77;
		break;
	}
	
	return psRecordCount;
}



DbvBool *
zraw_fill_DbvBool(void)
{
	DbvBool *psDbvBool = NULL;


	psDbvBool = (DbvBool *) DbvAlloc (sizeof(DbvBool));
	*psDbvBool = DBV_TRUE;


	return psDbvBool;
}



/*-------------------------- DbvSchemaInfo ----------------------*/

void zraw_setup_DbvSchemaInfo(DbvExplainRecord *psExplainRecord)
{
        DbvSchemaInfo *psSchemaInfo = NULL;

      	psSchemaInfo = (DbvSchemaInfo *)DbvAlloc(sizeof(DbvSchemaInfo));

	zraw_fill_DbvSchemaInfo(psSchemaInfo);

	/* Assign the explain record formed to the Dbv structure */
	psExplainRecord->eExplainRecordType = ERT_SchemaInfo;
	psExplainRecord->uExplainRecord.psSchemaInfo = psSchemaInfo;
}



void zraw_fill_DbvSchemaInfo(DbvSchemaInfo *psSchemaInfo)
{
	/* o */
	psSchemaInfo->psCommonInfo = zraw_fill_DbvCommonInfo();

	/* c */
	psSchemaInfo->pcSchema = zraw_fill_DbvObjectIdentifier();

	/* c */
	fill_dbv_inter_string(&psSchemaInfo->sName, "schema name");

	/* o */
	psSchemaInfo->ppsDescription = zraw_fill_DbvHumanString_list();

	/* o */
	psSchemaInfo->ppsTagTypeMapping = zraw_fill_DbvTagTypeMapping_list();

	/* o */
	psSchemaInfo->ppsRecordStructure = zraw_fill_DbvElementInfo_list();
}



DbvObjectIdentifier 
zraw_fill_DbvObjectIdentifier(void)
{
	char *oid = ANSI_ATTRIBUTE_SET_BIB_1;

	DbvObjectIdentifier pcSchema = NULL;

	/* DbvObjectIdentifier is a typedefed 'char *' */
	pcSchema = (DbvObjectIdentifier) DbvAlloc (strlen(oid) + 1);
	memcpy(pcSchema, oid, strlen(oid));
	
	return pcSchema;
}



DbvTagTypeMapping **
zraw_fill_DbvTagTypeMapping_list(void)
{
	DbvTagTypeMapping **ppsTagTypeMapping = NULL;

	ppsTagTypeMapping = (DbvTagTypeMapping **) DbvAlloc (sizeof (DbvTagTypeMapping *) * 3);
	ppsTagTypeMapping[0] = (DbvTagTypeMapping *) DbvAlloc (sizeof (DbvTagTypeMapping));
	ppsTagTypeMapping[1] = (DbvTagTypeMapping *) DbvAlloc (sizeof (DbvTagTypeMapping));
	ppsTagTypeMapping[2] = NULL;
	

	/* c, o, o */
	ppsTagTypeMapping[0]->ulTagType = 13;
	ppsTagTypeMapping[0]->pcTagSet = zraw_fill_DbvObjectIdentifier();
	ppsTagTypeMapping[0]->pvDefaultTagType = (DbvNull *)DbvAlloc(1);


	/* c, o, o */
	ppsTagTypeMapping[1]->ulTagType = 14;
	ppsTagTypeMapping[1]->pcTagSet = zraw_fill_DbvObjectIdentifier();
	ppsTagTypeMapping[1]->pvDefaultTagType = (DbvNull *)DbvAlloc(1);


	return ppsTagTypeMapping;
}



DbvElementInfo **
zraw_fill_DbvElementInfo_list(void)
{
	DbvElementInfo **ppsRecordStructure = NULL;
	static int count = 0;

	ppsRecordStructure = (DbvElementInfo **) DbvAlloc (sizeof (DbvElementInfo *) * 3);

	ppsRecordStructure[0] = (DbvElementInfo *) DbvAlloc (sizeof (DbvElementInfo));
	ppsRecordStructure[1] = (DbvElementInfo *) DbvAlloc (sizeof (DbvElementInfo));
	ppsRecordStructure[2] = NULL;


	/* c */
	fill_dbv_inter_string(&ppsRecordStructure[0]->sElementName, "element info inter string");

	/* c */
	ppsRecordStructure[0]->ppsElementTagPath = zraw_fill_DbvPath_list();

	/* o */
	ppsRecordStructure[0]->psDataType = zraw_fill_DbvElementDataType(EDTT_Primitive);

	/* c */
	ppsRecordStructure[0]->fRequired = DBV_TRUE;
	
	/* c */
	ppsRecordStructure[0]->fRepeatable = DBV_FALSE;


	/* o */
	ppsRecordStructure[0]->ppsDescription = zraw_fill_DbvHumanString_list();


	/* c, c, o, c, c, o */
	fill_dbv_inter_string(&ppsRecordStructure[1]->sElementName, "element info inter string");
	ppsRecordStructure[1]->ppsElementTagPath = zraw_fill_DbvPath_list();

	/* dirty variable to avoid recursion */
	if (count == 0) {
		count++;
		ppsRecordStructure[1]->psDataType = zraw_fill_DbvElementDataType(EDTT_Structured);
	} else

		ppsRecordStructure[1]->psDataType = zraw_fill_DbvElementDataType(EDTT_Primitive);



	ppsRecordStructure[1]->fRequired = DBV_TRUE;
	ppsRecordStructure[1]->fRepeatable = DBV_FALSE;

	ppsRecordStructure[1]->ppsDescription = zraw_fill_DbvHumanString_list();


	return ppsRecordStructure;
}



DbvPath **
zraw_fill_DbvPath_list(void)
{
	DbvPath **ppsElementTagPath = NULL;

	DbvStringOrNumeric *psTagValue = NULL;

	ppsElementTagPath = (DbvPath **) DbvAlloc (sizeof (DbvPath *) * 3);
	ppsElementTagPath[0] = (DbvPath *) DbvAlloc (sizeof (DbvPath));
	ppsElementTagPath[1] = (DbvPath *) DbvAlloc (sizeof (DbvPath));
	ppsElementTagPath[2] = NULL;
	
	/* c */
	ppsElementTagPath[0]->ulTagType = 98765;

	/* c */
	psTagValue = zraw_fill_DbvStringOrNumeric(SNT_String);
	ppsElementTagPath[0]->sTagValue = *psTagValue;
	

	/* c, c */
	ppsElementTagPath[1]->ulTagType = 98765;
	psTagValue = zraw_fill_DbvStringOrNumeric(SNT_String);
	ppsElementTagPath[1]->sTagValue = *psTagValue;
	

	return ppsElementTagPath;
}



DbvElementDataType *
zraw_fill_DbvElementDataType(DbvElementDataTypeType eElementDataTypeType)
{
	DbvElementDataType *psDataType = NULL;

	psDataType = (DbvElementDataType *) DbvAlloc (sizeof (DbvElementDataType));
	
	switch (eElementDataTypeType) {
	case EDTT_Primitive:
		psDataType->eElementDataTypeType = EDTT_Primitive;
		psDataType->uElementDataType.ePrimitive = PDT_IntUnit;
		break;

/********************************************************************/
/* CAREFUL - with the following code there is a chance of recursion */

	case EDTT_Structured:
		psDataType->eElementDataTypeType = EDTT_Structured;
		psDataType->uElementDataType.ppsStructured = zraw_fill_DbvElementInfo_list();
		break;	

/*******************************************************************/
	}

	
	return psDataType;
}



/*-------------------------- DbvTagSetInfo ----------------------*/

void zraw_setup_DbvTagSetInfo(DbvExplainRecord *psExplainRecord)
{
        DbvTagSetInfo *psTagSetInfo = NULL;

      	psTagSetInfo = (DbvTagSetInfo *)DbvAlloc(sizeof(DbvTagSetInfo));

	zraw_fill_DbvTagSetInfo(psTagSetInfo);

	/* Assign the explain record formed to the Dbv structure */
	psExplainRecord->eExplainRecordType = ERT_TagSetInfo;
	psExplainRecord->uExplainRecord.psTagSetInfo = psTagSetInfo;
}



void zraw_fill_DbvTagSetInfo(DbvTagSetInfo *psTagSetInfo)
{
	/* o */
	psTagSetInfo->psCommonInfo = zraw_fill_DbvCommonInfo();

	/* c */
	psTagSetInfo->pcTagSet = zraw_fill_DbvObjectIdentifier();

	/* c */
	fill_dbv_inter_string(&psTagSetInfo->sName, "tagset name");

	/* o */
	psTagSetInfo->ppsDescription = zraw_fill_DbvHumanString_list();

	/* o */
	psTagSetInfo->ppsElements = zraw_fill_DbvElements_list();

}



DbvElements **
zraw_fill_DbvElements_list(void)
{
	DbvElements **ppsElements = NULL;
	DbvStringOrNumeric *psDbvStringOrNumeric = NULL;

	ppsElements = (DbvElements **) DbvAlloc (sizeof (DbvElements *) * 3);

	ppsElements[0] = (DbvElements *) DbvAlloc (sizeof (DbvElements));
	ppsElements[1] = (DbvElements *) DbvAlloc (sizeof (DbvElements));
	ppsElements[2] = NULL;


	/* c */
	fill_dbv_inter_string(&ppsElements[0]->sElementName, "element name");

	/* o */
	ppsElements[0]->ppsNicknames = zraw_fill_DbvInternationalString_list();

	/* c */
	psDbvStringOrNumeric = zraw_fill_DbvStringOrNumeric(SNT_String);
	ppsElements[0]->sElementTag = *psDbvStringOrNumeric;
	
	/* o */
	ppsElements[0]->ppsDescription = zraw_fill_DbvHumanString_list();

	/* o */
	ppsElements[0]->peDataType = zraw_fill_DbvPrimitiveDataType();

	
	/* o */
	ppsElements[0]->ppsOtherInformation = zraw_fill_DbvOtherInformation_list();


	/* c, o, c, o, o, o */
	fill_dbv_inter_string(&ppsElements[1]->sElementName, "element name");

	ppsElements[1]->ppsNicknames = zraw_fill_DbvInternationalString_list();
	psDbvStringOrNumeric = zraw_fill_DbvStringOrNumeric(SNT_String);
	ppsElements[1]->sElementTag = *psDbvStringOrNumeric;

	ppsElements[1]->ppsDescription = zraw_fill_DbvHumanString_list();
	ppsElements[1]->peDataType = zraw_fill_DbvPrimitiveDataType();
	ppsElements[1]->ppsOtherInformation = zraw_fill_DbvOtherInformation_list();


	return ppsElements;

	
}


DbvPrimitiveDataType *
zraw_fill_DbvPrimitiveDataType(void)
{
	DbvPrimitiveDataType *peDataType = NULL;

	peDataType = (DbvPrimitiveDataType *) DbvAlloc (sizeof (DbvPrimitiveDataType));
	*peDataType = PDT_TrueOrFalse;

	return peDataType;
}



/*-------------------------- DbvRecordSyntaxInfo ----------------------*/

void zraw_setup_DbvRecordSyntaxInfo(DbvExplainRecord *psExplainRecord)
{
        DbvRecordSyntaxInfo *psRecordSyntaxInfo = NULL;

      	psRecordSyntaxInfo = (DbvRecordSyntaxInfo *)DbvAlloc(sizeof(DbvRecordSyntaxInfo));

	zraw_fill_DbvRecordSyntaxInfo(psRecordSyntaxInfo);

	/* Assign the explain record formed to the Dbv structure */
	psExplainRecord->eExplainRecordType = ERT_RecordSyntaxInfo;
	psExplainRecord->uExplainRecord.psRecordSyntaxInfo = psRecordSyntaxInfo;
}




void zraw_fill_DbvRecordSyntaxInfo(DbvRecordSyntaxInfo *psRecordSyntaxInfo)
{
	/* o */
	psRecordSyntaxInfo->psCommonInfo = zraw_fill_DbvCommonInfo();

	/* c */
	psRecordSyntaxInfo->pcRecordSyntax = zraw_fill_DbvObjectIdentifier();

	/* c */
	fill_dbv_inter_string(&psRecordSyntaxInfo->sName, "record syntax name");

	/* o */
	psRecordSyntaxInfo->ppcTransferSyntaxes = zraw_fill_DbvObjectIdentifier_list();

	/* o */
	psRecordSyntaxInfo->ppsDescription = zraw_fill_DbvHumanString_list();

	/* o */
	psRecordSyntaxInfo->psAsn1Module = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
	fill_dbv_inter_string(psRecordSyntaxInfo->psAsn1Module, "asn1 module");

	/* o */
	psRecordSyntaxInfo->ppsAbstractStructure = zraw_fill_DbvElementInfo_list();

}



/*-------------------------- DbvAttributeSetInfo ----------------------*/

void zraw_setup_DbvAttributeSetInfo(DbvExplainRecord *psExplainRecord)
{
        DbvAttributeSetInfo *psAttributeSetInfo = NULL;

      	psAttributeSetInfo = (DbvAttributeSetInfo *)DbvAlloc(sizeof(DbvAttributeSetInfo));

	zraw_fill_DbvAttributeSetInfo(psAttributeSetInfo);

	/* Assign the explain record formed to the Dbv structure */
	psExplainRecord->eExplainRecordType = ERT_AttributeSetInfo;
	psExplainRecord->uExplainRecord.psAttributeSetInfo = psAttributeSetInfo;
}




void zraw_fill_DbvAttributeSetInfo(DbvAttributeSetInfo *psAttributeSetInfo)
{
	/* o */
	psAttributeSetInfo->psCommonInfo = zraw_fill_DbvCommonInfo();

	/* c */
	psAttributeSetInfo->pcAttributeSetId = zraw_fill_DbvObjectIdentifier();

	/* c */
	fill_dbv_inter_string(&psAttributeSetInfo->sName, "attribute set info name");

	/* o */
	psAttributeSetInfo->ppsAttributes = zraw_fill_DbvAttributeType_list();

	/* o */
	psAttributeSetInfo->ppsDescription = zraw_fill_DbvHumanString_list();
}



DbvAttributeType **
zraw_fill_DbvAttributeType_list(void)
{
	DbvAttributeType **ppsAttributes = NULL;

	ppsAttributes = (DbvAttributeType **) DbvAlloc (sizeof (DbvAttributeType *) * 3);

	ppsAttributes[0] = (DbvAttributeType *) DbvAlloc (sizeof (DbvAttributeType));
	ppsAttributes[1] = (DbvAttributeType *) DbvAlloc (sizeof (DbvAttributeType));
	ppsAttributes[2] = NULL;


	/* o */
	ppsAttributes[0]->psName = zraw_fill_DbvInternationalString("first attributes name");

	/* o */
	ppsAttributes[0]->ppsDescription = zraw_fill_DbvHumanString_list();

	/* o */
	ppsAttributes[0]->ulAttributeType = 985;

	/* c */
	ppsAttributes[0]->ppsAttributeValues = zraw_fill_DbvAttributeDescription_list();
	

	/* o, o, o, c */
	ppsAttributes[1]->psName = zraw_fill_DbvInternationalString("second attributes name");
	ppsAttributes[1]->ppsDescription = zraw_fill_DbvHumanString_list();
	ppsAttributes[1]->ulAttributeType = 986;
	ppsAttributes[1]->ppsAttributeValues = zraw_fill_DbvAttributeDescription_list();
	

	return ppsAttributes;
}



DbvAttributeDescription **
zraw_fill_DbvAttributeDescription_list(void)
{
	DbvAttributeDescription **ppsAttributeValues = NULL;
	DbvStringOrNumeric *psDbvStringOrNumeric = NULL;

	ppsAttributeValues = (DbvAttributeDescription **) DbvAlloc (sizeof (DbvAttributeDescription *) * 3 );

	ppsAttributeValues[0] = (DbvAttributeDescription *) DbvAlloc (sizeof (DbvAttributeDescription));
	ppsAttributeValues[1] = (DbvAttributeDescription *) DbvAlloc (sizeof (DbvAttributeDescription));
	ppsAttributeValues[2] = NULL;


	/* we've alloced the nodes - now fill em */

	/* o */
	ppsAttributeValues[0]->psName = zraw_fill_DbvInternationalString("first attribute values name");

	/* o */
	ppsAttributeValues[0]->ppsDescription = zraw_fill_DbvHumanString_list();

	/* c */
	psDbvStringOrNumeric = zraw_fill_DbvStringOrNumeric(SNT_String);
	ppsAttributeValues[0]->sAttributeValue = *psDbvStringOrNumeric;

	/* o */	
	ppsAttributeValues[0]->ppsEquivalentAttributes = zraw_fill_DbvStringOrNumeric_list();


	/* second node */
	/* o */
	ppsAttributeValues[1]->psName = zraw_fill_DbvInternationalString("second attributes values name");

	/* o */
	ppsAttributeValues[1]->ppsDescription = zraw_fill_DbvHumanString_list();

	/* c */
	psDbvStringOrNumeric = zraw_fill_DbvStringOrNumeric(SNT_String);
	ppsAttributeValues[1]->sAttributeValue = *psDbvStringOrNumeric;

	/* o */	
	ppsAttributeValues[1]->ppsEquivalentAttributes = zraw_fill_DbvStringOrNumeric_list();



	return ppsAttributeValues;

}



DbvStringOrNumeric **
zraw_fill_DbvStringOrNumeric_list(void)
{
	DbvStringOrNumeric **ppsEquivalentAttributes = NULL, *psDbvStringOrNumeric = NULL;

	ppsEquivalentAttributes = (DbvStringOrNumeric **) DbvAlloc (sizeof (DbvStringOrNumeric *) * 3);
	ppsEquivalentAttributes[0] = zraw_fill_DbvStringOrNumeric(SNT_String);
	ppsEquivalentAttributes[1] = zraw_fill_DbvStringOrNumeric(SNT_Numeric);
	ppsEquivalentAttributes[2] = NULL;


	return ppsEquivalentAttributes;
}



/*-------------------------- DbvTermListInfo ----------------------*/

void zraw_setup_DbvTermListInfo(DbvExplainRecord *psExplainRecord)
{
        DbvTermListInfo *psTermListInfo = NULL;

      	psTermListInfo = (DbvTermListInfo *)DbvAlloc(sizeof(DbvTermListInfo));

	zraw_fill_DbvTermListInfo(psTermListInfo);

	/* Assign the explain record formed to the Dbv structure */
	psExplainRecord->eExplainRecordType = ERT_TermListInfo;
	psExplainRecord->uExplainRecord.psTermListInfo = psTermListInfo;
}




void zraw_fill_DbvTermListInfo(DbvTermListInfo *psTermListInfo)
{
	/* o */
	psTermListInfo->psCommonInfo = zraw_fill_DbvCommonInfo();

	/* c */
	fill_dbv_inter_string(&psTermListInfo->sDatabaseName, "attribute set info name");
	/* c */
	psTermListInfo->ppsTermLists = zraw_fill_DbvTermList_list();

}



DbvTermList **
zraw_fill_DbvTermList_list(void)
{
	DbvTermList **ppsTermLists = NULL;

	ppsTermLists = (DbvTermList **) DbvAlloc (sizeof (DbvTermList *) * 3);
	ppsTermLists[0] = (DbvTermList *) DbvAlloc (sizeof (DbvTermList));
	ppsTermLists[1] = (DbvTermList *) DbvAlloc (sizeof (DbvTermList));
	ppsTermLists[2] = NULL;

	/* c */
	fill_dbv_inter_string(&ppsTermLists[0]->sName, "term list name");

	/* o */
	ppsTermLists[0]->ppsTitle = zraw_fill_DbvHumanString_list();

	/* o */
	ppsTermLists[0]->peSearchCost = zraw_fill_DbvSearchCost();

	/* c */
	ppsTermLists[0]->fScanable = DBV_TRUE;

	/* o */
	ppsTermLists[0]->ppsBroader = zraw_fill_DbvInternationalString_list();

	/* o */
	ppsTermLists[0]->ppsNarrower = zraw_fill_DbvInternationalString_list();


	/* c, o, o, c, o, o */ 
	fill_dbv_inter_string(&ppsTermLists[1]->sName, "term list name");

	ppsTermLists[1]->ppsTitle = zraw_fill_DbvHumanString_list();
	ppsTermLists[1]->peSearchCost = zraw_fill_DbvSearchCost();

	ppsTermLists[1]->fScanable = DBV_FALSE;

	ppsTermLists[1]->ppsBroader = zraw_fill_DbvInternationalString_list();
	ppsTermLists[1]->ppsNarrower = zraw_fill_DbvInternationalString_list();

	return ppsTermLists;
}



DbvSearchCost *
zraw_fill_DbvSearchCost(void)
{
	DbvSearchCost *peSearchCost = NULL;

	peSearchCost = (DbvSearchCost *) DbvAlloc (sizeof (DbvSearchCost));
	*peSearchCost = SC_Expensive;

	return peSearchCost;
}


/*-------------------------- DbvExtendedServicesInfo ----------------------*/

void zraw_setup_DbvExtendedServicesInfo(DbvExplainRecord *psExplainRecord)
{
        DbvExtendedServicesInfo *psExtendedServicesInfo = NULL;

      	psExtendedServicesInfo = (DbvExtendedServicesInfo *)DbvAlloc(sizeof(DbvExtendedServicesInfo));

	zraw_fill_DbvExtendedServicesInfo(psExtendedServicesInfo);

	/* Assign the explain record formed to the Dbv structure */
	psExplainRecord->eExplainRecordType = ERT_ExtendedServicesInfo;
	psExplainRecord->uExplainRecord.psExtendedServicesInfo = psExtendedServicesInfo;
}




void zraw_fill_DbvExtendedServicesInfo(DbvExtendedServicesInfo *psExtendedServicesInfo)
{
	/* o */
	psExtendedServicesInfo->psCommonInfo = zraw_fill_DbvCommonInfo();

	/* c */
	psExtendedServicesInfo->pcType = zraw_fill_DbvObjectIdentifier();

	/* o */
	psExtendedServicesInfo->psName = zraw_fill_DbvInternationalString("extended services name");

	/* c */
	psExtendedServicesInfo->fPrivateType = DBV_FALSE;
	
	/* c */
	psExtendedServicesInfo->fRestrictionsApply = DBV_FALSE;
	
	/* c */
	psExtendedServicesInfo->fFeeApply = DBV_FALSE;

	/* c */
	psExtendedServicesInfo->fAvailable = DBV_FALSE;

	/* c */
	psExtendedServicesInfo->fRetentionSupported = DBV_FALSE;

	/* c */
	psExtendedServicesInfo->eWaitAction = ESII_Depends;

	/* o */
	psExtendedServicesInfo->ppsDescription = zraw_fill_DbvHumanString_list();
	/* o */
	psExtendedServicesInfo->psSpecificExplain = zraw_fill_DbvASN1External();

	/* o */
	psExtendedServicesInfo->psEsASN = zraw_fill_DbvInternationalString("psEsASN string");

}



DbvASN1External *
zraw_fill_DbvASN1External(void)
{
	DbvASN1External *psSpecificExplain = NULL;
	char *sutrs_string = "test sutrs";

	psSpecificExplain = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));

	/* fill with a sutrs */
        fill_dbv_sutrs_external(psSpecificExplain, sutrs_string);

	return psSpecificExplain;

}



/*-------------------------- DbvAttributeDetails ----------------------*/

void zraw_setup_DbvAttributeDetails(DbvExplainRecord *psExplainRecord)
{
        DbvAttributeDetails *psAttributeDetails = NULL;

      	psAttributeDetails = (DbvAttributeDetails *)DbvAlloc(sizeof(DbvAttributeDetails));

	zraw_fill_DbvAttributeDetails(psAttributeDetails);

	/* Assign the explain record formed to the Dbv structure */
	psExplainRecord->eExplainRecordType = ERT_AttributeDetails;
	psExplainRecord->uExplainRecord.psAttributeDetails = psAttributeDetails;
}




void zraw_fill_DbvAttributeDetails(DbvAttributeDetails *psAttributeDetails)
{
	/* o */
	psAttributeDetails->psCommonInfo = zraw_fill_DbvCommonInfo();

	/* c */
	fill_dbv_inter_string(&psAttributeDetails->sDatabaseName, "attribute details name");

	/* o */
	psAttributeDetails->ppsAttributesBySet = zraw_fill_DbvAttributesBySet_list();

	/* o */
	psAttributeDetails->psAttributeCombinations = zraw_fill_DbvAttributeCombinations();

}



DbvAttributesBySet **
zraw_fill_DbvAttributesBySet_list(void)
{
	DbvAttributesBySet **ppsAttributesBySet = NULL;

	ppsAttributesBySet = (DbvAttributesBySet **) DbvAlloc (sizeof(DbvAttributesBySet *) * 3);
	ppsAttributesBySet[0] = (DbvAttributesBySet *) DbvAlloc (sizeof(DbvAttributesBySet));
	ppsAttributesBySet[1] = (DbvAttributesBySet *) DbvAlloc (sizeof(DbvAttributesBySet));
	ppsAttributesBySet[2] = NULL;

	/* c */
	ppsAttributesBySet[0]->pcAttributeSet = zraw_fill_DbvObjectIdentifier();

	/* c */
	ppsAttributesBySet[0]->ppsAttributesByType = zraw_fill_DbvAttributesByType();

	/* c */
	ppsAttributesBySet[1]->pcAttributeSet = zraw_fill_DbvObjectIdentifier();

	/* c */
	ppsAttributesBySet[1]->ppsAttributesByType = zraw_fill_DbvAttributesByType();

	return ppsAttributesBySet;
}



DbvAttributesByType **
zraw_fill_DbvAttributesByType(void)
{
	DbvAttributesByType **ppsAttributesByType = NULL;

	ppsAttributesByType = (DbvAttributesByType **) DbvAlloc (sizeof(DbvAttributesByType *) * 3);
	ppsAttributesByType[0] = (DbvAttributesByType *) DbvAlloc (sizeof(DbvAttributesByType));
	ppsAttributesByType[1] = (DbvAttributesByType *) DbvAlloc (sizeof(DbvAttributesByType));
	ppsAttributesByType[2] = NULL;

	
	/* c, o, o */
	ppsAttributesByType[0]->ulAttributeType = 234;

	ppsAttributesByType[0]->psDefaultIfOmitted = zraw_fill_DbvOmittedAttributeInterpretation();
	ppsAttributesByType[0]->ppsAttributeValues = zraw_fill_DbvAttributeValues_list();


	/* c, o, o */
	ppsAttributesByType[1]->ulAttributeType = 235;

	ppsAttributesByType[1]->psDefaultIfOmitted = zraw_fill_DbvOmittedAttributeInterpretation();
	ppsAttributesByType[1]->ppsAttributeValues = zraw_fill_DbvAttributeValues_list();

	return ppsAttributesByType;

}



DbvOmittedAttributeInterpretation *
zraw_fill_DbvOmittedAttributeInterpretation(void)
{
	DbvOmittedAttributeInterpretation *psOptionalType = NULL;

	psOptionalType = (DbvOmittedAttributeInterpretation *) DbvAlloc (sizeof (DbvOmittedAttributeInterpretation));


	/* o */
	psOptionalType->psDefaultValue = zraw_fill_DbvStringOrNumeric(SNT_String);

	/* o */
	psOptionalType->ppsDefaultDescription = zraw_fill_DbvHumanString_list();


	return psOptionalType;
}



DbvAttributeValues **
zraw_fill_DbvAttributeValues_list(void)
{
	DbvAttributeValues **ppsAttributeValues = NULL;
	DbvStringOrNumeric *psDbvStringOrNumeric = NULL;

	ppsAttributeValues = (DbvAttributeValues **) DbvAlloc (sizeof (DbvAttributeValues * ) * 3);


	ppsAttributeValues[0] = (DbvAttributeValues *) DbvAlloc (sizeof (DbvAttributeValues));
	ppsAttributeValues[1] = (DbvAttributeValues *) DbvAlloc (sizeof (DbvAttributeValues));
	ppsAttributeValues[2] = NULL;


	/* c */
	psDbvStringOrNumeric = zraw_fill_DbvStringOrNumeric(SNT_Numeric);
	ppsAttributeValues[0]->sValue = *psDbvStringOrNumeric;
	
	/* o */
	ppsAttributeValues[0]->ppsDescription = zraw_fill_DbvHumanString_list();

	/* o */
	ppsAttributeValues[0]->ppsSubAttributes = zraw_fill_DbvStringOrNumeric_list();

	/* o */
	ppsAttributeValues[0]->ppsSuperAttributes = zraw_fill_DbvStringOrNumeric_list();

	/* o */
	ppsAttributeValues[0]->pvPartialSupport = (DbvNull *)DbvAlloc(1);


	/* c, o, o, o */
	psDbvStringOrNumeric = zraw_fill_DbvStringOrNumeric(SNT_String);
	ppsAttributeValues[1]->sValue = *psDbvStringOrNumeric;
	
	ppsAttributeValues[1]->ppsDescription = zraw_fill_DbvHumanString_list();
	ppsAttributeValues[1]->ppsSubAttributes = zraw_fill_DbvStringOrNumeric_list();
	ppsAttributeValues[1]->ppsSuperAttributes = zraw_fill_DbvStringOrNumeric_list();
	ppsAttributeValues[1]->pvPartialSupport = (DbvNull *)DbvAlloc(1);


	return ppsAttributeValues;
}



DbvAttributeCombinations *
zraw_fill_DbvAttributeCombinations(void)
{
	DbvAttributeCombinations *psAttributeCombinations = NULL;

	psAttributeCombinations = (DbvAttributeCombinations *) DbvAlloc (sizeof (DbvAttributeCombinations));

	/* c */
	psAttributeCombinations->pcDefaultAttributeSet = zraw_fill_DbvObjectIdentifier();

	/* c */
	psAttributeCombinations->ppsLegalCombinations = zraw_fill_DbvAttributeCombination_list();

	return psAttributeCombinations;
}



DbvAttributeCombination **
zraw_fill_DbvAttributeCombination_list(void)
{	
	DbvAttributeCombination **ppsLegalCombinations = NULL;

	ppsLegalCombinations = (DbvAttributeCombination **) DbvAlloc (sizeof (DbvAttributeCombination *) * 3);
	ppsLegalCombinations[0] = (DbvAttributeCombination *) DbvAlloc (sizeof (DbvAttributeCombination));
	ppsLegalCombinations[1] = (DbvAttributeCombination *) DbvAlloc (sizeof (DbvAttributeCombination));
	ppsLegalCombinations[2] = NULL;

	/* c */
	ppsLegalCombinations[0]->ppsAttributeOccurrence = zraw_fill_DbvAttributeOccurrence_list();

	/* c */
	ppsLegalCombinations[1]->ppsAttributeOccurrence = zraw_fill_DbvAttributeOccurrence_list();


	return ppsLegalCombinations;
}



DbvAttributeOccurrence **
zraw_fill_DbvAttributeOccurrence_list(void)
{
	DbvAttributeOccurrence **ppsAttributeOccurrence = NULL;

	ppsAttributeOccurrence = (DbvAttributeOccurrence **) DbvAlloc (sizeof (DbvAttributeOccurrence * ) * 3);
	ppsAttributeOccurrence[0] = (DbvAttributeOccurrence *) DbvAlloc (sizeof (DbvAttributeOccurrence));
	ppsAttributeOccurrence[1] = (DbvAttributeOccurrence *) DbvAlloc (sizeof (DbvAttributeOccurrence));
	ppsAttributeOccurrence[2] = NULL;

	/* o */
	ppsAttributeOccurrence[0]->pcAttributeSet = zraw_fill_DbvObjectIdentifier();

	/* c */
	ppsAttributeOccurrence[0]->ulAttributeType = 45;

	/* o */
	ppsAttributeOccurrence[0]->pvMustBeSupplied = (DbvNull *)DbvAlloc(1);

	/* c */
	zraw_fill_DbvAttributeOccurrence(&ppsAttributeOccurrence[0]->sAttributeValues, AOT_AnyOrNone);



	/* o, c, o, c */
	ppsAttributeOccurrence[1]->pcAttributeSet = zraw_fill_DbvObjectIdentifier();
	ppsAttributeOccurrence[1]->ulAttributeType = 46;

	ppsAttributeOccurrence[1]->pvMustBeSupplied = (DbvNull *)DbvAlloc(1);

	zraw_fill_DbvAttributeOccurrence(&ppsAttributeOccurrence[1]->sAttributeValues, AOT_Specific);



	return ppsAttributeOccurrence;
	
}



void
zraw_fill_DbvAttributeOccurrence(DbvAttributeOccurrenceChoice *psAttributeValues, DbvAttributeOccurrenceChoiceType eAttributeOccurrenceChoiceType)
{
	switch (eAttributeOccurrenceChoiceType) {
	case AOT_AnyOrNone:
		psAttributeValues->eAttributeOccurrenceChoiceType = AOT_AnyOrNone;
		psAttributeValues->uAttributeOccurrenceChoiceType.pvAnyOrNone = (DbvNull *)DbvAlloc (1);
		break;
	case AOT_Specific:
		psAttributeValues->eAttributeOccurrenceChoiceType = AOT_Specific;
		psAttributeValues->uAttributeOccurrenceChoiceType.ppsSpecific = zraw_fill_DbvStringOrNumeric_list();
		break;
	}

}





/*-------------------------- DbvTermListDetails ----------------------*/

void zraw_setup_DbvTermListDetails(DbvExplainRecord *psExplainRecord)
{
        DbvTermListDetails *psTermListDetails = NULL;

      	psTermListDetails = (DbvTermListDetails *)DbvAlloc(sizeof(DbvTermListDetails));

	zraw_fill_DbvTermListDetails(psTermListDetails);

	/* Assign the explain record formed to the Dbv structure */
	psExplainRecord->eExplainRecordType = ERT_TermListDetails;
	psExplainRecord->uExplainRecord.psTermListDetails = psTermListDetails;
}



void zraw_fill_DbvTermListDetails(DbvTermListDetails *psTermListDetails)
{
	/* o */
	psTermListDetails->psCommonInfo = zraw_fill_DbvCommonInfo();

	/* c */
	fill_dbv_inter_string(&psTermListDetails->sTermListName, "term list name");

	/* o */
	psTermListDetails->ppsDescription = zraw_fill_DbvHumanString_list();

	/* o */
	psTermListDetails->psAttributes = zraw_fill_DbvAttributeCombinations();

	/* o */
	psTermListDetails->psScanInfo = zraw_fill_DbvScanInfo();

	/* o */
	psTermListDetails->pulEstNumberTerms = zraw_fill_Ulong();

	/* o */ 
	psTermListDetails->ppsSampleTerms = zraw_fill_DbvTerm_list();
}



DbvScanInfo *
zraw_fill_DbvScanInfo(void)
{
	DbvScanInfo *psScanInfo = NULL;

	psScanInfo = (DbvScanInfo *) DbvAlloc (sizeof (DbvScanInfo));

	/* o */
	psScanInfo->pulMaxStepSize = zraw_fill_Ulong();

	/* o */
	psScanInfo->ppsCollatingSequence = zraw_fill_DbvHumanString_list();

	/* o */
	psScanInfo->pfIncreasing = zraw_fill_DbvBool();
	
	return psScanInfo;
}



DbvTerm **
zraw_fill_DbvTerm_list(void)
{
	DbvTerm **ppsSampleTerms = NULL;

	ppsSampleTerms = (DbvTerm **) DbvAlloc (sizeof (DbvTerm *) * 9);
	ppsSampleTerms[0] = zraw_fill_DbvTerm(TT_General);
	ppsSampleTerms[1] = zraw_fill_DbvTerm(TT_Numeric);
	ppsSampleTerms[2] = zraw_fill_DbvTerm(TT_SimpleCharacter);
	ppsSampleTerms[3] = zraw_fill_DbvTerm(TT_ObjectIdentifier);
	ppsSampleTerms[4] = zraw_fill_DbvTerm(TT_DateTime);
	ppsSampleTerms[5] = zraw_fill_DbvTerm(TT_External);
	ppsSampleTerms[6] = zraw_fill_DbvTerm(TT_IntegerAndUnit);
	ppsSampleTerms[7] = zraw_fill_DbvTerm(TT_Null);
	ppsSampleTerms[8] = NULL;

	return ppsSampleTerms;
}



DbvTerm *
zraw_fill_DbvTerm(DbvTermType eTermType)
{
	DbvTerm *psTerm = NULL;

	char *test_general = "this is a general term test string";
	unsigned long test_integer = 55;
	char *test_simpchar = "this is a simple character term test string";
	char *test_oid = ANSI_UKMARC;




	/* Generalized time - see the ASN.1 (not Z39.50) spec 
           1995 (1995), Feb (02), 16th (16), nine oclock (21), six minutes (06),
      	   27.3 seconds (27.3) */
	char *test_datetime = "19950216210627.3";

	char *test_sutrs_external = "this is a term test sutrs external"; 

	psTerm = (DbvTerm *) DbvAlloc (sizeof (DbvTerm));

	switch (eTermType) {
	case TT_General:
		psTerm->eTermType = TT_General;
		psTerm->uTerm.psGeneral = (DbvOctetString *) DbvAlloc (sizeof(DbvOctetString));
		fill_dbv_octet_string(psTerm->uTerm.psGeneral, test_general);

		break;
	case TT_Numeric:
		psTerm->eTermType = TT_Numeric;
		psTerm->uTerm.ulInteger = test_integer;
		break;
	case TT_SimpleCharacter:
		psTerm->eTermType = TT_SimpleCharacter;
		psTerm->uTerm.psSimpleCharacter = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
		fill_dbv_inter_string(psTerm->uTerm.psSimpleCharacter, test_simpchar);
		break;
	case TT_ObjectIdentifier:
		psTerm->eTermType = TT_ObjectIdentifier;
		psTerm->uTerm.pcObjectIdentifier = (DbvObjectIdentifier ) DbvAlloc (strlen(test_oid) +1);
		memcpy(psTerm->uTerm.pcObjectIdentifier, test_oid, strlen(test_oid));
		break;
	case TT_DateTime:
		psTerm->eTermType = TT_DateTime;
		psTerm->uTerm.pcDateTime = (DbvGeneralizedTime ) DbvAlloc (strlen(test_datetime) +1);
		memcpy(psTerm->uTerm.pcDateTime, test_datetime, strlen(test_datetime));
		break;
	case TT_External:
		psTerm->eTermType = TT_External;
		psTerm->uTerm.psExternal = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
		fill_dbv_sutrs_external(psTerm->uTerm.psExternal, test_sutrs_external);
		break;
	case TT_IntegerAndUnit:
		psTerm->eTermType = TT_IntegerAndUnit;
		psTerm->uTerm.psIntegerAndUnit = zraw_fill_DbvIntUnit();
		break;
	case TT_Null:
		psTerm->eTermType = TT_Null;
		break;
	}

	return psTerm;
}



/*-------------------------- DbvElementSetDetails ----------------------*/


void zraw_setup_DbvElementSetDetails(DbvExplainRecord *psExplainRecord)
{
        DbvElementSetDetails *psElementSetDetails = NULL;

      	psElementSetDetails = (DbvElementSetDetails *)DbvAlloc(sizeof(DbvElementSetDetails));

	zraw_fill_DbvElementSetDetails(psElementSetDetails);

	/* Assign the explain record formed to the Dbv structure */
	psExplainRecord->eExplainRecordType = ERT_ElementSetDetails;
	psExplainRecord->uExplainRecord.psElementSetDetails = psElementSetDetails;
}



void zraw_fill_DbvElementSetDetails(DbvElementSetDetails *psElementSetDetails)
{
	/* o */
	psElementSetDetails->psCommonInfo = zraw_fill_DbvCommonInfo();

	/* c */
	fill_dbv_inter_string(&psElementSetDetails->sDatabaseName, "element set details database name");

	/* c */
	fill_dbv_inter_string(&psElementSetDetails->sElementSetName, "element set name");

	/* c */
	psElementSetDetails->pcRecordSyntax = zraw_fill_DbvObjectIdentifier();

	/* c */
	psElementSetDetails->pcSchema = zraw_fill_DbvObjectIdentifier();

	/* o */
	psElementSetDetails->ppsDescription = zraw_fill_DbvHumanString_list();

	/* o */
	psElementSetDetails->ppsDetailsPerElement = zraw_fill_DbvDetailsPerElement_list();
}



DbvDetailsPerElement **
zraw_fill_DbvDetailsPerElement_list(void)
{
	DbvDetailsPerElement **ppsDetailsPerElement = NULL;

	ppsDetailsPerElement = (DbvDetailsPerElement **) DbvAlloc (sizeof (DbvDetailsPerElement *) * 3);
	ppsDetailsPerElement[0] = (DbvDetailsPerElement *) DbvAlloc (sizeof (DbvDetailsPerElement));
	ppsDetailsPerElement[1] = (DbvDetailsPerElement *) DbvAlloc (sizeof (DbvDetailsPerElement));
	ppsDetailsPerElement[2] = NULL;


	/* o, o, o, o, o, o, o, c, c, o, o, o, o, o, o, o */ 
	ppsDetailsPerElement[0]->psName = zraw_fill_DbvInternationalString("first element name");
	ppsDetailsPerElement[0]->psRecordTag = zraw_fill_DbvRecordTag();
	ppsDetailsPerElement[0]->ppsSchemaTags = zraw_fill_DbvPathA_list();
	ppsDetailsPerElement[0]->pulMaxSize = zraw_fill_Ulong();
	ppsDetailsPerElement[0]->pulMinSize = zraw_fill_Ulong();
	ppsDetailsPerElement[0]->pulAvgSize = zraw_fill_Ulong();
	ppsDetailsPerElement[0]->pulFixedSize = zraw_fill_Ulong();
	ppsDetailsPerElement[0]->fRepeatable = DBV_FALSE;
	ppsDetailsPerElement[0]->fRequired = DBV_TRUE;
	ppsDetailsPerElement[0]->ppsDescription = zraw_fill_DbvHumanString_list();
	ppsDetailsPerElement[0]->ppsContents = zraw_fill_DbvHumanString_list();
	ppsDetailsPerElement[0]->ppsBillingInfo = zraw_fill_DbvHumanString_list();
	ppsDetailsPerElement[0]->ppsRestrictions = zraw_fill_DbvHumanString_list();
	ppsDetailsPerElement[0]->ppsAlternateNames = zraw_fill_DbvInternationalString_list();
	ppsDetailsPerElement[0]->ppsGenericNames = zraw_fill_DbvInternationalString_list();
	ppsDetailsPerElement[0]->psSearchAccess = zraw_fill_DbvAttributeCombinations();
	

	/* second node */
	/* o, o, o, o, o, o, o, c, c, o, o, o, o, o, o, o */ 
	ppsDetailsPerElement[1]->psName = zraw_fill_DbvInternationalString("second element name");
	ppsDetailsPerElement[1]->psRecordTag = zraw_fill_DbvRecordTag();
	ppsDetailsPerElement[1]->ppsSchemaTags = zraw_fill_DbvPathA_list();
	ppsDetailsPerElement[1]->pulMaxSize = zraw_fill_Ulong();
	ppsDetailsPerElement[1]->pulMinSize = zraw_fill_Ulong();
	ppsDetailsPerElement[1]->pulAvgSize = zraw_fill_Ulong();
	ppsDetailsPerElement[1]->pulFixedSize = zraw_fill_Ulong();
	ppsDetailsPerElement[1]->fRepeatable = DBV_FALSE;
	ppsDetailsPerElement[1]->fRequired = DBV_TRUE;
	ppsDetailsPerElement[1]->ppsDescription = zraw_fill_DbvHumanString_list();
	ppsDetailsPerElement[1]->ppsContents = zraw_fill_DbvHumanString_list();
	ppsDetailsPerElement[1]->ppsBillingInfo = zraw_fill_DbvHumanString_list();
	ppsDetailsPerElement[1]->ppsRestrictions = zraw_fill_DbvHumanString_list();
	ppsDetailsPerElement[1]->ppsAlternateNames = zraw_fill_DbvInternationalString_list();
	ppsDetailsPerElement[1]->ppsGenericNames = zraw_fill_DbvInternationalString_list();
	ppsDetailsPerElement[1]->psSearchAccess = zraw_fill_DbvAttributeCombinations();


	return ppsDetailsPerElement;
}


DbvRecordTag *
zraw_fill_DbvRecordTag(void)
{
	DbvRecordTag *psRecordTag = NULL;
	DbvStringOrNumeric *psDbvStringOrNumeric = NULL;

	psRecordTag = (DbvRecordTag *) DbvAlloc (sizeof (DbvRecordTag));

	/* o */
	psRecordTag->psQualifier = zraw_fill_DbvStringOrNumeric(SNT_Numeric);

	/* c */
	psDbvStringOrNumeric = zraw_fill_DbvStringOrNumeric(SNT_String);
	psRecordTag->sTagValue = *psDbvStringOrNumeric; 


	return psRecordTag;
}



DbvPathA **
zraw_fill_DbvPathA_list(void)
{
	DbvPathA **ppsSchemaTags = NULL;

	ppsSchemaTags = (DbvPathA **) DbvAlloc (sizeof (DbvPathA *) * 3);
	ppsSchemaTags[0] = (DbvPathA *) DbvAlloc (sizeof (DbvPathA));
	ppsSchemaTags[1] = (DbvPathA *) DbvAlloc (sizeof (DbvPathA));
	ppsSchemaTags[2] = NULL;

	/* c */
	ppsSchemaTags[0]->ppsSchemaTags = zraw_fill_DbvPath_list();
	ppsSchemaTags[1]->ppsSchemaTags = zraw_fill_DbvPath_list();

	return ppsSchemaTags;
}



/*-------------------------- DbvRetrievalRecordDetails ----------------------*/

void zraw_setup_DbvRetrievalRecordDetails(DbvExplainRecord *psExplainRecord)
{
        DbvRetrievalRecordDetails *psRetrievalRecordDetails = NULL;

      	psRetrievalRecordDetails = (DbvRetrievalRecordDetails *)DbvAlloc(sizeof(DbvRetrievalRecordDetails));

	zraw_fill_DbvRetrievalRecordDetails(psRetrievalRecordDetails);

	/* Assign the explain record formed to the Dbv structure */
	psExplainRecord->eExplainRecordType = ERT_RetrievalRecordDetails;
	psExplainRecord->uExplainRecord.psRetrievalRecordDetails = psRetrievalRecordDetails;
}



void zraw_fill_DbvRetrievalRecordDetails(DbvRetrievalRecordDetails *psRetrievalRecordDetails)
{
	/* o */
	psRetrievalRecordDetails->psCommonInfo = zraw_fill_DbvCommonInfo();

	/* c */
	fill_dbv_inter_string(&psRetrievalRecordDetails->sDatabaseName, "element set details database name");

	/* c */
	psRetrievalRecordDetails->pcSchema = zraw_fill_DbvObjectIdentifier();

	/* c */
	psRetrievalRecordDetails->pcRecordSyntax = zraw_fill_DbvObjectIdentifier();

	/* o */
	psRetrievalRecordDetails->ppsDescription = zraw_fill_DbvHumanString_list();
	/* o */
	psRetrievalRecordDetails->ppsDetailsPerElement = zraw_fill_DbvDetailsPerElement_list();

}





/*-------------------------- DbvSortDetails ----------------------*/

void zraw_setup_DbvSortDetails(DbvExplainRecord *psExplainRecord)
{
        DbvSortDetails *psSortDetails = NULL;

      	psSortDetails = (DbvSortDetails *)DbvAlloc(sizeof(DbvSortDetails));

	zraw_fill_DbvSortDetails(psSortDetails);

	/* Assign the explain record formed to the Dbv structure */
	psExplainRecord->eExplainRecordType = ERT_SortDetails;
	psExplainRecord->uExplainRecord.psSortDetails = psSortDetails;
}



void zraw_fill_DbvSortDetails(DbvSortDetails *psSortDetails)
{
	/* o */
	psSortDetails->psCommonInfo = zraw_fill_DbvCommonInfo();

	/* c */
	fill_dbv_inter_string(&psSortDetails->sDatabaseName, "sort details database name");

	/* o */
	psSortDetails->ppsSortKeys = zraw_fill_DbvSortKeys_list();

}


DbvSortKeys **
zraw_fill_DbvSortKeys_list(void)
{	
	DbvSortKeys **ppsSortKeys = NULL;

	ppsSortKeys = (DbvSortKeys **) DbvAlloc (sizeof (DbvSortKeys *) * 3);
	ppsSortKeys[0] = (DbvSortKeys *) DbvAlloc (sizeof (DbvSortKeys));
	ppsSortKeys[1] = (DbvSortKeys *) DbvAlloc (sizeof (DbvSortKeys));
	ppsSortKeys[2] = NULL;


	/* o, o, o, o, o */ 
	ppsSortKeys[0]->ppsDescription = zraw_fill_DbvHumanString_list();
	ppsSortKeys[0]->ppsElementSpecifications = zraw_fill_DbvSpecification_list();

	ppsSortKeys[0]->psAttributeSpecifications = zraw_fill_DbvAttributeCombinations();
	ppsSortKeys[0]->psSortType = zraw_fill_DbvSortType(STT_Character);
	ppsSortKeys[0]->peCaseSensitivity = zraw_fill_DbvCaseSensitivity();


	/* o, o, o, o, o */ 
	ppsSortKeys[1]->ppsDescription = zraw_fill_DbvHumanString_list();
	ppsSortKeys[1]->ppsElementSpecifications = zraw_fill_DbvSpecification_list();
	ppsSortKeys[1]->psAttributeSpecifications = zraw_fill_DbvAttributeCombinations();
	ppsSortKeys[1]->psSortType = zraw_fill_DbvSortType(STT_Structured);
	ppsSortKeys[1]->peCaseSensitivity = zraw_fill_DbvCaseSensitivity();


	return ppsSortKeys;
}



DbvSpecification **
zraw_fill_DbvSpecification_list(void)
{
	DbvSpecification **ppsElementSpecifications = NULL;

	ppsElementSpecifications = (DbvSpecification **) DbvAlloc (sizeof (DbvSpecification *) * 3);

	/* o */
	ppsElementSpecifications[0] = zraw_fill_DbvSpecification(EST_Primitive);

	/* o */
	ppsElementSpecifications[1] = zraw_fill_DbvSpecification(EST_External);
	ppsElementSpecifications[2] = NULL;

	return ppsElementSpecifications;

}



DbvSpecification *
zraw_fill_DbvSpecification(DbvElementSpecType eElementSpecType)
{
	DbvSpecification *psGeneric = NULL;
 
        char *oid_value = ANSI_DANMARC;

	psGeneric = (DbvSpecification *) DbvAlloc (sizeof (DbvSpecification));
 
        /* DbvObjectIdentifier is a typedef char * */
 
	/* o */
        /* +1 to allocate space for the \0 */
        psGeneric->pcSchema = (DbvObjectIdentifier ) DbvAlloc (strlen(oid_value) +1);
 
        /* Have an ANSI_DANMARC for the ObjectIdentifier */
	strcpy(psGeneric->pcSchema, oid_value);

	/* optional */
        psGeneric->psElementSpec = zraw_fill_DbvElementSpec(eElementSpecType);

	return psGeneric;
}



DbvElementSpec *
zraw_fill_DbvElementSpec(DbvElementSpecType eElementSpecType)
{

	DbvElementSpec *psElementSpec = NULL;

        char *test_inter_string = "a specification test";
        char sutrs_string[1000];

	psElementSpec = (DbvElementSpec *) DbvAlloc (sizeof (DbvElementSpec));

	switch (eElementSpecType) {
	case EST_Primitive:

                /* An international string */
                psElementSpec->eElementSpecType = EST_Primitive;
                psElementSpec->uElementSpec.psPrimitive = (DbvInternationalString *)DbvAlloc (sizeof (DbvInternationalString));
                fill_dbv_inter_string(psElementSpec->uElementSpec.psPrimitive, test_inter_string);
		break;
	case EST_External:
                psElementSpec->eElementSpecType = EST_External;
                psElementSpec->uElementSpec.psExternal = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));
 
                /* Set up a sutrs external */
                strcpy(sutrs_string, "an external specification sutrs");
                fill_dbv_sutrs_external(psElementSpec->uElementSpec.psExternal, sutrs_string);
		break;
        }

	return psElementSpec;
}



DbvSortType *
zraw_fill_DbvSortType(DbvSortTypeType eSortTypeType)
{
	DbvSortType *psSortType = NULL;

	psSortType = (DbvSortType *) DbvAlloc (sizeof (DbvSortType));

	switch (eSortTypeType) {
	case STT_Structured:
		psSortType->eSortTypeType = STT_Structured;
		psSortType->uSortType.ppsStructured = zraw_fill_DbvHumanString_list();
		break;
	case STT_Character:
	case STT_Numeric:
		psSortType->eSortTypeType = eSortTypeType;
		break;
	}

	return psSortType;
}



DbvCaseSensitivity *
zraw_fill_DbvCaseSensitivity(void)
{
	DbvCaseSensitivity *peCaseSensitivity = NULL;

	/* o */
	peCaseSensitivity = (DbvCaseSensitivity *) DbvAlloc (sizeof (DbvCaseSensitivity));
	*peCaseSensitivity = CSE_DefaultNo;


	return peCaseSensitivity;
}



/*-------------------------- DbvProcessingInformation ----------------------*/

void zraw_setup_DbvProcessingInformation(DbvExplainRecord *psExplainRecord)
{
        DbvProcessingInformation *psProcessing = NULL;

      	psProcessing = (DbvProcessingInformation *)DbvAlloc(sizeof(DbvProcessingInformation));

	zraw_fill_DbvProcessingInformation(psProcessing);

	/* Assign the explain record formed to the Dbv structure */
	psExplainRecord->eExplainRecordType = ERT_Processing;
	psExplainRecord->uExplainRecord.psProcessing = psProcessing;
}




void zraw_fill_DbvProcessingInformation(DbvProcessingInformation *psProcessing)
{
	/* o */
	psProcessing->psCommonInfo = zraw_fill_DbvCommonInfo();

	/* c */
	fill_dbv_inter_string(&psProcessing->sDatabaseName, "processing database name");

	/* c */
	psProcessing->eProcessingContext = PC_RecordPresentation;

	/* c */
	fill_dbv_inter_string(&psProcessing->sName, "processing name");

	/* c */
	psProcessing->pcOid = zraw_fill_DbvObjectIdentifier();

	/* o */
	psProcessing->ppsDescription = zraw_fill_DbvHumanString_list();

	/* o */
	psProcessing->psInstructions = zraw_fill_DbvASN1External();

}





/*-------------------------- DbvVariantSetInfo ----------------------*/

void zraw_setup_DbvVariantSetInfo(DbvExplainRecord *psExplainRecord)
{
        DbvVariantSetInfo *psVariants = NULL;

      	psVariants = (DbvVariantSetInfo *)DbvAlloc(sizeof(DbvVariantSetInfo));

	zraw_fill_DbvVariantSetInfo(psVariants);

	/* Assign the explain record formed to the Dbv structure */
	psExplainRecord->eExplainRecordType = ERT_Variants;
	psExplainRecord->uExplainRecord.psVariants = psVariants;
}





void zraw_fill_DbvVariantSetInfo(DbvVariantSetInfo *psVariants)
{
	/* o */
	psVariants->psCommonInfo = zraw_fill_DbvCommonInfo();

	/* c */
	psVariants->pcVariantSet = zraw_fill_DbvObjectIdentifier();

	/* c */
	fill_dbv_inter_string(&psVariants->sName, "variant set name");

	/* o */
	psVariants->ppsVariants = zraw_fill_DbvVariantClass_list();

}



DbvVariantClass **
zraw_fill_DbvVariantClass_list(void)
{
	DbvVariantClass **ppsVariants = NULL;

	ppsVariants = (DbvVariantClass **) DbvAlloc (sizeof (DbvVariantClass *) * 3);
	ppsVariants[0] = (DbvVariantClass *) DbvAlloc (sizeof (DbvVariantClass));
	ppsVariants[1] = (DbvVariantClass *) DbvAlloc (sizeof (DbvVariantClass));
	ppsVariants[2] = NULL;


	/* o */
	ppsVariants[0]->psName = zraw_fill_DbvInternationalString("first variants name");

	/* o */
	ppsVariants[0]->ppsDescription = zraw_fill_DbvHumanString_list();

	/* c */
	ppsVariants[0]->ulVariantClass = 456;

	/* c */
	ppsVariants[0]->ppsVariantTypes = zraw_fill_DbvVariantTypes_list();



	/* o, o, c, c */
	ppsVariants[1]->psName = zraw_fill_DbvInternationalString("second variants name");
	ppsVariants[1]->ppsDescription = zraw_fill_DbvHumanString_list();

	ppsVariants[1]->ulVariantClass = 456;
	ppsVariants[1]->ppsVariantTypes = zraw_fill_DbvVariantTypes_list();

	return ppsVariants;
}



DbvVariantTypes **
zraw_fill_DbvVariantTypes_list(void)
{
	DbvVariantTypes **ppsVariantTypes = NULL;

	ppsVariantTypes = (DbvVariantTypes **) DbvAlloc (sizeof (DbvVariantTypes *) * 3);
	ppsVariantTypes[0] = (DbvVariantTypes *) DbvAlloc (sizeof (DbvVariantTypes));
	ppsVariantTypes[1] = (DbvVariantTypes *) DbvAlloc (sizeof (DbvVariantTypes));
	ppsVariantTypes[2] = NULL;


	/* first node */

	/* o */
	ppsVariantTypes[0]->psName = zraw_fill_DbvInternationalString("first variant types name");

	/* o */
	ppsVariantTypes[0]->ppsDescription = zraw_fill_DbvHumanString_list();

	/* c */
	ppsVariantTypes[0]->ulVariantType = 321;

	/* o */
	ppsVariantTypes[0]->psVariantValue = zraw_fill_DbvVariantValue();



	/* second node */

	/* o */
	ppsVariantTypes[1]->psName = zraw_fill_DbvInternationalString("second variant types name");

	/* o */
	ppsVariantTypes[1]->ppsDescription = zraw_fill_DbvHumanString_list();

	/* c */
	ppsVariantTypes[1]->ulVariantType = 322;

	/* o */
	ppsVariantTypes[1]->psVariantValue = zraw_fill_DbvVariantValue();


	return ppsVariantTypes;
}



DbvVariantValue *
zraw_fill_DbvVariantValue(void)
{
	DbvVariantValue *psVariantValue = NULL;

	psVariantValue = (DbvVariantValue *) DbvAlloc (sizeof (DbvVariantValue));

	/* c */
	psVariantValue->eDataType = PDT_TrueOrFalse;

	/* o */
	psVariantValue->psValues = zraw_fill_DbvValueSet();


	return psVariantValue;
}



DbvValueSet *
zraw_fill_DbvValueSet(void)
{
	DbvValueSet *psValues = NULL;

	int choice = 0;
        char choice_string[100];

	psValues = (DbvValueSet *) DbvAlloc (sizeof (DbvValueSet));

	
	choice = 0;
        while (choice < 1 || choice > 2) {
                printf("Enter eValueSetType type: VT_Range (1), VT_Enumerated (2): ");
                choice = (atol(gets(choice_string)));
        }


	switch (choice) {
	case 1:
		psValues->eValueSetType = VT_Range;
		psValues->uValueSet.psRange = zraw_fill_DbvValueRange();
		break;
	case 2:
		psValues->eValueSetType = VT_Enumerated;
		psValues->uValueSet.ppsEnumerated = zraw_fill_DbvValueDescription_list();
		break;
	}
	
	return psValues;
}



DbvValueRange *
zraw_fill_DbvValueRange(void)
{
	DbvValueRange *psRange = NULL;

	psRange = (DbvValueRange *) DbvAlloc (sizeof (DbvValueRange));

	/* o */
	psRange->psLower = zraw_fill_DbvValueDescription(VDT_Octets);

	/* o */
	psRange->psUpper = zraw_fill_DbvValueDescription(VDT_ValueAndUnit);

	return psRange;
}



DbvValueDescription *
zraw_fill_DbvValueDescription(DbvValueDescriptionType eValueDescriptionType)
{
	DbvValueDescription *psDbvValueDescription = NULL;


	psDbvValueDescription = (DbvValueDescription *) DbvAlloc (sizeof (DbvValueDescription));

	switch (eValueDescriptionType) {
	case VDT_Integer:
		psDbvValueDescription->eValueDescriptionType = VDT_Integer;
		psDbvValueDescription->uValueDescription.ulInteger = 99;
		break;
	case VDT_String:
		psDbvValueDescription->eValueDescriptionType = VDT_String;
		psDbvValueDescription->uValueDescription.psString = zraw_fill_DbvInternationalString("value descriptor string");
		break;
	case VDT_Octets:
		psDbvValueDescription->eValueDescriptionType = VDT_Octets;
		psDbvValueDescription->uValueDescription.psOctets = zraw_fill_DbvOctetString();
		break;
	case VDT_Oid:
		psDbvValueDescription->eValueDescriptionType = VDT_Oid;
		psDbvValueDescription->uValueDescription.pcOid = zraw_fill_DbvObjectIdentifier();
		break;
	case VDT_Unit:
		psDbvValueDescription->eValueDescriptionType = VDT_Unit;
		psDbvValueDescription->uValueDescription.psUnit = zraw_fill_DbvUnit();
		break;
	case VDT_ValueAndUnit:
		psDbvValueDescription->eValueDescriptionType = VDT_ValueAndUnit;
		psDbvValueDescription->uValueDescription.psValueAndUnit = zraw_fill_DbvIntUnit();
		break;
	}

	return psDbvValueDescription;
}



DbvOctetString *
zraw_fill_DbvOctetString(void)
{
	DbvOctetString *psDbvOctetString = NULL;

	psDbvOctetString = (DbvOctetString *) DbvAlloc (sizeof (DbvOctetString));
	fill_dbv_octet_string(psDbvOctetString, "test octet string");

	return psDbvOctetString;
}



DbvValueDescription **
zraw_fill_DbvValueDescription_list(void)
{
	DbvValueDescription **ppsEnumerated = NULL;


	/* 7 = 0.. 6 */
	ppsEnumerated = (DbvValueDescription **) DbvAlloc (sizeof (DbvValueDescription *) * 7 );

	ppsEnumerated[0] = zraw_fill_DbvValueDescription(VDT_Integer);
	ppsEnumerated[1] = zraw_fill_DbvValueDescription(VDT_String);
	ppsEnumerated[2] = zraw_fill_DbvValueDescription(VDT_Octets);
	ppsEnumerated[3] = zraw_fill_DbvValueDescription(VDT_Oid);
	ppsEnumerated[4] = zraw_fill_DbvValueDescription(VDT_Unit);
	ppsEnumerated[5] = zraw_fill_DbvValueDescription(VDT_ValueAndUnit);
	ppsEnumerated[6] = NULL;


	return ppsEnumerated;
}




/*-------------------------- DbvUnitInfo ----------------------*/

void zraw_setup_DbvUnitInfo(DbvExplainRecord *psExplainRecord)
{
        DbvUnitInfo *psUnits = NULL;

      	psUnits = (DbvUnitInfo *)DbvAlloc(sizeof(DbvUnitInfo));

	zraw_fill_DbvUnitInfo(psUnits);

	/* Assign the explain record formed to the Dbv structure */
	psExplainRecord->eExplainRecordType = ERT_Units;
	psExplainRecord->uExplainRecord.psUnits = psUnits;
}




void zraw_fill_DbvUnitInfo(DbvUnitInfo *psUnits)
{

	/* o */
	psUnits->psCommonInfo = zraw_fill_DbvCommonInfo();

	/* c */
	fill_dbv_inter_string(&psUnits->sUnitSystem, "unit info system");

	/* o */
	psUnits->ppsDescription = zraw_fill_DbvHumanString_list();

	/* o */
	psUnits->ppsUnitTypes = zraw_fill_DbvUnitType_list();
}



DbvUnitType **
zraw_fill_DbvUnitType_list(void)
{
	DbvUnitType **ppsUnitTypes = NULL;

	ppsUnitTypes = (DbvUnitType **) DbvAlloc (sizeof (DbvUnitType *) * 3);

	ppsUnitTypes[0] = (DbvUnitType *) DbvAlloc (sizeof (DbvUnitType));
	ppsUnitTypes[1] = (DbvUnitType *) DbvAlloc (sizeof (DbvUnitType));
	ppsUnitTypes[2] = NULL;


	/* o */
	ppsUnitTypes[0]->psName = zraw_fill_DbvInternationalString("first units types name");

	/* o */
	ppsUnitTypes[0]->ppsDescription = zraw_fill_DbvHumanString_list();

	/* c */
	ppsUnitTypes[0]->sUnitType = *(zraw_fill_DbvStringOrNumeric(SNT_String));

	/* c */
	ppsUnitTypes[0]->ppsUnits = zraw_fill_DbvUnits();



	/* o, o, c, c */
	ppsUnitTypes[1]->psName = zraw_fill_DbvInternationalString("second unit types name");
	ppsUnitTypes[1]->ppsDescription = zraw_fill_DbvHumanString_list();


	ppsUnitTypes[1]->sUnitType = *(zraw_fill_DbvStringOrNumeric(SNT_Numeric));

	ppsUnitTypes[1]->ppsUnits = zraw_fill_DbvUnits();



	return ppsUnitTypes;
}



DbvUnits **
zraw_fill_DbvUnits(void)
{
	DbvUnits **ppsUnits = NULL;
	DbvStringOrNumeric *psDbvStringOrNumeric = NULL;

	ppsUnits = (DbvUnits **) DbvAlloc (sizeof (DbvUnits *) * 3);

	ppsUnits[0] = (DbvUnits *) DbvAlloc (sizeof (DbvUnits));
	ppsUnits[1] = (DbvUnits *) DbvAlloc (sizeof (DbvUnits));


	/* o, o, c */
	ppsUnits[0]->psName = zraw_fill_DbvInternationalString("first units name");
	ppsUnits[0]->ppsDescription = zraw_fill_DbvHumanString_list();
	ppsUnits[0]->sUnit = *(zraw_fill_DbvStringOrNumeric(SNT_String)); 


	/* o, o, c */
	ppsUnits[1]->psName = zraw_fill_DbvInternationalString("second units name");
	ppsUnits[1]->ppsDescription = zraw_fill_DbvHumanString_list();
	ppsUnits[1]->sUnit = *(zraw_fill_DbvStringOrNumeric(SNT_String)); 



	return ppsUnits;

}



/*-------------------------- DbvCategoryList ----------------------*/

void 
zraw_setup_DbvCategoryList(DbvExplainRecord *psExplainRecord)
{
        DbvCategoryList *psCategoryList = NULL;

      	psCategoryList = (DbvCategoryList *)DbvAlloc(sizeof(DbvCategoryList));

	zraw_fill_DbvCategoryList(psCategoryList);

	/* Assign the explain record formed to the Dbv structure */
	psExplainRecord->eExplainRecordType = ERT_CategoryList;
	psExplainRecord->uExplainRecord.psCategoryList = psCategoryList;
}



void 
zraw_fill_DbvCategoryList(DbvCategoryList *psCategoryList)
{
	/* o */
	psCategoryList->psCommonInfo = zraw_fill_DbvCommonInfo();

	/* c */
	psCategoryList->ppsCategories = zraw_fill_DbvCategoryInfo_list();
}



DbvCategoryInfo **
zraw_fill_DbvCategoryInfo_list(void)
{
	DbvCategoryInfo **ppsCategories = NULL;

	ppsCategories = (DbvCategoryInfo **) DbvAlloc (sizeof (DbvCategoryInfo *) * 3);
	ppsCategories[0] = (DbvCategoryInfo *) DbvAlloc (sizeof (DbvCategoryInfo));
	ppsCategories[1] = (DbvCategoryInfo *) DbvAlloc (sizeof (DbvCategoryInfo));
	ppsCategories[2] = NULL;


	/* c */
	fill_dbv_inter_string(&ppsCategories[0]->sCategory, "first category string");

	/* o */
	ppsCategories[0]->psOriginalCategory = zraw_fill_DbvInternationalString("first original category");

	/* o */
	ppsCategories[0]->ppsDescription = zraw_fill_DbvHumanString_list();

	/* o */
	ppsCategories[0]->psAsn1Module = zraw_fill_DbvInternationalString("first asn1module");


	/* second node */

	/* c, o, o, o */
	fill_dbv_inter_string(&ppsCategories[1]->sCategory, "second category string ");
	ppsCategories[1]->psOriginalCategory = zraw_fill_DbvInternationalString("second original category");
	ppsCategories[1]->ppsDescription = zraw_fill_DbvHumanString_list();
	ppsCategories[1]->psAsn1Module = zraw_fill_DbvInternationalString("second asn1module");





	return ppsCategories;

}






