#include "api_target_release.h"

void print_releasereq_fields(FILE *f, DbvReleaseReq *peReleaseReq)
{
	fprintf(f, "peReleaseReq: ");
	switch(*peReleaseReq)
	{
	case ReleaseReq_Normal:
		fprintf(f, "ReleaseReq_Normal\n");
		break;
	case ReleaseReq_Urgent:
		fprintf(f, "ReleaseReq_Urgent\n");
		break;
	case ReleaseReq_Undefined:
		fprintf(f, "ReleaseReq_Undefined\n");
		break;
	default:
		fprintf(f, "Error: the value is not valid!\n");
		break;
	}
}



int send_releasersp_to_origin(DbvAssocId lAssocId)
{
	long choice;
	char choice_string[32];

	DbvReleaseRsp   sReleaseRsp;
	DbvError        *psError = NULL;

	sReleaseRsp.peReleaseRspReason=(DbvReleaseRspReason *)
		DbvAlloc(sizeof(DbvReleaseRspReason));

	choice=0;
	while(choice<1 || choice >2)
	{
		printf("Accept or Reject the release request\n\t1.Affirmative\n\t2.Negative\n");
		choice=atol(gets(choice_string));
	}
	switch(choice)
	{
	case 1:
		sReleaseRsp.eReleaseRspResult=Affirmative;
		break;
	case 2:
		sReleaseRsp.eReleaseRspResult=Negative;
		break;
	}
	choice=0;
	while(choice<1 || choice >3)
	{
		printf("Enter the release reason\n\t1.None\n\t2.Normal\n\t3.Not_Finished\n");
		choice=atol(gets(choice_string));
	}
	switch(choice)
	{
	case 1:
		sReleaseRsp.peReleaseRspReason=NULL;
		break;
	case 2:
		*sReleaseRsp.peReleaseRspReason=Normal;
		break;
	case 3:
		*sReleaseRsp.peReleaseRspReason=Not_Finished;
		break;
	}

	if(DbvReleaseResponse(lAssocId, &sReleaseRsp, &psError) == SI_OK) 
	{
		printf("Connection released ok\n");
	} else {
		printf("Connection release failed\n");
		PrivateErrorHandling(&psError);
	}
}

