/*  Module Name: @(#)api_usmarc_formatter.h	7.1
    Version: 11/15/96
    Author: John Hough

    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ

    Date of Issue:

    QA Acceptance:
    Date of Acceptance:

    Description: Header file for api_usmarc_formatter.c. Inspired
		 by code in the Willow Z39.50 application.

*/


#ifndef api_usmarc_formatter_h
#define api_usmarc_formatter_h

 
#include "api_common_includes.h"


typedef char str[1024];

typedef enum MarcType {
	Tomas_marc = 0,
	Normal_marc = 1
} MarcType;


#define CODELEN 3

/* End of String */
#define EOS '\0'     

/* Max length for bibliographical record */
#define MAXBIBLEN 6114 

/* Min length for bibliograpghical record */
#define MINBIBLEN 124  

/* Max length for holdings record */
#define MAXHLEN 6114  

/* Min length for holdings record */
#define MINHLEN 112   


/* Record end */
#define REC_END '\035'                      

/* Record seperator */
#define REC_SEP '\036'       


/* Start of Subsection */
#define REC_SUBSEC '\037'                  

/* Charaacter to output for subsection */
#define SCHAR '|'                 


int usmarc_format(DbvOctetString *psDbvOctetString, MarcType eMarcType, DbvBool ePrintHeader, FILE *file);
int holdings_rec(char *record);
int hold_rec(char *record, int length, FILE *f)  ;
int check_hold_length(int length, FILE *f);
int bib_rec(char *record, int length, MarcType eMarcType, DbvBool ePrintHeader, FILE *f);
int check_bib_length(int length, FILE *f);
int int_from_string(char *string, int len, FILE *f);
int check_addr(int addr, int length, FILE *f);
int print_bib_leader(char *record, FILE *f)                  ;
int print_rec_status(char *record, FILE *f);
int check_8_9_10_11(char *record, FILE *f);
int print_trans_type(char *record, FILE *f);
int get_code_length_offset(char *record, int *code, int *compon_length, int *offset, int *p, FILE *f);
int print_data(char *dp, int length, FILE *f);
int ndmarc(char* record, int length, FILE *f);
int nbib_rec(char *record, int length, FILE *f);
int ndisplay( int code, char *record, int offset, int compon_length, FILE *f);
int copy(char *dp, char *sp, int length );
int show_field(char *data, int type, char *name, FILE *f);


#endif
