/*  Module Name: @(#)bstrings_replace.c	4.1
    Version: 5/15/96
    Author: John Hough
    
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ

    Date of Issue:  

    QA Acceptance:  
    Date of Acceptance:  

    Description:  

*/


/* bcopy replacement */
void bcopy_replacement(char *src, char *dst, int len)
{
	/* Dont use memmove() because some environments (e.g. Solaris 1)
	dont support it !!. */
 
	/* determine if the regions overlap
	*
	* 3 cases:  src==dst, src<dst, src>dst
	*
	* if src==dst, they overlap completely, but nothing needs to be moved
	* if src<dst and src+len>dst then they overlap
	* if src>dst and src<dst+len then they overlap
	*/
 
	/* If nothing to copy then return */
	if (src == dst || len <= 0) 
		return;    

	/* If the regions overlap copy backwards */
	if (src<dst && src+len>dst) {  
		src = src + len - 1;
		dst = dst + len - 1;
		for ( ; len>0; len--, src--, dst--) 
			*dst = *src;

	/* else they dont overlap so copy forwards */
	} else {  

		/* Copy forwards  */
		for ( ; len>0; len--, src++, dst++) 
			*dst = *src;
	} 
}


/* bzero replacement */
void bzero_replacement(char *b, int len)
{
	memset(b, 0, len);
}
