/*  Module Name: @(#)invalid_pdu.c	7.1
    Version: 11/15/96
    Author: John Hough

    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ

    Date of Issue:

    QA Acceptance:
    Date of Acceptance:

    Description: Invalid (Unknown) PDU file output routines


*/

#include "invalid_pdu.h"

int DBVoutput_invalid_pdu(DbvOctetString *psInvalidAPDU)
{
	FILE *fp = NULL;
	char filename[SA_ARRAY_SIZE];

	/* Form INVALID_PDU_DIR/Inv_Pdu.<process id> 
	   (INVALID_PDU_DIR #defined in sidefs.h) */
	DBVform_inpdu_filename(filename, INVALID_PDU_DIR);
	fp = DBVopen_inpdu_file(filename);

	if (fp != NULL) {
		DBVwrite_inpdu_file(fp, psInvalidAPDU);
		DBVclose_inpdu_file(fp);
	} else
		return -1;
	
	return 1;
}



int DBVform_inpdu_filename(char *filename, char *diagdir)
{
	char pid_string[SA_ARRAY_SIZE];

	/* 8 digits max */
	sprintf(pid_string, "%.8d", getpid());

	DBVsa_strcpy(filename, diagdir);
	DBVsa_strcat(filename, "/Inv_Pdu.");
	DBVsa_strcat(filename, pid_string);

	return 1;
}



FILE *DBVopen_inpdu_file(char *filename)
{
	FILE *fp = NULL;

	/* Open file for append */
	if ((fp = fopen(filename, "a")) == NULL) {
		fprintf(stderr, "couldnt open invalid pdu file diagnostic file\n");
		return NULL;
	}

	return fp;
}



int DBVclose_inpdu_file(FILE *fp)
{
	fclose(fp);
}



int DBVwrite_inpdu_file(FILE *fp, DbvOctetString *psInvalidAPDU)
{
	/* Call a function in tp_style_print.c */
	DBVprint_invalidapdu(fp, psInvalidAPDU);

}



