/*
 *    iordext.h
 *
 *    "IORDEXT" ASN.1 module C type definitions and prototypes
 *
 *    This .h file was by snacc on Thu Apr 24 11:53:20 1997
 *
 *    UBC snacc written compiler by Mike Sample
 *
 *    NOTE: This is a machine generated file - editing not recommended
 */


#ifndef _iordext_h_
#define _iordext_h_




typedef enum IORDEXTAnyId
{
    subitoOid_ANY_ID = 35} IORDEXTAnyId;


void InitAnyIORDEXT();

typedef enum
    {
        SINGLE = 1,
        COLLECTIVE = 2
    } AddBillingInfoEnum; /* ENUMERATED { SINGLE(1), COLLECTIVE(2) }  */

#define BEncAddBillingInfoEnumContent BEncAsnEnumContent

#define BDecAddBillingInfoEnumContent BDecAsnEnumContent

#define PrintAddBillingInfoEnum PrintAsnEnum

#define FreeAddBillingInfoEnum FreeAsnEnum 




typedef enum
    {
        ALL1 = 1,
        NEGATIVE = 2,
        NONE3 = 3
    } AddDeliveryInfoEnum1; /* ENUMERATED { ALL1(1), NEGATIVE(2), NONE3(3) }  */

#define BEncAddDeliveryInfoEnum1Content BEncAsnEnumContent

#define BDecAddDeliveryInfoEnum1Content BDecAsnEnumContent

#define PrintAddDeliveryInfoEnum1 PrintAsnEnum

#define FreeAddDeliveryInfoEnum1 FreeAsnEnum 




typedef enum
    {
        ALL2 = 1,
        NEGATIVE1 = 2,
        NONE4 = 3
    } AddDeliveryInfoEnum; /* ENUMERATED { ALL2(1), NEGATIVE1(2), NONE4(3) }  */

#define BEncAddDeliveryInfoEnumContent BEncAsnEnumContent

#define BDecAddDeliveryInfoEnumContent BDecAsnEnumContent

#define PrintAddDeliveryInfoEnum PrintAsnEnum

#define FreeAddDeliveryInfoEnum FreeAsnEnum 




typedef enum
    {
        USERGROUP1 = 1,
        USERGROUP2 = 2
    } AddRequesterInfoEnum; /* ENUMERATED { USERGROUP1(1), USERGROUP2(2) }  */

#define BEncAddRequesterInfoEnumContent BEncAsnEnumContent

#define BDecAddRequesterInfoEnumContent BDecAsnEnumContent

#define PrintAddRequesterInfoEnum PrintAsnEnum

#define FreeAddRequesterInfoEnum FreeAsnEnum 




typedef struct BillingBankInfo /* SEQUENCE */
{
    VisibleString bankAccountHouse; /* [1] IMPLICIT VisibleString */
    VisibleString bankAccountRoutingSymbol; /* [2] IMPLICIT VisibleString */
    VisibleString bankAccountNo; /* [3] IMPLICIT VisibleString */
    AsnBool bankAuthority; /* [4] IMPLICIT BOOLEAN */
} BillingBankInfo;

AsnLen BEncBillingBankInfoContent PROTO((BUF_TYPE b, BillingBankInfo* v));

void BDecBillingBankInfoContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, BillingBankInfo* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintBillingBankInfo PROTO((FILE* f, BillingBankInfo* v, unsigned short int indent));
void FreeBillingBankInfo PROTO((BillingBankInfo* v));





typedef struct BillingCreditCardInfo /* SEQUENCE */
{
    VisibleString cardCompany; /* [1] IMPLICIT VisibleString */
    VisibleString cardNo; /* [2] IMPLICIT VisibleString */
    ISO_Date cardValidFrom; /* [3] IMPLICIT ISO-Date OPTIONAL */
    ISO_Date cardValidThru; /* [4] IMPLICIT ISO-Date */
} BillingCreditCardInfo;

AsnLen BEncBillingCreditCardInfoContent PROTO((BUF_TYPE b, BillingCreditCardInfo* v));

void BDecBillingCreditCardInfoContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, BillingCreditCardInfo* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintBillingCreditCardInfo PROTO((FILE* f, BillingCreditCardInfo* v, unsigned short int indent));
void FreeBillingCreditCardInfo PROTO((BillingCreditCardInfo* v));





typedef struct AddRequesterInfo /* SEQUENCE */
{
    AddRequesterInfoEnum* requesterGroup; /* [1] IMPLICIT AddRequesterInfoEnum DEFAULT 1 */
    VisibleString requesterEmailAddress; /* [2] IMPLICIT VisibleString OPTIONAL */
} AddRequesterInfo;

AsnLen BEncAddRequesterInfoContent PROTO((BUF_TYPE b, AddRequesterInfo* v));

void BDecAddRequesterInfoContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, AddRequesterInfo* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintAddRequesterInfo PROTO((FILE* f, AddRequesterInfo* v, unsigned short int indent));
void FreeAddRequesterInfo PROTO((AddRequesterInfo* v));





typedef struct AddDeliveryInfo /* SEQUENCE */
{
    AddDeliveryInfoEnum* statusLevelUser; /* [1] IMPLICIT AddDeliveryInfoEnum DEFAULT 2 */
    AddDeliveryInfoEnum1* statusLevelRequester; /* [2] IMPLICIT AddDeliveryInfoEnum1 DEFAULT 3 */
    VisibleString deliveryNotes; /* [3] IMPLICIT VisibleString OPTIONAL */
    VisibleString countryDeliveryTarget; /* [4] IMPLICIT VisibleString OPTIONAL */
    AsnBool* alternativePostalDelivery; /* [5] IMPLICIT BOOLEAN DEFAULT FALSE */
} AddDeliveryInfo;

AsnLen BEncAddDeliveryInfoContent PROTO((BUF_TYPE b, AddDeliveryInfo* v));

void BDecAddDeliveryInfoContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, AddDeliveryInfo* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintAddDeliveryInfo PROTO((FILE* f, AddDeliveryInfo* v, unsigned short int indent));
void FreeAddDeliveryInfo PROTO((AddDeliveryInfo* v));





typedef struct AddBillingInfo /* CHOICE */
{
    enum AddBillingInfoChoiceId
    {
        ADDBILLINGINFO_BILLINGBANKINFO,
        ADDBILLINGINFO_BILLINGCREDITCARDINFO,
        ADDBILLINGINFO_BILLINGINVOICETYPE,
        ADDBILLINGINFO_BILLINGPREPAIDID,
        ADDBILLINGINFO_BILLINGDEPOSITID
    } choiceId;
    union AddBillingInfoChoiceUnion
    {
    struct BillingBankInfo* billingBankInfo; /* [1] IMPLICIT BillingBankInfo */
    struct BillingCreditCardInfo* billingCreditCardInfo; /* [2] IMPLICIT BillingCreditCardInfo */
    AddBillingInfoEnum billingInvoiceType; /* [3] IMPLICIT AddBillingInfoEnum */
    VisibleString* billingPrepaidId; /* [4] IMPLICIT VisibleString */
    VisibleString* billingDepositId; /* [5] IMPLICIT VisibleString */
    } a;
} AddBillingInfo;

AsnLen BEncAddBillingInfoContent PROTO((BUF_TYPE b, AddBillingInfo* v));

void BDecAddBillingInfoContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, AddBillingInfo* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintAddBillingInfo PROTO((FILE* f, AddBillingInfo* v, unsigned short int indent));
void FreeAddBillingInfo PROTO((AddBillingInfo* v));





typedef struct OrigSubitoAdditionalInfo /* [PRIVATE 1] IMPLICIT SEQUENCE */
{
    AsnBool* customerInfoToKeep; /* [1] IMPLICIT BOOLEAN DEFAULT FALSE */
    struct AddRequesterInfo* addRequesterInfo; /* [2] IMPLICIT AddRequesterInfo OPTIONAL */
    struct AddDeliveryInfo* addDeliveryInfo; /* [3] IMPLICIT AddDeliveryInfo OPTIONAL */
    struct AddBillingInfo* addBillingInfo; /* [4] AddBillingInfo OPTIONAL */
} OrigSubitoAdditionalInfo;

AsnLen BEncOrigSubitoAdditionalInfoContent PROTO((BUF_TYPE b, OrigSubitoAdditionalInfo* v));

void BDecOrigSubitoAdditionalInfoContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, OrigSubitoAdditionalInfo* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintOrigSubitoAdditionalInfo PROTO((FILE* f, OrigSubitoAdditionalInfo* v, unsigned short int indent));
void FreeOrigSubitoAdditionalInfo PROTO((OrigSubitoAdditionalInfo* v));





typedef struct SubitoAdditionalInfo /* CHOICE */
{
    enum SubitoAdditionalInfoChoiceId
    {
        SUBITOADDITIONALINFO_JOHNFIX
    } choiceId;
    union SubitoAdditionalInfoChoiceUnion
    {
    struct OrigSubitoAdditionalInfo* johnfix; /* OrigSubitoAdditionalInfo */
    } a;
} SubitoAdditionalInfo;

AsnLen BEncSubitoAdditionalInfo PROTO((BUF_TYPE b, SubitoAdditionalInfo* v));

void BDecSubitoAdditionalInfo PROTO(( BUF_TYPE b, SubitoAdditionalInfo* result, AsnLen* bytesDecoded, ENV_TYPE env));
AsnLen BEncSubitoAdditionalInfoContent PROTO((BUF_TYPE b, SubitoAdditionalInfo* v));

void BDecSubitoAdditionalInfoContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, SubitoAdditionalInfo* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintSubitoAdditionalInfo PROTO((FILE* f, SubitoAdditionalInfo* v, unsigned short int indent));
void FreeSubitoAdditionalInfo PROTO((SubitoAdditionalInfo* v));





extern AsnInt subitoOid;

#endif /* conditional include of iordext.h */
