/*  Module Name: @(#)logfiles.h	7.1
    Version: 11/15/96
    Author: Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description: DBV-OSI II API code to write information to the API system
        log files. This is necessary when there is either no existing
        association, or it has not been initialised yet
        (ReceiveAssociateRequest() for instance).
 
*/
 
#ifndef LOGFILES_H
#define LOGFILES_H

#include "z3950_includes.h"
#include <fcntl.h>
#include <unistd.h>

void DBVWriteOriginLog(char *pcLogData);
void DBVWriteTargetLog(char *pcLogData);
void DBVWriteLog(char *pcLogData);
void DBVWriteErrorToLog(DbvError **ppsError, char *pcDiagnostic);

void DBVWriteLogdata(char *pcLogData);
#ifndef NO_OSI
void DBVLogISODEACSEError(char *pcFunction, struct AcSAPabort
        *psAssocControlAbort);
void DBVLogISODEPError(char *pcFunction, struct PSAPabort
        *psPresentationAbort);
#endif /* NO_OSI */

int DBVOpenLogFile(void);
void DBVCloseLogFile(void);

#endif
