/*  Module Name: @(#)memcheck.c	1.2
    Version: 9/19/96
    Author:  M. Bush
    
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ

    Date of Issue: 

    QA Acceptance: 
    Date of Acceptance: 

    Description:  
		  Header file for memory management routines.
*/

/* memcheck contains a set of routines used to
allocate and free memory. */

#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "memcheck.h"


static unsigned long	Total = 0 ;

void SError_( enum ErrorLevel_ Error, char*ErrorString, char*ModuleName )
{
	char	Reply;
	char	Message[200];

	switch (Error) {
	case Warning_ :
		printf("%c%s:%s\n", 7, ModuleName, ErrorString);
		break;
	case Error_ :
		printf("%c%s:%s\n", 7, ModuleName, ErrorString);
		printf("Do you wish to continue? [Y or N]");
		scanf("%c", &Reply);
		Reply = toupper(Reply);
		if (Reply == 'N') {
			exit(-1);
		}
		while (getchar() != '\n')
			;
		break;
	case Fatal_ :
		sprintf(Message, "%c%s:%s", 7, ModuleName, ErrorString);
		printf( Message );
		exit(-1);
		break;
	}
}

void	*mc_SMalloc(size_t Size, char*ModName)
{
	void *   Space = calloc(Size, 1);

	if (Space == NULL) {
		SError_(Fatal_, "Out of memory", ModName);
		return NULL;
	} else {
		Total = Total + Size;
		return(Space);
	}
}


void*	SBYTES_(size_t NumBytes, char *ModName)
{
	void *   Space = calloc(NumBytes, 1);

	if (Space == NULL) {
		SError_(Fatal_, "Out of memory", ModName);
		return NULL;
	} else {
		Total = Total + NumBytes;
		return(Space);
	}
}


void FREE_ ( void*Item )
{
	 free( (char * ) Item );
}


void    Memused()
{
	printf("Memory used %ld \n", Total);
}

