/*  Module Name: @(#)oid_overwrites_d.c	7.1
    Version: 11/15/96
    Author: John Hough
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description: snacc oid overwrite
 
*/


#include "sidefs.h"
#include "sitypes.h"
#include "sitypes2.h"
#include "dbvproto.h"
#include "iord_ext.h"
#include "itemordr.h"


int val;
jmp_buf env;

if ((val = setjmp(env)) == 0) {

AsnOid temp;

/* in z3950_globals.c */
extern char sutrsOid_static[],
	opacOid_static[],
	summaryOid_static[],
	genericOid_static[], 
	estaskOid_static[];


/*  ANSI_UNSTRUCTURED_TEXT_RECORD - 1.2.840.10003.5.101 */
ASN_MakeOid(ANSI_UNSTRUCTURED_TEXT_RECORD, &temp, env);
memcpy(sutrsOid_static, temp.octs, temp.octetLen);
Asn1Free(temp.octs);
sutrsOid.octs = sutrsOid_static;
sutrsOid.octetLen = temp.octetLen;
oid0.octs = sutrsOid_static;
oid0.octetLen = temp.octetLen;


/*  ANSI_OPAC_RECORD - 1.2.840.10003.5.102 */
ASN_MakeOid(ANSI_OPAC_RECORD, &temp, env);
memcpy(opacOid_static, temp.octs, temp.octetLen);
Asn1Free(temp.octs);
opacOid.octs = opacOid_static;
opacOid.octetLen = temp.octetLen;
oid3.octs = opacOid_static;
oid3.octetLen = temp.octetLen;


/*  ANSI_SUMMARY_RECORD - 1.2.840.10003.5.103 */
ASN_MakeOid(ANSI_SUMMARY_RECORD, &temp, env);
memcpy(summaryOid_static, temp.octs, temp.octetLen);
Asn1Free(temp.octs);
summaryOid.octs = summaryOid_static;
summaryOid.octetLen = temp.octetLen;
oid1.octs = summaryOid_static;
oid1.octetLen = temp.octetLen;


/*  ANSI_GENERIC_RECORD - 1.2.840.10003.5.105 */
ASN_MakeOid(ANSI_GENERIC_RECORD, &temp, env);
memcpy(genericOid_static, temp.octs, temp.octetLen);
Asn1Free(temp.octs);
genericOid.octs = genericOid_static;
genericOid.octetLen = temp.octetLen;
oid4.octs = genericOid_static;
oid4.octetLen = temp.octetLen;


/*  ANSI_ES_TASK_PACKAGE_RECORD (Extended Service Task Package) - 1.2.840.10003.5.106 */
ASN_MakeOid(ANSI_ES_TASK_PACKAGE_RECORD, &temp, env);
memcpy(estaskOid_static, temp.octs, temp.octetLen);
Asn1Free(temp.octs);
estaskOid.octs = estaskOid_static;
estaskOid.octetLen = temp.octetLen;
oid2.octs = estaskOid_static;
oid2.octetLen = temp.octetLen;


} else {
	fprintf(stderr, "Fatal event: ASN_MakeOid failed for oid_overwrites_d.c\n");
}

