/*  Module Name: @(#)origin-sm.h	7.1
    Version: 11/15/96
    Author: Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description: Origin state machine code for DBV-OSI II project.
        
*/

#ifndef ORIGIN_SM_H
#define ORIGIN_SM_H

#include "z3950_includes.h"


#define DBV_O_STATES 21
#define DBV_O_EVENTS 36
#define DBV_O_EVENTS_ARRAY (DBV_O_EVENTS+1) 



/* Origin States - See document D-022 for full details */

#define DBV_OS_CLOSED                   1
#define DBV_OS_ASSOCREQ_INPROGRESS      2
#define DBV_OS_ASSOCIATION              3
#define DBV_OS_INITSENT                 4
#define DBV_OS_OPEN                     5
#define DBV_OS_SEARCH_SENT              6
#define DBV_OS_PRESENT_SENT             7
#define DBV_OS_DELETE_SENT              8
#define DBV_OS_SCAN_SENT                9
#define DBV_OS_RESOURCE_REPORT_SENT     10
#define DBV_OS_SORT_REQUEST_SENT        11
#define DBV_OS_EXTENDED_SERVICE_SENT    12
#define DBV_OS_RELEASEREQ_SENT          13
#define DBV_OS_CLOSE_SENT               14
#define DBV_OS_CLOSE_RCVD               15
#define DBV_OS_ERROR                    16
#define DBV_OS_DEAD                     17
 
#define DBV_OS_ACCCNT_RCVD              18
#define DBV_OS_RESCNT_RCVD              19
#define DBV_OS_TRIGRESCNT_SENT          20


 
/* Incoming Origin Events - See document D-022 for full details */
 
/* Event (pdu forming) by local user, pdu arriving from target */
 
#define DBV_OE_IASSOCREQ                1
#define DBV_OE_AASSOCIATERESP_IND_TRUE  2
#define DBV_OE_AASSOCIATERESP_IND_FALSE 3
#define DBV_OE_INITREQ                  4
#define DBV_OE_INITRESP_PDU_TRUE        5
#define DBV_OE_INITRESP_PDU_FALSE       6
#define DBV_OE_SEARCHREQ                7
#define DBV_OE_SEARCHRESP_PDU           8
#define DBV_OE_PRESENTREQ               9
#define DBV_OE_PRESENTRESP_PDU          10
#define DBV_OE_DELETEREQ                11
#define DBV_OE_DELETERESP_PDU           12
#define DBV_OE_SCANREQ                  13
#define DBV_OE_SCANRESP_PDU             14
#define DBV_OE_RESOURCEREQ              15
#define DBV_OE_RESOURCERESP_PDU         16
#define DBV_OE_SORTREQ                  17
#define DBV_OE_SORTRESP_PDU             18
#define DBV_OE_SEGMENTREQ_PDU           19
#define DBV_OE_EXTENDEDREQ              20
#define DBV_OE_EXTENDEDRESP_PDU         21
#define DBV_OE_IRELREQ                  22
#define DBV_OE_ARELREQ_IND              23
#define DBV_OE_ARELRESP_IND             24
#define DBV_OE_AABORT_IND               25
#define DBV_OE_IABORTREQ                26
#define DBV_OE_CLOSEREQ_PDU             27
#define DBV_OE_CLOSEREQ                 28
#define DBV_OE_CLOSERESP                29
#define DBV_OE_DECODE_FAILED            30
 
#define DBV_OE_ACCCNTREQ_PDU            31
#define DBV_OE_ACCCNTRSP                32
#define DBV_OE_RESCNTREQ_PDU            33
#define DBV_OE_RESCNTRSP                34
#define DBV_OE_TRIGRESCNTREQ            35




#endif
