/*  Module Name: @(#)origin_z3950_close.c	7.1
    Version: 11/15/96
    Author: John Hough
    
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ

    Date of Issue:  

    QA Acceptance:  
    Date of Acceptance:  

    Description: Origin end routines to process a received Close PDU sent by 
		 a target 
		 (Note that there is only one Close PDU in z39.50, there
		 is not a CloseRequest, CloseResponse` pair).

*/

#include "origin_z3950_close.h"

/*****************************************************************
******************************************************************
******************************************************************
PROCESS Close PDU RECEIVED FROM TARGET 
*/

int DBVset_dbv_originfields_closereq(DbvOriginData *psOriginData, PDU *PDU_ptr, DbvOriginEvent eOriginEvent, jmp_buf env)
{
	/* Ind if close request */
	/* Conf if close response */

	/* If a previous closeRequest PDU has just been sent,
	   assume the close PDU received is a 'closeResponse */
	if (eOriginEvent == OR_CloseConf) 
		psOriginData->eOriginEvent = OR_CloseConf;
	else
		psOriginData->eOriginEvent = OR_CloseInd;


	psOriginData->uOriginData.psCloseReq = (DbvCloseReq *) DbvAlloc (sizeof (DbvCloseReq));
	CheckDbvAlloc(psOriginData->uOriginData.psCloseReq, env);

	DBVset_dbv_closereq_refid(psOriginData->uOriginData.psCloseReq, PDU_ptr, env);
	DBVset_dbv_closereq_closereason(psOriginData->uOriginData.psCloseReq, PDU_ptr, env);
	DBVset_dbv_closereq_diaginfo(psOriginData->uOriginData.psCloseReq, PDU_ptr, env);
	DBVset_dbv_closereq_resrepform(psOriginData->uOriginData.psCloseReq, PDU_ptr, env);
	DBVset_dbv_closereq_resreport(psOriginData->uOriginData.psCloseReq, PDU_ptr, env);
	DBVset_dbv_closereq_otherinfo(psOriginData->uOriginData.psCloseReq, PDU_ptr, env);

	/* Following frees elements in PDU_ptr, not PDU_ptr itself */
	FreePDU(PDU_ptr);

}



