/*  Module Name: @(#)origin_z3950_init.h	7.1
    Version: 11/15/96
    Author: John Hough
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description: Origin association handling functions Using TCP/OSI Services
*/

#ifndef origin_z3950_init_h
#define origin_z3950_init_h

#include "z3950_includes.h"


int DbvInitializeRequest(DbvAssocId lAssocId, DbvInitializeReq *psInitializeReq, DbvError **ppsSIError);
int DBVCheckDbvInitReqFields(DbvAssocId lAssocId, DbvInitializeReq *psInitializeReq, DbvError **ppsSIError);
int DBVcheck_dbv_initreq_prover(DbvAssocId lAssocId, DbvInitializeReq *psInitializeReq, DbvError **ppsSIError);
int DBVcheck_dbv_initreq_options(DbvAssocId lAssocId, DbvInitializeReq *psInitializeReq, DbvError **ppsSIError);
int DBVcheck_dbv_initreq_auth(DbvAssocId lAssocId, DbvInitializeReq *psInitializeReq, DbvError **ppsSIError);
int DBVcheck_idauth_struct(DbvAssocId lAssocId, DbvAuthentication *psAuthentication, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_initreq_userinf(DbvAssocId lAssocId, DbvInitializeReq *psInitializeReq, DbvError **ppsSIError);
int DBVcheck_dbv_initreq_otherinfo(DbvAssocId lAssocId, DbvInitializeReq *psInitializeReq, DbvError **ppsSIError);
int DBVsetup_snacc_initrequest(PDU *PDU_ptr, DbvInitializeReq *psInitializeReq, jmp_buf env);
int DBVset_snacc_initreq_refid(PDU *PDU_ptr, DbvOctetString *psReferenceId, jmp_buf env);
int DBVset_snacc_initreq_protocolversion(PDU *PDU_ptr, DbvProtocolVersion pcProtocolVersion, jmp_buf env);
int DBVset_snacc_initreq_options(PDU *PDU_ptr, DbvOptions pcOptions, jmp_buf env);
int DBVset_snacc_initreq_prefmessize(PDU *PDU_ptr, Ulong ulPreferredMessageSize, jmp_buf env);
int DBVset_snacc_initreq_maxmessize(PDU *PDU_ptr, Ulong ulMaximumMessageSize, jmp_buf env);
int DBVset_snacc_initreq_authentication(PDU *PDU_ptr, DbvAuthentication *psAuthentication, jmp_buf env);
int DBVset_snacc_initreq_authentication_open(PDU *PDU_ptr, DbvAuthentication *psAuthentication, jmp_buf env);
int DBVset_snacc_initreq_authentication_idpass(PDU *PDU_ptr, DbvAuthentication *psAuthentication, jmp_buf env);
int DBVset_snacc_initreq_authentication_other(PDU *PDU_ptr, DbvAuthentication *psAuthentication, jmp_buf env);
int DBVset_snacc_initreq_impid(PDU *PDU_ptr, DbvInternationalString *psImplementationId, jmp_buf env);
int DBVset_snacc_initreq_impname(PDU *PDU_ptr, DbvInternationalString *psImplementationName, jmp_buf env);
int DBVset_snacc_initreq_impver(PDU *PDU_ptr, DbvInternationalString *psImplementationVersion, jmp_buf env);
int DBVset_snacc_initreq_userinfo(PDU *PDU_ptr, DbvASN1External *psUserInformationField, jmp_buf env);
int DBVset_snacc_initreq_otherinfo(PDU *PDU_ptr, DbvOtherInformation **ppsOtherInformation, jmp_buf env);
int DBVset_dbv_fields_initresp(DbvOriginData *psOriginData, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_initresp_refid(DbvInitializeRsp *initresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_initresp_prover(DbvInitializeRsp *initresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_initresp_options(DbvInitializeRsp *initresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_initresp_prefmes(DbvInitializeRsp *initresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_initresp_maxmes(DbvInitializeRsp *initresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_initresp_result(DbvInitializeRsp *initresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_initresp_impid(DbvInitializeRsp *initresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_initresp_impname(DbvInitializeRsp *initresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_initresp_impver(DbvInitializeRsp *initresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_initresp_userinfo(DbvInitializeRsp *initresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_initresp_otherinfo(DbvInitializeRsp *initresp, PDU *PDU_ptr, jmp_buf env);

#endif
