/*  Module Name: @(#)origin_z3950_main.h	7.1
    Version: 11/15/96
    Author: John Hough, Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description: DBV-OSI II client main routines
                 (common for all client functions)
*/

#ifndef z3950_client_main_h
#define z3950_client_main_h

#include "z3950_includes.h"


int DbvReceiveDataOrigin( DbvAssocId lAssocId, DbvSecs lSeconds, 
			  DbvOriginData **ppsOriginData, DbvError **ppsError);
int DBVconvert_pdu_to_origin_data(DbvAssocId lAssocId, DbvOriginData *psOriginData, PDU *PDU_ptr, char **ber_data, unsigned long ber_data_length, DbvError **ppsError, jmp_buf env); 
int DBVsnacc_to_dbv_initrsp(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvOriginData *psOriginData, jmp_buf env);
int DBVget_snacc_initrsp_state(PDU *PDU_ptr);
int DBVsnacc_to_dbv_srchrsp(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvOriginData *psOriginData, jmp_buf env);
int DBVsnacc_to_dbv_presrsp(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvOriginData *psOriginData, jmp_buf env);
int DBVsnacc_to_dbv_delrsp(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvOriginData *psOriginData, jmp_buf env);
int DBVsnacc_to_dbv_resreprsp(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvOriginData *psOriginData, jmp_buf env);
int DBVsnacc_to_dbv_scanrsp(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvOriginData *psOriginData, jmp_buf env);
int DBVsnacc_to_dbv_sortrsp(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvOriginData *psOriginData, jmp_buf env);
int DBVsnacc_to_dbv_segreq(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvOriginData *psOriginData, jmp_buf env);
int DBVsnacc_to_dbv_extendrsp(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvOriginData *psOriginData, jmp_buf env);
int DBVsnacc_to_dbv_orclose(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvOriginData *psOriginData, jmp_buf env);
int DBVCloseTraceOrigin(DbvAssocId lAssocId, DbvCloseReq *psCloseReq, DbvOriginEvent eOriginEvent);
int DBVsnacc_to_dbv_orunknown(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvOriginData *psOriginData, char **ber_data, unsigned long ber_data_length, jmp_buf env);

int DBVsnacc_to_dbv_accessreq(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvOriginData *psOriginData, jmp_buf env);
int DBVsnacc_to_dbv_rescntrlreq(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvOriginData *psOriginData, jmp_buf env);



#endif

