/*  Module Name: @(#)origin_z3950_scan.h	7.1
    Version: 11/15/96
    Author: John Hough
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description: 
*/

#ifndef origin_z3950_scan_h
#define origin_z3950_scan_h

#include "z3950_includes.h"

int DbvScanRequest(DbvAssocId lAssocId, DbvScanReq *psScanReq, DbvError **ppsSIError);
int DBVCheckDbvScanReqFields(DbvAssocId lAssocId, DbvScanReq *psScanReq, DbvError **ppsSIError);
int DBVcheck_dbv_scanreq_dbnames(DbvAssocId lAssocId, DbvScanReq *psScanReq, DbvError **ppsSIError);
int DBVcheck_dbv_scanreq_attset(DbvAssocId lAssocId, DbvScanReq *psScanReq, DbvError **ppsSIError);
int DBVcheck_dbv_scanreq_atttrm(DbvAssocId lAssocId, DbvScanReq *psScanReq, DbvError **ppsSIError);
int DBVcheck_dbv_scanreq_otherinfo(DbvAssocId lAssocId, DbvScanReq *psScanReq, DbvError **ppsSIError);
int DBVsetup_snacc_scanrequest(PDU *PDU_ptr, DbvScanReq *psScanReq, jmp_buf env);
int DBVset_snacc_scanreq_refid(PDU *PDU_ptr, DbvOctetString *psReferenceId, jmp_buf env);
int DBVset_snacc_scanreq_dbnames(PDU *PDU_ptr, DbvInternationalString **ppsDatabaseNames, jmp_buf env);
int DBVset_snacc_scanreq_attsetid(PDU *PDU_ptr, DbvObjectIdentifier pcAttributeSetId, jmp_buf env);
int DBVset_snacc_scanreq_attplusterm(PDU *PDU_ptr, DbvAttributesPlusTerm sAttributesPlusTerm, jmp_buf env);
int DBVset_snacc_scanreq_stepsize(PDU *PDU_ptr, Ulong *pulStepSize, jmp_buf env);
int DBVset_snacc_scanreq_numterms(PDU *PDU_ptr, Ulong ulNumberOfTermsRequested, jmp_buf env);
int DBVset_snacc_scanreq_prefpos(PDU *PDU_ptr, Ulong *pulPreferredPositionInResponse, jmp_buf env);
int DBVset_snacc_scanreq_otherinfo(PDU *PDU_ptr, DbvOtherInformation **ppsOtherInformation, jmp_buf env);
int DBVset_dbv_fields_scanresp(DbvOriginData *psOriginData, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_scanresp_refid(DbvScanRsp *scanresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_scanresp_stepsize(DbvScanRsp *scanresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_scanresp_scanstat(DbvScanRsp *scanresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_scanresp_numentries(DbvScanRsp *scanresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_scanresp_posterm(DbvScanRsp *scanresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_scanresp_entries(DbvScanRsp *scanresp, PDU *PDU_ptr, jmp_buf env);
int DBVsnacc_to_dbv_entries(DbvEntry **ppsEntry, ListEntriesSeqOf *entries, jmp_buf env);
int DBVsnacc_to_dbv_entry(DbvEntry *psEntry, Entry *data_ptr, jmp_buf env);
int DBVsnacc_to_dbv_terminfo(DbvTermInfo *psTermInfo, struct TermInfo* termInfo, jmp_buf env);
int DBVsnacc_to_dbv_attrtermlist(DbvAttributesPlusTerm **ppsAlternativeTerm, TermInfoSeqOf *alternativeTerm, jmp_buf env);
int DBVsnacc_to_dbv_occurbyatt_list(DbvOccurrenceByAttributes **ppsByAttributes, OccurrenceByAttributes *byAttributes, jmp_buf env);
int DBVsnacc_to_dbv_occurbyattseq(DbvOccurrenceByAttributes *psByAttributes, OccurrenceByAttributesSeq *data_ptr, jmp_buf env);
int DBVsnacc_to_dbv_occurrence(DbvOccurrence *psOccurrence, struct OccurrenceByAttributesSeqChoice* occurrences, jmp_buf env);
int DBVsnacc_to_dbv_bydatabase(DbvOccurrenceByDb **ppsOccurrenceByDb, OccurrenceByAttributesSeqChoiceSeqOf *byDatabase, jmp_buf env);
int DBVsnacc_to_dbv_bigoccurrthing(DbvOccurrenceByDb *psOccurrenceByDb, OccurrenceByAttributesSeqChoiceSeqOfSeq *data_ptr, jmp_buf env);
int DBVset_dbv_scanresp_attsetid(DbvScanRsp *scanresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_scanresp_otherinfo(DbvScanRsp *scanresp, PDU *PDU_ptr, jmp_buf env);

#endif
