/*  Module Name: @(#)origin_z3950_search.h	7.1
    Version: 11/15/96
    Author: John Hough
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description: 
*/

#ifndef origin_z3950_search_h
#define origin_z3950_search_h

#include "z3950_includes.h"

int DbvSearchRequest(DbvAssocId lAssocId, DbvSearchReq *psSearchReq, DbvError **ppsSIError);
int DBVCheckDbvSearchReqFields(DbvAssocId lAssocId, DbvSearchReq *psSearchReq, DbvError **ppsSIError);
int DBVcheck_dbv_srchreq_replace(DbvAssocId lAssocId, DbvSearchReq *psSearchReq, DbvError **ppsSIError);
int DBVcheck_dbv_srchreq_dbnames(DbvAssocId lAssocId, DbvSearchReq *psSearchReq, DbvError **ppsSIError);
int DBVcheck_dbv_srchreq_sselnam(DbvAssocId lAssocId, DbvSearchReq *psSearchReq, DbvError **ppsSIError);
int DBVcheck_dbv_srchreq_mselnam(DbvAssocId lAssocId, DbvSearchReq *psSearchReq, DbvError **ppsSIError);
int DBVcheck_dbv_srchreq_prefsyn(DbvAssocId lAssocId, DbvSearchReq *psSearchReq, DbvError **ppsSIError);
int DBVcheck_dbv_srchreq_query(DbvAssocId lAssocId, DbvSearchReq *psSearchReq, DbvError **ppsSIError);
int DBVcheck_dbv_rpn(DbvAssocId lAssocId, DbvRPNQuery *psRpnQuery, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_rpnstruct(DbvAssocId lAssocId, DbvRPNStructure *psRpnStructure, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_operator(DbvAssocId lAssocId, DbvOperator *psOperator, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_prox(DbvAssocId lAssocId, DbvProximityOperator *psProximityOperator, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_operand(DbvAssocId lAssocId, DbvOperand *psRpnOperand, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_resplusatts(DbvAssocId lAssocId, DbvResultSetPlusAttributes *psResultSetPlusAttributes, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_srchreq_addinf(DbvAssocId lAssocId, DbvSearchReq *psSearchReq, DbvError **ppsSIError);
int DBVcheck_dbv_srchreq_othinfo(DbvAssocId lAssocId, DbvSearchReq *psSearchReq, DbvError **ppsSIError);
int DBVsetup_snacc_srchrequest(PDU *PDU_ptr, DbvSearchReq *psSearchReq, jmp_buf env);
int DBVset_snacc_searchreq_refid(PDU *PDU_ptr, DbvOctetString *psReferenceId, jmp_buf env);
int DBVset_snacc_searchreq_ssetupper(PDU *PDU_ptr,  Ulong ulSmallSetUpperBound, jmp_buf env);
int DBVset_snacc_searchreq_lsetlower(PDU *PDU_ptr, Ulong ulLargeSetLowerBound, jmp_buf env);
int DBVset_snacc_searchreq_msetpres(PDU *PDU_ptr, Ulong ulMediumSetPresentNumber, jmp_buf env);
int DBVset_snacc_searchreq_replace(PDU *PDU_ptr, DbvBool fReplaceIndicator, jmp_buf env);
int DBVset_snacc_searchreq_resultset(PDU *PDU_ptr, DbvInternationalString sResultSetName, jmp_buf env);
int DBVset_snacc_searchreq_dbnames(PDU *PDU_ptr, DbvInternationalString **ppsDatabaseNames, jmp_buf env);
int DBVset_snacc_searchreq_ssetelname(PDU *PDU_ptr, DbvElementSetNames *psSmallSetElementNames, jmp_buf env);
int DBVset_snacc_searchreq_msetelname(PDU *PDU_ptr, DbvElementSetNames *psMediumSetElementNames, jmp_buf env);
int DBVset_snacc_searchreq_prefrecsyn(PDU *PDU_ptr, DbvObjectIdentifier pcPreferredRecordSyntax, jmp_buf env);
int DBVset_snacc_searchreq_query(PDU *PDU_ptr, DbvQuery *psQuery, jmp_buf env);
int DBVdbv_to_snacc_rpnquery(struct RPNQuery* type_1, DbvRPNQuery *psRpnQuery, jmp_buf env);
int DBVdbv_to_snacc_rpnstruct(struct RPNStructure* rpn, DbvRPNStructure *psRpnStructure, jmp_buf env);
int DBVdbv_to_snacc_rpnrpnop(struct RPNStructureSeq* rpnRpnOp, DbvRPNLopRopOperator *psRpnLopRopOperator, jmp_buf env);
int DBVdbv_to_snacc_operator(struct Operator* op, DbvOperator sOperator, jmp_buf env);
int DBVdbv_to_snacc_prox(struct ProximityOperator* prox, DbvProximityOperator *psProximityOperator, jmp_buf env);
int DBVdbv_to_snacc_proxunitcode(struct ProximityOperatorChoice* proximityUnitCode, DbvProximityUnitCode sProximityUnitCode, jmp_buf env);
int DBVdbv_to_snacc_operand(struct Operand* op, DbvOperand* psRpnOperand, jmp_buf env);
int DBVdbv_to_snacc_resulattr(struct ResultSetPlusAttributes* resultAttr, DbvResultSetPlusAttributes *psResultSetPlusAttributes, jmp_buf env);
int DBVset_snacc_searchreq_addinfo(PDU *PDU_ptr, DbvOtherInformation **ppsAdditionalSearchInfo, jmp_buf env);
int DBVset_snacc_searchreq_otherinfo(PDU *PDU_ptr, DbvOtherInformation **ppsOtherInformation, jmp_buf env);
int DBVset_dbv_fields_searchresp(DbvOriginData *psOriginData, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchresp_refid(DbvSearchRsp *searchresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchresp_rescount(DbvSearchRsp *searchresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchresp_numrecs(DbvSearchRsp *searchresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchresp_nextres(DbvSearchRsp *searchresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchresp_srchstat(DbvSearchRsp *searchresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchresp_resstat(DbvSearchRsp *searchresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchresp_presstat(DbvSearchRsp *searchresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchresp_records(DbvSearchRsp *searchresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchresp_addinfo(DbvSearchRsp *searchresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchresp_otherinfo(DbvSearchRsp *searchresp, PDU *PDU_ptr, jmp_buf env);


#endif
