/*  Module Name: @(#)origin_z3950_sort.h	7.1
    Version: 11/15/96
    Author: John Hough
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description: 
*/

#ifndef origin_z3950_sort_h
#define origin_z3950_sort_h

#include "z3950_includes.h"


int DbvSortRequest(DbvAssocId lAssocId, DbvSortReq *psSortReq, DbvError **ppsSIError);
int DBVCheckDbvSortReqFields(DbvAssocId lAssocId, DbvSortReq *psSortReq, DbvError **ppsSIError);
int DBVcheck_dbv_sortreq_inresname(DbvAssocId lAssocId, DbvSortReq *psSortReq, DbvError **ppsSIError);
int DBVcheck_dbv_sortreq_sequence(DbvAssocId lAssocId, DbvSortReq *psSortReq, DbvError **ppsSIError);
int DBVcheck_sortkeyspec(DbvAssocId lAssocId, DbvSortKeySpec *psSortSequence, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_sortelmnt(DbvAssocId lAssocId, DbvSortElement *psSortElement, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_sortkey(DbvAssocId lAssocId, DbvSortKey *psGeneric, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_sortatts(DbvAssocId lAssocId, DbvSortAttributes *psSortAttributes, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_sortattsetid(DbvAssocId lAssocId, DbvObjectIdentifier pcAttributeSetId, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_sortattelmnt(DbvAssocId lAssocId, DbvAttributeElement **ppsAttributeElement, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbspecsortkey(DbvAssocId lAssocId, DbvDbSpecificSortKey **ppsDatabaseSpecific, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_specsortkey(DbvAssocId lAssocId, DbvDbSpecificSortKey *psDatabaseSpecific, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_sortmvaction(DbvAssocId lAssocId, DbvSortMVAction *psMVActionType, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_sortreq_otherinfo(DbvAssocId lAssocId, DbvSortReq *psSortReq, DbvError **ppsSIError);
int DBVsetup_snacc_sortrequest(PDU *PDU_ptr, DbvSortReq *psSortReq, jmp_buf env);
int DBVset_snacc_sortreq_refid(PDU *PDU_ptr, DbvOctetString *psReferenceId, jmp_buf env);
int DBVset_snacc_sortreq_inresset(PDU *PDU_ptr, DbvInternationalString **ppsInputResultSetName, jmp_buf env);
int DBVset_snacc_sortreq_sortedres(PDU *PDU_ptr, DbvInternationalString sSortedResultSetName, jmp_buf env);
int DBVset_snacc_sortreq_sortseq(PDU *PDU_ptr, DbvSortKeySpec **ppsSortSequence, jmp_buf env);
int DBVdbv_to_snacc_sortkeyspec(SortKeySpec *data_ptr, DbvSortKeySpec *psSortSequence, jmp_buf env);
int DBVdbv_to_snacc_sortelmnt(struct SortElement* sortElement, DbvSortElement *psSortElement, jmp_buf env);
int DBVdbv_to_snacc_sortkey(struct SortKey* generic, DbvSortKey *psGeneric, jmp_buf env);
int DBVdbv_to_snacc_sortatts(struct SortKeySeq* sortAttributes, DbvSortAttributes *psSortAttributes, jmp_buf env);
int DBVdbv_to_snacc_dbspecific(SortElementSeqOf *datbaseSpecific, DbvDbSpecificSortKey **ppsDatabaseSpecific, jmp_buf env);
int DBVdbv_to_snacc_specsortkey(SortElementSeqOfSeq *data_ptr, DbvDbSpecificSortKey *psDatabaseSpecific, jmp_buf env);
int DBVdbv_to_snacc_sortrel(SortKeySpec *data_ptr, DbvSortKeySpec *psSortSequence, jmp_buf env);
int DBVdbv_to_snacc_sortcase(SortKeySpec *data_ptr, DbvSortKeySpec *psSortSequence, jmp_buf env);
int DBVdbv_to_snacc_sortmv(struct SortKeySpecChoice* missingValueAction, DbvSortMVAction *psMVActionType, jmp_buf env);
int DBVset_snacc_sortreq_otherinfo(PDU *PDU_ptr, DbvOtherInformation **ppsOtherInformation, jmp_buf env);
int DBVset_dbv_fields_sortresp(DbvOriginData *psOriginData, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_sortresp_refid(DbvSortRsp *sortresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_sortresp_sortstat(DbvSortRsp *sortresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_sortresp_resstat(DbvSortRsp *sortresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_sortresp_diag(DbvSortRsp *sortresp, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_sortresp_otherinfo(DbvSortRsp *sortresp, PDU *PDU_ptr, jmp_buf env);
#endif
