/*  Module Name: @(#)shared_z3950_close.h	7.1
    Version: 11/15/96
    Author: John Hough
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description: 
*/

#ifndef shared_z3950_close_h
#define shared_z3950_close_h

#include "z3950_includes.h"


/* Close type - request or response */
typedef enum DBVCloseType {
	CL_Req = 1,
	CL_Rsp = 2
} DBVCloseType;


int DbvCloseRequest(DbvAssocId lAssocId, DbvCloseReq *psCloseReq, DbvError **ppsSIError);
int DbvCloseResponse(DbvAssocId lAssocId, DbvCloseReq *psCloseRsp, DbvError **ppsSIError);
int DBVClose(DbvAssocId lAssocId, DbvCloseReq *psCloseReq, DBVCloseType closetype, DbvError **ppsSIError);
int DBVCheckDbvCloseReqFields(DbvAssocId lAssocId, DbvCloseReq *psCloseReq, DbvError **ppsSIError);
int DBVCheckDbvCloseRspFields(DbvAssocId lAssocId, DbvCloseReq *psCloseRsp, DbvError **ppsSIError);
int DBVCheckDbvCloseFields(DbvAssocId lAssocId, DbvCloseReq *psCloseReq, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_close_reason(DbvAssocId lAssocId, DbvCloseReq *psCloseReq, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_close_resrepfmt(DbvAssocId lAssocId, DbvCloseReq *psCloseReq, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_close_resrep(DbvAssocId lAssocId, DbvCloseReq *psCloseReq, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_close_otherinfo(DbvAssocId lAssocId, DbvCloseReq *psCloseReq, char *error_buffer, DbvError **ppsSIError);
int DBVsetup_snacc_closerequest(PDU *PDU_ptr, DbvCloseReq *psCloseReq, jmp_buf env);
int DBVset_snacc_closereq_refid(PDU *PDU_ptr, DbvOctetString *psReferenceId, jmp_buf env);
int DBVset_snacc_closereq_closereason(PDU *PDU_ptr, DbvCloseReason eCloseReason, jmp_buf env);
int DBVset_snacc_closereq_diaginfo(PDU *PDU_ptr, DbvInternationalString *psDiagnosticInformation, jmp_buf env) ;
int DBVset_snacc_closereq_resrepform(PDU *PDU_ptr, DbvObjectIdentifier  pcResourceReportFormat, jmp_buf env);
int DBVset_snacc_closereq_resreport(PDU *PDU_ptr, DbvASN1External *psResourceReport, jmp_buf env);
int DBVset_snacc_closereq_otherinfo(PDU *PDU_ptr, DbvOtherInformation **ppsOtherInformation, jmp_buf env);
int DBVset_dbv_closereq_refid(DbvCloseReq *closereq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_closereq_closereason(DbvCloseReq *closereq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_closereq_diaginfo(DbvCloseReq *closereq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_closereq_resrepform(DbvCloseReq *closereq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_closereq_resreport(DbvCloseReq *closereq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_closereq_otherinfo(DbvCloseReq *closereq, PDU *PDU_ptr, jmp_buf env);

#endif
