/*  Module Name: @(#)state_machine.h	7.1
    Version: 11/15/96
    Author: Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description: State machine code for DBV-OSI II project.
        Note that this state machine is not a full Z39.50 v3 SM because
        control APDUs are not included.
        This file contains the functions to change the state of the association.
*/


#ifndef STATE_MACHINE_H
#define STATE_MACHINE_H

#include "z3950_includes.h"

int DBVChangeState( DbvAssocId lAssocId, long lEvent, DbvError **ppsError );

void DBVSetState(DbvAssocId lAssocId, long lNewState);

int DBVOriginSMError(DbvAssocId lAssocId, long lEvent, long lNextState,
        DBVAssociateDetails *psAssociateDetails, DbvError **ppsError);

int DBVTargetSMError(DbvAssocId lAssocId, long lEvent, long lNextState,
        DBVAssociateDetails *psAssociateDetails, DbvError **ppsError);

long DBVGetTargetState(DbvAssocId lAssocId);

#endif

