/*  Module Name: @(#)str_hand.h	1.5
    Version: 9/20/96
    Author:  M. Bush
    
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ

    Date of Issue:  

    QA Acceptance:  
    Date of Acceptance: 

    Description:  
		  Header file for string handling functions.
*/

#ifndef STR_Include
#define STR_Include

#define INTSIZE   100
#define LINESIZE  500
#define XLINESIZE 300000

typedef enum str_MarkerType {
		STR_SeqMarker,
		STR_ListMarker,
		STR_InternalMarker,
		STR_EndOfString } STR_MarkerType;

char* STR_Quote( const char *InString , char *Buf , int BufLength );
char* STR_UnQuote( const char *InString , char *Buf , int BufLength );
char* STR_Save(char* X);
void  STR_DeleteReturns( char* Text );
void  STR_FirstToUpper( char* Text );
void  STR_ToLower( char* Text );
void  STR_ToUpper( char* Text );
void  STR_Shuffle( char* String );
void  STR_RemoveEndSpaces( char* String );
void  STR_RemoveEndMaskChars( char* String, char Mask );
void  STR_RemoveEndSpacesAndEOLMs( char* String );
int   STR_CompareBeginning( char* Main, char* Sub );
int	STR_CompareBeginningNoBlank( char* Main, char* Sub );
Bool_	STR_ExtractNumber( char* String, int *Pos, char* Number );
void	STR_InsertNumber( char* String, char* Number );
void	STR_InsertArgument( char* String, char* Argument, char InsertChar );
Bool_	STR_CopyFrom( char* To, char* From, int Pos, int EndPos );
void	STR_CopyToMask( char* String, int Pos, char Mask, char* Buffer );
void	STR_ElimMultiSpaces( char* String );
Bool_	STR_AllSpace( char* String );
Bool_	STR_LegalChars( char* String, char* Illegal );
Bool_	STR_LegalChar( char c );
void	STR_AddSpaces( char* String );
Bool_	STR_GetIntString( char* String, int *Pos, char* Hold );
Bool_	STR_GetTextToMarker( char* String, int *Pos, char* Hold, char* TextMarker );
Bool_	STR_GetTextToMarkerExact( char* String, int *Pos, char* Hold, char* TextMarker );
void	STR_TransformEscSeq( char* String );
Bool_	STR_SpaceTab( char* String );
Bool_	STR_WhiteSpace( char* String );
Bool_	STR_WhiteSpaceFrom( char* String, int Pos );
Bool_	STR_IsStringAlnum( char* String );
Bool_	STR_IsStringAlphaWS( char* String );
Bool_	STR_IsStringAlnumWS( char* String );
Bool_	STR_AnyAlnumInString( char* String );
Bool_	STR_AnyAlphaInString( char* String );
Bool_	STR_AnyNumericInString( char* String );
Bool_	STR_IsStringNumeric( char* String );
Bool_	STR_IsStringNumeric1( char* String );
Bool_	STR_RemoveSubString( char* String1, char* String2, int *Pos );
Bool_	STR_RemoveSubStringFromPos( char* String1, char* String2, int *Pos );
void	STR_InsertString( char* String1, char* String2, int Pos );
void	STR_Replace( char* String, char* Old, char* New );
void	STR_ReplaceJustOnce( char* String, char* Old, char* New );
void	STR_ReplaceJustOnceC( char* String, char* Old, char C );
int	STR_CharToInt( char* String );
void	STR_IntToChar( int i, char* Buffer );
int	STR_Position( char* String1, char* String2 );
int	STR_PositionOfSubStringBasic( char* String1, char* String2 );
Bool_	STR_IsStringPhrase( char* String );
Bool_	STR_WhiteSpacesToEOL( char* String, int Pos );
STR_MarkerType	STR_GetTextToZ3950RPNMarkers( char* String, int *Pos, char* Hold );
char*	STR_NumberStringAddition( char* NoString1, char* NoString2 );
Bool_	STR_Z3950NumberCompare( char* String1, char* String2 );
void	STR_Enclose( char* String, char* Enclose );
void	STR_Double( char* String, char* Double );
void	STR_Blank( char* String, int StartPos, int EndPos, char Mask );
int	STR_FirstNonWS( char* String, int StartPos );
Bool_	STR_GetNextWord( char* String, int *Pos, char* Word, Bool_ *WSPrecede, Bool_ *WSSucceed );
Bool_	STR_GetToEOL( char* String, int *Pos, char* Word, Bool_ *WSPrecede, Bool_ *WSSucceed );
void	STR_StandardizeEOL( char* String );
void	STR_RemoveLocsIncl( char* String, int Start, int End );
void	STR_RemoveMultiples( char* String, char C );
void	STR_RemoveDoubles( char* String, char C );
void	STR_InsertEOLs( char* String, int LineSize, int StartSpaces );
void	STR_InsertInFormatMarkerLeftOverWrite( char* String1, char* String2 );
void	STR_InsertInFormatMarkerRightOverWrite( char* String1, char* String2 );
int	STR_LengthOfLongestStringInArray( int ArrayNo, char *Fields[] );
void	STR_RemoveCharactersAfterLastEOL( char* String );
void	STR_RemovePuncsFromNumbers( char* String );
int	STR_StrcmpWildCard( char* String1, char* String2, char WildCard );
Bool_	STR_IsNumber( char* String );
void	STR_ContentsOfFileToString( char* FileName, char* Buffer );
void	STR_ContentsOfStringToFile( char* FileName, char* Buffer );
void	STR_RemoveLinesBeginningWith( char* String, char* Sequence );
void	STR_OverWriteLocInLine( char* String, char* Over, int Loc );
Bool_	STR_DetectUniqueAlphaString( char* MainString, char* MinorString );
Bool_	STR_IsNextBlankLine( char* String, int Pos );
Bool_	STR_SetCharsInFormat( char* Format );
int	STR_LengthOfOccurrenceOfCharacter( char* String, char C );
Bool_	STR_AllNonePrintChars( char* String );
int	STR_MaxTermLength( char* String );
void	STR_RemoveCharsUpToMarker( char* String, char* Marker );
Bool_	STR_ReturnFirstFormatType( char* String, char* Format );

void	STR_AddCharacterToEnd(char *s, char c);
char	*STR_RemoveLeadingSpaces(char *s);
char 	*STR_CaseChar(char *s, char c);
int	STR_StringNotIn(char *s1, char *s2);
void	STR_ChangeChars( char* String, int NumberOfChanges, Bool_ Backward, char* Encloser, char ToReplace, char ReplaceWith );
void	STR_GetLastNumber( char* String, char* LastNumberC );
void	STR_Reverse( char* String );
int	STR_LocateBlank( char* Command, int Start, char Encloser, int MaxCharsInACommandline );
void	STR_RemoveGivenChar( char* String, char C );
void	STR_RemoveEncloseChars( char* String, char Enclose );
void	STR_RemoveLeadingZeros( char* String );
void	STR_InsertZeros( char* String, int Number );
void	STR_ncpy(char *s1,char *s2,int n);
char	*STR_GetField(char *s, int n);
void	STR_MonthToNumber( char* Month, char* MonthNo );
Bool_	STR_GetNonMask( char* String, char Mask, char* Text );
void	STR_InsertSpacesInLongWords( char* String, int Size );
char*	STR_PointerToFirstNonWhiteSpace( char* String );
Bool_	STR_PromptAtEnd( char* String );
int	STR_PositionOfPointer( char* String1, char* String2 );
void	STR_InsertCAtBeginningOfLine( char* String, int Pos, char C );
void	STR_LineTruncation( char* String, int LineSize );
int	STR_CalculateMaxLength( char* String );
void	STR_RemoveSpacesFollowing1stSpecCharOnEachLine( char* String, char C );
char	STR_LastPrintCharacterInString( char* String );
void	STR_ReplaceLastPrintCharacterInString( char* String, char C );
void	STR_ExchangeChars( char* String, char Old, char New, char Encloser );
void	STR_GetToEndOfLineAndConcatonate( FILE* Stream, char* String );
void	STR_ExchangeStrings( char* String, char* Old, char* New, char Encloser );
char*	STR_strstrCaseInsensitive( char* String1, char* String2 );
int	STR_strcmpCaseInsensitive( char* String1, char* String2 );
char*	STR_FindFileName( char* Path, char* FileName );
Bool_   STR_Correspond( char* String1, char* String2 );
char*	STR_AnyFormatMarkers( char* String );
void	STR_RemoveEmptyFile( char* FileName );
int	STR_MonthDayToDayInYear( char* Month, char* Day, char* Year );
Bool_	STR_GetLineNumber( char* Buffer, int LineNumber, char* LineText );
void	STR_EncloseWord( char* String, char* Word, char* Enclose );
void	STR_RemoveIntegersAtEnd( char* String, char* StringEndIntsRemoved );
int	STR_NumberOfOcurrencesChar( char* String, char C );
void	STR_RemoveSpacesFromEOLs( char* String );

#endif
