/*  Module Name: @(#)target-sm.h	7.1
    Version: 11/15/96
    Author: Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description: Target state machine code for DBV-OSI II project.
        
*/
 
#ifndef TARGET_SM_H
#define TARGET_SM_H

#include "z3950_includes.h"


#define DBV_T_STATES 21
#define DBV_T_EVENTS 35
#define DBV_T_EVENTS_ARRAY (DBV_T_EVENTS+1)


/* Target States - See document D-022 for full details */


#define DBV_TS_CLOSED                   1
#define DBV_TS_ASSOC_INPROGRESS         2
#define DBV_TS_ASSOCIATION              3
#define DBV_TS_INIT_RECVD               4
#define DBV_TS_OPEN                     5
#define DBV_TS_SEARCH_RECVD             6
#define DBV_TS_PRESENT_RECVD            7
#define DBV_TS_DELETE_RECVD             8
#define DBV_TS_SCAN_RECVD               9
#define DBV_TS_RESOURCE_REPORT_RECVD    10
#define DBV_TS_SORT_RECVD               11
#define DBV_TS_EXTENDED_SERVICE_RECVD   12
#define DBV_TS_ARELEASE_REQ_RECVD       13
#define DBV_TS_CLOSE_SENT               14
#define DBV_TS_CLOSE_RECVD              15
#define DBV_TS_ERROR                    16
#define DBV_TS_DEAD                     17
 
#define DBV_TS_ACCCNT_SENT              18
#define DBV_TS_RESCNT_SENT              19
#define DBV_TS_TRIGRESCNT_RECVD         20


 
/* Incoming Target Events - See document D-022 for full details */
 
/* Event (pdu forming) by local user, pdu arriving from origin */
 

#define DBV_TE_AASOCREQ_IND             1
#define DBV_TE_IASSOCRESP_TRUE          2
#define DBV_TE_IASSOCRESP_FALSE         3
#define DBV_TE_INITREQ_PDU              4
#define DBV_TE_INITRESP_TRUE            5
#define DBV_TE_INITRESP_FALSE           6
#define DBV_TE_SEARCHREQ_PDU            7
#define DBV_TE_SEARCHRESP               8
#define DBV_TE_PRESENTREQ_PDU           9
#define DBV_TE_PRESENTRESP              10
#define DBV_TE_DELETEREQ_PDU            11
#define DBV_TE_DELETERESP               12
#define DBV_TE_SCANREQ_PDU              13
#define DBV_TE_SCANRESP                 14
#define DBV_TE_RESOURCEREQ_PDU          15
#define DBV_TE_RESOURCERESP             16
#define DBV_TE_SORTREQ_PDU              17
#define DBV_TE_SORTRESP                 18
#define DBV_TE_SEGMENTREQ               19
#define DBV_TE_EXTENDEDREQ_PDU          20
#define DBV_TE_EXTENDEDRESP             21
#define DBV_TE_AREL_IND                 22
#define DBV_TE_IRELRESP                 23
#define DBV_TE_AABORT_IND               24
#define DBV_TE_IABORTREQ                25
#define DBV_TE_CLOSEREQ_PDU             26
#define DBV_TE_CLOSEREQ                 27
#define DBV_TE_CLOSERESP                28
#define DBV_TE_DECODE_FAILED            29

 
#define DBV_TE_ACCCNTREQ                30
#define DBV_TE_ACCCNTRSP_PDU            31
#define DBV_TE_RESCNTREQ                32
#define DBV_TE_RESCNTRSP_PDU            33
#define DBV_TE_TRIGRESCNTREQ_PDU        34



#endif
