/*  Module Name: @(#)target_z3950_close.c	7.1
    Version: 11/15/96
    Author: John Hough
    
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ

    Date of Issue:  

    QA Acceptance:  
    Date of Acceptance:  

    Description: Target end routines to process a received Close PDU sent by 
		 an origin  
		 (Note that there is only one Close PDU in z39.50, there
		 is not a CloseRequest, CloseResponse` pair).

*/

#include "target_z3950_close.h"

/*****************************************************************
******************************************************************
******************************************************************
PROCESS Close PDU RECEIVED FROM ORIGIN 
*/

int DBVset_dbv_targetfields_closereq(DbvTargetData *psTargetData, PDU *PDU_ptr, DbvTargetEvent eTargetEvent, jmp_buf env)
{
	/* Ind if close request */
	/* Conf if close response */

	/* If a previous closeRequest PDU has just been sent,
           assume the close PDU received is a 'closeResponse */
        if (eTargetEvent == TA_CloseConf) 
                psTargetData->eTargetEvent = TA_CloseConf;
        else 
                psTargetData->eTargetEvent = TA_CloseInd;
	

	psTargetData->uTargetData.psCloseReq = (DbvCloseReq *) DbvAlloc (sizeof (DbvCloseReq));
	CheckDbvAlloc(psTargetData->uTargetData.psCloseReq, env);

	DBVset_dbv_closereq_refid(psTargetData->uTargetData.psCloseReq, PDU_ptr, env);
	DBVset_dbv_closereq_closereason(psTargetData->uTargetData.psCloseReq, PDU_ptr, env);
	DBVset_dbv_closereq_diaginfo(psTargetData->uTargetData.psCloseReq, PDU_ptr, env);
	DBVset_dbv_closereq_resrepform(psTargetData->uTargetData.psCloseReq, PDU_ptr, env);
	DBVset_dbv_closereq_resreport(psTargetData->uTargetData.psCloseReq, PDU_ptr, env);
	DBVset_dbv_closereq_otherinfo(psTargetData->uTargetData.psCloseReq, PDU_ptr, env);

	/* Following frees elements in PDU_ptr, not PDU_ptr itself */
	FreePDU(PDU_ptr);
}



