/*  Module Name: @(#)target_z3950_main.h	7.1
    Version: 11/15/96
    Author: John Hough, Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description: DBV-OSI II target main routines
                 (common for all target functions)
*/

#ifndef z3950_server_main_h
#define z3950_server_main_h

#include "z3950_includes.h"


int DbvReceiveDataTarget( DbvAssocId lAssocId, DbvSecs lSeconds, 
			  DbvTargetData **ppsTargetData, DbvError **ppsError);
int DBVconvert_pdu_to_target_data(DbvAssocId lAssocId, DbvTargetData *psTargetData, PDU *PDU_ptr, char *ber_data, unsigned long ber_data_length, DbvError **ppsError, jmp_buf env);
int DBVsnacc_to_dbv_initreq(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvTargetData *psTargetData, jmp_buf env);
int DBVsnacc_to_dbv_srchreq(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvTargetData *psTargetData, jmp_buf env);
int DBVsnacc_to_dbv_presreq(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvTargetData *psTargetData, jmp_buf env);
int DBVsnacc_to_dbv_delreq(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvTargetData *psTargetData, jmp_buf env);
int DBVsnacc_to_dbv_resrepreq(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvTargetData *psTargetData, jmp_buf env);
int DBVsnacc_to_dbv_scanreq(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvTargetData *psTargetData, jmp_buf env);
int DBVsnacc_to_dbv_sortreq(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvTargetData *psTargetData, jmp_buf env);
int DBVsnacc_to_dbv_extendreq(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvTargetData *psTargetData, jmp_buf env);
int DBVsnacc_to_dbv_taclose(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvTargetData *psTargetData, jmp_buf env);
int DBVCloseTraceTarget(DbvAssocId lAssocId, DbvCloseReq *psCloseReq, DbvTargetEvent eTargetEvent);
int DBVsnacc_to_dbv_taunknown(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvTargetData *psTargetData, char *ber_data, unsigned long ber_data_length, jmp_buf env);
int DBVsnacc_to_dbv_accessrsp(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvTargetData *psTargetData, jmp_buf env);
int DBVsnacc_to_dbv_rescntrlrsp(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvTargetData *psTargetData, jmp_buf env);
int DBVsnacc_to_dbv_trigrescntrlreq(PDU *PDU_ptr, DbvAssocId lAssocId, DbvError **ppsError, DbvTargetData *psTargetData, jmp_buf env);

#endif
