/*  Module Name: @(#)target_z3950_scan.h	7.1
    Version: 11/15/96
    Author: John Hough
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
*/

#ifndef target_z3950_scan_h
#define target_z3950_scan_h

#include "z3950_includes.h"


int DbvScanResponse(DbvAssocId lAssocId, DbvScanRsp *psScanRsp, DbvError **ppsSIError);
int DBVCheckDbvScanRspFields(DbvAssocId lAssocId, DbvScanRsp *psScanRsp, DbvError **ppsSIError);
int DBVcheck_dbv_scanrsp_stat(DbvAssocId lAssocId, DbvScanRsp *psScanRsp, DbvError **ppsSIError);
int DBVcheck_dbv_scanrsp_entries(DbvAssocId lAssocId, DbvScanRsp *psScanRsp, DbvError **ppsSIError);
int DBVcheck_dbv_entries(DbvAssocId lAssocId, DbvListEntries *psEntries, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_entry_list(DbvAssocId lAssocId, DbvEntry **ppsEntry, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_entry(DbvAssocId lAssocId, DbvEntry *psEntry, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_terminfo(DbvAssocId lAssocId, DbvTermInfo *psTermInfo, char* error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_attel_list(DbvAssocId lAssocId, DbvAttributeElement **ppsAttributeElement, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_attsplusterm_list(DbvAssocId lAssocId, DbvAttributesPlusTerm **ppsAlternativeTerm, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_occurbyatt_list(DbvAssocId lAssocId, DbvOccurrenceByAttributes **ppsByAttributes, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_byattributes(DbvAssocId lAssocId, DbvOccurrenceByAttributes *psByAttributes, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_attel_list_comp(DbvAssocId lAssocId, DbvAttributeElement **ppsAttributeElement, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_occurrence(DbvAssocId lAssocId, DbvOccurrence *psOccurrence, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_occurbydb_list(DbvAssocId lAssocId, DbvOccurrenceByDb **ppsOccurrenceByDb, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_occurbydb(DbvAssocId lAssocId, DbvOccurrenceByDb *psOccurrenceByDb, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_scanrsp_attset(DbvAssocId lAssocId, DbvScanRsp *psScanRsp, DbvError **ppsSIError);
int DBVcheck_dbv_scanrsp_otherinfo(DbvAssocId lAssocId, DbvScanRsp *psScanRsp, DbvError **ppsSIError);
int DBVsetup_snacc_scanresponse(PDU *PDU_ptr, DbvScanRsp *psScanRsp, jmp_buf env);
int DBVset_snacc_scanresp_refid(PDU *PDU_ptr, DbvOctetString *psReferenceId, jmp_buf env);
int DBVset_snacc_scanresp_stepsize(PDU *PDU_ptr, Ulong *pulStepSize, jmp_buf env);
int DBVset_snacc_scanresp_scanstat(PDU *PDU_ptr, DbvScanStatus eScanStatus, jmp_buf env);
int DBVset_snacc_scanresp_numentries(PDU *PDU_ptr,Ulong ulNumberOfEntriesReturned, jmp_buf env);
int DBVset_snacc_scanresp_posterm(PDU *PDU_ptr, Ulong *pulPositionOfTerm, jmp_buf env);
int DBVset_snacc_scanresp_entries(PDU *PDU_ptr, DbvListEntries *psEntries, jmp_buf env);
int DBVdbv_to_snacc_listent(struct ListEntries *entries, DbvListEntries *psEntries, jmp_buf env);
int DBVdbv_to_snacc_entries(ListEntriesSeqOf *entries, DbvEntry **ppsEntry, jmp_buf env);
int DBVdbv_to_snacc_entry(Entry *data_ptr, DbvEntry *psEntry, jmp_buf env);
int DBVdbv_to_snacc_terminfo(struct TermInfo* termInfo, DbvTermInfo *psTermInfo, jmp_buf env);
int DBVdbv_to_snacc_attrtermlist(TermInfoSeqOf *alternativeTerm, DbvAttributesPlusTerm **ppsAlternativeTerm, jmp_buf env);
int DBVdbv_to_snacc_occurbyatt_list(OccurrenceByAttributes *byAttributes, DbvOccurrenceByAttributes **ppsByAttributes, jmp_buf env);
int DBVdbv_to_snacc_occurbyattseq(OccurrenceByAttributesSeq *data_ptr, DbvOccurrenceByAttributes *psByAttributes, jmp_buf env);
int DVBVdbv_to_snacc_occurrence(struct OccurrenceByAttributesSeqChoice* occurrences, DbvOccurrence *psOccurrence, jmp_buf env);
int DBVdbv_to_snacc_bydatabase(OccurrenceByAttributesSeqChoiceSeqOf *byDatabase, DbvOccurrenceByDb **ppsOccurrenceByDb, jmp_buf env);
int DBVdbv_to_snacc_bigoccurrthing(OccurrenceByAttributesSeqChoiceSeqOfSeq *data_ptr, DbvOccurrenceByDb *psOccurrenceByDb, jmp_buf env);
int DBVset_snacc_scanresp_attsetid(PDU *PDU_ptr, DbvObjectIdentifier pcAttributeSetId, jmp_buf env);
int DBVset_snacc_scanresp_otherinfo(PDU *PDU_ptr, DbvOtherInformation **ppsOtherInformation, jmp_buf env);
int DBVset_dbv_fields_scanreq(DbvTargetData *psTargetData, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_scanreq_refid(DbvScanReq *scanreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_scanreq_dbnames(DbvScanReq *scanreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_scanreq_attsetid(DbvScanReq *scanreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_scanreq_attplusterm(DbvScanReq *scanreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_scanreq_stepsize(DbvScanReq *scanreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_scanreq_numterms(DbvScanReq *scanreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_scanreq_prefpos(DbvScanReq *scanreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_scanreq_otherinfo(DbvScanReq *scanreq, PDU *PDU_ptr, jmp_buf env);

#endif
