/*  Module Name: @(#)target_z3950_search.h	7.1
    Version: 11/15/96
    Author: John Hough
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
*/

#ifndef target_z3950_search_h
#define target_z3950_search_h

#include "z3950_includes.h"

 

int DbvSearchResponse(DbvAssocId lAssocId, DbvSearchRsp *psSearchRsp, DbvError **ppsSIError);
int DBVCheckDbvSearchRspFields(DbvAssocId lAssocId, DbvSearchRsp *psSearchRsp, DbvError **ppsSIError);
int DBVcheck_dbv_srchrsp_sstat(DbvAssocId lAssocId, DbvSearchRsp *psSearchRsp, DbvError **ppsSIError);
int DBVcheck_dbv_srchrsp_ressetst(DbvAssocId lAssocId, DbvSearchRsp *psSearchRsp, DbvError **ppsSIError);
int DBVcheck_dbv_srchrsp_presst(DbvAssocId lAssocId, DbvSearchRsp *psSearchRsp, DbvError **ppsSIError);
int DBVcheck_dbv_srchrsp_records(DbvAssocId lAssocId, DbvSearchRsp *psSearchRsp, DbvError **ppsSIError);
int DBVcheck_dbv_srchrsp_addinf(DbvAssocId lAssocId, DbvSearchRsp *psSearchRsp, DbvError **ppsSIError);
int DBVcheck_dbv_srchrsp_othinfo(DbvAssocId lAssocId, DbvSearchRsp *psSearchRsp, DbvError **ppsSIError);
int DBVsetup_snacc_srchresponse(PDU *PDU_ptr, DbvSearchRsp *psSearchRsp, jmp_buf env);
int DBVset_snacc_searchresp_refid(PDU *PDU_ptr, DbvOctetString *psReferenceId, jmp_buf env);
int DBVset_snacc_searchresp_rescount(PDU *PDU_ptr, Ulong ulResultCount, jmp_buf env) ;
int DBVset_snacc_searchresp_numrecs(PDU *PDU_ptr, Ulong ulNumberOfRecordsReturned, jmp_buf env);
int DBVset_snacc_searchresp_nextres(PDU *PDU_ptr, Ulong ulNextResultSetPosition, jmp_buf env);
int DBVset_snacc_searchresp_srchstat(PDU *PDU_ptr, DbvBool fSearchStatus, jmp_buf env);
int DBVset_snacc_searchresp_resstat(PDU *PDU_ptr, DbvResultSetStatus *peResultSetStatus, jmp_buf env);
int DBVset_snacc_searchresp_presstat(PDU *PDU_ptr, DbvPresentStatus *pePresentStatus, jmp_buf env);
int DBVset_snacc_searchresp_records(PDU *PDU_ptr, DbvRecords *psRecords, jmp_buf env);
int DBVset_snacc_searchresp_addinfo(PDU *PDU_ptr, DbvOtherInformation **ppsAdditionalSearchInfo, jmp_buf env);
int DBVset_snacc_searchresp_otherinfo(PDU *PDU_ptr, DbvOtherInformation **ppsOtherInformation, jmp_buf env);
int DBVset_dbv_fields_searchreq(DbvTargetData *psTargetData, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchreq_refid(DbvSearchReq *searchreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchreq_ssetupper(DbvSearchReq *searchreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchreq_lsetlower(DbvSearchReq *searchreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchreq_msetpres(DbvSearchReq *searchreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchreq_replace(DbvSearchReq *searchreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchreq_resultset(DbvSearchReq *searchreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchreq_dbnames(DbvSearchReq *searchreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchreq_ssetelname(DbvSearchReq *searchreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchreq_msetelname(DbvSearchReq *searchreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchreq_prefrecsyn(DbvSearchReq *searchreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchreq_query(DbvSearchReq *searchreq, PDU *PDU_ptr, jmp_buf env);
int DBVsnacc_to_dbv_query(DbvRPNQuery *psRpnQuery, struct RPNQuery* type_1, jmp_buf env);
int DBVsnacc_to_dbv_rpn(DbvRPNStructure *psRpnStructure, struct RPNStructure* rpn, jmp_buf env);
int DBVsnacc_to_dbv_operand(DbvOperand *psRpnOperand, struct Operand* op, jmp_buf env);
int DBVsnacc_to_dbv_resulattr(DbvResultSetPlusAttributes *psResuLtSetPlusAttributes, struct ResultSetPlusAttributes* resultAttr, jmp_buf env);
int DBVsnacc_to_dbv_lopropop(DbvRPNLopRopOperator *psRpnLopRopOperator, struct RPNStructureSeq* rpnRpnOp, jmp_buf env);
int DBVsnacc_to_dbv_operator(DbvOperator *psOperator, struct Operator* op, jmp_buf env);
int DBVsnacc_to_dbv_prox(DbvProximityOperator *psProximityOperator, struct ProximityOperator* prox, jmp_buf env);
int DBVsnacc_to_dbv_proxunitcode(DbvProximityUnitCode *psProximityUnitCode, struct ProximityOperatorChoice* proximityUnitCode, jmp_buf env) ;
int DBVset_dbv_searchreq_addinfo(DbvSearchReq *searchreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_searchreq_otherinfo(DbvSearchReq *searchreq, PDU *PDU_ptr, jmp_buf env);

#endif
