/*  Module Name: @(#)target_z3950_sort.h	7.1
    Version: 11/15/96
    Author: John Hough
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
*/

#ifndef target_z3950_sort_h
#define target_z3950_sort_h

#include "z3950_includes.h"


int DbvSortResponse(DbvAssocId lAssocId, DbvSortRsp *psSortRsp, DbvError **ppsSIError);
int DBVCheckDbvSortRspFields(DbvAssocId lAssocId, DbvSortRsp *psSortRsp, DbvError **ppsSIError);
int DBVcheck_dbv_sortrsp_status(DbvAssocId lAssocId, DbvSortRsp *psSortRsp, DbvError **ppsSIError);
int DBVcheck_dbv_sortrsp_ressetid(DbvAssocId lAssocId, DbvSortRsp *psSortRsp, DbvError **ppsSIError);
int DBVcheck_dbv_sortrsp_diag(DbvAssocId lAssocId, DbvSortRsp *psSortRsp, DbvError **ppsSIError);
int DBVcheck_dbv_sortrsp_otherinfo(DbvAssocId lAssocId, DbvSortRsp *psSortRsp, DbvError **ppsSIError);
int DBVsetup_snacc_sortresponse(PDU *PDU_ptr, DbvSortRsp *psSortRsp, jmp_buf env);
int DBVset_snacc_sortresp_refid(PDU *PDU_ptr, DbvOctetString *psReferenceId, jmp_buf env);
int DBVset_snacc_sortresp_sortstat(PDU *PDU_ptr, DbvSortStatus eSortStatus, jmp_buf env);
int DBVset_snacc_sortresp_resstat(PDU *PDU_ptr, DbvSortResultSetStatus *peResultSetStatus, jmp_buf env);
int DBVset_snacc_sortresp_diag(PDU *PDU_ptr, DbvDiagRec **ppsDiagnostics, jmp_buf env);
int DBVset_snacc_sortresp_otherinfo(PDU *PDU_ptr, DbvOtherInformation **ppsOtherInformation, jmp_buf env);
int DBVset_dbv_fields_sortreq(DbvTargetData *psTargetData, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_sortreq_refid(DbvSortReq *sortreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_sortreq_inresset(DbvSortReq *sortreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_sortreq_sortedres(DbvSortReq *sortreq, PDU *PDU_ptr, jmp_buf env);
int DBVset_dbv_sortreq_sortseq(DbvSortReq *sortreq, PDU *PDU_ptr, jmp_buf env);
int DBVsnacc_to_dbv_sortkeyspec(DbvSortKeySpec *psSortSequence, SortKeySpec *data_ptr, jmp_buf env);
int DBVsnacc_to_dbv_sortelmnt(DbvSortElement *psSortElement, struct SortElement* sortElement, jmp_buf env);
int DBVsnacc_to_dbv_sortkey(DbvSortKey *psGeneric, struct SortKey* generic, jmp_buf env);
int DBVsnacc_to_dbv_soratts(DbvSortAttributes *psSortAttributes, struct SortKeySeq* sortAttributes, jmp_buf env);
int DBVsnacc_to_dbv_dbspecific(DbvDbSpecificSortKey **ppsDatabaseSpecific, SortElementSeqOf *datbaseSpecific, jmp_buf env);
int DBVsnacc_to_dbv_specsortkey(DbvDbSpecificSortKey *psDatabaseSpecific, SortElementSeqOfSeq *data_ptr, jmp_buf env);
int DBVsnacc_to_dbv_sortrel(DbvSortKeySpec *psSortSequence, SortKeySpec *data_ptr, jmp_buf env);
int DBVsnacc_to_dbv_sortcase(DbvSortKeySpec *psSortSequence, SortKeySpec *data_ptr, jmp_buf env);
int DBVsnacc_to_dbv_sortmv(DbvSortMVAction *psMVActionType, struct SortKeySpecChoice* missingValueAction, jmp_buf env);
int DBVset_dbv_sortreq_otherinfo(DbvSortReq *sortreq, PDU *PDU_ptr, jmp_buf env);

#endif
