/*  Module Name: @(#)target_z3950_trigger.c	7.1
    Version: 11/15/96
    Author: John Hough
    
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ

    Date of Issue:  

    QA Acceptance:  
    Date of Acceptance:  

    Description:  Target end routines to process a received 
		  TriggerResourceControlRequest PDU sent by an origin.
		  There's no TriggerResourceControlResponse.
		  

*/


#include "target_z3950_trigger.h"


/*****************************************************************
******************************************************************
******************************************************************
CREATE TriggerResourceControlResponse PDU TO SEND TO ORIGIN AND SEND IT 
*/


/* THERE AINT ONE */




/*****************************************************************
******************************************************************
******************************************************************
PROCESS TriggerResourceControlRequest PDU RECEIVED FROM ORIGIN 
*/

int DBVset_dbv_fields_DbvTriggerResourceControlReq(DbvTargetData *psTargetData, PDU *PDU_ptr, jmp_buf env)
{
 
        psTargetData->eTargetEvent = TA_TrigResourCntrlInd;
        psTargetData->uTargetData.psTriggerResourceControlReq = (DbvTriggerResourceControlReq *) DbvAlloc ( sizeof (DbvTriggerResourceControlReq));
	CheckDbvAlloc(psTargetData->uTargetData.psTriggerResourceControlReq, env);

	/* o */
        DBVset_DbvTriggerResourceControlReq_psReferenceId(psTargetData->uTargetData.psTriggerResourceControlReq, PDU_ptr, env);

	/* c */
        DBVset_DbvTriggerResourceControlReq_eRequestedAction(psTargetData->uTargetData.psTriggerResourceControlReq, PDU_ptr, env);

	/* o */
        DBVset_DbvTiggerResourceControlReq_pcPreferredResourceReportFormat(psTargetData->uTargetData.psTriggerResourceControlReq, PDU_ptr, env);

	/* o */
        DBVset_DbvTiggerResourceControlReq_pfResultSetWanted(psTargetData->uTargetData.psTriggerResourceControlReq, PDU_ptr, env);
 
	/* o */
	DBVset_DbvTriggerResourceControlReq_ppsOtherInformation(psTargetData->uTargetData.psTriggerResourceControlReq, PDU_ptr, env);

        /* Following frees elements in PDU_ptr, not PDU_ptr itself */
        FreePDU(PDU_ptr);
 
}



int DBVset_DbvTriggerResourceControlReq_psReferenceId(DbvTriggerResourceControlReq *psTriggerResourceControlReq, PDU *PDU_ptr, jmp_buf env)
{
	/* o */	
	DBVsnacc_to_dbv_DbvOctetString_opt(&psTriggerResourceControlReq->psReferenceId, &PDU_ptr->a.triggerResourceControlRequest->referenceId, env);
}



int DBVset_DbvTriggerResourceControlReq_eRequestedAction(DbvTriggerResourceControlReq *psTriggerResourceControlReq, PDU *PDU_ptr, jmp_buf env)
{
	/* c */
	switch (PDU_ptr->a.triggerResourceControlRequest->requestedAction) {
	case RESOURCEREPORT1:
		psTriggerResourceControlReq->eRequestedAction = RA_ResourceReport1;
		break;
	case RESOURCECONTROL:
		psTriggerResourceControlReq->eRequestedAction = RA_ResourceControl;
		break;
	case CANCEL:
		psTriggerResourceControlReq->eRequestedAction = RA_Cancel;
		break;
	}
}



int DBVset_DbvTiggerResourceControlReq_pcPreferredResourceReportFormat(DbvTriggerResourceControlReq *psTriggerResourceControlReq, PDU *PDU_ptr, jmp_buf env)
{
	/* o */
	DBVsnacc_to_dbv_objectident_opt(&psTriggerResourceControlReq->pcPreferredResourceReportFormat, &PDU_ptr->a.triggerResourceControlRequest->prefResourceReportFormat, env);
}



int DBVset_DbvTiggerResourceControlReq_pfResultSetWanted(DbvTriggerResourceControlReq *psTriggerResourceControlReq, PDU *PDU_ptr, jmp_buf env)
{
	/* o */
	DBVsnacc_to_dbv_DbvBool_opt(&psTriggerResourceControlReq->pfResultSetWanted, PDU_ptr->a.triggerResourceControlRequest->resultSetWanted, env);
}


int DBVset_DbvTriggerResourceControlReq_ppsOtherInformation(DbvTriggerResourceControlReq *psTriggerResourceControlReq, PDU *PDU_ptr, jmp_buf env)
{
	/* o */
	DBVsnacc_to_dbv_otherinfo_opt(&psTriggerResourceControlReq->ppsOtherInformation, PDU_ptr->a.triggerResourceControlRequest->otherInfo, env);
}



