/*  Module Name: @(#)trace_assocutil_params.h	7.1
    Version: 11/15/96
    Author: Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Prints the input parameters of the association and utility
        functions to the trace file.
 
        Used by the origin and target.

 
*/

#ifndef TRACE_ASSOCUTIL_PARAMS_H
#define TRACE_ASSOCUTIL_PARAMS_H

#include "z3950_includes.h"

void Trace_writeDbvAssocId(DbvAssocId);
void Trace_writeDbvSecs(DbvSecs lSeconds, DbvAssocId lAssocId);
void Trace_writeDbvTarget(DbvTarget *psTarget, TBL OutTable);
void Trace_writeDbvAssociateState(DbvAssociateState *peAssociateState,
        DbvAssocId lAssocId);
void Trace_writeDbvAssociateResult(DbvAssociateResult *puAssociateResult,
        DbvAssociateState eAssociateState, DbvAssocId lAssocId);
void Trace_writeDbvAssociateRsp(DbvAssociateRsp eAssociateRsp,
        DbvAssocId lAssocId);
void Trace_writeDbvReleaseRsp(DbvReleaseRsp *psReleaseRsp, DbvAssocId lAssocId);
void Trace_writeDbvAssociateRejectSource(DbvAssociateRejectSource
        *peAssociateRejectSource, DbvAssocId lAssocId);
void Trace_writeDbvAssociateRejectResult(DbvAssociateRejectResult
        *peAssociateRejectResult, DbvAssocId lAssocId);
void Trace_writeDbvAssociateRejectReason(DbvAssociateRejectReason
        *peAssociateRejectReason, DbvAssocId lAssocId);
void Trace_writeDbvReleaseState(DbvReleaseState *peReleaseState,
        DbvAssocId lAssocId);
void Trace_DbvProtocolStack(DbvProtocolStack *, DbvAssocId);


#endif 

