/*  Module Name: @(#)api_usmarc_formatter.h	4.2
    Version: 8/22/96
    Author: John Hough

    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ

    Date of Issue:

    QA Acceptance:
    Date of Acceptance:

    Description: Header file for api_usmarc_formatter.c. Inspired
		 by code in the Willow Z39.50 application.

*/


#ifndef DBVapi_usmarc_formatter_h
#define DBVapi_usmarc_formatter_h

 
#include "z3950_includes.h"


typedef char DBVstr[1024];

typedef enum DBVMarcType {
	Tomas_marc = 0,
	Normal_marc = 1
} DBVMarcType;


#define DBVCODELEN 3

/* End of String */
#define DBVEOS '\0'     

/* Max length for bibliographical record */
#define DBVMAXBIBLEN 6114 

/* Min length for bibliograpghical record */
#define DBVMINBIBLEN 124  

/* Max length for holdings record */
#define DBVMAXHLEN 6114  

/* Min length for holdings record */
#define DBVMINHLEN 112   


/* Record end */
#define DBVREC_END '\035'                      

/* Record seperator */
#define DBVREC_SEP '\036'       


/* Start of Subsection */
#define DBVREC_SUBSEC '\037'                  

/* Charaacter to output for subsection */
#define DBVSCHAR '|'                 


int DBVusmarc_format(DbvOctetString *psDbvOctetString, DBVMarcType eMarcType, DbvBool ePrintHeader, FILE *file);
int DBVholdings_rec(char *record);
int DBVhold_rec(char *record, int length, FILE *f)  ;
int DBVcheck_hold_length(int length, FILE *f);
int DBVbib_rec(char *record, int length, DBVMarcType eMarcType, DbvBool ePrintHeader, FILE *f);
int DBVcheck_bib_length(int length, FILE *f);
int DBVint_from_string(char *string, int len, FILE *f);
int DBVcheck_addr(int addr, int length, FILE *f);
int DBVprint_bib_leader(char *record, FILE *f)                  ;
int DBVprint_rec_status(char *record, FILE *f);
int DBVcheck_8_9_10_11(char *record, FILE *f);
int DBVprint_trans_type(char *record, FILE *f);
int DBVget_code_length_offset(char *record, int *code, int *compon_length, int *offset, int *p, FILE *f);
int DBVprint_data(char *dp, int length, FILE *f);
int DBVndmarc(char* record, int length, FILE *f);
int DBVnbib_rec(char *record, int length, FILE *f);
int DBVndisplay( int code, char *record, int offset, int compon_length, FILE *f);
int DBVcopy(char *dp, char *sp, int length );
int DBVshow_field(char *data, int type, char *name, FILE *f);


#endif
