/*
 *    z39_50_externals_e_1995.h
 *
 *    "Z39-50-EXTERNALS-E-1995" ASN.1 module C type definitions and prototypes
 *
 *    This .h file was by snacc on Thu Apr 24 11:53:17 1997
 *
 *    UBC snacc written compiler by Mike Sample
 *
 *    NOTE: This is a machine generated file - editing not recommended
 */


#ifndef _z39_50_externals_e_1995_h_
#define _z39_50_externals_e_1995_h_




typedef enum Z39_50_EXTERNALS_E_1995AnyId
{
    accdes1Oid_ANY_ID = 7,
    acckrb1Oid_ANY_ID = 8,
    resrep1Oid_ANY_ID = 9,
    resrep2Oid_ANY_ID = 10,
    esperresOid_ANY_ID = 11,
    accprompt1Oid_ANY_ID = 12} Z39_50_EXTERNALS_E_1995AnyId;


void InitAnyZ39_50_EXTERNALS_E_1995();


#define REPLACE 1
#define APPEND 2

typedef AsnInt OriginPartNotToKeep1Int; /* INTEGER { REPLACE(1), APPEND(2) }  */

#define BEncOriginPartNotToKeep1IntContent BEncAsnIntContent

#define BDecOriginPartNotToKeep1IntContent BDecAsnIntContent

#define PrintOriginPartNotToKeep1Int PrintAsnInt

#define FreeOriginPartNotToKeep1Int FreeAsnInt 





#define GROUPID 0
#define USERID 1
#define PASSWORD 2
#define NEWPASSWORD 3
#define COPYRIGHT 4
#define SESSIONID 5

typedef AsnInt PromptIdSeqInt; /* INTEGER { GROUPID(0), USERID(1), PASSWORD(2), NEWPASSWORD(3), COPYRIGHT(4), SESSIONID(5) }  */

#define BEncPromptIdSeqIntContent BEncAsnIntContent

#define BDecPromptIdSeqIntContent BDecAsnIntContent

#define PrintPromptIdSeqInt PrintAsnInt

#define FreePromptIdSeqInt FreeAsnInt 





#define INTEGER 1
#define DATE1 2
#define FLOAT 3
#define ALPHANUMERIC 4
#define URL_URN 5
#define BOOLEAN 6

typedef AsnInt ChallengeSeqInt; /* INTEGER { INTEGER(1), DATE1(2), FLOAT(3), ALPHANUMERIC(4), URL_URN(5), BOOLEAN(6) }  */

#define BEncChallengeSeqIntContent BEncAsnIntContent

#define BDecChallengeSeqIntContent BDecAsnIntContent

#define PrintChallengeSeqInt PrintAsnInt

#define FreeChallengeSeqInt FreeAsnInt 





#define CURRENTSEARCHRECORDS 1
#define FINALSEARCHRECORDS 2
#define CURRENTPRESENTRECORDS 3
#define FINALPRESENTRECORDS 4
#define CURRENTOPTIMEPROCESSING 5
#define FINALOPTIMEPROCESSING 6
#define CURRENTASSOCTIME 7
#define CURRENTOPERATIONCOST 8
#define FINALOPERATIONCOST 9
#define CURRENTASSOCCOST 10
#define FINALOPTIMEELAPSED 11
#define PERCENTCOMPLETE 12
#define CURRENTSEARCHASSOCCOST 13
#define CURRENTPRESENTASSOCCOST 14
#define CURRENTCONNECTASSOCCOST 15
#define CURRENTOTHERASSOCCOST 16

typedef AsnInt EstimateType; /* INTEGER { CURRENTSEARCHRECORDS(1), FINALSEARCHRECORDS(2), CURRENTPRESENTRECORDS(3), FINALPRESENTRECORDS(4), CURRENTOPTIMEPROCESSING(5), FINALOPTIMEPROCESSING(6), CURRENTASSOCTIME(7), CURRENTOPERATIONCOST(8), FINALOPERATIONCOST(9), CURRENTASSOCCOST(10), FINALOPTIMEELAPSED(11), PERCENTCOMPLETE(12), CURRENTSEARCHASSOCCOST(13), CURRENTPRESENTASSOCCOST(14), CURRENTCONNECTASSOCCOST(15), CURRENTOTHERASSOCCOST(16) }  */

#define BEncEstimateTypeContent BEncAsnIntContent

#define BDecEstimateTypeContent BDecAsnIntContent

#define PrintEstimateType PrintAsnInt

#define FreeEstimateType FreeAsnInt 




typedef AsnList ChallengeSeqSeqOf; /* SEQUENCE OF InternationalString */

AsnLen BEncChallengeSeqSeqOfContent PROTO((BUF_TYPE b, ChallengeSeqSeqOf* v));

void BDecChallengeSeqSeqOfContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ChallengeSeqSeqOf* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintChallengeSeqSeqOf PROTO((FILE* f, ChallengeSeqSeqOf* v, unsigned short int indent));
void FreeChallengeSeqSeqOf PROTO((ChallengeSeqSeqOf* v));





typedef struct Estimate2 /* SEQUENCE */
{
    struct StringOrNumeric* type; /* [1] StringOrNumeric */
    struct IntUnit* value; /* [2] IMPLICIT IntUnit */
} Estimate2;

AsnLen BEncEstimate2Content PROTO((BUF_TYPE b, Estimate2* v));

void BDecEstimate2Content PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, Estimate2* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintEstimate2 PROTO((FILE* f, Estimate2* v, unsigned short int indent));
void FreeEstimate2 PROTO((Estimate2* v));





typedef struct Encryption /* SEQUENCE */
{
    AsnOcts cryptType; /* [1] IMPLICIT OCTET STRING OPTIONAL */
    AsnOcts credential; /* [2] IMPLICIT OCTET STRING OPTIONAL */
    AsnOcts data; /* [3] IMPLICIT OCTET STRING */
} Encryption;

AsnLen BEncEncryptionContent PROTO((BUF_TYPE b, Encryption* v));

void BDecEncryptionContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, Encryption* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintEncryption PROTO((FILE* f, Encryption* v, unsigned short int indent));
void FreeEncryption PROTO((Encryption* v));





typedef struct DRNType /* SEQUENCE */
{
    AsnOcts userId; /* [1] IMPLICIT OCTET STRING OPTIONAL */
    AsnOcts salt; /* [2] IMPLICIT OCTET STRING OPTIONAL */
    AsnOcts randomNumber; /* [3] IMPLICIT OCTET STRING */
} DRNType;

AsnLen BEncDRNTypeContent PROTO((BUF_TYPE b, DRNType* v));

void BDecDRNTypeContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, DRNType* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintDRNType PROTO((FILE* f, DRNType* v, unsigned short int indent));
void FreeDRNType PROTO((DRNType* v));





typedef struct KRBRequest /* SEQUENCE */
{
    InternationalString service; /* [1] IMPLICIT InternationalString */
    InternationalString instance; /* [2] IMPLICIT InternationalString OPTIONAL */
    InternationalString realm; /* [3] IMPLICIT InternationalString OPTIONAL */
} KRBRequest;

AsnLen BEncKRBRequestContent PROTO((BUF_TYPE b, KRBRequest* v));

void BDecKRBRequestContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, KRBRequest* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintKRBRequest PROTO((FILE* f, KRBRequest* v, unsigned short int indent));
void FreeKRBRequest PROTO((KRBRequest* v));





typedef struct KRBResponse /* SEQUENCE */
{
    InternationalString userid; /* [1] IMPLICIT InternationalString OPTIONAL */
    AsnOcts ticket; /* [2] IMPLICIT OCTET STRING */
} KRBResponse;

AsnLen BEncKRBResponseContent PROTO((BUF_TYPE b, KRBResponse* v));

void BDecKRBResponseContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, KRBResponse* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintKRBResponse PROTO((FILE* f, KRBResponse* v, unsigned short int indent));
void FreeKRBResponse PROTO((KRBResponse* v));





typedef struct TargetPart1 /* SEQUENCE */
{
    InternationalString targetSuppliedResultSet; /* [1] IMPLICIT InternationalString OPTIONAL */
    AsnInt* numberOfRecords; /* [2] IMPLICIT INTEGER OPTIONAL */
} TargetPart1;

AsnLen BEncTargetPart1Content PROTO((BUF_TYPE b, TargetPart1* v));

void BDecTargetPart1Content PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, TargetPart1* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintTargetPart1 PROTO((FILE* f, TargetPart1* v, unsigned short int indent));
void FreeTargetPart1 PROTO((TargetPart1* v));





typedef struct PersistentResultSetSeq1 /* SEQUENCE */
{
    AsnNull originPart; /* [1] IMPLICIT NULL */
    struct TargetPart1* targetPart; /* [2] TargetPart1 OPTIONAL */
} PersistentResultSetSeq1;

AsnLen BEncPersistentResultSetSeq1Content PROTO((BUF_TYPE b, PersistentResultSetSeq1* v));

void BDecPersistentResultSetSeq1Content PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, PersistentResultSetSeq1* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintPersistentResultSetSeq1 PROTO((FILE* f, PersistentResultSetSeq1* v, unsigned short int indent));
void FreePersistentResultSetSeq1 PROTO((PersistentResultSetSeq1* v));





typedef struct PromptIdSeq /* SEQUENCE */
{
    PromptIdSeqInt type; /* [1] IMPLICIT PromptIdSeqInt */
    InternationalString suggestedString; /* [2] IMPLICIT InternationalString OPTIONAL */
} PromptIdSeq;

AsnLen BEncPromptIdSeqContent PROTO((BUF_TYPE b, PromptIdSeq* v));

void BDecPromptIdSeqContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, PromptIdSeq* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintPromptIdSeq PROTO((FILE* f, PromptIdSeq* v, unsigned short int indent));
void FreePromptIdSeq PROTO((PromptIdSeq* v));





typedef struct ResponseSeqChoice /* CHOICE */
{
    enum ResponseSeqChoiceChoiceId
    {
        RESPONSESEQCHOICE_STRING,
        RESPONSESEQCHOICE_ACCEPT,
        RESPONSESEQCHOICE_ACKNOWLEDGE,
        RESPONSESEQCHOICE_DIAGNOSTIC,
        RESPONSESEQCHOICE_ENCRYPTED
    } choiceId;
    union ResponseSeqChoiceChoiceUnion
    {
    InternationalString* string; /* [1] IMPLICIT InternationalString */
    AsnBool accept; /* [2] IMPLICIT BOOLEAN */
    AsnNull acknowledge; /* [3] IMPLICIT NULL */
    struct DiagRec* diagnostic; /* [4] DiagRec */
    struct Encryption* encrypted; /* [5] IMPLICIT Encryption */
    } a;
} ResponseSeqChoice;

AsnLen BEncResponseSeqChoiceContent PROTO((BUF_TYPE b, ResponseSeqChoice* v));

void BDecResponseSeqChoiceContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ResponseSeqChoice* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintResponseSeqChoice PROTO((FILE* f, ResponseSeqChoice* v, unsigned short int indent));
void FreeResponseSeqChoice PROTO((ResponseSeqChoice* v));





typedef struct ChallengeSeqChoice /* CHOICE */
{
    enum ChallengeSeqChoiceChoiceId
    {
        CHALLENGESEQCHOICE_CHARACTER,
        CHALLENGESEQCHOICE_ENCRYPTED
    } choiceId;
    union ChallengeSeqChoiceChoiceUnion
    {
    InternationalString* character; /* [1] IMPLICIT InternationalString */
    struct Encryption* encrypted; /* [2] IMPLICIT Encryption */
    } a;
} ChallengeSeqChoice;

AsnLen BEncChallengeSeqChoiceContent PROTO((BUF_TYPE b, ChallengeSeqChoice* v));

void BDecChallengeSeqChoiceContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ChallengeSeqChoice* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintChallengeSeqChoice PROTO((FILE* f, ChallengeSeqChoice* v, unsigned short int indent));
void FreeChallengeSeqChoice PROTO((ChallengeSeqChoice* v));





typedef AsnList ResourceReport2SeqOf; /* SEQUENCE OF Estimate2 */

AsnLen BEncResourceReport2SeqOfContent PROTO((BUF_TYPE b, ResourceReport2SeqOf* v));

void BDecResourceReport2SeqOfContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ResourceReport2SeqOf* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintResourceReport2SeqOf PROTO((FILE* f, ResourceReport2SeqOf* v, unsigned short int indent));
void FreeResourceReport2SeqOf PROTO((ResourceReport2SeqOf* v));





typedef struct Estimate /* SEQUENCE */
{
    EstimateType type; /* [1] IMPLICIT EstimateType */
    AsnInt value; /* [2] IMPLICIT INTEGER */
    AsnInt* currency_code; /* [3] IMPLICIT INTEGER OPTIONAL */
} Estimate;

AsnLen BEncEstimateContent PROTO((BUF_TYPE b, Estimate* v));

void BDecEstimateContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, Estimate* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintEstimate PROTO((FILE* f, Estimate* v, unsigned short int indent));
void FreeEstimate PROTO((Estimate* v));





typedef struct ResourceReport2 /* SEQUENCE */
{
    ResourceReport2SeqOf* estimates; /* [1] IMPLICIT ResourceReport2SeqOf OPTIONAL */
    InternationalString message; /* [2] IMPLICIT InternationalString OPTIONAL */
} ResourceReport2;

AsnLen BEncResourceReport2Content PROTO((BUF_TYPE b, ResourceReport2* v));

void BDecResourceReport2Content PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ResourceReport2* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintResourceReport2 PROTO((FILE* f, ResourceReport2* v, unsigned short int indent));
void FreeResourceReport2 PROTO((ResourceReport2* v));





typedef struct PromptId /* CHOICE */
{
    enum PromptIdChoiceId
    {
        PROMPTID_ENUMMERATEDPROMPT,
        PROMPTID_NONENUMERATEDPROMPT
    } choiceId;
    union PromptIdChoiceUnion
    {
    struct PromptIdSeq* enummeratedPrompt; /* [1] IMPLICIT PromptIdSeq */
    InternationalString* nonEnumeratedPrompt; /* [2] IMPLICIT InternationalString */
    } a;
} PromptId;

AsnLen BEncPromptIdContent PROTO((BUF_TYPE b, PromptId* v));

void BDecPromptIdContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, PromptId* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintPromptId PROTO((FILE* f, PromptId* v, unsigned short int indent));
void FreePromptId PROTO((PromptId* v));





typedef struct DES_RN_Object /* CHOICE */
{
    enum DES_RN_ObjectChoiceId
    {
        DES_RN_OBJECT_CHALLENGE,
        DES_RN_OBJECT_RESPONSE
    } choiceId;
    union DES_RN_ObjectChoiceUnion
    {
    struct DRNType* challenge; /* [1] IMPLICIT DRNType */
    struct DRNType* response; /* [2] IMPLICIT DRNType */
    } a;
} DES_RN_Object;

AsnLen BEncDES_RN_Object PROTO((BUF_TYPE b, DES_RN_Object* v));

void BDecDES_RN_Object PROTO(( BUF_TYPE b, DES_RN_Object* result, AsnLen* bytesDecoded, ENV_TYPE env));
AsnLen BEncDES_RN_ObjectContent PROTO((BUF_TYPE b, DES_RN_Object* v));

void BDecDES_RN_ObjectContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, DES_RN_Object* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintDES_RN_Object PROTO((FILE* f, DES_RN_Object* v, unsigned short int indent));
void FreeDES_RN_Object PROTO((DES_RN_Object* v));





typedef struct KRBObject /* CHOICE */
{
    enum KRBObjectChoiceId
    {
        KRBOBJECT_CHALLENGE,
        KRBOBJECT_RESPONSE
    } choiceId;
    union KRBObjectChoiceUnion
    {
    struct KRBRequest* challenge; /* [1] IMPLICIT KRBRequest */
    struct KRBResponse* response; /* [2] IMPLICIT KRBResponse */
    } a;
} KRBObject;

AsnLen BEncKRBObject PROTO((BUF_TYPE b, KRBObject* v));

void BDecKRBObject PROTO(( BUF_TYPE b, KRBObject* result, AsnLen* bytesDecoded, ENV_TYPE env));
AsnLen BEncKRBObjectContent PROTO((BUF_TYPE b, KRBObject* v));

void BDecKRBObjectContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, KRBObject* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintKRBObject PROTO((FILE* f, KRBObject* v, unsigned short int indent));
void FreeKRBObject PROTO((KRBObject* v));





typedef struct OriginPartNotToKeep1 /* SEQUENCE */
{
    InternationalString originSuppliedResultSet; /* [1] IMPLICIT InternationalString OPTIONAL */
    OriginPartNotToKeep1Int* replaceOrAppend; /* [2] IMPLICIT OriginPartNotToKeep1Int OPTIONAL */
} OriginPartNotToKeep1;

AsnLen BEncOriginPartNotToKeep1Content PROTO((BUF_TYPE b, OriginPartNotToKeep1* v));

void BDecOriginPartNotToKeep1Content PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, OriginPartNotToKeep1* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintOriginPartNotToKeep1 PROTO((FILE* f, OriginPartNotToKeep1* v, unsigned short int indent));
void FreeOriginPartNotToKeep1 PROTO((OriginPartNotToKeep1* v));





typedef struct PersistentResultSetSeq /* SEQUENCE */
{
    AsnNull toKeep; /* [1] IMPLICIT NULL */
    struct OriginPartNotToKeep1* notToKeep; /* [2] OriginPartNotToKeep1 OPTIONAL */
} PersistentResultSetSeq;

AsnLen BEncPersistentResultSetSeqContent PROTO((BUF_TYPE b, PersistentResultSetSeq* v));

void BDecPersistentResultSetSeqContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, PersistentResultSetSeq* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintPersistentResultSetSeq PROTO((FILE* f, PersistentResultSetSeq* v, unsigned short int indent));
void FreePersistentResultSetSeq PROTO((PersistentResultSetSeq* v));





typedef struct ResponseSeq /* SEQUENCE */
{
    struct PromptId* promptId; /* [1] PromptId */
    struct ResponseSeqChoice* promptResponse; /* [2] ResponseSeqChoice */
} ResponseSeq;

AsnLen BEncResponseSeqContent PROTO((BUF_TYPE b, ResponseSeq* v));

void BDecResponseSeqContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ResponseSeq* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintResponseSeq PROTO((FILE* f, ResponseSeq* v, unsigned short int indent));
void FreeResponseSeq PROTO((ResponseSeq* v));





typedef struct ChallengeSeq /* SEQUENCE */
{
    struct PromptId* promptId; /* [1] PromptId */
    InternationalString defaultResponse; /* [2] IMPLICIT InternationalString OPTIONAL */
    struct ChallengeSeqChoice* promptInfo; /* [3] ChallengeSeqChoice OPTIONAL */
    InternationalString regExpr; /* [4] IMPLICIT InternationalString OPTIONAL */
    AsnNull* responseRequired; /* [5] IMPLICIT NULL OPTIONAL */
    ChallengeSeqSeqOf* allowedValues; /* [6] IMPLICIT ChallengeSeqSeqOf OPTIONAL */
    AsnNull* shouldSave; /* [7] IMPLICIT NULL OPTIONAL */
    ChallengeSeqInt* dataType; /* [8] IMPLICIT ChallengeSeqInt OPTIONAL */
    struct NEWEXTERNAL* diagnostic; /* [9] IMPLICIT NEWEXTERNAL OPTIONAL */
} ChallengeSeq;

AsnLen BEncChallengeSeqContent PROTO((BUF_TYPE b, ChallengeSeq* v));

void BDecChallengeSeqContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ChallengeSeq* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintChallengeSeq PROTO((FILE* f, ChallengeSeq* v, unsigned short int indent));
void FreeChallengeSeq PROTO((ChallengeSeq* v));





typedef AsnList ResourceReport1SeqOf; /* SEQUENCE OF Estimate */

AsnLen BEncResourceReport1SeqOfContent PROTO((BUF_TYPE b, ResourceReport1SeqOf* v));

void BDecResourceReport1SeqOfContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ResourceReport1SeqOf* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintResourceReport1SeqOf PROTO((FILE* f, ResourceReport1SeqOf* v, unsigned short int indent));
void FreeResourceReport1SeqOf PROTO((ResourceReport1SeqOf* v));





typedef struct ResourceReport1 /* SEQUENCE */
{
    ResourceReport1SeqOf* estimates; /* [1] IMPLICIT ResourceReport1SeqOf */
    InternationalString message; /* [2] IMPLICIT InternationalString */
} ResourceReport1;

AsnLen BEncResourceReport1 PROTO((BUF_TYPE b, ResourceReport1* v));

void BDecResourceReport1 PROTO(( BUF_TYPE b, ResourceReport1* result, AsnLen* bytesDecoded, ENV_TYPE env));
AsnLen BEncResourceReport1Content PROTO((BUF_TYPE b, ResourceReport1* v));

void BDecResourceReport1Content PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ResourceReport1* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintResourceReport1 PROTO((FILE* f, ResourceReport1* v, unsigned short int indent));
void FreeResourceReport1 PROTO((ResourceReport1* v));





typedef struct ResourceReport2Record /* CHOICE */
{
    enum ResourceReport2RecordChoiceId
    {
        RESOURCEREPORT2RECORD_JOHNFIX
    } choiceId;
    union ResourceReport2RecordChoiceUnion
    {
    struct ResourceReport2* johnfix; /* ResourceReport2 */
    } a;
} ResourceReport2Record;

AsnLen BEncResourceReport2Record PROTO((BUF_TYPE b, ResourceReport2Record* v));

void BDecResourceReport2Record PROTO(( BUF_TYPE b, ResourceReport2Record* result, AsnLen* bytesDecoded, ENV_TYPE env));
AsnLen BEncResourceReport2RecordContent PROTO((BUF_TYPE b, ResourceReport2Record* v));

void BDecResourceReport2RecordContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ResourceReport2Record* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintResourceReport2Record PROTO((FILE* f, ResourceReport2Record* v, unsigned short int indent));
void FreeResourceReport2Record PROTO((ResourceReport2Record* v));





typedef AsnList Challenge; /* SEQUENCE OF ChallengeSeq */

AsnLen BEncChallengeContent PROTO((BUF_TYPE b, Challenge* v));

void BDecChallengeContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, Challenge* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintChallenge PROTO((FILE* f, Challenge* v, unsigned short int indent));
void FreeChallenge PROTO((Challenge* v));





typedef AsnList Response; /* SEQUENCE OF ResponseSeq */

AsnLen BEncResponseContent PROTO((BUF_TYPE b, Response* v));

void BDecResponseContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, Response* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintResponse PROTO((FILE* f, Response* v, unsigned short int indent));
void FreeResponse PROTO((Response* v));





typedef struct PersistentResultSet /* CHOICE */
{
    enum PersistentResultSetChoiceId
    {
        PERSISTENTRESULTSET_ESREQUEST,
        PERSISTENTRESULTSET_TASKPACKAGE
    } choiceId;
    union PersistentResultSetChoiceUnion
    {
    struct PersistentResultSetSeq* esRequest; /* [1] IMPLICIT PersistentResultSetSeq */
    struct PersistentResultSetSeq1* taskPackage; /* [2] IMPLICIT PersistentResultSetSeq1 */
    } a;
} PersistentResultSet;

AsnLen BEncPersistentResultSet PROTO((BUF_TYPE b, PersistentResultSet* v));

void BDecPersistentResultSet PROTO(( BUF_TYPE b, PersistentResultSet* result, AsnLen* bytesDecoded, ENV_TYPE env));
AsnLen BEncPersistentResultSetContent PROTO((BUF_TYPE b, PersistentResultSet* v));

void BDecPersistentResultSetContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, PersistentResultSet* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintPersistentResultSet PROTO((FILE* f, PersistentResultSet* v, unsigned short int indent));
void FreePersistentResultSet PROTO((PersistentResultSet* v));





typedef struct PromptObject /* CHOICE */
{
    enum PromptObjectChoiceId
    {
        PROMPTOBJECT_CHALLENGE,
        PROMPTOBJECT_RESPONSE
    } choiceId;
    union PromptObjectChoiceUnion
    {
    Challenge* challenge; /* [1] IMPLICIT Challenge */
    Response* response; /* [2] IMPLICIT Response */
    } a;
} PromptObject;

AsnLen BEncPromptObject PROTO((BUF_TYPE b, PromptObject* v));

void BDecPromptObject PROTO(( BUF_TYPE b, PromptObject* result, AsnLen* bytesDecoded, ENV_TYPE env));
AsnLen BEncPromptObjectContent PROTO((BUF_TYPE b, PromptObject* v));

void BDecPromptObjectContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, PromptObject* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintPromptObject PROTO((FILE* f, PromptObject* v, unsigned short int indent));
void FreePromptObject PROTO((PromptObject* v));





extern AsnOid resrep1Oid;
extern AsnOid resrep2Oid;
extern AsnOid accprompt1Oid;
extern AsnOid accdes1Oid;
extern AsnOid acckrb1Oid;
extern AsnOid esperresOid;

#endif /* conditional include of z39_50_externals_e_1995.h */
