/* -----------  iord_ext.h -------------------------------------------*/

/* When using this file with other DBV-OSI II includes, include as follows

#include "sidefs.h"
#include "sitypes.h"
#include "sitypes2.h"
#include "dbvproto.h"
#include "iord_ext.h"
#include "itemordr.h"
*/





/*  Module Name: @(#)iord_ext.h	7.2
    Version: 12/2/96
    Author: 

    Crossnet Stystems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ

    Date of Issue:  

    QA Acceptance:
    Date of Acceptance:

    Description:


*/

#if !defined(IORD_EXT_H)
#define IORD_EXT_H


/* --------------------------------------------------------------------
		C-Definitions for Subito ItemOrder Extensions
---------------------------------------------------------------------- */

typedef enum DbvRequesterGroup {
		RG_UserGroup1		 = 1,
		RG_UserGroup2		 = 2
} DbvRequesterGroup;


typedef enum DbvStatusLevelUser {
		SLU_All 	= 1,
		SLU_Negative 	= 2,
		SLU_None 	= 3
} DbvStatusLevelUser;


typedef enum DbvStatusLevelRequester {
		SLO_All 	= 1,
		SLO_Negative 	= 2,
		SLO_None 	= 3
} DbvStatusLevelRequester;


typedef enum DbvBillingInvoiceType {
		BIT_Single 	= 1,
		BIT_Collective 	= 2
} DbvBillingInvoiceType;


typedef enum DbvAddBillingType {
		ABT_BankInfo 			= 1,
		ABT_CreditCardInfo 		= 2,
		ABT_InvoiceType 		= 3,
		ABT_PrepaidType			= 4,	
		ABT_DepositType			= 5	
} DbvAddBillingType;



/* -----------------------------------------------------------------
   additional requester information 
--------------------------------------------------------------------*/

typedef struct DbvAddRequesterInfo {
DbvRequesterGroup	*peRequesterGroup; 	    /* default RG_UserGroup1 */
DbvVisibleString	 pcRequesterEmailAddress;   /* opt. */
} DbvAddRequesterInfo;


/* -----------------------------------------------------------------
   additional delivery information 
--------------------------------------------------------------------*/


typedef struct DbvAddDeliveryInfo {
DbvStatusLevelUser	 *peStatusLevelUser; 	      /* default SLU_Negative */
DbvStatusLevelRequester  *peStatusLevelOrigin;	      /* default SLO_None */
DbvVisibleString	  pcDeliveryNotes; 	      /* opt. */
DbvVisibleString	  pcCountryDeliveryTarget;    /* opt */ 
DbvBool		 	 *pfAlternativePostalDelivery;/* default FALSE */
} DbvAddDeliveryInfo;


/* -----------------------------------------------------------------
   additional billing information 
--------------------------------------------------------------------*/


typedef struct DbvBillingBankInfo {
DbvVisibleString	 pcBankAccountHouse;		/* mand */
DbvVisibleString	 pcBankAccountRoutingSymbol; 	/* mand */
DbvVisibleString  	 pcBankAccountNo; 		/* mand */
DbvBool		 	 fBankAuthority;
} DbvBillingBankInfo;





typedef struct DbvBillingCreditCardInfo {
DbvVisibleString	pcCardCompany;	 	/* mand */
DbvVisibleString	pcCardNo;		/* mand */
DbvVisibleString	pcCardValidFrom; 	/* opt */
DbvVisibleString	pcCardValidThru;	/* mand */
} DbvBillingCreditCardInfo;


typedef struct DbvAddBillingInfo {
DbvAddBillingType		 eAddBillingType;
union {
	DbvBillingBankInfo		*psBillingBankInfo;
	DbvBillingCreditCardInfo	*psBillingCreditCardInfo; 
	DbvBillingInvoiceType		 eBillingInvoiceType;
	DbvVisibleString		 pcPrepaidId;	
	DbvVisibleString		 pcDepositId;
  } 				uAddBillingInfo;
} DbvAddBillingInfo;


typedef struct DbvSubitoAdditionalInfo {
DbvBool				*pfCustomerInfoToKeep; /* default FALSE */
DbvAddRequesterInfo		*psAddRequesterInfo;
DbvAddDeliveryInfo		*psAddDeliveryInfo;
DbvAddBillingInfo		*psAddBillingInfo;
} DbvSubitoAdditionalInfo;



#endif
