/*
 * asn_real.h
 *
 * MS 92
 * Copyright (C) 1992 Michael Sample and the University of British Columbia
 *
 * This library is free software; you can redistribute it and/or
 * modify it provided that this copyright/license information is retained
 * in original form.
 *
 * If you modify this file, you must clearly indicate your changes.
 *
 * This source code is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 */


/* 

Changes by John Hough (hough@sun001.sil.com) for DBV-OSI II:

A] Catering for OSF architecture
        1) unsigned long -> unsigned int
        2) long -> int
*/


#ifndef _asn_real_h_
#define _asn_real_h_

typedef double AsnReal;

extern AsnReal PLUS_INFINITY;
extern AsnReal MINUS_INFINITY;


void InitAsnInfinity();

AsnLen BEncAsnReal PROTO((BUF_TYPE b, AsnReal* data));

void BDecAsnReal PROTO((BUF_TYPE b, AsnReal* result, AsnLen* bytesDecoded,
                       ENV_TYPE env));

AsnLen BEncAsnRealContent PROTO((BUF_TYPE b, AsnReal* data));

void BDecAsnRealContent PROTO((BUF_TYPE b,
                               AsnTag tag,
                               AsnLen len,
                               AsnReal* result,
                               AsnLen* bytesDecoded,
                               ENV_TYPE env));

/* do nothing */ 
#define FreeAsnReal(v)

void PrintAsnReal PROTO((FILE* f, AsnReal* b, unsigned short int indent));

#endif
