/*  Module Name: @(#)FreeN_DbvFuncs.c	7.2
    Version: 3/3/97
    Author: Dan Maskell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to free space allocated for lists of structure types.
        Used by the origin and target.

    05-02-96 Dan Maskell Added Functions for ILL & Item order stuff
    14-03-96 Dan Maskell Added Functions for Explain support
    26-03-96 Dan Maskell Added Functions for Generic support
*/
#include "testy_calls.h"
#include "Free_DbvFuncs.h"

void FreeN_DbvAttributeElement( DbvAttributeElement **ppsAttributeElement )
   {

   DbvAttributeElement **pps_base;

   if ( ppsAttributeElement == NULL )
      return;

   pps_base = ppsAttributeElement;

   while( *ppsAttributeElement )
      {
      Free_DbvAttributeElement( *ppsAttributeElement );
      ppsAttributeElement++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvAttributeElement() */ 

void FreeN_DbvAttributesPlusTerm( DbvAttributesPlusTerm 
					**ppsAttributesPlusTerm )
   {

   DbvAttributesPlusTerm **pps_base;

   if ( ppsAttributesPlusTerm == NULL )
      return;

   pps_base = ppsAttributesPlusTerm;

   while( *ppsAttributesPlusTerm )
      {
      Free_DbvAttributesPlusTerm( *ppsAttributesPlusTerm );
      ppsAttributesPlusTerm++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvAttributesPlusTerm() */ 

void FreeN_DbvCircRecord( DbvCircRecord **ppsCircRecord )
   {

   DbvCircRecord **pps_base;

   if ( ppsCircRecord == NULL )
      return;

   pps_base = ppsCircRecord;

   while( *ppsCircRecord )
      {
      Free_DbvCircRecord( *ppsCircRecord );
      ppsCircRecord++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvCircRecord() */ 

void FreeN_DbvDiagRec( DbvDiagRec **ppsDiagRec )
   {

   DbvDiagRec **pps_base;

   if ( ppsDiagRec == NULL )
      return;

   pps_base = ppsDiagRec;

   while( *ppsDiagRec )
      {
      Free_DbvDiagRec( *ppsDiagRec );
      ppsDiagRec++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvDiagRec() */ 

void FreeN_DbvElementSetsDbSpecific( DbvElementSetsDbSpecific 
					**ppsElementSetsDbSpecific )
   {

   DbvElementSetsDbSpecific **pps_base;

   if ( ppsElementSetsDbSpecific == NULL )
      return;

   pps_base = ppsElementSetsDbSpecific;

   while( *ppsElementSetsDbSpecific )
      {
      Free_DbvElementSetsDbSpecific( *ppsElementSetsDbSpecific );
      ppsElementSetsDbSpecific++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvElementSetsDbSpecific() */ 

void FreeN_DbvEntry( DbvEntry **ppsEntry )
   {

   DbvEntry **pps_base;

   if ( ppsEntry == NULL )
      return;

   pps_base = ppsEntry;

   while( *ppsEntry )
      {
      Free_DbvEntry( *ppsEntry );
      ppsEntry++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvEntry() */ 

void FreeN_DbvEstimate1( DbvEstimate1 **ppsEstimate1 )
   {

   DbvEstimate1 **pps_base;

   if ( ppsEstimate1 == NULL )
      return;

   pps_base = ppsEstimate1;

   while( *ppsEstimate1 )
      {
      Free_DbvEstimate1( *ppsEstimate1 );
      ppsEstimate1++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvEstimate1() */ 

void FreeN_DbvEstimate2( DbvEstimate2 **ppsEstimate2 )
   {

   DbvEstimate2 **pps_base;

   if ( ppsEstimate2 == NULL )
      return;

   pps_base = ppsEstimate2;

   while( *ppsEstimate2 )
      {
      Free_DbvEstimate2( *ppsEstimate2 );
      ppsEstimate2++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvEstimate2() */ 

void FreeN_DbvFormatSpec( DbvFormatSpec **ppsFormatSpec )
   {

   DbvFormatSpec **pps_base;

   if ( ppsFormatSpec == NULL )
      return;

   pps_base = ppsFormatSpec;

   while( *ppsFormatSpec )
      {
      Free_DbvFormatSpec( *ppsFormatSpec );
      ppsFormatSpec++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvFormatSpec() */ 

void FreeN_DbvHoldingsRecord( DbvHoldingsRecord **ppsHoldingsRecord )
   {

   DbvHoldingsRecord **pps_base;

   if ( ppsHoldingsRecord == NULL )
      return;

   pps_base = ppsHoldingsRecord;

   while( *ppsHoldingsRecord )
      {
      Free_DbvHoldingsRecord( *ppsHoldingsRecord );
      ppsHoldingsRecord++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvHoldingsRecord() */ 

void FreeN_DbvInternationalString( DbvInternationalString 
					**ppsInternationalString )
   {

   DbvInternationalString **pps_base;

   if ( ppsInternationalString == NULL )
      return;

   pps_base = ppsInternationalString;

   while( *ppsInternationalString )
      {
      FreeDbvInternationalString( *ppsInternationalString );
      ppsInternationalString++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvInternationalString() */ 

void FreeN_DbvListStatus( DbvListStatus **ppsListStatus )
   {

   DbvListStatus **pps_base;

   if ( ppsListStatus == NULL )
      return;

   pps_base = ppsListStatus;

   while( *ppsListStatus )
      {
      Free_DbvListStatus( *ppsListStatus );
      ppsListStatus++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvListStatus() */ 

void FreeN_DbvNamePlusRecord( DbvNamePlusRecord **ppsNamePlusRecord )
   {

   DbvNamePlusRecord **pps_base;

   if ( ppsNamePlusRecord == NULL )
      return;

   pps_base = ppsNamePlusRecord;

   while( *ppsNamePlusRecord )
      {
      Free_DbvNamePlusRecord( *ppsNamePlusRecord );
      ppsNamePlusRecord++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvNamePlusRecord() */ 

void FreeN_DbvOccurrenceByDb( DbvOccurrenceByDb **ppsOccurrenceByDb )
   {

   DbvOccurrenceByDb **pps_base;

   if ( ppsOccurrenceByDb == NULL )
      return;

   pps_base = ppsOccurrenceByDb;

   while( *ppsOccurrenceByDb )
      {
      Free_DbvOccurrenceByDb( *ppsOccurrenceByDb );
      ppsOccurrenceByDb++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvOccurrenceByDb() */ 

void FreeN_DbvPermAllowableFunctions( DbvPermAllowableFunctions 
					**ppePermAllowableFunctions )
   {

   DbvPermAllowableFunctions **pps_base;

   if ( ppePermAllowableFunctions == NULL )
      return;

   pps_base = ppePermAllowableFunctions;

   while( *ppePermAllowableFunctions )
      {
      Free_DbvPermAllowableFunctions( *ppePermAllowableFunctions );
      ppePermAllowableFunctions++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvPermAllowableFunctions() */ 

void FreeN_DbvPermissions( DbvPermissions **ppsPermissions )
   {

   DbvPermissions **pps_base;

   if ( ppsPermissions == NULL )
      return;

   pps_base = ppsPermissions;

   while( *ppsPermissions )
      {
      Free_DbvPermissions( *ppsPermissions );
      ppsPermissions++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvPermissions() */ 

void FreeN_DbvRange( DbvRange **ppsRange )
   {

   DbvRange **pps_base;

   if ( ppsRange == NULL )
      return;

   pps_base = ppsRange;

   while( *ppsRange )
      {
      Free_DbvRange( *ppsRange );
      ppsRange++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvRange() */ 

void FreeN_DbvSortKeySpec( DbvSortKeySpec **ppsSortKeySpec )
   {

   DbvSortKeySpec **pps_base;

   if ( ppsSortKeySpec == NULL )
      return;

   pps_base = ppsSortKeySpec;

   while( *ppsSortKeySpec )
      {
      Free_DbvSortKeySpec( *ppsSortKeySpec );
      ppsSortKeySpec++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvSortKeySpec() */ 

void FreeN_DbvStringOrNumeric( DbvStringOrNumeric **ppsStringOrNumeric )
   {

   DbvStringOrNumeric **pps_base;

   if ( ppsStringOrNumeric == NULL )
      return;

   pps_base = ppsStringOrNumeric;

   while( *ppsStringOrNumeric )
      {
      Free_DbvStringOrNumeric( *ppsStringOrNumeric );
      ppsStringOrNumeric++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvStringOrNumeric() */ 

void FreeN_DbvSuppliedRecord( DbvSuppliedRecord **ppsSuppliedRecord )
   {

   DbvSuppliedRecord **pps_base;

   if ( ppsSuppliedRecord == NULL )
      return;

   pps_base = ppsSuppliedRecord;

   while( *ppsSuppliedRecord )
      {
      Free_DbvSuppliedRecord( *ppsSuppliedRecord );
      ppsSuppliedRecord++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvSuppliedRecord() */ 

void FreeN_DbvTaskPackageRecord( DbvTaskPackageRecord **ppsTaskPackageRecord )
   {

   DbvTaskPackageRecord **pps_base;

   if ( ppsTaskPackageRecord == NULL )
      return;

   pps_base = ppsTaskPackageRecord;

   while( *ppsTaskPackageRecord )
      {
      Free_DbvTaskPackageRecord( *ppsTaskPackageRecord );
      ppsTaskPackageRecord++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvTaskPackageRecord() */ 

void FreeN_DbvVolume( DbvVolume **ppsVolume )
   {

   DbvVolume **pps_base;

   if ( ppsVolume == NULL )
      return;

   pps_base = ppsVolume;

   while( *ppsVolume )
      {
      Free_DbvVolume( *ppsVolume );
      ppsVolume++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvVolume() */ 

void FreeN_Ulong( Ulong **ppUlong )
   {

   Ulong **pp_base;

   if ( ppUlong == NULL )
      return;

   pp_base = ppUlong;

   while( *ppUlong )
      {
      Free_Ulong( *ppUlong );
      ppUlong++;
      } /* End while */

   DbvFree( pp_base );
   } /* End FreeN_Ulong() */ 

void FreeN_DbvOtherInformation( DbvOtherInformation **ppsOtherInformation )
   {
 
   DbvOtherInformation **pps_base;
 
   if ( ppsOtherInformation == NULL )
      return;
 
   pps_base = ppsOtherInformation;
 
   while( *ppsOtherInformation )
      {
      FreeDbvOtherInformation( *ppsOtherInformation );
      ppsOtherInformation++;
      } /* End while */
 
   DbvFree( pps_base );
   } /* End FreeN_DbvOtherInformation() */
 
void FreeN_DbvOccurrenceByAttributes(DbvOccurrenceByAttributes 
	**ppsByAttributes )
   {
 
   DbvOccurrenceByAttributes **pps_base;
 
   if ( ppsByAttributes == NULL )
      return;
 
   pps_base = ppsByAttributes;
 
   while( *ppsByAttributes )
      {
      Free_DbvOccurrenceByAttributes( *ppsByAttributes );
      ppsByAttributes++;
      } /* End while */
 
   DbvFree( pps_base );
   } /* End FreeN_DbvOccurrenceByAttributes() */
 
void FreeN_DbvDbSpecificComp(DbvDbSpecificComp **ppsDbSpecific )
   {
 
   DbvDbSpecificComp **pps_base;
 
   if ( ppsDbSpecific == NULL )
      return;
 
   pps_base = ppsDbSpecific;
 
   while( *ppsDbSpecific )
      {
      Free_DbvDbSpecificComp( *ppsDbSpecific );
      ppsDbSpecific++;
      } /* End while */
 
   DbvFree( pps_base );
   } /* End FreeN_DbvDbSpecificComp() */

void FreeN_DbvObjectIdentifier(DbvObjectIdentifier *ppcObjectIdentifier)
   {
 
   DbvObjectIdentifier *ppc_base;
 
   if ( ppcObjectIdentifier == NULL )
      return;
 
   ppc_base = ppcObjectIdentifier;
 
   while( *ppcObjectIdentifier )
      {
      FreeDbvObjectIdentifier( *ppcObjectIdentifier );
      ppcObjectIdentifier++;
      } /* End while */
 
   DbvFree( ppc_base );
   } /* End FreeN_DbvObjectIdentifier() */

/* 5-2-96 The following function where added by Dan Maskell  */

void FreeN_DbvSystemId( DbvSystemId **ppsSystemId )
   {

   DbvSystemId **pps_base;

   if ( ppsSystemId == NULL )
      return;

   pps_base = ppsSystemId;

   while( *ppsSystemId )
      {
      Free_DbvSystemId( *ppsSystemId );
      ppsSystemId++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvSystemId() */ 

void FreeN_DbvElectronicDeliveryService( 
	DbvElectronicDeliveryService **ppsElectronicDeliveryService )
   {

   DbvElectronicDeliveryService **pps_base;

   if ( ppsElectronicDeliveryService == NULL )
      return;

   pps_base = ppsElectronicDeliveryService;

   while( *ppsElectronicDeliveryService )
      {
      Free_DbvElectronicDeliveryService( *ppsElectronicDeliveryService );
      ppsElectronicDeliveryService++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvElectronicDeliveryService() */ 

void FreeN_DbvSupplyMediumInfo( DbvSupplyMediumInfo **ppsSupplyMediumInfo )
   {

   DbvSupplyMediumInfo **pps_base;

   if ( ppsSupplyMediumInfo == NULL )
      return;

   pps_base = ppsSupplyMediumInfo;

   while( *ppsSupplyMediumInfo )
      {
      Free_DbvSupplyMediumInfo( *ppsSupplyMediumInfo );
      ppsSupplyMediumInfo++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvSupplyMediumInfo() */ 

void FreeN_DbvSendToList( DbvSendToList **ppsSendToList )
   {

   DbvSendToList **pps_base;

   if ( ppsSendToList == NULL )
      return;

   pps_base = ppsSendToList;

   while( *ppsSendToList )
      {
      Free_DbvSendToList( *ppsSendToList );
      ppsSendToList++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvSendToList() */ 

void FreeN_DbvExtension( DbvExtension **ppsExtension )
   {

   DbvExtension **pps_base;

   if ( ppsExtension == NULL )
      return;

   pps_base = ppsExtension;

   while( *ppsExtension )
      {
      Free_DbvExtension( *ppsExtension );
      ppsExtension++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvExtension() */ 

void FreeN_DbvServiceType( DbvServiceType **ppsServiceType )
   {

   DbvServiceType **pps_base;

   if ( ppsServiceType == NULL )
      return;

   pps_base = ppsServiceType;

   while( *ppsServiceType )
      {
      Free_DbvServiceType( *ppsServiceType );
      ppsServiceType++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvServiceType() */ 

void FreeN_DbvASN1External( DbvASN1External **ppsASN1External )
   {

   DbvASN1External **pps_base;

   if ( ppsASN1External == NULL )
      return;

   pps_base = ppsASN1External;

   while( *ppsASN1External )
      {
      FreeDbvASN1External( *ppsASN1External );
      ppsASN1External++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvASN1External() */ 


/* Explain Record Support */


void FreeN_DbvHumanString( DbvHumanString **ppsHumanString )
   {
   DbvHumanString **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvHumanString()\n" );
#endif

   if ( ppsHumanString == NULL )
      return;

   pps_base = ppsHumanString;

   while( *ppsHumanString )
      {
      Free_DbvHumanString( *ppsHumanString );
      ppsHumanString++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvHumanString() */ 

void FreeN_DbvIconObject( DbvIconObject **ppsIconObject )
   {
   DbvIconObject **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvIconObject()\n" );
#endif

   if ( ppsIconObject == NULL )
      return;

   pps_base = ppsIconObject;

   while( *ppsIconObject )
      {
      Free_DbvIconObject( *ppsIconObject );
      ppsIconObject++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvIconObject() */ 

void FreeN_DbvDatabaseList( DbvDatabaseList **ppsDatabaseList )
   {
   DbvDatabaseList **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvDatabaseList()\n" );
#endif

   if ( ppsDatabaseList == NULL )
      return;

   pps_base = ppsDatabaseList;

   while( *ppsDatabaseList )
      {
      Free_DbvDatabaseList( *ppsDatabaseList );
      ppsDatabaseList++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvDatabaseList() */ 

void FreeN_DbvNetworkAddress( DbvNetworkAddress **ppsNetworkAddress )
   {
   DbvNetworkAddress **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvNetworkAddress()\n" );
#endif

   if ( ppsNetworkAddress == NULL )
      return;

   pps_base = ppsNetworkAddress;

   while( *ppsNetworkAddress )
      {
      Free_DbvNetworkAddress( *ppsNetworkAddress );
      ppsNetworkAddress++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvNetworkAddress() */ 

void FreeN_DbvOperators( DbvOperators **ppsOperators )
   {
   DbvOperators **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvOperators()\n" );
#endif

   if ( ppsOperators == NULL )
      return;

   pps_base = ppsOperators;

   while( *ppsOperators )
      {
      Free_DbvOperators( *ppsOperators );
      ppsOperators++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvOperators() */ 

void FreeN_DbvSearchKey( DbvSearchKey **ppsSearchKey )
   {
   DbvSearchKey **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvSearchKey()\n" );
#endif

   if ( ppsSearchKey == NULL )
      return;

   pps_base = ppsSearchKey;

   while( *ppsSearchKey )
      {
      Free_DbvSearchKey( *ppsSearchKey );
      ppsSearchKey++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvSearchKey() */ 


void FreeN_DbvHumanStringSeq( DbvHumanStringSeq **ppsDescription )
   {
   DbvHumanStringSeq **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvHumanStringSeq()\n" );
#endif

   if ( ppsDescription == NULL )
      return;

   pps_base = ppsDescription;

   while( *ppsDescription )
      {
      Free_DbvHumanStringSeq( *ppsDescription );
      ppsDescription++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvHumanStringSeq() */ 



void FreeN_DbvUnitType( DbvUnitType **ppsUnitType )
   {
   DbvUnitType **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvUnitType()\n" );
#endif

   if ( ppsUnitType == NULL )
      return;

   pps_base = ppsUnitType;

   while( *ppsUnitType )
      {
      Free_DbvUnitType( *ppsUnitType );
      ppsUnitType++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvUnitType() */ 

void FreeN_DbvUnitsSupported( DbvUnitsSupported **ppsUnitsSupported )
   {
   DbvUnitsSupported **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvUnitsSupported()\n" );
#endif

   if ( ppsUnitsSupported == NULL )
      return;

   pps_base = ppsUnitsSupported;

   while( *ppsUnitsSupported )
      {
      Free_DbvUnitsSupported( *ppsUnitsSupported );
      ppsUnitsSupported++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvUnitsSupported() */ 

void FreeN_DbvQueryTypeDetails( DbvQueryTypeDetails **ppsQueryTypeDetails )
   {
   DbvQueryTypeDetails **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvQueryTypeDetails()\n" );
#endif

   if ( ppsQueryTypeDetails == NULL )
      return;

   pps_base = ppsQueryTypeDetails;

   while( *ppsQueryTypeDetails )
      {
      Free_DbvQueryTypeDetails( *ppsQueryTypeDetails );
      ppsQueryTypeDetails++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvQueryTypeDetails() */ 

void FreeN_DbvOtherCharge( DbvOtherCharge **ppsOtherCharge )
   {
   DbvOtherCharge **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvOtherCharge()\n" );
#endif

   if ( ppsOtherCharge == NULL )
      return;

   pps_base = ppsOtherCharge;

   while( *ppsOtherCharge )
      {
      Free_DbvOtherCharge( *ppsOtherCharge );
      ppsOtherCharge++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvOtherCharge() */ 

void FreeN_DbvElementSetNames( DbvElementSetNames **ppsElementSetNames )
   {
   DbvElementSetNames **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvElementSetNames()\n" );
#endif

   if ( ppsElementSetNames == NULL )
      return;

   pps_base = ppsElementSetNames;

   while( *ppsElementSetNames )
      {
      Free_DbvElementSetNames( *ppsElementSetNames );
      ppsElementSetNames++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvElementSetNames() */ 

void FreeN_DbvAccessRestrictions( 
			DbvAccessRestrictions **ppsAccessRestrictions )
   {
   DbvAccessRestrictions **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvAccessRestrictions()\n" );
#endif

   if ( ppsAccessRestrictions == NULL )
      return;

   pps_base = ppsAccessRestrictions;

   while( *ppsAccessRestrictions )
      {
      Free_DbvAccessRestrictions( *ppsAccessRestrictions );
      ppsAccessRestrictions++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvAccessRestrictions() */ 


void FreeN_DbvTagTypeMapping( DbvTagTypeMapping **ppsTagTypeMapping )
   {
   DbvTagTypeMapping **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvTagTypeMapping()\n" );
#endif

   if ( ppsTagTypeMapping == NULL )
      return;

   pps_base = ppsTagTypeMapping;

   while( *ppsTagTypeMapping )
      {
      Free_DbvTagTypeMapping( *ppsTagTypeMapping );
      ppsTagTypeMapping++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvTagTypeMapping() */ 

void FreeN_DbvPath( DbvPath **ppsPath )
   {
   DbvPath **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvPath()\n" );
#endif

   if ( ppsPath == NULL )
      return;

   pps_base = ppsPath;

   while( *ppsPath )
      {
      Free_DbvPath( *ppsPath );
      ppsPath++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvPath() */ 

void FreeN_DbvPathA( DbvPathA **ppsPathA )
   {
   DbvPathA **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvPathA()\n" );
#endif

   if ( ppsPathA == NULL )
      return;

   pps_base = ppsPathA;

   while( *ppsPathA )
      {
      Free_DbvPathA( *ppsPathA );
      ppsPathA++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvPathA() */ 

void FreeN_DbvElementInfo( DbvElementInfo **ppsElementInfo )
   {
   DbvElementInfo **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvElementInfo()\n" );
#endif

   if ( ppsElementInfo == NULL )
      return;

   pps_base = ppsElementInfo;

   while( *ppsElementInfo )
      {
      Free_DbvElementInfo( *ppsElementInfo );
      ppsElementInfo++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvElementInfo() */ 

void FreeN_DbvElements( DbvElements **ppsElements )
   {
   DbvElements **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvElements()\n" );
#endif

   if ( ppsElements == NULL )
      return;

   pps_base = ppsElements;

   while( *ppsElements )
      {
      Free_DbvElements( *ppsElements );
      ppsElements++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvElements() */ 

void FreeN_DbvAttributeDescription( 
		DbvAttributeDescription **ppsAttributeDescription )
   {
   DbvAttributeDescription **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvAttributeDescription()\n" );
#endif

   if ( ppsAttributeDescription == NULL )
      return;

   pps_base = ppsAttributeDescription;

   while( *ppsAttributeDescription )
      {
      Free_DbvAttributeDescription( *ppsAttributeDescription );
      ppsAttributeDescription++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvAttributeDescription() */ 

void FreeN_DbvAttributeType( DbvAttributeType **ppsAttributeType )
   {
   DbvAttributeType **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvAttributeType()\n" );
#endif

   if ( ppsAttributeType == NULL )
      return;

   pps_base = ppsAttributeType;

   while( *ppsAttributeType )
      {
      Free_DbvAttributeType( *ppsAttributeType );
      ppsAttributeType++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvAttributeType() */ 

void FreeN_DbvTermList( DbvTermList **ppsTermList )
   {
   DbvTermList **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvTermList()\n" );
#endif

   if ( ppsTermList == NULL )
      return;

   pps_base = ppsTermList;

   while( *ppsTermList )
      {
      Free_DbvTermList( *ppsTermList );
      ppsTermList++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvTermList() */ 

void FreeN_DbvValueDescription( DbvValueDescription **ppsValueDescription )
   {
   DbvValueDescription **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvValueDescription()\n" );
#endif

   if ( ppsValueDescription == NULL )
      return;

   pps_base = ppsValueDescription;

   while( *ppsValueDescription )
      {
      Free_DbvValueDescription( *ppsValueDescription );
      ppsValueDescription++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvValueDescription() */ 

void FreeN_DbvAttributeValues( DbvAttributeValues **ppsAttributeValues )
   {
   DbvAttributeValues **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvAttributeValues()\n" );
#endif

   if ( ppsAttributeValues == NULL )
      return;

   pps_base = ppsAttributeValues;

   while( *ppsAttributeValues )
      {
      Free_DbvAttributeValues( *ppsAttributeValues );
      ppsAttributeValues++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvAttributeValues() */ 

void FreeN_DbvAttributesByType( DbvAttributesByType **ppsAttributesByType )
   {
   DbvAttributesByType **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvAttributesByType()\n" );
#endif

   if ( ppsAttributesByType == NULL )
      return;

   pps_base = ppsAttributesByType;

   while( *ppsAttributesByType )
      {
      Free_DbvAttributesByType( *ppsAttributesByType );
      ppsAttributesByType++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvAttributesByType() */ 

void FreeN_DbvAttributesBySet( DbvAttributesBySet **ppsAttributesBySet )
   {
   DbvAttributesBySet **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvAttributesBySet()\n" );
#endif

   if ( ppsAttributesBySet == NULL )
      return;

   pps_base = ppsAttributesBySet;

   while( *ppsAttributesBySet )
      {
      Free_DbvAttributesBySet( *ppsAttributesBySet );
      ppsAttributesBySet++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvAttributesBySet() */ 

void FreeN_DbvAttributeDetails( DbvAttributeDetails **ppsAttributeDetails )
   {
   DbvAttributeDetails **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvAttributeDetails()\n" );
#endif

   if ( ppsAttributeDetails == NULL )
      return;

   pps_base = ppsAttributeDetails;

   while( *ppsAttributeDetails )
      {
      Free_DbvAttributeDetails( *ppsAttributeDetails );
      ppsAttributeDetails++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvAttributeDetails() */ 

void FreeN_DbvTerm( DbvTerm **ppsTerm )
   {
   DbvTerm **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvTerm()\n" );
#endif

   if ( ppsTerm == NULL )
      return;

   pps_base = ppsTerm;

   while( *ppsTerm )
      {
      Free_DbvTerm( *ppsTerm );
      ppsTerm++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvTerm() */ 

void FreeN_DbvDetailsPerElement( DbvDetailsPerElement **ppsDetailsPerElement )
   {
   DbvDetailsPerElement **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvDetailsPerElement()\n" );
#endif

   if ( ppsDetailsPerElement == NULL )
      return;

   pps_base = ppsDetailsPerElement;

   while( *ppsDetailsPerElement )
      {
      Free_DbvDetailsPerElement( *ppsDetailsPerElement );
      ppsDetailsPerElement++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvDetailsPerElement() */ 

void FreeN_DbvSortKeys( DbvSortKeys **ppsSortKeys )
   {
   DbvSortKeys **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvSortKeys()\n" );
#endif

   if ( ppsSortKeys == NULL )
      return;

   pps_base = ppsSortKeys;

   while( *ppsSortKeys )
      {
      Free_DbvSortKeys( *ppsSortKeys );
      ppsSortKeys++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvSortKeys() */ 

void FreeN_DbvVariantTypes( DbvVariantTypes **ppsVariantTypes )
   {
   DbvVariantTypes **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvVariantTypes()\n" );
#endif

   if ( ppsVariantTypes == NULL )
      return;

   pps_base = ppsVariantTypes;

   while( *ppsVariantTypes )
      {
      Free_DbvVariantTypes( *ppsVariantTypes );
      ppsVariantTypes++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvVariantTypes() */ 

void FreeN_DbvVariantClass( DbvVariantClass **ppsVariantClass )
   {
   DbvVariantClass **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvVariantClass()\n" );
#endif

   if ( ppsVariantClass == NULL )
      return;

   pps_base = ppsVariantClass;

   while( *ppsVariantClass )
      {
      Free_DbvVariantClass( *ppsVariantClass );
      ppsVariantClass++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvVariantClass() */ 

void FreeN_DbvUnits( DbvUnits **ppsUnits )
   {
   DbvUnits **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvUnits()\n" );
#endif

   if ( ppsUnits == NULL )
      return;

   pps_base = ppsUnits;

   while( *ppsUnits )
      {
      Free_DbvUnits( *ppsUnits );
      ppsUnits++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvUnits() */ 

void FreeN_DbvUnit( DbvUnit **ppsUnit )
   {
   DbvUnit **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvUnit()\n" );
#endif

   if ( ppsUnit == NULL )
      return;

   pps_base = ppsUnit;

   while( *ppsUnit )
      {
      Free_DbvUnit( *ppsUnit );
      ppsUnit++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvUnit() */ 

void FreeN_DbvCategoryInfo( DbvCategoryInfo **ppsCategoryInfo )
   {
   DbvCategoryInfo **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvCategoryInfo()\n" );
#endif

   if ( ppsCategoryInfo == NULL )
      return;

   pps_base = ppsCategoryInfo;

   while( *ppsCategoryInfo )
      {
      Free_DbvCategoryInfo( *ppsCategoryInfo );
      ppsCategoryInfo++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvCategoryInfo() */ 

void FreeN_DbvAttributeOccurrence( 
			DbvAttributeOccurrence **ppsAttributeOccurrence )
   {
   DbvAttributeOccurrence **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvAttributeOccurrence()\n" );
#endif

   if ( ppsAttributeOccurrence == NULL )
      return;

   pps_base = ppsAttributeOccurrence;

   while( *ppsAttributeOccurrence )
      {
      Free_DbvAttributeOccurrence( *ppsAttributeOccurrence );
      ppsAttributeOccurrence++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvAttributeOccurrence() */ 

void FreeN_DbvAttributeCombination( 
		DbvAttributeCombination **ppsAttributeCombination )
   {
   DbvAttributeCombination **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvAttributeCombination()\n" );
#endif

   if ( ppsAttributeCombination == NULL )
      return;

   pps_base = ppsAttributeCombination;

   while( *ppsAttributeCombination )
      {
      Free_DbvAttributeCombination( *ppsAttributeCombination );
      ppsAttributeCombination++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvAttributeCombination() */ 

void FreeN_DbvAttributeCombinations( 
			DbvAttributeCombinations **ppsAttributeCombinations )
   {
   DbvAttributeCombinations **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvAttributeCombinations()\n" );
#endif

   if ( ppsAttributeCombinations == NULL )
      return;

   pps_base = ppsAttributeCombinations;

   while( *ppsAttributeCombinations )
      {
      Free_DbvAttributeCombinations( *ppsAttributeCombinations );
      ppsAttributeCombinations++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvAttributeCombinations() */ 

void FreeN_DbvSpecification( DbvSpecification **ppsSpecification )
   {
   DbvSpecification **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvSpecification()\n" );
#endif

   if ( ppsSpecification == NULL )
      return;

   pps_base = ppsSpecification;

   while( *ppsSpecification )
      {
      Free_DbvSpecification( *ppsSpecification );
      ppsSpecification++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvSpecification() */ 


#ifdef NOT_YET_IMPLEMENTED

/* Generic Record Support */

void FreeN_DbvValue( DbvValue **ppsValue )
   {
   DbvValue **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvValue()\n" );
#endif

   if ( ppsValue == NULL )
      return;

   pps_base = ppsValue;

   while( *ppsValue )
      {
      Free_DbvValue( *ppsValue );
      ppsValue++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvValue() */ 



void FreeN_DbvTriples( DbvTriples **ppsTriples )
   {
   DbvTriples **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvTriples()\n" );
#endif

   if ( ppsTriples == NULL )
      return;

   pps_base = ppsTriples;

   while( *ppsTriples )
      {
      Free_DbvTriples( *ppsTriples );
      ppsTriples++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvTriples() */ 



void FreeN_DbvTagPath( DbvTagPath **ppsTagPath )
   {
   DbvTagPath **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvTagPath()\n" );
#endif

   if ( ppsTagPath == NULL )
      return;

   pps_base = ppsTagPath;

   while( *ppsTagPath )
      {
      Free_DbvTagPath( *ppsTagPath );
      ppsTagPath++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvTagPath() */ 

void FreeN_DbvTaggedElement( DbvTaggedElement **ppsTaggedElement )
   {
   DbvTaggedElement **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvTaggedElement()\n" );
#endif

   if ( ppsTaggedElement == NULL )
      return;

   pps_base = ppsTaggedElement;

   while( *ppsTaggedElement )
      {
      Free_DbvTaggedElement( *ppsTaggedElement );
      ppsTaggedElement++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvTaggedElement() */ 



void FreeN_DbvVariant( DbvVariant **ppsVariant )
   {
   DbvVariant **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvVariant()\n" );
#endif

   if ( ppsVariant == NULL )
      return;

   pps_base = ppsVariant;

   while( *ppsVariant )
      {
      Free_DbvVariant( *ppsVariant );
      ppsVariant++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvVariant() */ 

void FreeN_DbvHits( DbvHits **ppsHits )
   {
   DbvHits **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvHits()\n" );
#endif

   if ( ppsHits == NULL )
      return;

   pps_base = ppsHits;

   while( *ppsHits )
      {
      Free_DbvHits( *ppsHits );
      ppsHits++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvHits() */ 


#endif 



void FreeN_DbvDataBaseInfoSeq( DbvDataBaseInfoSeq **ppsDbvDataBaseInfoSeq )
   {
   DbvDataBaseInfoSeq **pps_base;

#ifdef DEBUG
   printf( "D - FreeN_DbvDataBaseInfoSeq()\n" );
#endif

   if ( ppsDbvDataBaseInfoSeq == NULL )
      return;

   pps_base = ppsDbvDataBaseInfoSeq;

   while( *ppsDbvDataBaseInfoSeq )
      {
      Free_DbvDataBaseInfoSeq( *ppsDbvDataBaseInfoSeq );
      ppsDbvDataBaseInfoSeq++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvDataBaseInfoSeq() */ 




/*******************************************************/
/* Access, Resource and Trigger Control */


void FreeN_DbvChallenge( DbvChallenge **ppsChallenge )
   {
   DbvChallenge **pps_base;

   if ( ppsChallenge == NULL )
      return;

   pps_base = ppsChallenge;

   while( *ppsChallenge )
      {
      Free_DbvChallenge( *ppsChallenge );
      ppsChallenge++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvChallenge() */



void FreeN_DbvResponse( DbvResponse **ppsResponse )
   {
   DbvResponse **pps_base;

   if ( ppsResponse == NULL )
      return;

   pps_base = ppsResponse;

   while( *ppsResponse )
      {
      Free_DbvResponse( *ppsResponse );
      ppsResponse++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvResponse() */



/* ---------------------------------------------------------------------*/
/* ---- User Info Format "Character Set And Language Negotiation" ----- */

void FreeN_DbvInitialSet( DbvInitialSet **ppsInitialSet )
   {
   DbvInitialSet **pps_base;

   if ( ppsInitialSet == NULL )
      return;

   pps_base = ppsInitialSet;

   while( *ppsInitialSet )
      {
      Free_DbvInitialSet( *ppsInitialSet );
      ppsInitialSet++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvInitialSet() */



void FreeN_DbvLanguageCode( DbvLanguageCode **ppsLanguageCode )
   {
   DbvLanguageCode **pps_base;

   if ( ppsLanguageCode == NULL )
      return;

   pps_base = ppsLanguageCode;

   while( *ppsLanguageCode )
      {
      Free_DbvLanguageCode( *ppsLanguageCode );
      ppsLanguageCode++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvLanguageCode() */



void FreeN_DbvProposedCharSet( DbvProposedCharSet **ppsProposedCharSet )
   {
   DbvProposedCharSet **pps_base;

   if ( ppsProposedCharSet == NULL )
      return;

   pps_base = ppsProposedCharSet;

   while( *ppsProposedCharSet )
      {
      Free_DbvProposedCharSet( *ppsProposedCharSet );
      ppsProposedCharSet++;
      } /* End while */

   DbvFree( pps_base );
   } /* End FreeN_DbvProposedCharSet() */




