
/*  Module Name: @(#)apifree.h	7.1
    Version: 11/15/96
    Author: Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Routines to free DBV PDU structures
 
        Used by the origin and target.
 
*/
 
 
#ifndef API_FREE_H
#define API_FREE_H

#include "sidefs.h"
#include "sitypes.h"
#include "sitypes2.h"
#include "dbvproto.h"

/* Function headers */

void FreeDbvOriginData(DbvOriginData *psOriginData);
void FreeDbvTargetData(DbvTargetData *psTargetData);
void FreeDbvInitializeRsp(DbvInitializeRsp *psInitializeRsp);
void FreeDbvInitializeReq(DbvInitializeReq *psInitializeReq);
void FreeDbvOctetString(DbvOctetString *psOctetString);
void Free_compulsory_DbvOctetString(DbvOctetString *psOctetString);
void FreeDbvProtocolVersion(DbvProtocolVersion pcProtocolVersion);
void FreeDbvOptions(DbvOptions pcOptions);
void FreeDbvInternationalString(DbvInternationalString *psInternationalString);
void FreeDbvObjectIdentifier(DbvObjectIdentifier pcObjectIdentifier);
void FreeDbvOtherInformation(DbvOtherInformation *psOtherInformation);
void FreeDbvInfoCategory(DbvInfoCategory *psInfoCategory);
void FreeDbvIdPassword(DbvIdPassword *psIdPassword);
void FreeDbvAuthentication(DbvAuthentication *psAuthentication);

#endif
