/*  Module Name: @(#)batch.h	7.1
    Version: 11/15/96
    Author: Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Routines to process the origin and target batch files.

*/

#ifndef BATCH_H
#define BATCH_H

#include "testy_calls.h"

/* Function Prototypes */
DbvBool batch_ParseUtilityEntries(char *pcEntry);
void batch_CheckFile(char *pcFilename);
void batch_ExecuteUtility(char *,char *);

/* Joint */
int batch_ExecDbvAbortRequest(char *pcFilename);
int batch_ExecDbvCloseRequest(char *pcFilename);
int batch_ExecDbvCloseResponse(char *pcFilename);

/* Utility Functions */
int batch_ExecSIGetEventLocation(char *pcFilename);
int batch_ExecSISetACSEFile(char *pcFilename);
int batch_ExecSIWhichStack(char *pcFilename);
int batch_ExecSISetTraceParameter(char *pcFilename);

typedef struct BatchFunctions {
        char Name[32];
        int (*function)(char *);
} BatchFunctions;

#define NO_ORIGIN_FUNCTIONS	19
#define NO_TARGET_FUNCTIONS  	20	
#define NO_UTILITY_FUNCTIONS	4

extern BatchFunctions psUtilityFunctions[NO_UTILITY_FUNCTIONS];


#endif

