/*  Module Name: @(#)config.h	7.1
    Version: 11/15/96
    Author: Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
	Routines to configure the origin and target.
 
        Used by the origin and target.
 
*/

#ifndef CONFIG_H
#define CONFIG_H

#include "testy_calls.h"

#define ORIGIN_CONFIG_FILE		"./configure"
#define ORIGIN_WORKINGDIRECTORY_DEFAULT	"../origin_scripts"
#define ORIGIN_ASSOCOUTPUTTO_DEFAULT 	"./Association_Results"
#define ORIGIN_COMPSTRUCTURESTO_DEFAULT	"./Completed_Origin_PDUs"
#define ORIGIN_UTILITYOUTPUTTO_DEFAULT	"./Utility_Results"
#define ORIGIN_RECEIVEDPDUSTO_DEFAULT	"./Received_Origin_PDUs"

#define TARGET_CONFIG_FILE		"./configure"
#define TARGET_WORKINGDIRECTORY_DEFAULT	"../target_scripts"
#define TARGET_ASSOCOUTPUTTO_DEFAULT 	"./Association_Results"
#define TARGET_COMPSTRUCTURESTO_DEFAULT	"./Completed_Target_PDUs"
#define TARGET_UTILITYOUTPUTTO_DEFAULT	"./Utility_Results"
#define TARGET_RECEIVEDPDUSTO_DEFAULT	"./Received_Target_PDUs"

typedef enum TTMode {
	Menu = 0,
	Batch = 1
} TTMode;

DbvBool config_OriginConfigure(void);
DbvBool config_GetBatchFile(void);
void config_GetMode(void);
void config_OriginGetWorkingDir(void);
void config_OriginGetAssocOutput(void);
void config_OriginGetCompletedStructures(void);
void config_OriginGetUtilityOutput(void);
void config_OriginGetReceivedPDUs(void);
void config_OriginGetDefaults(void);

DbvBool config_TargetConfigure(void);
void config_TargetGetWorkingDir(void);
void config_TargetGetAssocOutput(void);
void config_TargetGetCompletedStructures(void);
void config_TargetGetUtilityOutput(void);
void config_TargetGetReceivedPDUs(void);
void config_TargetGetDefaults(void);

char *config_SearchForEntry(char *pcEntry);
char *config_GetStringField(TBL psInTable);
char *config_GetCharField(TBL psInTable);

void config_OriginQuit(void);
void config_TargetQuit(void);

#endif
