/*  Module Name: @(#)conv_DbvFuncs1.c	7.1
    Version: 11/15/96
    Author: Dan Maskell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
	Functions to convert enumerated types between enum and string format
        Used by the origin and target.
 
    12-04-96 	D.B.Maskell	Created to support DbvSubitoAdditionalInfo
				as part of Ill
*/


#include "convert_DbvFuncs.h"


void convert_DbvRequesterGroup(char **text, DbvRequesterGroup *peRequesterGroup)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("RG_UserGroup1", *text) == 0)
         *peRequesterGroup = RG_UserGroup1;
      else
      if(strcmp("RG_UserGroup2", *text) == 0)
         *peRequesterGroup = RG_UserGroup2;
      else
         printf("Warning: DbvRequesterGroup string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peRequesterGroup == RG_UserGroup1)
         strcpy(temp, "RG_UserGroup1");

      if( *peRequesterGroup == RG_UserGroup2)
         strcpy(temp, "RG_UserGroup2");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvRequesterGroup enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvRequesterGroup() */

void convert_DbvStatusLevelUser(char **text, 
				DbvStatusLevelUser *peStatusLevelUser)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("SLU_All", *text) == 0)
         *peStatusLevelUser = SLU_All;
      else
      if(strcmp("SLU_Negative", *text) == 0)
         *peStatusLevelUser = SLU_Negative;
      else
      if(strcmp("SLU_None", *text) == 0)
         *peStatusLevelUser = SLU_None;
      else
         printf("Warning: DbvStatusLevelUser string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peStatusLevelUser == SLU_All)
         strcpy(temp, "SLU_All");

      if( *peStatusLevelUser == SLU_Negative)
         strcpy(temp, "SLU_Negative");

      if( *peStatusLevelUser == SLU_None)
         strcpy(temp, "SLU_None");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvStatusLevelUser enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvStatusLevelUser() */

void convert_DbvStatusLevelRequester(char **text, DbvStatusLevelRequester *peStatusLevelOrigin)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("SLO_All", *text) == 0)
         *peStatusLevelOrigin = SLO_All;
      else
      if(strcmp("SLO_Negative", *text) == 0)
         *peStatusLevelOrigin = SLO_Negative;
      else
      if(strcmp("SLO_None", *text) == 0)
         *peStatusLevelOrigin = SLO_None;
      else
         printf("Warning: DbvStatusLevelRequester string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peStatusLevelOrigin == SLO_All)
         strcpy(temp, "SLO_All");

      if( *peStatusLevelOrigin == SLO_Negative)
         strcpy(temp, "SLO_Negative");

      if( *peStatusLevelOrigin == SLO_None)
         strcpy(temp, "SLO_None");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvStatusLevelRequester enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvStatusLevelRequester() */

void convert_DbvBillingInvoiceType(char **text, 
				DbvBillingInvoiceType *peBillingInvoiceType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("BIT_Single", *text) == 0)
         *peBillingInvoiceType = BIT_Single;
      else
      if(strcmp("BIT_Collective", *text) == 0)
         *peBillingInvoiceType = BIT_Collective;
      else
         printf("Warning: DbvBillingInvoiceType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peBillingInvoiceType == BIT_Single)
         strcpy(temp, "BIT_Single");

      if( *peBillingInvoiceType == BIT_Collective)
         strcpy(temp, "BIT_Collective");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvBillingInvoiceType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvBillingInvoiceType() */

void convert_DbvAddBillingType(char **text, 
					DbvAddBillingType *peAddBillingType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("ABT_BankInfo", *text) == 0)
         *peAddBillingType = ABT_BankInfo;
      else
      if(strcmp("ABT_CreditCardInfo", *text) == 0)
         *peAddBillingType = ABT_CreditCardInfo;
      else
      if(strcmp("ABT_InvoiceType", *text) == 0)
         *peAddBillingType = ABT_InvoiceType;
      else
      if(strcmp("ABT_PrepaidType", *text) == 0)
         *peAddBillingType = ABT_PrepaidType;
      else
      if(strcmp("ABT_DepositType", *text) == 0)
         *peAddBillingType = ABT_DepositType;

      else
         printf("Warning: DbvAddBillingType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peAddBillingType == ABT_BankInfo)
         strcpy(temp, "ABT_BankInfo");

      if( *peAddBillingType == ABT_CreditCardInfo)
         strcpy(temp, "ABT_CreditCardInfo");

      if( *peAddBillingType == ABT_InvoiceType)
         strcpy(temp, "ABT_InvoiceType");

      if( *peAddBillingType == ABT_PrepaidType)
         strcpy(temp, "ABT_PrepaidType");

      if( *peAddBillingType == ABT_DepositType)
         strcpy(temp, "ABT_DepositType");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvAddBillingType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvAddBillingType() */

