/*  Module Name: @(#)conv_DbvFuncs2.c	7.1
    Version: 11/15/96
    Author: Dan Maskell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
	Functions to convert enumerated types between enum and string format
        Used by the origin and target.
 
*/


#include "convert_DbvFuncs.h"


void convert_DbvExplainRecordType(char **text, 
			DbvExplainRecordType *peExplainRecordType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("ERT_TargetInfo", *text) == 0)
         *peExplainRecordType = ERT_TargetInfo;
      else
      if(strcmp("ERT_DatabaseInfo", *text) == 0)
         *peExplainRecordType = ERT_DatabaseInfo;
      else
      if(strcmp("ERT_SchemaInfo", *text) == 0)
         *peExplainRecordType = ERT_SchemaInfo;
      else
      if(strcmp("ERT_TagSetInfo", *text) == 0)
         *peExplainRecordType = ERT_TagSetInfo;
      else
      if(strcmp("ERT_RecordSyntaxInfo", *text) == 0)
         *peExplainRecordType = ERT_RecordSyntaxInfo;
      else
      if(strcmp("ERT_AttributeSetInfo", *text) == 0)
         *peExplainRecordType = ERT_AttributeSetInfo;
      else
      if(strcmp("ERT_TermListInfo", *text) == 0)
         *peExplainRecordType = ERT_TermListInfo;
      else
      if(strcmp("ERT_ExtendedServicesInfo", *text) == 0)
         *peExplainRecordType = ERT_ExtendedServicesInfo;
      else
      if(strcmp("ERT_AttributeDetails", *text) == 0)
         *peExplainRecordType = ERT_AttributeDetails;
      else
      if(strcmp("ERT_TermListDetails", *text) == 0)
         *peExplainRecordType = ERT_TermListDetails;
      else
      if(strcmp("ERT_ElementSetDetails", *text) == 0)
         *peExplainRecordType = ERT_ElementSetDetails;
      else
      if(strcmp("ERT_RetrievalRecordDetails", *text) == 0)
         *peExplainRecordType = ERT_RetrievalRecordDetails;
      else
      if(strcmp("ERT_SortDetails", *text) == 0)
         *peExplainRecordType = ERT_SortDetails;
      else
      if(strcmp("ERT_Processing", *text) == 0)
         *peExplainRecordType = ERT_Processing;
      else
      if(strcmp("ERT_Variants", *text) == 0)
         *peExplainRecordType = ERT_Variants;
      else
      if(strcmp("ERT_Units", *text) == 0)
         *peExplainRecordType = ERT_Units;
      else
      if(strcmp("ERT_CategoryList", *text) == 0)
         *peExplainRecordType = ERT_CategoryList;
      else
      if(strcmp("ERT_Invalid", *text) == 0)
         *peExplainRecordType = ERT_Invalid;
      else
         printf("Warning: DbvExplainRecordType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peExplainRecordType == ERT_TargetInfo )
         strcpy(temp, "ERT_TargetInfo");

      if( *peExplainRecordType == ERT_DatabaseInfo)
         strcpy(temp, "ERT_DatabaseInfo");

      if( *peExplainRecordType == ERT_SchemaInfo)
         strcpy(temp, "ERT_SchemaInfo");

      if( *peExplainRecordType == ERT_TagSetInfo)
         strcpy(temp, "ERT_TagSetInfo");

      if( *peExplainRecordType == ERT_RecordSyntaxInfo)
         strcpy(temp, "ERT_RecordSyntaxInfo");

      if( *peExplainRecordType == ERT_AttributeSetInfo)
         strcpy(temp, "ERT_AttributeSetInfo");

      if( *peExplainRecordType == ERT_TermListInfo)
         strcpy(temp, "ERT_TermListInfo");

      if( *peExplainRecordType == ERT_ExtendedServicesInfo)
         strcpy(temp, "ERT_ExtendedServicesInfo");

      if( *peExplainRecordType == ERT_AttributeDetails)
         strcpy(temp, "ERT_AttributeDetails");

      if( *peExplainRecordType == ERT_TermListDetails)
         strcpy(temp, "ERT_TermListDetails");

      if( *peExplainRecordType == ERT_ElementSetDetails)
         strcpy(temp, "ERT_ElementSetDetails");

      if( *peExplainRecordType == ERT_RetrievalRecordDetails)
         strcpy(temp, "ERT_RetrievalRecordDetails");

      if( *peExplainRecordType == ERT_SortDetails)
         strcpy(temp, "ERT_SortDetails");

      if( *peExplainRecordType == ERT_Processing)
         strcpy(temp, "ERT_Processing");

      if( *peExplainRecordType == ERT_Variants)
         strcpy(temp, "ERT_Variants");

      if( *peExplainRecordType == ERT_Units)
         strcpy(temp, "ERT_Units");

      if( *peExplainRecordType == ERT_CategoryList)
         strcpy(temp, "ERT_CategoryList");

      if( *peExplainRecordType == ERT_Invalid)
         strcpy(temp, "ERT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvExplainRecordType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvExplainRecordType() */

void convert_DbvBodyTypeType(char **text, DbvBodyTypeType *peBodyTypeType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("BTT_IanaType", *text) == 0)
         *peBodyTypeType = BTT_IanaType;
      else
      if(strcmp("BTT_Z3950Type", *text) == 0)
         *peBodyTypeType = BTT_Z3950Type;
      else
      if(strcmp("BTT_OtherType", *text) == 0)
         *peBodyTypeType = BTT_OtherType;
      else
      if(strcmp("BTT_Invalid", *text) == 0)
         *peBodyTypeType = BTT_Invalid;
      else
         printf("Warning: DbvBodyTypeType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peBodyTypeType == BTT_IanaType)
         strcpy(temp, "BTT_IanaType");

      if( *peBodyTypeType == BTT_Z3950Type)
         strcpy(temp, "BTT_Z3950Type");

      if( *peBodyTypeType == BTT_OtherType)
         strcpy(temp, "BTT_OtherType");

      if( *peBodyTypeType == BTT_Invalid)
         strcpy(temp, "BTT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvBodyTypeType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvBodyTypeType() */

void convert_DbvNetworkAddressType(char **text, 
				DbvNetworkAddressType *peNetworkAddressType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("NAT_InternetAddress", *text) == 0)
         *peNetworkAddressType = NAT_InternetAddress;
      else
      if(strcmp("NAT_OsiPresentationAddress", *text) == 0)
         *peNetworkAddressType = NAT_OsiPresentationAddress;
      else
      if(strcmp("NAT_OtherAddress", *text) == 0)
         *peNetworkAddressType = NAT_OtherAddress;
      else
      if(strcmp("NAT_Invalid", *text) == 0)
         *peNetworkAddressType = NAT_Invalid;
      else
         printf("Warning: DbvNetworkAddressType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peNetworkAddressType == NAT_InternetAddress)
         strcpy(temp, "NAT_InternetAddress");

      if( *peNetworkAddressType == NAT_OsiPresentationAddress)
         strcpy(temp, "NAT_OsiPresentationAddress");

      if( *peNetworkAddressType == NAT_OtherAddress)
         strcpy(temp, "NAT_OtherAddress");

      if( *peNetworkAddressType == NAT_Invalid)
         strcpy(temp, "NAT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvNetworkAddressType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvNetworkAddressType() */

void convert_DbvQueryTypeDetailsType(char **text, 
			DbvQueryTypeDetailsType *peQueryTypeDetailsType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("QTDT_Private", *text) == 0)
         *peQueryTypeDetailsType = QTDT_Private;
      else
      if(strcmp("QTDT_Rpn", *text) == 0)
         *peQueryTypeDetailsType = QTDT_Rpn;
      else
      if(strcmp("QTDT_Iso8777", *text) == 0)
         *peQueryTypeDetailsType = QTDT_Iso8777;
      else
      if(strcmp("QTDT_Z39_58", *text) == 0)
         *peQueryTypeDetailsType = QTDT_Z39_58;
      else
      if(strcmp("QTDT_Erpn", *text) == 0)
         *peQueryTypeDetailsType = QTDT_Erpn;
      else
      if(strcmp("QTDT_RankedList", *text) == 0)
         *peQueryTypeDetailsType = QTDT_RankedList;
      else
      if(strcmp("QTDT_Invalid", *text) == 0)
         *peQueryTypeDetailsType = QTDT_Invalid;
      else
         printf("Warning: DbvQueryTypeDetailsType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peQueryTypeDetailsType == QTDT_Private)
         strcpy(temp, "QTDT_Private");

      if( *peQueryTypeDetailsType == QTDT_Rpn)
         strcpy(temp, "QTDT_Rpn");

      if( *peQueryTypeDetailsType == QTDT_Iso8777)
         strcpy(temp, "QTDT_Iso8777");

      if( *peQueryTypeDetailsType == QTDT_Z39_58)
         strcpy(temp, "QTDT_Z39_58");

      if( *peQueryTypeDetailsType == QTDT_Erpn)
         strcpy(temp, "QTDT_Erpn");

      if( *peQueryTypeDetailsType == QTDT_RankedList)
         strcpy(temp, "QTDT_RankedList");

      if( *peQueryTypeDetailsType == QTDT_Invalid)
         strcpy(temp, "QTDT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvQueryTypeDetailsType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvQueryTypeDetailsType() */

void convert_DbvUnitsSupportedType(char **text, 
				DbvUnitsSupportedType *peUnitsSupportedType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("UST_Known", *text) == 0)
         *peUnitsSupportedType = UST_Known;
      else
      if(strcmp("UST_Private", *text) == 0)
         *peUnitsSupportedType = UST_Private;
      else
      if(strcmp("UST_Invalid", *text) == 0)
         *peUnitsSupportedType = UST_Invalid;
      else
         printf("Warning: DbvUnitsSupportedType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peUnitsSupportedType == UST_Known)
         strcpy(temp, "UST_Known");

      if( *peUnitsSupportedType == UST_Private)
         strcpy(temp, "UST_Private");

      if( *peUnitsSupportedType == UST_Invalid)
         strcpy(temp, "UST_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvUnitsSupportedType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvUnitsSupportedType() */

void convert_DbvAccessType(char **text, DbvAccessType *peAccessType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("AT_Any", *text) == 0)
         *peAccessType = AT_Any;
      else
      if(strcmp("AT_Search", *text) == 0)
         *peAccessType = AT_Search;
      else
      if(strcmp("AT_Present", *text) == 0)
         *peAccessType = AT_Present;
      else
      if(strcmp("AT_SpecificElements", *text) == 0)
         *peAccessType = AT_SpecificElements;
      else
      if(strcmp("AT_ExtendedServices", *text) == 0)
         *peAccessType = AT_ExtendedServices;
      else
      if(strcmp("AT_ByDatabase", *text) == 0)
         *peAccessType = AT_ByDatabase;
      else
      if(strcmp("AT_Invalid", *text) == 0)
         *peAccessType = AT_Invalid;
      else
         printf("Warning: DbvAccessType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peAccessType == AT_Any)
         strcpy(temp, "AT_Any");

      if( *peAccessType == AT_Search)
         strcpy(temp, "AT_Search");

      if( *peAccessType == AT_Present)
         strcpy(temp, "AT_Present");

      if( *peAccessType == AT_SpecificElements)
         strcpy(temp, "AT_SpecificElements");

      if( *peAccessType == AT_ExtendedServices)
         strcpy(temp, "AT_ExtendedServices");

      if( *peAccessType == AT_ByDatabase)
         strcpy(temp, "AT_ByDatabase");

      if( *peAccessType == AT_Invalid)
         strcpy(temp, "AT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvAccessType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvAccessType() */

void convert_DbvRecordCountType(char **text, 
				DbvRecordCountType *peRecordCountType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("RCT_ActualNumber", *text) == 0)
         *peRecordCountType = RCT_ActualNumber;
      else
      if(strcmp("RCT_ApproxNumber", *text) == 0)
         *peRecordCountType = RCT_ApproxNumber;
      else
      if(strcmp("RCT_Invalid", *text) == 0)
         *peRecordCountType = RCT_Invalid;
      else
         printf("Warning: DbvRecordCountType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peRecordCountType == RCT_ActualNumber)
         strcpy(temp, "RCT_ActualNumber");

      if( *peRecordCountType == RCT_ApproxNumber)
         strcpy(temp, "RCT_ApproxNumber");

      if( *peRecordCountType == RCT_Invalid)
         strcpy(temp, "RCT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvRecordCountType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvRecordCountType() */

void convert_DbvElementDataTypeType(char **text, 
				DbvElementDataTypeType *peElementDataTypeType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("EDTT_Primitive", *text) == 0)
         *peElementDataTypeType = EDTT_Primitive;
      else
      if(strcmp("EDTT_Structured", *text) == 0)
         *peElementDataTypeType = EDTT_Structured;
      else
      if(strcmp("EDTT_Invalid", *text) == 0)
         *peElementDataTypeType = EDTT_Invalid;
      else
         printf("Warning: DbvElementDataTypeType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peElementDataTypeType == EDTT_Primitive)
         strcpy(temp, "EDTT_Primitive");

      if( *peElementDataTypeType == EDTT_Structured)
         strcpy(temp, "EDTT_Structured");

      if( *peElementDataTypeType == EDTT_Invalid)
         strcpy(temp, "EDTT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvElementDataTypeType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvElementDataTypeType() */

void convert_DbvPrimitiveDataType(char **text, 
				DbvPrimitiveDataType *pePrimitiveDataType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("PDT_OctetString", *text) == 0)
         *pePrimitiveDataType = PDT_OctetString;
      else
      if(strcmp("PDT_Numeric", *text) == 0)
         *pePrimitiveDataType = PDT_Numeric;
      else
      if(strcmp("PDT_Date", *text) == 0)
         *pePrimitiveDataType = PDT_Date;
      else
      if(strcmp("PDT_External", *text) == 0)
         *pePrimitiveDataType = PDT_External;
      else
      if(strcmp("PDT_String", *text) == 0)
         *pePrimitiveDataType = PDT_String;
      else
      if(strcmp("PDT_TrueOrFalse", *text) == 0)
         *pePrimitiveDataType = PDT_TrueOrFalse;
      else
      if(strcmp("PDT_Oid", *text) == 0)
         *pePrimitiveDataType = PDT_Oid;
      else
      if(strcmp("PDT_IntUnit", *text) == 0)
         *pePrimitiveDataType = PDT_IntUnit;
      else
      if(strcmp("PDT_Empty", *text) == 0)
         *pePrimitiveDataType = PDT_Empty;
      else
      if(strcmp("PDT_NoneOfTheAbove", *text) == 0)
         *pePrimitiveDataType = PDT_NoneOfTheAbove;
      else
      if(strcmp("PDT_Invalid", *text) == 0)
         *pePrimitiveDataType = PDT_Invalid;
      else
         printf("Warning: DbvPrimitiveDataType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *pePrimitiveDataType == PDT_OctetString)
         strcpy(temp, "PDT_OctetString");

      if( *pePrimitiveDataType == PDT_Numeric)
         strcpy(temp, "PDT_Numeric");

      if( *pePrimitiveDataType == PDT_Date)
         strcpy(temp, "PDT_Date");

      if( *pePrimitiveDataType == PDT_External)
         strcpy(temp, "PDT_External");

      if( *pePrimitiveDataType == PDT_String)
         strcpy(temp, "PDT_String");

      if( *pePrimitiveDataType == PDT_TrueOrFalse)
         strcpy(temp, "PDT_TrueOrFalse");

      if( *pePrimitiveDataType == PDT_Oid)
         strcpy(temp, "PDT_Oid");

      if( *pePrimitiveDataType == PDT_IntUnit)
         strcpy(temp, "PDT_IntUnit");

      if( *pePrimitiveDataType == PDT_Empty)
         strcpy(temp, "PDT_Empty");

      if( *pePrimitiveDataType == PDT_NoneOfTheAbove)
         strcpy(temp, "PDT_NoneOfTheAbove");

      if( *pePrimitiveDataType == PDT_Invalid)
         strcpy(temp, "PDT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvPrimitiveDataType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvPrimitiveDataType() */

void convert_DbvSearchCost(char **text, DbvSearchCost *peSearchCost)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("SC_Optimized", *text) == 0)
         *peSearchCost = SC_Optimized;
      else
      if(strcmp("SC_Normal", *text) == 0)
         *peSearchCost = SC_Normal;
      else
      if(strcmp("SC_Expensive", *text) == 0)
         *peSearchCost = SC_Expensive;
      else
      if(strcmp("SC_Filter", *text) == 0)
         *peSearchCost = SC_Filter;
      else
      if(strcmp("SC_Invalid", *text) == 0)
         *peSearchCost = SC_Invalid;
      else
         printf("Warning: DbvSearchCost string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peSearchCost == SC_Optimized)
         strcpy(temp, "SC_Optimized");

      if( *peSearchCost == SC_Normal)
         strcpy(temp, "SC_Normal");

      if( *peSearchCost == SC_Expensive)
         strcpy(temp, "SC_Expensive");

      if( *peSearchCost == SC_Filter)
         strcpy(temp, "SC_Filter");

      if( *peSearchCost == SC_Invalid)
         strcpy(temp, "SC_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvSearchCost enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvSearchCost() */

void convert_DbvExtendedServicesInfoInt(char **text, 
			DbvExtendedServicesInfoInt *peExtendedServicesInfoInt)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("ESII_WaitSupported", *text) == 0)
         *peExtendedServicesInfoInt = ESII_WaitSupported;
      else
      if(strcmp("ESII_WaitAlways", *text) == 0)
         *peExtendedServicesInfoInt = ESII_WaitAlways;
      else
      if(strcmp("ESII_WaitNotSupported", *text) == 0)
         *peExtendedServicesInfoInt = ESII_WaitNotSupported;
      else
      if(strcmp("ESII_Depends", *text) == 0)
         *peExtendedServicesInfoInt = ESII_Depends;
      else
      if(strcmp("ESII_NotSaying", *text) == 0)
         *peExtendedServicesInfoInt = ESII_NotSaying;
      else
      if(strcmp("ESII_Invalid", *text) == 0)
         *peExtendedServicesInfoInt = ESII_Invalid;
      else
         printf("Warning: DbvExtendedServicesInfoInt string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peExtendedServicesInfoInt == ESII_WaitSupported)
         strcpy(temp, "ESII_WaitSupported");

      if( *peExtendedServicesInfoInt == ESII_WaitAlways)
         strcpy(temp, "ESII_WaitAlways");

      if( *peExtendedServicesInfoInt == ESII_WaitNotSupported)
         strcpy(temp, "ESII_WaitNotSupported");

      if( *peExtendedServicesInfoInt == ESII_Depends)
         strcpy(temp, "ESII_Depends");

      if( *peExtendedServicesInfoInt == ESII_NotSaying)
         strcpy(temp, "ESII_NotSaying");

      if( *peExtendedServicesInfoInt == ESII_Invalid)
         strcpy(temp, "ESII_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvExtendedServicesInfoInt enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvExtendedServicesInfoInt() */

void convert_DbvSortTypeType(char **text, DbvSortTypeType *peSortTypeType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("STT_Character", *text) == 0)
         *peSortTypeType = STT_Character;
      else
      if(strcmp("STT_Numeric", *text) == 0)
         *peSortTypeType = STT_Numeric;
      else
      if(strcmp("STT_Structured", *text) == 0)
         *peSortTypeType = STT_Structured;
      else
      if(strcmp("STT_Invalid", *text) == 0)
         *peSortTypeType = STT_Invalid;
      else
         printf("Warning: DbvSortTypeType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peSortTypeType == STT_Character)
         strcpy(temp, "STT_Character");

      if( *peSortTypeType == STT_Numeric)
         strcpy(temp, "STT_Numeric");

      if( *peSortTypeType == STT_Structured)
         strcpy(temp, "STT_Structured");

      if( *peSortTypeType == STT_Invalid)
         strcpy(temp, "STT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvSortTypeType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvSortTypeType() */

void convert_DbvCaseSensitivity(char **text, 
			DbvCaseSensitivity *peCaseSensitivity)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("CSE_Always", *text) == 0)
         *peCaseSensitivity = CSE_Always;
      else
      if(strcmp("CSE_Never", *text) == 0)
         *peCaseSensitivity = CSE_Never;
      else
      if(strcmp("CSE_DefaultYes", *text) == 0)
         *peCaseSensitivity = CSE_DefaultYes;
      else
      if(strcmp("CSE_DefaultNo", *text) == 0)
         *peCaseSensitivity = CSE_DefaultNo;
      else
      if(strcmp("CSE_Invalid", *text) == 0)
         *peCaseSensitivity = CSE_Invalid;
      else
         printf("Warning: DbvCaseSensitivity string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peCaseSensitivity == CSE_Always)
         strcpy(temp, "CSE_Always");

      if( *peCaseSensitivity == CSE_Never)
         strcpy(temp, "CSE_Never");

      if( *peCaseSensitivity == CSE_DefaultYes)
         strcpy(temp, "CSE_DefaultYes");

      if( *peCaseSensitivity == CSE_DefaultNo)
         strcpy(temp, "CSE_DefaultNo");

      if( *peCaseSensitivity == CSE_Invalid)
         strcpy(temp, "CSE_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvCaseSensitivity enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvCaseSensitivity() */

void convert_DbvProcessingContext(char **text, 
				DbvProcessingContext *peProcessingContext)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("PC_Access", *text) == 0)
         *peProcessingContext = PC_Access;
      else
      if(strcmp("PC_Search", *text) == 0)
         *peProcessingContext = PC_Search;
      else
      if(strcmp("PC_Retrieval", *text) == 0)
         *peProcessingContext = PC_Retrieval;
      else
      if(strcmp("PC_RecordPresentation", *text) == 0)
         *peProcessingContext = PC_RecordPresentation;
      else
      if(strcmp("PC_RecordHandling", *text) == 0)
         *peProcessingContext = PC_RecordHandling;
      else
      if(strcmp("PC_Invalid", *text) == 0)
         *peProcessingContext = PC_Invalid;
      else
         printf("Warning: DbvProcessingContext string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peProcessingContext == PC_Access)
         strcpy(temp, "PC_Access");

      if( *peProcessingContext == PC_Search)
         strcpy(temp, "PC_Search");

      if( *peProcessingContext == PC_Retrieval)
         strcpy(temp, "PC_Retrieval");

      if( *peProcessingContext == PC_RecordPresentation)
         strcpy(temp, "PC_RecordPresentation");

      if( *peProcessingContext == PC_RecordHandling)
         strcpy(temp, "PC_RecordHandling");

      if( *peProcessingContext == PC_Invalid)
         strcpy(temp, "PC_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvProcessingContext enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvProcessingContext() */

void convert_DbvValueSetType(char **text, DbvValueSetType *peValueSetType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("VT_Range", *text) == 0)
         *peValueSetType = VT_Range;
      else
      if(strcmp("VT_Enumerated", *text) == 0)
         *peValueSetType = VT_Enumerated;
      else
      if(strcmp("VT_Invalid", *text) == 0)
         *peValueSetType = VT_Invalid;
      else
         printf("Warning: DbvValueSetType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peValueSetType == VT_Range)
         strcpy(temp, "VT_Range");

      if( *peValueSetType == VT_Enumerated)
         strcpy(temp, "VT_Enumerated");

      if( *peValueSetType == VT_Invalid)
         strcpy(temp, "VT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvValueSetType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvValueSetType() */

void convert_DbvValueDescriptionType(char **text, 
			DbvValueDescriptionType *peValueDescriptionType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("VDT_Integer", *text) == 0)
         *peValueDescriptionType = VDT_Integer;
      else
      if(strcmp("VDT_String", *text) == 0)
         *peValueDescriptionType = VDT_String;
      else
      if(strcmp("VDT_Octets", *text) == 0)
         *peValueDescriptionType = VDT_Octets;
      else
      if(strcmp("VDT_Oid", *text) == 0)
         *peValueDescriptionType = VDT_Oid;
      else
      if(strcmp("VDT_Unit", *text) == 0)
         *peValueDescriptionType = VDT_Unit;
      else
      if(strcmp("VDT_ValueAndUnit", *text) == 0)
         *peValueDescriptionType = VDT_ValueAndUnit;
      else
      if(strcmp("VDT_Invalid", *text) == 0)
         *peValueDescriptionType = VDT_Invalid;
      else
         printf("Warning: DbvValueDescriptionType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peValueDescriptionType == VDT_Integer)
         strcpy(temp, "VDT_Integer");

      if( *peValueDescriptionType == VDT_String)
         strcpy(temp, "VDT_String");

      if( *peValueDescriptionType == VDT_Octets)
         strcpy(temp, "VDT_Octets");

      if( *peValueDescriptionType == VDT_Oid)
         strcpy(temp, "VDT_Oid");

      if( *peValueDescriptionType == VDT_Unit)
         strcpy(temp, "VDT_Unit");

      if( *peValueDescriptionType == VDT_ValueAndUnit)
         strcpy(temp, "VDT_ValueAndUnit");

      if( *peValueDescriptionType == VDT_Invalid)
         strcpy(temp, "VDT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvValueDescriptionType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvValueDescriptionType() */

void convert_DbvAttributeOccurrenceChoiceType(char **text, 
	DbvAttributeOccurrenceChoiceType *peAttributeOccurrenceChoiceType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("AOT_AnyOrNone", *text) == 0)
         *peAttributeOccurrenceChoiceType = AOT_AnyOrNone;
      else
      if(strcmp("AOT_Specific", *text) == 0)
         *peAttributeOccurrenceChoiceType = AOT_Specific;
      else
      if(strcmp("AOT_Invalid", *text) == 0)
         *peAttributeOccurrenceChoiceType = AOT_Invalid;
      else
         printf("Warning: DbvAttributeOccurrenceChoiceType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peAttributeOccurrenceChoiceType == AOT_AnyOrNone)
         strcpy(temp, "AOT_AnyOrNone");

      if( *peAttributeOccurrenceChoiceType == AOT_Specific)
         strcpy(temp, "AOT_Specific");

      if( *peAttributeOccurrenceChoiceType == AOT_Invalid)
         strcpy(temp, "AOT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvAttributeOccurrenceChoiceType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvAttributeOccurrenceChoiceType() */


