/*  Module Name: @(#)conv_DbvFuncs3.c	7.1
    Version: 11/15/96
    Author: Dan Maskell
 
    Crossnet Systems Lrd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
	Functions to convert enumerated types between enum and string format
        Used by the origin and target.
 
*/

#include "convert_DbvFuncs.h"


#ifdef NOT_YET_IMPLEMENTED

void convert_DbvElementDataGType(char **text, DbvElementDataGType *peElementDataGType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("EDT_Octets", *text) == 0)
         *peElementDataGType = EDT_Octets;
      else
      if(strcmp("EDT_Numeric", *text) == 0)
         *peElementDataGType = EDT_Numeric;
      else
      if(strcmp("EDT_Date", *text) == 0)
         *peElementDataGType = EDT_Date;
      else
      if(strcmp("EDT_Ext", *text) == 0)
         *peElementDataGType = EDT_Ext;
      else
      if(strcmp("EDT_String", *text) == 0)
         *peElementDataGType = EDT_String;
      else
      if(strcmp("EDT_TrueOrFalse", *text) == 0)
         *peElementDataGType = EDT_TrueOrFalse;
      else
      if(strcmp("EDT_Oid", *text) == 0)
         *peElementDataGType = EDT_Oid;
      else
      if(strcmp("EDT_IntUnit", *text) == 0)
         *peElementDataGType = EDT_IntUnit;
      else
      if(strcmp("EDT_ElementNotThere", *text) == 0)
         *peElementDataGType = EDT_ElementNotThere;
      else
      if(strcmp("EDT_ElementEmpty", *text) == 0)
         *peElementDataGType = EDT_ElementEmpty;
      else
      if(strcmp("EDT_NoDataRequested", *text) == 0)
         *peElementDataGType = EDT_NoDataRequested;
      else
      if(strcmp("EDT_Diagnostic", *text) == 0)
         *peElementDataGType = EDT_Diagnostic;
      else
      if(strcmp("EDT_Subtree", *text) == 0)
         *peElementDataGType = EDT_Subtree;
      else
      if(strcmp("EDT_Invalid", *text) == 0)
         *peElementDataGType = EDT_Invalid;
      else
         printf("Warning: DbvElementDataGType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peElementDataGType == EDT_Octets )
         strcpy(temp, "EDT_Octets");

      if( *peElementDataGType == EDT_Numeric)
         strcpy(temp, "EDT_Numeric");

      if( *peElementDataGType == EDT_Date)
         strcpy(temp, "EDT_Date");

      if( *peElementDataGType == EDT_Ext)
         strcpy(temp, "EDT_Ext");

      if( *peElementDataGType == EDT_String)
         strcpy(temp, "EDT_String");

      if( *peElementDataGType == EDT_TrueOrFalse)
         strcpy(temp, "EDT_TrueOrFalse");

      if( *peElementDataGType == EDT_Oid)
         strcpy(temp, "EDT_Oid");

      if( *peElementDataGType == EDT_IntUnit)
         strcpy(temp, "EDT_IntUnit");

      if( *peElementDataGType == EDT_ElementNotThere)
         strcpy(temp, "EDT_ElementNotThere");

      if( *peElementDataGType == EDT_ElementEmpty)
         strcpy(temp, "EDT_ElementEmpty");

      if( *peElementDataGType == EDT_NoDataRequested)
         strcpy(temp, "EDT_NoDataRequested");

      if( *peElementDataGType == EDT_Diagnostic)
         strcpy(temp, "EDT_Diagnostic");

      if( *peElementDataGType == EDT_Subtree)
         strcpy(temp, "EDT_Subtree");

      if( *peElementDataGType == EDT_Invalid)
         strcpy(temp, "EDT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvElementDataGType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvElementDataGType() */

void convert_DbvUsageIntType(char **text, DbvUsageIntType *peUsageIntType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("UIT_Redistributable", *text) == 0)
         *peUsageIntType = UIT_Redistributable;
      else
      if(strcmp("UIT_Restricted", *text) == 0)
         *peUsageIntType = UIT_Restricted;
      else
      if(strcmp("UIT_LicensePointer", *text) == 0)
         *peUsageIntType = UIT_LicensePointer;
      else
      if(strcmp("UIT_Invalid", *text) == 0)
         *peUsageIntType = UIT_Invalid;
      else
         printf("Warning: DbvUsageIntType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peUsageIntType == UIT_Redistributable)
         strcpy(temp, "UIT_Redistributable");

      if( *peUsageIntType == UIT_Restricted)
         strcpy(temp, "UIT_Restricted");

      if( *peUsageIntType == UIT_LicensePointer)
         strcpy(temp, "UIT_LicensePointer");

      if( *peUsageIntType == UIT_Invalid)
         strcpy(temp, "UIT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvUsageIntType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvUsageIntType() */

void convert_DbvVariantValueType(char **text, 
				DbvVariantValueType *peVariantValueType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("VVT_Int", *text) == 0)
         *peVariantValueType = VVT_Int;
      else
      if(strcmp("VVT_InternationalString", *text) == 0)
         *peVariantValueType = VVT_InternationalString;
      else
      if(strcmp("VVT_Octs", *text) == 0)
         *peVariantValueType = VVT_Octs;
      else
      if(strcmp("VVT_Oid", *text) == 0)
         *peVariantValueType = VVT_Oid;
      else
      if(strcmp("VVT_Bool", *text) == 0)
         *peVariantValueType = VVT_Bool;
      else
      if(strcmp("VVT_Null", *text) == 0)
         *peVariantValueType = VVT_Null;
      else
      if(strcmp("VVT_Unit", *text) == 0)
         *peVariantValueType = VVT_Unit;
      else
      if(strcmp("VVT_ValueAndUnit", *text) == 0)
         *peVariantValueType = VVT_ValueAndUnit;
      else
      if(strcmp("VVT_Invalid", *text) == 0)
         *peVariantValueType = VVT_Invalid;
      else
         printf("Warning: DbvVariantValueType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peVariantValueType == VVT_Int)
         strcpy(temp, "VVT_Int");

      if( *peVariantValueType == VVT_InternationalString)
         strcpy(temp, "VVT_InternationalString");

      if( *peVariantValueType == VVT_Octs)
         strcpy(temp, "VVT_Octs");

      if( *peVariantValueType == VVT_Oid)
         strcpy(temp, "VVT_Oid");

      if( *peVariantValueType == VVT_Bool)
         strcpy(temp, "VVT_Bool");

      if( *peVariantValueType == VVT_Null)
         strcpy(temp, "VVT_Null");

      if( *peVariantValueType == VVT_Unit)
         strcpy(temp, "VVT_Unit");

      if( *peVariantValueType == VVT_ValueAndUnit)
         strcpy(temp, "VVT_ValueAndUnit");

      if( *peVariantValueType == VVT_Invalid)
         strcpy(temp, "VVT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvVariantValueType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvVariantValueType() */

#endif
