/*  Module Name: @(#)conv_DbvFuncs4.c	7.1
    Version: 11/15/96
    Author: John Hough
 
    Crossnet Systems Lrd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
	Functions to convert enumerated types between enum and string format
        Used by the origin and target.
 
*/

#include "convert_DbvFuncs.h"



void convert_DbvPromptObjectType(char **text, DbvPromptObjectType *pePromptObjectType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("POT_Challenge", *text) == 0)
         *pePromptObjectType = POT_Challenge;
      else
      if(strcmp("POT_Response", *text) == 0)
         *pePromptObjectType = POT_Response;
      else
      if(strcmp("POT_Invalid", *text) == 0)
         *pePromptObjectType = POT_Invalid;
      else
         printf("Warning: DbvPromptObjectType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *pePromptObjectType == POT_Challenge )
         strcpy(temp, "POT_Challenge");

      if( *pePromptObjectType == POT_Response)
         strcpy(temp, "POT_Response");

      if( *pePromptObjectType == POT_Invalid)
         strcpy(temp, "POT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvPromptObjectType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvPromptObjectType() */



void convert_DbvEPromptIdType(char **text, DbvEPromptIdType *peEPromptIdType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("EPIT_GroupId", *text) == 0)
         *peEPromptIdType = EPIT_GroupId;
      else
      if(strcmp("EPIT_UserId", *text) == 0)
         *peEPromptIdType = EPIT_UserId;
      else
      if(strcmp("EPIT_Password", *text) == 0)
         *peEPromptIdType = EPIT_Password;
      else
      if(strcmp("EPIT_NewPassword", *text) == 0)
         *peEPromptIdType = EPIT_NewPassword;
      else
      if(strcmp("EPIT_Copyright", *text) == 0)
         *peEPromptIdType = EPIT_Copyright;
      else
      if(strcmp("EPIT_SessionId", *text) == 0)
         *peEPromptIdType = EPIT_SessionId;
      else
      if(strcmp("EPIT_Invalid", *text) == 0)
         *peEPromptIdType = EPIT_Invalid;
      else
         printf("Warning: DbvEPromptIdType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peEPromptIdType == EPIT_GroupId )
         strcpy(temp, "EPIT_GroupId");

      if( *peEPromptIdType == EPIT_UserId)
         strcpy(temp, "EPIT_UserId");

      if( *peEPromptIdType == EPIT_Password )
         strcpy(temp, "EPIT_Password");

      if( *peEPromptIdType == EPIT_NewPassword)
         strcpy(temp, "EPIT_NewPassword");

      if( *peEPromptIdType == EPIT_Copyright)
         strcpy(temp, "EPIT_Copyright");

      if( *peEPromptIdType == EPIT_SessionId)
         strcpy(temp, "EPIT_SessionId");

      if( *peEPromptIdType == EPIT_Invalid)
         strcpy(temp, "EPIT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvEPromptIdType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvEPromptIdType() */



void convert_DbvRequestedAction(char **text, DbvRequestedAction *peRequestedAction)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("RA_ResourceReport1", *text) == 0)
         *peRequestedAction = RA_ResourceReport1;
      else
      if(strcmp("RA_ResourceControl", *text) == 0)
         *peRequestedAction = RA_ResourceControl;
      else
      if(strcmp("RA_Cancel", *text) == 0)
         *peRequestedAction = RA_Cancel;
      else
      if(strcmp("RA_Invalid", *text) == 0)
         *peRequestedAction = RA_Invalid;
      else
         printf("Warning: DbvRequestedAction string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peRequestedAction == RA_ResourceReport1 )
         strcpy(temp, "RA_ResourceReport1");

      if( *peRequestedAction == RA_ResourceControl)
         strcpy(temp, "RA_ResourceControl");

      if( *peRequestedAction == RA_Cancel )
         strcpy(temp, "RA_Cancel");

      if( *peRequestedAction == RA_Invalid)
         strcpy(temp, "RA_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvRequestedAction enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvRequestedAction() */



void convert_DbvSecurityChallengeType(char **text, DbvSecurityChallengeType *peSecurityChallengeType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("SECT_SimpleForm", *text) == 0)
         *peSecurityChallengeType = SECT_SimpleForm;
      else
      if(strcmp("SECT_ExternallyDefined", *text) == 0)
         *peSecurityChallengeType = SECT_ExternallyDefined;
      else
      if(strcmp("SECT_Invalid", *text) == 0)
         *peSecurityChallengeType = SECT_Invalid;
      else
         printf("Warning: DbvSecurityChallengeType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peSecurityChallengeType == SECT_SimpleForm )
         strcpy(temp, "SECT_SimpleForm");

      if( *peSecurityChallengeType == SECT_ExternallyDefined)
         strcpy(temp, "SECT_ExternallyDefined");

      if( *peSecurityChallengeType == SECT_Invalid )
         strcpy(temp, "SECT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvSecurityChallengeType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvSecurityChallengeType() */



void convert_DbvPromptInfoType(char **text, DbvPromptInfoType *pePromptInfoType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("PIIT_Character", *text) == 0)
         *pePromptInfoType = PIIT_Character;
      else
      if(strcmp("PIIT_Encrypted", *text) == 0)
         *pePromptInfoType = PIIT_Encrypted;
      else
      if(strcmp("PIIT_Invalid", *text) == 0)
         *pePromptInfoType = PIIT_Invalid;
      else
         printf("Warning: DbvPromptInfoType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *pePromptInfoType == PIIT_Character )
         strcpy(temp, "PIIT_Character");

      if( *pePromptInfoType == PIIT_Encrypted)
         strcpy(temp, "PIIT_Encrypted");

      if( *pePromptInfoType == PIIT_Invalid )
         strcpy(temp, "PIIT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvPromptInfoType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvPromptInfoType() */





void convert_DbvDataType(char **text, DbvDataType *peDataType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("DTTT_Integer", *text) == 0)
         *peDataType = DTTT_Integer;
      else
      if(strcmp("DTTT_Date1", *text) == 0)
         *peDataType = DTTT_Date1;
      else
      if(strcmp("DTTT_Float", *text) == 0)
         *peDataType = DTTT_Float;
      else
      if(strcmp("DTTT_AlphaNumeric", *text) == 0)
         *peDataType = DTTT_AlphaNumeric;
      else
      if(strcmp("DTTT_UrlUrn", *text) == 0)
         *peDataType = DTTT_UrlUrn;
      else
      if(strcmp("DTTT_Boolean", *text) == 0)
         *peDataType = DTTT_Boolean;
      else
      if(strcmp("DTTT_Invalid", *text) == 0)
         *peDataType = DTTT_Invalid;
      else
         printf("Warning: DbvDataType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peDataType == DTTT_Integer )
         strcpy(temp, "DTTT_Integer");

      if( *peDataType == DTTT_Date1)
         strcpy(temp, "DTTT_Date1");

      if( *peDataType == DTTT_Float )
         strcpy(temp, "DTTT_Float");

      if( *peDataType == DTTT_AlphaNumeric )
         strcpy(temp, "DTTT_AlphaNumeric");

      if( *peDataType == DTTT_UrlUrn )
         strcpy(temp, "DTTT_UrlUrn");

      if( *peDataType == DTTT_Boolean )
         strcpy(temp, "DTTT_Boolean");

      if( *peDataType == DTTT_Invalid )
         strcpy(temp, "DTTT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvDataType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvDataType() */



void convert_DbvResponseType(char **text, DbvResponseType *peResponseType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("RT_String", *text) == 0)
         *peResponseType = RT_String;
      else
      if(strcmp("RT_Accept", *text) == 0)
         *peResponseType = RT_Accept;
      else
      if(strcmp("RT_Acknowledge", *text) == 0)
         *peResponseType = RT_Acknowledge;
      else
      if(strcmp("RT_Diagnostic", *text) == 0)
         *peResponseType = RT_Diagnostic;
      else
      if(strcmp("RT_Encrypted", *text) == 0)
         *peResponseType = RT_Encrypted;
      else
      if(strcmp("RT_Invalid", *text) == 0)
         *peResponseType = RT_Invalid;
      else
         printf("Warning: DbvResponseType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peResponseType == RT_String )
         strcpy(temp, "RT_String");

      if( *peResponseType == RT_Accept)
         strcpy(temp, "RT_Accept");

      if( *peResponseType == RT_Acknowledge )
         strcpy(temp, "RT_Acknowledge");

      if( *peResponseType == RT_Diagnostic )
         strcpy(temp, "RT_Diagnostic");

      if( *peResponseType == RT_Encrypted )
         strcpy(temp, "RT_Encrypted");

      if( *peResponseType == RT_Invalid )
         strcpy(temp, "RT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvResponseType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvResponseType() */



void convert_DbvPromptIdType(char **text, DbvPromptIdType *pePromptIdType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("PIT_EnumeratedPrompt", *text) == 0)
         *pePromptIdType = PIT_EnumeratedPrompt;
      else
      if(strcmp("PIT_NoneEnumeratedPrompt", *text) == 0)
         *pePromptIdType = PIT_NoneEnumeratedPrompt;
      else
      if(strcmp("PIT_Invalid", *text) == 0)
         *pePromptIdType = PIT_Invalid;
      else
         printf("Warning: DbvPromptIdType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *pePromptIdType == PIT_EnumeratedPrompt )
         strcpy(temp, "PIT_EnumeratedPrompt");

      if( *pePromptIdType == PIT_NoneEnumeratedPrompt)
         strcpy(temp, "PIT_NoneEnumeratedPrompt");

      if( *pePromptIdType == PIT_Invalid )
         strcpy(temp, "PIT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvPromptIdType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvPromptIdType() */



void convert_DbvPartialResultsAvailable(char **text, DbvPartialResultsAvailable *pePartialResultsAvailable)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("PRA_Subset", *text) == 0)
         *pePartialResultsAvailable = PRA_Subset;
      else
      if(strcmp("PRA_Interim2", *text) == 0)
         *pePartialResultsAvailable = PRA_Interim2;
      else
      if(strcmp("PRA_None2", *text) == 0)
         *pePartialResultsAvailable = PRA_None2;
      else
      if(strcmp("PRA_Invalid", *text) == 0)
         *pePartialResultsAvailable = PRA_Invalid;
      else
         printf("Warning: DbvPartialResultsAvailable string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *pePartialResultsAvailable == PRA_Subset )
         strcpy(temp, "PRA_Subset");

      if( *pePartialResultsAvailable == PRA_Interim2)
         strcpy(temp, "PRA_Interim2");

      if( *pePartialResultsAvailable == PRA_None2 )
         strcpy(temp, "PRA_None2");

      if( *pePartialResultsAvailable == PRA_Invalid )
         strcpy(temp, "PRA_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvPartialResultsAvailable enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvPartialResultsAvailable() */






