/*  Module Name: @(#)
    Version: 
    Author: Dan Maskell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to convert enumerated types between enum and string format
	Used by the origin and target.

*/

#include "convert_DbvFuncs.h"

/*+-----------------------------------------------+*/
/*! convert_DbvSelectedCharSetType                !*/ 
/*+-----------------------------------------------+*/
void convert_DbvSelectedCharSetType( char **text, DbvSelectedCharSetType *DbvSelectedCharSetType )
   {
   int length;
   char temp[ SML_BUFFER ];
   if ( *text != NULL )
      {
      if ( strcmp( "SCST_Iso2022", *text) == 0 )
         *DbvSelectedCharSetType = SCST_Iso2022;
      else
      if ( strcmp( "SCST_Iso10646", *text) == 0 )
         *DbvSelectedCharSetType = SCST_Iso10646;
      else
      if ( strcmp( "SCST_Private", *text) == 0 )
         *DbvSelectedCharSetType = SCST_Private;
      else
      if ( strcmp( "SCST_None", *text) == 0 )
         *DbvSelectedCharSetType = SCST_None;
      else
      if ( strcmp( "SCST_Invalid", *text) == 0 )
         *DbvSelectedCharSetType = SCST_Invalid;
      else
        printf( "Warning: DbvSelectedCharSetType could not be converted\n" );
      } /* End if */
   else
      {
      temp[ 0 ] = '\0';
      if ( *DbvSelectedCharSetType == SCST_Iso2022 )
         strcpy( temp, "SCST_Iso2022" );
      
      if ( *DbvSelectedCharSetType == SCST_Iso10646 )
         strcpy( temp, "SCST_Iso10646" );
      
      if ( *DbvSelectedCharSetType == SCST_Private )
         strcpy( temp, "SCST_Private" );
      
      if ( *DbvSelectedCharSetType == SCST_None )
         strcpy( temp, "SCST_None" );
      
      if ( *DbvSelectedCharSetType == SCST_Invalid )
         strcpy( temp, "SCST_Invalid" );
      
      length = strlen( temp );
      if( length )
         {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
         } /* End if */
      else
         printf( "Warning: DbvSelectedCharSetType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvSelectedCharSetType() */
 
/*+-----------------------------------------------+*/
/*! convert_DbvPrivateCharacterSetType            !*/ 
/*+-----------------------------------------------+*/
void convert_DbvPrivateCharacterSetType( char **text, DbvPrivateCharacterSetType *DbvPrivateCharacterSetType )
   {
   int length;
   char temp[ SML_BUFFER ];
   if ( *text != NULL )
      {
      if ( strcmp( "PCST_ViaOid", *text) == 0 )
         *DbvPrivateCharacterSetType = PCST_ViaOid;
      else
      if ( strcmp( "PCST_ExternallySpecified", *text) == 0 )
         *DbvPrivateCharacterSetType = PCST_ExternallySpecified;
      else
      if ( strcmp( "PCST_PreviouslyAgreedUpon", *text) == 0 )
         *DbvPrivateCharacterSetType = PCST_PreviouslyAgreedUpon;
      else
      if ( strcmp( "PCST_Invalid", *text) == 0 )
         *DbvPrivateCharacterSetType = PCST_Invalid;
      else
        printf( "Warning: DbvPrivateCharacterSetType could not be converted\n" );
      } /* End if */
   else
      {
      temp[ 0 ] = '\0';
      if ( *DbvPrivateCharacterSetType == PCST_ViaOid )
         strcpy( temp, "PCST_ViaOid" );
      
      if ( *DbvPrivateCharacterSetType == PCST_ExternallySpecified )
         strcpy( temp, "PCST_ExternallySpecified" );
      
      if ( *DbvPrivateCharacterSetType == PCST_PreviouslyAgreedUpon )
         strcpy( temp, "PCST_PreviouslyAgreedUpon" );
      
      if ( *DbvPrivateCharacterSetType == PCST_Invalid )
         strcpy( temp, "PCST_Invalid" );
      
      length = strlen( temp );
      if( length )
         {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
         } /* End if */
      else
         printf( "Warning: DbvPrivateCharacterSetType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvPrivateCharacterSetType() */
 
/*+-----------------------------------------------+*/
/*! convert_DbvEnvironmentType                    !*/ 
/*+-----------------------------------------------+*/
void convert_DbvEnvironmentType( char **text, DbvEnvironmentType *DbvEnvironmentType )
   {
   int length;
   char temp[ SML_BUFFER ];
   if ( *text != NULL )
      {
      if ( strcmp( "ENT_SevenBit", *text) == 0 )
         *DbvEnvironmentType = ENT_SevenBit;
      else
      if ( strcmp( "ENT_EightBit", *text) == 0 )
         *DbvEnvironmentType = ENT_EightBit;
      else
      if ( strcmp( "ENT_Invalid", *text) == 0 )
         *DbvEnvironmentType = ENT_Invalid;
      else
        printf( "Warning: DbvEnvironmentType could not be converted\n" );
      } /* End if */
   else
      {
      temp[ 0 ] = '\0';
      if ( *DbvEnvironmentType == ENT_SevenBit )
         strcpy( temp, "ENT_SevenBit" );
      
      if ( *DbvEnvironmentType == ENT_EightBit )
         strcpy( temp, "ENT_EightBit" );
      
      if ( *DbvEnvironmentType == ENT_Invalid )
         strcpy( temp, "ENT_Invalid" );
      
      length = strlen( temp );
      if( length )
         {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
         } /* End if */
      else
         printf( "Warning: DbvEnvironmentType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvEnvironmentType() */
 
/*+-----------------------------------------------+*/
/*! convert_DbvIso2022Type                        !*/ 
/*+-----------------------------------------------+*/
void convert_DbvIso2022Type( char **text, DbvIso2022Type *DbvIso2022Type )
   {
   int length;
   char temp[ SML_BUFFER ];
   if ( *text != NULL )
      {
      if ( strcmp( "I2022T_OriginProposal", *text) == 0 )
         *DbvIso2022Type = I2022T_OriginProposal;
      else
      if ( strcmp( "I2022T_TargetResponse", *text) == 0 )
         *DbvIso2022Type = I2022T_TargetResponse;
      else
      if ( strcmp( "I2022T_Invalid", *text) == 0 )
         *DbvIso2022Type = I2022T_Invalid;
      else
        printf( "Warning: DbvIso2022Type could not be converted\n" );
      } /* End if */
   else
      {
      temp[ 0 ] = '\0';
      if ( *DbvIso2022Type == I2022T_OriginProposal )
         strcpy( temp, "I2022T_OriginProposal" );
      
      if ( *DbvIso2022Type == I2022T_TargetResponse )
         strcpy( temp, "I2022T_TargetResponse" );
      
      if ( *DbvIso2022Type == I2022T_Invalid )
         strcpy( temp, "I2022T_Invalid" );
      
      length = strlen( temp );
      if( length )
         {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
         } /* End if */
      else
         printf( "Warning: DbvIso2022Type enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvIso2022Type() */
 
/*+-----------------------------------------------+*/
/*! convert_DbvProposedCharSetType                !*/ 
/*+-----------------------------------------------+*/
void convert_DbvProposedCharSetType( char **text, DbvProposedCharSetType *DbvProposedCharSetType )
   {
   int length;
   char temp[ SML_BUFFER ];
   if ( *text != NULL )
      {
      if ( strcmp( "PRCST_Iso2022", *text) == 0 )
         *DbvProposedCharSetType = PRCST_Iso2022;
      else
      if ( strcmp( "PRCST_Iso10646", *text) == 0 )
         *DbvProposedCharSetType = PRCST_Iso10646;
      else
      if ( strcmp( "PRCST_Private", *text) == 0 )
         *DbvProposedCharSetType = PRCST_Private;
      else
      if ( strcmp( "PRCST_Invalid", *text) == 0 )
         *DbvProposedCharSetType = PRCST_Invalid;
      else
        printf( "Warning: DbvProposedCharSetType could not be converted\n" );
      } /* End if */
   else
      {
      temp[ 0 ] = '\0';
      if ( *DbvProposedCharSetType == PRCST_Iso2022 )
         strcpy( temp, "PRCST_Iso2022" );
      
      if ( *DbvProposedCharSetType == PRCST_Iso10646 )
         strcpy( temp, "PRCST_Iso10646" );
      
      if ( *DbvProposedCharSetType == PRCST_Private )
         strcpy( temp, "PRCST_Private" );
      
      if ( *DbvProposedCharSetType == PRCST_Invalid )
         strcpy( temp, "PRCST_Invalid" );
      
      length = strlen( temp );
      if( length )
         {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
         } /* End if */
      else
         printf( "Warning: DbvProposedCharSetType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvProposedCharSetType() */
 
/*+-----------------------------------------------+*/
/*! convert_DbvCharSetAndLanguageType             !*/ 
/*+-----------------------------------------------+*/
void convert_DbvCharSetAndLanguageType( char **text, DbvCharSetAndLanguageType *DbvCharSetAndLanguageType )
   {
   int length;
   char temp[ SML_BUFFER ];
   if ( *text != NULL )
      {
      if ( strcmp( "CSALT_Proposal", *text) == 0 )
         *DbvCharSetAndLanguageType = CSALT_Proposal;
      else
      if ( strcmp( "CSALT_Response", *text) == 0 )
         *DbvCharSetAndLanguageType = CSALT_Response;
      else
      if ( strcmp( "CSALT_Invalid", *text) == 0 )
         *DbvCharSetAndLanguageType = CSALT_Invalid;
      else
        printf( "Warning: DbvCharSetAndLanguageType could not be converted\n" );
      } /* End if */
   else
      {
      temp[ 0 ] = '\0';
      if ( *DbvCharSetAndLanguageType == CSALT_Proposal )
         strcpy( temp, "CSALT_Proposal" );
      
      if ( *DbvCharSetAndLanguageType == CSALT_Response )
         strcpy( temp, "CSALT_Response" );
      
      if ( *DbvCharSetAndLanguageType == CSALT_Invalid )
         strcpy( temp, "CSALT_Invalid" );
      
      length = strlen( temp );
      if( length )
         {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
         } /* End if */
      else
         printf( "Warning: DbvCharSetAndLanguageType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvCharSetAndLanguageType() */
 
