/*  Module Name: @(#)convert_DbvFuncs.c	7.1
    Version: 11/15/96
    Author: Dan Maskell/Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
	Functions to convert enumerated types between enum and string format
        Used by the origin and target.
 
*/

#include "convert_DbvFuncs.h"


void convert_DbvBool(char **text, DbvBool *peBool)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("DBV_TRUE", *text) == 0)
         *peBool = DBV_TRUE;
      else
      if(strcmp("DBV_FALSE", *text) == 0)
         *peBool = DBV_FALSE;
      else
         printf("Warning: DbvBool string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peBool == DBV_TRUE )
         strcpy(temp, "DBV_TRUE");

      if( *peBool == DBV_FALSE)
         strcpy(temp, "DBV_FALSE");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvBool enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvBool() */


void convert_DbvDbRecordType(char **text, DbvDbRecordType *peDbRecordType)
   {
   int length;
   char temp[SML_BUFFER];

   if( *text == NULL )
      {
      if( *peDbRecordType == DRT_Retrieval )
         strcpy(temp, "DRT_Retrieval" );

      if( *peDbRecordType == DRT_SurrogateDiagnostics )
         strcpy(temp, "DRT_SurrogateDiagnostics" );

      if( *peDbRecordType == DRT_StartingFragment )
         strcpy(temp, "DRT_StartingFragment" );

      if( *peDbRecordType == DRT_IntermediateFragment )
         strcpy(temp, "DRT_IntermediateFragment" );

      if( *peDbRecordType == DRT_FinalFragment )
         strcpy(temp, "DRT_FinalFragment" );

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvDbRecordType enum could not be converted!\n");
      } /* End if */
   else
     {
      temp[ 0 ] = '\0';
      if(strcmp("DRT_Retrieval", *text) == 0)
         *peDbRecordType = DRT_Retrieval;
      else
      if(strcmp("DRT_SurrogateDiagnostics", *text) == 0)
         *peDbRecordType = DRT_SurrogateDiagnostics;
      else
      if(strcmp("DRT_StartingFragment", *text) == 0)
         *peDbRecordType = DRT_StartingFragment;
      else
      if(strcmp("DRT_IntermediateFragment", *text) == 0)
         *peDbRecordType = DRT_IntermediateFragment;
      else
      if(strcmp("DRT_FinalFragment", *text) == 0)
         *peDbRecordType = DRT_FinalFragment;
      else
         printf("Warning: DbvDbRecordType string could not be converted: %s\n"
		,*text);
      } /* End if */

   } /* End convert_DbvDbRecordType() */


void convert_DbvDeleteFunction(char **text, DbvDeleteFunction *peDeleteFunction)
   {
   int length;
   char temp[ SML_BUFFER ]; 

   if(*text != NULL)
      {
      if(strcmp("DF_List", *text) == 0)
         *peDeleteFunction = DF_List;
      else
      if(strcmp("DF_All", *text) == 0)
         *peDeleteFunction = DF_All;
      else
      if(strcmp("DF_Invalid", *text) == 0)
         *peDeleteFunction = DF_Invalid;
      else
         printf("Warning: DbvDeleteFunction string could not be converted: %s\n"
		,*text);
      } /* End if */
   else
      {
      temp[ 0 ] = '\0';
      if( *peDeleteFunction == DF_List )
         strcpy(temp, "DF_List" );

      if( *peDeleteFunction == DF_All )
         strcpy(temp, "DF_All" );

      if( *peDeleteFunction == DF_Invalid )
         strcpy(temp, "DF_Invalid" );

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvDeleteFunction enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvDeleteFunction() */


void convert_DbvDeleteSetStatus(char **text, 
			  DbvDeleteSetStatus *peDeleteSetStatus )
   {

   char temp[ SML_BUFFER ];
   int length;

   if(*text != NULL)
      {
      if( strcmp( "DSS_Success", *text ) == 0 )
         *peDeleteSetStatus = DSS_Success;
      else
      if( strcmp( "DSS_ResultSetDidNotExist", *text ) == 0 )
         *peDeleteSetStatus = DSS_ResultSetDidNotExist;
      else
      if( strcmp( "DSS_PreviouslyDeletedByTarget", *text ) == 0 )
         *peDeleteSetStatus = DSS_PreviouslyDeletedByTarget;
      else
      if( strcmp( "DSS_SystemProblemAtTarget", *text ) == 0 )
         *peDeleteSetStatus = DSS_SystemProblemAtTarget;
      else
      if( strcmp( "DSS_AccessNotAllowed", *text ) == 0 )
         *peDeleteSetStatus = DSS_AccessNotAllowed;
      else
      if( strcmp( "DSS_ResourceControlAtOrigin", *text ) == 0 )
         *peDeleteSetStatus = DSS_ResourceControlAtOrigin;
      else
      if( strcmp( "DSS_ResourceControlAtTarget", *text ) == 0 )
         *peDeleteSetStatus = DSS_ResourceControlAtTarget;
      else
      if( strcmp( "DSS_BulkDeleteNotSupported", *text ) == 0 )
         *peDeleteSetStatus = DSS_BulkDeleteNotSupported;
      else
      if( strcmp( "DSS_NotAllSetsDeletedOnBulkDlt", *text ) == 0 )
         *peDeleteSetStatus = DSS_NotAllSetsDeletedOnBulkDlt;
      else
      if( strcmp( "DSS_NotAllRequestedSetsDeleted", *text ) == 0 )
         *peDeleteSetStatus = DSS_NotAllRequestedSetsDeleted;
      else
      if( strcmp( "DSS_ResultSetInUse", *text ) == 0 )
         *peDeleteSetStatus = DSS_ResultSetInUse;
      else
      if( strcmp( "DSS_Invalid", *text ) == 0 )
         *peDeleteSetStatus = DSS_Invalid;
      else
      printf("Warning: DbvDeleteSetStatus string could not be converted: %s\n",*text);
      } /* End if */
   else
      {
      temp[ 0 ] = '\0';
      if( *peDeleteSetStatus == DSS_Success )
         strcpy(temp, "DSS_Success");

      if( *peDeleteSetStatus == DSS_ResultSetDidNotExist )
         strcpy(temp, "DSS_ResultSetDidNotExist");

      if( *peDeleteSetStatus == DSS_PreviouslyDeletedByTarget )
         strcpy(temp, "DSS_PreiouslyDeletedByTarget" );

      if( *peDeleteSetStatus == DSS_SystemProblemAtTarget )
         strcpy(temp, "DSS_SystemProblemAtTarget" );

      if( *peDeleteSetStatus == DSS_AccessNotAllowed )
         strcpy(temp, "DSS_AccessNotAllowed" );

      if( *peDeleteSetStatus == DSS_ResourceControlAtOrigin )
         strcpy(temp, "DSS_ResourceControlAtOrigin" );

      if( *peDeleteSetStatus == DSS_ResourceControlAtTarget )
         strcpy(temp, "DSS_ResourceControlAtTarget" );

      if( *peDeleteSetStatus == DSS_BulkDeleteNotSupported )
         strcpy(temp, "DSS_BulkDeleteNotSupported" );

      if( *peDeleteSetStatus == DSS_NotAllSetsDeletedOnBulkDlt )
         strcpy(temp, "DSS_NotAllSetsDeletedOnBuldDlt" );

      if( *peDeleteSetStatus == DSS_NotAllRequestedSetsDeleted )
         strcpy(temp, "DSS_NotAllRequestedSetsDeleted " );

      if( *peDeleteSetStatus == DSS_ResultSetInUse )
         strcpy(temp, "DSS_ResultSetInUse" );

      if( *peDeleteSetStatus == DSS_Invalid )
         strcpy(temp, "DSS_Invalid" );

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvDeleteSetStatus enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvDeleteSetStatus() */


void convert_DbvDiagnosticsType(char **text, 
				   DbvDiagnosticsType *peDiagnosticsType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("DT_DefaultFormat", *text) == 0)
         *peDiagnosticsType = DT_DefaultFormat;
      else
      if(strcmp("DT_ExternallyDefined", *text) == 0)
         *peDiagnosticsType = DT_ExternallyDefined;
      else
         printf("Warning: DbvDiagnosticsType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peDiagnosticsType == DT_DefaultFormat )
         strcpy(temp, "DT_DefaultFormat");

      if( *peDiagnosticsType == DT_ExternallyDefined)
         strcpy(temp, "DT_ExternallyDefined");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvDiagnosticsType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvDiagnosticsType() */


void convert_DbvElementSetType(char **text, DbvElementSetType *peElementSetType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if(*text != NULL)
      {
      if(strcmp("EST_Generic", *text) == 0)
         *peElementSetType = EST_Generic;
      else
      if(strcmp("EST_DatabaseSpecific", *text) == 0)
         *peElementSetType = EST_DatabaseSpecific;
      else
         printf("Warning: DbvElementSetType string could not be converted: %s\n"
		,*text);
      } /* End if */
   else
      {
      temp[ 0 ] = '\0';
      if( *peElementSetType == EST_Generic)
         strcpy(temp, "EST_Generic");

      if( *peElementSetType == EST_DatabaseSpecific)
         strcpy(temp, "EST_DatabaseSpecific");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvElementSetType enum could not be converted!\n");
      } /* End else */


   } /* End convert_DbvElementSetType() */


void convert_DbvFragmentSyntaxType(char **text, 
				   DbvFragmentSyntaxType *peFragmentSyntaxType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("FST_ExternallyTagged", *text) == 0)
         *peFragmentSyntaxType = FST_ExternallyTagged;
      else
      if(strcmp("FST_NotExternallyTagged", *text) == 0)
         *peFragmentSyntaxType = FST_NotExternallyTagged;
      else
         printf("Warning: DbvFragmentSyntaxType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peFragmentSyntaxType == FST_ExternallyTagged )
         strcpy(temp, "FST_ExternallyTagged");

      if( *peFragmentSyntaxType == FST_NotExternallyTagged)
         strcpy(temp, "FST_NotExternallyTagged");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvFragmentSyntaxType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvFragmentSyntaxType() */


void convert_DbvPresentStatus(char **text, 
				DbvPresentStatus *pePresentStatus)
   {
   int length;
   char temp[SML_BUFFER];
   if( *text != NULL )
      {
      if(strcmp("PS_Success", *text) == 0)
         *pePresentStatus = PS_Success;
      else
      if(strcmp("PS_Partial_1", *text) == 0)
         *pePresentStatus = PS_Partial_1;
      else
      if(strcmp("PS_Partial_2", *text) == 0)
         *pePresentStatus = PS_Partial_2;
      else
      if(strcmp("PS_Partial_3", *text) == 0)
         *pePresentStatus = PS_Partial_3;
      else
      if(strcmp("PS_Partial_4", *text) == 0)
         *pePresentStatus = PS_Partial_4;
      else
      if(strcmp("PS_Failure", *text) == 0)
         *pePresentStatus = PS_Failure;
      else
      if(strcmp("PS_Invalid", *text) == 0)
         *pePresentStatus = PS_Invalid;
      else
         printf("Warning: DbvPresentStatus string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *pePresentStatus == PS_Success )
         strcpy(temp, "PS_Success");

      if( *pePresentStatus == PS_Partial_1 )
         strcpy(temp, "PS_Partial_1");

      if( *pePresentStatus == PS_Partial_2 )
         strcpy(temp, "PS_Partial_2");

      if( *pePresentStatus == PS_Partial_3 )
         strcpy(temp, "PS_Partial_3");

      if( *pePresentStatus == PS_Partial_4 )
         strcpy(temp, "PS_Partial_4");

      if( *pePresentStatus == PS_Failure )
         strcpy(temp, "PS_Failure");

      if( *pePresentStatus == PS_Invalid )
         strcpy(temp, "PS_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvPresentStatus enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvPresentStatus() */


void convert_DbvProtocolVersionInForce(char **text, 
		DbvProtocolVersionInForce *peProtocolVersionInForce )
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("PVIF_Version2", *text) == 0)
         *peProtocolVersionInForce = PVIF_Version2;
      else
      if(strcmp("PVIF_Version3", *text) == 0)
         *peProtocolVersionInForce = PVIF_Version3;
      else
         printf("Warning: DbvProtocolVersionInForce string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peProtocolVersionInForce == PVIF_Version2 )
         strcpy(temp, "PVIF_Version2");

      if( *peProtocolVersionInForce == PVIF_Version3)
         strcpy(temp, "PVIF_Version3");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvProtocolVersionInForce enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvProtocolVersionInForce() */


void convert_DbvQueryType(char **text, DbvQueryType *peQueryType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if(*text != NULL)
      {
      if(strcmp("QT_Private", *text) == 0)
         *peQueryType = QT_Private;
      else
      if(strcmp("QT_Rpn", *text) == 0)
         *peQueryType = QT_Rpn;
      else
      if(strcmp("QT_Iso8777", *text) == 0)
         *peQueryType = QT_Iso8777;
      else
      if(strcmp("QT_Z3958", *text) == 0)
         *peQueryType = QT_Z3958;
      else
      if(strcmp("QT_Erpn", *text) == 0)
         *peQueryType = QT_Erpn;
      else
      if(strcmp("QT_NaturalLanguage", *text) == 0)
         *peQueryType = QT_NaturalLanguage;
      else
         printf("Warning: DbvQueryType string could not be converted: %s\n"
		,*text);
      } /* End if */
   else
      {
      temp[ 0 ] = '\0';
      if( *peQueryType == QT_Private )
         strcpy(temp, "QT_Private");

      if( *peQueryType == QT_Rpn )
         strcpy(temp, "QT_Rpn");

      if( *peQueryType == QT_Iso8777 )
         strcpy(temp, "QT_Iso8777");

      if( *peQueryType == QT_Z3958 )
         strcpy(temp, "QT_Z3958");

      if( *peQueryType == QT_Erpn )
         strcpy(temp, "QT_Erpn");

      if( *peQueryType == QT_NaturalLanguage )
         strcpy(temp, "QT_NaturalLanguage");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvQueryType enum could not be converted!\n");
      } /* End if */

   } /* End convert_DbvQueryType() */


void convert_DbvRecordType(char **text, DbvRecordType *peRecordType)
   {
   int length;
   char temp[SML_BUFFER];

   if( *text != NULL )
      {
      if(strcmp("RT_Response", *text) == 0)
         *peRecordType = RT_Response;
      else
      if(strcmp("RT_NonSurrDiagnostics", *text) == 0)
         *peRecordType = RT_NonSurrDiagnostics;
      else
      if(strcmp("RT_MultipleNonSurrDiagnostics", *text) == 0)
         *peRecordType = RT_MultipleNonSurrDiagnostics;
      else
         printf("Warning: DbvRecordType string could not be converted: %s\n",*text);
      }
      else
      {
      if( *peRecordType == RT_Response )
         strcpy(temp, "RT_Response");

      if( *peRecordType == RT_NonSurrDiagnostics )
         strcpy(temp, "RT_NonSurrDiagnostics");

      if( *peRecordType == RT_MultipleNonSurrDiagnostics )
         strcpy(temp, "RT_MultipleNonSurrDiagnostics");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvRecordType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvRecordType() */


void convert_DbvResultSetStatus(char **text, 
				DbvResultSetStatus *peResultSetStatus)
   {
   int length;
   char temp[SML_BUFFER];
   if( *text != NULL )
      {
      if(strcmp("RSS_Subset", *text) == 0)
         *peResultSetStatus = RSS_Subset;
      else
      if(strcmp("RSS_Interim", *text) == 0)
         *peResultSetStatus = RSS_Interim;
      else
      if(strcmp("RSS_None", *text) == 0)
         *peResultSetStatus = RSS_None;
      else
      if(strcmp("RSS_Invalid", *text) == 0)
         *peResultSetStatus = RSS_Invalid;
      else
         printf("Warning: DbvResultSetStatus string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peResultSetStatus == RSS_Subset )
         strcpy(temp, "RSS_Subset");

      if( *peResultSetStatus == RSS_Interim )
         strcpy(temp, "RSS_Interim");

      if( *peResultSetStatus == RSS_None )
         strcpy(temp, "RSS_None");

      if( *peResultSetStatus == RSS_Invalid )
         strcpy(temp, "RSS_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvResultSetStatus enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvResultSetStatus() */


void convert_DbvTermType(char **text, DbvTermType *peTermType)
   {
   int length;
   char temp[SML_BUFFER];
   if( *text != NULL )
      {
      if(strcmp("TT_General", *text) == 0)
         *peTermType = TT_General;
      else
      if(strcmp("TT_Numeric", *text) == 0)
         *peTermType = TT_Numeric;
      else
      if(strcmp("TT_SimpleCharacter", *text) == 0)
         *peTermType = TT_SimpleCharacter;
      else
      if(strcmp("TT_ObjectIdentifier", *text) == 0)
         *peTermType = TT_ObjectIdentifier;
      else
      if(strcmp("TT_DateTime", *text) == 0)
         *peTermType = TT_DateTime;
      else
      if(strcmp("TT_External", *text) == 0)
         *peTermType = TT_External;
      else
      if(strcmp("TT_IntegerAndUnit", *text) == 0)
         *peTermType = TT_IntegerAndUnit;
      else
      if(strcmp("TT_Null", *text) == 0)
         *peTermType = TT_Null;
      else
         printf("Warning: DbvTermType string could not be converted: %s\n"
		,*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peTermType == TT_General )
         strcpy(temp, "TT_General");
      if( *peTermType == TT_Numeric  )
         strcpy(temp, "TT_Numeric");
      if( *peTermType == TT_SimpleCharacter )
         strcpy(temp, "TT_SimpleCharacter");
      if( *peTermType ==  TT_ObjectIdentifier)
         strcpy(temp, "TT_ObjectIdentifier");
      if( *peTermType == TT_DateTime )
         strcpy(temp, "TT_DateTime");
      if( *peTermType == TT_External )
         strcpy(temp, "TT_External");
      if( *peTermType == TT_IntegerAndUnit )
         strcpy(temp, "TT_IntegerAndUnit");
      if( *peTermType == TT_Null)
         strcpy(temp, "TT_Null");
      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvTermType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvTermType() */

void convert_DbvSortStatus(char **text, DbvSortStatus *peSortStatus)
   {
   int length;
   char temp[ STRING_LEN ];

   if( *text != NULL )
      {
      if(strcmp("SOS_Success", *text) == 0)
         *peSortStatus = SOS_Success;
      else
      if(strcmp("SOS_Partial_1", *text) == 0)
         *peSortStatus = SOS_Partial_1;
      else
      if(strcmp("SOS_Failure", *text) == 0)
         *peSortStatus = SOS_Failure;
      else
      if(strcmp("SOS_Invalid", *text) == 0)
         *peSortStatus = SOS_Invalid;
      else
         printf("Warning: DbvSortStatus string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peSortStatus == SOS_Success )
         strcpy(temp, "SOS_Success");

      if( *peSortStatus == SOS_Partial_1)
         strcpy(temp, "SOS_Partial_1");

      if( *peSortStatus == SOS_Failure )
         strcpy(temp, "SOS_Failure");

      if( *peSortStatus == SOS_Invalid )
         strcpy(temp, "SOS_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvSortStatus enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvSortStatus() */
void convert_DbvSortResultSetStatus(char **text, DbvSortResultSetStatus *peSortResultSetStatus)
   {
   int length;
   char temp[  STRING_LEN ];

   if( *text != NULL )
      {
      if(strcmp("SRSS_Empty", *text) == 0)
         *peSortResultSetStatus = SRSS_Empty;
      else
      if(strcmp("SRSS_Interim", *text) == 0)
         *peSortResultSetStatus = SRSS_Interim;
      if(strcmp("SRSS_Unchanged", *text) == 0)
         *peSortResultSetStatus = SRSS_Unchanged;
      else
      if(strcmp("SRSS_None", *text) == 0)
         *peSortResultSetStatus = SRSS_None;
      else
      if(strcmp("SRSS_Invalid", *text) == 0)
         *peSortResultSetStatus = SRSS_Invalid;
      else
         printf("Warning: DbvSortResultSetStatus string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peSortResultSetStatus == SRSS_Empty )
         strcpy(temp, "SRSS_Empty");

      if( *peSortResultSetStatus == SRSS_Interim)
         strcpy(temp, "SRSS_Interim");

      if( *peSortResultSetStatus == SRSS_Unchanged )
         strcpy(temp, "SRSS_Unchanged");

      if( *peSortResultSetStatus == SRSS_None)
         strcpy(temp, "SRSS_None");

      if( *peSortResultSetStatus == SRSS_Invalid)
         strcpy(temp, "SRSS_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvSortResultSetStatus enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvSortResultSetStatus() */
void convert_DbvSortElementType(char **text, DbvSortElementType *peSortElementType)
   {
   int length;
   char temp[ STRING_LEN ];

   if( *text != NULL )
      {
      if(strcmp("SET_Generic", *text) == 0)
         *peSortElementType = SET_Generic;
      else
      if(strcmp("SET_DbSpecific", *text) == 0)
         *peSortElementType = SET_DbSpecific;
      else
         printf("Warning: DbvSortElementType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peSortElementType == SET_Generic )
         strcpy(temp, "SET_Generic");

      if( *peSortElementType == SET_DbSpecific)
         strcpy(temp, "SET_DbSpecific");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf( "Warning: DbvSortElementType enum could not be converted!\n" );
      } /* End else */
   } /* End convert_DbvSortElementType() */
void convert_DbvSortRelationType(char **text, 
				DbvSortRelationType *peSortRelationType)
   {
   int length;
   char temp[ STRING_LEN ];
   if( *text != NULL )
      {
      if(strcmp("SRT_Ascending", *text) == 0)
         *peSortRelationType = SRT_Ascending;
      else
      if(strcmp("SRT_Descending", *text) == 0)
         *peSortRelationType = SRT_Descending;
      else
      if(strcmp("SRT_FrequencyAsc", *text) == 0)
         *peSortRelationType = SRT_FrequencyAsc;
      else
      if(strcmp("SRT_FrequencyDesc", *text) == 0)
         *peSortRelationType = SRT_FrequencyDesc;
      else
      if(strcmp("SRT_Invalid", *text) == 0)
         *peSortRelationType = SRT_Invalid;
      else
         printf("Warning: DbvSortRelationType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peSortRelationType == SRT_Ascending )
         strcpy(temp, "SRT_Ascending");

      if( *peSortRelationType == SRT_Descending )
         strcpy(temp, "SRT_Descending");

      if( *peSortRelationType == SRT_FrequencyAsc )
         strcpy(temp, "SRT_FrequencyAsc");

      if( *peSortRelationType == SRT_FrequencyDesc )
         strcpy(temp, "SRT_FrequencyDesc");

      if( *peSortRelationType == SRT_Invalid )
         strcpy(temp, "SRT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvSortRelationType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvSortRelationType() */
void convert_DbvSortCaseType(char **text, DbvSortCaseType *peSortCaseType)
   {
   int length;
   char temp[ STRING_LEN ];

   if( *text != NULL )
      {
      if(strcmp("SCT_CaseSensitive", *text) == 0)
         *peSortCaseType = SCT_CaseSensitive;
      else
      if(strcmp("SCT_CaseInsensitive", *text) == 0)
         *peSortCaseType = SCT_CaseInsensitive;
      else
      if(strcmp("SCT_Invalid", *text) == 0)
         *peSortCaseType = SCT_Invalid;
      else
         printf("Warning: DbvSortCaseType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peSortCaseType == SCT_CaseSensitive )
         strcpy(temp, "SCT_CaseSensitive");

      if( *peSortCaseType == SCT_CaseInsensitive)
         strcpy(temp, "SCT_CaseInsensitive");

      if( *peSortCaseType == SCT_Invalid)
         strcpy(temp, "SCT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvSortCaseType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvSortCaseType() */
void convert_DbvSortKeyType(char **text, DbvSortKeyType *peSortKeyType)
   {
   int length;
   char temp[ STRING_LEN ];
   if( *text != NULL )
      {
      if(strcmp("SKT_SortField", *text) == 0)
         *peSortKeyType = SKT_SortField;
      else
      if(strcmp("SKT_ElementSpec", *text) == 0)
         *peSortKeyType = SKT_ElementSpec;
      else
      if(strcmp("SKT_SortAttributes", *text) == 0)
         *peSortKeyType = SKT_SortAttributes;
      else
         printf("Warning: DbvSortKeyType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peSortKeyType == SKT_SortField )
         strcpy(temp, "SKT_SortField");

      if( *peSortKeyType == SKT_ElementSpec )
         strcpy(temp, "SKT_ElementSpec");

      if( *peSortKeyType == SKT_SortAttributes )
         strcpy(temp, "SKT_SortAttributes");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvSortKeyType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvSortKeyType() */
void convert_DbvSortMVActionType(char **text, DbvSortMVActionType *peSortMVActionType)
   {
   int length;
   char temp[ STRING_LEN ];

   if( *text != NULL )
      {
      if(strcmp("SMT_Abort", *text) == 0)
         *peSortMVActionType = SMT_Abort;
      else
      if(strcmp("SMT_Null", *text) == 0)
         *peSortMVActionType = SMT_Null;
      else
      if(strcmp("SMT_Constant", *text) == 0)
         *peSortMVActionType = SMT_Constant;
      else
         printf("Warning: DbvSortMVActionType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peSortMVActionType == SMT_Abort )
         strcpy(temp, "SMT_Abort");

      if( *peSortMVActionType == SMT_Null)
         strcpy(temp, "SMT_Null");

      if( *peSortMVActionType == SMT_Constant )
         strcpy(temp, "SMT_Constant" );

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvSortMVActionType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvSortMVActionType() */
void convert_DbvElementSpecType(char **text, 
				DbvElementSpecType *peElementSpecType)
   {
   int length;
   char temp[ STRING_LEN ];

   if( *text != NULL )
      {
      if(strcmp("EST_Primitive", *text) == 0)
         *peElementSpecType = EST_Primitive;
      else
      if(strcmp("EST_External", *text) == 0)
         *peElementSpecType = EST_External;
      else
         printf("Warning: DbvElementSpecType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peElementSpecType == EST_Primitive )
         strcpy(temp, "EST_Primitive");

      if( *peElementSpecType == EST_External)
         strcpy(temp, "EST_External");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvElementSpecType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvElementSpecType() */
void convert_DbvAttributeValueType( char **text, 
			DbvAttributeValueType *peDbvAttributeValueType )
   {
   int length;
   char temp[ STRING_LEN ];

   if( *text != NULL )
      {
      if(strcmp("AVT_Numeric", *text ) == 0)
         *peDbvAttributeValueType = AVT_Numeric;
      else
      if(strcmp("AVT_Complex", *text ) == 0)
         *peDbvAttributeValueType = AVT_Complex;
      else
         printf("Warning: DbvAttributeValueType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peDbvAttributeValueType == AVT_Numeric )
         strcpy(temp, "AVT_Numeric");

      if( *peDbvAttributeValueType == AVT_Complex)
         strcpy(temp, "AVT_Complex");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvAttributeValueType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvAttributeValueType() */
void convert_DbvStringOrNumericType(char **text, 
			DbvStringOrNumericType *peStringOrNumericType)
   {
   int length;
   char temp[ STRING_LEN ];

   if( *text != NULL )
      {
      if(strcmp("SNT_String", *text) == 0)
         *peStringOrNumericType = SNT_String;
      else
      if(strcmp("SNT_Numeric", *text) == 0)
         *peStringOrNumericType = SNT_Numeric;
      else
         printf("Warning: DbvStringOrNumericType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peStringOrNumericType == SNT_String )
         strcpy(temp, "SNT_String" );

      if( *peStringOrNumericType == SNT_Numeric )
         strcpy(temp, "SNT_Numeric" );

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvStringOrNumericType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvStringOrNumericType() */
void convert_DbvScanStatus(char **text, DbvScanStatus *peScanStatus)
   {
   int length;
   char temp[ STRING_LEN ];
   if( *text != NULL )
      {
      if(strcmp("SCS_Success", *text) == 0)
         *peScanStatus = SCS_Success;
      else
      if(strcmp("SCS_Partial_1", *text) == 0)
         *peScanStatus = SCS_Partial_1;
      else
      if(strcmp("SCS_Partial_2", *text) == 0)
         *peScanStatus = SCS_Partial_2;
      else
      if(strcmp("SCS_Partial_3", *text) == 0)
         *peScanStatus = SCS_Partial_3;
      else
      if(strcmp("SCS_Partial_4", *text) == 0)
         *peScanStatus = SCS_Partial_4;
      else
      if(strcmp("SCS_Partial_5", *text) == 0)
         *peScanStatus = SCS_Partial_5;
      else
      if(strcmp("SCS_Failure", *text) == 0)
         *peScanStatus = SCS_Failure;
      else
      if(strcmp("SCS_Invalid", *text) == 0)
         *peScanStatus = SCS_Invalid;
      else
         printf("Warning: DbvScanStatus string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peScanStatus == SCS_Success )
         strcpy(temp, "SCS_Success");

      if( *peScanStatus == SCS_Partial_1 )
         strcpy(temp, "SCS_Partial_1");

      if( *peScanStatus == SCS_Partial_2 )
         strcpy(temp, "SCS_Partial_2");

      if( *peScanStatus == SCS_Partial_3 )
         strcpy(temp, "SCS_Partial_3");

      if( *peScanStatus == SCS_Partial_4 )
         strcpy(temp, "SCS_Partial_4");

      if( *peScanStatus == SCS_Partial_5 )
         strcpy(temp, "SCS_Partial_5");

      if( *peScanStatus == SCS_Failure )
         strcpy(temp, "SCS_Failure");

      if( *peScanStatus == SCS_Invalid )
         strcpy(temp, "SCS_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvScanStatus enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvScanStatus() */

void convert_DbvEntryType(char **text, DbvEntryType *peEntryType)
   {
   int length;
   char temp[ STRING_LEN ];

   if( *text != NULL )
      {
      if(strcmp("ET_TermInfo", *text) == 0)
         *peEntryType = ET_TermInfo;
      else
      if(strcmp("ET_SurrogateDiagnostic", *text) == 0)
         *peEntryType = ET_SurrogateDiagnostic;
      else
         printf("Warning: DbvEntryType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peEntryType == ET_TermInfo )
         strcpy(temp, "ET_TermInfo");

      if( *peEntryType == ET_SurrogateDiagnostic)
         strcpy(temp, "ET_SurrogateDiagnostic");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvEntryType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvEntryType() */


void convert_DbvOccurrenceType(char **text, DbvOccurrenceType *peOccurrenceType)
   {
   int length;
   char temp[ STRING_LEN ];

   if( *text != NULL )
      {
      if(strcmp("OT_Global", *text) == 0)
         *peOccurrenceType = OT_Global;
      else
      if(strcmp("OT_ByDatabase", *text) == 0)
         *peOccurrenceType = OT_ByDatabase;
      else
         printf("Warning: DbvOccurrenceType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peOccurrenceType == OT_Global )
         strcpy(temp, "OT_Global");

      if( *peOccurrenceType == OT_ByDatabase)
         strcpy(temp, "OT_ByDatabase");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvOccurrenceType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvOccurrenceType() */


void convert_DbvRecordCompositionType(char **text, 
			DbvRecordCompositionType *peRecordCompositionType)
   {
   int length;
   char temp[ STRING_LEN ];

   if( *text != NULL )
      {
      if(strcmp("RCT_ElementSetNames", *text) == 0)
         *peRecordCompositionType = RCT_ElementSetNames;
      else
      if(strcmp("RCT_CompSpec", *text) == 0)
         *peRecordCompositionType = RCT_CompSpec;
      else
         printf("Warning: DbvRecordCompositionType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peRecordCompositionType == RCT_ElementSetNames )
         strcpy(temp, "RCT_ElementSetNames");

      if( *peRecordCompositionType == RCT_CompSpec)
         strcpy(temp, "RCT_CompSpec");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvRecordCompositionType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvRecordCompositionType() */


void convert_DbvExtServicesFunctions(char **text, DbvExtServicesFunctions *peFunction)
{
        char temp[SML_BUFFER];
 
        if(*text == NULL)
        {
                /* Convert enum type to string */
                if(*peFunction == ESF_Create)
                        strcpy(temp, "ESF_Create");
                /* Convert enum type to string */
                if(*peFunction == ESF_Delete)
                        strcpy(temp, "ESF_Delete");
                /* Convert enum type to string */
                if(*peFunction == ESF_Modify )
                        strcpy(temp, "ESF_Modify");
                if(*peFunction == ESF_Invalid )
                        strcpy(temp, "ESF_Invalid");
                if(strlen(temp)==0)
                        printf("Warning: DbvExtServicesFunctions enum could not be converted!\n");
                *text = (char *)malloc(strlen(temp)+1);
                strcpy(*text, temp);
        }
        else
        {
                /* Convert string to enum */
                if(strcmp("ESF_Create" , *text) == 0)
                        *peFunction = ESF_Create;
                else
                if(strcmp("ESF_Delete" , *text) == 0)
                        *peFunction = ESF_Delete;
                else
                if(strcmp("ESF_Modify" , *text) == 0)
                        *peFunction = ESF_Modify;
                else
                if(strcmp("ESF_Invalid" , *text) == 0)
                        *peFunction = ESF_Invalid;
                else
                        printf("Warning: DbvExtServicesFunctions string could not be converted: %s\n", *text);
        }
}

void convert_DbvExtServicesWaitAction(char **text, DbvExtServicesWaitAction *peWaitAction)
{
        char temp[SML_BUFFER];
 
        if(*text == NULL)
        {
                /* Convert enum type to string */
                if(*peWaitAction == ESWA_Wait)
                        strcpy(temp, "ESWA_Wait");
                if(*peWaitAction == ESWA_WaitIfPossible)
                        strcpy(temp, "ESWA_WaotIfPossible");
                if(*peWaitAction == ESWA_DontWait)
                        strcpy(temp, "ESWA_DontWait");
                if(*peWaitAction == ESWA_DontReturnPackage)
                        strcpy(temp, "ESWA_DontReturnPackage");
                if(*peWaitAction == ESWA_Invalid)
                        strcpy(temp, "ESWA_Invalid");
                if(strlen(temp)==0)
                        printf("Warning: DbvExtServicesWaitAction enum could not be converted!\n");
                *text = (char *)malloc(strlen(temp)+1);
                strcpy(*text, temp);
        }
        else
        {
                /* Convert string to enum */
                if(strcmp("ESWA_Wait" , *text) == 0)
                        *peWaitAction = ESWA_Wait;
                else
                if(strcmp("ESWA_WaitIfPossible" , *text) == 0)
                        *peWaitAction = ESWA_WaitIfPossible;
                else
                if(strcmp("ESWA_DontWait" , *text) == 0)
                        *peWaitAction = ESWA_DontWait;
                else
                if(strcmp("ESWA_DontReturnPackage" , *text) == 0)
                        *peWaitAction = ESWA_DontReturnPackage;
                else
                if(strcmp("ESWA_Invalid" , *text) == 0)
                        *peWaitAction = ESWA_Invalid;
                else
                        printf("Warning: DbvExtServicesWaitAction string could not be converted: %s\n", *text);
        }
}


void convert_DbvExtServicesOperationStatus(char **text, DbvExtServicesOperationStatus *peOperationStatus)
{
        char temp[SML_BUFFER];
 
        if(*text == NULL)
        {
                /* Convert enum type to string */
                if(*peOperationStatus == ESOS_Done )
                        strcpy(temp, "ESOS_Done");
                if(*peOperationStatus == ESOS_Queued )
                        strcpy(temp, "ESOS_Queued");
                if(*peOperationStatus == ESOS_Failure )
                        strcpy(temp, "ESOS_Failure");
                if(*peOperationStatus == ESOS_Invalid )
                        strcpy(temp, "ESOS_Invalid");

                if(strlen(temp)==0)
                        printf("Warning: DbvExtServicesOperationStatus enum could not be converted!\n");
                *text = (char *)malloc(strlen(temp)+1);
                strcpy(*text, temp);
        }
        else
        {
                /* Convert string to enum */
                if(strcmp("ESOS_Done" , *text) == 0)
                        *peOperationStatus = ESOS_Done ;
                else
               if(strcmp("ESOS_Queued" , *text) == 0)
                        *peOperationStatus = ESOS_Queued ;
                else
               if(strcmp("ESOS_Failure" , *text) == 0)
                        *peOperationStatus = ESOS_Failure;
                else
               if(strcmp("ESOS_Invalid" , *text) == 0)
                        *peOperationStatus = ESOS_Invalid;
                else
                        printf("Warning: DbvExtServicesOperationStatus string could not be converted: %s\n", *text);
        }
}


void convert_DbvUpdateReqOrRsp(char **text, DbvUpdateReqOrRsp *peUpdateReqOrRsp)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("UROR_Request", *text) == 0)
         *peUpdateReqOrRsp = UROR_Request;
      else
      if(strcmp("UROR_Response", *text) == 0)
         *peUpdateReqOrRsp = UROR_Response;
      else
         printf("Warning: DbvUpdateReqOrRsp string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peUpdateReqOrRsp == UROR_Request )
         strcpy(temp, "UROR_Request");

      if( *peUpdateReqOrRsp == UROR_Response)
         strcpy(temp, "UROR_Response");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvUpdateReqOrRsp enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvUpdateReqOrRsp() */

void convert_DbvUpdtAction(char **text, DbvUpdtAction *peUpdtAction)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("UA_RecordInsert", *text) == 0)
         *peUpdtAction = UA_RecordInsert;
      else
      if(strcmp("UA_RecordReplace", *text) == 0)
         *peUpdtAction = UA_RecordReplace;
      else
      if(strcmp("UA_RecordDelete", *text) == 0)
         *peUpdtAction = UA_RecordDelete;
      else
      if(strcmp("UA_ElementUpdate", *text) == 0)
         *peUpdtAction = UA_ElementUpdate;
      else
      if(strcmp("UA_Invalid", *text) == 0)
         *peUpdtAction = UA_Invalid;
      else
         printf("Warning: DbvUpdtAction string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peUpdtAction == UA_RecordInsert )
         strcpy(temp, "UA_RecordInsert");

      if( *peUpdtAction == UA_RecordReplace)
         strcpy(temp, "UA_RecordReplace");

      if( *peUpdtAction == UA_RecordDelete )
         strcpy(temp, "UA_RecordDelete");

      if( *peUpdtAction == UA_ElementUpdate)
         strcpy(temp, "UA_ElementUpdate");

      if( *peUpdtAction == UA_Invalid)
         strcpy(temp, "UA_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvUpdtAction enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvUpdtAction() */

void convert_DbvUpdtRecordIdType(char **text, 
				 DbvUpdtRecordIdType *peUpdtRecordIdType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("URIT_Number", *text) == 0)
         *peUpdtRecordIdType = URIT_Number;
      else
      if(strcmp("URIT_String", *text) == 0)
         *peUpdtRecordIdType = URIT_String;
      else
      if(strcmp("URIT_Opaque", *text) == 0)
         *peUpdtRecordIdType = URIT_Opaque;
      else
         printf("Warning: DbvUpdtRecordIdType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peUpdtRecordIdType == URIT_Number )
         strcpy(temp, "URIT_Number");

      if( *peUpdtRecordIdType == URIT_String)
         strcpy(temp, "URIT_String");

      if( *peUpdtRecordIdType == URIT_Opaque)
         strcpy(temp, "URIT_Opaque");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvUpdtRecordIdType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvUpdtRecordIdType() */

void convert_DbvUpdtSupplementalIdType(char **text, 
			 DbvUpdtSupplementalIdType *peUpdtSupplementalIdType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("USIT_Time", *text) == 0)
         *peUpdtSupplementalIdType = USIT_Time;
      else
      if(strcmp("USIT_Version", *text) == 0)
         *peUpdtSupplementalIdType = USIT_Version;
      else
      if(strcmp("USIT_PreviousVersion", *text) == 0)
         *peUpdtSupplementalIdType = USIT_PreviousVersion;
      else
         printf("Warning: DbvUpdtSupplementalIdType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peUpdtSupplementalIdType == USIT_Time )
         strcpy(temp, "USIT_Time");

      if( *peUpdtSupplementalIdType == USIT_Version)
         strcpy(temp, "USIT_Version");

      if( *peUpdtSupplementalIdType == USIT_PreviousVersion)
         strcpy(temp, "USIT_PreviousVersion");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvUpdtSupplementalIdType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvUpdtSupplementalIdType() */
 
void convert_DbvUpdtTaskStatus(char **text, DbvUpdtTaskStatus *peUpdtTaskStatus)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("UTS_Success", *text) == 0)
         *peUpdtTaskStatus = UTS_Success;
      else
      if(strcmp("UTS_Partial", *text) == 0)
         *peUpdtTaskStatus = UTS_Partial;
      else
      if(strcmp("UTS_Failure", *text) == 0)
         *peUpdtTaskStatus = UTS_Failure;
      else
      if(strcmp("UTS_Invalid", *text) == 0)
         *peUpdtTaskStatus = UTS_Invalid;
      else
         printf("Warning: DbvUpdtTaskStatus string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peUpdtTaskStatus == UTS_Success )
         strcpy(temp, "UTS_Success");

      if( *peUpdtTaskStatus == UTS_Partial)
         strcpy(temp, "UTS_Partial");

      if( *peUpdtTaskStatus == UTS_Failure)
         strcpy(temp, "UTS_Failure");

      if( *peUpdtTaskStatus == UTS_Invalid)
         strcpy(temp, "UTS_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvUpdtTaskStatus enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvUpdtTaskStatus() */
 
void convert_DbvUpdtRecordStatus(char **text, DbvUpdtRecordStatus *peUpdtRecordStatus)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("URST_Success", *text) == 0)
         *peUpdtRecordStatus = URST_Success;
      else
      if(strcmp("URST_Queued", *text) == 0)
         *peUpdtRecordStatus = URST_Queued;
      else
      if(strcmp("URST_InProcess", *text) == 0)
         *peUpdtRecordStatus = URST_InProcess;
      else
      if(strcmp("URST_Failure", *text) == 0)
         *peUpdtRecordStatus = URST_Failure;
      else
      if(strcmp("URST_Invalid", *text) == 0)
         *peUpdtRecordStatus = URST_Invalid;
      else
         printf("Warning: DbvUpdtRecordStatus string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peUpdtRecordStatus == URST_Success )
         strcpy(temp, "URST_Success");

      if( *peUpdtRecordStatus == URST_Queued)
         strcpy(temp, "URST_Queued");

      if( *peUpdtRecordStatus == URST_InProcess)
         strcpy(temp, "URST_InProcess");

      if( *peUpdtRecordStatus == URST_Failure)
         strcpy(temp, "URST_Failure");

      if( *peUpdtRecordStatus == URST_Invalid)
         strcpy(temp, "URST_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvUpdtRecordStatus enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvUpdtRecordStatus() */

void convert_DbvUpdtRecordOrDiagType(char **text, 
			 DbvUpdtRecordOrDiagType *peUpdtRecordOrDiagType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("URDT_Record", *text) == 0)
         *peUpdtRecordOrDiagType = URDT_Record;
      else
      if(strcmp("URDT_Diagnostic", *text) == 0)
         *peUpdtRecordOrDiagType = URDT_Diagnostic;
      else
         printf("Warning: DbvUpdtRecordOrDiagType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peUpdtRecordOrDiagType == URDT_Record )
         strcpy(temp, "URDT_Record");

      if( *peUpdtRecordOrDiagType == URDT_Diagnostic)
         strcpy(temp, "URDT_Diagnostic");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvUpdtRecordOrDiagType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvUpdtRecordOrDiagType() */
 
void convert_DbvExtServicesTaskStatus(char **text, DbvExtServicesTaskStatus *peExtServicesTaskStatus)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("ESTS_Pending", *text) == 0)
         *peExtServicesTaskStatus = ESTS_Pending;
      else
      if(strcmp("ESTS_Active", *text) == 0)
         *peExtServicesTaskStatus = ESTS_Active;
      else
      if(strcmp("ESTS_Complete", *text) == 0)
         *peExtServicesTaskStatus = ESTS_Complete;
      else
      if(strcmp("ESTS_Aborted", *text) == 0)
         *peExtServicesTaskStatus = ESTS_Aborted;
      else
      if(strcmp("ESTS_Invalid", *text) == 0)
         *peExtServicesTaskStatus = ESTS_Invalid;
      else
         printf("Warning: DbvExtServicesTaskStatus string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peExtServicesTaskStatus == ESTS_Pending )
         strcpy(temp, "ESTS_Pending");

      if( *peExtServicesTaskStatus == ESTS_Active)
         strcpy(temp, "ESTS_Active");

      if( *peExtServicesTaskStatus == ESTS_Complete)
         strcpy(temp, "ESTS_Complete");

      if( *peExtServicesTaskStatus == ESTS_Aborted)
         strcpy(temp, "ESTS_Aborted");

      if( *peExtServicesTaskStatus == ESTS_Invalid)
         strcpy(temp, "ESTS_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvExtServicesTaskStatus enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvExtServicesTaskStatus() */
 
void convert_DbvPermAllowableFunctions(char **text, 
			DbvPermAllowableFunctions *pePermAllowableFunctions )
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("PAF_Delete", *text) == 0)
         *pePermAllowableFunctions = PAF_Delete;
      else
      if(strcmp("PAF_ModifyContents", *text) == 0)
         *pePermAllowableFunctions = PAF_ModifyContents;
      else
      if(strcmp("PAF_ModifyPermissions", *text) == 0)
         *pePermAllowableFunctions = PAF_ModifyPermissions;
      else
      if(strcmp("PAF_Present", *text) == 0)
         *pePermAllowableFunctions = PAF_Present;
      else
      if(strcmp("PAF_Invoke", *text) == 0)
         *pePermAllowableFunctions = PAF_Invoke;
      else
      if(strcmp("PAF_Invalid", *text) == 0)
         *pePermAllowableFunctions = PAF_Invalid;
      else
         printf("Warning: DbvPermAllowableFunctions string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *pePermAllowableFunctions == PAF_Delete )
         strcpy(temp, "PAF_Delete");

      if( *pePermAllowableFunctions == PAF_ModifyContents)
         strcpy(temp, "PAF_ModifyContents");

      if( *pePermAllowableFunctions == PAF_ModifyPermissions)
         strcpy(temp, "PAF_ModifyPermissions");

      if( *pePermAllowableFunctions == PAF_Present)
         strcpy(temp, "PAF_Present");

      if( *pePermAllowableFunctions == PAF_Invoke)
         strcpy(temp, "PAF_Invoke");

      if( *pePermAllowableFunctions == PAF_Invalid)
         strcpy(temp, "PAF_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvPermAllowableFunctions enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvPermAllowableFunctions() */

void convert_DbvRpnQueryType(char **text, DBVRpnQueryType *peRpnQueryType)
{
   int length;
   char temp[ SML_BUFFER ];
 
   if( *text != NULL )
      {
      if(strcmp("RPN_Q1", *text) == 0)
         *peRpnQueryType = RPN_Q1;
      else
      if(strcmp("RPN_Q2", *text) == 0)
         *peRpnQueryType = RPN_Q2;
      else
      if(strcmp("RPN_Q3", *text) == 0)
         *peRpnQueryType = RPN_Q3;
      else
         printf("Warning: eRpnQueryType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peRpnQueryType == RPN_Q1 )
         strcpy(temp, "RPN_Q1");
 
      if( *peRpnQueryType == RPN_Q2)
         strcpy(temp, "RPN_Q2");
 
      if( *peRpnQueryType == RPN_Q3)
         strcpy(temp, "RPN_Q3");
 
      length = strlen( temp );
      if( length )
         {
         *text = (char *)malloc( length + 1 );
         strcpy(*text, temp);
         } /* End if */
      else
         printf("Warning: eRpnQueryType enum could not be converted!\n");
      } /* End else */
} /* convert_DbvRpnQueryType */

void convert_DbvProximityRelationType(char **text, DbvProximityRelationType 
	*peProximityRelationType)
{
   int length;
   char temp[ SML_BUFFER ];
 
   if( *text != NULL )
      {
      if(strcmp("PRT_LessThan", *text) == 0)
         *peProximityRelationType = PRT_LessThan;
      else
      if(strcmp("PRT_LessThanOrEqual", *text) == 0)
         *peProximityRelationType = PRT_LessThanOrEqual;
      else
      if(strcmp("PRT_Equal", *text) == 0)
         *peProximityRelationType = PRT_Equal;
      else
      if(strcmp("PRT_GreaterThanOrEqual", *text) == 0)
         *peProximityRelationType = PRT_GreaterThanOrEqual;
      else
      if(strcmp("PRT_GreaterThan", *text) == 0)
         *peProximityRelationType = PRT_GreaterThan;
      else
      if(strcmp("PRT_NotEqual", *text) == 0)
         *peProximityRelationType = PRT_NotEqual;
      else
      if(strcmp("PRT_Invalid", *text) == 0)
         *peProximityRelationType = PRT_Invalid;
      else
         printf("Warning: peProximityRelationType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peProximityRelationType == PRT_LessThan )
         strcpy(temp, "PRT_LessThan");
      if( *peProximityRelationType == PRT_LessThanOrEqual )
         strcpy(temp, "PRT_LessThanOrEqual");
      if( *peProximityRelationType == PRT_Equal )
         strcpy(temp, "PRT_Equal");
      if( *peProximityRelationType == PRT_GreaterThanOrEqual )
         strcpy(temp, "PRT_GreaterThanOrEqual");
      if( *peProximityRelationType == PRT_GreaterThan )
         strcpy(temp, "PRT_GreaterThan");
      if( *peProximityRelationType == PRT_NotEqual )
         strcpy(temp, "PRT_NotEqual");
      if( *peProximityRelationType == PRT_Invalid )
         strcpy(temp, "PRT_Invalid");
 
      length = strlen( temp );
      if( length )
         {
         *text = (char *)malloc( length + 1 );
         strcpy(*text, temp);
         } /* End if */
      else
         printf("Warning: peProximityRelationType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvProximityRelationType */


void convert_DbvProximityUnitType(char **text, DbvProximityUnitType 
	*peProximityUnitType)
{
   int length;
   char temp[ SML_BUFFER ];
 
   if( *text != NULL )
      {
      if(strcmp("PUT_Known", *text) == 0)
         *peProximityUnitType = PUT_Known;
      else
      if(strcmp("PUT_Private", *text) == 0)
         *peProximityUnitType = PUT_Private;
      else
         printf("Warning: peProximityUnitType string could not be converted: %s\n",*text);
      } /* End if */
   else
      {
      temp[ 0 ] = '\0';
      if( *peProximityUnitType == PUT_Known )
         strcpy(temp, "PUT_Known");
      if( *peProximityUnitType == PUT_Private )
         strcpy(temp, "PUT_Private");
 
      length = strlen( temp );
      if( length )
         {
         *text = (char *)malloc( length + 1 );
         strcpy(*text, temp);
         } /* End if */
      else
         printf("Warning: peProximityUnitType enum could not be converted!\n ");
      } /* End else */
   } /* End convert_DbvProximityUnitType */


void convert_DbvKnownProximityUnit(char **text, DbvKnownProximityUnit 
	*peKnownProximityUnit)
{
   int length;
   char temp[ SML_BUFFER ];
 
   if( *text != NULL )
      {
      if(strcmp("KPU_Character", *text) == 0)
         *peKnownProximityUnit = KPU_Character;
      else
      if(strcmp("KPU_Word", *text) == 0)
         *peKnownProximityUnit = KPU_Word;
      else
      if(strcmp("KPU_Sentence", *text) == 0)
         *peKnownProximityUnit = KPU_Sentence;
      else
      if(strcmp("KPU_Paragraph", *text) == 0)
         *peKnownProximityUnit = KPU_Paragraph;
      else
      if(strcmp("KPU_Section", *text) == 0)
         *peKnownProximityUnit = KPU_Section;
      else
      if(strcmp("KPU_Chapter", *text) == 0)
         *peKnownProximityUnit = KPU_Chapter;
      else
      if(strcmp("KPU_Document", *text) == 0)
         *peKnownProximityUnit = KPU_Document;
      else
      if(strcmp("KPU_Element", *text) == 0)
         *peKnownProximityUnit = KPU_Element;
      else
      if(strcmp("KPU_SubElement", *text) == 0)
         *peKnownProximityUnit = KPU_SubElement;
      else
      if(strcmp("KPU_ElementType", *text) == 0)
         *peKnownProximityUnit = KPU_ElementType;
      else
      if(strcmp("KPU_Byte", *text) == 0)
         *peKnownProximityUnit = KPU_Byte;
      else
      if(strcmp("KPU_Invalid", *text) == 0)
         *peKnownProximityUnit = KPU_Invalid;
      else
         printf("Warning: peKnownProximityUnit string could not be converted: %s\n",*text);
      } /* End if */
   else
      {
      temp[ 0 ] = '\0';
      if( *peKnownProximityUnit == KPU_Character )
         strcpy(temp, "KPU_Character");
      if( *peKnownProximityUnit == KPU_Word )
         strcpy(temp, "KPU_Word");
      if( *peKnownProximityUnit == KPU_Sentence )
         strcpy(temp, "KPU_Sentence");
      if( *peKnownProximityUnit == KPU_Paragraph )
         strcpy(temp, "KPU_Paragraph");
      if( *peKnownProximityUnit == KPU_Section )
         strcpy(temp, "KPU_Section");
      if( *peKnownProximityUnit == KPU_Chapter )
         strcpy(temp, "KPU_Chapter");
      if( *peKnownProximityUnit == KPU_Document )
         strcpy(temp, "KPU_Document");
      if( *peKnownProximityUnit == KPU_Element )
         strcpy(temp, "KPU_Element");
      if( *peKnownProximityUnit == KPU_SubElement )
         strcpy(temp, "KPU_SubElement");
      if( *peKnownProximityUnit == KPU_ElementType )
         strcpy(temp, "KPU_ElementType");
      if( *peKnownProximityUnit == KPU_Byte )
         strcpy(temp, "KPU_Byte");
      if( *peKnownProximityUnit == KPU_Invalid )
         strcpy(temp, "KPU_Invalid");
 
      length = strlen( temp );
      if( length )
         {
         *text = (char *)malloc( length + 1 );
         strcpy(*text, temp);
         } /* End if */
      else
         printf("Warning: peKnownProximityUnit enum could not be converted!\n ");
      } /* End else */
   } /* End convert_DbvKnownProximityUnit */
 
void convert_DbvTraceLevel(char **text,
                         DbvTraceLevel *peTraceLevel)
   {
   int length;
   char temp[ SML_BUFFER ];
 
   if( *text != NULL )
      {
      if(strcmp("Trace_Off", *text) == 0)
         *peTraceLevel = Trace_Off;
      else
      if(strcmp("Trace_Low", *text) == 0)
         *peTraceLevel = Trace_Low;
      else
      if(strcmp("Trace_High", *text) == 0)
         *peTraceLevel = Trace_High;
      else
         printf("Warning: DbvTraceLevel string could not be converted: %s\n",
                *text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peTraceLevel == Trace_Off )
         strcpy(temp, "Trace_Off");
 
      if( *peTraceLevel == Trace_Low )
         strcpy(temp, "Trace_Low");
 
      if( *peTraceLevel == Trace_High )
         strcpy(temp, "Trace_High");
 
      length = strlen( temp );
      if( length )
         {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
         } /* End if */
      else
         printf("Warning: DbvTraceLevel enum could not be converted!\n ");
      } /* End else */
   } /* End convert_DbvUpdtRecordOrDiagType() */
 
/* Added by Dan Maskell for Item Order and Ill Support */

void convert_DbvIllPduType(char **text, DbvIllPduType *peIllPduType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("ILL_IllRequest", *text) == 0)
         *peIllPduType = ILL_IllRequest;
      else
      if(strcmp("ILL_StatusOrErrorReport", *text) == 0)
         *peIllPduType = ILL_StatusOrErrorReport;
      else
      if(strcmp("ILL_Invalid", *text) == 0)
         *peIllPduType = ILL_Invalid;
      else
         printf("Warning: DbvIllPduType string could not be converted: %s\n",
			*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peIllPduType == ILL_IllRequest)
         strcpy(temp, "ILL_IllRequest");

      if( *peIllPduType == ILL_StatusOrErrorReport )
         strcpy(temp, "ILL_StatusOrErrorReport");

      if( *peIllPduType == ILL_Invalid)
         strcpy(temp, "ILL_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvIllPduType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvIllPduType() */

void convert_DbvEsIoAuxiliaryStatus(char **text,
			DbvEsIoAuxiliaryStatus *peEsIoAuxiliaryStatus)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("IOAS_NotReceived", *text) == 0)
         *peEsIoAuxiliaryStatus = IOAS_NotReceived;
      else
      if(strcmp("IOAS_LoanQueue", *text) == 0)
         *peEsIoAuxiliaryStatus = IOAS_LoanQueue;
      else
      if(strcmp("IOAS_Forwarded", *text) == 0)
         *peEsIoAuxiliaryStatus = IOAS_Forwarded;
      else
      if(strcmp("IOAS_UnfilledCopyright", *text) == 0)
         *peEsIoAuxiliaryStatus = IOAS_UnfilledCopyright;
      else
      if(strcmp("IOAS_FilledCopyright", *text) == 0)
         *peEsIoAuxiliaryStatus = IOAS_FilledCopyright;
      else
      if(strcmp("IOAS_Invalid", *text) == 0)
         *peEsIoAuxiliaryStatus = IOAS_Invalid;
      else
         printf("Warning: DbvEsIoAuxiliaryStatus string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peEsIoAuxiliaryStatus == IOAS_NotReceived)
         strcpy(temp, "IOAS_NotReceived");

      if( *peEsIoAuxiliaryStatus == IOAS_LoanQueue)
         strcpy(temp, "IOAS_LoanQueue");

      if( *peEsIoAuxiliaryStatus == IOAS_Forwarded)
         strcpy(temp, "IOAS_Forwarded");

      if( *peEsIoAuxiliaryStatus == IOAS_UnfilledCopyright)
         strcpy(temp, "IOAS_UnfilledCopyright");

      if( *peEsIoAuxiliaryStatus == IOAS_FilledCopyright)
         strcpy(temp, "IOAS_FilledCopyright");

      if( *peEsIoAuxiliaryStatus == IOAS_Invalid)
         strcpy(temp, "IOAS_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvEsIoAuxiliaryStatus enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvEsIoAuxiliaryStatus() */


void convert_DbvEsIoPaymentMethodType(char **text,
			DbvEsIoPaymentMethodType *peEsIoPaymentMethodType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("IOPM_BillInvoice", *text) == 0)
         *peEsIoPaymentMethodType = IOPM_BillInvoice;
      else
      if(strcmp("IOPM_Prepay", *text) == 0)
         *peEsIoPaymentMethodType = IOPM_Prepay;
      else
      if(strcmp("IOPM_DepositAccount", *text) == 0)
         *peEsIoPaymentMethodType = IOPM_DepositAccount;
      else
      if(strcmp("IOPM_CreditCard", *text) == 0)
         *peEsIoPaymentMethodType = IOPM_CreditCard;
      else
      if(strcmp("IOPM_CardInfoPrevSupplied", *text) == 0)
         *peEsIoPaymentMethodType = IOPM_CardInfoPrevSupplied;
      else
      if(strcmp("IOPM_PrivateKnown", *text) == 0)
         *peEsIoPaymentMethodType = IOPM_PrivateKnown;
      else
      if(strcmp("IOPM_PrivateNotKnown", *text) == 0)
         *peEsIoPaymentMethodType = IOPM_PrivateNotKnown;
      else
      if(strcmp("IOPM_Invalid", *text) == 0)
         *peEsIoPaymentMethodType = IOPM_Invalid;
      else
         printf("Warning: DbvEsIoPaymentMethodType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peEsIoPaymentMethodType == IOPM_BillInvoice)
         strcpy(temp, "IOPM_BillInvoice");

      if( *peEsIoPaymentMethodType == IOPM_Prepay)
         strcpy(temp, "IOPM_Prepay");

      if( *peEsIoPaymentMethodType == IOPM_DepositAccount)
         strcpy(temp, "IOPM_DepositAccount");

      if( *peEsIoPaymentMethodType == IOPM_CreditCard)
         strcpy(temp, "IOPM_CreditCard");

      if( *peEsIoPaymentMethodType == IOPM_CardInfoPrevSupplied)
         strcpy(temp, "IOPM_CardInfoPrevSupplied");

      if( *peEsIoPaymentMethodType == IOPM_PrivateKnown)
         strcpy(temp, "IOPM_PrivateKnown");

      if( *peEsIoPaymentMethodType == IOPM_PrivateNotKnown)
         strcpy(temp, "IOPM_PrivateNotKnown");

      if( *peEsIoPaymentMethodType == IOPM_Invalid)
         strcpy(temp, "IOPM_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvEsIoPaymentMethodType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvEsIoPaymentMethodType() */


void convert_DbvItemOrderReqOrRsp(char **text,
			DbvItemOrderReqOrRsp *peItemOrderReqOrRsp)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("IOROR_Request", *text) == 0)
         *peItemOrderReqOrRsp = IOROR_Request;
      else
      if(strcmp("IOROR_Response", *text) == 0)
         *peItemOrderReqOrRsp = IOROR_Response;
      else
         printf("Warning: DbvItemOrderReqOrRsp string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peItemOrderReqOrRsp == IOROR_Request)
         strcpy(temp, "IOROR_Request");

      if( *peItemOrderReqOrRsp == IOROR_Response)
         strcpy(temp, "IOROR_Response");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvItemOrderReqOrRsp enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvItemOrderReqOrRsp() */


void convert_DbvIllStringType(char **text,
			DbvIllStringType *peIllStringType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("ST_GeneralString", *text) == 0)
         *peIllStringType = ST_GeneralString;
      else
      if(strcmp("ST_EdifactString", *text) == 0)
         *peIllStringType = ST_EdifactString;
      else
         printf("Warning: DbvIllStringType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peIllStringType == ST_GeneralString)
         strcpy(temp, "ST_GeneralString");

      if( *peIllStringType == ST_EdifactString)
         strcpy(temp, "ST_EdifactString");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvIllStringType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvIllStringType() */

void convert_DbvIllProtocolVersion(char **text,
			DbvIllProtocolVersion *peIllProtocolVersion)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("PV_Version1", *text) == 0)
         *peIllProtocolVersion = PV_Version1;
      else
      if(strcmp("PV_Version2", *text) == 0)
         *peIllProtocolVersion = PV_Version2;
      else
      if(strcmp("PV_Invalid", *text) == 0)
         *peIllProtocolVersion = PV_Invalid;
      else
         printf("Warning: DbvIllProtocolVersion string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peIllProtocolVersion == PV_Version1)
         strcpy(temp, "PV_Version1");

      if( *peIllProtocolVersion == PV_Version2)
         strcpy(temp, "PV_Version2");

      if( *peIllProtocolVersion == PV_Invalid)
         strcpy(temp, "PV_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvIllProtocolVersion enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvIllProtocolVersion() */

void convert_DbvNameOfPersOrInstType(char **text,
			DbvNameOfPersOrInstType *peNameOfPersOrInstType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("NPI_NameOfPerson", *text) == 0)
         *peNameOfPersOrInstType = NPI_NameOfPerson;
      else
      if(strcmp("NPI_NameOfInstitution", *text) == 0)
         *peNameOfPersOrInstType = NPI_NameOfInstitution;
      else
         printf("Warning: DbvNameOfPersOrInstType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peNameOfPersOrInstType == NPI_NameOfPerson)
         strcpy(temp, "NPI_NameOfPerson");

      if( *peNameOfPersOrInstType == NPI_NameOfInstitution)
         strcpy(temp, "NPI_NameOfInstitution");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvNameOfPersOrInstType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvNameOfPersOrInstType() */

void convert_DbvPersOrInstSymbolType(char **text,
			DbvPersOrInstSymbolType *pePersOrInstSymbolType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("SPI_PersonSymbol", *text) == 0)
         *pePersOrInstSymbolType = SPI_PersonSymbol;
      else
      if(strcmp("SPI_InstitutionSymbol", *text) == 0)
         *pePersOrInstSymbolType = SPI_InstitutionSymbol;
      else
         printf("Warning: DbvPersOrInstSymbolType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *pePersOrInstSymbolType == SPI_PersonSymbol)
         strcpy(temp, "SPI_PersonSymbol");

      if( *pePersOrInstSymbolType == SPI_InstitutionSymbol)
         strcpy(temp, "SPI_InstitutionSymbol");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvPersOrInstSymbolType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvPersOrInstSymbolType() */


void convert_DbvTransactionType(char **text,
			DbvTransactionType *peTransactionType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("TT_Simple", *text) == 0)
         *peTransactionType = TT_Simple;
      else
      if(strcmp("TT_Chained", *text) == 0)
         *peTransactionType = TT_Chained;
      else
      if(strcmp("TT_Partitioned", *text) == 0)
         *peTransactionType = TT_Partitioned;
      else
      if(strcmp("TT_Invalid", *text) == 0)
         *peTransactionType = TT_Invalid;
      else
         printf("Warning: DbvTransactionType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peTransactionType == TT_Simple)
         strcpy(temp, "TT_Simple");

      if( *peTransactionType == TT_Chained)
         strcpy(temp, "TT_Chained");

      if( *peTransactionType == TT_Partitioned)
         strcpy(temp, "TT_Partitioned");

      if( *peTransactionType == TT_Invalid)
         strcpy(temp, "TT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvTransactionType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvTransactionType() */

void convert_DbvDeliveryServiceType(char **text,
			DbvDeliveryServiceType *peDeliveryServiceType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("DST_PhysicalDelivery", *text) == 0)
         *peDeliveryServiceType = DST_PhysicalDelivery;
      else
      if(strcmp("DST_ElectronicDelivery", *text) == 0)
         *peDeliveryServiceType = DST_ElectronicDelivery;
      else
      if(strcmp("DST_Invalid", *text) == 0)
         *peDeliveryServiceType = DST_Invalid;
      else
         printf("Warning: DbvDeliveryServiceType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peDeliveryServiceType == DST_PhysicalDelivery)
         strcpy(temp, "DST_PhysicalDelivery");

      if( *peDeliveryServiceType == DST_ElectronicDelivery)
         strcpy(temp, "DST_ElectronicDelivery");

      if( *peDeliveryServiceType == DST_Invalid)
         strcpy(temp, "DST_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvDeliveryServiceType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvDeliveryServiceType() */


void convert_DbvElDeliveryDetailsType(char **text,
			DbvElDeliveryDetailsType *peElDeliveryDetailsType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("DDT_SystemAddress", *text) == 0)
         *peElDeliveryDetailsType = DDT_SystemAddress;
      else
      if(strcmp("DDT_SystemId", *text) == 0)
         *peElDeliveryDetailsType = DDT_SystemId;
      else
         printf("Warning: DbvDeliveryServiceType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peElDeliveryDetailsType == DDT_SystemAddress)
         strcpy(temp, "DDT_SystemAddress");

      if( *peElDeliveryDetailsType == DDT_SystemId)
         strcpy(temp, "DDT_SystemId");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvElDeliveryDetailsType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvElDeliveryDetailsType() */


void convert_DbvServiceType(char **text, DbvServiceType *peServiceType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("ST_Loan", *text) == 0)
         *peServiceType = ST_Loan;
      else
      if(strcmp("ST_CopyNonReturnable", *text) == 0)
         *peServiceType = ST_CopyNonReturnable;
      else
      if(strcmp("ST_Locations", *text) == 0)
         *peServiceType = ST_Locations;
      else
      if(strcmp("ST_Estimate", *text) == 0)
         *peServiceType = ST_Estimate;
      else
      if(strcmp("ST_ResponderSpecific", *text) == 0)
         *peServiceType = ST_ResponderSpecific;
      else
      if(strcmp("ST_Invalid", *text) == 0)
         *peServiceType = ST_Invalid;
      else
         printf("Warning: DbvServiceType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peServiceType == ST_Loan)
         strcpy(temp, "ST_Loan");

      if( *peServiceType == ST_CopyNonReturnable)
         strcpy(temp, "ST_CopyNonReturnable");

      if( *peServiceType == ST_Locations)
         strcpy(temp, "ST_Locations");

      if( *peServiceType == ST_Estimate)
         strcpy(temp, "ST_Estimate");

      if( *peServiceType == ST_ResponderSpecific)
         strcpy(temp, "ST_ResponderSpecific");

      if( *peServiceType == ST_Invalid)
         strcpy(temp, "ST_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvServiceType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvServiceType() */


void convert_DbvOptionalMsgRequirements(char **text,
			DbvOptionalMsgRequirements *peOptionalMsgRequirements)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("OMR_Requires", *text) == 0)
         *peOptionalMsgRequirements = OMR_Requires;
      else
      if(strcmp("OMR_Desires", *text) == 0)
         *peOptionalMsgRequirements = OMR_Desires;
      else
      if(strcmp("OMR_Neither", *text) == 0)
         *peOptionalMsgRequirements = OMR_Neither;
      else
      if(strcmp("OMR_Invalid", *text) == 0)
         *peOptionalMsgRequirements = OMR_Invalid;
      else
         printf("Warning: DbvOptionalMsgRequirements string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peOptionalMsgRequirements == OMR_Requires)
         strcpy(temp, "OMR_Requires");

      if( *peOptionalMsgRequirements == OMR_Desires)
         strcpy(temp, "OMR_Desires");

      if( *peOptionalMsgRequirements == OMR_Neither)
         strcpy(temp, "OMR_Neither");

      if( *peOptionalMsgRequirements == OMR_Invalid)
         strcpy(temp, "OMR_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvOptionalMsgRequirements enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvOptionalMsgRequirements() */


void convert_DbvExpiry(char **text, DbvExpiry *peExpiry)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("EXP_NeedBeforeDate", *text) == 0)
         *peExpiry = EXP_NeedBeforeDate;
      else
      if(strcmp("EXP_OtherDate", *text) == 0)
         *peExpiry = EXP_OtherDate;
      else
      if(strcmp("EXP_NoExpiry", *text) == 0)
         *peExpiry = EXP_NoExpiry;
      else
      if(strcmp("EXP_Invalid", *text) == 0)
         *peExpiry = EXP_Invalid;
      else
         printf("Warning: DbvExpiry string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peExpiry == EXP_NeedBeforeDate)
         strcpy(temp, "EXP_NeedBeforeDate");

      if( *peExpiry == EXP_OtherDate)
         strcpy(temp, "EXP_OtherDate");

      if( *peExpiry == EXP_NoExpiry)
         strcpy(temp, "EXP_NoExpiry");

      if( *peExpiry == EXP_Invalid)
         strcpy(temp, "EXP_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvExpiry enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvExpiry() */


void convert_DbvSupplyMediumType(char **text,
			DbvSupplyMediumType *peSupplyMediumType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("SMT_Printed", *text) == 0)
         *peSupplyMediumType = SMT_Printed;
      else
      if(strcmp("SMT_Photocopy", *text) == 0)
         *peSupplyMediumType = SMT_Photocopy;
      else
      if(strcmp("SMT_Microform", *text) == 0)
         *peSupplyMediumType = SMT_Microform;
      else
      if(strcmp("SMT_FilmOrVideoRecording", *text) == 0)
         *peSupplyMediumType = SMT_FilmOrVideoRecording;
      else
      if(strcmp("SMT_AudioRecording", *text) == 0)
         *peSupplyMediumType = SMT_AudioRecording;
      else
      if(strcmp("SMT_MachineReadable", *text) == 0)
         *peSupplyMediumType = SMT_MachineReadable;
      else
      if(strcmp("SMT_Other", *text) == 0)
         *peSupplyMediumType = SMT_Other;
      else
      if(strcmp("SMT_Invalid", *text) == 0)
         *peSupplyMediumType = SMT_Invalid;
      else
         printf("Warning: DbvSupplyMediumType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peSupplyMediumType == SMT_Printed)
         strcpy(temp, "SMT_Printed");

      if( *peSupplyMediumType == SMT_Photocopy)
         strcpy(temp, "SMT_Photocopy");

      if( *peSupplyMediumType == SMT_Microform)
         strcpy(temp, "SMT_Microform");

      if( *peSupplyMediumType == SMT_FilmOrVideoRecording)
         strcpy(temp, "SMT_FilmOrVideoRecording");

      if( *peSupplyMediumType == SMT_AudioRecording)
         strcpy(temp, "SMT_AudioRecording");

      if( *peSupplyMediumType == SMT_MachineReadable)
         strcpy(temp, "SMT_MachineReadable");

      if( *peSupplyMediumType == SMT_Other)
         strcpy(temp, "SMT_Other");

      if( *peSupplyMediumType == SMT_Invalid)
         strcpy(temp, "SMT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvSupplyMediumType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvSupplyMediumType() */


void convert_DbvPlaceOnHold(char **text, DbvPlaceOnHold *pePlaceOnHold)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("POH_Yes", *text) == 0)
         *pePlaceOnHold = POH_Yes;
      else
      if(strcmp("POH_No", *text) == 0)
         *pePlaceOnHold = POH_No;
      else
      if(strcmp("POH_ResponderPolicy", *text) == 0)
         *pePlaceOnHold = POH_ResponderPolicy;
      else
      if(strcmp("POH_Invalid", *text) == 0)
         *pePlaceOnHold = POH_Invalid;
      else
         printf("Warning: DbvPlaceOnHold string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *pePlaceOnHold == POH_Yes)
         strcpy(temp, "POH_Yes");

      if( *pePlaceOnHold == POH_No)
         strcpy(temp, "POH_No");

      if( *pePlaceOnHold == POH_ResponderPolicy)
         strcpy(temp, "POH_ResponderPolicy");

      if( *pePlaceOnHold == POH_Invalid)
         strcpy(temp, "POH_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvPlaceOnHold enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvPlaceOnHold() */


void convert_DbvItemType(char **text, DbvItemType *peItemType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("IT_Monograph", *text) == 0)
         *peItemType = IT_Monograph;
      else
      if(strcmp("IT_Serial", *text) == 0)
         *peItemType = IT_Serial;
      else
      if(strcmp("IT_Other", *text) == 0)
         *peItemType = IT_Other;
      else
      if(strcmp("IT_Invalid", *text) == 0)
         *peItemType = IT_Invalid;
      else
         printf("Warning: DbvItemType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peItemType == IT_Monograph)
         strcpy(temp, "IT_Monograph");

      if( *peItemType == IT_Serial)
         strcpy(temp, "IT_Serial");

      if( *peItemType == IT_Other)
         strcpy(temp, "IT_Other");

      if( *peItemType == IT_Invalid)
         strcpy(temp, "IT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvItemType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvItemType() */


void convert_DbvMediumType(char **text, DbvMediumType *peMediumType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("MT_Printed", *text) == 0)
         *peMediumType = MT_Printed;
      else
      if(strcmp("MT_Microform", *text) == 0)
         *peMediumType = MT_Microform;
      else
      if(strcmp("MT_FilmOrVideoRecording", *text) == 0)
         *peMediumType = MT_FilmOrVideoRecording;
      else
      if(strcmp("MT_AudioRecording", *text) == 0)
         *peMediumType = MT_AudioRecording;
      else
      if(strcmp("MT_MachineReadable", *text) == 0)
         *peMediumType = MT_MachineReadable;
      else
      if(strcmp("MT_Other", *text) == 0)
         *peMediumType = MT_Other;
      else
      if(strcmp("MT_Invalid", *text) == 0)
         *peMediumType = MT_Invalid;
      else
         printf("Warning: DbvMediumType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peMediumType == MT_Printed)
         strcpy(temp, "MT_Printed");

      if( *peMediumType == MT_Microform)
         strcpy(temp, "MT_Microform");

      if( *peMediumType == MT_FilmOrVideoRecording)
         strcpy(temp, "MT_FilmOrVideoRecording");

      if( *peMediumType == MT_AudioRecording)
         strcpy(temp, "MT_AudioRecording");

      if( *peMediumType == MT_MachineReadable)
         strcpy(temp, "MT_MachineReadable");

      if( *peMediumType == MT_Other)
         strcpy(temp, "MT_Other");

      if( *peMediumType == MT_Invalid)
         strcpy(temp, "MT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvMediumType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvMediumType() */


void convert_DbvPreference(char **text, DbvPreference *pePreference)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("PRE_Ordered", *text) == 0)
         *pePreference = PRE_Ordered;
      else
      if(strcmp("PRE_Unordered", *text) == 0)
         *pePreference = PRE_Unordered;
      else
      if(strcmp("PRE_Invalid", *text) == 0)
         *pePreference = PRE_Invalid;
      else
         printf("Warning: DbvPreference string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *pePreference == PRE_Ordered)
         strcpy(temp, "PRE_Ordered");

      if( *pePreference == PRE_Unordered)
         strcpy(temp, "PRE_Unordered");

      if( *pePreference == PRE_Invalid)
         strcpy(temp, "PRE_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvPreference enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvPreference() */


void convert_DbvTransactionResults(char **text, 
			DbvTransactionResults *peTransactionResults)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("TR_Conditional", *text) == 0)
         *peTransactionResults = TR_Conditional;
      else
      if(strcmp("TR_Retry", *text) == 0)
         *peTransactionResults = TR_Retry;
      else
      if(strcmp("TR_Unfilled", *text) == 0)
         *peTransactionResults = TR_Unfilled;
      else
      if(strcmp("TR_LocationsProvided", *text) == 0)
         *peTransactionResults = TR_LocationsProvided;
      else
      if(strcmp("TR_WillSupply", *text) == 0)
         *peTransactionResults = TR_WillSupply;
      else
      if(strcmp("TR_HoldPlaced", *text) == 0)
         *peTransactionResults = TR_HoldPlaced;
      else
      if(strcmp("TR_Estimate", *text) == 0)
         *peTransactionResults = TR_Estimate;
      else
      if(strcmp("TR_Invalid", *text) == 0)
         *peTransactionResults = TR_Invalid;
      else
         printf("Warning: DbvTransactionResults string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peTransactionResults == TR_Conditional)
         strcpy(temp, "TR_Conditional");

      if( *peTransactionResults == TR_Retry)
         strcpy(temp, "TR_Retry");

      if( *peTransactionResults == TR_Unfilled)
         strcpy(temp, "TR_Unfilled");

      if( *peTransactionResults == TR_LocationsProvided)
         strcpy(temp, "TR_LocationsProvided");

      if( *peTransactionResults == TR_WillSupply)
         strcpy(temp, "TR_WillSupply");

      if( *peTransactionResults == TR_HoldPlaced)
         strcpy(temp, "TR_HoldPlaced");

      if( *peTransactionResults == TR_Estimate)
         strcpy(temp, "TR_Estimate");

      if( *peTransactionResults == TR_Invalid)
         strcpy(temp, "TR_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvTransactionResults enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvTransactionResults() */


void convert_DbvMostRecentService(char **text, 
			DbvMostRecentService *peMostRecentService)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("MRS_IllRequest", *text) == 0)
         *peMostRecentService = MRS_IllRequest;
      else
      if(strcmp("MRS_Forward", *text) == 0)
         *peMostRecentService = MRS_Forward;
      else
      if(strcmp("MRS_ForwardNotification", *text) == 0)
         *peMostRecentService = MRS_ForwardNotification;
      else
      if(strcmp("MRS_Shipped", *text) == 0)
         *peMostRecentService = MRS_Shipped;
      else
      if(strcmp("MRS_IllAnswer", *text) == 0)
         *peMostRecentService = MRS_IllAnswer;
      else
      if(strcmp("MRS_ConditionalReply", *text) == 0)
         *peMostRecentService = MRS_ConditionalReply;
      else
      if(strcmp("MRS_Cancel", *text) == 0)
         *peMostRecentService = MRS_Cancel;
      else
      if(strcmp("MRS_CancelReply", *text) == 0)
         *peMostRecentService = MRS_CancelReply;
      else
      if(strcmp("MRS_Received", *text) == 0)
         *peMostRecentService = MRS_Received;
      else
      if(strcmp("MRS_Recall", *text) == 0)
         *peMostRecentService = MRS_Recall;
      else
      if(strcmp("MRS_Returned", *text) == 0)
         *peMostRecentService = MRS_Returned;
      else
      if(strcmp("MRS_CheckedIn", *text) == 0)
         *peMostRecentService = MRS_CheckedIn;
      else
      if(strcmp("MRS_RenewAnswer", *text) == 0)
         *peMostRecentService = MRS_RenewAnswer;
      else
      if(strcmp("MRS_Lost", *text) == 0)
         *peMostRecentService = MRS_Lost;
      else
      if(strcmp("MRS_Damaged", *text) == 0)
         *peMostRecentService = MRS_Damaged;
      else
      if(strcmp("MRS_Message", *text) == 0)
         *peMostRecentService = MRS_Message;
      else
      if(strcmp("MRS_StatusQuery", *text) == 0)
         *peMostRecentService = MRS_StatusQuery;
      else
      if(strcmp("MRS_StatusOrErrorReport", *text) == 0)
         *peMostRecentService = MRS_StatusOrErrorReport;
      else
      if(strcmp("MRS_Expired", *text) == 0)
         *peMostRecentService = MRS_Expired;
      else
      if(strcmp("MRS_Invalid", *text) == 0)
         *peMostRecentService = MRS_Invalid;
      else
         printf("Warning: DbvMostRecentService string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peMostRecentService == MRS_IllRequest)
         strcpy(temp, "MRS_IllRequest");

      if( *peMostRecentService == MRS_Forward)
         strcpy(temp, "MRS_Forward");

      if( *peMostRecentService == MRS_ForwardNotification)
         strcpy(temp, "MRS_ForwardNotification");

      if( *peMostRecentService == MRS_Shipped)
         strcpy(temp, "MRS_Shipped");

      if( *peMostRecentService == MRS_IllAnswer)
         strcpy(temp, "MRS_IllAnswer");

      if( *peMostRecentService == MRS_ConditionalReply)
         strcpy(temp, "MRS_ConditionalReply");

      if( *peMostRecentService == MRS_Cancel)
         strcpy(temp, "MRS_Cancel");

      if( *peMostRecentService == MRS_CancelReply)
         strcpy(temp, "MRS_CancelReply");

      if( *peMostRecentService == MRS_Received)
         strcpy(temp, "MRS_Received");

      if( *peMostRecentService == MRS_Recall)
         strcpy(temp, "MRS_Recall");

      if( *peMostRecentService == MRS_Returned)
         strcpy(temp, "MRS_Returned");

      if( *peMostRecentService == MRS_CheckedIn)
         strcpy(temp, "MRS_CheckedIn");

      if( *peMostRecentService == MRS_RenewAnswer)
         strcpy(temp, "MRS_RenewAnswer");

      if( *peMostRecentService == MRS_Lost)
         strcpy(temp, "MRS_Lost");

      if( *peMostRecentService == MRS_Damaged)
         strcpy(temp, "MRS_Damaged");

      if( *peMostRecentService == MRS_Message)
         strcpy(temp, "MRS_Message");

      if( *peMostRecentService == MRS_StatusQuery)
         strcpy(temp, "MRS_StatusQuery");

      if( *peMostRecentService == MRS_StatusOrErrorReport)
         strcpy(temp, "MRS_StatusOrErrorReport");

      if( *peMostRecentService == MRS_Expired)
         strcpy(temp, "MRS_Expired");

      if( *peMostRecentService == MRS_Invalid)
         strcpy(temp, "MRS_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvMostRecentService enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvMostRecentService() */



void convert_DbvShippedServiceType(char **text, 
			DbvShippedServiceType *peShippedServiceType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("SST_Loan", *text) == 0)
         *peShippedServiceType = SST_Loan;
      else
      if(strcmp("SST_CopyNonReturnable", *text) == 0)
         *peShippedServiceType = SST_CopyNonReturnable;
      else
      if(strcmp("SST_Invalid", *text) == 0)
         *peShippedServiceType = SST_Invalid;
      else
         printf("Warning: DbvShippedServiceType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peShippedServiceType == SST_Loan)
         strcpy(temp, "SST_Loan");

      if( *peShippedServiceType == SST_CopyNonReturnable)
         strcpy(temp, "SST_CopyNonReturnable");

      if( *peShippedServiceType == SST_Invalid)
         strcpy(temp, "SST_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvShippedServiceType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvShippedServiceType() */


void convert_DbvCurrentState(char **text, 
			DbvCurrentState *peCurrentState)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("CS_NotSupplied", *text) == 0)
         *peCurrentState = CS_NotSupplied;
      else
      if(strcmp("CS_Pending", *text) == 0)
         *peCurrentState = CS_Pending;
      else
      if(strcmp("CS_InProcess", *text) == 0)
         *peCurrentState = CS_InProcess;
      else
      if(strcmp("CS_Forward", *text) == 0)
         *peCurrentState = CS_Forward;
      else
      if(strcmp("CS_Conditional", *text) == 0)
         *peCurrentState = CS_Conditional;
      else
      if(strcmp("CS_CancelPending", *text) == 0)
         *peCurrentState = CS_CancelPending;
      else
      if(strcmp("CS_Cancelled", *text) == 0)
         *peCurrentState = CS_Cancelled;
      else
      if(strcmp("CS_Shipped", *text) == 0)
         *peCurrentState = CS_Shipped;
      else
      if(strcmp("CS_Received", *text) == 0)
         *peCurrentState = CS_Received;
      else
      if(strcmp("CS_RenewPending", *text) == 0)
         *peCurrentState = CS_RenewPending;
      else
      if(strcmp("CS_NotReceivedOverdue", *text) == 0)
         *peCurrentState = CS_NotReceivedOverdue;
      else
      if(strcmp("CS_RenewOverdue", *text) == 0)
         *peCurrentState = CS_RenewOverdue;
      else
      if(strcmp("CS_Overdue", *text) == 0)
         *peCurrentState = CS_Overdue;
      else
      if(strcmp("CS_Returned", *text) == 0)
         *peCurrentState = CS_Returned;
      else
      if(strcmp("CS_CheckedIn", *text) == 0)
         *peCurrentState = CS_CheckedIn;
      else
      if(strcmp("CS_Recall", *text) == 0)
         *peCurrentState = CS_Recall;
      else
      if(strcmp("CS_Lost", *text) == 0)
         *peCurrentState = CS_Lost;
      else
      if(strcmp("CS_Unknown", *text) == 0)
         *peCurrentState = CS_Unknown;
      else
      if(strcmp("CS_Invalid", *text) == 0)
         *peCurrentState = CS_Invalid;
      else
         printf("Warning: DbvCurrentState string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peCurrentState == CS_NotSupplied)
         strcpy(temp, "CS_NotSupplied");

      if( *peCurrentState == CS_Pending)
         strcpy(temp, "CS_Pending");

      if( *peCurrentState == CS_InProcess)
         strcpy(temp, "CS_InProcess");

      if( *peCurrentState == CS_Forward)
         strcpy(temp, "CS_Forward");

      if( *peCurrentState == CS_Conditional)
         strcpy(temp, "CS_Conditional");

      if( *peCurrentState == CS_CancelPending)
         strcpy(temp, "CS_CancelPending");

      if( *peCurrentState == CS_Cancelled)
         strcpy(temp, "CS_Cancelled");

      if( *peCurrentState == CS_Shipped)
         strcpy(temp, "CS_Shipped");

      if( *peCurrentState == CS_Received)
         strcpy(temp, "CS_Received");

      if( *peCurrentState == CS_RenewPending)
         strcpy(temp, "CS_RenewPending");

      if( *peCurrentState == CS_NotReceivedOverdue)
         strcpy(temp, "CS_NotReceivedOverdue");

      if( *peCurrentState == CS_RenewOverdue)
         strcpy(temp, "CS_RenewOverdue");

      if( *peCurrentState == CS_Overdue)
         strcpy(temp, "CS_Overdue");

      if( *peCurrentState == CS_Returned)
         strcpy(temp, "CS_Returned");

      if( *peCurrentState == CS_CheckedIn)
         strcpy(temp, "CS_CheckedIn");

      if( *peCurrentState == CS_Recall)
         strcpy(temp, "CS_Recall");

      if( *peCurrentState == CS_Lost)
         strcpy(temp, "CS_Lost");

      if( *peCurrentState == CS_Unknown)
         strcpy(temp, "CS_Unknown");

      if( *peCurrentState == CS_Invalid)
         strcpy(temp, "CS_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvCurrentState enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvCurrentState() */


void convert_DbvIllAPDUType(char **text, 
			DbvIllAPDUType *peIllAPDUType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("IAT_IllRequest", *text) == 0)
         *peIllAPDUType = IAT_IllRequest;
      else
      if(strcmp("IAT_ForwardNotification", *text) == 0)
         *peIllAPDUType = IAT_ForwardNotification;
      else
      if(strcmp("IAT_Shipped", *text) == 0)
         *peIllAPDUType = IAT_Shipped;
      else
      if(strcmp("IAT_IllAnswer", *text) == 0)
         *peIllAPDUType = IAT_IllAnswer;
      else
      if(strcmp("IAT_ConditionalReply", *text) == 0)
         *peIllAPDUType = IAT_ConditionalReply;
      else
      if(strcmp("IAT_Cancel", *text) == 0)
         *peIllAPDUType = IAT_Cancel;
      else
      if(strcmp("IAT_CancelReply", *text) == 0)
         *peIllAPDUType = IAT_CancelReply;
      else
      if(strcmp("IAT_Received", *text) == 0)
         *peIllAPDUType = IAT_Received;
      else
      if(strcmp("IAT_Recall", *text) == 0)
         *peIllAPDUType = IAT_Recall;
      else
      if(strcmp("IAT_Returned", *text) == 0)
         *peIllAPDUType = IAT_Returned;
      else
      if(strcmp("IAT_CheckedIn", *text) == 0)
         *peIllAPDUType = IAT_CheckedIn;
      else
      if(strcmp("IAT_Overdue", *text) == 0)
         *peIllAPDUType = IAT_Overdue;
      else
      if(strcmp("IAT_Renew", *text) == 0)
         *peIllAPDUType = IAT_Renew;
      else
      if(strcmp("IAT_RenewAnswer", *text) == 0)
         *peIllAPDUType = IAT_RenewAnswer;
      else
      if(strcmp("IAT_Lost", *text) == 0)
         *peIllAPDUType = IAT_Lost;
      else
      if(strcmp("IAT_Damaged", *text) == 0)
         *peIllAPDUType = IAT_Damaged;
      else
      if(strcmp("IAT_Message", *text) == 0)
         *peIllAPDUType = IAT_Message;
      else
      if(strcmp("IAT_StatusQuery", *text) == 0)
         *peIllAPDUType = IAT_StatusQuery;
      else
      if(strcmp("IAT_StatusOrErrorReport", *text) == 0)
         *peIllAPDUType = IAT_StatusOrErrorReport;
      else
      if(strcmp("IAT_Expired", *text) == 0)
         *peIllAPDUType = IAT_Expired;
      else
      if(strcmp("IAT_Invalid", *text) == 0)
         *peIllAPDUType = IAT_Invalid;
      else
         printf("Warning: DbvIllAPDUType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peIllAPDUType == IAT_IllRequest )
         strcpy(temp, " IAT_IllRequest");

      if( *peIllAPDUType == IAT_ForwardNotification)
         strcpy(temp, "IAT_ForwardNotification");

      if( *peIllAPDUType == IAT_Shipped)
         strcpy(temp, "IAT_Shipped");

      if( *peIllAPDUType == IAT_IllAnswer)
         strcpy(temp, "IAT_IllAnswer");

      if( *peIllAPDUType == IAT_ConditionalReply)
         strcpy(temp, "IAT_ConditionalReply");

      if( *peIllAPDUType == IAT_Cancel)
         strcpy(temp, "IAT_Cancel");

      if( *peIllAPDUType == IAT_CancelReply)
         strcpy(temp, "IAT_CancelReply");

      if( *peIllAPDUType == IAT_Received)
         strcpy(temp, "IAT_Received");

      if( *peIllAPDUType == IAT_Recall)
         strcpy(temp, "IAT_Recall");

      if( *peIllAPDUType == IAT_Returned)
         strcpy(temp, "IAT_Returned");

      if( *peIllAPDUType == IAT_CheckedIn)
         strcpy(temp, "IAT_CheckedIn");

      if( *peIllAPDUType == IAT_Overdue)
         strcpy(temp, "IAT_Overdue");

      if( *peIllAPDUType == IAT_Renew)
         strcpy(temp, "IAT_Renew");

      if( *peIllAPDUType == IAT_RenewAnswer)
         strcpy(temp, "IAT_RenewAnswer");

      if( *peIllAPDUType == IAT_Lost)
         strcpy(temp, "IAT_Lost");

      if( *peIllAPDUType == IAT_Damaged)
         strcpy(temp, "IAT_Damaged");

      if( *peIllAPDUType == IAT_Message)
         strcpy(temp, "IAT_Message");

      if( *peIllAPDUType == IAT_StatusQuery)
         strcpy(temp, "IAT_StatusQuery");

      if( *peIllAPDUType == IAT_StatusOrErrorReport)
         strcpy(temp, "IAT_StatusOrErrorReport");

      if( *peIllAPDUType == IAT_Expired)
         strcpy(temp, "IAT_Expired");

      if( *peIllAPDUType == IAT_Invalid)
         strcpy(temp, "IAT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvIllAPDUType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvIllAPDUType() */


void convert_DbvReportSource(char **text, DbvReportSource *peReportSource)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("RS_User", *text) == 0)
         *peReportSource = RS_User;
      else
      if(strcmp("RS_Provider", *text) == 0)
         *peReportSource = RS_Provider;
      else
         printf("Warning: DbvReportSource string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peReportSource == RS_User)
         strcpy(temp, "RS_User");

      if( *peReportSource == RS_Provider)
         strcpy(temp, "RS_Provider");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvReportSource enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvReportSource() */


void convert_DbvIntermediaryProblem(char **text, 
			DbvIntermediaryProblem *peIntermediaryProblem)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("IP_CannotSendOnward", *text) == 0)
         *peIntermediaryProblem = IP_CannotSendOnward;
      else
      if(strcmp("IP_Invalid", *text) == 0)
         *peIntermediaryProblem = IP_Invalid;
      else
         printf("Warning: DbvIntermediaryProblem string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peIntermediaryProblem == IP_CannotSendOnward)
         strcpy(temp, "IP_CannotSendOnward");

      if( *peIntermediaryProblem == IP_Invalid)
         strcpy(temp, "IP_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvIntermediaryProblem enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvIntermediaryProblem() */


void convert_DbvUnableToPerform(char **text, 
			DbvUnableToPerform *peUnableToPerform)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("UTP_NotAvailable", *text) == 0)
         *peUnableToPerform = UTP_NotAvailable;
      else
      if(strcmp("UTP_ResourceLimitation", *text) == 0)
         *peUnableToPerform = UTP_ResourceLimitation;
      else
      if(strcmp("UTP_Other", *text) == 0)
         *peUnableToPerform = UTP_Other;
      else
      if(strcmp("UTP_Invalid", *text) == 0)
         *peUnableToPerform = UTP_Invalid;
      else
         printf("Warning: DbvUnableToPerform string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peUnableToPerform == UTP_NotAvailable)
         strcpy(temp, "UTP_NotAvailable");

      if( *peUnableToPerform == UTP_ResourceLimitation)
         strcpy(temp, "UTP_ResourceLimitation");

      if( *peUnableToPerform == UTP_Other)
         strcpy(temp, "UTP_Other");

      if( *peUnableToPerform == UTP_Invalid)
         strcpy(temp, "UTP_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvUnableToPerform enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvUnableToPerform() */


void convert_DbvUserErrorReportType(char **text, 
			DbvUserErrorReportType *peUserErrorReportType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("UER_AlreadyForwarded", *text) == 0)
         *peUserErrorReportType = UER_AlreadyForwarded;
      else
      if(strcmp("UER_IntermediaryProblem", *text) == 0)
         *peUserErrorReportType = UER_IntermediaryProblem;
      else
      if(strcmp("UER_SecurityProblem", *text) == 0)
         *peUserErrorReportType = UER_SecurityProblem;
      else
      if(strcmp("UER_UnableToPerform", *text) == 0)
         *peUserErrorReportType = UER_UnableToPerform;
      else
         printf("Warning: DbvUserErrorReportType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peUserErrorReportType == UER_AlreadyForwarded)
         strcpy(temp, "UER_AlreadyForwarded");

      if( *peUserErrorReportType == UER_IntermediaryProblem)
         strcpy(temp, "UER_IntermediaryProblem");

      if( *peUserErrorReportType == UER_SecurityProblem)
         strcpy(temp, "UER_SecurityProblem");

      if( *peUserErrorReportType == UER_UnableToPerform)
         strcpy(temp, "UER_UnableToPerform");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvUserErrorReportType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvUserErrorReportType() */


void convert_DbvProviderErrorReportType(char **text, 
			DbvProviderErrorReportType *peProviderErrorReportType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("PER_GeneralProblem", *text) == 0)
         *peProviderErrorReportType = PER_GeneralProblem;
      else
      if(strcmp("PER_TransactionIdProblem", *text) == 0)
         *peProviderErrorReportType = PER_TransactionIdProblem;
      else
      if(strcmp("PER_StateTransitionProhibited", *text) == 0)
         *peProviderErrorReportType = PER_StateTransitionProhibited;
      else
         printf("Warning: DbvProviderErrorReportType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peProviderErrorReportType == PER_GeneralProblem)
         strcpy(temp, "PER_GeneralProblem");

      if( *peProviderErrorReportType == PER_TransactionIdProblem)
         strcpy(temp, "PER_TransactionIdProblem");

      if( *peProviderErrorReportType == PER_StateTransitionProhibited)
         strcpy(temp, "PER_StateTransitionProhibited");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvProviderErrorReportType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvProviderErrorReportType() */


void convert_DbvTransactionIdProblem(char **text, 
			DbvTransactionIdProblem *peTransactionIdProblem)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("TIP_DuplicateTransactionId", *text) == 0)
         *peTransactionIdProblem = TIP_DuplicateTransactionId;
      else
      if(strcmp("TIP_InvalidTransactionId", *text) == 0)
         *peTransactionIdProblem = TIP_InvalidTransactionId;
      else
      if(strcmp("TIP_UnknownTransactionId", *text) == 0)
         *peTransactionIdProblem = TIP_UnknownTransactionId;
      else
      if(strcmp("TIP_Invalid", *text) == 0)
         *peTransactionIdProblem = TIP_Invalid;
      else
         printf("Warning: DbvTransactionIdProblem string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peTransactionIdProblem == TIP_DuplicateTransactionId)
         strcpy(temp, "TIP_DuplicateTransactionId");

      if( *peTransactionIdProblem == TIP_InvalidTransactionId)
         strcpy(temp, "TIP_InvalidTransactionId");

      if( *peTransactionIdProblem == TIP_UnknownTransactionId)
         strcpy(temp, "TIP_UnknownTransactionId");

      if( *peTransactionIdProblem == TIP_Invalid)
         strcpy(temp, "TIP_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvTransactionIdProblem enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvTransactionIdProblem() */



void convert_DbvReasonNoReport(char **text, 
			DbvReasonNoReport *peReasonNoReport)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("RNR_Temporary", *text) == 0)
         *peReasonNoReport = RNR_Temporary;
      else
      if(strcmp("RNR_Permanent", *text) == 0)
         *peReasonNoReport = RNR_Permanent;
      else
      if(strcmp("RNR_Invalid", *text) == 0)
         *peReasonNoReport = RNR_Invalid;
      else
         printf("Warning: DbvReasonNoReport string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peReasonNoReport == RNR_Temporary)
         strcpy(temp, "RNR_Temporary");

      if( *peReasonNoReport == RNR_Permanent)
         strcpy(temp, "RNR_Permanent");

      if( *peReasonNoReport == RNR_Invalid)
         strcpy(temp, "RNR_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvReasonNoReport enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvReasonNoReport() */


void convert_DbvGeneralProblem(char **text, DbvGeneralProblem *peGeneralProblem)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("GP_UnrecognizedAPDU", *text) == 0)
         *peGeneralProblem = GP_UnrecognizedAPDU;
      else
      if(strcmp("GP_MistypedAPDU", *text) == 0)
         *peGeneralProblem = GP_MistypedAPDU;
      else
      if(strcmp("GP_BadlyStructuredAPDU", *text) == 0)
         *peGeneralProblem = GP_BadlyStructuredAPDU;
      else
      if(strcmp("GP_ProtocolVersionNotSupported", *text) == 0)
         *peGeneralProblem = GP_ProtocolVersionNotSupported;
      else
      if(strcmp("GP_Other", *text) == 0)
         *peGeneralProblem = GP_Other;
      else
      if(strcmp("GP_Invalid", *text) == 0)
         *peGeneralProblem = GP_Invalid;
      else
         printf("Warning: DbvGeneralProblem string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peGeneralProblem == GP_UnrecognizedAPDU)
         strcpy(temp, "GP_UnrecognizedAPDU");

      if( *peGeneralProblem == GP_MistypedAPDU)
         strcpy(temp, "GP_MistypedAPDU");

      if( *peGeneralProblem == GP_BadlyStructuredAPDU)
         strcpy(temp, "GP_BadlyStructuredAPDU");

      if( *peGeneralProblem == GP_ProtocolVersionNotSupported)
         strcpy(temp, "GP_ProtocolVersionNotSupported");

      if( *peGeneralProblem == GP_Other)
         strcpy(temp, "GP_Other");

      if( *peGeneralProblem == GP_Invalid)
         strcpy(temp, "GP_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvGeneralProblem enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvGeneralProblem() */


