/*  Module Name: @(#)convert_DbvFuncs.h	7.2
    Version: 2/27/97
    Author: Dan Maskell/Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to convert enumerated types between enum and string format
        Used by the origin and target.
 
*/
 
#ifndef CONVERT_DBVFUNCS_H
#define CONVERT_DBVFUNCS_H

#include "testy_calls.h"


/* convert_DbvFuncs.c */


void 
convert_DbvBool (char **text, DbvBool * peBool);
void 
convert_DbvDbRecordType (char **text, DbvDbRecordType * peDbRecordType);
void 
convert_DbvDeleteFunction (char **text, DbvDeleteFunction * peDeleteFunction);
void 
convert_DbvDeleteSetStatus (char **text,
			    DbvDeleteSetStatus * peDeleteSetStatus);
void 
convert_DbvDiagnosticsType (char **text,
			    DbvDiagnosticsType * peDiagnosticsType);
void 
convert_DbvElementSetType (char **text, DbvElementSetType * peElementSetType);
void 
convert_DbvFragmentSyntaxType (char **text,
			       DbvFragmentSyntaxType * peFragmentSyntaxType);
void 
convert_DbvPresentStatus (char **text,
			  DbvPresentStatus * pePresentStatus);
void 
convert_DbvProtocolVersionInForce (char **text,
		       DbvProtocolVersionInForce * peProtocolVersionInForce);
void 
convert_DbvQueryType (char **text, DbvQueryType * peQueryType);
void 
convert_DbvRecordType (char **text, DbvRecordType * peRecordType);
void 
convert_DbvResultSetStatus (char **text,
			    DbvResultSetStatus * peResultSetStatus);
void 
convert_DbvTermType (char **text, DbvTermType * peTermType);
void 
convert_DbvSortStatus (char **text, DbvSortStatus * peSortStatus);
void 
convert_DbvSortResultSetStatus (char **text, DbvSortResultSetStatus * peSortResultSetStatus);
void 
convert_DbvSortElementType (char **text, DbvSortElementType * peSortElementType);
void 
convert_DbvSortRelationType (char **text,
			     DbvSortRelationType * peSortRelationType);
void 
convert_DbvSortCaseType (char **text, DbvSortCaseType * peSortCaseType);
void 
convert_DbvSortKeyType (char **text, DbvSortKeyType * peSortKeyType);
void 
convert_DbvSortMVActionType (char **text, DbvSortMVActionType * peSortMVActionType);
void 
convert_DbvElementSpecType (char **text,
			    DbvElementSpecType * peElementSpecType);
void 
convert_DbvAttributeValueType (char **text,
			    DbvAttributeValueType * peDbvAttributeValueType);
void 
convert_DbvStringOrNumericType (char **text,
			     DbvStringOrNumericType * peStringOrNumericType);
void 
convert_DbvScanStatus (char **text, DbvScanStatus * peScanStatus);
void 
convert_DbvEntryType (char **text, DbvEntryType * peEntryType);
void 
convert_DbvOccurrenceType (char **text, DbvOccurrenceType * peOccurrenceType);
void 
convert_DbvRecordCompositionType (char **text,
			 DbvRecordCompositionType * peRecordCompositionType);
void 
convert_DbvExtServicesFunctions (char **text, DbvExtServicesFunctions * peFunction);
void 
convert_DbvExtServicesWaitAction (char **text, DbvExtServicesWaitAction * peWaitAction);
void 
convert_DbvExtServicesOperationStatus (char **text, DbvExtServicesOperationStatus * peOperationStatus);
void 
convert_DbvUpdateReqOrRsp (char **text, DbvUpdateReqOrRsp * peUpdateReqOrRsp);
void 
convert_DbvUpdtAction (char **text, DbvUpdtAction * peUpdtAction);
void 
convert_DbvUpdtRecordIdType (char **text,
			     DbvUpdtRecordIdType * peUpdtRecordIdType);
void 
convert_DbvUpdtSupplementalIdType (char **text,
		       DbvUpdtSupplementalIdType * peUpdtSupplementalIdType);
void 
convert_DbvUpdtTaskStatus (char **text, DbvUpdtTaskStatus * peUpdtTaskStatus);
void 
convert_DbvUpdtRecordStatus (char **text, DbvUpdtRecordStatus * peUpdtRecordStatus);
void 
convert_DbvUpdtRecordOrDiagType (char **text,
			   DbvUpdtRecordOrDiagType * peUpdtRecordOrDiagType);
void 
convert_DbvExtServicesTaskStatus (char **text, DbvExtServicesTaskStatus * peExtServicesTaskStatus);
void 
convert_DbvPermAllowableFunctions (char **text,
		       DbvPermAllowableFunctions * pePermAllowableFunctions);
void 
convert_DbvRpnQueryType (char **text, DBVRpnQueryType * peRpnQueryType);
void 
convert_DbvProximityRelationType (char **text, DbvProximityRelationType
				  * peProximityRelationType);
void 
convert_DbvProximityUnitType (char **text, DbvProximityUnitType
			      * peProximityUnitType);
void 
convert_DbvKnownProximityUnit (char **text, DbvKnownProximityUnit
			       * peKnownProximityUnit);
void 
convert_DbvTraceLevel (char **text,
		       DbvTraceLevel * peTraceLevel);
void 
convert_DbvIllPduType (char **text, DbvIllPduType * peIllPduType);
void 
convert_DbvEsIoAuxiliaryStatus (char **text,
			     DbvEsIoAuxiliaryStatus * peEsIoAuxiliaryStatus);
void 
convert_DbvEsIoPaymentMethodType (char **text,
			 DbvEsIoPaymentMethodType * peEsIoPaymentMethodType);
void 
convert_DbvItemOrderReqOrRsp (char **text,
			      DbvItemOrderReqOrRsp * peItemOrderReqOrRsp);
void 
convert_DbvIllStringType (char **text,
			  DbvIllStringType * peIllStringType);
void 
convert_DbvIllProtocolVersion (char **text,
			       DbvIllProtocolVersion * peIllProtocolVersion);
void 
convert_DbvNameOfPersOrInstType (char **text,
			   DbvNameOfPersOrInstType * peNameOfPersOrInstType);
void 
convert_DbvPersOrInstSymbolType (char **text,
			   DbvPersOrInstSymbolType * pePersOrInstSymbolType);
void 
convert_DbvTransactionType (char **text,
			    DbvTransactionType * peTransactionType);
void 
convert_DbvDeliveryServiceType (char **text,
			     DbvDeliveryServiceType * peDeliveryServiceType);
void 
convert_DbvElDeliveryDetailsType (char **text,
			 DbvElDeliveryDetailsType * peElDeliveryDetailsType);
void 
convert_DbvServiceType (char **text, DbvServiceType * peServiceType);
void 
convert_DbvOptionalMsgRequirements (char **text,
		     DbvOptionalMsgRequirements * peOptionalMsgRequirements);
void 
convert_DbvExpiry (char **text, DbvExpiry * peExpiry);
void 
convert_DbvSupplyMediumType (char **text,
			     DbvSupplyMediumType * peSupplyMediumType);
void 
convert_DbvPlaceOnHold (char **text, DbvPlaceOnHold * pePlaceOnHold);
void 
convert_DbvItemType (char **text, DbvItemType * peItemType);
void 
convert_DbvMediumType (char **text, DbvMediumType * peMediumType);
void 
convert_DbvPreference (char **text, DbvPreference * pePreference);
void 
convert_DbvTransactionResults (char **text,
			       DbvTransactionResults * peTransactionResults);
void 
convert_DbvMostRecentService (char **text,
			      DbvMostRecentService * peMostRecentService);
void 
convert_DbvShippedServiceType (char **text,
			       DbvShippedServiceType * peShippedServiceType);
void 
convert_DbvCurrentState (char **text,
			 DbvCurrentState * peCurrentState);
void 
convert_DbvIllAPDUType (char **text,
			DbvIllAPDUType * peIllAPDUType);
void 
convert_DbvReportSource (char **text, DbvReportSource * peReportSource);
void 
convert_DbvIntermediaryProblem (char **text,
			     DbvIntermediaryProblem * peIntermediaryProblem);
void 
convert_DbvUnableToPerform (char **text,
			    DbvUnableToPerform * peUnableToPerform);
void 
convert_DbvUserErrorReportType (char **text,
			     DbvUserErrorReportType * peUserErrorReportType);
void 
convert_DbvProviderErrorReportType (char **text,
		     DbvProviderErrorReportType * peProviderErrorReportType);
void 
convert_DbvTransactionIdProblem (char **text,
			   DbvTransactionIdProblem * peTransactionIdProblem);
void 
convert_DbvReasonNoReport (char **text,
			   DbvReasonNoReport * peReasonNoReport);
void 
convert_DbvGeneralProblem (char **text, DbvGeneralProblem * peGeneralProblem);


/* conv_DbvFuncs1.c */


void 
convert_DbvRequesterGroup (char **text, DbvRequesterGroup * peRequesterGroup);
void 
convert_DbvStatusLevelUser (char **text,
			    DbvStatusLevelUser * peStatusLevelUser);
void 
convert_DbvStatusLevelRequester (char **text, DbvStatusLevelRequester * peStatusLevelOrigin);
void 
convert_DbvBillingInvoiceType (char **text,
			       DbvBillingInvoiceType * peBillingInvoiceType);
void 
convert_DbvAddBillingType (char **text,
			   DbvAddBillingType * peAddBillingType);

/* conv_DbvFuncs2.c */


void
convert_DbvRequesterGroup (char **text, DbvRequesterGroup * peRequesterGroup);
void
convert_DbvStatusLevelUser (char **text,
			    DbvStatusLevelUser * peStatusLevelUser);
void
convert_DbvStatusLevelRequester (char **text, DbvStatusLevelRequester * peStatusLevelOrigin);
void
convert_DbvBillingInvoiceType (char **text,
			       DbvBillingInvoiceType * peBillingInvoiceType);
void
convert_DbvAddBillingType (char **text,
			   DbvAddBillingType * peAddBillingType);

/* conv_DbvFuncs3.c */


#ifdef NOT_YET_IMPLEMENTED

void 
convert_DbvElementDataGType (char **text, DbvElementDataGType * peElementDataGType);
void 
convert_DbvUsageIntType (char **text, DbvUsageIntType * peUsageIntType);
void 
convert_DbvVariantValueType (char **text,
			     DbvVariantValueType * peVariantValueType);

#endif



/* conv_DbvFuncs4.c */


void 
convert_DbvPromptObjectType (char **text, DbvPromptObjectType * pePromptObjectType);
void 
convert_DbvEPromptIdType (char **text, DbvEPromptIdType * peEPromptIdType);
void 
convert_DbvRequestedAction (char **text, DbvRequestedAction * peRequestedAction);
void 
convert_DbvSecurityChallengeType (char **text, DbvSecurityChallengeType * peSecurityChallengeType);
void 
convert_DbvPromptInfoType (char **text, DbvPromptInfoType * pePromptInfoType);
void 
convert_DbvDataType(char **text, DbvDataType *peDataType);
void 
convert_DbvResponseType(char **text, DbvResponseType *peResponseType);

void 
convert_DbvPromptIdType (char **text, DbvPromptIdType * pePromptIdType);
void 
convert_DbvPartialResultsAvailable (char **text, DbvPartialResultsAvailable * pePartialResultsAvailable);


/* convert_DbvFuncs5.c */

void convert_DbvSelectedCharSetType( char **text, DbvSelectedCharSetType *DbvSelectedCharSetType );
void convert_DbvPrivateCharacterSetType( char **text, DbvPrivateCharacterSetType *DbvPrivateCharacterSetType );
void convert_DbvEnvironmentType( char **text, DbvEnvironmentType *DbvEnvironmentType );
void convert_DbvIso2022Type( char **text, DbvIso2022Type *DbvIso2022Type );
void convert_DbvProposedCharSetType( char **text, DbvProposedCharSetType *DbvProposedCharSetType );
void convert_DbvCharSetAndLanguageType( char **text, DbvCharSetAndLanguageType *DbvCharSetAndLanguageType );
#endif

