/*  Module Name: @(#)external_processing.h	3.4
    Version: 6/22/95
    Author: Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        DBV-OSI II Origin Test Tool external functions. Covers the conversion
        of strings to enumerated types and reading and writing to/from tbl
        files. All specific to the external format.
 
        Used by the origin and target.
 
*/

#ifndef EXTERNAL_PROCESSING_H
#define EXTERNAL_PROCESSING_H

#include <stdio.h>

#include "sl_list.h"
#include "memcheck.h"
#include "tbl.h"
#include "str_hand.h"

#include "sidefs.h"
#include "sitypes.h"
#include "sitypes2.h"
#include "dbvproto.h"

#include "testy_calls.h"

/* Functions to get External format for TBL files */
void get_DbvASN1External(DbvASN1External **ppsASN1External, TBL InTable);
void get_DbvSingleASN1Type(DbvSingleASN1Type **ppsSingleASN1Type, TBL InTable);
void get_DbvOpacRecord(DbvOpacRecord **ppsOpacRecord, TBL ExternalTable);
void get_DbvHoldingsRecord(DbvHoldingsRecord *psHoldingsRecord, TBL ExternalTable);
void get_DbvHoldingsAndCircData(DbvHoldingsAndCircData *psHoldingsAndCirc, TBL ExternalTable);
void get_DbvVolume(DbvVolume *psVolume, TBL ExternalTable);
void get_DbvCircRecord(DbvCircRecord **ppsCircRecord, TBL ExternalTable);
void get_DbvSummary(DbvSummaryRecord **ppsSummaryRecord, TBL ExternalTable);
void get_DbvFormatSpec(DbvFormatSpec *psFormat, TBL ExternalTable);
void get_DbvResourceReport1(DbvResourceReport1 **ppsResourceReport1, TBL ExternalTable);
void get_DbvEstimate1(DbvEstimate1 *psEstimate, TBL ExternalTable);



/* Functions to write External format to TBL files */
void write_DbvASN1External(DbvASN1External *psASN1External, TBL OutTable);
void write_SingleASN1Type(DbvSingleASN1Type *psSingleASN1Type, TBL OutTable);
void write_DbvOpacRecord(DbvOpacRecord *psOpacRecord, TBL OutTable);
void write_DbvHoldingsRecord(DbvHoldingsRecord *psHoldingsData, TBL OutTable);
void write_DbvHoldingsAndCircData(DbvHoldingsAndCircData *psHoldingsAndCirc, TBL OutTable);
void write_DbvVolume(DbvVolume *psVolume, TBL OutTable);
void write_DbvCircRecord(DbvCircRecord *psCircRecord, TBL OutTable);
void write_DbvSummaryRecord(DbvSummaryRecord *psSummaryRecord, TBL OutTable);
void write_DbvFormatSpec(DbvFormatSpec *psFormat, TBL OutTable);
void write_DbvResourceReport1(DbvResourceReport1 *psResourceReport1, TBL OutTable);
void write_DbvEstimate1(DbvEstimate1 *psEstimate, TBL OutTable);

#endif

