/*  Module Name: @(#)getN_DbvFuncs.c	7.1
    Version: 11/15/96
    Author: Dan Maskell/Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
	Functions to read in lists of structures.

    Modification History

    06-02-96 Dan Maskell Additional Functions added
    07-03-96 Dan Maskell Added support for Explain record
    25-03-96 Dan Maskell Added support for Generic record
*/
 
#include "get_DbvFuncs.h"
 
extern TBL_Return T_Return;

void getN_DbvAttributeElement( DbvAttributeElement ***pppsAttributeElement,
				 TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvAttributeElement **ppsAttributeElement;

   /* Attribute Elements */

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Elements */

   if ( intfield > 0 )
      {
      ppsAttributeElement = ( DbvAttributeElement **)DbvAlloc( 
			( sizeof( DbvAttributeElement* ) * (intfield + 1 )));
      *pppsAttributeElement = ppsAttributeElement;

      for ( ; intfield; intfield-- )
         {
         get_DbvAttributeElement( ppsAttributeElement, InTable );
         ppsAttributeElement++;
         } /* End for */
 
      *ppsAttributeElement = NULL;
      } /* End if */

   } /* End getN_DbvAttributeElement() */

void getN_DbvDbSpecificComp( DbvDbSpecificComp ***pppsDbSpecificComp, 
				TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvDbSpecificComp **ppsDbSpecificComp;

   /* Attribute Elements */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );


   if ( intfield > 0 )
      {
      ppsDbSpecificComp = ( DbvDbSpecificComp **)DbvAlloc( 
			( sizeof( DbvDbSpecificComp* ) * (intfield + 1 )));
      *pppsDbSpecificComp = ppsDbSpecificComp;

      for ( ; intfield; intfield-- )
         {
         get_DbvDbSpecificComp( ppsDbSpecificComp, InTable );
         ppsDbSpecificComp++;
         } /* End for */
 
      *ppsDbSpecificComp = NULL;
      } /* End if */

   } /* End getN_DbvDbSpecificComp() */
void getN_DbvDiagRec( DbvDiagRec ***pppsDiagRec, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvDiagRec **ppsDiagRec;

   /* Attribute Elements */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Diag Records */

   if ( intfield > 0 )
      {
      ppsDiagRec = ( DbvDiagRec **)DbvAlloc( 
			( sizeof( DbvDiagRec* ) * (intfield + 1 )));
      *pppsDiagRec = ppsDiagRec;

      for ( ; intfield; intfield-- )
         {
         get_DbvDiagRec( ppsDiagRec, InTable );
         ppsDiagRec++;
         } /* End for */
 
      *ppsDiagRec = NULL;
      } /* End if */

   } /* End getN_DbvDiagRec() */

void getN_DbvEntry( DbvEntry ***pppsEntry, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvEntry **ppsEntry;

   /* Attribute Elements */

   TBL_GetRecord( InTable);
   stringfield = get_char_field( InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Entry */

   if ( intfield > 0 )
      {
      ppsEntry = ( DbvEntry **)DbvAlloc(( sizeof( DbvEntry* ) * 
	(intfield + 1 )));
      *pppsEntry = ppsEntry;

      for ( ; intfield; intfield-- )
         {
         get_DbvEntry( ppsEntry, InTable );
         ppsEntry++;
         } /* End for */
 
      *ppsEntry = NULL;
      } /* End if */

   } /* End getN_DbvEntry() */
void getN_DbvObjectIdentifier( DbvObjectIdentifier **pppcObjectIdentifier, 
				TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvObjectIdentifier *ppcObjectIdentifier;

   /* Attribute Elements */

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Object Identifiers */

   if ( intfield > 0 )
      {
      ppcObjectIdentifier = ( DbvObjectIdentifier *)DbvAlloc( 
			( sizeof( DbvObjectIdentifier* ) * (intfield + 1 )));
      *pppcObjectIdentifier = ppcObjectIdentifier;

      for ( ; intfield; intfield-- )
         {
         TBL_GetRecord( InTable );
         get_DbvObjectIdentifier( ppcObjectIdentifier, InTable );
         ppcObjectIdentifier++;
         } /* End for */
 
      ppcObjectIdentifier = NULL;
      } /* End if */

   } /* End getN_DbvObjectIdentifier() */

void getN_DbvOccurrenceByDb( DbvOccurrenceByDb ***pppsOccurrenceByDb,
				 TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvOccurrenceByDb **ppsOccurrenceByDb;

   /* Attribute Elements */

   TBL_GetRecord( InTable);
   stringfield = get_char_field( InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* ppsOccurrenceByDb */

   if ( intfield > 0 )
      {
      ppsOccurrenceByDb = ( DbvOccurrenceByDb **)DbvAlloc( 
			( sizeof( DbvOccurrenceByDb* ) * (intfield + 1 )));
      *pppsOccurrenceByDb = ppsOccurrenceByDb;

      for ( ; intfield; intfield-- )
         {
         get_DbvOccurrenceByDb( ppsOccurrenceByDb, InTable );
         ppsOccurrenceByDb++;
         } /* End for */
 
      *ppsOccurrenceByDb = NULL;
      } /* End if */

   } /* End getN_DbvOccurrenceByDb() */
void getN_DbvRange( DbvRange ***pppsRange, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvRange **ppsRange;

   /* Number of Ranges */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Ranges */

   if ( intfield > 0 )
      {
      ppsRange = ( DbvRange **)DbvAlloc( 
			( sizeof( DbvRange* ) * (intfield + 1 )));
      *pppsRange = ppsRange;

      for ( ; intfield; intfield-- )
         {
         get_DbvRange( ppsRange, InTable );
         ppsRange++;
         } /* End for */
 
      *ppsRange = NULL;
      } /* End if */

   } /* End getN_DbvRange() */


void getN_DbvEstimate2( DbvEstimate2 ***pppsEstimate, TBL ExternalTable )
   {
   char *stringfield;
   int  intfield;
   DbvEstimate2 **ppsEstimate;

   /* Attribute Elements */

   TBL_GetRecord( ExternalTable );
   stringfield = get_char_field(ExternalTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( ExternalTable, T_Return );

   /* Number of Estimate2 */

   if ( intfield > 0 )
      {
      ppsEstimate = ( DbvEstimate2 **)DbvAlloc( 
			( sizeof( DbvEstimate2* ) * (intfield + 1 )));
      *pppsEstimate = ppsEstimate;

      for ( ; intfield; intfield-- )
         {
         get_DbvEstimate2( ppsEstimate, ExternalTable );
         ppsEstimate++;
         } /* End for */
 
      *ppsEstimate = NULL;
      } /* End if */

   } /* End getN_DbvEstimate2() */

void getN_DbvPermAllowableFunctions( DbvPermAllowableFunctions 
			  ***pppeAllowableFunctions, TBL ExternalTable )
   {
   char *stringfield;
   int  intfield;
   DbvPermAllowableFunctions **ppeAllowableFunctions;

   /* Number of PermAllowableFunctions */

   TBL_GetRecord( ExternalTable );
   stringfield = get_char_field(ExternalTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( ExternalTable, T_Return );

   /* PermAllowableFunctions */

   if ( intfield > 0 )
      {
      ppeAllowableFunctions = ( DbvPermAllowableFunctions **)DbvAlloc( 
		( sizeof( DbvPermAllowableFunctions* ) * (intfield + 1 )));
      *pppeAllowableFunctions = ppeAllowableFunctions;

      for ( ; intfield; intfield-- )
         {
         get_DbvPermAllowableFunctions( ppeAllowableFunctions, ExternalTable );
         ppeAllowableFunctions++;
         } /* End for */
 
      *ppeAllowableFunctions = NULL;
      } /* End if */

   } /* End getN_DbvPermAllowableFunctions() */

void getN_DbvPermissions( DbvPermissions ***pppsPermissions, TBL ExternalTable )
   {
   char *stringfield;
   int  intfield;
   DbvPermissions **ppsPermissions;

   /* Number of Permissions */

   TBL_GetRecord( ExternalTable );
   stringfield = get_char_field(ExternalTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( ExternalTable, T_Return );

   /* Permissions */

   if ( intfield > 0 )
      {
      ppsPermissions = ( DbvPermissions **)DbvAlloc( 
			( sizeof( DbvPermissions* ) * (intfield + 1 )));
      *pppsPermissions = ppsPermissions;

      for ( ; intfield; intfield-- )
         {
         get_DbvPermissions( ppsPermissions, ExternalTable );
         ppsPermissions++;
         } /* End for */
 
      *ppsPermissions = NULL;
      } /* End if */

   } /* End getN_DbvPermissions() */

void getN_DbvSuppliedRecord( DbvSuppliedRecord ***pppsSuppliedRecord, 
				TBL ExternalTable )
   {
   char *stringfield;
   int  intfield;
   DbvSuppliedRecord **ppsSuppliedRecord;

   /* Supplied Record */

   TBL_GetRecord( ExternalTable );
   stringfield = get_char_field(ExternalTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( ExternalTable, T_Return );

   /* Elements */

   if ( intfield > 0 )
      {
      ppsSuppliedRecord = ( DbvSuppliedRecord **)DbvAlloc( 
			( sizeof( DbvSuppliedRecord* ) * (intfield + 1 )));
      *pppsSuppliedRecord = ppsSuppliedRecord;

      for ( ; intfield; intfield-- )
         {
         get_DbvSuppliedRecord( ppsSuppliedRecord, ExternalTable );
         ppsSuppliedRecord++;
         } /* End for */
 
      *ppsSuppliedRecord = NULL;
      } /* End if */

   } /* End getN_DbvSuppliedRecord() */

void getN_DbvTaskPackageRecord( DbvTaskPackageRecord ***pppsTaskPackageRecord, 
				TBL ExternalTable )
   {
   char *stringfield;
   int  intfield;
   DbvTaskPackageRecord **ppsTaskPackageRecord;

   /* Number of Records */

   TBL_GetRecord( ExternalTable );
   stringfield = get_char_field(ExternalTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( ExternalTable, T_Return );

   /* TaskPackageRecord */

   if ( intfield > 0 )
      {
      ppsTaskPackageRecord = ( DbvTaskPackageRecord **)DbvAlloc( 
			( sizeof( DbvTaskPackageRecord* ) * (intfield + 1 )));
      *pppsTaskPackageRecord = ppsTaskPackageRecord;

      for ( ; intfield; intfield-- )
         {
         get_DbvTaskPackageRecord( ppsTaskPackageRecord, ExternalTable );
         ppsTaskPackageRecord++;
         } /* End for */
 
      *ppsTaskPackageRecord = NULL;
      } /* End if */

   } /* End getN_DbvTaskPackageRecord() */

void getN_DbvOtherInformation( DbvOtherInformation ***pppsOtherInformation,
                                TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvOtherInformation **ppsOtherInformation;
 
 
   /* Ignore the title */
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return );
   DbvFree( stringfield );
 
   /* Number of Records */
   intfield = get_int_field( InTable, T_Return );
 
   /* OtherInformation Records */
 
   if ( intfield > 0 )
      {
      ppsOtherInformation = ( DbvOtherInformation **)DbvAlloc(
                        ( sizeof( DbvOtherInformation* ) * (intfield + 1 )));
      *pppsOtherInformation = ppsOtherInformation;
 
      for ( ; intfield; intfield-- )
         {
         get_DbvOtherInformation(ppsOtherInformation, InTable );
         ppsOtherInformation++;
         } /* End for */
 
      *ppsOtherInformation = NULL;

      } /* End if */
   } /* End  getN_DbvOtherInformation() */

void getN_DbvOccurrenceByAttributes(DbvOccurrenceByAttributes 
	***pppsByAttributes, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvOccurrenceByAttributes **ppsByAttributes;
 
   /* Ignore the title */
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return );
   DbvFree( stringfield );
 
   /* Number of Records */
   intfield = get_int_field( InTable, T_Return );
 
   /* DbvOccurrenceByAttributes Records */
 
   if ( intfield > 0 )
      {
      ppsByAttributes = ( DbvOccurrenceByAttributes **)DbvAlloc(
                        ( sizeof( DbvOccurrenceByAttributes* ) * 
			(intfield + 1 )));
      *pppsByAttributes = ppsByAttributes;
 
      for ( ; intfield; intfield-- )
         {
         get_DbvOccurrenceByAttributes(ppsByAttributes, InTable );
         ppsByAttributes++;
         } /* End for */
 
      *ppsByAttributes = NULL;
 
	  } /* End if */
      
   } /* End  getN_DbvOccurrenceByAttributes() */
 
/* Functions beyond this point where added by Dan Maskell 6-2-96 */

void getN_DbvElectronicDeliveryService( 
		DbvElectronicDeliveryService ***pppsElectronicDeliveryService, 
		TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvElectronicDeliveryService **ppsElectronicDeliveryService;

   /* ElectronicDeliveryService  Elements */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );


   if ( intfield > 0 )
      {
      ppsElectronicDeliveryService = ( DbvElectronicDeliveryService **)
		DbvAlloc( ( sizeof( DbvElectronicDeliveryService* ) * 
			  (intfield + 1 )));
      *pppsElectronicDeliveryService = ppsElectronicDeliveryService;

      for ( ; intfield; intfield-- )
         {
         get_DbvElectronicDeliveryService( ppsElectronicDeliveryService,
					   InTable );
         ppsElectronicDeliveryService++;
         } /* End for */
 
      *ppsElectronicDeliveryService = NULL;
      } /* End if */

   } /* End getN_DbvElectronicDeliveryService() */


void getN_DbvSystemId( DbvSystemId ***pppsSystemId, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvSystemId **ppsSystemId;

   /* System Ids */

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   if ( intfield > 0 )
      {
      ppsSystemId = ( DbvSystemId **)DbvAlloc( 
			( sizeof( DbvSystemId* ) * (intfield + 1 )));
      *pppsSystemId = ppsSystemId;

      for ( ; intfield; intfield-- )
         {
         get_DbvSystemId( ppsSystemId, InTable );
         ppsSystemId++;
         } /* End for */
 
      *ppsSystemId = NULL;
      } /* End if */

   } /* End getN_DbvSystemId() */


void getN_DbvSendToList( DbvSendToList ***pppsSendToList, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvSendToList **ppsSendToList;

   /* SendToList */

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   if ( intfield > 0 )
      {
      ppsSendToList = ( DbvSendToList **)DbvAlloc( 
			( sizeof( DbvSendToList* ) * (intfield + 1 )));
      *pppsSendToList = ppsSendToList;

      for ( ; intfield; intfield-- )
         {
         get_DbvSendToList( ppsSendToList, InTable );
         ppsSendToList++;
         } /* End for */
 
      *ppsSendToList = NULL;
      } /* End if */

   } /* End getN_DbvSendToList() */


void getN_DbvExtension( DbvExtension ***pppsExtension,
				 TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvExtension **ppsExtension;

   /* Extension Elements */

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Elements */

   if ( intfield > 0 )
      {
      ppsExtension = ( DbvExtension **)DbvAlloc( 
			( sizeof( DbvExtension* ) * (intfield + 1 )));
      *pppsExtension = ppsExtension;

      for ( ; intfield; intfield-- )
         {
         get_DbvExtension( ppsExtension, InTable );
         ppsExtension++;
         } /* End for */
 
      *ppsExtension = NULL;
      } /* End if */

   } /* End getN_DbvExtension() */


void getN_DbvSupplyMediumInfo( DbvSupplyMediumInfo ***pppsSupplyMediumInfo,
				 TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvSupplyMediumInfo **ppsSupplyMediumInfo;

   /* SupplyMediumInfo Elements */

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Elements */

   if ( intfield > 0 )
      {
      ppsSupplyMediumInfo = ( DbvSupplyMediumInfo **)DbvAlloc( 
			( sizeof( DbvSupplyMediumInfo* ) * (intfield + 1 )));
      *pppsSupplyMediumInfo = ppsSupplyMediumInfo;

      for ( ; intfield; intfield-- )
         {
         get_DbvSupplyMediumInfo( ppsSupplyMediumInfo, InTable );
         ppsSupplyMediumInfo++;
         } /* End for */
 
      *ppsSupplyMediumInfo = NULL;
      } /* End if */

   } /* End getN_DbvSupplyMediumInfo() */


void getN_DbvServiceType( DbvServiceType ***pppsServiceType, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvServiceType **ppsServiceType;

   /* ServiceType Elements */

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Elements */

   if ( intfield > 0 )
      {
      ppsServiceType = ( DbvServiceType **)DbvAlloc( 
			( sizeof( DbvServiceType* ) * (intfield + 1 )));
      *pppsServiceType = ppsServiceType;

      for ( ; intfield; intfield-- )
         {
         get_DbvServiceType( ppsServiceType, InTable );
         ppsServiceType++;
         } /* End for */
 
      *ppsServiceType = NULL;
      } /* End if */

   } /* End getN_DbvServiceType() */


void getN_DbvASN1External( DbvASN1External ***pppsASN1External,
				 TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvASN1External **ppsASN1External;

   /* ASN1External Elements */

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Elements */

   if ( intfield > 0 )
      {
      ppsASN1External = ( DbvASN1External **)DbvAlloc( 
			( sizeof( DbvASN1External* ) * (intfield + 1 )));
      *pppsASN1External = ppsASN1External;

      for ( ; intfield; intfield-- )
         {
         get_DbvASN1External( ppsASN1External, InTable );
         ppsASN1External++;
         } /* End for */
 
      *ppsASN1External = NULL;
      } /* End if */

   } /* End getN_DbvASN1External() */


/* Explain Record Support */


void getN_DbvHumanString( DbvHumanString ***pppsDbvHumanString, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvHumanString **ppsDbvHumanString;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* HumanStrings */

   if ( intfield > 0 )
      {
      ppsDbvHumanString = ( DbvHumanString **)DbvAlloc( 
			( sizeof( DbvHumanString* ) * (intfield + 1 )));
      *pppsDbvHumanString = ppsDbvHumanString;

      for ( ; intfield; intfield-- )
         {
         get_DbvHumanString( ppsDbvHumanString, InTable );
         ppsDbvHumanString++;
         } /* End for */
 
      *ppsDbvHumanString = NULL;
      } /* End if */

   } /* End getN_DbvHumanString() */

void getN_DbvDatabaseList( DbvDatabaseList ***pppsDatabaseList, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvDatabaseList **ppsDatabaseList;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* DatabaseLists */

   if ( intfield > 0 )
      {
      ppsDatabaseList = ( DbvDatabaseList **)DbvAlloc( 
			( sizeof( DbvDatabaseList* ) * (intfield + 1 )));
      *pppsDatabaseList = ppsDatabaseList;

      for ( ; intfield; intfield-- )
         {
         get_DbvDatabaseList( ppsDatabaseList, InTable );
         ppsDatabaseList++;
         } /* End for */
 
      *ppsDatabaseList = NULL;
      } /* End if */

   } /* End getN_DbvDatabaseList() */

void getN_DbvOperators( DbvOperators ***pppsDbvOperators, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvOperators **ppsDbvOperators;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Operatorss */

   if ( intfield > 0 )
      {
      ppsDbvOperators = ( DbvOperators **)DbvAlloc( 
			( sizeof( DbvOperators* ) * (intfield + 1 )));
      *pppsDbvOperators = ppsDbvOperators;

      for ( ; intfield; intfield-- )
         {
         get_DbvOperators( ppsDbvOperators, InTable );
         ppsDbvOperators++;
         } /* End for */
 
      *ppsDbvOperators = NULL;
      } /* End if */

   } /* End getN_DbvOperators() */

void getN_DbvSearchKey( DbvSearchKey ***pppsDbvSearchKey, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvSearchKey **ppsDbvSearchKey;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* SearchKeys */

   if ( intfield > 0 )
      {
      ppsDbvSearchKey = ( DbvSearchKey **)DbvAlloc( 
			( sizeof( DbvSearchKey* ) * (intfield + 1 )));
      *pppsDbvSearchKey = ppsDbvSearchKey;

      for ( ; intfield; intfield-- )
         {
         get_DbvSearchKey( ppsDbvSearchKey, InTable );
         ppsDbvSearchKey++;
         } /* End for */
 
      *ppsDbvSearchKey = NULL;
      } /* End if */

   } /* End getN_DbvSearchKey() */



void getN_DbvHumanStringSeq( DbvHumanStringSeq ***pppsDescription, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvHumanStringSeq **ppsDescription;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Description */

   if ( intfield > 0 )
      {
      ppsDescription = ( DbvHumanStringSeq **)DbvAlloc( 
			( sizeof( DbvHumanStringSeq* ) * (intfield + 1 )));
      *pppsDescription = ppsDescription;

      for ( ; intfield; intfield-- )
         {
         get_DbvHumanStringSeq( ppsDescription, InTable );
         ppsDescription++;
         } /* End for */
 
      *ppsDescription = NULL;
      } /* End if */

   } /* End getN_DbvHumanStringSeq() */

void getN_DbvUnitsSupported( DbvUnitsSupported ***pppsUnitsSupported, 
			     TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvUnitsSupported **ppsUnitsSupported;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* UnitsSupporteds */

   if ( intfield > 0 )
      {
      ppsUnitsSupported = ( DbvUnitsSupported **)DbvAlloc( 
			( sizeof( DbvUnitsSupported* ) * (intfield + 1 )));
      *pppsUnitsSupported = ppsUnitsSupported;

      for ( ; intfield; intfield-- )
         {
         get_DbvUnitsSupported( ppsUnitsSupported, InTable );
         ppsUnitsSupported++;
         } /* End for */
 
      *ppsUnitsSupported = NULL;
      } /* End if */

   } /* End getN_DbvUnitsSupported() */

void getN_Ulong( Ulong ***pppUlong, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   Ulong **ppUlong;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Ulongs */

   if ( intfield > 0 )
      {
      ppUlong = ( Ulong **)DbvAlloc( ( sizeof( Ulong* ) * (intfield + 1 )));
      *pppUlong = ppUlong;

      for ( ; intfield; intfield-- )
         {
         TBL_GetRecord( InTable );
         stringfield = get_char_field(InTable, T_Return ); 
         DbvFree( stringfield );
         *ppUlong = (Ulong*)get_integer_string( InTable );
         ppUlong++;
         } /* End for */
 
      *ppUlong = NULL;
      } /* End if */

   } /* End getN_Ulong() */

void getN_DbvOtherCharge( DbvOtherCharge ***pppsDbvOtherCharge, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvOtherCharge **ppsDbvOtherCharge;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* OtherCharges */

   if ( intfield > 0 )
      {
      ppsDbvOtherCharge = ( DbvOtherCharge **)DbvAlloc( 
			( sizeof( DbvOtherCharge* ) * (intfield + 1 )));
      *pppsDbvOtherCharge = ppsDbvOtherCharge;

      for ( ; intfield; intfield-- )
         {
         get_DbvOtherCharge( ppsDbvOtherCharge, InTable );
         ppsDbvOtherCharge++;
         } /* End for */
 
      *ppsDbvOtherCharge = NULL;
      } /* End if */

   } /* End getN_DbvOtherCharge() */

void getN_DbvQueryTypeDetails( DbvQueryTypeDetails ***pppsQueryTypeDetails, 
		TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvQueryTypeDetails **ppsQueryTypeDetails;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* DbvQueryTypeDetails */

   if ( intfield > 0 )
      {
      ppsQueryTypeDetails = ( DbvQueryTypeDetails **)DbvAlloc( 
			( sizeof( DbvQueryTypeDetails* ) * (intfield + 1 )));
      *pppsQueryTypeDetails = ppsQueryTypeDetails;

      for ( ; intfield; intfield-- )
         {
         get_DbvQueryTypeDetails( ppsQueryTypeDetails, InTable );
         ppsQueryTypeDetails++;
         } /* End for */
 
      *ppsQueryTypeDetails = NULL;
      } /* End if */

   } /* End getN_DbvQueryTypeDetails() */

void getN_DbvElementSetNames( DbvElementSetNames ***pppsElementSetNames, 
			      TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvElementSetNames **ppsElementSetNames;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* ElementSetNamess */

   if ( intfield > 0 )
      {
      ppsElementSetNames = ( DbvElementSetNames **)DbvAlloc( 
			( sizeof( DbvElementSetNames* ) * (intfield + 1 )));
      *pppsElementSetNames = ppsElementSetNames;

      for ( ; intfield; intfield-- )
         {
         get_DbvElementSetNames( ppsElementSetNames, InTable );
         ppsElementSetNames++;
         } /* End for */
 
      *ppsElementSetNames = NULL;
      } /* End if */

   } /* End getN_DbvElementSetNames() */

void getN_DbvInternationalString( 
		DbvInternationalString ***pppsInternationalString, 
		TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvInternationalString **ppsInternationalString;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* InternationalStrings */

   if ( intfield > 0 )
      {
      ppsInternationalString = ( DbvInternationalString **)DbvAlloc( 
			( sizeof( DbvInternationalString* ) * (intfield + 1 )));
      *pppsInternationalString = ppsInternationalString;

      for ( ; intfield; intfield-- )
         {
         get_DbvInternationalString( ppsInternationalString, InTable );
         ppsInternationalString++;
         } /* End for */
 
      *ppsInternationalString = NULL;
      } /* End if */

   } /* End getN_DbvInternationalString() */

void getN_DbvIconObject( DbvIconObject ***pppsDbvIconObject, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvIconObject **ppsDbvIconObject;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* IconObjects */

   if ( intfield > 0 )
      {
      ppsDbvIconObject = ( DbvIconObject **)DbvAlloc( 
			( sizeof( DbvIconObject* ) * (intfield + 1 )));
      *pppsDbvIconObject = ppsDbvIconObject;

      for ( ; intfield; intfield-- )
         {
         get_DbvIconObject( ppsDbvIconObject, InTable );
         ppsDbvIconObject++;
         } /* End for */
 
      *ppsDbvIconObject = NULL;
      } /* End if */

   } /* End getN_DbvIconObject() */

void getN_DbvPath( DbvPath ***pppsDbvPath, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvPath **ppsDbvPath;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Paths */

   if ( intfield > 0 )
      {
      ppsDbvPath = ( DbvPath **)DbvAlloc( 
			( sizeof( DbvPath* ) * (intfield + 1 )));
      *pppsDbvPath = ppsDbvPath;

      for ( ; intfield; intfield-- )
         {
         get_DbvPath( ppsDbvPath, InTable );
         ppsDbvPath++;
         } /* End for */
 
      *ppsDbvPath = NULL;
      } /* End if */

   } /* End getN_DbvPath() */

void getN_DbvPathA( DbvPathA ***pppsPathA, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvPathA **ppsPathA;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* PathAs */

   if ( intfield > 0 )
      {
      ppsPathA = ( DbvPathA **)DbvAlloc( 
			( sizeof( DbvPathA* ) * (intfield + 1 )));
      *pppsPathA = ppsPathA;

      for ( ; intfield; intfield-- )
         {
         get_DbvPathA( ppsPathA, InTable );
         ppsPathA++;
         } /* End for */
 
      *ppsPathA = NULL;
      } /* End if */

   } /* End getN_DbvPathA() */

void getN_DbvTagTypeMapping( DbvTagTypeMapping ***pppsDbvTagTypeMapping, 
		TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvTagTypeMapping **ppsDbvTagTypeMapping;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* DbvTagTypeMappings */

   if ( intfield > 0 )
      {
      ppsDbvTagTypeMapping = ( DbvTagTypeMapping **)DbvAlloc( 
			( sizeof( DbvTagTypeMapping* ) * (intfield + 1 )));
      *pppsDbvTagTypeMapping = ppsDbvTagTypeMapping;

      for ( ; intfield; intfield-- )
         {
         get_DbvTagTypeMapping( ppsDbvTagTypeMapping, InTable );
         ppsDbvTagTypeMapping++;
         } /* End for */
 
      *ppsDbvTagTypeMapping = NULL;
      } /* End if */

   } /* End getN_DbvTagTypeMapping() */

void getN_DbvElements( DbvElements ***pppsDbvElements, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvElements **ppsDbvElements;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Elementss */

   if ( intfield > 0 )
      {
      ppsDbvElements = ( DbvElements **)DbvAlloc( 
			( sizeof( DbvElements* ) * (intfield + 1 )));
      *pppsDbvElements = ppsDbvElements;

      for ( ; intfield; intfield-- )
         {
         get_DbvElements( ppsDbvElements, InTable );
         ppsDbvElements++;
         } /* End for */
 
      *ppsDbvElements = NULL;
      } /* End if */

   } /* End getN_DbvElements() */

void getN_DbvAttributeDescription( 
			DbvAttributeDescription ***pppsDbvAttributeDescription, 
			TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvAttributeDescription **ppsDbvAttributeDescription;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* AttributeDescriptions */

   if ( intfield > 0 )
      {
      ppsDbvAttributeDescription = ( DbvAttributeDescription **)DbvAlloc( 
			( sizeof( DbvAttributeDescription* ) *
			(intfield + 1 )));
      *pppsDbvAttributeDescription = ppsDbvAttributeDescription;

      for ( ; intfield; intfield-- )
         {
         get_DbvAttributeDescription( ppsDbvAttributeDescription, InTable );
         ppsDbvAttributeDescription++;
         } /* End for */
 
      *ppsDbvAttributeDescription = NULL;
      } /* End if */

   } /* End getN_DbvAttributeDescription() */

void getN_DbvAttributeType( DbvAttributeType ***pppsDbvAttributeType, 
			    TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvAttributeType **ppsDbvAttributeType;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* AttributeTypes */

   if ( intfield > 0 )
      {
      ppsDbvAttributeType = ( DbvAttributeType **)DbvAlloc( 
			( sizeof( DbvAttributeType* ) * (intfield + 1 )));
      *pppsDbvAttributeType = ppsDbvAttributeType;

      for ( ; intfield; intfield-- )
         {
         get_DbvAttributeType( ppsDbvAttributeType, InTable );
         ppsDbvAttributeType++;
         } /* End for */
 
      *ppsDbvAttributeType = NULL;
      } /* End if */

   } /* End getN_DbvAttributeType() */


void getN_DbvTermList( DbvTermList ***pppsTermList, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvTermList **ppsTermList;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* TermLists */

   if ( intfield > 0 )
      {
      ppsTermList = ( DbvTermList **)DbvAlloc( 
			( sizeof( DbvTermList* ) * (intfield + 1 )));
      *pppsTermList = ppsTermList;

      for ( ; intfield; intfield-- )
         {
         get_DbvTermList( ppsTermList, InTable );
         ppsTermList++;
         } /* End for */
 
      *ppsTermList = NULL;
      } /* End if */

   } /* End getN_DbvTermList() */

void getN_DbvStringOrNumeric( DbvStringOrNumeric ***pppsStringOrNumeric, 
			      TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvStringOrNumeric **ppsStringOrNumeric;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* StringOrNumerics */

   if ( intfield > 0 )
      {
      ppsStringOrNumeric = ( DbvStringOrNumeric **)DbvAlloc( 
			( sizeof( DbvStringOrNumeric* ) * (intfield + 1 )));
      *pppsStringOrNumeric = ppsStringOrNumeric;

      for ( ; intfield; intfield-- )
         {
         get_DbvStringOrNumeric( ppsStringOrNumeric, InTable );
         ppsStringOrNumeric++;
         } /* End for */
 
      *ppsStringOrNumeric = NULL;
      } /* End if */

   } /* End getN_DbvStringOrNumeric() */

void getN_DbvAttributeValues( DbvAttributeValues ***pppsAttributeValues, 
			      TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvAttributeValues **ppsAttributeValues;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* AttributeValues */

   if ( intfield > 0 )
      {
      ppsAttributeValues = ( DbvAttributeValues **)DbvAlloc( 
			( sizeof( DbvAttributeValues* ) * (intfield + 1 )));
      *pppsAttributeValues = ppsAttributeValues;

      for ( ; intfield; intfield-- )
         {
         get_DbvAttributeValues( ppsAttributeValues, InTable );
         ppsAttributeValues++;
         } /* End for */
 
      *ppsAttributeValues = NULL;
      } /* End if */

   } /* End getN_DbvAttributeValues() */

void getN_DbvAttributesByType( DbvAttributesByType ***pppsAttributesByType, 
			      TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvAttributesByType **ppsAttributesByType;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* AttributesByType */

   if ( intfield > 0 )
      {
      ppsAttributesByType = ( DbvAttributesByType **)DbvAlloc( 
			( sizeof( DbvAttributesByType* ) * (intfield + 1 )));
      *pppsAttributesByType = ppsAttributesByType;

      for ( ; intfield; intfield-- )
         {
         get_DbvAttributesByType( ppsAttributesByType, InTable );
         ppsAttributesByType++;
         } /* End for */
 
      *ppsAttributesByType = NULL;
      } /* End if */

   } /* End getN_DbvAttributesByType() */

void getN_DbvAttributesBySet( DbvAttributesBySet ***pppsAttributesBySet, 
			      TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvAttributesBySet **ppsAttributesBySet;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* AttributesBySets */

   if ( intfield > 0 )
      {
      ppsAttributesBySet = ( DbvAttributesBySet **)DbvAlloc( 
			( sizeof( DbvAttributesBySet* ) * (intfield + 1 )));
      *pppsAttributesBySet = ppsAttributesBySet;

      for ( ; intfield; intfield-- )
         {
         get_DbvAttributesBySet( ppsAttributesBySet, InTable );
         ppsAttributesBySet++;
         } /* End for */
 
      *ppsAttributesBySet = NULL;
      } /* End if */

   } /* End getN_DbvAttributesBySet() */

void getN_DbvAttributeOccurrence( 
		DbvAttributeOccurrence ***pppsAttributeOccurrence, 
		TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvAttributeOccurrence **ppsAttributeOccurrence;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* AttributeOccurrences */

   if ( intfield > 0 )
      {
      ppsAttributeOccurrence = ( DbvAttributeOccurrence **)DbvAlloc( 
			( sizeof( DbvAttributeOccurrence* ) * (intfield + 1 )));
      *pppsAttributeOccurrence = ppsAttributeOccurrence;

      for ( ; intfield; intfield-- )
         {
         get_DbvAttributeOccurrence( ppsAttributeOccurrence, InTable );
         ppsAttributeOccurrence++;
         } /* End for */
 
      *ppsAttributeOccurrence = NULL;
      } /* End if */

   } /* End getN_DbvAttributeOccurrence() */

void getN_DbvAttributeCombination( 
	DbvAttributeCombination ***pppsAttributeCombination, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvAttributeCombination **ppsAttributeCombination;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* AttributeCombinations */

   if ( intfield > 0 )
      {
      ppsAttributeCombination = ( DbvAttributeCombination **)DbvAlloc( 
		( sizeof( DbvAttributeCombination* ) * (intfield + 1 )));
      *pppsAttributeCombination = ppsAttributeCombination;

      for ( ; intfield; intfield-- )
         {
         get_DbvAttributeCombination( ppsAttributeCombination, InTable );
         ppsAttributeCombination++;
         } /* End for */
 
      *ppsAttributeCombination = NULL;
      } /* End if */

   } /* End getN_DbvAttributeCombination() */

void getN_DbvAttributeCombinations( 
			DbvAttributeCombinations ***pppsAttributeCombinations, 
			TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvAttributeCombinations **ppsAttributeCombinations;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* AttributeCombinations */

   if ( intfield > 0 )
      {
      ppsAttributeCombinations = ( DbvAttributeCombinations **)DbvAlloc( 
			( sizeof(DbvAttributeCombinations*) * (intfield + 1 )));
      *pppsAttributeCombinations = ppsAttributeCombinations;

      for ( ; intfield; intfield-- )
         {
         get_DbvAttributeCombinations( ppsAttributeCombinations, InTable );
         ppsAttributeCombinations++;
         } /* End for */
 
      *ppsAttributeCombinations = NULL;
      } /* End if */

   } /* End getN_DbvAttributeCombinations() */

void getN_DbvTerm( DbvTerm ***pppsTerm, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvTerm **ppsTerm;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Term */

   if ( intfield > 0 )
      {
      ppsTerm = ( DbvTerm **)DbvAlloc( 
			( sizeof(DbvTerm*) * (intfield + 1 )));
      *pppsTerm = ppsTerm;

      for ( ; intfield; intfield-- )
         {
         get_DbvTerm( ppsTerm, InTable );
         ppsTerm++;
         } /* End for */
 
      *ppsTerm = NULL;
      } /* End if */

   } /* End getN_DbvTerm() */

void getN_DbvDetailsPerElement( DbvDetailsPerElement ***pppsDetailsPerElement, 
				TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvDetailsPerElement **ppsDetailsPerElement;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* DetailsPerElement */

   if ( intfield > 0 )
      {
      ppsDetailsPerElement = ( DbvDetailsPerElement **)DbvAlloc( 
			( sizeof(DbvDetailsPerElement*) * (intfield + 1 )));
      *pppsDetailsPerElement = ppsDetailsPerElement;

      for ( ; intfield; intfield-- )
         {
         get_DbvDetailsPerElement( ppsDetailsPerElement, InTable );
         ppsDetailsPerElement++;
         } /* End for */
 
      *ppsDetailsPerElement = NULL;
      } /* End if */

   } /* End getN_DbvDetailsPerElement() */

void getN_DbvSpecification( DbvSpecification ***pppsSpecification, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvSpecification **ppsSpecification;
   DbvBool doingfirst = DBV_TRUE;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Specification */

   if ( intfield > 0 )
      {
      ppsSpecification = ( DbvSpecification **)DbvAlloc( 
			( sizeof(DbvSpecification*) * (intfield + 1 )));
      *pppsSpecification = ppsSpecification;

      for ( ; intfield; intfield-- )
         {

         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);

         stringfield = get_string_field( InTable, T_Return );
         if( (strcmp(stringfield, NOTHING)) != 0 ) {

#ifdef NO
	 	/* must do a TBL_GetRecord for every Specification except
	    	the first because DbvSpecification starts 
	    	with a DbvObjectIdentifier */
	 	if (doingfirst == DBV_TRUE)
			doingfirst = DBV_FALSE;
	 	else
   	 		TBL_GetRecord( InTable );
#endif

   	 	TBL_GetRecord( InTable );
         	get_DbvSpecification( ppsSpecification, InTable );
         	ppsSpecification++;
	}
	DbvFree(stringfield);

         } /* End for */
 
      *ppsSpecification = NULL;
      } /* End if */

   } /* End getN_DbvSpecification() */

void getN_DbvSortKeys( DbvSortKeys ***pppsSortKeys, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvSortKeys **ppsSortKeys;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* SortKeyss */

   if ( intfield > 0 )
      {
      ppsSortKeys = ( DbvSortKeys **)DbvAlloc( 
			( sizeof( DbvSortKeys* ) * (intfield + 1 )));
      *pppsSortKeys = ppsSortKeys;

      for ( ; intfield; intfield-- )
         {
         get_DbvSortKeys( ppsSortKeys, InTable );
         ppsSortKeys++;
         } /* End for */
 
      *ppsSortKeys = NULL;
      } /* End if */

   } /* End getN_DbvSortKeys() */

void getN_DbvVariantTypes( DbvVariantTypes ***pppsVariantTypes, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvVariantTypes **ppsVariantTypes;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* VariantTypess */

   if ( intfield > 0 )
      {
      ppsVariantTypes = ( DbvVariantTypes **)DbvAlloc( 
			( sizeof( DbvVariantTypes* ) * (intfield + 1 )));
      *pppsVariantTypes = ppsVariantTypes;

      for ( ; intfield; intfield-- )
         {
         get_DbvVariantTypes( ppsVariantTypes, InTable );
         ppsVariantTypes++;
         } /* End for */
 
      *ppsVariantTypes = NULL;
      } /* End if */

   } /* End getN_DbvVariantTypes() */

void getN_DbvVariantClass( DbvVariantClass ***pppsVariantClass, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvVariantClass **ppsVariantClass;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Variants */

   if ( intfield > 0 )
      {
      ppsVariantClass = ( DbvVariantClass **)DbvAlloc( 
			( sizeof( DbvVariantClass* ) * (intfield + 1 )));
      *pppsVariantClass = ppsVariantClass;

      for ( ; intfield; intfield-- )
         {
         get_DbvVariantClass( ppsVariantClass, InTable );
         ppsVariantClass++;
         } /* End for */
 
      *ppsVariantClass = NULL;
      } /* End if */

   } /* End getN_DbvVariantClass() */

void getN_DbvUnitType( DbvUnitType ***pppsUnitType, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvUnitType **ppsUnitType;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* UnitTypes */

   if ( intfield > 0 )
      {
      ppsUnitType = ( DbvUnitType **)DbvAlloc( 
			( sizeof( DbvUnitType* ) * (intfield + 1 )));
      *pppsUnitType = ppsUnitType;

      for ( ; intfield; intfield-- )
         {
         get_DbvUnitType( ppsUnitType, InTable );
         ppsUnitType++;
         } /* End for */
 
      *ppsUnitType = NULL;
      } /* End if */

   } /* End getN_DbvUnitType() */

void getN_DbvUnit( DbvUnit ***pppsUnit, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvUnit **ppsUnit;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Units */

   if ( intfield > 0 )
      {
      ppsUnit = ( DbvUnit **)DbvAlloc( ( sizeof( DbvUnit* ) * (intfield + 1 )));
      *pppsUnit = ppsUnit;

      for ( ; intfield; intfield-- )
         {
         get_DbvUnit( ppsUnit, InTable );
         ppsUnit++;
         } /* End for */
 
      *ppsUnit = NULL;
      } /* End if */

   } /* End getN_DbvUnit() */

void getN_DbvUnits( DbvUnits ***pppsUnits, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvUnits **ppsUnits;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Unitss */

   if ( intfield > 0 )
      {
      ppsUnits = ( DbvUnits **)DbvAlloc( 
			( sizeof( DbvUnits* ) * (intfield + 1 )));
      *pppsUnits = ppsUnits;

      for ( ; intfield; intfield-- )
         {
         get_DbvUnits( ppsUnits, InTable );
         ppsUnits++;
         } /* End for */
 
      *ppsUnits = NULL;
      } /* End if */

   } /* End getN_DbvUnits() */

void getN_DbvCategoryInfo( DbvCategoryInfo ***pppsCategoryInfo, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvCategoryInfo **ppsCategoryInfo;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* CategoryInfo */

   if ( intfield > 0 )
      {
      ppsCategoryInfo = ( DbvCategoryInfo **)DbvAlloc( 
			( sizeof( DbvCategoryInfo* ) * (intfield + 1 )));
      *pppsCategoryInfo = ppsCategoryInfo;

      for ( ; intfield; intfield-- )
         {
         get_DbvCategoryInfo( ppsCategoryInfo, InTable );
         ppsCategoryInfo++;
         } /* End for */
 
      *ppsCategoryInfo = NULL;
      } /* End if */

   } /* End getN_DbvCategoryInfo() */

void getN_DbvAccessRestrictions(
		DbvAccessRestrictions ***pppsAccessRestrictions, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvAccessRestrictions **ppsAccessRestrictions;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* AccessRestrictionss */

   if ( intfield > 0 )
      {
      ppsAccessRestrictions = ( DbvAccessRestrictions **)DbvAlloc( 
			( sizeof( DbvAccessRestrictions* ) * (intfield + 1 )));
      *pppsAccessRestrictions = ppsAccessRestrictions;

      for ( ; intfield; intfield-- )
         {
         get_DbvAccessRestrictions( ppsAccessRestrictions, InTable );
         ppsAccessRestrictions++;
         } /* End for */
 
      *ppsAccessRestrictions = NULL;
      } /* End if */

   } /* End getN_DbvAccessRestrictions() */

void getN_DbvNetworkAddress( DbvNetworkAddress ***pppsNetworkAddress, 
				TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvNetworkAddress **ppsNetworkAddress;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* NetworkAddresss */

   if ( intfield > 0 )
      {
      ppsNetworkAddress = ( DbvNetworkAddress **)DbvAlloc( 
			( sizeof( DbvNetworkAddress* ) * (intfield + 1 )));
      *pppsNetworkAddress = ppsNetworkAddress;

      for ( ; intfield; intfield-- )
         {
         get_DbvNetworkAddress( ppsNetworkAddress, InTable );
         ppsNetworkAddress++;
         } /* End for */
 
      *ppsNetworkAddress = NULL;
      } /* End if */

   } /* End getN_DbvNetworkAddress() */

void getN_DbvElementInfo( DbvElementInfo ***pppsElementInfo, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvElementInfo **ppsElementInfo;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* ElementInfos */

   if ( intfield > 0 )
      {
      ppsElementInfo = ( DbvElementInfo **)DbvAlloc( 
			( sizeof( DbvElementInfo* ) * (intfield + 1 )));
      *pppsElementInfo = ppsElementInfo;

      for ( ; intfield; intfield-- )
         {
         get_DbvElementInfo( ppsElementInfo, InTable );
         ppsElementInfo++;
         } /* End for */
 
      *ppsElementInfo = NULL;
      } /* End if */

   } /* End getN_DbvElementInfo() */


#ifdef NOT_YET_IMPLEMENTED

void getN_DbvValue( DbvValue ***pppsValue, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvValue **ppsValue;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Value */

   if ( intfield > 0 )
      {
      ppsValue = ( DbvValue **)DbvAlloc( 
			( sizeof( DbvValue* ) * (intfield + 1 )));
      *pppsValue = ppsValue;

      for ( ; intfield; intfield-- )
         {
         get_DbvValue( ppsValue, InTable );
         ppsValue++;
         } /* End for */
 
      *ppsValue = NULL;
      } /* End if */

   } /* End getN_DbvValue() */

void getN_DbvTriples( DbvTriples ***pppsTriples, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvTriples **ppsTriples;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Triples */

   if ( intfield > 0 )
      {
      ppsTriples = ( DbvTriples **)DbvAlloc( 
			( sizeof( DbvTriples* ) * (intfield + 1 )));
      *pppsTriples = ppsTriples;

      for ( ; intfield; intfield-- )
         {
         get_DbvTriples( ppsTriples, InTable );
         ppsTriples++;
         } /* End for */
 
      *ppsTriples = NULL;
      } /* End if */

   } /* End getN_DbvTriples() */

void getN_DbvTagPath( DbvTagPath ***pppsTagPath, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvTagPath **ppsTagPath;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* TagPath */

   if ( intfield > 0 )
      {
      ppsTagPath = ( DbvTagPath **)DbvAlloc( 
			( sizeof( DbvTagPath* ) * (intfield + 1 )));
      *pppsTagPath = ppsTagPath;

      for ( ; intfield; intfield-- )
         {
         get_DbvTagPath( ppsTagPath, InTable );
         ppsTagPath++;
         } /* End for */
 
      *ppsTagPath = NULL;
      } /* End if */

   } /* End getN_DbvTagPath() */

void getN_DbvTaggedElement( DbvTaggedElement ***pppsTaggedElement, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvTaggedElement **ppsTaggedElement;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* TaggedElements */

   if ( intfield > 0 )
      {
      ppsTaggedElement = ( DbvTaggedElement **)DbvAlloc( 
			( sizeof( DbvTaggedElement* ) * (intfield + 1 )));
      *pppsTaggedElement = ppsTaggedElement;

      for ( ; intfield; intfield-- )
         {
         get_DbvTaggedElement( ppsTaggedElement, InTable );
         ppsTaggedElement++;
         } /* End for */
 
      *ppsTaggedElement = NULL;
      } /* End if */

   } /* End getN_DbvTaggedElement() */

#endif


void getN_DbvValueDescription( DbvValueDescription ***pppsValueDescription, 
								TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvValueDescription **ppsValueDescription;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* ValueDescriptions */

   if ( intfield > 0 )
      {
      ppsValueDescription = ( DbvValueDescription **)DbvAlloc( 
			( sizeof( DbvValueDescription* ) * (intfield + 1 )));
      *pppsValueDescription = ppsValueDescription;

      for ( ; intfield; intfield-- )
         {
         get_DbvValueDescription( ppsValueDescription, InTable );
         ppsValueDescription++;
         } /* End for */
 
      *ppsValueDescription = NULL;
      } /* End if */

   } /* End getN_DbvValueDescription() */


#ifdef NOT_YET_IMPLEMENTED

void getN_DbvVariant( DbvVariant ***pppsVariant, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvVariant **ppsVariant;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Variants */

   if ( intfield > 0 )
      {
      ppsVariant = ( DbvVariant **)DbvAlloc( 
			( sizeof( DbvVariant* ) * (intfield + 1 )));
      *pppsVariant = ppsVariant;

      for ( ; intfield; intfield-- )
         {
         get_DbvVariant( ppsVariant, InTable );
         ppsVariant++;
         } /* End for */
 
      *ppsVariant = NULL;
      } /* End if */

   } /* End getN_DbvVariant() */

void getN_DbvHits( DbvHits ***pppsHits, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvHits **ppsHits;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* Hitss */

   if ( intfield > 0 )
      {
      ppsHits = ( DbvHits **)DbvAlloc( 
			( sizeof( DbvHits* ) * (intfield + 1 )));
      *pppsHits = ppsHits;

      for ( ; intfield; intfield-- )
         {
         get_DbvHits( ppsHits, InTable );
         ppsHits++;
         } /* End for */
 
      *ppsHits = NULL;
      } /* End if */

   } /* End getN_DbvHits() */

#endif

void getN_DbvDataBaseInfoSeq( DbvDataBaseInfoSeq ***pppsDataBaseInfoSeq, 
								TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvDataBaseInfoSeq **ppsDataBaseInfoSeq;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );

   /* DataBaseInfoSeqs */

   if ( intfield > 0 )
      {
      ppsDataBaseInfoSeq = ( DbvDataBaseInfoSeq **)DbvAlloc( 
			( sizeof( DbvDataBaseInfoSeq* ) * (intfield + 1 )));
      *pppsDataBaseInfoSeq = ppsDataBaseInfoSeq;

      for ( ; intfield; intfield-- )
         {
         get_DbvDataBaseInfoSeq( ppsDataBaseInfoSeq, InTable );
         ppsDataBaseInfoSeq++;
         } /* End for */
 
      *ppsDataBaseInfoSeq = NULL;
      } /* End if */

   } /* End getN_DbvDataBaseInfoSeq() */

