/*  Module Name: @(#)getN_DbvFuncs.c	6.5
    Version: 11/8/96
    Author: Dan Maskell/strdgen
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
	Functions to read in lists of structures.

*/
 
#include "get_DbvFuncs.h"
 
extern TBL_Return T_Return;
/*+-----------------------------------------------+*/
/*! getN_DbvCharSetAndLanguage                    !*/ 
/*+-----------------------------------------------+*/
void getN_DbvCharSetAndLanguage( DbvCharSetAndLanguage ***pppsDbvCharSetAndLanguage,
				 TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvCharSetAndLanguage **ppsDbvCharSetAndLanguage;
 
#ifdef DEBUG
   printf( "D - getN_DbvCharSetAndLanguage()\n" );
#endif
  
   /* Attribute Elements */
 
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );
 
   intfield = get_int_field( InTable, T_Return );
 
   /* Elements */
   if ( intfield > 0 )
      {
      ppsDbvCharSetAndLanguage = ( DbvCharSetAndLanguage **)DbvAlloc( 
			( sizeof( DbvCharSetAndLanguage* ) * (intfield + 1 )));
      *pppsDbvCharSetAndLanguage = ppsDbvCharSetAndLanguage;
      for ( ; intfield; intfield-- )
         {
         get_DbvCharSetAndLanguage( ppsDbvCharSetAndLanguage, InTable );
         ppsDbvCharSetAndLanguage++;
         } /* End for */
  
      *ppsDbvCharSetAndLanguage = NULL;
      } /* End if */
 
   } /* End getN_DbvCharSetAndLanguage() */
 
/*+-----------------------------------------------+*/
/*! getN_DbvTargetResponse                        !*/ 
/*+-----------------------------------------------+*/
void getN_DbvTargetResponse( DbvTargetResponse ***pppsDbvTargetResponse,
				 TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvTargetResponse **ppsDbvTargetResponse;
 
#ifdef DEBUG
   printf( "D - getN_DbvTargetResponse()\n" );
#endif
  
   /* Attribute Elements */
 
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );
 
   intfield = get_int_field( InTable, T_Return );
 
   /* Elements */
   if ( intfield > 0 )
      {
      ppsDbvTargetResponse = ( DbvTargetResponse **)DbvAlloc( 
			( sizeof( DbvTargetResponse* ) * (intfield + 1 )));
      *pppsDbvTargetResponse = ppsDbvTargetResponse;
      for ( ; intfield; intfield-- )
         {
         get_DbvTargetResponse( ppsDbvTargetResponse, InTable );
         ppsDbvTargetResponse++;
         } /* End for */
  
      *ppsDbvTargetResponse = NULL;
      } /* End if */
 
   } /* End getN_DbvTargetResponse() */
 
/*+-----------------------------------------------+*/
/*! getN_DbvSelectedCharSet                       !*/ 
/*+-----------------------------------------------+*/
void getN_DbvSelectedCharSet( DbvSelectedCharSet ***pppsDbvSelectedCharSet,
				 TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvSelectedCharSet **ppsDbvSelectedCharSet;
 
#ifdef DEBUG
   printf( "D - getN_DbvSelectedCharSet()\n" );
#endif
  
   /* Attribute Elements */
 
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );
 
   intfield = get_int_field( InTable, T_Return );
 
   /* Elements */
   if ( intfield > 0 )
      {
      ppsDbvSelectedCharSet = ( DbvSelectedCharSet **)DbvAlloc( 
			( sizeof( DbvSelectedCharSet* ) * (intfield + 1 )));
      *pppsDbvSelectedCharSet = ppsDbvSelectedCharSet;
      for ( ; intfield; intfield-- )
         {
         get_DbvSelectedCharSet( ppsDbvSelectedCharSet, InTable );
         ppsDbvSelectedCharSet++;
         } /* End for */
  
      *ppsDbvSelectedCharSet = NULL;
      } /* End if */
 
   } /* End getN_DbvSelectedCharSet() */
 
/*+-----------------------------------------------+*/
/*! getN_DbvOriginProposal                        !*/ 
/*+-----------------------------------------------+*/
void getN_DbvOriginProposal( DbvOriginProposal ***pppsDbvOriginProposal,
				 TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvOriginProposal **ppsDbvOriginProposal;
 
#ifdef DEBUG
   printf( "D - getN_DbvOriginProposal()\n" );
#endif
  
   /* Attribute Elements */
 
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );
 
   intfield = get_int_field( InTable, T_Return );
 
   /* Elements */
   if ( intfield > 0 )
      {
      ppsDbvOriginProposal = ( DbvOriginProposal **)DbvAlloc( 
			( sizeof( DbvOriginProposal* ) * (intfield + 1 )));
      *pppsDbvOriginProposal = ppsDbvOriginProposal;
      for ( ; intfield; intfield-- )
         {
         get_DbvOriginProposal( ppsDbvOriginProposal, InTable );
         ppsDbvOriginProposal++;
         } /* End for */
  
      *ppsDbvOriginProposal = NULL;
      } /* End if */
 
   } /* End getN_DbvOriginProposal() */
 
/*+-----------------------------------------------+*/
/*! getN_DbvProposedCharSet                       !*/ 
/*+-----------------------------------------------+*/
void getN_DbvProposedCharSet( DbvProposedCharSet ***pppsDbvProposedCharSet,
				 TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvProposedCharSet **ppsDbvProposedCharSet;
 
#ifdef DEBUG
   printf( "D - getN_DbvProposedCharSet()\n" );
#endif
  
   /* Attribute Elements */
 
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );
 
   intfield = get_int_field( InTable, T_Return );
 
   /* Elements */
   if ( intfield > 0 )
      {
      ppsDbvProposedCharSet = ( DbvProposedCharSet **)DbvAlloc( 
			( sizeof( DbvProposedCharSet* ) * (intfield + 1 )));
      *pppsDbvProposedCharSet = ppsDbvProposedCharSet;
      for ( ; intfield; intfield-- )
         {
         get_DbvProposedCharSet( ppsDbvProposedCharSet, InTable );
         ppsDbvProposedCharSet++;
         } /* End for */
  
      *ppsDbvProposedCharSet = NULL;
      } /* End if */
 
   } /* End getN_DbvProposedCharSet() */
 
/*+-----------------------------------------------+*/
/*! getN_DbvPrivateCharacterSet                   !*/ 
/*+-----------------------------------------------+*/
void getN_DbvPrivateCharacterSet( DbvPrivateCharacterSet ***pppsDbvPrivateCharacterSet,
				 TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvPrivateCharacterSet **ppsDbvPrivateCharacterSet;
 
#ifdef DEBUG
   printf( "D - getN_DbvPrivateCharacterSet()\n" );
#endif
  
   /* Attribute Elements */
 
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );
 
   intfield = get_int_field( InTable, T_Return );
 
   /* Elements */
   if ( intfield > 0 )
      {
      ppsDbvPrivateCharacterSet = ( DbvPrivateCharacterSet **)DbvAlloc( 
			( sizeof( DbvPrivateCharacterSet* ) * (intfield + 1 )));
      *pppsDbvPrivateCharacterSet = ppsDbvPrivateCharacterSet;
      for ( ; intfield; intfield-- )
         {
         get_DbvPrivateCharacterSet( ppsDbvPrivateCharacterSet, InTable );
         ppsDbvPrivateCharacterSet++;
         } /* End for */
  
      *ppsDbvPrivateCharacterSet = NULL;
      } /* End if */
 
   } /* End getN_DbvPrivateCharacterSet() */
 
/*+-----------------------------------------------+*/
/*! getN_DbvIso10646                              !*/ 
/*+-----------------------------------------------+*/
void getN_DbvIso10646( DbvIso10646 ***pppsDbvIso10646,
				 TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvIso10646 **ppsDbvIso10646;
 
#ifdef DEBUG
   printf( "D - getN_DbvIso10646()\n" );
#endif
  
   /* Attribute Elements */
 
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );
 
   intfield = get_int_field( InTable, T_Return );
 
   /* Elements */
   if ( intfield > 0 )
      {
      ppsDbvIso10646 = ( DbvIso10646 **)DbvAlloc( 
			( sizeof( DbvIso10646* ) * (intfield + 1 )));
      *pppsDbvIso10646 = ppsDbvIso10646;
      for ( ; intfield; intfield-- )
         {
         get_DbvIso10646( ppsDbvIso10646, InTable );
         ppsDbvIso10646++;
         } /* End for */
  
      *ppsDbvIso10646 = NULL;
      } /* End if */
 
   } /* End getN_DbvIso10646() */
 
/*+-----------------------------------------------+*/
/*! getN_DbvIso2022                               !*/ 
/*+-----------------------------------------------+*/
void getN_DbvIso2022( DbvIso2022 ***pppsDbvIso2022,
				 TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvIso2022 **ppsDbvIso2022;
 
#ifdef DEBUG
   printf( "D - getN_DbvIso2022()\n" );
#endif
  
   /* Attribute Elements */
 
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );
 
   intfield = get_int_field( InTable, T_Return );
 
   /* Elements */
   if ( intfield > 0 )
      {
      ppsDbvIso2022 = ( DbvIso2022 **)DbvAlloc( 
			( sizeof( DbvIso2022* ) * (intfield + 1 )));
      *pppsDbvIso2022 = ppsDbvIso2022;
      for ( ; intfield; intfield-- )
         {
         get_DbvIso2022( ppsDbvIso2022, InTable );
         ppsDbvIso2022++;
         } /* End for */
  
      *ppsDbvIso2022 = NULL;
      } /* End if */
 
   } /* End getN_DbvIso2022() */
 
/*+-----------------------------------------------+*/
/*! getN_DbvIso2022Response                       !*/ 
/*+-----------------------------------------------+*/
void getN_DbvIso2022Response( DbvIso2022Response ***pppsDbvIso2022Response,
				 TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvIso2022Response **ppsDbvIso2022Response;
 
#ifdef DEBUG
   printf( "D - getN_DbvIso2022Response()\n" );
#endif
  
   /* Attribute Elements */
 
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );
 
   intfield = get_int_field( InTable, T_Return );
 
   /* Elements */
   if ( intfield > 0 )
      {
      ppsDbvIso2022Response = ( DbvIso2022Response **)DbvAlloc( 
			( sizeof( DbvIso2022Response* ) * (intfield + 1 )));
      *pppsDbvIso2022Response = ppsDbvIso2022Response;
      for ( ; intfield; intfield-- )
         {
         get_DbvIso2022Response( ppsDbvIso2022Response, InTable );
         ppsDbvIso2022Response++;
         } /* End for */
  
      *ppsDbvIso2022Response = NULL;
      } /* End if */
 
   } /* End getN_DbvIso2022Response() */
 
/*+-----------------------------------------------+*/
/*! getN_DbvIso2022Proposal                       !*/ 
/*+-----------------------------------------------+*/
void getN_DbvIso2022Proposal( DbvIso2022Proposal ***pppsDbvIso2022Proposal,
				 TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvIso2022Proposal **ppsDbvIso2022Proposal;
 
#ifdef DEBUG
   printf( "D - getN_DbvIso2022Proposal()\n" );
#endif
  
   /* Attribute Elements */
 
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );
 
   intfield = get_int_field( InTable, T_Return );
 
   /* Elements */
   if ( intfield > 0 )
      {
      ppsDbvIso2022Proposal = ( DbvIso2022Proposal **)DbvAlloc( 
			( sizeof( DbvIso2022Proposal* ) * (intfield + 1 )));
      *pppsDbvIso2022Proposal = ppsDbvIso2022Proposal;
      for ( ; intfield; intfield-- )
         {
         get_DbvIso2022Proposal( ppsDbvIso2022Proposal, InTable );
         ppsDbvIso2022Proposal++;
         } /* End for */
  
      *ppsDbvIso2022Proposal = NULL;
      } /* End if */
 
   } /* End getN_DbvIso2022Proposal() */
 
/*+-----------------------------------------------+*/
/*! getN_DbvLeftAndRight                          !*/ 
/*+-----------------------------------------------+*/
void getN_DbvLeftAndRight( DbvLeftAndRight ***pppsDbvLeftAndRight,
				 TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvLeftAndRight **ppsDbvLeftAndRight;
 
#ifdef DEBUG
   printf( "D - getN_DbvLeftAndRight()\n" );
#endif
  
   /* Attribute Elements */
 
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );
 
   intfield = get_int_field( InTable, T_Return );
 
   /* Elements */
   if ( intfield > 0 )
      {
      ppsDbvLeftAndRight = ( DbvLeftAndRight **)DbvAlloc( 
			( sizeof( DbvLeftAndRight* ) * (intfield + 1 )));
      *pppsDbvLeftAndRight = ppsDbvLeftAndRight;
      for ( ; intfield; intfield-- )
         {
         get_DbvLeftAndRight( ppsDbvLeftAndRight, InTable );
         ppsDbvLeftAndRight++;
         } /* End for */
  
      *ppsDbvLeftAndRight = NULL;
      } /* End if */
 
   } /* End getN_DbvLeftAndRight() */
 
/*+-----------------------------------------------+*/
/*! getN_DbvInitialSet                            !*/ 
/*+-----------------------------------------------+*/
void getN_DbvInitialSet( DbvInitialSet ***pppsDbvInitialSet,
				 TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvInitialSet **ppsDbvInitialSet;
 
#ifdef DEBUG
   printf( "D - getN_DbvInitialSet()\n" );
#endif
  
   /* Attribute Elements */
 
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );
 
   intfield = get_int_field( InTable, T_Return );
 
   /* Elements */
   if ( intfield > 0 )
      {
      ppsDbvInitialSet = ( DbvInitialSet **)DbvAlloc( 
			( sizeof( DbvInitialSet* ) * (intfield + 1 )));
      *pppsDbvInitialSet = ppsDbvInitialSet;
      for ( ; intfield; intfield-- )
         {
         get_DbvInitialSet( ppsDbvInitialSet, InTable );
         ppsDbvInitialSet++;
         } /* End for */
  
      *ppsDbvInitialSet = NULL;
      } /* End if */
 
   } /* End getN_DbvInitialSet() */
 
/*+-----------------------------------------------+*/
/*! getN_DbvEnvironment                           !*/ 
/*+-----------------------------------------------+*/
void getN_DbvEnvironment( DbvEnvironment ***pppsDbvEnvironment,
				 TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvEnvironment **ppsDbvEnvironment;
 
#ifdef DEBUG
   printf( "D - getN_DbvEnvironment()\n" );
#endif
  
   /* Attribute Elements */
 
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );
 
   intfield = get_int_field( InTable, T_Return );
 
   /* Elements */
   if ( intfield > 0 )
      {
      ppsDbvEnvironment = ( DbvEnvironment **)DbvAlloc( 
			( sizeof( DbvEnvironment* ) * (intfield + 1 )));
      *pppsDbvEnvironment = ppsDbvEnvironment;
      for ( ; intfield; intfield-- )
         {
         get_DbvEnvironment( ppsDbvEnvironment, InTable );
         ppsDbvEnvironment++;
         } /* End for */
  
      *ppsDbvEnvironment = NULL;
      } /* End if */
 
   } /* End getN_DbvEnvironment() */
 


/*+-----------------------------------------------+*/
/*! getN_DbvLanguageCode                           !*/ 
/*+-----------------------------------------------+*/
void getN_DbvLanguageCode( DbvLanguageCode ***pppsProposedLanguages,
				 TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvLanguageCode **ppsProposedLanguages;
 
#ifdef DEBUG
   printf( "D - getN_DbvLanguageCode()\n" );
#endif
  
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return ); 
   DbvFree( stringfield );
 
   intfield = get_int_field( InTable, T_Return );
 
   if ( intfield > 0 )
      {
      ppsProposedLanguages = ( DbvLanguageCode **)DbvAlloc( 
			( sizeof( DbvLanguageCode* ) * (intfield + 1 )));
      *pppsProposedLanguages = ppsProposedLanguages;
      for ( ; intfield; intfield-- )
         {
         get_DbvLanguageCode( ppsProposedLanguages, InTable );
         ppsProposedLanguages++;
         } /* End for */
  
      *ppsProposedLanguages = NULL;
      } /* End if */
 
   } /* End getN_DbvLanguageCode() */







