/*  Module Name: @(#)get_DbvFuncs1.c	7.1
    Version: 11/15/96
    Author: Dan Maskell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to get structure types from the script files. 
	Used by the origin and target.

    12-04-96 D.B.Maskell Created for Ill support
*/
 
#include "get_DbvFuncs.h"


#undef DEBUG

extern TBL_Return T_Return;


void get_DbvRequesterGroup( DbvRequesterGroup **ppeRequesterGroup, TBL InTable )
   {
   char *stringfield;
   DbvRequesterGroup	*peRequesterGroup;
   DbvRequesterGroup	eRequesterGroup;

#ifdef DEBUG
   printf( "D - get_DbvRequesterGroup()\n" );
#endif
   /* Malloc the space */

   if ( *ppeRequesterGroup == NULL )
      *ppeRequesterGroup = (DbvRequesterGroup*)DbvAlloc(
						sizeof( DbvRequesterGroup ));
   peRequesterGroup = *ppeRequesterGroup;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvRequesterGroup( &stringfield, &eRequesterGroup );
   *peRequesterGroup = eRequesterGroup;
   DbvFree( stringfield );

   } /* End get_DbvRequesterGroup() */


void get_DbvStatusLevelUser( DbvStatusLevelUser **ppeStatusLevelUser, 
								TBL InTable )
   {
   char *stringfield;
   DbvStatusLevelUser	*peStatusLevelUser;
   DbvStatusLevelUser	eStatusLevelUser;

#ifdef DEBUG
   printf( "D - get_DbvStatusLevelUser()\n" );
#endif
   /* Malloc the space */

   if ( *ppeStatusLevelUser == NULL )
      *ppeStatusLevelUser = (DbvStatusLevelUser*)DbvAlloc(
						sizeof( DbvStatusLevelUser ));
   peStatusLevelUser = *ppeStatusLevelUser;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvStatusLevelUser( &stringfield, &eStatusLevelUser );
   *peStatusLevelUser = eStatusLevelUser;
   DbvFree( stringfield );

   } /* End get_DbvStatusLevelUser() */

void get_DbvStatusLevelRequester( 
		DbvStatusLevelRequester **ppeStatusLevelRequester, 
		TBL InTable )
   {
   char *stringfield;
   DbvStatusLevelRequester	*peStatusLevelRequester;
   DbvStatusLevelRequester	eStatusLevelRequester;

#ifdef DEBUG
   printf( "D - get_DbvStatusLevelRequester()\n" );
#endif
   /* Malloc the space */

   if ( *ppeStatusLevelRequester == NULL )
      *ppeStatusLevelRequester = (DbvStatusLevelRequester*)DbvAlloc( 
					sizeof( DbvStatusLevelRequester ));
   peStatusLevelRequester = *ppeStatusLevelRequester;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvStatusLevelRequester( &stringfield, &eStatusLevelRequester );
   *peStatusLevelRequester = eStatusLevelRequester;
   DbvFree( stringfield );

   } /* End get_DbvStatusLevelRequester() */



