/*  Module Name: @(#)get_DbvFuncs2.c	7.1
    Version: 11/15/96
    Author: Dan Maskell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to get structure types from the script files. 
	Used by the origin and target.

*/
 
#include "get_DbvFuncs.h"



extern TBL_Return T_Return;

void get_DbvCommonInfo( DbvCommonInfo **ppsCommonInfo, TBL InTable )
   {
   char *stringfield;
   DbvCommonInfo		*psCommonInfo;

#ifdef DEBUG
   printf( "D - get_DbvCommonInfo()\n" );
#endif
   /* Malloc the space */

   if ( *ppsCommonInfo == NULL )
      *ppsCommonInfo = (DbvCommonInfo*)DbvAlloc( sizeof( DbvCommonInfo ) );
   psCommonInfo = *ppsCommonInfo;

   /* pcDateAdded */

   TBL_GetRecord( InTable );
   get_DbvGeneralizedTime( &psCommonInfo->pcDateAdded, InTable );

   /* pcDateChanged */

   TBL_GetRecord( InTable );
   get_DbvGeneralizedTime( &psCommonInfo->pcDateChanged, InTable );

   /* pcExpiry */

   TBL_GetRecord( InTable );
   get_DbvGeneralizedTime( &psCommonInfo->pcExpiry, InTable );

   /* psHumanStringLanguage */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvLanguageCode( &psCommonInfo->psHumanStringLanguage, InTable );
   DbvFree(stringfield);

   /* ppsOtherInformation */
   getN_DbvOtherInformation( &psCommonInfo->ppsOtherInformation, InTable);

   } /* End get_DbvCommonInfo() */

void get_DbvHumanString( DbvHumanString **ppsHumanString, TBL InTable )
   {
   char *stringfield;
   DbvHumanString 		*psHumanString;
#ifdef DEBUG
   printf( "D - get_DbvHumanString()\n" );
#endif
   /* Malloc the space */

   if ( *ppsHumanString == NULL )
      *ppsHumanString = (DbvHumanString*)DbvAlloc( sizeof( DbvHumanString ) );
   psHumanString = *ppsHumanString;

   /* psLanguage */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvLanguageCode( &psHumanString->psLanguage, InTable );

   DbvFree( stringfield );

   /* sText */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree( stringfield );

   get_compulsory_DbvInternationalString( &psHumanString->sText, InTable) ;

   } /* End get_DbvHumanString() */

void get_DbvBodyType( DbvBodyType **ppsBodyType, TBL InTable )
   {
   char *stringfield;
   DbvBodyType		*psBodyType;
   DbvBodyTypeType	eBodyTypeType;

#ifdef DEBUG
   printf( "D - get_DbvBodyType()\n" );
#endif
   /* Malloc the space */

   if ( *ppsBodyType == NULL )
      *ppsBodyType = (DbvBodyType*)DbvAlloc( sizeof( DbvBodyType ) );
   psBodyType = *ppsBodyType;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvBodyTypeType( &stringfield, &eBodyTypeType );
   psBodyType->eBodyTypeType = eBodyTypeType;
   DbvFree( stringfield );

   switch( eBodyTypeType )
      {
      case BTT_IanaType:
	 get_DbvInternationalString( &psBodyType->uBodyType.psIanaType, 
				     InTable );
         break;

      case BTT_Z3950Type:
	 get_DbvInternationalString( &psBodyType->uBodyType.psZ3950Type,
				     InTable );
         break;

      case BTT_OtherType:
	 get_DbvInternationalString( &psBodyType->uBodyType.psOtherType,
				     InTable );
         break;

      case BTT_Invalid:
      default:
	 break;
      } /* End switch */

   } /* End get_DbvBodyType() */

void get_DbvIconObject( DbvIconObject **ppsIconObject, TBL InTable )
   {
   char *stringfield;
   DbvIconObject	*psIconObject;
   DbvBodyType		*psBodyType;

#ifdef DEBUG
   printf( "D - get_DbvIconObject()\n" );
#endif
   /* Malloc the space */

   if ( *ppsIconObject == NULL )
      *ppsIconObject = (DbvIconObject*)DbvAlloc( sizeof( DbvIconObject ) );
   psIconObject = *ppsIconObject;

   /* sBodyType */
   psBodyType = &psIconObject->sBodyType;
   get_DbvBodyType( &psBodyType, InTable );

   /* sContent */
   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree( stringfield );
   get_compulsory_DbvOctetString(&psIconObject->sContent, InTable );

   } /* End get_DbvIconObject() */

void get_DbvContactInfo( DbvContactInfo **ppsContactInfo, TBL InTable )
   {
   char *stringfield;
   DbvContactInfo		*psContactInfo;

#ifdef DEBUG
   printf( "D - get_DbvContactInfo()\n" );
#endif
   /* Malloc the space */

   if ( *ppsContactInfo == NULL )
      *ppsContactInfo = (DbvContactInfo*)DbvAlloc( sizeof( DbvContactInfo ) );
   psContactInfo = *ppsContactInfo;

   /* psName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psContactInfo->psName, InTable );

   DbvFree(stringfield);

   /* ppsDescription */
   getN_DbvHumanString( &psContactInfo->ppsDescription, InTable );

   /* ppsAddress */
   getN_DbvHumanString( &psContactInfo->ppsAddress, InTable );

   /* psEmail */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psContactInfo->psEmail, InTable );

   /* psPhone */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psContactInfo->psPhone, InTable );

   } /* End get_DbvContactInfo() */

void get_DbvDatabaseList( DbvDatabaseList **ppsDatabaseList, TBL InTable )
   {
   char *stringfield;
   DbvDatabaseList		*psDatabaseList;
   DbvStringOrNumeric	*psStringOrNumeric;

#ifdef DEBUG
   printf( "D - get_DbvDatabaseList()\n" );
#endif
   /* Malloc the space */

   if ( *ppsDatabaseList == NULL )
      *ppsDatabaseList = (DbvDatabaseList*)DbvAlloc(sizeof( DbvDatabaseList ));
   psDatabaseList = *ppsDatabaseList;

   /* ppsInnerDatabases - compulsory because can have a zero length
      sequence */
   getN_compulsory_DbvInternationalString( &psDatabaseList->ppsInnerDatabases, InTable );

   } /* End get_DbvDatabaseList() */

void get_DbvInterAddress( DbvInterAddress **ppsInterAddress, TBL InTable )
   {
   char *stringfield;
   DbvInterAddress		*psInterAddress;

#ifdef DEBUG
   printf( "D - get_DbvInterAddress()\n" );
#endif
   /* Malloc the space */

   if ( *ppsInterAddress == NULL )
      *ppsInterAddress = (DbvInterAddress*)DbvAlloc( sizeof( DbvInterAddress ));
   psInterAddress = *ppsInterAddress;

   /* sHostAddress */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psInterAddress->sHostAddress,
					  InTable );

   /* ulPort */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psInterAddress->ulPort = get_int_field( InTable, T_Return );

   } /* End get_DbvInterAddress() */

void get_DbvOsiPresentationAddress( 
		DbvOsiPresentationAddress **ppsOsiPresentationAddress, 
		TBL InTable )
   {
   char *stringfield;
   DbvOsiPresentationAddress		*psOsiPresentationAddress;

#ifdef DEBUG
   printf( "D - get_DbvOsiPresentationAddress()\n" );
#endif
   /* Malloc the space */

   if ( *ppsOsiPresentationAddress == NULL )
      *ppsOsiPresentationAddress = (DbvOsiPresentationAddress*)DbvAlloc(
					sizeof( DbvOsiPresentationAddress ));
   psOsiPresentationAddress = *ppsOsiPresentationAddress;

   /* sPsel */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( 
				&psOsiPresentationAddress->sPsel, InTable );

   /* psSSel */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psOsiPresentationAddress->psSSel, InTable );

   DbvFree(stringfield);
   
   /* psTSel */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psOsiPresentationAddress->psTSel, InTable );

   DbvFree(stringfield);
   /* sNSap */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( 
				&psOsiPresentationAddress->sNSap, InTable );

   } /* End get_DbvOsiPresentationAddress() */

void get_DbvOtherAddress( DbvOtherAddress **ppsOtherAddress, TBL InTable )
   {
   char *stringfield;
   DbvOtherAddress	*psOtherAddress;

#ifdef DEBUG
   printf( "D - get_DbvOtherAddress()\n" );
#endif
   /* Malloc the space */

   if ( *ppsOtherAddress == NULL )
      *ppsOtherAddress = (DbvOtherAddress*)DbvAlloc( sizeof( DbvOtherAddress ));
   psOtherAddress = *ppsOtherAddress;

   /* sType */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psOtherAddress->sType, InTable );

   /* sAddress */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psOtherAddress->sAddress, InTable );

   } /* End get_DbvOtherAddress() */

void get_DbvNetworkAddress( DbvNetworkAddress **ppsNetworkAddress, TBL InTable )
   {
   char *stringfield;
   DbvNetworkAddress		*psNetworkAddress;
   DbvNetworkAddressType	eNetworkAddressType;

#ifdef DEBUG
   printf( "D - get_DbvNetworkAddress()\n" );
#endif
   /* Malloc the space */

   if ( *ppsNetworkAddress == NULL )
      *ppsNetworkAddress = (DbvNetworkAddress*)DbvAlloc( 
					sizeof( DbvNetworkAddress ) );
   psNetworkAddress = *ppsNetworkAddress;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvNetworkAddressType( &stringfield, &eNetworkAddressType );
   psNetworkAddress->eNetworkAddressType = eNetworkAddressType;
   DbvFree( stringfield );

   switch( eNetworkAddressType )
      {
      case NAT_InternetAddress:
	 get_DbvInterAddress( &psNetworkAddress->
			      uNetworkAddress.psInternetAddress, InTable );
         break;

      case NAT_OsiPresentationAddress:
	 get_DbvOsiPresentationAddress( &psNetworkAddress->uNetworkAddress.
					psOsiPresentationAddress, InTable );
         break;

      case NAT_OtherAddress:
	 get_DbvOtherAddress( &psNetworkAddress->
			      uNetworkAddress.psOtherAddress, InTable );
         break;

      default:
	 break;
      } /* End switch */

   } /* End get_DbvNetworkAddress() */

void get_DbvOperators( DbvOperators **ppsOperators, TBL InTable )
   {
   char *stringfield;
   DbvOperators		*psOperators;

#ifdef DEBUG
   printf( "D - get_DbvOperators()\n" );
#endif
   /* Malloc the space */

   if ( *ppsOperators == NULL )
      *ppsOperators = (DbvOperators*)DbvAlloc( sizeof( DbvOperators ) );
   psOperators = *ppsOperators;

   /* sOperator */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   get_compulsory_DbvInternationalString( &psOperators->sOperator, InTable );

   /* ppsDescription */
   getN_DbvHumanString( &psOperators->ppsDescription, InTable );

   } /* End get_DbvOperators() */

void get_DbvSearchKey( DbvSearchKey **ppsSearchKey, TBL InTable )
   {
   char *stringfield;
   DbvSearchKey		*psSearchKey;

#ifdef DEBUG
   printf( "D - get_DbvSearchKey()\n" );
#endif
   /* Malloc the space */

   if ( *ppsSearchKey == NULL )
      *ppsSearchKey = (DbvSearchKey*)DbvAlloc( sizeof( DbvSearchKey ) );
   psSearchKey = *ppsSearchKey;

   /* sSearchKey */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   get_compulsory_DbvInternationalString( &psSearchKey->sSearchKey, InTable );

   /* ppsDescription */
   getN_DbvHumanString( &psSearchKey->ppsDescription, InTable );

   } /* End get_DbvSearchKey() */


void get_DbvHumanStringSeq( DbvHumanStringSeq **ppsDescription, TBL InTable )
   {
   char *stringfield;
   DbvHumanStringSeq		*psDescription;

#ifdef DEBUG
   printf( "D - get_DbvHumanStringSeq()\n" );
#endif
   /* Malloc the space */

   if ( *ppsDescription == NULL )
      *ppsDescription = (DbvHumanStringSeq*)DbvAlloc( sizeof( DbvHumanStringSeq ) );
   psDescription = *ppsDescription;

   /* ppsHumanString */
   getN_DbvHumanString( &psDescription->ppsHumanString, InTable );

   } /* End get_DbvHumanStringSeq() */



void get_DbvPrivateCapabilities( 
		DbvPrivateCapabilities **ppsPrivateCapabilities, 
		TBL InTable )
   {
   DbvPrivateCapabilities		*psPrivateCapabilities;

#ifdef DEBUG
   printf( "D - get_DbvPrivateCapabilities()\n" );
#endif
   /* Malloc the space */

   if ( *ppsPrivateCapabilities == NULL )
      *ppsPrivateCapabilities = (DbvPrivateCapabilities*)DbvAlloc( 
					sizeof( DbvPrivateCapabilities ) );
   psPrivateCapabilities = *ppsPrivateCapabilities;

   /* ppsOperators */
   getN_DbvOperators( &psPrivateCapabilities->ppsOperators, InTable );

   /* ppsSearchKeys */
   getN_DbvSearchKey( &psPrivateCapabilities->ppsSearchKeys, InTable );

   /* ppsDescription */
   getN_DbvHumanStringSeq( &psPrivateCapabilities->ppsDescription, InTable );
   } /* End get_DbvPrivateCapabilities() */

void get_DbvPrivate( DbvPrivate **ppsPrivate, TBL InTable )
   {
   char *stringfield;
   DbvPrivate		*psPrivate;

#ifdef DEBUG
   printf( "D - get_DbvPrivate()\n" );
#endif
   /* Malloc the space */

   if ( *ppsPrivate == NULL )
      *ppsPrivate = (DbvPrivate*)DbvAlloc( sizeof( DbvPrivate ) );
   psPrivate = *ppsPrivate;

   /* ulUnit */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   psPrivate->ulUnit = get_int_field( InTable, T_Return );

   /* ppsDescription */
   getN_DbvHumanString( &psPrivate->ppsDescription, InTable );

   } /* End get_DbvPrivate() */

void get_DbvUnitsSupported( DbvUnitsSupported **ppsUnitsSupported, TBL InTable )
   {
   char *stringfield;
   DbvUnitsSupported		*psUnitsSupported;
   DbvUnitsSupportedType	eUnitsSupportedType;

#ifdef DEBUG
   printf( "D - get_DbvUnitsSupported()\n" );
#endif
   /* Malloc the space */

   if ( *ppsUnitsSupported == NULL )
      *ppsUnitsSupported = (DbvUnitsSupported*)DbvAlloc( 
					sizeof( DbvUnitsSupported ) );
   psUnitsSupported = *ppsUnitsSupported;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvUnitsSupportedType( &stringfield, &eUnitsSupportedType );
   psUnitsSupported->eUnitsSupportedType = eUnitsSupportedType;
   DbvFree( stringfield );

   switch( eUnitsSupportedType )
      {
      case UST_Known:
         TBL_GetRecord( InTable );

         /* Ignore the title */
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
         psUnitsSupported->uUnitsSupported.ulKnown = get_int_field( InTable,
								T_Return );
         break;

      case UST_Private:
	 get_DbvPrivate( &psUnitsSupported->uUnitsSupported.psPrivate,
			 InTable );
         break;

      default:
	 break;
      } /* End switch */

   } /* End get_DbvUnitsSupported() */

void get_DbvProximitySupport( DbvProximitySupport **ppsProximitySupport,
			      TBL InTable )
   {
   char *stringfield;
   DbvProximitySupport		*psProximitySupport;

#ifdef DEBUG
   printf( "D - get_DbvProximitySupport()\n" );
#endif
   /* Malloc the space */

   if ( *ppsProximitySupport == NULL )
      *ppsProximitySupport = (DbvProximitySupport*)DbvAlloc( 
					sizeof( DbvProximitySupport ) );
   psProximitySupport = *ppsProximitySupport;

   /* fAnySupport */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   psProximitySupport->fAnySupport =  get_DbvBool( InTable );

   /* ppsUnitsSupported */
   getN_DbvUnitsSupported( &psProximitySupport->ppsUnitsSupported, InTable );

   } /* End get_DbvProximitySupport() */

void get_DbvRpnCapabilities( DbvRpnCapabilities **ppsRpnCapabilities,
			      TBL InTable )
   {
   char *stringfield;
   DbvRpnCapabilities		*psRpnCapabilities;

#ifdef DEBUG
   printf( "D - get_DbvRpnCapabilities()\n" );
#endif
   /* Malloc the space */

   if ( *ppsRpnCapabilities == NULL )
      *ppsRpnCapabilities = (DbvRpnCapabilities*)DbvAlloc( 
					sizeof( DbvRpnCapabilities ) );
   psRpnCapabilities = *ppsRpnCapabilities;

   /* ppulOperators */
   getN_Ulong( &psRpnCapabilities->ppulOperators, InTable );

   /* fResultSetAsOperandSupported */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psRpnCapabilities->fResultSetAsOperandSupported = get_DbvBool( InTable );

   /* fRestrictionOperandSupported */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psRpnCapabilities->fRestrictionOperandSupported = get_DbvBool( InTable );

   /* psProximity */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvProximitySupport( &psRpnCapabilities->psProximity, InTable );

   DbvFree(stringfield);
   } /* End get_DbvRpnCapabilities() */

void get_DbvIso8777Capabilities( 
		DbvIso8777Capabilities **ppsIso8777Capabilities, 
		TBL InTable )
   {
   DbvIso8777Capabilities	*psIso8777Capabilities;

#ifdef DEBUG
   printf( "D - get_DbvIso8777Capabilities()\n" );
#endif
   /* Malloc the space */

   if ( *ppsIso8777Capabilities == NULL )
      *ppsIso8777Capabilities = (DbvIso8777Capabilities*)DbvAlloc( 
					sizeof( DbvIso8777Capabilities ) );
   psIso8777Capabilities = *ppsIso8777Capabilities;

   /* ppsSearchKeys */
   getN_DbvSearchKey( &psIso8777Capabilities->ppsSearchKeys, InTable );

   /* ppsRestrictions */
   getN_DbvHumanString( &psIso8777Capabilities->ppsRestrictions,  InTable );
   } /* End get_DbvIso8777Capabilities() */

void get_DbvQueryTypeDetails( DbvQueryTypeDetails **ppsQueryTypeDetails, 
			      TBL InTable )
   {
   char *stringfield;
   DbvQueryTypeDetails		*psQueryTypeDetails;
   DbvQueryTypeDetailsType	eQueryTypeDetailsType;

#ifdef DEBUG
   printf( "D - get_DbvQueryTypeDetails()\n" );
#endif
   /* Malloc the space */

   if ( *ppsQueryTypeDetails == NULL )
      *ppsQueryTypeDetails = (DbvQueryTypeDetails*)DbvAlloc( 
					sizeof( DbvQueryTypeDetails ) );
   psQueryTypeDetails = *ppsQueryTypeDetails;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvQueryTypeDetailsType( &stringfield, &eQueryTypeDetailsType );
   psQueryTypeDetails->eQueryTypeDetailsType = eQueryTypeDetailsType;
   DbvFree( stringfield );

   switch( eQueryTypeDetailsType )
      {
      case QTDT_Private:
	 get_DbvPrivateCapabilities( &psQueryTypeDetails->
				     uQueryTypeDetails.psPrivate, InTable );
         break;

      case QTDT_Rpn:
	 get_DbvRpnCapabilities( &psQueryTypeDetails->
				 uQueryTypeDetails.psRpn, InTable );
         break;

      case QTDT_Iso8777:
	 get_DbvIso8777Capabilities( &psQueryTypeDetails->
				     uQueryTypeDetails.psIso8777, InTable );
         break;

      case QTDT_Z39_58:
	 getN_DbvHumanString( &psQueryTypeDetails->
			      uQueryTypeDetails.ppsZ39_58, InTable );
         break;

      case QTDT_Erpn:
	 get_DbvRpnCapabilities( &psQueryTypeDetails->
				 uQueryTypeDetails.psErpn, InTable );
         break;

      case QTDT_RankedList:
	 getN_DbvHumanString( &psQueryTypeDetails->
			      uQueryTypeDetails.ppsRankedList, InTable );
         break;

      default:
	 break;
      } /* End switch */

   } /* End get_DbvQueryTypeDetails() */

void get_DbvAccessRestrictions( DbvAccessRestrictions **ppsAccessRestrictions, 
				TBL InTable )
   {
   char *stringfield;
   DbvAccessRestrictions	*psAccessRestrictions;
   DbvAccessType		eAccessType;

#ifdef DEBUG
   printf( "D - get_DbvAccessRestrictions()\n" );
#endif
   /* Malloc the space */

   if ( *ppsAccessRestrictions == NULL )
      *ppsAccessRestrictions = (DbvAccessRestrictions*)DbvAlloc( 
					sizeof( DbvAccessRestrictions ) );
   psAccessRestrictions = *ppsAccessRestrictions;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvAccessType( &stringfield, &eAccessType );
   psAccessRestrictions->eAccessType = eAccessType;
   DbvFree( stringfield );

   /* ppsAccessText */
   getN_DbvHumanString( &psAccessRestrictions->ppsAccessText, InTable );

   /* ppcAccessChallenges */
   getN_DbvObjectIdentifier( &psAccessRestrictions->ppcAccessChallenges, 
			     InTable );

   } /* End get_DbvAccessRestrictions() */

void get_DbvCharge( DbvCharge **ppsCharge, TBL InTable )
   {
   char *stringfield;
   DbvCharge	*psCharge;
   DbvIntUnit	*psCost;

#ifdef DEBUG
   printf( "D - get_DbvCharge()\n" );
#endif
   /* Malloc the space */

   if ( *ppsCharge == NULL )
      *ppsCharge = (DbvCharge*)DbvAlloc( sizeof( DbvCharge ) );
   psCharge = *ppsCharge;

   /* sCost */
   psCost = &psCharge->sCost;
   get_DbvIntUnit( &psCost, InTable );

   /* psPerWhat */

/*
   TBL_GetRecord(InTable);
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( ( strcmp( stringfield, NOTHING ) ) != 0 )
      get_DbvUnit( &psCharge->psPerWhat, InTable );

   DbvFree(stringfield);
*/
   get_DbvUnit( &psCharge->psPerWhat, InTable );



   /* ppsText */
   getN_DbvHumanString( &psCharge->ppsText, InTable );

   } /* End get_DbvCharge() */

void get_DbvOtherCharge( DbvOtherCharge **ppsOtherCharge, TBL InTable )
   {
   DbvOtherCharge	*psOtherCharge;
   DbvCharge		*psCharge;

#ifdef DEBUG
   printf( "D - get_DbvOtherCharge()\n" );
#endif
   /* Malloc the space */

   if ( *ppsOtherCharge == NULL )
      *ppsOtherCharge = (DbvOtherCharge*)DbvAlloc( sizeof( DbvOtherCharge ) );
   psOtherCharge = *ppsOtherCharge;

   /* ppsForWhat */
   getN_DbvHumanString( &psOtherCharge->ppsForWhat,  InTable );

   /* sCharge */
   psCharge = &psOtherCharge->sCharge;
   get_DbvCharge( &psCharge, InTable );
   } /* End get_DbvOtherCharge() */

void get_DbvCosts( DbvCosts **ppsCosts, TBL InTable )
   {
   char		*stringfield;
   DbvCosts	*psCosts;

#ifdef DEBUG
   printf( "D - get_DbvCosts()\n" );
#endif
   /* Malloc the space */

   if ( *ppsCosts == NULL )
      *ppsCosts = (DbvCosts*)DbvAlloc( sizeof( DbvCosts ) );
   psCosts = *ppsCosts;

   /* psConnectCharge */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCharge( &psCosts->psConnectCharge, InTable );

   DbvFree(stringfield);

   /* psConnectTime */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCharge( &psCosts->psConnectTime, InTable );

   DbvFree(stringfield);

   /* psDisplayCharge */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCharge( &psCosts->psDisplayCharge, InTable );

   DbvFree(stringfield);

   /* psSearchCharge */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCharge( &psCosts->psSearchCharge, InTable );

   DbvFree(stringfield);


   /* psSubscriptCharge */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCharge( &psCosts->psSubscriptCharge, InTable );

   DbvFree(stringfield);



   /* ppsOtherCharge */
   getN_DbvOtherCharge( &psCosts->ppsOtherCharge, InTable );

   } /* End get_DbvCosts() */

void get_DbvAccessInfo( DbvAccessInfo **ppsAccessInfo, TBL InTable )
   {
   char *stringfield;
   DbvAccessInfo	*psAccessInfo;

#ifdef DEBUG
   printf( "D - get_DbvAccessInfo()\n" );
#endif
   /* Malloc the space */

   if ( *ppsAccessInfo == NULL )
      *ppsAccessInfo = (DbvAccessInfo*)DbvAlloc( sizeof( DbvAccessInfo ) );
   psAccessInfo = *ppsAccessInfo;

   /* ppsQueryTypesSupported */
   getN_DbvQueryTypeDetails( &psAccessInfo->ppsQueryTypesSupported, InTable );

   /* ppcDiagnosticsSets */
   getN_DbvObjectIdentifier( &psAccessInfo->ppcDiagnosticsSets, InTable );

   /* ppcAttributeSetIds */
   getN_DbvObjectIdentifier( &psAccessInfo->ppcAttributeSetIds, InTable );

   /* ppcSchemas */
   getN_DbvObjectIdentifier( &psAccessInfo->ppcSchemas, InTable );

   /* ppcRecordSyntaxes */
   getN_DbvObjectIdentifier( &psAccessInfo->ppcRecordSyntaxes, InTable );

   /* ppcResourceChallenges */
   getN_DbvObjectIdentifier( &psAccessInfo->ppcResourceChallenges, InTable );

   /* ppsRestrictedAccess */
   getN_DbvAccessRestrictions( &psAccessInfo->ppsRestrictedAccess, InTable );

   /* psCostInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCosts( &psAccessInfo->psCostInfo, InTable );

   DbvFree(stringfield);

   /* ppcVariantSets */
   getN_DbvObjectIdentifier( &psAccessInfo->ppcVariantSets, InTable );

   /* ppsElementSetNames */
   getN_DbvInternationalString( &psAccessInfo->ppsElementSetNames, InTable );

   /* ppsUnitSystems */
   getN_DbvInternationalString( &psAccessInfo->ppsUnitSystems, InTable );

   } /* End get_DbvAccessInfo() */

void get_DbvTargetInfo( DbvTargetInfo **ppsTargetInfo, 
			       TBL InTable )
   {
   char *stringfield;
   DbvTargetInfo	*psTargetInfo;

#ifdef DEBUG
   printf( "D - get_DbvTargetInfo()\n" );
#endif
   /* Malloc the space */

   if ( *ppsTargetInfo == NULL )
      *ppsTargetInfo = (DbvTargetInfo*)DbvAlloc( sizeof( DbvTargetInfo ) );
   psTargetInfo = *ppsTargetInfo;

   /* psCommonInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCommonInfo( &psTargetInfo->psCommonInfo, InTable );

   DbvFree(stringfield);

   /* sName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psTargetInfo->sName, InTable );

   /* ppsRecentNews */
   getN_DbvHumanString( &psTargetInfo->ppsRecentNews, InTable );

   /* ppsIcon */
   getN_DbvIconObject( &psTargetInfo->ppsIcon, InTable );

   /* fNamedResultSets */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psTargetInfo->fNamedResultSets = get_DbvBool( InTable );

   /* fMultipleDBSearch */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psTargetInfo->fMultipleDBSearch = get_DbvBool( InTable );

   /* pulMaxResultSets */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      psTargetInfo->pulMaxResultSets = (Ulong*)get_integer_string( InTable );
   DbvFree(stringfield);

   /* pulMaxResultSize */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      psTargetInfo->pulMaxResultSize = (Ulong*)get_integer_string( InTable );
   DbvFree(stringfield);

   /* pulMaxTerms */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      psTargetInfo->pulMaxTerms = (Ulong*)get_integer_string( InTable );
   DbvFree(stringfield);

   /* psTimeoutInterval */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvIntUnit( &psTargetInfo->psTimeoutInterval, InTable );
   DbvFree(stringfield);

   /* ppsWelcomeMessage */
   getN_DbvHumanString( &psTargetInfo->ppsWelcomeMessage, InTable );

   /* psContactInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvContactInfo( &psTargetInfo->psContactInfo, InTable );
   DbvFree(stringfield);

   /* ppsDescription */
   getN_DbvHumanString( &psTargetInfo->ppsDescription, InTable );

   /* ppsNicknames */
   getN_DbvInternationalString( &psTargetInfo->ppsNicknames, InTable );

   /* ppsUsageRest */
   getN_DbvHumanString( &psTargetInfo->ppsUsageRest, InTable );

   /* ppsPaymentAddr */
   getN_DbvHumanString( &psTargetInfo->ppsPaymentAddr, InTable );

   /* ppsHours */
   getN_DbvHumanString( &psTargetInfo->ppsHours, InTable );

   /* ppsDbCombinations */
   getN_DbvDatabaseList( &psTargetInfo->ppsDbCombinations, InTable );

   /* ppsAddresses */
   getN_DbvNetworkAddress( &psTargetInfo->ppsAddresses, InTable );

   /* ppsLanguages */
   getN_DbvInternationalString( &psTargetInfo->ppsLanguages, InTable );

   /* psCommonAccessInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvAccessInfo( &psTargetInfo->psCommonAccessInfo, InTable );
   DbvFree(stringfield);

   } /* End get_DbvTargetInfo() */

void get_DbvRecordCount( DbvRecordCount **ppsRecordCount, TBL InTable )
   {
   char *stringfield;
   DbvRecordCount	*psRecordCount;
   DbvRecordCountType	eRecordCountType;

#ifdef DEBUG
   printf( "D - get_DbvRecordCount()\n" );
#endif
   /* Malloc the space */

   if ( *ppsRecordCount == NULL )
      *ppsRecordCount = (DbvRecordCount*)DbvAlloc( sizeof( DbvRecordCount ) );
   psRecordCount = *ppsRecordCount;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvRecordCountType( &stringfield, &eRecordCountType );
   psRecordCount->eRecordCountType = eRecordCountType;
   DbvFree( stringfield );

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   switch( eRecordCountType )
      {
      case RCT_ActualNumber:
         psRecordCount->uRecordCount.ulActualNumber = 
					get_int_field( InTable, T_Return );
         break;

      case RCT_ApproxNumber:
         psRecordCount->uRecordCount.ulApproxNumber = 
					get_int_field( InTable, T_Return );
         break;

      default:
	 break;
      } /* End switch */

   } /* End get_DbvRecordCount() */

void get_DbvDatabaseInfo( DbvDatabaseInfo **ppsDatabaseInfo, TBL InTable )
   {
   char *stringfield;
   DbvDatabaseInfo		*psDatabaseInfo;
   DbvBool			*pBool;

#ifdef DEBUG
   printf( "D - get_DbvDatabaseInfo()\n" );
#endif
   /* Malloc the space */

   if ( *ppsDatabaseInfo == NULL )
      *ppsDatabaseInfo = (DbvDatabaseInfo*)DbvAlloc( 
						sizeof( DbvDatabaseInfo ) );
   psDatabaseInfo = *ppsDatabaseInfo;

   /* psCommonInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCommonInfo( &psDatabaseInfo->psCommonInfo, InTable );
   DbvFree(stringfield);

   /* sName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psDatabaseInfo->sName,
					  InTable );

   /* pvExplainDatabase */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvNull( &psDatabaseInfo->pvExplainDatabase, InTable );
   DbvFree(stringfield);

   /* ppsNicknames */
   getN_DbvInternationalString( &psDatabaseInfo->ppsNicknames, InTable );

   /* ppsIcon */
   getN_DbvIconObject( &psDatabaseInfo->ppsIcon, InTable );

   /* fUserFee */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psDatabaseInfo->fUserFee = get_DbvBool( InTable );


   /* fAvailable */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psDatabaseInfo->fAvailable = get_DbvBool( InTable );

   /* ppsTitleString */
   getN_DbvHumanString( &psDatabaseInfo->ppsTitleString, InTable );

   /* ppsKeywords */
   getN_DbvDataBaseInfoSeq( &psDatabaseInfo->ppsKeywords, InTable );

   /* ppsDescription */
   getN_DbvHumanString( &psDatabaseInfo->ppsDescription, InTable );

   /* ppsAssociatedDbs */
   getN_DbvInternationalString( &psDatabaseInfo->ppsAssociatedDbs, InTable );

   /* ppsSubDbs */
   getN_DbvInternationalString( &psDatabaseInfo->ppsSubDbs, InTable );

   /* ppsDisclaimers */
   getN_DbvHumanString( &psDatabaseInfo->ppsDisclaimers, InTable );

   /* ppsNews */
   getN_DbvHumanString( &psDatabaseInfo->ppsNews, InTable );

   /* psRecordCount */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvRecordCount( &psDatabaseInfo->psRecordCount, InTable );
   DbvFree(stringfield);

   /* ppsDefaultOrder */
   getN_DbvHumanString( &psDatabaseInfo->ppsDefaultOrder, InTable );

   /* pulAvRecordSize */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      psDatabaseInfo->pulAvRecordSize = (Ulong*)get_integer_string( InTable );
   DbvFree(stringfield);

   /* pulMaxRecordSize */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      psDatabaseInfo->pulMaxRecordSize = (Ulong*)get_integer_string( InTable );
   DbvFree(stringfield);

   /* ppsHours */
   getN_DbvHumanString( &psDatabaseInfo->ppsHours, InTable );

   /* ppsBestTime */
   getN_DbvHumanString( &psDatabaseInfo->ppsBestTime, InTable );

   /* pcLastUpdate */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvGeneralizedTime( &psDatabaseInfo->pcLastUpdate, InTable );
   DbvFree(stringfield);

   /* psUpdateInterval */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvIntUnit( &psDatabaseInfo->psUpdateInterval, InTable );
   DbvFree(stringfield);

   /* ppsCoverage */
   getN_DbvHumanString( &psDatabaseInfo->ppsCoverage, InTable );

   /* pfProprietary */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      {
      pBool = (DbvBool*)DbvAlloc( sizeof( DbvBool ));
      *pBool = get_DbvBool( InTable );
      psDatabaseInfo->pfProprietary = pBool;
      } /* End if */
   DbvFree(stringfield);

   /* ppsCopyrightText */
   getN_DbvHumanString( &psDatabaseInfo->ppsCopyrightText, InTable );

   /* ppsCopyrightNotice */
   getN_DbvHumanString( &psDatabaseInfo->ppsCopyrightNotice, InTable );

   /* psProducerContactInfo */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvContactInfo( &psDatabaseInfo->psProducerContactInfo, InTable );

   DbvFree(stringfield);

   /* psSupplierContactInfo */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvContactInfo( &psDatabaseInfo->psSupplierContactInfo, InTable );

   DbvFree(stringfield);

   /* psSubmissionContactInfo */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvContactInfo( &psDatabaseInfo->psSubmissionContactInfo, InTable );

   DbvFree(stringfield);

   /* psAccessInfo */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvAccessInfo( &psDatabaseInfo->psAccessInfo, InTable );

   DbvFree(stringfield);

   } /* End get_DbvDatabaseInfo() */

void get_DbvTagTypeMapping( DbvTagTypeMapping **ppsTagTypeMapping, 
			    TBL InTable )
   {
   char *stringfield;
   DbvTagTypeMapping		*psTagTypeMapping;

#ifdef DEBUG
   printf( "D - get_DbvTagTypeMapping()\n" );
#endif
   /* Malloc the space */

   if ( *ppsTagTypeMapping == NULL )
      *ppsTagTypeMapping = (DbvTagTypeMapping*)DbvAlloc( 
						sizeof( DbvTagTypeMapping ) );
   psTagTypeMapping = *ppsTagTypeMapping;

   /* ulTagType */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psTagTypeMapping->ulTagType = (Ulong)get_int_field( InTable, T_Return);

   /* pcTagSet */
   TBL_GetRecord( InTable );
   get_DbvObjectIdentifier( &psTagTypeMapping->pcTagSet, InTable );

   /* pvDefaultTagType */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvNull( &psTagTypeMapping->pvDefaultTagType, InTable );
   DbvFree(stringfield);

   } /* End get_DbvTagTypeMapping() */

void get_DbvPath( DbvPath **ppsPath, TBL InTable )
   {
   char *stringfield;
   DbvPath		*psPath;
   DbvStringOrNumeric	*psTagValue;

#ifdef DEBUG
   printf( "D - get_DbvPath()\n" );
#endif
   /* Malloc the space */

   if ( *ppsPath == NULL )
      *ppsPath = (DbvPath*)DbvAlloc( sizeof( DbvPath ) );
   psPath = *ppsPath;

   /* ulTagType */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psPath->ulTagType = (Ulong)get_int_field( InTable, T_Return);

   /* sTagValue */
   psTagValue = &psPath->sTagValue;
   get_DbvStringOrNumeric( &psTagValue, InTable );

   } /* End get_DbvPath() */

void get_DbvPathA( DbvPathA **ppsPathA, TBL InTable )
   {
   DbvPathA		*psPathA;

#ifdef DEBUG
   printf( "D - get_DbvPathA()\n" );
#endif
   /* Malloc the space */

   if ( *ppsPathA == NULL )
      *ppsPathA = (DbvPathA*)DbvAlloc( sizeof( DbvPathA ) );
   psPathA = *ppsPathA;

   /* ppsSchemaTags */
   getN_compulsory_DbvPath( &psPathA->ppsSchemaTags, InTable );

   } /* End get_DbvPathA() */

void get_DbvElementInfo( DbvElementInfo **ppsElementInfo, TBL InTable )
   {
   char *stringfield;
   DbvElementInfo	*psElementInfo;

#ifdef DEBUG
   printf( "D - get_DbvElementInfo()\n" );
#endif
   /* Malloc the space */

   if ( *ppsElementInfo == NULL )
      *ppsElementInfo = (DbvElementInfo*)DbvAlloc( sizeof( DbvElementInfo ) );
   psElementInfo = *ppsElementInfo;

   /* sElementName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   get_compulsory_DbvInternationalString( &psElementInfo->sElementName, 
					  InTable );
   /* ppsElementTagPath */
   getN_DbvPath( &psElementInfo->ppsElementTagPath, InTable );

   /* psDataType */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvElementDataType( &psElementInfo->psDataType, InTable );

   DbvFree(stringfield);
  
   /* fRequired */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psElementInfo->fRequired = get_DbvBool( InTable );

   /* fRepeatable */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psElementInfo->fRepeatable = get_DbvBool( InTable );

   /* ppsDescription */
   getN_DbvHumanString( &psElementInfo->ppsDescription, InTable );
   } /* End get_DbvElementInfo() */

void get_DbvElementDataType( DbvElementDataType **ppsElementDataType, 
			     TBL InTable )
   {
   char *stringfield;
   DbvElementDataType		*psElementDataType;
   DbvElementDataTypeType	eElementDataTypeType;
   DbvPrimitiveDataType		ePrimitive;
#ifdef DEBUG
   printf( "D - get_DbvElementDataType()\n" );
#endif
   /* Malloc the space */

   if ( *ppsElementDataType == NULL )
      *ppsElementDataType = (DbvElementDataType*)DbvAlloc( 
					sizeof( DbvElementDataType ) );
   psElementDataType = *ppsElementDataType;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvElementDataTypeType( &stringfield, &eElementDataTypeType );
   psElementDataType->eElementDataTypeType = eElementDataTypeType;
   DbvFree( stringfield );

   switch( eElementDataTypeType )
      {
      case EDTT_Primitive:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
         stringfield = get_string_field( InTable, T_Return );
         convert_DbvPrimitiveDataType( &stringfield, &ePrimitive );
	 psElementDataType->uElementDataType.ePrimitive = ePrimitive;
         DbvFree(stringfield);
         break;

      case EDTT_Structured:
	 getN_DbvElementInfo( &psElementDataType->
			      uElementDataType.ppsStructured,
			      InTable );
         break;

      default:
	 break;
      } /* End switch */

   } /* End get_DbvElementDataType() */

void get_DbvSchemaInfo( DbvSchemaInfo **ppsSchemaInfo, TBL InTable )
   {
   char *stringfield;
   DbvSchemaInfo		*psSchemaInfo;

#ifdef DEBUG
   printf( "D - get_DbvSchemaInfo()\n" );
#endif
   /* Malloc the space */

   if ( *ppsSchemaInfo == NULL )
      *ppsSchemaInfo = (DbvSchemaInfo*)DbvAlloc( sizeof( DbvSchemaInfo ) );
   psSchemaInfo = *ppsSchemaInfo;

   /* psCommonInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCommonInfo( &psSchemaInfo->psCommonInfo, InTable );
   DbvFree(stringfield);

   /* pcSchema */
   TBL_GetRecord( InTable );
   get_DbvObjectIdentifier( &psSchemaInfo->pcSchema, InTable );

   /* sName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psSchemaInfo->sName, InTable );

   /* ppsDescription */
   getN_DbvHumanString( &psSchemaInfo->ppsDescription, InTable );

   /* ppsTagTypeMapping */
   getN_DbvTagTypeMapping( &psSchemaInfo->ppsTagTypeMapping, InTable );

   /* ppsRecordStructure */
   getN_DbvElementInfo(  &psSchemaInfo->ppsRecordStructure, InTable );
   } /* End get_DbvSchemaInfo() */

void get_DbvElements( DbvElements **ppsElements, TBL InTable )
   {
   char *stringfield;
   DbvElements		*psElements;
   DbvStringOrNumeric	*psElementTag;


#ifdef DEBUG
   printf( "D - get_DbvElements()\n" );
#endif
   /* Malloc the space */

   if ( *ppsElements == NULL )
      *ppsElements = (DbvElements*)DbvAlloc( sizeof( DbvElements ) );
   psElements = *ppsElements;

   /* sElementName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psElements->sElementName, InTable );

   /* ppsNicknames */
   getN_DbvInternationalString( &psElements->ppsNicknames, InTable );

   /* sElementTag */
   psElementTag = &psElements->sElementTag;
   get_DbvStringOrNumeric( &psElementTag,  InTable );

   /* ppsDescription */
   getN_DbvHumanString( &psElements->ppsDescription, InTable );

   /* peDataType */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvPrimitiveDataType( &psElements->peDataType, InTable );

   DbvFree(stringfield);

   /* ppsOtherInformation */
   getN_DbvOtherInformation( &psElements->ppsOtherInformation, InTable );

   } /* End get_DbvElements() */

void get_DbvPrimitiveDataType( DbvPrimitiveDataType **ppePrimitiveDataType, 
				TBL InTable )
   {
   char *stringfield;
   DbvPrimitiveDataType		*pePrimitiveDataType;
   

#ifdef DEBUG
   printf( "D - get_DbvPrimitiveDataType()\n" );
#endif
   /* Malloc the space */

   if ( *ppePrimitiveDataType == NULL )
      *ppePrimitiveDataType = (DbvPrimitiveDataType*)DbvAlloc( 
					sizeof( DbvPrimitiveDataType ) );
   pePrimitiveDataType = *ppePrimitiveDataType;

   /* eDataType */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvPrimitiveDataType( &stringfield, pePrimitiveDataType);
   DbvFree( stringfield );

   } /* End get_DbvPrimitiveDataType() */

void get_DbvTagSetInfo( DbvTagSetInfo **ppsTagSetInfo, TBL InTable )
   {
   char *stringfield;
   DbvTagSetInfo		*psTagSetInfo;

#ifdef DEBUG
   printf( "D - get_DbvTagSetInfo()\n" );
#endif
   /* Malloc the space */

   if ( *ppsTagSetInfo == NULL )
      *ppsTagSetInfo = (DbvTagSetInfo*)DbvAlloc( sizeof( DbvTagSetInfo ) );
   psTagSetInfo = *ppsTagSetInfo;

   /* psCommonInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCommonInfo( &psTagSetInfo->psCommonInfo, InTable );
   DbvFree(stringfield);

   /* pcTagSet */
   TBL_GetRecord( InTable );
   get_DbvObjectIdentifier( &psTagSetInfo->pcTagSet, InTable );

   /* sName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psTagSetInfo->sName, InTable );

   /* ppsDescription */
   getN_DbvHumanString( &psTagSetInfo->ppsDescription, InTable );

   /* ppsElements */
   getN_DbvElements( &psTagSetInfo->ppsElements, InTable );
   } /* End get_DbvTagSetInfo() */

void get_DbvRecordSyntaxInfo( DbvRecordSyntaxInfo **ppsRecordSyntaxInfo, 
			      TBL InTable )
   {
   char *stringfield;
   DbvRecordSyntaxInfo		*psRecordSyntaxInfo;

#ifdef DEBUG
   printf( "D - get_DbvRecordSyntaxInfo()\n" );
#endif
   /* Malloc the space */

   if ( *ppsRecordSyntaxInfo == NULL )
      *ppsRecordSyntaxInfo = (DbvRecordSyntaxInfo*)DbvAlloc( 
					sizeof( DbvRecordSyntaxInfo ) );
   psRecordSyntaxInfo = *ppsRecordSyntaxInfo;

   /* psCommonInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCommonInfo( &psRecordSyntaxInfo->psCommonInfo, InTable );

   DbvFree(stringfield);

   /* pcRecordSyntax */
   TBL_GetRecord( InTable );
   get_DbvObjectIdentifier( &psRecordSyntaxInfo->pcRecordSyntax, InTable );

   /* sName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psRecordSyntaxInfo->sName, 
					  InTable );

   /* ppcTransferSyntaxes */
   getN_DbvObjectIdentifier( &psRecordSyntaxInfo->ppcTransferSyntaxes,
			     InTable );

   /* ppsDescription */
   getN_DbvHumanString( &psRecordSyntaxInfo->ppsDescription, InTable );

   /* psAsn1Module */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psRecordSyntaxInfo->psAsn1Module, InTable );

   DbvFree(stringfield);

   /* ppsAbstractStructure */
   getN_DbvElementInfo( &psRecordSyntaxInfo->ppsAbstractStructure, InTable );

   } /* End get_DbvRecordSyntaxInfo() */

void get_DbvAttributeDescription( 
			DbvAttributeDescription **ppsAttributeDescription, 
			TBL InTable )
   {
   char *stringfield;
   DbvAttributeDescription	*psAttributeDescription;
   DbvStringOrNumeric		*psStringOrNumeric;

#ifdef DEBUG
   printf( "D - get_DbvAttributeDescription()\n" );
#endif
   /* Malloc the space */

   if ( *ppsAttributeDescription == NULL )
      *ppsAttributeDescription = (DbvAttributeDescription*)DbvAlloc( 
					sizeof( DbvAttributeDescription ) );
   psAttributeDescription = *ppsAttributeDescription;

   /* psName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psAttributeDescription->psName, InTable );

   DbvFree(stringfield);

   /* ppsDescription */
   getN_DbvHumanString( &psAttributeDescription->ppsDescription, InTable );

   /* psAttributeValue */
   psStringOrNumeric = &psAttributeDescription->sAttributeValue;
   get_DbvStringOrNumeric( &psStringOrNumeric, InTable );
   
   /* ppsEquivalentAttributes */
   getN_DbvStringOrNumeric( &psAttributeDescription->ppsEquivalentAttributes,
			    InTable );
   } /* End get_DbvAttributeDescription() */

void get_DbvAttributeType( DbvAttributeType **ppsAttributeType, TBL InTable )
   {
   char *stringfield;
   DbvAttributeType	*psAttributeType;

#ifdef DEBUG
   printf( "D - get_DbvAttributeType()\n" );
#endif
   /* Malloc the space */

   if ( *ppsAttributeType == NULL )
      *ppsAttributeType = (DbvAttributeType*)DbvAlloc( 
					sizeof( DbvAttributeType ) );
   psAttributeType = *ppsAttributeType;

   /* psName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psAttributeType->psName, InTable );

   DbvFree(stringfield);

   /* ppsDescription */
   getN_DbvHumanString( &psAttributeType->ppsDescription, InTable );

   /* ulAttributeType */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psAttributeType->ulAttributeType = (Ulong)get_int_field( InTable, 
							    T_Return );
   
   /* ppsAttributeValues */
   getN_compulsory_DbvAttributeDescription( &psAttributeType->ppsAttributeValues, InTable );

   } /* End get_DbvAttributeType() */

void get_DbvAttributeSetInfo( DbvAttributeSetInfo **ppsAttributeSetInfo, 
			      TBL InTable )
   {
   char *stringfield;
   DbvAttributeSetInfo		*psAttributeSetInfo;

#ifdef DEBUG
   printf( "D - get_DbvAttributeSetInfo()\n" );
#endif
   /* Malloc the space */

   if ( *ppsAttributeSetInfo == NULL )
      *ppsAttributeSetInfo = (DbvAttributeSetInfo*)DbvAlloc( 
					sizeof( DbvAttributeSetInfo ) );
   psAttributeSetInfo = *ppsAttributeSetInfo;

   /* psCommonInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCommonInfo( &psAttributeSetInfo->psCommonInfo, InTable );

   DbvFree(stringfield);

   /* pcAttributeSetId */
   TBL_GetRecord( InTable );
   get_DbvObjectIdentifier( &psAttributeSetInfo->pcAttributeSetId, InTable );

   /* sName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psAttributeSetInfo->sName, 
					  InTable );

   /* ppsAttributes */
   getN_DbvAttributeType( &psAttributeSetInfo->ppsAttributes, InTable );

   /* ppsDescription */
   getN_DbvHumanString( &psAttributeSetInfo->ppsDescription, InTable );

   } /* End get_DbvAttributeSetInfo() */

void get_DbvTermList( DbvTermList **ppsTermList, TBL InTable )
   {
   char *stringfield;
   DbvTermList		*psTermList;

#ifdef DEBUG
   printf( "D - get_DbvTermList()\n" );
#endif
   /* Malloc the space */

   if ( *ppsTermList == NULL )
      *ppsTermList = (DbvTermList*)DbvAlloc( 
					sizeof( DbvTermList ) );
   psTermList = *ppsTermList;

   /* sName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psTermList->sName, 
					  InTable );

   /* ppsTitle */
   getN_DbvHumanString( &psTermList->ppsTitle, InTable );

   /* peSearchCost */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvSearchCost( &psTermList->peSearchCost, InTable );

   DbvFree(stringfield);

   /* fScanable */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psTermList->fScanable = get_DbvBool( InTable );

   /* ppsBroader */
   getN_DbvInternationalString( &psTermList->ppsBroader, InTable );

   /* ppsNarrower */
   getN_DbvInternationalString( &psTermList->ppsNarrower, InTable );

   } /* End get_DbvTermList() */

void get_DbvSearchCost( DbvSearchCost **ppeSearchCost, TBL InTable )
   {
   char *stringfield;
   DbvSearchCost	*peSearchCost;

#ifdef DEBUG
   printf( "D - get_DbvSearchCost()\n" );
#endif
   /* Malloc the space */

   if ( *ppeSearchCost == NULL )
      *ppeSearchCost = (DbvSearchCost*)DbvAlloc( sizeof( DbvSearchCost ) );
   peSearchCost = *ppeSearchCost;

   /* SearchCost */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvSearchCost( &stringfield, peSearchCost);
   DbvFree( stringfield );

   } /* End get_DbvSearchCost() */

void get_DbvTermListInfo( DbvTermListInfo **ppsTermListInfo, TBL InTable )
   {
   char *stringfield;
   DbvTermListInfo		*psTermListInfo;

#ifdef DEBUG
   printf( "D - get_DbvTermListInfo()\n" );
#endif
   /* Malloc the space */

   if ( *ppsTermListInfo == NULL )
      *ppsTermListInfo = (DbvTermListInfo*)DbvAlloc( 
					sizeof( DbvTermListInfo ) );
   psTermListInfo = *ppsTermListInfo;

   /* psCommonInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCommonInfo( &psTermListInfo->psCommonInfo, InTable );

   DbvFree(stringfield);

   /* psDatabaseName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   get_compulsory_DbvInternationalString( &psTermListInfo->sDatabaseName, 
								InTable );

   /* ppsTermLists */
   getN_DbvTermList( &psTermListInfo->ppsTermLists, InTable );

   } /* End get_DbvTermListInfo() */

void get_DbvExtendedServicesInfo( 
			DbvExtendedServicesInfo **ppsExtendedServicesInfo, 
			TBL InTable )
   {
   char *stringfield;
   DbvExtendedServicesInfo	*psExtendedServicesInfo;
   DbvExtendedServicesInfoInt	eWaitAction;

#ifdef DEBUG
   printf( "D - get_DbvExtendedServicesInfo()\n" );
#endif
   /* Malloc the space */

   if ( *ppsExtendedServicesInfo == NULL )
      *ppsExtendedServicesInfo = (DbvExtendedServicesInfo*)DbvAlloc( 
					sizeof( DbvExtendedServicesInfo ) );
   psExtendedServicesInfo = *ppsExtendedServicesInfo;

   /* psCommonInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCommonInfo( &psExtendedServicesInfo->psCommonInfo, InTable );

   DbvFree(stringfield);

   /* pcType */
   TBL_GetRecord( InTable );
   get_DbvObjectIdentifier( &psExtendedServicesInfo->pcType, InTable );

   /* psName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psExtendedServicesInfo->psName, InTable );

   DbvFree(stringfield);
   /* fPrivateType */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psExtendedServicesInfo->fPrivateType = get_DbvBool( InTable );

   /* fRestrictionsApply */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psExtendedServicesInfo->fRestrictionsApply = get_DbvBool( InTable );

   /* fFeeApply */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psExtendedServicesInfo->fFeeApply = get_DbvBool( InTable );

   /* fAvailable */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psExtendedServicesInfo->fAvailable = get_DbvBool( InTable );

   /* fRetentionSupported */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psExtendedServicesInfo->fRetentionSupported = get_DbvBool( InTable );

   /* eWaitAction */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   convert_DbvExtendedServicesInfoInt( &stringfield, &eWaitAction );
   psExtendedServicesInfo->eWaitAction = eWaitAction;
   DbvFree(stringfield);

   /* ppsDescription */
   getN_DbvHumanString( &psExtendedServicesInfo->ppsDescription, InTable );

   /* psSpecificExplain */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvASN1External( &psExtendedServicesInfo->psSpecificExplain,
			   InTable );

   DbvFree(stringfield);

   /* psEsASN */
    
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psExtendedServicesInfo->psEsASN, InTable );

   DbvFree(stringfield);

   } /* End get_DbvExtendedServicesInfo() */

void get_DbvOmittedAttributeInterpretation( 
	DbvOmittedAttributeInterpretation **ppsOmittedAttributeInterpretation, 
	TBL InTable )
   {
   char *stringfield;
   DbvOmittedAttributeInterpretation	*psOmittedAttributeInterpretation;

#ifdef DEBUG
   printf( "D - get_DbvOmittedAttributeInterpretation()\n" );
#endif
   /* Malloc the space */

   if ( *ppsOmittedAttributeInterpretation == NULL )
      *ppsOmittedAttributeInterpretation = 
			(DbvOmittedAttributeInterpretation*)DbvAlloc( 
			sizeof( DbvOmittedAttributeInterpretation ) );
   psOmittedAttributeInterpretation = *ppsOmittedAttributeInterpretation;

   /* psDefaultValue */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvStringOrNumeric( &psOmittedAttributeInterpretation->
			      psDefaultValue, InTable );
   DbvFree(stringfield);

   /* ppsDefaultDescription */
   getN_DbvHumanString( &psOmittedAttributeInterpretation->
			ppsDefaultDescription, 
			InTable );

   } /* End get_DbvOmittedAttributeInterpretation() */

void get_DbvAttributeValues( DbvAttributeValues **ppsAttributeValues, 
			TBL InTable )
   {
   char *stringfield;
   DbvAttributeValues	*psAttributeValues;
   DbvStringOrNumeric	*psValue;

#ifdef DEBUG
   printf( "D - get_DbvAttributeValues()\n" );
#endif
   /* Malloc the space */

   if ( *ppsAttributeValues == NULL )
      *ppsAttributeValues = (DbvAttributeValues*)DbvAlloc( 
					sizeof( DbvAttributeValues ) );
   psAttributeValues = *ppsAttributeValues;

   /* sValue */
   psValue = &psAttributeValues->sValue;
   get_DbvStringOrNumeric( &psValue, InTable );

   /* ppsDescription */
   getN_DbvHumanString( &psAttributeValues->ppsDescription, InTable );

   /* ppsSubAttributes */
   getN_DbvStringOrNumeric( &psAttributeValues->ppsSubAttributes, InTable );

   /* ppsSuperAttributes */
   getN_DbvStringOrNumeric( &psAttributeValues->ppsSuperAttributes, InTable );

   /* pvPartialSupport */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvNull( &psAttributeValues->pvPartialSupport, InTable );
   DbvFree(stringfield);

   } /* End get_DbvAttributeValues() */

void get_DbvAttributesByType( DbvAttributesByType **ppsAttributesByType, 
	TBL InTable )
   {
   char *stringfield;
   DbvAttributesByType	*psAttributesByType;

#ifdef DEBUG
   printf( "D - get_DbvAttributesByType()\n" );
#endif
   /* Malloc the space */

   if ( *ppsAttributesByType == NULL )
      *ppsAttributesByType = 
			(DbvAttributesByType*)DbvAlloc( 
			sizeof( DbvAttributesByType ) );
   psAttributesByType = *ppsAttributesByType;

   /* ulAttributeType */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psAttributesByType->ulAttributeType = (Ulong)get_int_field( InTable, 
							       T_Return );
   /* psOptionalType */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvOmittedAttributeInterpretation( &psAttributesByType->
					  psDefaultIfOmitted, 
					  InTable );
   DbvFree(stringfield);

   /* ppsAttributeValues */
   getN_DbvAttributeValues( &psAttributesByType->ppsAttributeValues, InTable );

   } /* End get_DbvAttributesByType() */

void get_DbvAttributesBySet( DbvAttributesBySet **ppsAttributesBySet, 
	TBL InTable )
   {
   char *stringfield;
   DbvAttributesBySet	*psAttributesBySet;

#ifdef DEBUG
   printf( "D - get_DbvAttributesBySet()\n" );
#endif
   /* Malloc the space */

   if ( *ppsAttributesBySet == NULL )
      *ppsAttributesBySet = (DbvAttributesBySet*)DbvAlloc( 
			sizeof( DbvAttributesBySet ) );
   psAttributesBySet = *ppsAttributesBySet;

   /* pcAttributeSet */
   TBL_GetRecord( InTable );
   get_DbvObjectIdentifier( &psAttributesBySet->pcAttributeSet, InTable );

   /* ppsAttributesByType */
   getN_DbvAttributesByType( &psAttributesBySet->ppsAttributesByType, InTable );

   } /* End get_DbvAttributesBySet() */

void get_DbvAttributeOccurrenceChoice( 
	DbvAttributeOccurrenceChoice **ppsAttributeOccurrenceChoice, 
	TBL InTable )
   {
   char *stringfield;
   DbvAttributeOccurrenceChoice		*psAttributeOccurrenceChoice;
   DbvAttributeOccurrenceChoiceType	eAttributeOccurrenceChoiceType;

#ifdef DEBUG
   printf( "D - get_DbvAttributeOccurrenceChoice()\n" );
#endif
   /* Malloc the space */

   if ( *ppsAttributeOccurrenceChoice == NULL )
      *ppsAttributeOccurrenceChoice = (DbvAttributeOccurrenceChoice*)DbvAlloc( 
				sizeof( DbvAttributeOccurrenceChoice ) );
   psAttributeOccurrenceChoice = *ppsAttributeOccurrenceChoice;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvAttributeOccurrenceChoiceType( &stringfield, 
					&eAttributeOccurrenceChoiceType );
   psAttributeOccurrenceChoice->eAttributeOccurrenceChoiceType =
					eAttributeOccurrenceChoiceType;
   DbvFree( stringfield );

   switch( eAttributeOccurrenceChoiceType )
      {
      case AOT_AnyOrNone:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
         stringfield = get_string_field( InTable, T_Return );
         if( (strcmp(stringfield, NOTHING)) != 0 )
	    get_DbvNull( &psAttributeOccurrenceChoice->
		      uAttributeOccurrenceChoiceType.
		      pvAnyOrNone, 
		      InTable );  
         DbvFree(stringfield);
         break;

      case AOT_Specific:
	 getN_DbvStringOrNumeric( &psAttributeOccurrenceChoice->
				  uAttributeOccurrenceChoiceType.
				  ppsSpecific, InTable );
         break;

      default:
	 break;
      } /* End switch */

   } /* End get_DbvAttributeOccurrenceChoice() */

void get_DbvAttributeOccurrence( 
		DbvAttributeOccurrence **ppsAttributeOccurrence, 
		TBL InTable )
   {
   char *stringfield;
   DbvAttributeOccurrence	*psAttributeOccurrence;
   DbvAttributeOccurrenceChoice *psAttributeOccurrenceChoice;

#ifdef DEBUG
   printf( "D - get_DbvAttributeOccurrence()\n" );
#endif
   /* Malloc the space */

   if ( *ppsAttributeOccurrence == NULL )
      *ppsAttributeOccurrence = (DbvAttributeOccurrence*)DbvAlloc( 
					sizeof( DbvAttributeOccurrence ) );
   psAttributeOccurrence = *ppsAttributeOccurrence;

   /* pcAttributeSet */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvObjectIdentifier( &psAttributeOccurrence->pcAttributeSet, 
								InTable );
   DbvFree(stringfield);

   /* ulAttributeType */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psAttributeOccurrence->ulAttributeType = 
				(Ulong)get_int_field( InTable, T_Return );

   /* pvMustBeSupplied */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvNull( &psAttributeOccurrence->pvMustBeSupplied, InTable );
   DbvFree(stringfield);

   /* sAttributeValues */
   psAttributeOccurrenceChoice = &psAttributeOccurrence->sAttributeValues;
   get_DbvAttributeOccurrenceChoice( &psAttributeOccurrenceChoice, InTable );

   } /* End get_DbvAttributeOccurrence() */

void get_DbvAttributeCombination( 
		DbvAttributeCombination **ppsAttributeCombination, 
		TBL InTable )
   {
   DbvAttributeCombination		*psAttributeCombination;

#ifdef DEBUG
   printf( "D - get_DbvAttributeCombination()\n" );
#endif
   /* Malloc the space */

   if ( *ppsAttributeCombination == NULL )
      *ppsAttributeCombination = (DbvAttributeCombination*)DbvAlloc( 
					sizeof( DbvAttributeCombination ) );
   psAttributeCombination = *ppsAttributeCombination;

   /* ppsAttributeOccurrence */
   getN_DbvAttributeOccurrence( &psAttributeCombination->ppsAttributeOccurrence,
				InTable );

   } /* End get_DbvAttributeCombination() */

void get_DbvAttributeCombinations( 
		DbvAttributeCombinations **ppsAttributeCombinations, 
		TBL InTable )
   {
   char *stringfield;
   DbvAttributeCombinations	*psAttributeCombinations;

#ifdef DEBUG
   printf( "D - get_DbvAttributeCombinations()\n" );
#endif
   /* Malloc the space */

   if ( *ppsAttributeCombinations == NULL )
      *ppsAttributeCombinations = (DbvAttributeCombinations*)DbvAlloc( 
			sizeof( DbvAttributeCombinations ) );
   psAttributeCombinations = *ppsAttributeCombinations;

   /* pcDefaultAttributeSet */
   TBL_GetRecord( InTable );
   get_DbvObjectIdentifier( &psAttributeCombinations->pcDefaultAttributeSet, 
				InTable );

   /* ppsLegalCombinations */
   getN_DbvAttributeCombination( &psAttributeCombinations->
				  ppsLegalCombinations, InTable );

   } /* End get_DbvAttributeCombinations() */

void get_DbvAttributeDetails( DbvAttributeDetails **ppsAttributeDetails, 
			      TBL InTable )
   {
   char *stringfield;
   DbvAttributeDetails		*psAttributeDetails;

#ifdef DEBUG
   printf( "D - get_DbvAttributeDetails()\n" );
#endif
   /* Malloc the space */

   if ( *ppsAttributeDetails == NULL )
      *ppsAttributeDetails = (DbvAttributeDetails*)DbvAlloc( 
					sizeof( DbvAttributeDetails ) );
   psAttributeDetails = *ppsAttributeDetails;

   /* psCommonInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCommonInfo( &psAttributeDetails->psCommonInfo, InTable );

   DbvFree(stringfield);

   /* sDatabaseName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psAttributeDetails->sDatabaseName, 
					  InTable );

   /* ppsAttributesBySet */
   getN_DbvAttributesBySet( &psAttributeDetails->ppsAttributesBySet, InTable );

   /* psAttributeCombinations */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvAttributeCombinations( &psAttributeDetails->
					psAttributeCombinations, InTable );
   DbvFree(stringfield);

   } /* End get_DbvAttributeDetails() */

void get_DbvScanInfo( DbvScanInfo **ppsScanInfo, TBL InTable )
   {
   char *stringfield;
   DbvScanInfo		*psScanInfo;
   DbvBool		*pBool;

#ifdef DEBUG
   printf( "D - get_DbvScanInfo()\n" );
#endif
   /* Malloc the space */

   if ( *ppsScanInfo == NULL )
      *ppsScanInfo = (DbvScanInfo*)DbvAlloc( 
					sizeof( DbvScanInfo ) );
   psScanInfo = *ppsScanInfo;

   /* pulMaxStepSize */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      psScanInfo->pulMaxStepSize = (Ulong*)get_integer_string( InTable );
   DbvFree(stringfield);

   /* ppsCollatingSequence */
   getN_DbvHumanString( &psScanInfo->ppsCollatingSequence, InTable );

   /* pfIncreasing */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      {
      /* Note : We Need to Malloc some space here ( Yuk ) */
      pBool = (DbvBool*)DbvAlloc( sizeof( DbvBool ));
      *pBool = get_DbvBool( InTable );
      psScanInfo->pfIncreasing = pBool;
      } /* End if */
   DbvFree(stringfield);

   } /* End get_DbvScanInfo() */

void get_DbvTermListDetails( DbvTermListDetails **ppsTermListDetails, 
			       TBL InTable )
   {
   char *stringfield;
   DbvTermListDetails	*psTermListDetails;

#ifdef DEBUG
   printf( "D - get_DbvTermListDetails()\n" );
#endif
   /* Malloc the space */

   if ( *ppsTermListDetails == NULL )
      *ppsTermListDetails = (DbvTermListDetails*)DbvAlloc( 
					sizeof( DbvTermListDetails ) );
   psTermListDetails = *ppsTermListDetails;

   /* psCommonInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCommonInfo( &psTermListDetails->psCommonInfo, InTable );

   DbvFree(stringfield);

   /* sTermListName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psTermListDetails->sTermListName, 
					  InTable );
   /* ppsDescription */
   getN_DbvHumanString( &psTermListDetails->ppsDescription, InTable );

   /* psAttributes */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvAttributeCombinations( &psTermListDetails->psAttributes, InTable );

   DbvFree(stringfield);

   /* psScanInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvScanInfo( &psTermListDetails->psScanInfo, InTable );

   DbvFree(stringfield);

   /* pulEstNumberTerms */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      psTermListDetails->pulEstNumberTerms = 
					(Ulong*)get_integer_string( InTable );
   DbvFree(stringfield);

   /* ppsSampleTerms */

   getN_DbvTerm( &psTermListDetails->ppsSampleTerms, InTable );

   } /* End get_DbvTermListDetails() */

void get_DbvRecordTag( DbvRecordTag **ppsRecordTag, TBL InTable )
   {
   char *stringfield;
   DbvRecordTag	*psRecordTag;
   DbvStringOrNumeric	*psStringOrNumeric;

#ifdef DEBUG
   printf( "D - get_DbvRecordTag()\n" );
#endif
   /* Malloc the space */

   if ( *ppsRecordTag == NULL )
      *ppsRecordTag = (DbvRecordTag*)DbvAlloc( 
					sizeof( DbvRecordTag ) );
   psRecordTag = *ppsRecordTag;

   /* psQualifier */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvStringOrNumeric( &psRecordTag->psQualifier, InTable );

   DbvFree(stringfield);

   /* sTagValue */
   psStringOrNumeric = &psRecordTag->sTagValue;
   get_DbvStringOrNumeric( &psStringOrNumeric, InTable );

   } /* End get_DbvRecordTag() */

void get_DbvDetailsPerElement( DbvDetailsPerElement **ppsDetailsPerElement, 
			       TBL InTable )
   {
   char *stringfield;
   DbvDetailsPerElement	*psDetailsPerElement;

#ifdef DEBUG
   printf( "D - get_DbvDetailsPerElement()\n" );
#endif
   /* Malloc the space */

   if ( *ppsDetailsPerElement == NULL )
      *ppsDetailsPerElement = (DbvDetailsPerElement*)DbvAlloc( 
					sizeof( DbvDetailsPerElement ) );
   psDetailsPerElement = *ppsDetailsPerElement;

   /* psName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psDetailsPerElement->psName, InTable );

   DbvFree(stringfield);

   /* psRecordTag */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvRecordTag( &psDetailsPerElement->psRecordTag, InTable );
   DbvFree(stringfield);

   /* ppsSchemaTags */
   getN_DbvPathA( &psDetailsPerElement->ppsSchemaTags,  InTable );

   /* pulMaxSize */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      psDetailsPerElement->pulMaxSize = (Ulong*)get_integer_string( InTable );
   DbvFree(stringfield);

   /* pulMinSize */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      psDetailsPerElement->pulMinSize = (Ulong*)get_integer_string( InTable );
   DbvFree(stringfield);

   /* pulAvgSize */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      psDetailsPerElement->pulAvgSize = (Ulong*)get_integer_string( InTable );
   DbvFree(stringfield);

   /* pulFixedSize */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      psDetailsPerElement->pulFixedSize = (Ulong*)get_integer_string( InTable );
   DbvFree(stringfield);

   /* fRepeatable */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psDetailsPerElement->fRepeatable = get_DbvBool( InTable );

   /* fRequired */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psDetailsPerElement->fRequired = get_DbvBool( InTable );

   /* ppsDescription */
   getN_DbvHumanString( &psDetailsPerElement->ppsDescription, InTable );

   /* ppsContents */
   getN_DbvHumanString( &psDetailsPerElement->ppsContents, InTable );

   /* ppsBillingInfo */
   getN_DbvHumanString( &psDetailsPerElement->ppsBillingInfo, InTable );

   /* ppsRestrictions */
   getN_DbvHumanString( &psDetailsPerElement->ppsRestrictions, InTable );

   /* ppsAlternateNames */
   getN_DbvInternationalString( &psDetailsPerElement->ppsAlternateNames, 
				InTable );

   /* ppsGenericNames */
   getN_DbvInternationalString( &psDetailsPerElement->ppsGenericNames, 
				InTable );
   /* psSearchAccess */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvAttributeCombinations( &psDetailsPerElement->psSearchAccess, 
				    InTable );
   DbvFree(stringfield);

   } /* End get_DbvDetailsPerElement() */

void get_DbvElementSetDetails( DbvElementSetDetails **ppsElementSetDetails, 
			       TBL InTable )
   {
   char *stringfield;
   DbvElementSetDetails	*psElementSetDetails;

#ifdef DEBUG
   printf( "D - get_DbvElementSetDetails()\n" );
#endif
   /* Malloc the space */

   if ( *ppsElementSetDetails == NULL )
      *ppsElementSetDetails = (DbvElementSetDetails*)DbvAlloc( 
					sizeof( DbvElementSetDetails ) );
   psElementSetDetails = *ppsElementSetDetails;

   /* psCommonInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCommonInfo( &psElementSetDetails->psCommonInfo, InTable );

   DbvFree(stringfield);

   /* sDatabaseName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psElementSetDetails->sDatabaseName, 
					  InTable );
   /* sElementSetName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psElementSetDetails->sElementSetName,
								   InTable );

   /* pcRecordSyntax */
   TBL_GetRecord( InTable );
   get_DbvObjectIdentifier( &psElementSetDetails->pcRecordSyntax, InTable );

   /* pcSchema */
   TBL_GetRecord( InTable );
   get_DbvObjectIdentifier( &psElementSetDetails->pcSchema, InTable );

   /* ppsDescription */
   getN_DbvHumanString( &psElementSetDetails->ppsDescription, InTable );

   /* ppsDetailsPerElement */
   getN_DbvDetailsPerElement( &psElementSetDetails->ppsDetailsPerElement, 
				InTable );

   } /* End get_DbvElementSetDetails() */

void get_DbvRetrievalRecordDetails( 
			DbvRetrievalRecordDetails **ppsRetrievalRecordDetails, 
			TBL InTable )
   {
   char *stringfield;
   DbvRetrievalRecordDetails	*psRetrievalRecordDetails;

#ifdef DEBUG
   printf( "D - get_DbvRetrievalRecordDetails()\n" );
#endif
   /* Malloc the space */

   if ( *ppsRetrievalRecordDetails == NULL )
      *ppsRetrievalRecordDetails = (DbvRetrievalRecordDetails*)DbvAlloc( 
					sizeof( DbvRetrievalRecordDetails ) );
   psRetrievalRecordDetails = *ppsRetrievalRecordDetails;

   /* psCommonInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCommonInfo( &psRetrievalRecordDetails->psCommonInfo, InTable );

   DbvFree(stringfield);

   /* sDatabaseName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psRetrievalRecordDetails->
					  sDatabaseName, 
					  InTable );
   /* pcSchema */
   TBL_GetRecord( InTable );
   get_DbvObjectIdentifier( &psRetrievalRecordDetails->pcSchema, InTable );

   /* pcRecordSyntax */
   TBL_GetRecord( InTable );
   get_DbvObjectIdentifier( &psRetrievalRecordDetails->pcRecordSyntax, 
			    InTable );

   /* ppsDescription */
   getN_DbvHumanString( &psRetrievalRecordDetails->ppsDescription, InTable );

   /* psDetailsPerElement */
   getN_DbvDetailsPerElement( &psRetrievalRecordDetails->
				ppsDetailsPerElement, InTable );

   } /* End get_DbvRetrievalRecordDetails() */

void get_DbvSortType( DbvSortType **ppsSortType, TBL InTable )
   {
   char *stringfield;
   DbvSortType		*psSortType;
   DbvSortTypeType	eSortTypeType;

#ifdef DEBUG
   printf( "D - get_DbvSortType()\n" );
#endif
   /* Malloc the space */

   if ( *ppsSortType == NULL )
      *ppsSortType = (DbvSortType*)DbvAlloc( sizeof( DbvSortType ) );
   psSortType = *ppsSortType;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvSortTypeType( &stringfield, &eSortTypeType );
   psSortType->eSortTypeType = eSortTypeType;
   DbvFree( stringfield );

   switch( eSortTypeType )
      {
      case STT_Numeric:
      case STT_Character:
	break;

      case STT_Structured:
	 getN_DbvHumanString( &psSortType->uSortType.ppsStructured, InTable );
         break;

      default:
	 break;
      } /* End switch */

   } /* End get_DbvSortType() */

void get_DbvCaseSensitivity( DbvCaseSensitivity **ppeCaseSensitivity, 
					TBL InTable )
   {
   char *stringfield;
   DbvCaseSensitivity	*peCaseSensitivity;
   DbvCaseSensitivity	eCaseSensitivity;

#ifdef DEBUG
   printf( "D - get_DbvCaseSensitivity()\n" );
#endif
   /* Malloc the space */

   if ( *ppeCaseSensitivity == NULL )
      *ppeCaseSensitivity = (DbvCaseSensitivity*)DbvAlloc( 
					sizeof( DbvCaseSensitivity ) );
   peCaseSensitivity = *ppeCaseSensitivity;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvCaseSensitivity( &stringfield, &eCaseSensitivity );
   *peCaseSensitivity = eCaseSensitivity;
   DbvFree( stringfield );

   } /* End get_DbvCaseSensitivity() */

void get_DbvSortKeys( DbvSortKeys **ppsSortKeys, TBL InTable )
   {
   char *stringfield;
   DbvSortKeys		*psSortKeys;

#ifdef DEBUG
   printf( "D - get_DbvSortKey()\n" );
#endif
   /* Malloc the space */

   if ( *ppsSortKeys == NULL )
      *ppsSortKeys = (DbvSortKeys*)DbvAlloc( sizeof( DbvSortKeys ) );
   psSortKeys = *ppsSortKeys;

   /* ppsDescription */
   getN_DbvHumanString( &psSortKeys->ppsDescription, InTable );

   /* ppsElementSpecifications */
   getN_DbvSpecification( &psSortKeys->ppsElementSpecifications, InTable );

   /* psAttributeSpecifications */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvAttributeCombinations( &psSortKeys->psAttributeSpecifications, 
				    InTable );

   DbvFree(stringfield);

   /* psSortType */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvSortType( &psSortKeys->psSortType, InTable );

   DbvFree(stringfield);

   /* peCaseSensitivity */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCaseSensitivity( &psSortKeys->peCaseSensitivity, InTable );

   DbvFree(stringfield);

   } /* End get_DbvSortKeys() */

void get_DbvSortDetails( DbvSortDetails **ppsSortDetails, TBL InTable )
   {
   char *stringfield;
   DbvSortDetails	*psSortDetails;

#ifdef DEBUG
   printf( "D - get_DbvSortDetails()\n" );
#endif
   /* Malloc the space */

   if ( *ppsSortDetails == NULL )
      *ppsSortDetails = (DbvSortDetails*)DbvAlloc( sizeof( DbvSortDetails ) );
   psSortDetails = *ppsSortDetails;

   /* psCommonInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCommonInfo( &psSortDetails->psCommonInfo, InTable );

   DbvFree(stringfield);

   /* sDatabaseName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psSortDetails->sDatabaseName, 
					  InTable );

   /* ppsSortKeys */
   getN_DbvSortKeys( &psSortDetails->ppsSortKeys, InTable );

   } /* End get_DbvSortDetails() */

void get_DbvProcessingInformation( 
		DbvProcessingInformation **ppsProcessingInformation, 
		TBL InTable )
   {
   char *stringfield;
   DbvProcessingInformation	*psProcessingInformation;
   DbvProcessingContext		*peProcessingContext;

#ifdef DEBUG
   printf( "D - get_DbvProcessingInformation()\n" );
#endif
   /* Malloc the space */

   if ( *ppsProcessingInformation == NULL )
      *ppsProcessingInformation = (DbvProcessingInformation*)DbvAlloc( 
					sizeof( DbvProcessingInformation ) );
   psProcessingInformation = *ppsProcessingInformation;

   /* psCommonInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCommonInfo( &psProcessingInformation->psCommonInfo, InTable );

   DbvFree(stringfield);

   /* sDatabaseName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psProcessingInformation->
					  sDatabaseName, 
					  InTable );
   /* eProcessingContext */
   peProcessingContext = &psProcessingInformation->eProcessingContext;
   get_DbvProcessingContext( &peProcessingContext, InTable );

   /* sName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psProcessingInformation->sName, 
								InTable );

   /* pcOid */
   TBL_GetRecord( InTable );
   get_DbvObjectIdentifier( &psProcessingInformation->pcOid, InTable );

   /* ppsDescription */
   getN_DbvHumanString( &psProcessingInformation->ppsDescription, InTable );

   /* psInstructions */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvASN1External( &psProcessingInformation->psInstructions, InTable );

   DbvFree(stringfield);
   } /* End get_DbvProcessingInformation() */

void get_DbvValueDescription( DbvValueDescription **ppsValueDescription, 
			      TBL InTable )
   {
   char *stringfield;
   DbvValueDescription		*psValueDescription;
   DbvValueDescriptionType	eValueDescriptionType;

#ifdef DEBUG
   printf( "D - get_DbvValueDescription()\n" );
#endif
   /* Malloc the space */

   if ( *ppsValueDescription == NULL )
      *ppsValueDescription = (DbvValueDescription*)DbvAlloc( 
					sizeof( DbvValueDescription ) );
   psValueDescription = *ppsValueDescription;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvValueDescriptionType( &stringfield, &eValueDescriptionType );
   psValueDescription->eValueDescriptionType = eValueDescriptionType;
   DbvFree( stringfield );

   switch( eValueDescriptionType )
      {
      case VDT_Integer:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
	 psValueDescription->uValueDescription.ulInteger = 
				(Ulong)get_int_field( InTable, T_Return );
         break;

      case VDT_String:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
	 get_DbvInternationalString( &psValueDescription->
				     uValueDescription.psString, InTable );
         break;

      case VDT_Octets:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
	 get_DbvOctetString( &psValueDescription->
				     uValueDescription.psOctets, InTable );
         break;

      case VDT_Oid:
         TBL_GetRecord( InTable );
	 get_DbvObjectIdentifier( &psValueDescription->uValueDescription.pcOid,
				  InTable );
         break;

      case VDT_Unit:
	 get_DbvUnit( &psValueDescription->uValueDescription.psUnit, InTable );
         break;

      case VDT_ValueAndUnit:
	 get_DbvIntUnit( &psValueDescription->uValueDescription.psValueAndUnit, 
			 InTable );
         break;

      default:
	 break;
      } /* End switch */

   } /* End get_DbvValueDescription() */

void get_DbvValueRange( DbvValueRange **ppsValueRange, TBL InTable )
   {
   char *stringfield;
   DbvValueRange	*psValueRange;

#ifdef DEBUG
   printf( "D - get_DbvValueRange()\n" );
#endif
   /* Malloc the space */

   if ( *ppsValueRange == NULL )
      *ppsValueRange = (DbvValueRange*)DbvAlloc( sizeof( DbvValueRange ) );
   psValueRange = *ppsValueRange;

   /* psLower */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvValueDescription( &psValueRange->psLower, InTable );
   DbvFree(stringfield);

   /* psUpper */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvValueDescription( &psValueRange->psUpper, InTable );
   DbvFree(stringfield);

   } /* End get_DbvValueRange() */

void get_DbvValueSet( DbvValueSet **ppsValueSet, TBL InTable )
   {
   char *stringfield;
   DbvValueSet		*psValueSet;
   DbvValueSetType	eValueSetType;

#ifdef DEBUG
   printf( "D - get_DbvValueSet()\n" );
#endif
   /* Malloc the space */

   if ( *ppsValueSet == NULL )
      *ppsValueSet = (DbvValueSet*)DbvAlloc( sizeof( DbvValueSet ) );
   psValueSet = *ppsValueSet;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvValueSetType( &stringfield, &eValueSetType );
   psValueSet->eValueSetType = eValueSetType;
   DbvFree( stringfield );

   switch( eValueSetType )
      {
      case VT_Range:
	 get_DbvValueRange( &psValueSet->uValueSet.psRange, InTable );
         break;

      case VT_Enumerated:
	 getN_DbvValueDescription( &psValueSet->
				   uValueSet.ppsEnumerated, InTable );
         break;

      default:
	 break;
      } /* End switch */

   } /* End get_DbvValueSet() */

void get_DbvVariantValue( DbvVariantValue **ppsVariantValue, TBL InTable )
   {
   char *stringfield;
   DbvVariantValue	*psVariantValue;
   DbvPrimitiveDataType	eDataType;

#ifdef DEBUG
   printf( "D - get_DbvVariantValue()\n" );
#endif
   /* Malloc the space */

   if ( *ppsVariantValue == NULL )
      *ppsVariantValue = (DbvVariantValue*)DbvAlloc( sizeof( DbvVariantValue ));
   psVariantValue = *ppsVariantValue;

   /* eDataType */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvPrimitiveDataType( &stringfield, &eDataType );
   psVariantValue->eDataType = eDataType;
   DbvFree( stringfield );

   /* psValues */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvValueSet( &psVariantValue->psValues, InTable );

   DbvFree(stringfield);

   } /* End get_DbvVariantValue() */

void get_DbvVariantTypes( DbvVariantTypes **ppsVariantTypes, TBL InTable )
   {
   char *stringfield;
   DbvVariantTypes	*psVariantTypes;
   DbvPrimitiveDataType	eDataType;

#ifdef DEBUG
   printf( "D - get_DbvVariantTypes()\n" );
#endif
   /* Malloc the space */

   if ( *ppsVariantTypes == NULL )
      *ppsVariantTypes = (DbvVariantTypes*)DbvAlloc( sizeof( DbvVariantTypes ));
   psVariantTypes = *ppsVariantTypes;

   /* psName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psVariantTypes->psName, InTable );

   DbvFree(stringfield);

   /* ppsDescription */
   getN_DbvHumanString( &psVariantTypes->ppsDescription, InTable );

   /* ulVariantType */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psVariantTypes->ulVariantType = (Ulong)get_int_field( InTable, T_Return );

   /* psVariantValue */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvVariantValue( &psVariantTypes->psVariantValue, InTable );

   DbvFree(stringfield);

   } /* End get_DbvVariantTypes() */

void get_DbvVariantClass( DbvVariantClass **ppsVariantClass, TBL InTable )
   {
   char *stringfield;
   DbvVariantClass	*psVariantClass;
   DbvPrimitiveDataType	eDataType;

#ifdef DEBUG
   printf( "D - get_DbvVariantClass()\n" );
#endif
   /* Malloc the space */

   if ( *ppsVariantClass == NULL )
      *ppsVariantClass = (DbvVariantClass*)DbvAlloc( sizeof( DbvVariantClass ));
   psVariantClass = *ppsVariantClass;

   /* psName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psVariantClass->psName, InTable );

   DbvFree(stringfield);

   /* ppsDescription */
   getN_DbvHumanString( &psVariantClass->ppsDescription, InTable );

   /* ulVariantClass */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psVariantClass->ulVariantClass = (Ulong)get_int_field( InTable, T_Return );

   /* ppsVariantTypes */
   getN_DbvVariantTypes( &psVariantClass->ppsVariantTypes, InTable );

   } /* End get_DbvVariantClass() */

void get_DbvVariantSetInfo( DbvVariantSetInfo **ppsVariantSetInfo, TBL InTable )
   {
   char *stringfield;
   DbvVariantSetInfo	*psVariantSetInfo;

#ifdef DEBUG
   printf( "D - get_DbvVariantSetInfo()\n" );
#endif
   /* Malloc the space */

   if ( *ppsVariantSetInfo == NULL )
      *ppsVariantSetInfo = (DbvVariantSetInfo*)DbvAlloc( 
					sizeof( DbvVariantSetInfo ) );
   psVariantSetInfo = *ppsVariantSetInfo;

   /* psCommonInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCommonInfo( &psVariantSetInfo->psCommonInfo, InTable );

   DbvFree(stringfield);

   /* pcVariantSet */
   TBL_GetRecord( InTable );
   get_DbvObjectIdentifier( &psVariantSetInfo->pcVariantSet, InTable );

   /* sName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psVariantSetInfo->sName, 
					  InTable );
   /* ppsVariants */
   getN_DbvVariantClass( &psVariantSetInfo->ppsVariants, InTable );

   } /* End get_DbvVariantSetInfo() */

void get_DbvUnits( DbvUnits **ppsUnits, TBL InTable )
   {
   char *stringfield;
   DbvUnits	*psUnits;
   DbvStringOrNumeric	*psStringOrNumeric;

#ifdef DEBUG
   printf( "D - get_DbvUnits()\n" );
#endif
   /* Malloc the space */

   if ( *ppsUnits == NULL )
      *ppsUnits = (DbvUnits*)DbvAlloc( sizeof( DbvUnits ) );
   psUnits = *ppsUnits;

   /* psName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psUnits->psName, InTable );

   DbvFree(stringfield);

   /* ppsDescription */
   getN_DbvHumanString( &psUnits->ppsDescription, InTable );

   /* sUnit */
   psStringOrNumeric = &psUnits->sUnit;
   get_DbvStringOrNumeric( &psStringOrNumeric, InTable );

   } /* End get_DbvUnits() */


void get_DbvUnitType( DbvUnitType **ppsUnitType, TBL InTable )
   {
   char *stringfield;
   DbvUnitType		*psUnitType;
   DbvStringOrNumeric	*psStringOrNumeric;

#ifdef DEBUG
   printf( "D - get_DbvUnitType()\n" );
#endif
   /* Malloc the space */

   if ( *ppsUnitType == NULL )
      *ppsUnitType = (DbvUnitType*)DbvAlloc( sizeof( DbvUnitType ) );
   psUnitType = *ppsUnitType;

   /* psName */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree( stringfield );

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psUnitType->psName, InTable );
   DbvFree(stringfield);

   /* ppsDescription */
   getN_DbvHumanString( &psUnitType->ppsDescription, InTable );

   /* sUnitType */
   psStringOrNumeric = &psUnitType->sUnitType;
   get_DbvStringOrNumeric( &psStringOrNumeric, InTable );

   /* ppsUnits */
   getN_compulsory_DbvUnits( &psUnitType->ppsUnits, InTable );

   } /* End get_DbvUnitType() */

void get_DbvUnitInfo( DbvUnitInfo **ppsUnitInfo, TBL InTable )
   {
   char *stringfield;
   DbvUnitInfo	*psUnitInfo;

#ifdef DEBUG
   printf( "D - get_DbvUnitInfo()\n" );
#endif
   /* Malloc the space */

   if ( *ppsUnitInfo == NULL )
      *ppsUnitInfo = (DbvUnitInfo*)DbvAlloc( sizeof( DbvUnitInfo ) );
   psUnitInfo = *ppsUnitInfo;

   /* psCommonInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCommonInfo( &psUnitInfo->psCommonInfo, InTable );

   DbvFree(stringfield);

   /* sUnitSystem */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvInternationalString( &psUnitInfo->sUnitSystem, InTable );

   /* ppsDescription */
   getN_DbvHumanString( &psUnitInfo->ppsDescription, InTable );

   /* ppsUnitTypes */
   getN_DbvUnitType( &psUnitInfo->ppsUnitTypes, InTable );

   } /* End get_DbvUnitInfo() */

void get_DbvCategoryInfo( DbvCategoryInfo **ppsCategoryInfo, TBL InTable )
   {
   char *stringfield;
   DbvCategoryInfo	*psCategoryInfo;

#ifdef DEBUG
   printf( "D - get_DbvCategoryInfo()\n" );
#endif
   /* Malloc the space */

   if ( *ppsCategoryInfo == NULL )
      *ppsCategoryInfo = (DbvCategoryInfo*)DbvAlloc( 
						sizeof( DbvCategoryInfo ) );
   psCategoryInfo = *ppsCategoryInfo;

   /* sCategory */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   get_compulsory_DbvInternationalString( &psCategoryInfo->sCategory, InTable );

   /* psOriginalCategory */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psCategoryInfo->psOriginalCategory,
								InTable );

   DbvFree(stringfield);

   /* ppsDescription */
   getN_DbvHumanString( &psCategoryInfo->ppsDescription, InTable );

   /* psAsn1Module */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psCategoryInfo->psAsn1Module, InTable );

   DbvFree(stringfield);

   } /* End get_DbvCategoryInfo() */

void get_DbvCategoryList( DbvCategoryList **ppsCategoryList, TBL InTable )
   {
   char *stringfield;
   DbvCategoryList	*psCategoryList;

#ifdef DEBUG
   printf( "D - get_DbvCategoryList()\n" );
#endif
   /* Malloc the space */

   if ( *ppsCategoryList == NULL )
      *ppsCategoryList = (DbvCategoryList*)DbvAlloc( sizeof( DbvCategoryList ));
   psCategoryList = *ppsCategoryList;

   /* psCommonInfo */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvCommonInfo( &psCategoryList->psCommonInfo, InTable );

   DbvFree(stringfield);

   /* ppsCategories */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
   	getN_compulsory_DbvCategoryInfo( &psCategoryList->ppsCategories, InTable );
   DbvFree(stringfield);


   } /* End get_DbvCategoryList() */

void get_DbvExplainRecord( DbvExplainRecord **ppsExplainRecord, TBL InTable )
   {
   char *stringfield;
   DbvExplainRecord	*psExplainRecord;
   DbvExplainRecordType	eExplainRecordType;

#ifdef DEBUG
   printf( "D - get_DbvExplainRecord()\n" );
#endif
   /* Malloc the space */

   if ( *ppsExplainRecord == NULL )
      *ppsExplainRecord = (DbvExplainRecord*)DbvAlloc( 
						sizeof( DbvExplainRecord ) );
   psExplainRecord = *ppsExplainRecord;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvExplainRecordType( &stringfield, &eExplainRecordType );
   psExplainRecord->eExplainRecordType = eExplainRecordType;
   DbvFree( stringfield );

   switch( eExplainRecordType )
      {
      case ERT_TargetInfo:
	 get_DbvTargetInfo( &psExplainRecord->uExplainRecord.psTargetInfo, 
				   InTable );
         break;

      case ERT_DatabaseInfo:
	 get_DbvDatabaseInfo( &psExplainRecord->uExplainRecord.psDatabaseInfo, 
				   InTable );
         break;

      case ERT_SchemaInfo:
	 get_DbvSchemaInfo( &psExplainRecord->
				   uExplainRecord.psSchemaInfo, 
				   InTable );
         break;

      case ERT_TagSetInfo:
	 get_DbvTagSetInfo( &psExplainRecord->uExplainRecord.psTagSetInfo, 
				   InTable );
         break;

      case ERT_RecordSyntaxInfo:
	 get_DbvRecordSyntaxInfo( &psExplainRecord->
				   uExplainRecord.psRecordSyntaxInfo, 
				   InTable );
         break;

      case ERT_AttributeSetInfo:
	 get_DbvAttributeSetInfo( &psExplainRecord->
				   uExplainRecord.psAttributeSetInfo, 
				   InTable );
         break;

      case ERT_TermListInfo:
	 get_DbvTermListInfo( &psExplainRecord->uExplainRecord.psTermListInfo, 
				   InTable );
         break;

      case ERT_ExtendedServicesInfo:
	 get_DbvExtendedServicesInfo( &psExplainRecord->
				   uExplainRecord.psExtendedServicesInfo, 
				   InTable );
         break;

      case ERT_AttributeDetails:
	 get_DbvAttributeDetails( &psExplainRecord->
				   uExplainRecord.psAttributeDetails, 
				   InTable );
         break;

      case ERT_TermListDetails:
	 get_DbvTermListDetails( &psExplainRecord->
				   uExplainRecord.psTermListDetails, 
				   InTable );
         break;

      case ERT_ElementSetDetails:
	 get_DbvElementSetDetails( &psExplainRecord->
				   uExplainRecord.psElementSetDetails, 
				   InTable );
         break;

      case ERT_RetrievalRecordDetails:
	 get_DbvRetrievalRecordDetails( &psExplainRecord->
				   uExplainRecord.psRetrievalRecordDetails, 
				   InTable );
         break;

      case ERT_SortDetails:
	 get_DbvSortDetails( &psExplainRecord->uExplainRecord.psSortDetails, 
				   InTable );
         break;

      case ERT_Processing:
	 get_DbvProcessingInformation( &psExplainRecord->
				   uExplainRecord.psProcessing, 
				   InTable );
         break;

      case ERT_Variants:
	 get_DbvVariantSetInfo( &psExplainRecord->uExplainRecord.psVariants, 
				   InTable );
         break;

      case ERT_Units:
	 get_DbvUnitInfo( &psExplainRecord->uExplainRecord.psUnits, InTable );
         break;

      case ERT_CategoryList:
	 get_DbvCategoryList( &psExplainRecord->uExplainRecord.psCategoryList, 
				   InTable );
         break;

      default:
	 break;
      } /* End switch */

   } /* End get_DbvExplainRecord() */

void get_DbvLanguageCode( DbvLanguageCode **ppsLanguageCode, TBL InTable )
   {

#ifdef DEBUG
   printf( "D - get_DbvLanguageCode()\n" );
#endif
   get_DbvInternationalString( (DbvInternationalString**)ppsLanguageCode,
				InTable );
   } /* End get_DbvLanguageCode() */

void get_DbvNull( DbvNull *pvNull, TBL InTable )
   {
   char *stringfield;

#ifdef DEBUG
   printf( "D - get_DbvNull()\n" );
#endif
   /* Malloc the space */

   if ( pvNull == NULL )
      return;

   /* The format for a Null is  title, ( COMPLETED/NULL ); */
   /* If it is completed a pointer is allocated else       */
   /* it is not set                                        */
   *pvNull = (DbvNull*)DbvAlloc( sizeof( DbvNull ) );

   } /* End get_DbvNull() */

void get_DbvProcessingContext( 
		DbvProcessingContext **ppeProcessingContext, TBL InTable )
   {
   char *stringfield;
   DbvProcessingContext		*peProcessingContext;
   DbvProcessingContext		eProcessingContext;

#ifdef DEBUG
   printf( "D - get_DbvProcessingContext()\n" );
#endif
   /* Malloc the space */

   if ( *ppeProcessingContext == NULL )
      *ppeProcessingContext = (DbvProcessingContext*)DbvAlloc( 
					sizeof( DbvProcessingContext ) );
   peProcessingContext = *ppeProcessingContext;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvProcessingContext( &stringfield, &eProcessingContext );
   *peProcessingContext = eProcessingContext;
   DbvFree( stringfield );

   } /* End get_DbvProcessingContext() */

void get_DbvDataBaseInfoSeq( DbvDataBaseInfoSeq **ppsDataBaseInfoSeq, 
								TBL InTable )
   {
   DbvDataBaseInfoSeq		*psDataBaseInfoSeq;

#ifdef DEBUG
   printf( "D - get_DbvDataBaseInfoSeq()\n" );
#endif
   /* Malloc the space */

   if ( *ppsDataBaseInfoSeq == NULL )
      *ppsDataBaseInfoSeq = (DbvDataBaseInfoSeq*)DbvAlloc( 
						sizeof( DbvDataBaseInfoSeq ) );
   psDataBaseInfoSeq = *ppsDataBaseInfoSeq;

   /* ppsKeywords */
   getN_DbvHumanString( &psDataBaseInfoSeq->ppsDataBaseInfo, InTable );

   } /* End get_DbvDataBaseInfoSeq() */
