/*  Module Name: @(#)get_DbvFuncs3.c	7.1
    Version: 11/15/96
    Author: Dan Maskell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to get structure types from the script files. 
	Used by the origin and target.

*/
 
#include "get_DbvFuncs.h"


#ifdef NOT_YET_IMPLEMENTED


extern TBL_Return T_Return;

void get_DbvUsageIntType( DbvUsageIntType **ppeUsageIntType, TBL InTable )
   {
   char *stringfield;
   DbvUsageIntType	*peUsageIntType;
   DbvUsageIntType	eUsageIntType;

#ifdef DEBUG
   printf( "D - get_DbvUsageIntType()\n" );
#endif
   /* Malloc the space */

   if ( *ppeUsageIntType == NULL )
      *ppeUsageIntType = (DbvUsageIntType*)DbvAlloc( sizeof( DbvUsageIntType ));
   peUsageIntType = *ppeUsageIntType;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvUsageIntType( &stringfield, &eUsageIntType );
   *peUsageIntType = eUsageIntType;
   DbvFree( stringfield );

   } /* End get_DbvUsageIntType() */

void get_DbvOrder( DbvOrder **ppsOrder, TBL InTable )
   {
   char *stringfield;
   DbvOrder		*psOrder;

#ifdef DEBUG
   printf( "D - get_DbvOrder()\n" );
#endif
   /* Malloc the space */

   if ( *ppsOrder == NULL )
      *ppsOrder = (DbvOrder*)DbvAlloc( sizeof( DbvOrder ) );
   psOrder = *ppsOrder;

   /* fAscending */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   psOrder->fAscending  =  get_DbvBool( InTable );

   /* ulOrder */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   psOrder->ulOrder  =  get_int_field( InTable, T_Return );
   } /* End get_DbvOrder() */

void get_DbvUsage( DbvUsage **ppsUsage, TBL InTable )
   {
   char *stringfield;
   DbvUsage		*psUsage;
   DbvUsageIntType 	*peUsageIntType;

#ifdef DEBUG
   printf( "D - get_DbvUsage()\n" );
#endif
   /* Malloc the space */

   if ( *ppsUsage == NULL )
      *ppsUsage = (DbvUsage*)DbvAlloc( sizeof( DbvUsage ) );
   psUsage = *ppsUsage;

   /* eType */
   peUsageIntType = &psUsage->eType;
   get_DbvUsageIntType( &peUsageIntType, InTable );

   /* psRestriction */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psUsage->psRestriction, InTable );
   DbvFree(stringfield);

   } /* End get_DbvUsage() */

void get_DbvHits( DbvHits **ppsHits, TBL InTable )
   {
   char *stringfield;
   DbvHits		*psHits;

#ifdef DEBUG
   printf( "D - get_DbvHits()\n" );
#endif
   /* Malloc the space */

   if ( *ppsHits == NULL )
      *ppsHits = (DbvHits*)DbvAlloc( sizeof( DbvHits ) );
   psHits = *ppsHits;

   /* psSatisfier */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvTerm( &psHits->psSatisfier, InTable );
   DbvFree(stringfield);

   /* psOffsetIntoElement */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvIntUnit( &psHits->psOffsetIntoElement, InTable );
   DbvFree(stringfield);

   /* psLength */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvIntUnit( &psHits->psLength, InTable );
   DbvFree(stringfield);

   /* pulHitRank */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      psHits->pulHitRank = (Ulong*)get_integer_string( InTable );
   DbvFree(stringfield);

   /* psTargetToken */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvOctetString( &psHits->psTargetToken, InTable );
   DbvFree(stringfield);

   } /* End get_DbvHits() */

void get_DbvValue( DbvValue **ppsValue, TBL InTable )
   {
   char *stringfield;
   DbvValue	*psValue;
   DbvVariantValueType	eVariantValueType;

#ifdef DEBUG
   printf( "D - get_DbvValue()\n" );
#endif
   /* Malloc the space */

   if ( *ppsValue == NULL )
      *ppsValue = (DbvValue*)DbvAlloc( sizeof( DbvValue ) );
   psValue = *ppsValue;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvVariantValueType( &stringfield, &eVariantValueType );
   psValue->eVariantValueType = eVariantValueType;
   DbvFree( stringfield );

   switch( eVariantValueType )
      {
      case VVT_Int:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
	 psValue->uVariantValueType.ulInt1 = (Ulong)get_int_field( InTable,
								T_Return );
         break;

      case VVT_InternationalString:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
	 get_DbvInternationalString( &psValue->
				     uVariantValueType.psInternationalString,
				     InTable );
         break;

      case VVT_Octs:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
	 get_DbvOctetString( &psValue->uVariantValueType.psOcts, InTable );
         break;

      case VVT_Oid:
         TBL_GetRecord( InTable );
	 get_DbvObjectIdentifier( &psValue->uVariantValueType.pcOid, InTable );
         break;

      case VVT_Bool:
	 TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
         psValue->uVariantValueType.fBool = get_DbvBool( InTable );
         break;

      case VVT_Null:
         break;

      case VVT_Unit:
	 get_DbvUnit( &psValue->uVariantValueType.psUnit, InTable );
         break;

      case VVT_ValueAndUnit:
	 get_DbvIntUnit( &psValue->uVariantValueType.psValueAndUnit, InTable );
         break;

      default:
	 break;
      } /* End switch */

   } /* End get_DbvValue() */

void get_DbvTriples( DbvTriples **ppsTriples, TBL InTable )
   {
   char *stringfield;
   DbvTriples		*psTriples;

#ifdef DEBUG
   printf( "D - get_DbvTriples()\n" );
#endif
   /* Malloc the space */

   if ( *ppsTriples == NULL )
      *ppsTriples = (DbvTriples*)DbvAlloc( sizeof( DbvTriples ) );
   psTriples = *ppsTriples;

   /* pcVariantSetId */
   TBL_GetRecord( InTable );
   get_DbvObjectIdentifier( &psTriples->pcVariantSetId, InTable );

   /* ulClass */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psTriples->ulClass = (Ulong)get_int_field( InTable, T_Return );

   /* ulType */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psTriples->ulType = (Ulong)get_int_field( InTable, T_Return );

   /* ppsValue */
   getN_DbvValue( &psTriples->ppsValue, InTable );

   } /* End get_DbvTriples() */

void get_DbvVariant( DbvVariant **ppsVariant, TBL InTable )
   {
   char *stringfield;
   DbvVariant		*psVariant;

#ifdef DEBUG
   printf( "D - get_DbvVariant()\n" );
#endif
   /* Malloc the space */

   if ( *ppsVariant == NULL )
      *ppsVariant = (DbvVariant*)DbvAlloc( sizeof( DbvVariant ) );
   psVariant = *ppsVariant;

   /* pcGlobalVariantSetId */
   TBL_GetRecord( InTable );
   get_DbvObjectIdentifier( &psVariant->pcGlobalVariantSetId, InTable );

   /* ppsTriples */
   getN_DbvTriples( &psVariant->ppsTriples, InTable );

   } /* End get_DbvVariant() */

void get_DbvTagPath( DbvTagPath **ppsTagPath, TBL InTable )
   {
   char *stringfield;
   DbvTagPath		*psTagPath;
   DbvStringOrNumeric   *psStringOrNumeric;

#ifdef DEBUG
   printf( "D - get_DbvTagPath()\n" );
#endif
   /* Malloc the space */

   if ( *ppsTagPath == NULL )
      *ppsTagPath = (DbvTagPath*)DbvAlloc( sizeof( DbvTagPath ) );
   psTagPath = *ppsTagPath;

   /* pulTagType */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
       psTagPath->pulTagType = (Ulong*)get_integer_string( InTable );
   DbvFree(stringfield);

   /* sTagValue */
   psStringOrNumeric = &psTagPath->sTagValue;
   get_DbvStringOrNumeric( &psStringOrNumeric, InTable );

   /* pulTagOccurrence */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
       psTagPath->pulTagOccurrence = (Ulong*)get_integer_string( InTable );
   DbvFree(stringfield);

   } /* End get_DbvTagPath() */

void get_DbvElementMetaData( DbvElementMetaData **ppsElementMetaData, 
			TBL InTable )
   {
   char *stringfield;
   DbvElementMetaData		*psElementMetaData;
   DbvStringOrNumeric   *psStringOrNumeric;

#ifdef DEBUG
   printf( "D - get_DbvElementMetaData()\n" );
#endif
   /* Malloc the space */

   if ( *ppsElementMetaData == NULL )
      *ppsElementMetaData = (DbvElementMetaData*)DbvAlloc( 
					sizeof( DbvElementMetaData ) );
   psElementMetaData = *ppsElementMetaData;

   /* psSeriesOrder */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvOrder( &psElementMetaData->psSeriesOrder, InTable );

   DbvFree(stringfield);

   /* psUsageRight */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvUsage( &psElementMetaData->psUsageRight, InTable );
   DbvFree(stringfield);

   /* ppsHits */

   getN_DbvHits( &psElementMetaData->ppsHits, InTable );

   /* psDisplayName */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psElementMetaData->psDisplayName, InTable );
   DbvFree(stringfield);

   /* ppsSupportedVariants */
   getN_DbvVariant( &psElementMetaData->ppsSupportedVariants, InTable );

   /* psMessage */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInternationalString( &psElementMetaData->psMessage, InTable );
   DbvFree(stringfield);

   /* psElementDescriptor */

   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvOctetString( &psElementMetaData->psElementDescriptor, InTable );
   DbvFree(stringfield);

   /* ppsSurrogateFor */
   getN_DbvTagPath( &psElementMetaData->ppsSurrogateFor, InTable );

   /* ppsSurrogateElement */
   getN_DbvTagPath( &psElementMetaData->ppsSurrogateElement, InTable );

   /* psOther */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvASN1External( &psElementMetaData->psOther, InTable );
   DbvFree(stringfield);

   } /* End get_DbvElementMetaData() */

void get_DbvElementDataG( DbvElementDataG **ppsElementDataG, TBL InTable )
   {
   char *stringfield;
   DbvElementDataG	*psElementDataG;
   DbvElementDataGType	eElementDataGType;

#ifdef DEBUG
   printf( "D - get_DbvElementDataG()\n" );
#endif
   /* Malloc the space */

   if ( *ppsElementDataG == NULL )
      *ppsElementDataG = (DbvElementDataG*)DbvAlloc( sizeof( DbvElementDataG ) );
   psElementDataG = *ppsElementDataG;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvElementDataGType( &stringfield, &eElementDataGType );
   psElementDataG->eElementDataGType = eElementDataGType;
   DbvFree( stringfield );

   switch( eElementDataGType )
      {
      case EDT_Octets:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
	 get_DbvOctetString( &psElementDataG->uElementDataG.psOctets, InTable );
         break;

      case EDT_Numeric:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
         psElementDataG->uElementDataG.ulNumeric = (Ulong)get_int_field(
	 						InTable, T_Return );
         break;

      case EDT_Date:
         TBL_GetRecord( InTable );
	 get_DbvGeneralizedTime( &psElementDataG->uElementDataG.pcDate, 
					InTable );
         break;

      case EDT_Ext:
	 get_DbvASN1External( &psElementDataG->uElementDataG.psExt, InTable );
         break;

      case EDT_String:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
	 get_DbvInternationalString( &psElementDataG->uElementDataG.psString,
				     InTable );
         break;

      case EDT_TrueOrFalse:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
	 psElementDataG->uElementDataG.fTrueOrFalse = get_DbvBool( InTable );
         break;

      case EDT_Oid:
         TBL_GetRecord( InTable );
	 get_DbvObjectIdentifier( &psElementDataG->uElementDataG.pcOid,
					InTable );
         break;

      case EDT_IntUnit:
	 get_DbvIntUnit( &psElementDataG->uElementDataG.psIntUnit, InTable );
         break;

      case EDT_ElementNotThere:
      case EDT_ElementEmpty:
      case EDT_NoDataRequested:
         break;

      case EDT_Diagnostic:
	 get_DbvASN1External( &psElementDataG->uElementDataG.psDiagnostic,
			       InTable );

         break;

      case EDT_Subtree:
	 getN_DbvTaggedElement( &psElementDataG->uElementDataG.ppsSubTree,
				InTable );
         break;

      default:
	 break;
      } /* End switch */

   } /* End get_DbvElementDataG() */

void get_DbvTaggedElement( DbvTaggedElement **ppsTaggedElement, TBL InTable )
   {
   char *stringfield;
   DbvTaggedElement	*psTaggedElement;
   DbvStringOrNumeric   *psStringOrNumeric;
   DbvElementDataG       *psElementDataG;

#ifdef DEBUG
   printf( "D - get_DbvTaggedElement()\n" );
#endif
   /* Malloc the space */

   if ( *ppsTaggedElement == NULL )
      *ppsTaggedElement = (DbvTaggedElement*)DbvAlloc( 
						sizeof( DbvTaggedElement ) );
   psTaggedElement = *ppsTaggedElement;

   /* pulTagType */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      psTaggedElement->pulTagType = (Ulong*)get_integer_string( InTable );
   DbvFree(stringfield);

   /* sTagValue */
   psStringOrNumeric = &psTaggedElement->sTagValue;
   get_DbvStringOrNumeric( &psStringOrNumeric, InTable );

   /* pulTagOccurrence */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      psTaggedElement->pulTagOccurrence = (Ulong*)get_integer_string( InTable );
   DbvFree(stringfield);

   /* sContent */
   psElementDataG = &psTaggedElement->sContent;
   get_DbvElementDataG( &psElementDataG, InTable );

   /* psMetaData */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvElementMetaData( &psTaggedElement->psMetaData, InTable );
   DbvFree(stringfield);

   /* psAppliedVariant */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvVariant( &psTaggedElement->psAppliedVariant, InTable );
   DbvFree(stringfield);

   } /* End get_DbvTaggedElement() */

void get_DbvGenericRecord( DbvGenericRecord **ppsDbvGenericRecord, TBL InTable )
   {
   DbvGenericRecord *psDbvGenericRecord;
#ifdef DEBUG
   printf( "D - get_DbvGenericRecord()\n" );
#endif
   if ( *ppsDbvGenericRecord == NULL )
      *ppsDbvGenericRecord = (DbvGenericRecord*)DbvAlloc( 
						sizeof( DbvGenericRecord ) );
   psDbvGenericRecord = *ppsDbvGenericRecord;


   /* Get DbvTaggedElement structures */
   getN_DbvTaggedElement( &psDbvGenericRecord->ppsTaggedElement, InTable );
   
   } /* End get_DbvGenericRecord() */

#endif
