/*  Module Name: @(#)get_DbvFuncs4.c	7.1
    Version: 11/15/96
    Author: John Hough
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to get structure types from the script files. 
	Used by the origin and target.

*/
 
#include "get_DbvFuncs.h"

extern TBL_Return T_Return;


void get_compulsory_DbvSecurityChallengeReq( DbvSecurityChallengeReq  *psSecurityChallengeReq, TBL InTable )
   {
   char *stringfield;
   DbvSecurityChallengeType	eSecurityChallengeReqType;

#ifdef DEBUG
   printf( "D - get_DbvSecurityChallengeReq()\n" );
#endif

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvSecurityChallengeType( &stringfield, &eSecurityChallengeReqType );
   psSecurityChallengeReq->eSecurityChallengeReqType = eSecurityChallengeReqType;
   DbvFree( stringfield );

   switch( eSecurityChallengeReqType )
      {
      case SECT_SimpleForm:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
	 get_DbvOctetString( &psSecurityChallengeReq->uSecurityChallengeReq.psSimpleForm, InTable );
         break;

      case SECT_ExternallyDefined:
         get_DbvASN1External( &psSecurityChallengeReq->uSecurityChallengeReq.psExternallyDefinedInfo, InTable );

         break;

      default:
	 break;
      } /* End switch */

   } /* End get_DbvSecurityChallengeReq() */



void get_DbvSecurityChallengeRsp( DbvSecurityChallengeRsp  **ppsSecurityChallengeRsp, TBL InTable )
   {
   char *stringfield;
   DbvSecurityChallengeRsp	*psSecurityChallengeRsp;
   DbvSecurityChallengeType	eSecurityChallengeRspType;

#ifdef DEBUG
   printf( "D - get_DbvSecurityChallengeRsp()\n" );
#endif
   /* Malloc the space */

   if ( *ppsSecurityChallengeRsp == NULL )
      *ppsSecurityChallengeRsp = (DbvSecurityChallengeRsp*)DbvAlloc( sizeof( DbvSecurityChallengeRsp ) );
   psSecurityChallengeRsp = *ppsSecurityChallengeRsp;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvSecurityChallengeType( &stringfield, &eSecurityChallengeRspType );
   psSecurityChallengeRsp->eSecurityChallengeRspType = eSecurityChallengeRspType;
   DbvFree( stringfield );

   switch( eSecurityChallengeRspType )
      {
      case SECT_SimpleForm:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
	 get_DbvOctetString( &psSecurityChallengeRsp->uSecurityChallengeRsp.psSimpleForm, InTable );
         break;

      case SECT_ExternallyDefined:
         get_DbvASN1External( &psSecurityChallengeRsp->uSecurityChallengeRsp.psExternallyDefinedInfo, InTable );

         break;

      default:
	 break;
      } /* End switch */

   } /* End get_DbvSecurityChallengeReq() */




void get_DbvPartialResultsAvailable( DbvPartialResultsAvailable  **ppePartialResultsAvailable, TBL InTable )
   {
   char *stringfield;
   DbvPartialResultsAvailable   *pePartialResultsAvailable;

#ifdef DEBUG
   printf( "D - get_DbvPartialResultsAvailable()\n" );
#endif
   /* Malloc the space */

   if ( *ppePartialResultsAvailable == NULL )
      *ppePartialResultsAvailable = (DbvPartialResultsAvailable*)DbvAlloc(
                                        	sizeof( DbvPartialResultsAvailable ) );
   pePartialResultsAvailable = *ppePartialResultsAvailable;
	
   stringfield = get_string_field( InTable, T_Return );
   convert_DbvPartialResultsAvailable( &stringfield, pePartialResultsAvailable);
   DbvFree( stringfield );

   } /* End get_DbvPartialResultsAvailable() */



void get_DbvEnumeratedPrompt( DbvEnumeratedPrompt  **ppsEnumeratedPrompt, TBL InTable )
   {
   char *stringfield;	
   DbvEnumeratedPrompt		*psEnumeratedPrompt;
   DbvEPromptIdType		eType;

#ifdef DEBUG
   printf( "D - get_DbvEnumeratedPrompt()\n" );
#endif
   /* Malloc the space */

   if ( *ppsEnumeratedPrompt == NULL )
      *ppsEnumeratedPrompt = (DbvEnumeratedPrompt*)DbvAlloc( sizeof( DbvEnumeratedPrompt ) );
   psEnumeratedPrompt = *ppsEnumeratedPrompt;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   /* c eType */
   stringfield = get_string_field( InTable, T_Return );
   convert_DbvEPromptIdType( &stringfield, &eType );
   psEnumeratedPrompt->eType = eType;
   DbvFree( stringfield );

   /* o psSuggestedString */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_DbvInternationalString( &psEnumeratedPrompt->psSuggestedString, InTable );

   } /* End get_DbvEnumeratedPrompt() */





void get_compulsory_DbvPromptId( DbvPromptId *psPromptId, TBL InTable )
   {
   char *stringfield;
   DbvPromptIdType	ePromptIdType;

#ifdef DEBUG
   printf( "D - get_DbvPromptId()\n" );
#endif

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvPromptIdType( &stringfield, &ePromptIdType );
   psPromptId->ePromptIdType = ePromptIdType;
   DbvFree( stringfield );

   switch( ePromptIdType )
      {
      case PIT_EnumeratedPrompt:
	 get_DbvEnumeratedPrompt( &psPromptId->uPromptId.psEnumeratedPrompt, InTable );
         break;

      case PIT_NoneEnumeratedPrompt:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
         get_DbvInternationalString( &psPromptId->uPromptId.psNonEnumeratedPrompt, InTable );

         break;

      default:
	 break;
      } /* End switch */

   } /* End get_DbvPromptId() */



void get_DbvEncryption( DbvEncryption  **ppsEncryption, TBL InTable )
   {
   char *stringfield;	
   DbvEncryption		*psEncryption;

#ifdef DEBUG
   printf( "D - get_DbvEncryption()\n" );
#endif
   /* Malloc the space */

   if ( *ppsEncryption == NULL )
      *ppsEncryption = (DbvEncryption*)DbvAlloc( sizeof( DbvEncryption ) );
   psEncryption = *ppsEncryption;

   /* o psCryptType */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_DbvOctetString( &psEncryption->psCryptType, InTable );

   /* o psCredential */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_DbvOctetString( &psEncryption->psCredential, InTable );


   /* c sData */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_compulsory_DbvOctetString( &psEncryption->sData, InTable );


   } /* End get_DbvEncryption() */



void get_DbvPromptInfo( DbvPromptInfo **ppsPromptInfo, TBL InTable )
   {
   char *stringfield;
   DbvPromptInfoType	ePromptInfoType;
   DbvPromptInfo        *psPromptInfo;

#ifdef DEBUG
   printf( "D - get_DbvPromptInfo()\n" );
#endif

   /* Malloc the space */

   if ( *ppsPromptInfo == NULL )
      *ppsPromptInfo = (DbvPromptInfo*)DbvAlloc( sizeof( DbvPromptInfo ) );
   psPromptInfo = *ppsPromptInfo;

   TBL_GetRecord( InTable );


   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvPromptInfoType( &stringfield, &ePromptInfoType );
   psPromptInfo->ePromptInfoType = ePromptInfoType;
   DbvFree( stringfield );

   switch( ePromptInfoType )
      {
      case PIIT_Character:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
         get_DbvInternationalString( &psPromptInfo->uPromptInfo.psCharacter, InTable );
         break;

      case PIIT_Encrypted:
	 get_DbvEncryption( &psPromptInfo->uPromptInfo.psEncrypted, InTable );
         break;

      default:
	 break;
      } /* End switch */

   } /* End get_DbvPromptInfo() */



void get_DbvDataType( DbvDataType  **ppeDataType, TBL InTable )
   {
   char *stringfield;
   DbvDataType   		*peDataType;
   DbvDataType   		eDataType;

#ifdef DEBUG
   printf( "D - get_DbvDataType()\n" );
#endif
   /* Malloc the space */

   if ( *ppeDataType == NULL )
      *ppeDataType = (DbvDataType*)DbvAlloc(
                                        sizeof( DbvDataType ) );
   peDataType = *ppeDataType;

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvDataType( &stringfield, &eDataType );
   *peDataType = eDataType;
   DbvFree( stringfield );

   } /* End get_DbvDataType() */



void get_DbvChallenge( DbvChallenge **ppsChallenge,
                                TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvAttributeElement          *psAttributeElement;
   DbvElementSpecType           eElementSpecType;
   DbvInternationalString       *psDatabaseName;
   DbvSortKey                   *psDbSort;
   DbvAttributeValue            *psAttributeValue;
   DbvChallenge                 *psChallenge;


   /* Malloc the space if required : Must be initialised to Null  */

   if ( *ppsChallenge == NULL )
      *ppsChallenge = (DbvChallenge*)DbvAlloc(
                                        sizeof( DbvChallenge ) );

   psChallenge = *ppsChallenge;

   /* c sPromptId */
   get_compulsory_DbvPromptId( &psChallenge->sPromptId, InTable );


   /* o psDefaultResponse */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_DbvInternationalString( &psChallenge->psDefaultResponse, InTable );

   /* o psPromptInfo */
   TBL_GetRecord( InTable ); 
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvPromptInfo( &psChallenge->psPromptInfo, InTable );
   DbvFree(stringfield);


   /* o psRegExpr */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   get_DbvInternationalString( &psChallenge->psRegExpr, InTable );

   /* o pvResponseRequired */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvNull( &psChallenge->pvResponseRequired, InTable );
   DbvFree(stringfield);


  /* o ppsInnerDatabases */
   getN_DbvInternationalString( &psChallenge->ppsAllowedValues, InTable );
  
   /* o pvShouldSave */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvNull( &psChallenge->pvShouldSave, InTable );
   DbvFree(stringfield);


   /* o peDataType */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvDataType( &psChallenge->peDataType, InTable );
   DbvFree(stringfield);



   /* o psDiagnostic */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvASN1External( &psChallenge->psDiagnostic, InTable );
   DbvFree(stringfield);


   } /* End get_DbvChallenge() */




void getN_DbvChallenge( DbvChallenge ***pppsChallenge, TBL InTable )
   {     
   char *stringfield;
   int  intfield; 
   DbvChallenge **ppsChallenge;
      
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return );
   DbvFree( stringfield );
    
   intfield = get_int_field( InTable, T_Return );

   /* ppsChallenge */

   if ( intfield > 0 )
      {
      ppsChallenge = ( DbvChallenge **)DbvAlloc(
                        ( sizeof( DbvChallenge* ) * (intfield + 1 )));
      *pppsChallenge = ppsChallenge;

      for ( ; intfield; intfield-- )
         {
         get_DbvChallenge( ppsChallenge, InTable );
         ppsChallenge++;
         } /* End for */

      *ppsChallenge = NULL;
      } /* End if */

   } /* End getN_DbvChallenge() */



void get_compulsory_DbvPromptResponse( DbvPromptResponse *psPromptResponse, TBL InTable )
   {
   char *stringfield;
   DbvResponseType	eResponseType;

#ifdef DEBUG
   printf( "D - get_compulsory_DbvPromptResponse()\n" );
#endif

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvResponseType( &stringfield, &eResponseType );
   psPromptResponse->eResponseType = eResponseType;
   DbvFree( stringfield );

   switch( eResponseType )
      {
      case RT_String:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
         get_DbvInternationalString( &psPromptResponse->uResponse.psString, InTable );
         break;

      case RT_Accept:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
	 psPromptResponse->uResponse.fAccept = get_DbvBool( InTable );
         break;

      case RT_Acknowledge:
         break;

      case RT_Diagnostic:
         get_DbvDiagRec( &psPromptResponse->uResponse.psDiagnostic, InTable );
         break;

      case RT_Encrypted:
         get_DbvEncryption( &psPromptResponse->uResponse.psEncryption, InTable );
         break;

      default:
	 break;
      } /* End switch */

   } /* End get_DbvPromptResponse() */



void get_DbvResponse( DbvResponse **ppsResponse,
                                TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvAttributeElement          *psAttributeElement;
   DbvElementSpecType           eElementSpecType;
   DbvInternationalString       *psDatabaseName;
   DbvSortKey                   *psDbSort;
   DbvAttributeValue            *psAttributeValue;
   DbvResponse 			*psResponse;


   /* Malloc the space if required : Must be initialised to Null  */

   if ( *ppsResponse == NULL )
      *ppsResponse = (DbvResponse*)DbvAlloc(
                                        sizeof( DbvResponse ) );

   psResponse = *ppsResponse;

   /* c sPromptId */
   get_compulsory_DbvPromptId( &psResponse->sPromptId, InTable );


   /* c sPromptResponse */
   get_compulsory_DbvPromptResponse( &psResponse->sPromptResponse, InTable );

   } /* End get_DbvResponse() */



void getN_DbvResponse( DbvResponse ***pppsResponse, TBL InTable )
   {     
   char *stringfield;
   int  intfield; 
   DbvResponse **ppsResponse;
      
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return );
   DbvFree( stringfield );
    
   intfield = get_int_field( InTable, T_Return );

   /* ppsResponse */

   if ( intfield > 0 )
      {
      ppsResponse = ( DbvResponse **)DbvAlloc(
                        ( sizeof( DbvResponse* ) * (intfield + 1 )));
      *pppsResponse = ppsResponse;

      for ( ; intfield; intfield-- )
         {
         get_DbvResponse( ppsResponse, InTable );
         ppsResponse++;
         } /* End for */

      *ppsResponse = NULL;
      } /* End if */

   } /* End getN_DbvResponse() */




void get_DbvPromptObject( DbvPromptObject **ppsPromptObject, TBL InTable )
   {
   char *stringfield;
   DbvPromptObject     *psPromptObject;
   DbvPromptObjectType	ePromptObjectType;

#ifdef DEBUG
   printf( "D - get_DbvPromptObject()\n" );
#endif
   /* Malloc the space */

   if ( *ppsPromptObject == NULL )
      *ppsPromptObject = (DbvPromptObject *)DbvAlloc(
                                                sizeof( DbvPromptObject ) );
   psPromptObject = *ppsPromptObject;

   TBL_GetRecord( InTable );

   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);

   stringfield = get_string_field( InTable, T_Return );
   convert_DbvPromptObjectType( &stringfield, &ePromptObjectType );
   psPromptObject->ePromptObjectType = ePromptObjectType;
   DbvFree( stringfield );

   switch( ePromptObjectType )
      {
      case POT_Challenge:
         getN_DbvChallenge( &psPromptObject->uPromptObject.ppsChallenge,
                                   InTable );
         break;

      case POT_Response:
         getN_DbvResponse( &psPromptObject->uPromptObject.ppsResponse,
                                   InTable );
         break;

      default:
         break;
      } /* End switch */

   } /* End get_DbvPromptObject() */



void getN_compulsory_DbvInternationalString(
                DbvInternationalString ***pppsInternationalString,
                TBL InTable )
   { 
   char *stringfield;
   int  intfield;
   DbvInternationalString **ppsInternationalString;
   
   TBL_GetRecord( InTable );    
   stringfield = get_char_field(InTable, T_Return );
   DbvFree( stringfield );
   
   intfield = get_int_field( InTable, T_Return );

   /* InternationalStrings */
   ppsInternationalString = ( DbvInternationalString **)DbvAlloc(
                        ( sizeof( DbvInternationalString* ) * (intfield + 1 )));
   *pppsInternationalString = ppsInternationalString;

   if ( intfield > 0 )
      {

      for ( ; intfield; intfield-- )
         {
         get_DbvInternationalString( ppsInternationalString, InTable );
         ppsInternationalString++;
         } /* End for */

      *ppsInternationalString = NULL;
      } /* End if */

   } /* End getN_compulsory_DbvInternationalString() */



void getN_compulsory_DbvAttributeDescription(
                        DbvAttributeDescription ***pppsDbvAttributeDescription,
                        TBL InTable )
   {
   char *stringfield;
   int  intfield; 
   DbvAttributeDescription **ppsDbvAttributeDescription;
    
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return );
   DbvFree( stringfield );
    
   intfield = get_int_field( InTable, T_Return );

   ppsDbvAttributeDescription = ( DbvAttributeDescription **)DbvAlloc(
                        ( sizeof( DbvAttributeDescription* ) *
                        (intfield + 1 )));
   *pppsDbvAttributeDescription = ppsDbvAttributeDescription;

   /* AttributeDescriptions */

   if ( intfield > 0 )
      {

      for ( ; intfield; intfield-- )
         {
         get_DbvAttributeDescription( ppsDbvAttributeDescription, InTable );
         ppsDbvAttributeDescription++;
         } /* End for */

      *ppsDbvAttributeDescription = NULL;
      } /* End if */

   } /* End getN_compulsory_DbvAttributeDescription() */



void getN_compulsory_DbvUnits( DbvUnits ***pppsUnits, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvUnits **ppsUnits;
 
   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return );
   DbvFree( stringfield ); 

   intfield = get_int_field( InTable, T_Return );
   
   ppsUnits = ( DbvUnits **)DbvAlloc(
                        ( sizeof( DbvUnits* ) * (intfield + 1 )));
   *pppsUnits = ppsUnits;

   /* Unitss */

   if ( intfield > 0 )
      {
      for ( ; intfield; intfield-- )
         {
         get_DbvUnits( ppsUnits, InTable );
         ppsUnits++;
         } /* End for */

      *ppsUnits = NULL;
      } /* End if */

   } /* End getN_compulsory_DbvUnits() */



void getN_compulsory_DbvSpecification( DbvSpecification ***pppsSpecification, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvSpecification **ppsSpecification;
   DbvBool doingfirst = DBV_TRUE;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return );
   DbvFree( stringfield );
                         
   intfield = get_int_field( InTable, T_Return );

   /* Specification */

   ppsSpecification = ( DbvSpecification **)DbvAlloc(
                        ( sizeof(DbvSpecification*) * (intfield + 1 )));
   *pppsSpecification = ppsSpecification;

   if ( intfield > 0 )
      {

      for ( ; intfield; intfield-- )
         {
         /* must do a TBL_GetRecord for every Specification except
            the first because DbvSpecification starts
            with a DbvObjectIdentifier */
         if (doingfirst == DBV_TRUE)
                doingfirst = DBV_FALSE;
         else
                TBL_GetRecord( InTable );

         get_DbvSpecification( ppsSpecification, InTable );
         ppsSpecification++;
         } /* End for */

      *ppsSpecification = NULL;
      } /* End if */

   } /* End getN_compulsory_DbvSpecification() */



void getN_compulsory_DbvCategoryInfo( DbvCategoryInfo ***pppsCategoryInfo, TBL InTable )
   {
   char *stringfield;  
   int  intfield;
   DbvCategoryInfo **ppsCategoryInfo;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return );
   DbvFree( stringfield );
    
   intfield = get_int_field( InTable, T_Return );
    
   /* CategoryInfo */
   ppsCategoryInfo = ( DbvCategoryInfo **)DbvAlloc(
                        ( sizeof( DbvCategoryInfo* ) * (intfield + 1 )));
   *pppsCategoryInfo = ppsCategoryInfo;


   if ( intfield > 0 )
      {
      for ( ; intfield; intfield-- )
         {
         get_DbvCategoryInfo( ppsCategoryInfo, InTable );
         ppsCategoryInfo++;
         } /* End for */

      *ppsCategoryInfo = NULL;
      } /* End if */

   } /* End getN_compulsory_DbvCategoryInfo() */



void getN_compulsory_DbvPath( DbvPath ***pppsDbvPath, TBL InTable )
   {
   char *stringfield;
   int  intfield;
   DbvPath **ppsDbvPath;

   TBL_GetRecord( InTable );
   stringfield = get_char_field(InTable, T_Return );
   DbvFree( stringfield );

   intfield = get_int_field( InTable, T_Return );
    
   /* Paths */
   ppsDbvPath = ( DbvPath **)DbvAlloc(
                        ( sizeof( DbvPath* ) * (intfield + 1 )));
   *pppsDbvPath = ppsDbvPath;


   if ( intfield > 0 )
      {
      for ( ; intfield; intfield-- )
         {
         get_DbvPath( ppsDbvPath, InTable );
         ppsDbvPath++;
         } /* End for */

      *ppsDbvPath = NULL;
      } /* End if */

   } /* End getN_compulsory_DbvPath() */



