/*  Module Name: @(#)get_DbvFuncs5.c	1.6
    Version: 7/3/97
    Author: Dan Maskell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to get structure types from the script files. 
	Used by the origin and target.

*/
 
#include "get_DbvFuncs.h"


extern TBL_Return T_Return;
/*+-----------------------------------------------+*/
/*! get_DbvCharSetAndLanguage                     !*/ 
/*+-----------------------------------------------+*/
void get_DbvCharSetAndLanguage( DbvCharSetAndLanguage **ppsDbvCharSetAndLanguage, TBL InTable )
   {
   DbvCharSetAndLanguage		*psDbvCharSetAndLanguage;
   DbvCharSetAndLanguageType eDbvCharSetAndLanguageType;
   char *stringfield;
 
#ifdef DEBUG
   printf( "D - get_DbvCharSetAndLanguage\n" );
#endif
   /* Malloc the space */
   if ( *ppsDbvCharSetAndLanguage == NULL )
      *ppsDbvCharSetAndLanguage = (DbvCharSetAndLanguage*)DbvAlloc( sizeof( DbvCharSetAndLanguage ) );
   psDbvCharSetAndLanguage = *ppsDbvCharSetAndLanguage;
 
 
   /* struct_enum.s0 */
   /* eCharSetAndLanguageType */
   TBL_GetRecord( InTable );
 
   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
 
   stringfield = get_string_field( InTable, T_Return );
   convert_DbvCharSetAndLanguageType( &stringfield, &eDbvCharSetAndLanguageType );
   psDbvCharSetAndLanguage->eCharSetAndLanguageType = eDbvCharSetAndLanguageType;
   DbvFree( stringfield );

   /* Union uCharSetAndLanguage */
   switch ( psDbvCharSetAndLanguage->eCharSetAndLanguageType )
      {
      /* struct_struct_p1.s1 */
      case CSALT_Proposal:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
         stringfield = get_string_field( InTable, T_Return );
         if( (strcmp(stringfield, NOTHING)) != 0 )
            get_DbvOriginProposal( &psDbvCharSetAndLanguage->uCharSetAndLanguage.psProposal, InTable );
         DbvFree(stringfield);
         break;

      /* struct_struct_p1.s1 */
      case CSALT_Response:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
         stringfield = get_string_field( InTable, T_Return );
         if( (strcmp(stringfield, NOTHING)) != 0 )
            get_DbvTargetResponse( &psDbvCharSetAndLanguage->uCharSetAndLanguage.psResponse, InTable );
         DbvFree(stringfield);
         break;

      default:
	 break;
      } /* End switch */
   } /* End get_DbvCharSetAndLanguage() */
 
/*+-----------------------------------------------+*/
/*! get_DbvTargetResponse                         !*/ 
/*+-----------------------------------------------+*/
void get_DbvTargetResponse( DbvTargetResponse **ppsDbvTargetResponse, TBL InTable )
   {
   DbvTargetResponse		*psDbvTargetResponse;
   DbvBool                      *pBool;
   char *stringfield;
 
#ifdef DEBUG
   printf( "D - get_DbvTargetResponse\n" );
#endif
   /* Malloc the space */
   if ( *ppsDbvTargetResponse == NULL )
      *ppsDbvTargetResponse = (DbvTargetResponse*)DbvAlloc( sizeof( DbvTargetResponse ) );
   psDbvTargetResponse = *ppsDbvTargetResponse;
 
   /* struct_struct_p1.s0 */
   /* psSelectedCharSets */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvSelectedCharSet( &psDbvTargetResponse->psSelectedCharSets, InTable );
   DbvFree(stringfield);
 
   /* struct_typedef_p1.s0 */
   /* psSelectedLanguage */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvGeneralString( &psDbvTargetResponse->psSelectedLanguage, InTable );
   DbvFree(stringfield);

   /* pfRecordsInSelectedCharSets */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      {
      pBool = (DbvBool*)DbvAlloc( sizeof( DbvBool ));
      *pBool = get_DbvBool( InTable );
      psDbvTargetResponse->pfRecordsInSelectedCharSets = pBool;
      } /* End if */
   DbvFree(stringfield);

 
   } /* End get_DbvTargetResponse() */
 
/*+-----------------------------------------------+*/
/*! get_DbvSelectedCharSet                        !*/ 
/*+-----------------------------------------------+*/
void get_DbvSelectedCharSet( DbvSelectedCharSet **ppsDbvSelectedCharSet, TBL InTable )
   {
   DbvSelectedCharSet		*psDbvSelectedCharSet;
   DbvSelectedCharSetType eDbvSelectedCharSetType;
   char *stringfield;
 
#ifdef DEBUG
   printf( "D - get_DbvSelectedCharSet\n" );
#endif
   /* Malloc the space */
   if ( *ppsDbvSelectedCharSet == NULL )
      *ppsDbvSelectedCharSet = (DbvSelectedCharSet*)DbvAlloc( sizeof( DbvSelectedCharSet ) );
   psDbvSelectedCharSet = *ppsDbvSelectedCharSet;
 
 
   /* struct_enum.s0 */
   /* eSelectedCharSetType */
   TBL_GetRecord( InTable );
 
   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
 
   stringfield = get_string_field( InTable, T_Return );
   convert_DbvSelectedCharSetType( &stringfield, &eDbvSelectedCharSetType );
   psDbvSelectedCharSet->eSelectedCharSetType = eDbvSelectedCharSetType;
   DbvFree( stringfield );

   /* Union uSelectedCharSet */
   switch ( psDbvSelectedCharSet->eSelectedCharSetType )
      {
      /* struct_struct_p1.s1 */
      case SCST_Iso2022:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
         stringfield = get_string_field( InTable, T_Return );
         if( (strcmp(stringfield, NOTHING)) != 0 )
            get_DbvIso2022( &psDbvSelectedCharSet->uSelectedCharSet.psIso2022, InTable );
         DbvFree(stringfield);
         break;

      /* struct_struct_p1.s1 */
      case SCST_Iso10646:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
         stringfield = get_string_field( InTable, T_Return );
         if( (strcmp(stringfield, NOTHING)) != 0 )
            get_DbvIso10646( &psDbvSelectedCharSet->uSelectedCharSet.psIso10646, InTable );
         DbvFree(stringfield);
         break;

      /* struct_struct_p1.s1 */
      case SCST_Private:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
         stringfield = get_string_field( InTable, T_Return );
         if( (strcmp(stringfield, NOTHING)) != 0 )
            get_DbvPrivateCharacterSet( &psDbvSelectedCharSet->uSelectedCharSet.psPrivate, InTable );
         DbvFree(stringfield);
         break;

      default:
	 break;
      } /* End switch */
   } /* End get_DbvSelectedCharSet() */
 
/*+-----------------------------------------------+*/
/*! get_DbvOriginProposal                         !*/ 
/*+-----------------------------------------------+*/
void get_DbvOriginProposal( DbvOriginProposal **ppsDbvOriginProposal, TBL InTable )
   {
   DbvOriginProposal		*psDbvOriginProposal;
   DbvBool                      *pBool;
   char *stringfield;

 
#ifdef DEBUG
   printf( "D - get_DbvOriginProposal\n" );
#endif
   /* Malloc the space */
   if ( *ppsDbvOriginProposal == NULL )
      *ppsDbvOriginProposal = (DbvOriginProposal*)DbvAlloc( sizeof( DbvOriginProposal ) );
   psDbvOriginProposal = *ppsDbvOriginProposal;
 
 
   /* ppsProposedCharSets */
   getN_DbvProposedCharSet( &psDbvOriginProposal->ppsProposedCharSets, InTable );
 
   /* ppsProposedLanguages */
   getN_DbvLanguageCode( &psDbvOriginProposal->ppsProposedLanguages, InTable );

   /* pfRecordsInSelectedCharSets */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      {
      pBool = (DbvBool*)DbvAlloc( sizeof( DbvBool ));
      *pBool = get_DbvBool( InTable );
      psDbvOriginProposal->pfRecordsInSelectedCharSets = pBool;
      } /* End if */
   DbvFree(stringfield);


   } /* End get_DbvOriginProposal() */
 
/*+-----------------------------------------------+*/
/*! get_DbvProposedCharSet                        !*/ 
/*+-----------------------------------------------+*/
void get_DbvProposedCharSet( DbvProposedCharSet **ppsDbvProposedCharSet, TBL InTable )
   {
   DbvProposedCharSet		*psDbvProposedCharSet;
   DbvProposedCharSetType eDbvProposedCharSetType;
   char *stringfield;
 
#ifdef DEBUG
   printf( "D - get_DbvProposedCharSet\n" );
#endif
   /* Malloc the space */
   if ( *ppsDbvProposedCharSet == NULL )
      *ppsDbvProposedCharSet = (DbvProposedCharSet*)DbvAlloc( sizeof( DbvProposedCharSet ) );
   psDbvProposedCharSet = *ppsDbvProposedCharSet;
 
 
   /* struct_enum.s0 */
   /* eProposedCharSetType */
   TBL_GetRecord( InTable );
 
   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
 
   stringfield = get_string_field( InTable, T_Return );
   convert_DbvProposedCharSetType( &stringfield, &eDbvProposedCharSetType );
   psDbvProposedCharSet->eProposedCharSetType = eDbvProposedCharSetType;
   DbvFree( stringfield );

   /* Union uProposedCharSet */
   switch ( psDbvProposedCharSet->eProposedCharSetType )
      {
      /* struct_struct_p1.s1 */
      case PRCST_Iso2022:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
         stringfield = get_string_field( InTable, T_Return );
         if( (strcmp(stringfield, NOTHING)) != 0 )
            get_DbvIso2022( &psDbvProposedCharSet->uProposedCharSet.psIso2022, InTable );
         DbvFree(stringfield);
         break;

      /* struct_struct_p1.s1 */
      case PRCST_Iso10646:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
         stringfield = get_string_field( InTable, T_Return );
         if( (strcmp(stringfield, NOTHING)) != 0 )
            get_DbvIso10646( &psDbvProposedCharSet->uProposedCharSet.psIso10646, InTable );
         DbvFree(stringfield);
         break;

      /* struct_struct_p1.s1 */
      case PRCST_Private:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
         stringfield = get_string_field( InTable, T_Return );
         if( (strcmp(stringfield, NOTHING)) != 0 )
            get_DbvPrivateCharacterSet( &psDbvProposedCharSet->uProposedCharSet.psPrivate, InTable );
         DbvFree(stringfield);
         break;

      default:
	 break;
      } /* End switch */
   } /* End get_DbvProposedCharSet() */
 
/*+-----------------------------------------------+*/
/*! get_DbvPrivateCharacterSet                    !*/ 
/*+-----------------------------------------------+*/
void get_DbvPrivateCharacterSet( DbvPrivateCharacterSet **ppsDbvPrivateCharacterSet, TBL InTable )
   {
   DbvPrivateCharacterSet		*psDbvPrivateCharacterSet;
   DbvPrivateCharacterSetType eDbvPrivateCharacterSetType;
   char *stringfield;
 
#ifdef DEBUG
   printf( "D - get_DbvPrivateCharacterSet\n" );
#endif
   /* Malloc the space */
   if ( *ppsDbvPrivateCharacterSet == NULL )
      *ppsDbvPrivateCharacterSet = (DbvPrivateCharacterSet*)DbvAlloc( sizeof( DbvPrivateCharacterSet ) );
   psDbvPrivateCharacterSet = *ppsDbvPrivateCharacterSet;
 
 
   /* struct_enum.s0 */
   /* ePrivateCharacterSetType */
   TBL_GetRecord( InTable );
 
   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
 
   stringfield = get_string_field( InTable, T_Return );
   convert_DbvPrivateCharacterSetType( &stringfield, &eDbvPrivateCharacterSetType );
   psDbvPrivateCharacterSet->ePrivateCharacterSetType = eDbvPrivateCharacterSetType;
   DbvFree( stringfield );

   /* Union uPrivateCharacterSet */
   switch ( psDbvPrivateCharacterSet->ePrivateCharacterSetType )
      {
      case PCST_ViaOid:
         getN_DbvObjectIdentifier( &psDbvPrivateCharacterSet->uPrivateCharacterSet.ppcViaOid, InTable);
         break;

      /* struct_typedef_p1.s0 */
      /* psExternallySpecified */
      case PCST_ExternallySpecified:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
         stringfield = get_string_field( InTable, T_Return );
         if( (strcmp(stringfield, NOTHING)) != 0 )
            get_DbvASN1External( &psDbvPrivateCharacterSet->uPrivateCharacterSet.psExternallySpecified, InTable );
         DbvFree(stringfield);
         break;
 
      default:
	 break;
      } /* End switch */
   } /* End get_DbvPrivateCharacterSet() */
 
/*+-----------------------------------------------+*/
/*! get_DbvIso10646                               !*/ 
/*+-----------------------------------------------+*/
void get_DbvIso10646( DbvIso10646 **ppsDbvIso10646, TBL InTable )
   {
   DbvIso10646		*psDbvIso10646;
 
#ifdef DEBUG
   printf( "D - get_DbvIso10646\n" );
#endif
   /* Malloc the space */
   if ( *ppsDbvIso10646 == NULL )
      *ppsDbvIso10646 = (DbvIso10646*)DbvAlloc( sizeof( DbvIso10646 ) );
   psDbvIso10646 = *ppsDbvIso10646;
 
   TBL_GetRecord( InTable );
   get_DbvObjectIdentifier( &psDbvIso10646->pcCollections, InTable );
   TBL_GetRecord( InTable );
   get_DbvObjectIdentifier( &psDbvIso10646->pcEncodingLevel, InTable );
   } /* End get_DbvIso10646() */
 
/*+-----------------------------------------------+*/
/*! get_DbvIso2022                                !*/ 
/*+-----------------------------------------------+*/
void get_DbvIso2022( DbvIso2022 **ppsDbvIso2022, TBL InTable )
   {
   DbvIso2022		*psDbvIso2022;
   DbvIso2022Type eDbvIso2022Type;
   char *stringfield;
 
#ifdef DEBUG
   printf( "D - get_DbvIso2022\n" );
#endif
   /* Malloc the space */
   if ( *ppsDbvIso2022 == NULL )
      *ppsDbvIso2022 = (DbvIso2022*)DbvAlloc( sizeof( DbvIso2022 ) );
   psDbvIso2022 = *ppsDbvIso2022;
 
 
   /* struct_enum.s0 */
   /* eIso2022Type */
   TBL_GetRecord( InTable );
 
   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
 
   stringfield = get_string_field( InTable, T_Return );
   convert_DbvIso2022Type( &stringfield, &eDbvIso2022Type );
   psDbvIso2022->eIso2022Type = eDbvIso2022Type;
   DbvFree( stringfield );

   /* Union uIso2022Type */
   switch ( psDbvIso2022->eIso2022Type )
      {
      /* struct_struct_p1.s1 */
      case I2022T_OriginProposal:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
         stringfield = get_string_field( InTable, T_Return );
         if( (strcmp(stringfield, NOTHING)) != 0 )
            get_DbvIso2022Proposal( &psDbvIso2022->uIso2022Type.psOriginProposal, InTable );
         DbvFree(stringfield);
         break;

      /* struct_struct_p1.s1 */
      case I2022T_TargetResponse:
         TBL_GetRecord( InTable );
         stringfield = get_char_field( InTable, T_Return );
         DbvFree(stringfield);
         stringfield = get_string_field( InTable, T_Return );
         if( (strcmp(stringfield, NOTHING)) != 0 )
            get_DbvIso2022Response( &psDbvIso2022->uIso2022Type.psTargetResponse, InTable );
         DbvFree(stringfield);
         break;

      default:
	 break;
      } /* End switch */
   } /* End get_DbvIso2022() */
 
/*+-----------------------------------------------+*/
/*! get_DbvIso2022Response                        !*/ 
/*+-----------------------------------------------+*/
void get_DbvIso2022Response( DbvIso2022Response **ppsDbvIso2022Response, TBL InTable )
   {
   DbvIso2022Response		*psDbvIso2022Response;
   char *stringfield;
 
#ifdef DEBUG
   printf( "D - get_DbvIso2022Response\n" );
#endif
   /* Malloc the space */
   if ( *ppsDbvIso2022Response == NULL )
      *ppsDbvIso2022Response = (DbvIso2022Response*)DbvAlloc( sizeof( DbvIso2022Response ) );
   psDbvIso2022Response = *ppsDbvIso2022Response;
 
   /* struct_struct_p1.s0 */
   /* psSelectedEnvironment */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvEnvironment( &psDbvIso2022Response->psSelectedEnvironment, InTable );
   DbvFree(stringfield);
 
   /* ppulSelectedSets */
   getN_Ulong( &psDbvIso2022Response->ppulSelectedSets, InTable);
   /* struct_struct_p1.s0 */
   /* psSelectedInitialSet */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvInitialSet( &psDbvIso2022Response->psSelectedInitialSet, InTable );
   DbvFree(stringfield);
   /* struct_struct_p1.s0 */
   /* psSelectedLeftAndRight */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvLeftAndRight( &psDbvIso2022Response->psSelectedLeftAndRight, InTable );
   DbvFree(stringfield);
   } /* End get_DbvIso2022Response() */
 
/*+-----------------------------------------------+*/
/*! get_DbvIso2022Proposal                        !*/ 
/*+-----------------------------------------------+*/
void get_DbvIso2022Proposal( DbvIso2022Proposal **ppsDbvIso2022Proposal, TBL InTable )
   {
   DbvIso2022Proposal		*psDbvIso2022Proposal;
   char *stringfield;
 
#ifdef DEBUG
   printf( "D - get_DbvIso2022Proposal\n" );
#endif
   /* Malloc the space */
   if ( *ppsDbvIso2022Proposal == NULL )
      *ppsDbvIso2022Proposal = (DbvIso2022Proposal*)DbvAlloc( sizeof( DbvIso2022Proposal ) );
   psDbvIso2022Proposal = *ppsDbvIso2022Proposal;
 
   /* struct_struct_p1.s0 */
   /* psProposedEnvironment */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvEnvironment( &psDbvIso2022Proposal->psProposedEnvironment, InTable );
   DbvFree(stringfield);
 
   /* ppulProposedSets */
   getN_Ulong( &psDbvIso2022Proposal->ppulProposedSets, InTable);
 
   /* ppsProposedInitialSets */
   getN_DbvInitialSet( &psDbvIso2022Proposal->ppsProposedInitialSets, InTable );
   /* struct_struct_p1.s0 */
   /* psProposedLeftAndRight */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   stringfield = get_string_field( InTable, T_Return );
   if( (strcmp(stringfield, NOTHING)) != 0 )
      get_DbvLeftAndRight( &psDbvIso2022Proposal->psProposedLeftAndRight, InTable );
   DbvFree(stringfield);
   } /* End get_DbvIso2022Proposal() */
 
/*+-----------------------------------------------+*/
/*! get_DbvLeftAndRight                           !*/ 
/*+-----------------------------------------------+*/
void get_DbvLeftAndRight( DbvLeftAndRight **ppsDbvLeftAndRight, TBL InTable )
   {
   DbvLeftAndRight		*psDbvLeftAndRight;
   char *stringfield;
 
#ifdef DEBUG
   printf( "D - get_DbvLeftAndRight\n" );
#endif
   /* Malloc the space */
   if ( *ppsDbvLeftAndRight == NULL )
      *ppsDbvLeftAndRight = (DbvLeftAndRight*)DbvAlloc( sizeof( DbvLeftAndRight ) );
   psDbvLeftAndRight = *ppsDbvLeftAndRight;
 
 
   /* struct_long.s0 */
   /* ulGLeft */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psDbvLeftAndRight->ulGLeft = get_int_field( InTable, T_Return );
 
   /* struct_long.s0 */
   /* ulGRight */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psDbvLeftAndRight->ulGRight = get_int_field( InTable, T_Return );
   } /* End get_DbvLeftAndRight() */
 
/*+-----------------------------------------------+*/
/*! get_DbvInitialSet                             !*/ 
/*+-----------------------------------------------+*/
void get_DbvInitialSet( DbvInitialSet **ppsDbvInitialSet, TBL InTable )
   {
   DbvInitialSet		*psDbvInitialSet;
   char *stringfield;
 
#ifdef DEBUG
   printf( "D - get_DbvInitialSet\n" );
#endif
   /* Malloc the space */
   if ( *ppsDbvInitialSet == NULL )
      *ppsDbvInitialSet = (DbvInitialSet*)DbvAlloc( sizeof( DbvInitialSet ) );
   psDbvInitialSet = *ppsDbvInitialSet;
 
 
   /* struct_long.s0 */
   /* ulG0 */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psDbvInitialSet->ulG0 = get_int_field( InTable, T_Return );
 
   /* struct_long.s0 */
   /* ulG1 */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psDbvInitialSet->ulG1 = get_int_field( InTable, T_Return );
 
   /* struct_long.s0 */
   /* ulG2 */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psDbvInitialSet->ulG2 = get_int_field( InTable, T_Return );
 
   /* struct_long.s0 */
   /* ulG3 */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psDbvInitialSet->ulG3 = get_int_field( InTable, T_Return );
 
   /* struct_long.s0 */
   /* ulC0 */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psDbvInitialSet->ulC0 = get_int_field( InTable, T_Return );
 
   /* struct_long.s0 */
   /* ulC1 */
   TBL_GetRecord( InTable );
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
   psDbvInitialSet->ulC1 = get_int_field( InTable, T_Return );
   } /* End get_DbvInitialSet() */
 
/*+-----------------------------------------------+*/
/*! get_DbvEnvironment                            !*/ 
/*+-----------------------------------------------+*/
void get_DbvEnvironment( DbvEnvironment **ppsDbvEnvironment, TBL InTable )
   {
   DbvEnvironment		*psDbvEnvironment;
   char *stringfield;
   DbvEnvironmentType eDbvEnvironmentType;
 
#ifdef DEBUG
   printf( "D - get_DbvEnvironment\n" );
#endif
   /* Malloc the space */
   if ( *ppsDbvEnvironment == NULL )
      *ppsDbvEnvironment = (DbvEnvironment*)DbvAlloc( sizeof( DbvEnvironment ) );
   psDbvEnvironment = *ppsDbvEnvironment;
 
 
   /* struct_enum.s0 */
   /* eEnvironmentType */
   TBL_GetRecord( InTable );
 
   /* Ignore the title */
   stringfield = get_char_field( InTable, T_Return );
   DbvFree(stringfield);
 
   stringfield = get_string_field( InTable, T_Return );
   convert_DbvEnvironmentType( &stringfield, &eDbvEnvironmentType );
   psDbvEnvironment->eEnvironmentType = eDbvEnvironmentType;
   DbvFree( stringfield );

   } /* End get_DbvEnvironment() */
 
