/*  Module Name: @(#)memcheck.h	1.2
    Version: 9/19/96
    Author:  M. Bush
    
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ

    Date of Issue: 

    QA Acceptance:  
    Date of Acceptance:  

    Description:  
		  Source code for memory processing functions.
*/

#ifndef MEMCHECK_H
#define MEMCHECK_H

#include <stdlib.h>

enum ErrorLevel_ {Warning_,Error_,Fatal_};

void SError_( enum ErrorLevel_ Error, char* ErrorString, char* ModuleName );

typedef int Bool_;

#ifndef TRUE
#define FALSE 0
#define TRUE 1
#endif

#ifndef True
#define False 0
#define True 1
#endif

#define Local_      static
#define Global_




#define Matches_    0

#define MALLOC_(ObjType)		\
    (ObjType*)malloc(sizeof(ObjType))

#define BYTES_(NumBytes)		\
    malloc(NumBytes)

void*	mc_SMalloc(size_t Size, char * ModName);

#define SMALLOC_(ObjType, ModName) \
    (ObjType*)mc_SMalloc(sizeof(ObjType),ModName);

void	*SBYTES_(size_t NumBytes, char *ModName);

void FREE_ ( void* Item );


#define NotEof_	    (int)'a';

#define	Check_(Condition,Text,Module)	    \
    if (Condition) {			    \
	SError_(Fatal_,Text,Module);	    \
    }


#endif
