/*  Module Name: @(#)o_ext.c	7.1
    Version: 11/15/96
    Author: Peter Watson

    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ

    Date of Issue:

    QA Acceptance:
    Date of Acceptance:

    Description:
	Functions to write results/read arguments to/from origin specific tbl
	files associated with the Z39.50 functions. For use with the testtool.

*/
#include "o_ext.h"

extern TBL_Return T_Return;
extern char string[];

/* Read in DbvExtendedServicesRequest tbl file */
int do_DbvExtendedServicesRequest(TestType eTestType)
{
	char InFilename[STRING_LEN];
	char OutFilename[STRING_LEN];
        char pcResult[STRING_LEN];
	TBL InTable, OutTable, LocalTable;
	int place = 0;
	int NumberOfPermissions;
	int loop;
	int intfield;
	int out_record = 1;
	int return_value = SI_OK;
	char *stringfield;
	char *version;
	char *options;
        char *pcDbvExtServicesWaitAction;
        char *pcDbvExtServicesFunctions;

        DbvExtServicesWaitAction eWaitAction;
        DbvExtServicesFunctions eFunction;
	DbvAssocId         lAssocId;
	DbvSecs            lSeconds;
	DbvExtendedServicesReq   *psExtendedServicesReq;
	DbvError           *psError=NULL;
	return_value = open_tables("extreq", eTestType, InFilename, OutFilename , &InTable, &OutTable);
	if(return_value == SI_NOTOK)
		return return_value;
	write_comment_field("\nResults of ExtendedServicesRequest\n", OutTable, T_Return);
	TBL_GetRecord(InTable);
	do {
	psExtendedServicesReq = (DbvExtendedServicesReq *) DbvAlloc (sizeof(DbvExtendedServicesReq));
/* Assoc Id */
	intfield=get_int_field(InTable,T_Return);
	lAssocId=intfield=get_int_field(InTable,T_Return);
	TBL_GetRecord(InTable);
	intfield=get_int_field(InTable,T_Return);
/* ReferenceId */
	get_DbvOctetString(&(psExtendedServicesReq->psReferenceId), InTable);

/* eFunction */
	TBL_GetRecord(InTable);
 	stringfield= get_char_field(InTable, T_Return);
        DbvFree(stringfield);
        pcDbvExtServicesFunctions = get_string_field(InTable, T_Return);
        convert_DbvExtServicesFunctions(&pcDbvExtServicesFunctions,&eFunction);
        psExtendedServicesReq->eFunction=eFunction;
	DbvFree(pcDbvExtServicesFunctions);


/* PackageType */
	TBL_GetRecord(InTable);
	get_DbvObjectIdentifier(&psExtendedServicesReq->pcPackageType,
		InTable); 

/* PackageName  */
 	TBL_GetRecord(InTable);
        stringfield= get_char_field(InTable, T_Return);
	DbvFree(stringfield);
	get_DbvInternationalString(&(psExtendedServicesReq->psPackageName), InTable);

/* UserId  */
	TBL_GetRecord(InTable);
        stringfield= get_char_field(InTable, T_Return);
	DbvFree(stringfield);
	get_DbvInternationalString(&(psExtendedServicesReq->psUserId), InTable);


/* RetentionTime Structure */

	TBL_GetRecord(InTable);
        stringfield= get_char_field(InTable, T_Return);
	DbvFree(stringfield);
        if((strcmp(stringfield=get_string_field(InTable, T_Return),NOTHING))!=0)
        {
	DbvFree(stringfield);
	get_DbvIntUnit(&(psExtendedServicesReq->psRetentionTime),InTable);
	}
	else
	DbvFree(stringfield);

/* NumberOfPermissions */
	TBL_GetRecord(InTable);	
        stringfield= get_char_field(InTable, T_Return);
	DbvFree(stringfield);	 
	NumberOfPermissions=intfield=get_int_field(InTable,T_Return);
 

/* Permissions */
	if(intfield > 0)
	{
		psExtendedServicesReq->ppsPermissions=(DbvPermissions **)DbvAlloc((intfield+1) * sizeof(DbvPermissions *));
		for(loop = 0; loop < intfield; loop ++)
		{
			psExtendedServicesReq->ppsPermissions[loop]=(DbvPermissions *)DbvAlloc(sizeof(DbvPermissions));
			get_DbvPermissions(&psExtendedServicesReq->ppsPermissions[loop],InTable);	
		}
	}

/* Description */
	TBL_GetRecord(InTable);	
        stringfield= get_char_field(InTable, T_Return);
	DbvFree(stringfield);
	get_DbvInternationalString(&(psExtendedServicesReq->psDescription), InTable);

/* OriginSpecificParameter External*/
	get_DbvASN1External(&(psExtendedServicesReq->psOriginSpecificParameter), InTable);

/* ExtServicesWaitAction */
	TBL_GetRecord(InTable);
 	stringfield= get_char_field(InTable, T_Return);
        DbvFree(stringfield);
        pcDbvExtServicesWaitAction = get_string_field(InTable, T_Return);
        convert_DbvExtServicesWaitAction(&pcDbvExtServicesWaitAction,&eWaitAction);
        psExtendedServicesReq->eWaitAction=eWaitAction;
	DbvFree(pcDbvExtServicesWaitAction);

/*Element */
	TBL_GetRecord(InTable);	
        stringfield= get_char_field(InTable, T_Return);
	DbvFree(stringfield);
	get_DbvInternationalString(&(psExtendedServicesReq->psElements), InTable);


/* OtherInformation */
	getN_DbvOtherInformation(&(psExtendedServicesReq->ppsOtherInformation), 
		InTable);

        bLocalResult = DBV_TRUE;
        if(open_result_table("o", &LocalTable, pcResult)==SI_OK)
	{
                write_DbvExtendedServicesRequest(psExtendedServicesReq, 
			LocalTable);
		TBL_Destruct(LocalTable);
	}
        bLocalResult = DBV_FALSE;

	printf("Press enter to execute DbvExtendedServicesRequest\n");
	fflush(stdin);
	get_return();

	return_value = DbvExtendedServicesRequest(lAssocId, psExtendedServicesReq, &psError);

	if(return_value == SI_OK)
	{
		printf("ExtendedServicesRequest Ok\n");
		printf("Writing output to %s\n", OutFilename);
		write_int_field(out_record++, OutTable, T_Return);
		write_string_field("IN_PARAM", OutTable, T_Return);
		TBL_PutRecord(OutTable);
		write_int_field(out_record++, OutTable, T_Return);
		write_string_field("IN_PARAM", OutTable, T_Return);
		TBL_PutRecord(OutTable);
		write_int_field(out_record++, OutTable, T_Return);
		write_string_field("NULL", OutTable, T_Return);
		TBL_PutRecord(OutTable);
	}
	else
	{
		printf("Call failed\n");
		write_DbvError(&psError, OutTable);
	}
	Free_DbvExtendedServicesReq(psExtendedServicesReq);
	TBL_GetRecord(InTable);
	out_record = 1; place = 0;
	}
	while(TBL_GetRecord(InTable)!=FALSE);

	TBL_Destruct(InTable);
	TBL_Destruct(OutTable);

	return return_value;
}

void write_DbvExtendedServicesResponse(DbvExtendedServicesRsp *psExtendedServicesRsp, TBL OutTable)
{
	int loop;
	char temp[STRING_LEN];
        char *pcDbvExtServicesOperationStatus;
	DbvExtServicesOperationStatus eOperationStatus;

        if( bLocalResult == DBV_TRUE)
                write_comment_field("Completed structure DbvExtendedServicesResponse",
                        OutTable, T_Return);
        else
        {
		write_comment_field("DbvExtendedServicesResponse received from Target", OutTable, T_Return);
		write_comment_field("Structure detailed - DbvOriginData.uOriginEvent->psExtendedServicesRsp:", OutTable, T_Return);
	}

/* ReferenceId is an optional field */
	write_DbvOctetString("psReferenceId", psExtendedServicesRsp->psReferenceId, OutTable);
        TBL_PutRecord(OutTable);

/* ExtServicesOperationStatus */
        pcDbvExtServicesOperationStatus= NULL;
        convert_DbvExtServicesOperationStatus(&pcDbvExtServicesOperationStatus,&(psExtendedServicesRsp->eOperationStatus));
	write_title_char(pcDbvExtServicesOperationStatus, "eOperationStatus", OutTable);
	DbvFree(pcDbvExtServicesOperationStatus);
	TBL_PutRecord(OutTable);

/* Diagnostics */
	if(psExtendedServicesRsp->ppsDiagnostics != NULL)
	{
		loop=0;
		while(psExtendedServicesRsp->ppsDiagnostics[loop] != NULL)
		{
			write_DbvDiagRec(psExtendedServicesRsp->ppsDiagnostics[loop], OutTable);
			loop++;
		}
	}
	else
		write_title_char("NULL", "ppsDiagnostics", OutTable);
	
/* ResourceReport ASN1External */

	write_comment_field("START of psTaskPackage", OutTable, T_Return);
	write_DbvASN1External(psExtendedServicesRsp->psTaskPackage, OutTable);
	write_comment_field("END of psTaskPackage", OutTable, T_Return);

/* Other Information */
	writeN_DbvOtherInformation(psExtendedServicesRsp->ppsOtherInformation, 
		OutTable);

        write_comment_field(" End ", OutTable, T_Return);
        TBL_PutRecord(OutTable);
}
 
