/*  Module Name: @(#)o_res.c	7.1
    Version: 11/15/96
    Author: Peter Watson

    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ

    Date of Issue:

    QA Acceptance:
    Date of Acceptance:

    Description:
	Functions to write results/read arguments to/from origin specific tbl
	files associated with the Z39.50 functions. For use with the testtool.

*/
#include "o_res.h"

extern TBL_Return T_Return;
extern char string[];

/* Read in DbvResourceReportRequest tbl file */
int do_DbvResourceReportRequest(TestType eTestType)
{
	char InFilename[STRING_LEN];
	char OutFilename[STRING_LEN];
        char pcResult[STRING_LEN];
	TBL InTable, OutTable, LocalTable;
	int place = 0;

	int intfield;
	int out_record = 1;
	int return_value = SI_OK;
	char *stringfield;
	char *version;
	char *format;
	char *options;

	DbvAssocId         lAssocId;
	DbvSecs            lSeconds;
	DbvResourceReportReq   *psResourceReportReq;
	DbvError           *psError=NULL;

	return_value = open_tables("resreq", eTestType, InFilename, OutFilename , &InTable, &OutTable);
	if(return_value == SI_NOTOK)
		return return_value;
	write_comment_field("\nResults of ResourceReportRequest\n", OutTable, T_Return);
	TBL_GetRecord(InTable);
	do {
	psResourceReportReq = (DbvResourceReportReq *) DbvAlloc (sizeof(DbvResourceReportReq));
/* Assoc Id */
	intfield=get_int_field(InTable,T_Return);
	lAssocId=intfield=get_int_field(InTable,T_Return);
	TBL_GetRecord(InTable);
	intfield=get_int_field(InTable,T_Return);

/* ReferenceId */
	get_DbvOctetString(&(psResourceReportReq->psReferenceId), InTable);

/* OperationId */
	TBL_GetRecord(InTable);
        stringfield= get_char_field(InTable, T_Return);
	DbvFree(stringfield);
	get_DbvOctetString(&(psResourceReportReq->psOperationId), InTable);


/* PrefResourceReportFormat */
 	TBL_GetRecord(InTable);
	get_DbvObjectIdentifier(&psResourceReportReq->
		pcPrefResourceReportFormat, InTable);

/* OtherInformation */
	getN_DbvOtherInformation(&(psResourceReportReq->ppsOtherInformation), 
		InTable);

        bLocalResult = DBV_TRUE;
        if(open_result_table("o", &LocalTable, pcResult)==SI_OK)
	{
                write_DbvResourceReportRequest(psResourceReportReq, LocalTable);
		TBL_Destruct(LocalTable);
	}
        bLocalResult = DBV_FALSE;

	printf("Press enter to execute DbvResourceReportRequest\n");
	fflush(stdin);
	get_return();

	return_value = DbvResourceReportRequest(lAssocId, psResourceReportReq, &psError);

	if(return_value == SI_OK)
	{
		printf("ResourceReportRequest Ok\n");
		printf("Writing output to %s\n", OutFilename);
		write_int_field(out_record++, OutTable, T_Return);
		write_string_field("IN_PARAM", OutTable, T_Return);
		TBL_PutRecord(OutTable);
		write_int_field(out_record++, OutTable, T_Return);
		write_string_field("IN_PARAM", OutTable, T_Return);
		TBL_PutRecord(OutTable);
		write_int_field(out_record++, OutTable, T_Return);
		write_string_field("NULL", OutTable, T_Return);
		TBL_PutRecord(OutTable);
	}
	else
	{
		printf("Call failed\n");
		write_DbvError(&psError, OutTable);
	}
	Free_DbvResourceReportReq(psResourceReportReq);
	TBL_GetRecord(InTable);
	out_record = 1; place = 0;
	}
	while(TBL_GetRecord(InTable)!=FALSE);

	TBL_Destruct(InTable);
	TBL_Destruct(OutTable);

	return return_value;
}

void write_DbvResourceReportResponse(DbvResourceReportRsp *psResourceReportRsp, TBL OutTable)
{

	char *pcDbvResourceReportStatus;

        if( bLocalResult == DBV_TRUE)
                write_comment_field("Completed structure DbvResourceReportResponse", OutTable, T_Return);
        else
        {
		write_comment_field("DbvResourceReportResponse received from Target", OutTable, T_Return);
		write_comment_field("Structure detailed - DbvOriginData.uOriginEvent->psResourceReportRsp:", OutTable, T_Return);
	}

/* ReferenceId is an optional field */
	write_DbvOctetString("psReferenceId",psResourceReportRsp->psReferenceId, OutTable);


/* ResourceReportStatus */
        pcDbvResourceReportStatus = NULL;
        convert_DbvResourceReportStatus(&pcDbvResourceReportStatus,&(psResourceReportRsp->eResourceReportStatus));
	write_title_char(pcDbvResourceReportStatus, "eResourceReportStatus", OutTable);
	DbvFree(pcDbvResourceReportStatus);
	TBL_PutRecord(OutTable);

/* ResourceReport ASN1External */
 
        write_comment_field("START of psResourceReport", OutTable, T_Return);
        write_DbvASN1External(psResourceReportRsp->psResourceReport, OutTable);
        write_comment_field("END of psResourceReport", OutTable, T_Return);
 
/* Other Information */
        writeN_DbvOtherInformation(psResourceReportRsp->ppsOtherInformation, 
		OutTable);
 
        write_comment_field(" End ", OutTable, T_Return);
        TBL_PutRecord(OutTable);
}
