/*  Module Name: @(#)o_seg.c	7.1
    Version: 11/15/96
    Author: Peter Watson

    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ

    Date of Issue:

    QA Acceptance:
    Date of Acceptance:

    Description:
	Functions to write results arguments to origin specific tbl
	files associated with the Z39.50 functions. For use with the testtool.

*/

#include "o_seg.h"

extern TBL_Return T_Return;
extern char string[];


void write_DbvSegmentRequest(DbvSegmentReq *psSegmentReq,
        TBL OutTable)
{
        char temp[STRING_LEN];
	int loop = 0;
        int ulNumberOfSegmentRecords;

        if( bLocalResult == DBV_TRUE)
                write_comment_field("Completed structure DbvSegmentRequest",
                        OutTable, T_Return);
        else
        {
        	write_comment_field("DbvSegmentReq received from Target", 
			OutTable, T_Return);
        	write_comment_field("Structure detailed - DbvOriginData.uOriginevent->psSegmentReq:", OutTable, T_Return);
	}
/* ReferenceId is an optional field */
        write_DbvOctetString("psReferenceId", psSegmentReq->psReferenceId,OutTable);

/* NumberOfRecordsReturned */
	write_title_int("ulNumberOfRecordsReturned", (int *)&(psSegmentReq->ulNumberOfRecordsReturned), OutTable);
	TBL_PutRecord(OutTable);

/* SegmentRecords */
	loop=0;
	while(psSegmentReq->ppsSegmentRecords[loop] != NULL)
	{
        	write_DbvNamePlusRecord(psSegmentReq->ppsSegmentRecords[loop], 
			OutTable);
		loop++;
	}

/* Other Information */
	writeN_DbvOtherInformation(psSegmentReq->ppsOtherInformation, OutTable);

	TBL_PutRecord(OutTable);
        write_comment_field(" End ", OutTable, T_Return);
        TBL_PutRecord(OutTable);
}


