
#ifndef ORIGIN_BATCH_H
#define ORIGIN_BATCH_H

#include "testy_calls.h"
#include "batch.h"

int batch_DoOriginBatchProcessing(void);
void batch_ExecuteOriginBatchFile(void);
void batch_ParseOriginBatchFile(TBL psBatchTable);
int batch_DoOriginBatchProcessing(void);


int batch_ExecDbvAssociateRequest(char *pcFilename);
int batch_ExecDbvReleaseRequest(char *pcFilename);
int batch_ExecDbvConfirmAssociateRequest(char *pcFilename);
int batch_ExecDbvConfirmReleaseRequest(char *pcFilename);
int batch_ExecDbvInitializeRequest(char *pcFilename);
int batch_ExecDbvSearchRequest(char *pcFilename);
int batch_ExecDbvPresentRequest(char *pcFilename);
int batch_ExecDbvDeleteResultSetRequest(char *pcFilename);
int batch_ExecDbvScanRequest(char *pcFilename);
int batch_ExecDbvResourceReportRequest(char *pcFilename);
int batch_ExecDbvSortRequest(char *pcFilename);
int batch_ExecDbvExtendedServicesRequest(char *pcFilename);
int batch_ExecDbvReceiveDataOrigin(char *pcFilename);
int batch_ExecDbvAccessControlResponse(char *pcFilename);
int batch_ExecDbvResourceControlResponse(char *pcFilename);
int batch_ExecDbvTriggerResourceControlRequest(char *pcFilename);

BatchFunctions psOriginFunctions[NO_ORIGIN_FUNCTIONS] = {
        { "DbvAssociateRequest",        batch_ExecDbvAssociateRequest },
        { "DbvReleaseRequest",          batch_ExecDbvReleaseRequest },
        { "DbvAbortRequest",            batch_ExecDbvAbortRequest },
        { "DbvConfirmAssociateRequest", batch_ExecDbvConfirmAssociateRequest},
        { "DbvConfirmReleaseRequest",   batch_ExecDbvConfirmReleaseRequest },
        { "DbvInitializeRequest",       batch_ExecDbvInitializeRequest },
        { "DbvSearchRequest",           batch_ExecDbvSearchRequest },
        { "DbvPresentRequest",          batch_ExecDbvPresentRequest },
        { "DbvDeleteResultSetRequest",  batch_ExecDbvDeleteResultSetRequest},
        { "DbvScanRequest",             batch_ExecDbvScanRequest },
        { "DbvResourceReportRequest",   batch_ExecDbvResourceReportRequest },
        { "DbvSortRequest",             batch_ExecDbvSortRequest },
        { "DbvExtendedServicesRequest", batch_ExecDbvExtendedServicesRequest},
        { "DbvCloseRequest",            batch_ExecDbvCloseRequest },
        { "DbvCloseResponse",           batch_ExecDbvCloseResponse },
        { "DbvReceiveDataOrigin",       batch_ExecDbvReceiveDataOrigin },
        { "DbvAccessControlResponse",   batch_ExecDbvAccessControlResponse },
        { "DbvResourceControlResponse", batch_ExecDbvResourceControlResponse },
        { "DbvTriggerResourceControlRequest",   batch_ExecDbvTriggerResourceControlRequest }
};

#endif

