/*  Module Name: @(#)sl_list.h	1.2
    Version: 9/19/96
    Author:  M. Bush
    
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ

    Date of Issue: 

    QA Acceptance:  
    Date of Acceptance: 

    Description:  
		  Header file for singly-linked list object functions.
*/

#ifndef SL_Include
#define SL_Include
#include "memcheck.h"

typedef struct	SList *SL;
typedef void	(*SL_Free)(void *);
typedef int	(*SL_CompFunc)(void *,void *);
typedef Bool_	(*SL_LocateFunc)(void*, void*);
typedef Bool_	(*SL_LocateFunc2)(void*, void*, void*);
typedef void	(*SL_TraverseFunc)(void*);
typedef void	(*SL_TraverseFunc3)(void*, void*, void*, void*);
typedef void*	(*SL_CopyFunc)(void*);
typedef Bool_	(*SL_OrderFunc)(void*, void*);
typedef Bool_	(*SL_PositionFunc)(void*, void*);

SL    	SL_Create(SL_Free Dispose);

void  	SL_Destruct(SL List);

void* 	SL_Remove(SL List);

void* 	SL_RemoveCurrent(SL List);

void*	SL_RemoveCurrentN(SL List);

void  	SL_End(SL List);

void  	SL_Start(SL List);

Bool_ 	SL_IsStart(SL List);

Bool_ 	SL_IsEnd(SL List);

void* 	SL_Current(SL List);

void  	SL_Succ(SL List);

void  	SL_DeleteHead(SL List);

void  	SL_Add(SL List, void* Item);

void  	SL_AddBefore(SL List, void* Item);

void  	SL_Assign( SL List, Bool_ Assign );

Bool_ 	SL_IsAssign( SL List );

void* 	SL_Locate( SL List, SL_LocateFunc LocateFunc, void* Item );

void*	SL_Locate2( SL List, SL_LocateFunc2 LocateFunc, void*Item1, void*Item2 );

void*	SL_LocateNext( SL List, SL_LocateFunc LocateFunc, void*Item );
void*	SL_LocateNext2( SL List, SL_LocateFunc2 LocateFunc, void*Item1, void*Item2 );

void*	SL_LocateNextBack( SL List, SL_LocateFunc LocateFunc, void*Item );
void*	SL_LocateNextBack2( SL List, SL_LocateFunc2 LocateFunc, void*Item1, void*Item2 );

void	SL_Copy( SL List, SL_CopyFunc CopyFunc, SL ListRet );

void  	SL_Traverse( SL List, SL_TraverseFunc TraverseFunc );

void	SL_Traverse3( SL List, SL_TraverseFunc3 TraverseFunc, void*Item1, void*Item2, void*Item3 );

Bool_ 	SL_EmptyList(SL List);

void  	SL_Prev(SL List);

void  	SL_AddList( SL List, SL AddList, Bool_ DestructAddList );

void	SL_AddStringList( SL List, SL AddList, Bool_ DestructAddList );

void	SL_AddListConditional( SL List, SL AddList, SL_LocateFunc LocateFunc );

void	SL_InsertList( SL List, SL AddList, Bool_ Before, Bool_ DestructAddList, Bool_ CurrentRemain );

int   	SL_NumberOfItemsInList( SL List );

void	SL_ReverseList( SL List );

void	SL_OrderList( SL List, SL_OrderFunc OrderFunc );

int	SL_Position( SL List, SL_PositionFunc PositionFunc, void*Item );

void	SL_Clear( SL List, Bool_ FreeItems );

int	SL_NumberOfTypeInList( SL List, SL_LocateFunc LocateFunc, void*Item );

void	SL_RemoveDuplicates( SL List );

SL_LocateFunc	SL_Identical_Locate( void* Item, void* ItemRet );

void*	SL_LocateAlike( SL List, SL_LocateFunc2 LocateFunc, void* Item );

void	SL_RemoveAlike( SL List, SL_LocateFunc2 LocateFunc, void* Item );

void	SL_HoldPosition( SL List );

void	SL_ReturnPosition( SL List );

#endif
