/*  Module Name: @(#)t_access.c	7.1
    Version: 11/15/96
    Author: John Hough
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to write results/read arguments from target Sort
        Req/Resp specific tbl files. For use with the testtool.

 
*/
 
#include "t_access.h"

extern TBL_Return T_Return;
extern char string[];
 

/*+---------------------------------------------------------------------+*/
/*! do_DbvAccessControlRequest() 					!*/
/*+---------------------------------------------------------------------+*/
int do_DbvAccessControlRequest(TestType eTestType)
   {
   char InFilename[ SZ_FILENAME ];
   char OutFilename[ SZ_FILENAME ];
   char pcResult[STRING_LEN];
   TBL InTable, OutTable, LocalTable;
 
   int intfield;
   int out_record = 1;
   int return_value = SI_OK;
   char *stringfield;
 
   DbvAssocId 		  lAssocId;
   DbvAccessControlReq 	  *psAccessControlReq;

   DbvError		  *psError;
 


   return_value = open_tables("accessreq", eTestType, 
			InFilename, OutFilename, &InTable, &OutTable);
   if(return_value == SI_NOTOK)
      return return_value;

   write_comment_field("\nResults of DbvAccessControlRequest\n", 
				OutTable, T_Return);
   TBL_GetRecord( InTable );
   do {
      psAccessControlReq = (DbvAccessControlReq *)DbvAlloc( sizeof(DbvAccessControlReq) );

      /* Assoc Id */
      intfield = get_int_field( InTable,T_Return );
      lAssocId = get_int_field( InTable,T_Return );

      /* o ReferenceId */
      TBL_GetRecord( InTable );
      intfield = get_int_field( InTable, T_Return );
      get_DbvOctetString( &psAccessControlReq->psReferenceId, InTable );

      /* c SecurityChallengeReq */
      get_compulsory_DbvSecurityChallengeReq( &psAccessControlReq->sSecurityChallengeReq, InTable );

      /* o OtherInformation */
      getN_DbvOtherInformation( &psAccessControlReq->ppsOtherInformation, InTable);

      bLocalResult = DBV_TRUE;
      if(open_result_table("o", &LocalTable, pcResult)==SI_OK)
      {
              write_DbvAccessControlRequest(psAccessControlReq, LocalTable);
              TBL_Destruct(LocalTable);
      }
      bLocalResult = DBV_FALSE;

      printf( "Press enter to execute AccessControlReq\n" );
      fflush( stdin );
      get_return();
 
      return_value = DbvAccessControlRequest(lAssocId, psAccessControlReq, &psError);
 
      if(return_value == SI_OK)
         {
         printf("AccessControlReq Ok\n");
         printf("Writing output to %s\n", OutFilename);
         write_int_field(out_record++, OutTable, T_Return);
         write_string_field("IN_PARAM", OutTable, T_Return);
         TBL_PutRecord(OutTable);
         write_int_field(out_record++, OutTable, T_Return);
         write_string_field("IN_PARAM", OutTable, T_Return);
         TBL_PutRecord(OutTable);
         write_int_field(out_record++, OutTable, T_Return);
         write_string_field("NULL", OutTable, T_Return);
         TBL_PutRecord(OutTable);
         } /* End if */
      else
         {
         printf( "Call failed\n" );
         write_DbvError(&psError, OutTable);
         }
      Free_DbvAccessControlReq(psAccessControlReq);
      TBL_GetRecord(InTable);
      out_record = 1;
      } while( TBL_GetRecord( InTable ) != FALSE );

   TBL_Destruct( InTable );
   TBL_Destruct( OutTable );

   /* Free : Special Function required : Must free all attached space */

/*   DbvFree_DbvAccessControlReq( psAccessControlReq );	*/

   return return_value;
   } /* End do_DbvAccessControlRequest() */


