/*  Module Name: @(#)t_ext.c	7.1
    Version: 11/15/96
    Author: Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to write results/read arguments from target ExtendedServices
        Req/Resp specific tbl files. For use with the testtool.

 
*/
 
#include "t_ext.h"

extern TBL_Return T_Return;
extern char string[];

int do_DbvExtendedServicesResponse(TestType eTestType)
{
        char InFilename[STRING_LEN];
        char OutFilename[STRING_LEN];
        char pcResult[STRING_LEN];
        TBL InTable, OutTable, LocalTable;
        int place = 0;
	int NumberOfDiagnostics; 
	int loop;
        int intfield;
        int out_record = 1;
        int return_value = SI_OK;
	DbvExtServicesOperationStatus eOperationStatus;
	char *pcDbvExtServicesOperationStatus;
        char *stringfield;
        char *version;
        char *options;
 
        DbvAssocId         lAssocId;
        DbvExtendedServicesRsp   *psExtendedServicesRsp;
        DbvError         *psSIError;
 
        return_value = open_tables("extresp", eTestType, InFilename, OutFilename, &InTable, &OutTable);
        if(return_value == SI_NOTOK)
                return return_value;
        write_comment_field("\nResults of DbvExtendedServicesResponse\n", OutTable, T_Return);
        TBL_GetRecord(InTable);
        do {
        psExtendedServicesRsp = (DbvExtendedServicesRsp *)DbvAlloc(sizeof(DbvExtendedServicesRsp));
/* Assoc Id */
        intfield=get_int_field(InTable,T_Return);
        lAssocId=intfield=get_int_field(InTable,T_Return);
        TBL_GetRecord(InTable);
        intfield=get_int_field(InTable,T_Return);
/* ReferenceId */
    get_DbvOctetString(&(psExtendedServicesRsp->psReferenceId), InTable);

/* eOperationStatus */
	TBL_GetRecord(InTable);
 	stringfield= get_char_field(InTable, T_Return);
        DbvFree(stringfield);
        pcDbvExtServicesOperationStatus = get_string_field(InTable, T_Return);
        convert_DbvExtServicesOperationStatus(&pcDbvExtServicesOperationStatus,&eOperationStatus);
        psExtendedServicesRsp->eOperationStatus=eOperationStatus;
	DbvFree(pcDbvExtServicesOperationStatus);

/* NumberOfDiagnostics */
	TBL_GetRecord(InTable);	
        stringfield= get_char_field(InTable, T_Return);
	DbvFree(stringfield);	 
	NumberOfDiagnostics=intfield=get_int_field(InTable,T_Return);

/* Diagnostics */
	if(intfield > 0)
	{
		psExtendedServicesRsp->ppsDiagnostics=(DbvDiagRec **)DbvAlloc((intfield+1) * sizeof(DbvDiagRec *));
		for(loop = 0; loop < intfield; loop ++)
		{
			psExtendedServicesRsp->ppsDiagnostics[loop]=(DbvDiagRec *)DbvAlloc(sizeof(DbvDiagRec));
			get_DbvDiagRec(&psExtendedServicesRsp->ppsDiagnostics[loop],InTable);	
		}
	}

/* TaskPackage */
	get_DbvASN1External(&(psExtendedServicesRsp->psTaskPackage), InTable);


/* OtherInformation */
	getN_DbvOtherInformation(&(psExtendedServicesRsp->ppsOtherInformation), 
		InTable);

        bLocalResult = DBV_TRUE;
        if(open_result_table("o", &LocalTable, pcResult)==SI_OK)
        {
                write_DbvExtendedServicesResponse(psExtendedServicesRsp, 
			LocalTable);
                TBL_Destruct(LocalTable);
        }
        bLocalResult = DBV_FALSE;

        printf("Press enter to execute ExtendedServicesRsp\n");
        fflush(stdin);
        get_return();
 
        return_value = DbvExtendedServicesResponse(lAssocId, psExtendedServicesRsp, &psSIError);
 
        if(return_value == SI_OK)
        {
                printf("ExtendedServicesResponse Ok\n");
                printf("Writing output to %s\n", OutFilename);
                write_int_field(out_record++, OutTable, T_Return);
                write_string_field("IN_PARAM", OutTable, T_Return);
                TBL_PutRecord(OutTable);
                write_int_field(out_record++, OutTable, T_Return);
                write_string_field("IN_PARAM", OutTable, T_Return);
                TBL_PutRecord(OutTable);
                write_int_field(out_record++, OutTable, T_Return);
                write_string_field("NULL", OutTable, T_Return);
                TBL_PutRecord(OutTable);
        }
        else
        {
                printf("Call failed\n");
                write_DbvError(&psSIError, OutTable);
        }
	Free_DbvExtendedServicesRsp(psExtendedServicesRsp);
        TBL_GetRecord(InTable);
        out_record = 1; place = 0;
        }
        while(TBL_GetRecord(InTable)!=FALSE);

        TBL_Destruct(InTable);
        TBL_Destruct(OutTable);
 
        return return_value;
}

void write_DbvExtendedServicesRequest(DbvExtendedServicesReq *psExtendedServicesReq,TBL OutTable)
{
	int loop;
        char temp[STRING_LEN];
	DbvExtServicesFunctions eFunction;
	char *pcDbvExtServicesFunctions; 
	DbvExtServicesWaitAction eWaitAction;
	char *pcDbvExtServicesWaitAction;  

        if( bLocalResult == DBV_TRUE)
                write_comment_field("Completed structure DbvExtendedServicesRequest", OutTable, T_Return);
        else
        {
       		write_comment_field("DbvExtendedServicesRequest received from Origin", OutTable, T_Return);
        	write_comment_field("Structure detailed - DbvTargetData.uTargetEvent->psExtendedServicesReq:", OutTable, T_Return);
	}
/* ReferenceId is an optional field */
        write_DbvOctetString("psReferenceId", psExtendedServicesReq->psReferenceId,
                OutTable);
/* Function */
        pcDbvExtServicesFunctions= NULL;
        convert_DbvExtServicesFunctions(&pcDbvExtServicesFunctions,&(psExtendedServicesReq->eFunction));
	write_title_char(pcDbvExtServicesFunctions, "eFunction", OutTable);
	DbvFree(pcDbvExtServicesFunctions);
	TBL_PutRecord(OutTable);

/* PackageType */
	write_title_char(psExtendedServicesReq->pcPackageType, "pcPackageType", OutTable);
	TBL_PutRecord(OutTable);

/* PackageName */
	write_DbvInternationalString("psPackageName", psExtendedServicesReq->psPackageName, OutTable);

/* UserId */
	write_DbvInternationalString("psUserId", psExtendedServicesReq->psUserId, OutTable);

/* RetentionTime */
	if(psExtendedServicesReq->psRetentionTime != NULL)
	{
	write_DbvIntUnit(psExtendedServicesReq->psRetentionTime, OutTable);
	}
	else
		write_title_char("NULL", "psRetentionTime", OutTable);

/* Permissions */
	if(psExtendedServicesReq->ppsPermissions != NULL)
	{
		loop=0;
		while(psExtendedServicesReq->ppsPermissions[loop] != NULL)
		{
			write_DbvPermissions(psExtendedServicesReq->ppsPermissions[loop], OutTable);
			loop++;
		}
	}
	else
		write_title_char("NULL", "ppsPermissions", OutTable); 

/* Description */
	write_DbvInternationalString("psDescription", psExtendedServicesReq->psDescription, OutTable);

/* OriginSpecificParameter ASN1External */
 
        write_comment_field("START of psOriginSpecificParameter", OutTable, T_Return);
        write_DbvASN1External(psExtendedServicesReq->psOriginSpecificParameter, OutTable);
        write_comment_field("END of psOriginSpecificParameter", OutTable, T_Return); 


/* WaitAction */
        pcDbvExtServicesWaitAction= NULL;
        convert_DbvExtServicesWaitAction(&pcDbvExtServicesWaitAction,&(psExtendedServicesReq->eWaitAction));
	write_title_char(pcDbvExtServicesWaitAction, "eWaitAction", OutTable);
	DbvFree(pcDbvExtServicesWaitAction);
	TBL_PutRecord(OutTable);

/* Elements */
	write_DbvInternationalString("psElements", psExtendedServicesReq->psElements, OutTable);

/* OtherInformation */
        writeN_DbvOtherInformation(psExtendedServicesReq->ppsOtherInformation, OutTable);

        write_comment_field(" End ", OutTable, T_Return);
        TBL_PutRecord(OutTable);
}


