/*  Module Name: @(#)t_pres.c	7.1
    Version: 11/15/96
    Author: Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to write results/read arguments from target Present
        Req/Resp specific tbl files. For use with the testtool.

 
*/
 
#include "t_pres.h"

extern TBL_Return T_Return;
extern char string[];

int do_DbvPresentResponse(TestType eTestType)
{
        char InFilename[STRING_LEN];
        char OutFilename[STRING_LEN];
        char pcResult[STRING_LEN];
        TBL InTable, OutTable, LocalTable;
        int place = 0;
 	int loop;
 	int  ulNumberOfRecordsReturned;
	int ulNextResultSetPosition;
        int intfield;
        int out_record = 1;
        int return_value = SI_OK;
        char *stringfield;
        char *version;
        char *options;
	char *pcDbvPresentStatus;
        DbvPresentStatus ePresentStatus;
        DbvAssocId         lAssocId;
        DbvPresentRsp   *psPresentRsp;
        DbvError         *psSIError;
 
        return_value = open_tables("presresp", eTestType, InFilename, OutFilename, &InTable, &OutTable);
        if(return_value == SI_NOTOK)
                return return_value;
        write_comment_field("\nResults of DbvPresentResponse\n", OutTable, T_Return);
        TBL_GetRecord(InTable);
        do {
        psPresentRsp = (DbvPresentRsp *)DbvAlloc(sizeof(DbvPresentRsp));
/* Assoc Id */
        intfield=get_int_field(InTable,T_Return);
        lAssocId=intfield=get_int_field(InTable,T_Return);
        TBL_GetRecord(InTable);
        intfield=get_int_field(InTable,T_Return);
/* ReferenceId */
        get_DbvOctetString(&(psPresentRsp->psReferenceId), InTable);


/* ulNumberOfRecordsReturned */
	TBL_GetRecord(InTable);
 	stringfield= get_char_field(InTable, T_Return);
        DbvFree(stringfield);
        psPresentRsp->ulNumberOfRecordsReturned=get_int_field(InTable,T_Return);
 

/* ulNextResultSetPosition */
	TBL_GetRecord(InTable);
 	stringfield= get_char_field(InTable, T_Return);
        DbvFree(stringfield);
        psPresentRsp->ulNextResultSetPosition=get_int_field(InTable,T_Return);
 

 /* ePresentStatus */
	TBL_GetRecord(InTable);
 	stringfield= get_char_field(InTable, T_Return);
        DbvFree(stringfield);
        pcDbvPresentStatus = get_string_field(InTable, T_Return);
        convert_DbvPresentStatus(&pcDbvPresentStatus,&ePresentStatus);
        psPresentRsp->ePresentStatus=ePresentStatus;
	DbvFree(pcDbvPresentStatus);

/* Records */
        TBL_GetRecord(InTable);
	/* Ignore the title */
	stringfield=get_char_field(InTable, T_Return); 
	DbvFree(stringfield);
        if((strcmp(stringfield=get_string_field(InTable, T_Return),NOTHING))!=0)
	{
	get_DbvRecords(&psPresentRsp->psRecords,InTable);	
        }
        DbvFree(stringfield);
/* OtherInformation */
	getN_DbvOtherInformation(&(psPresentRsp->ppsOtherInformation), InTable);

        bLocalResult = DBV_TRUE;
        if(open_result_table("o", &LocalTable, pcResult)==SI_OK)
        {
                write_DbvPresentResponse(psPresentRsp, LocalTable);
                TBL_Destruct(LocalTable);
        }
        bLocalResult = DBV_FALSE;

        printf("Press enter to execute PresentRsp\n");
        fflush(stdin);
        get_return();
 
        return_value = DbvPresentResponse(lAssocId, psPresentRsp, &psSIError);
 
        if(return_value == SI_OK)
        {
                printf("PresentResponse Ok\n");
                printf("Writing output to %s\n", OutFilename);
                write_int_field(out_record++, OutTable, T_Return);
                write_string_field("IN_PARAM", OutTable, T_Return);
                TBL_PutRecord(OutTable);
                write_int_field(out_record++, OutTable, T_Return);
                write_string_field("IN_PARAM", OutTable, T_Return);
                TBL_PutRecord(OutTable);
                write_int_field(out_record++, OutTable, T_Return);
                write_string_field("NULL", OutTable, T_Return);
                TBL_PutRecord(OutTable);
        }
        else
        {
                printf("Call failed\n");
                write_DbvError(&psSIError, OutTable);
        }
	Free_DbvPresentRsp(psPresentRsp);
        TBL_GetRecord(InTable);
        out_record = 1; place = 0;
        }
        while(TBL_GetRecord(InTable)!=FALSE);

        TBL_Destruct(InTable);
        TBL_Destruct(OutTable);
 
        return return_value;
}

void write_DbvPresentRequest(DbvPresentReq *psPresentReq, TBL OutTable)
{
        char temp[STRING_LEN];
	int loop;
	int ulNumberOfRecordsRequested;
	int ulResultSetStartPoint; 

        if( bLocalResult == DBV_TRUE)
                write_comment_field("Completed structure DbvPresentRequest",
                        OutTable, T_Return);
        else
        {
        	write_comment_field("DbvPresentRequest received from Origin", OutTable, T_Return);
        	write_comment_field("Structure detailed - DbvTargetData.uTargetEvent->psPresentReq:", OutTable, T_Return);
	}
	TBL_PutRecord(OutTable);
/* ReferenceId is an optional field */
        write_DbvOctetString("psReferenceId", psPresentReq->psReferenceId,OutTable);
	TBL_PutRecord(OutTable);
/* sResultSetId */
	write_DbvInternationalString("sResultSetId", &(psPresentReq->sResultSetId), OutTable);
	TBL_PutRecord(OutTable);

/* ulResultSetStartPoint */
	write_title_int( "ulResultSetStartPoint",(int *)&(psPresentReq->ulResultSetStartPoint), OutTable);
	TBL_PutRecord(OutTable);

/* ulNumberOfRecordsRequested */
	write_title_int( "ulNumberOfRecordsRequested",(int *)&(psPresentReq->ulNumberOfRecordsRequested), OutTable);
	TBL_PutRecord(OutTable);



/* AdditionalRanges */
	write_comment_field("START of ppsAdditionalRanges  list", OutTable,
		T_Return);
	if(psPresentReq->ppsAdditionalRanges != NULL)
	{
		loop=-1;
		do {
			loop++;
			write_DbvRange(psPresentReq->ppsAdditionalRanges[loop], 
				OutTable);
		}
		while(psPresentReq->ppsAdditionalRanges[loop] != NULL);
	}
	else
		write_title_char("NULL", "ppsAdditionalRanges", OutTable); 
	write_comment_field("END of ppsAdditionalRanges  list", OutTable,
		T_Return);
	TBL_PutRecord(OutTable);
/* RecordComposition */
	if(psPresentReq->psRecordComposition != NULL)
	{
	write_DbvRecordComposition(psPresentReq->psRecordComposition, OutTable);
	}
	else
	write_title_char("NULL", "psRecordComposition", OutTable); 
	TBL_PutRecord(OutTable);
/* PreferredRecordSyntax */
	write_title_char(psPresentReq->pcPreferredRecordSyntax, "pcPreferredRecordSyntax", OutTable);
	TBL_PutRecord(OutTable);

/* pulMaxSegmentCount */
        write_integer_string( "pulMaxSegmentCount", (int *)psPresentReq->pulMaxSegmentCount, 
	OutTable );
	TBL_PutRecord(OutTable);

/* pulMaxRecordSize */
        write_integer_string( "pulMaxRecordSize", (int *)psPresentReq->pulMaxRecordSize, 
	OutTable );
	TBL_PutRecord(OutTable);

/*  pulMaxSegmentSize */
        write_integer_string( "pulMaxSegmentSize", (int *)psPresentReq->pulMaxSegmentSize, 
	OutTable );
	TBL_PutRecord(OutTable);

/* OtherInformation */

   writeN_DbvOtherInformation(psPresentReq->ppsOtherInformation, OutTable);

       write_comment_field(" End ", OutTable, T_Return);
        TBL_PutRecord(OutTable);
}


