/*  Module Name: @(#)t_release.c	7.1
    Version: 11/15/96
    Author: Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to write results from received TA_ReleaseInd to
         specific tbl files. For use with the testtool.
 
 
*/
 
#include "t_release.h"
 
extern TBL_Return T_Return;
extern char string[];

void write_DbvReleaseRequest(DbvReleaseReq *peReleaseReq, TBL OutTable)
{
	char temp[STRING_LEN];

        write_comment_field("DbvReleaseRequest received from Origin", 
		OutTable, T_Return);
	write_comment_field("Structure detailed - DbvTargetData.uTargetEvent->peReleaseReq:", OutTable, T_Return);
        TBL_PutRecord(OutTable);

	switch(*peReleaseReq)
	{
	case ReleaseReq_Normal:
		sprintf(temp,"peReleaseReq: ReleaseReq_Normal");
		break;
	case ReleaseReq_Urgent:
		sprintf(temp,"peReleaseReq: ReleaseReq_Urgent");
		break;
	case ReleaseReq_Undefined:
		sprintf(temp,"peReleaseReq: ReleaseReq_Undefined");
		break;
	default:
		sprintf(temp,"peReleaseReq: TYPE UNKNOWN");
		break;
		
	}
        write_char_field(temp, OutTable, T_Return);
        TBL_PutRecord(OutTable);
        write_comment_field(" End ", OutTable, T_Return);
        TBL_PutRecord(OutTable);

}

