/*  Module Name: @(#)t_res.c	7.1
    Version: 11/15/96
    Author: Peter Watson
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to write results/read arguments from target ResourceReport
        Req/Resp specific tbl files. For use with the testtool.

 
*/
 
#include "t_res.h"

extern TBL_Return T_Return;
extern char string[];

int do_DbvResourceReportResponse(TestType eTestType)
{
        char InFilename[STRING_LEN];
        char OutFilename[STRING_LEN];
		char pcResult[STRING_LEN];
		TBL InTable, OutTable, LocalTable;
        int place = 0;
 
        int intfield;
        int out_record = 1;
        int return_value = SI_OK;
        char *stringfield;
        char *version;
        char *options;
	char *pcDbvResourceReportStatus;
        DbvResourceReportStatus eResourceReportStatus;
        DbvAssocId         lAssocId;
        DbvResourceReportRsp   *psResourceReportRsp;
        DbvError         *psSIError;
 
        return_value = open_tables("rescresp", eTestType, InFilename, OutFilename, &InTable, &OutTable);
        if(return_value == SI_NOTOK)
                return return_value;
        write_comment_field("\nResults of DbvResourceReportResponse\n", OutTable, T_Return);
        TBL_GetRecord(InTable);
        do {
        psResourceReportRsp = (DbvResourceReportRsp *)DbvAlloc(sizeof(DbvResourceReportRsp));
/* Assoc Id */
        intfield=get_int_field(InTable,T_Return);
        lAssocId=intfield=get_int_field(InTable,T_Return);
        TBL_GetRecord(InTable);
        intfield=get_int_field(InTable,T_Return);
/* ReferenceId */
	get_DbvOctetString(&(psResourceReportRsp->psReferenceId), InTable);
/* ResourceReportStatus */
	TBL_GetRecord(InTable);
 	stringfield= get_char_field(InTable, T_Return);
        DbvFree(stringfield);
        pcDbvResourceReportStatus = get_string_field(InTable, T_Return);
        convert_DbvResourceReportStatus(&pcDbvResourceReportStatus,&eResourceReportStatus);
        psResourceReportRsp->eResourceReportStatus=eResourceReportStatus;
	DbvFree(pcDbvResourceReportStatus);

/* ResourceReport External */
	get_DbvASN1External(&(psResourceReportRsp->psResourceReport), InTable);
	

/* OtherInformation */
	getN_DbvOtherInformation(&(psResourceReportRsp->ppsOtherInformation), InTable);

        bLocalResult = DBV_TRUE;
        if(open_result_table("o", &LocalTable, pcResult)==SI_OK)
        {
                write_DbvResourceReportResponse(psResourceReportRsp, 
			LocalTable);
                TBL_Destruct(LocalTable);
        }
        bLocalResult = DBV_FALSE;

        printf("Press enter to execute ResourceReportRsp\n");
        fflush(stdin);
        get_return();
 
        return_value = DbvResourceReportResponse(lAssocId, psResourceReportRsp, &psSIError);
 
        if(return_value == SI_OK)
        {
                printf("ResourceReportResponse Ok\n");
                printf("Writing output to %s\n", OutFilename);
                write_int_field(out_record++, OutTable, T_Return);
                write_string_field("IN_PARAM", OutTable, T_Return);
                TBL_PutRecord(OutTable);
                write_int_field(out_record++, OutTable, T_Return);
                write_string_field("IN_PARAM", OutTable, T_Return);
                TBL_PutRecord(OutTable);
                write_int_field(out_record++, OutTable, T_Return);
                write_string_field("NULL", OutTable, T_Return);
                TBL_PutRecord(OutTable);
        }
        else
        {
                printf("Call failed\n");
                write_DbvError(&psSIError, OutTable);
        }
	Free_DbvResourceReportRsp(psResourceReportRsp);
        TBL_GetRecord(InTable);
        out_record = 1; place = 0;
        }
        while(TBL_GetRecord(InTable)!=FALSE);

        TBL_Destruct(InTable);
        TBL_Destruct(OutTable);
 
        return return_value;
}

void write_DbvResourceReportRequest(DbvResourceReportReq *psResourceReportReq,TBL OutTable)
{
        char temp[STRING_LEN];
 
        if( bLocalResult == DBV_TRUE)
                write_comment_field("Completed structure DbvResourceReportRequest", OutTable, T_Return);
        else
        {
        	write_comment_field("DbvResourceReportRequest received from Origin", OutTable, T_Return);
        	write_comment_field("Structure detailed - DbvTargetData.uTargetEvent->psResourceReportReq:", OutTable, T_Return);
	}

/* ReferenceId is an optional field */
        write_DbvOctetString("psReferenceId", psResourceReportReq->psReferenceId,
                OutTable);
        TBL_PutRecord(OutTable);
/* OperationId */
        write_DbvOctetString("psOperationId", psResourceReportReq->psOperationId,OutTable);
        TBL_PutRecord(OutTable);
/* PrefResourceReportFormat */
	write_title_char(psResourceReportReq->pcPrefResourceReportFormat, "pcPrefResourceReportFormat", OutTable);
	TBL_PutRecord(OutTable);

/* Other Information */
        writeN_DbvOtherInformation(psResourceReportReq->ppsOtherInformation, OutTable);

        write_comment_field(" End ", OutTable, T_Return);
        TBL_PutRecord(OutTable);
}
