/*  Module Name: @(#)t_rescntrl.c	7.1
    Version: 11/15/96
    Author: John Hough
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to write results/read arguments from target Sort
        Req/Resp specific tbl files. For use with the testtool.

 
*/
 
#include "t_rescntrl.h"

extern TBL_Return T_Return;
extern char string[];
 

/*+---------------------------------------------------------------------+*/
/*! do_DbvResourceControlRequest() 					!*/
/*+---------------------------------------------------------------------+*/
int do_DbvResourceControlRequest(TestType eTestType)
   {
   char InFilename[ SZ_FILENAME ];
   char OutFilename[ SZ_FILENAME ];
   char pcResult[STRING_LEN];
   TBL InTable, OutTable, LocalTable;
 
   int intfield;
   int out_record = 1;
   int return_value = SI_OK;
   char *stringfield;
 
   DbvAssocId			lAssocId;
   DbvResourceControlReq	*psResourceControlReq;
   DbvBool			*pBool;
   DbvPartialResultsAvailable    ePartialResultsAvailable;
   DbvError			*psError;
 

   return_value = open_tables("rescntrlreq", eTestType, 
			InFilename, OutFilename, &InTable, &OutTable);
   if(return_value == SI_NOTOK)
      return return_value;

   write_comment_field("\nResults of DbvResourceControlRequest\n", 
				OutTable, T_Return);
   TBL_GetRecord( InTable );
   do {
      psResourceControlReq = (DbvResourceControlReq *)DbvAlloc( sizeof(DbvResourceControlReq) );

      /* Assoc Id */
      intfield = get_int_field( InTable,T_Return );
      lAssocId = get_int_field( InTable,T_Return );

      /* o ReferenceId */
      TBL_GetRecord( InTable );
      intfield = get_int_field( InTable, T_Return );
      get_DbvOctetString( &psResourceControlReq->psReferenceId, InTable );


      /* o SuspendedFlag */
      TBL_GetRecord( InTable );
      stringfield = get_char_field( InTable, T_Return );
      DbvFree(stringfield);
      stringfield = get_string_field( InTable, T_Return );
      if( (strcmp(stringfield, NOTHING)) != 0 )
      {
      pBool = (DbvBool*)DbvAlloc( sizeof( DbvBool ));
      *pBool = get_DbvBool( InTable );
      psResourceControlReq->pfSuspendedFlag = pBool;
      } /* End if */
      DbvFree(stringfield);


      /* o psResourceReport */
      TBL_GetRecord( InTable );
      stringfield = get_char_field( InTable, T_Return );
      DbvFree(stringfield);
      stringfield = get_string_field( InTable, T_Return );
      if( (strcmp(stringfield, NOTHING)) != 0 )
            get_DbvASN1External( &psResourceControlReq->psResourceReport,
                           InTable );
      DbvFree(stringfield);


      /* o PartialResultsAvailable */
      TBL_GetRecord( InTable );
      stringfield = get_char_field( InTable, T_Return );
      DbvFree(stringfield);

      stringfield = get_string_field( InTable, T_Return );
      if( (strcmp(stringfield, NOTHING)) != 0 )
	get_DbvPartialResultsAvailable( &psResourceControlReq->pePartialResultsAvailable, InTable );
      DbvFree(stringfield);


      /* c ResponseRequired */ 
      TBL_GetRecord( InTable );
      stringfield = get_char_field( InTable, T_Return );
      DbvFree(stringfield);
      psResourceControlReq->fResponseRequired = get_DbvBool( InTable );
   

      /* o TriggeredRequestFlag */
      TBL_GetRecord( InTable );
      stringfield = get_char_field( InTable, T_Return );
      DbvFree(stringfield);
      stringfield = get_string_field( InTable, T_Return );
      if( (strcmp(stringfield, NOTHING)) != 0 )
      {
      pBool = (DbvBool*)DbvAlloc( sizeof( DbvBool ));
      *pBool = get_DbvBool( InTable );
      psResourceControlReq->pfTriggeredRequestFlag = pBool;
      } /* End if */
      DbvFree(stringfield);


      /* o OtherInformation */
      getN_DbvOtherInformation( &psResourceControlReq->ppsOtherInformation, InTable);

      bLocalResult = DBV_TRUE;
      if(open_result_table("o", &LocalTable, pcResult)==SI_OK)
      {
              write_DbvResourceControlRequest(psResourceControlReq, LocalTable);
              TBL_Destruct(LocalTable);
      }
      bLocalResult = DBV_FALSE;

      printf( "Press enter to execute ResourceControlReq\n" );
      fflush( stdin );
      get_return();
 
      return_value = DbvResourceControlRequest(lAssocId, psResourceControlReq, &psError);
 
      if(return_value == SI_OK)
         {
         printf("ResourceControlReq Ok\n");
         printf("Writing output to %s\n", OutFilename);
         write_int_field(out_record++, OutTable, T_Return);
         write_string_field("IN_PARAM", OutTable, T_Return);
         TBL_PutRecord(OutTable);
         write_int_field(out_record++, OutTable, T_Return);
         write_string_field("IN_PARAM", OutTable, T_Return);
         TBL_PutRecord(OutTable);
         write_int_field(out_record++, OutTable, T_Return);
         write_string_field("NULL", OutTable, T_Return);
         TBL_PutRecord(OutTable);
         } /* End if */
      else
         {
         printf( "Call failed\n" );
         write_DbvError(&psError, OutTable);
         }
      Free_DbvResourceControlReq(psResourceControlReq);
      TBL_GetRecord(InTable);
      out_record = 1;
      } while( TBL_GetRecord( InTable ) != FALSE );

   TBL_Destruct( InTable );
   TBL_Destruct( OutTable );

   /* Free : Special Function required : Must free all attached space */

/*   DbvFree_DbvResourceControlReq( psResourceControlReq );	*/

   return return_value;
   } /* End do_DbvResourceControlRequest() */


