/*  Module Name: @(#)t_seg.c	7.1
    Version: 11/15/96
    Author: Peter Watson
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Function to read arguments from Target Segment
        Resp specific tbl files. For use with the testtool.
 
*/
 
#include "t_seg.h"

extern TBL_Return T_Return;
extern char string[];

int do_DbvSegmentRequest(TestType eTestType)
{
	char InFilename[STRING_LEN];
	char OutFilename[STRING_LEN];
	char pcResult[STRING_LEN];
	TBL InTable, OutTable, LocalTable;
	int place = 0;
	int  ulNumberOfSegmentRecords;
	int intfield;
	int out_record = 1;
	int return_value = SI_OK;
	char *stringfield;
	char *version;
	char *options;

	DbvAssocId         lAssocId;
	DbvSecs            lSeconds;
    	DbvSegmentReq  *psSegmentReq;
	DbvError           *psError=NULL;
	DbvNamePlusRecord	**ppsSegmentRecords=NULL;

	return_value = open_tables("segreq", eTestType, InFilename, 
		OutFilename, &InTable, &OutTable);
	if(return_value == SI_NOTOK)
		return return_value;
	write_comment_field("\nResults of SegmentRequest\n", OutTable, 
		T_Return);
	TBL_GetRecord(InTable);
	do {
	psSegmentReq = (DbvSegmentReq *) DbvAlloc (sizeof(DbvSegmentReq));
/* Assoc Id */
	intfield=get_int_field(InTable,T_Return);
	lAssocId=intfield=get_int_field(InTable,T_Return);
	TBL_GetRecord(InTable);
	intfield=get_int_field(InTable,T_Return);
/* ReferenceId */
        get_DbvOctetString(&(psSegmentReq->psReferenceId), InTable);
        TBL_GetRecord(InTable);
/* NumberOfRecordsReturned */
        stringfield= get_char_field(InTable, T_Return);
        DbvFree(stringfield);
        psSegmentReq->ulNumberOfRecordsReturned=get_int_field(InTable,T_Return);
/* NumberOfSegmentRecords */ 
        TBL_GetRecord(InTable);
        stringfield = get_char_field(InTable, T_Return);
        DbvFree(stringfield);
	intfield=get_int_field(InTable,T_Return);
/* SegmentRecords */
/* get_NamePlusRecord(int *records,DbvNamePlusRecord **ppsSegmentRecords, TBL Table) */
	ppsSegmentRecords = ( DbvNamePlusRecord **)DbvAlloc(
                        ( sizeof( DbvNamePlusRecord* ) * (intfield + 1) ));

	psSegmentReq->ppsSegmentRecords = ppsSegmentRecords;
	for ( ; intfield; intfield-- )
	{
        	get_DbvNamePlusRecord(ppsSegmentRecords, InTable);
		ppsSegmentRecords++;
	}
	*ppsSegmentRecords = NULL;
/* OtherInformation */
	getN_DbvOtherInformation(&(psSegmentReq->ppsOtherInformation), InTable);

        bLocalResult = DBV_TRUE;
        if(open_result_table("o", &LocalTable, pcResult)==SI_OK)
        {
                write_DbvSegmentRequest(psSegmentReq, LocalTable);
                TBL_Destruct(LocalTable);
        }
        bLocalResult = DBV_FALSE;

    	printf("Press enter to execute DbvSegmentRequest\n");
	fflush(stdin);
	get_return();

    	return_value = DbvSegmentRequest(lAssocId, psSegmentReq, &psError);

	if(return_value == SI_OK)
	{
        printf("SegmentRequest Ok\n");
		printf("Writing output to %s\n", OutFilename);
		write_int_field(out_record++, OutTable, T_Return);
		write_string_field("IN_PARAM", OutTable, T_Return);
		TBL_PutRecord(OutTable);
		write_int_field(out_record++, OutTable, T_Return);
		write_string_field("IN_PARAM", OutTable, T_Return);
		TBL_PutRecord(OutTable);
		write_int_field(out_record++, OutTable, T_Return);
		write_string_field("NULL", OutTable, T_Return);
		TBL_PutRecord(OutTable);
	}
	else
	{
		printf("Call failed\n");
		write_DbvError(&psError, OutTable);
	}
	Free_DbvSegmentReq(psSegmentReq);
	TBL_GetRecord(InTable);
	out_record = 1; place = 0;
	}
	while(TBL_GetRecord(InTable)!=FALSE);

	TBL_Destruct(InTable);
	TBL_Destruct(OutTable);

	return return_value;
}
