/*  Module Name: @(#)t_trigger.c	7.1
    Version: 11/15/96
    Author: John Hough
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to write results to target 
        trigger resource control Req specific tbl files. 
	For use with the testtool.

 
*/
 
#include "t_trigger.h"

extern TBL_Return T_Return;
extern char string[];


/*+---------------------------------------------------------------------+*/
/*! write_DbvTriggerResourceControlRequest()                            !*/
/*+---------------------------------------------------------------------+*/

void write_DbvTriggerResourceControlRequest( DbvTriggerResourceControlReq *psTriggerResourceControlReq, TBL OutTable)
   {
#ifdef DEBUG
   printf( "D - write_DbvTriggerResourceControlRequest()\n" );
#endif  

   /* Write the title out */
   if(psTriggerResourceControlReq == NULL)
      {
      write_title_char("NULL","DbvTriggerResourceControlReq", OutTable);
      TBL_PutRecord(OutTable);
      return;
      } /* End if */

   write_title_char("psTriggerResourceControlReq", "Structure", OutTable);
   TBL_PutRecord( OutTable );

   write_comment_field( "START of DbvTriggerResourceControlReq", OutTable, T_Return );

   /* psReferenceId */
   write_DbvOctetString( "psReferenceId", psTriggerResourceControlReq->psReferenceId, OutTable);

   /* eRequestedAction */
   write_DbvRequestedAction( "eRequestedAction", &psTriggerResourceControlReq->eRequestedAction, OutTable);

   /* pcPreferredResourceReportFormat */
   write_DbvObjectIdentifier( "pcPreferredResourceReportFormat", psTriggerResourceControlReq->pcPreferredResourceReportFormat, OutTable);

   /* pfResultSetWanted */
   if ( psTriggerResourceControlReq->pfResultSetWanted )
      write_DbvBool( "pfResultSetWanted", *psTriggerResourceControlReq->pfResultSetWanted, OutTable);
   else
      write_title_char("NULL","pfResultSetWanted", OutTable);
   TBL_PutRecord(OutTable);


   /* ppsOtherInformation */
   writeN_DbvOtherInformation( psTriggerResourceControlReq->ppsOtherInformation,OutTable );
  
   write_comment_field( "END of DbvTriggerResourceControlReq", OutTable, T_Return );
   TBL_PutRecord(OutTable);

   } /* End write_DbvTriggerResourceControlRequest() */



