
#ifndef TARGETBATCH_H
#define TARGETBATCH_H

#include "testy_calls.h"
#include "batch.h"

int batch_DoTargetBatchProcessing(void);
void batch_ParseTargetBatchFile(TBL psBatchTable);
void batch_ExecuteTargetBatchFile(void);

/* Target Functions */
int batch_ExecDbvTargetInitialize(char *pcFilename);
int batch_ExecDbvReceiveAssociateRequest(char *pcFilename);
int batch_ExecDbvAssociateResponse(char *pcFilename);
int batch_ExecDbvReleaseResponse(char *pcFilename);
int batch_ExecDbvInitializeResponse(char *pcFilename);
int batch_ExecDbvSearchResponse(char *pcFilename);
int batch_ExecDbvPresentResponse(char *pcFilename);
int batch_ExecDbvDeleteResultSetResponse(char *pcFilename);
int batch_ExecDbvScanResponse(char *pcFilename);
int batch_ExecDbvResourceReportResponse(char *pcFilename);
int batch_ExecDbvSortResponse(char *pcFilename);
int batch_ExecDbvSegmentationRequest(char *pcFilename);
int batch_ExecDbvExtendedServicesResponse(char *pcFilename);
int batch_ExecDbvReceiveDataTarget(char *pcFilename);
int batch_ExecDbvAccessControlRequest(char *pcFilename);
int batch_ExecDbvResourceControlRequest(char *pcFilename);



BatchFunctions psTargetFunctions[NO_TARGET_FUNCTIONS] = {
        { "DbvTargetInitialize",        batch_ExecDbvTargetInitialize },
        { "DbvReceiveAssociateRequest", batch_ExecDbvReceiveAssociateRequest },
        { "DbvAssociateResponse",       batch_ExecDbvAssociateResponse },
        { "DbvReleaseResponse",         batch_ExecDbvReleaseResponse },
        { "DbvAbortRequest",            batch_ExecDbvAbortRequest },
        { "DbvInitializeResponse",      batch_ExecDbvInitializeResponse },
        { "DbvSearchResponse",          batch_ExecDbvSearchResponse },
        { "DbvPresentResponse",         batch_ExecDbvPresentResponse },
        { "DbvDeleteResultSetResponse", batch_ExecDbvDeleteResultSetResponse },
        { "DbvScanResponse",            batch_ExecDbvScanResponse },
        { "DbvResourceReportResponse",  batch_ExecDbvResourceReportResponse },
        { "DbvSortResponse",            batch_ExecDbvSortResponse },
        { "DbvSegmentationRequest",     batch_ExecDbvSegmentationRequest },
        { "DbvExtendedServicesResponse",batch_ExecDbvExtendedServicesResponse },
        { "DbvCloseRequest",            batch_ExecDbvCloseRequest },
        { "DbvCloseResponse",           batch_ExecDbvCloseResponse },
        { "DbvReceiveDataTarget",       batch_ExecDbvReceiveDataTarget },
        { "DbvAccessControlRequest",    batch_ExecDbvAccessControlRequest },
        { "DbvResourceControlRequest",  batch_ExecDbvResourceControlRequest }
};

#endif
