/*  Module Name: @(#)writeN_DbvFuncs.c	7.2
    Version: 2/27/97
    Author: Dan Maskell/Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to write sequences of structure types to the result script 
	files.  Used by the origin and target.

    Modification History
    08-02-96  Dan Maskell Added Functions for ILL & Item order stuff
    26-03-96  Dan Maskell Added Functions for Generic Record
*/

#include "testy_calls.h"
extern TBL_Return T_Return;

void writeN_DbvEstimate2(DbvEstimate2 **ppsEstimate, TBL OutTable)
   {

   write_comment_field("START of DbvEstimate2 sequence", OutTable, T_Return);
   if( ppsEstimate != NULL)
      {
      while( ppsEstimate && *ppsEstimate )
         {
         write_DbvEstimate2( *ppsEstimate, OutTable );
         ppsEstimate++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "Estimate2", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvEstimate2 sequence", OutTable, T_Return );
     
   } /* End writeN_DbvEstimate2() */

void writeN_DbvIntUnit(DbvIntUnit **ppsIntUnit, TBL OutTable)
   {

   write_comment_field("START of DbvIntUnit sequence", OutTable, T_Return);
   if( ppsIntUnit != NULL)
      {
      while( ppsIntUnit && *ppsIntUnit )
         {
         write_DbvIntUnit( *ppsIntUnit, OutTable );
         ppsIntUnit++;
         } 
      } 
   else
      {
      write_title_char("NULL", "IntUnit", OutTable);
      TBL_PutRecord(OutTable);
      } 

   write_comment_field( "END of DbvIntUnit sequence", OutTable, T_Return );
     
   } 

void writeN_DbvPermAllowableFunctions(DbvPermAllowableFunctions
			**ppsPermAllowableFunctions, TBL OutTable)
   {

   write_comment_field("START of DbvPermAllowableFunctions sequence", 
				OutTable, T_Return);
   if( ppsPermAllowableFunctions != NULL)
      {
      while( ppsPermAllowableFunctions && *ppsPermAllowableFunctions )
         {
         write_DbvPermAllowableFunctions( *ppsPermAllowableFunctions, 
						OutTable );
         ppsPermAllowableFunctions++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "PermAllowableFunctions", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvPermAllowableFunctions sequence", 
							OutTable, T_Return );
     
   } /* End writeN_DbvPermAllowableFunctions() */

void writeN_DbvPermissions(DbvPermissions **ppsPermissions, TBL OutTable)
   {

   write_comment_field("START of DbvPermissions sequence", OutTable, T_Return);
   if( ppsPermissions != NULL)
      {
      while( ppsPermissions && *ppsPermissions )
         {
         write_DbvPermissions( *ppsPermissions, OutTable );
         ppsPermissions++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "Permissions", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvPermissions sequence", OutTable, T_Return );
     
   } /* End writeN_DbvPermissions() */

void writeN_DbvDiagRec(DbvDiagRec **ppsDiagRec, TBL OutTable)
   {

   write_comment_field("START of DbvDiagRec sequence", OutTable, T_Return);
   if( ppsDiagRec != NULL)
      {
      while( ppsDiagRec && *ppsDiagRec )
         {
         write_DbvDiagRec( *ppsDiagRec, OutTable );
         ppsDiagRec++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DiagRec", OutTable);
      TBL_PutRecord(OutTable);      } /* End else */

   write_comment_field( "END of DbvDiagRec sequence", OutTable, T_Return );
     
   } /* End writeN_DbvPermissions() */

void writeN_DbvOtherInformation(DbvOtherInformation **ppsOtherInformation, 
	TBL OutTable)
   {
 
   write_comment_field("START of DbvOtherInformation sequence", OutTable, T_Return);
   if( ppsOtherInformation != NULL)
      {
      while( ppsOtherInformation && *ppsOtherInformation )
         {
         write_DbvOtherInformation( *ppsOtherInformation, OutTable );
         ppsOtherInformation++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "OtherInformation", OutTable);
      TBL_PutRecord(OutTable);      } /* End else */
 
   write_comment_field( "END of DbvOtherInformation sequence", OutTable, T_Return );
 
   } /* End writeN_DbvPermissions() */

void writeN_DbvOccurrenceByAttributes(DbvOccurrenceByAttributes 
	**ppsOccurrenceByAttributes, TBL OutTable)
   {
 
   write_comment_field("START of DbvOccurrenceByAttributes sequence", OutTable, 
	T_Return);
   if( ppsOccurrenceByAttributes != NULL)
      {
      while( ppsOccurrenceByAttributes && *ppsOccurrenceByAttributes )
         {
         write_DbvOccurrenceByAttributes(*ppsOccurrenceByAttributes, OutTable );
         ppsOccurrenceByAttributes++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "OccurrenceByAttributes", OutTable);
      TBL_PutRecord(OutTable);      } /* End else */
 
   write_comment_field( "END of DbvOccurrenceByAttributes sequence", OutTable, 
	T_Return );
 
   } /* End writeN_DbvOccurrenceByAttributes() */

void writeN_DbvSuppliedRecord(DbvSuppliedRecord **ppsSuppliedRecord,
	TBL OutTable)
{
   write_comment_field("START of DbvSuppliedRecord sequence", OutTable,
        T_Return);
   if( ppsSuppliedRecord != NULL)
   {
	while( ppsSuppliedRecord && *ppsSuppliedRecord )
        {
        write_DbvSuppliedRecord(*ppsSuppliedRecord, OutTable );
        ppsSuppliedRecord++;
        } /* End while */

   }
   else
   {
	write_title_char("NULL", "DbvSuppliedRecord", OutTable);
	TBL_PutRecord(OutTable);
   }

   write_comment_field( "END of DbvSuppliedRecord sequence", OutTable,
        T_Return );
}

void writeN_DbvTaskPackageRecord(DbvTaskPackageRecord **ppsTaskPackageRecord,
        TBL OutTable)
{
   write_comment_field("START of DbvTaskPackageRecord sequence", OutTable,
        T_Return);
   if( ppsTaskPackageRecord != NULL)
   {
        while( ppsTaskPackageRecord && *ppsTaskPackageRecord )
        {
        write_DbvTaskPackageRecord(*ppsTaskPackageRecord, OutTable );
        ppsTaskPackageRecord++;
        } /* End while */
 
   }
   else
   {
        write_title_char("NULL", "DbvTaskPackageRecord", OutTable);
        TBL_PutRecord(OutTable);
   }
 
   write_comment_field( "END of DbvTaskPackageRecord sequence", OutTable,
        T_Return );
}


/* Functions beyond this point were added by Dan Maskell on 8-2-86 */


void writeN_DbvSystemId(DbvSystemId **ppsSystemId, TBL OutTable)
   {

   write_comment_field("START of DbvSystemId sequence", OutTable, T_Return);
   if( ppsSystemId != NULL)
      {
      while( ppsSystemId && *ppsSystemId )
         {
         write_DbvSystemId( *ppsSystemId, OutTable );
         ppsSystemId++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "SystemId", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvSystemId sequence", OutTable, T_Return );
     
   } /* End writeN_DbvSystemId() */


void writeN_DbvElectronicDeliveryService(
		DbvElectronicDeliveryService **ppsElectronicDeliveryService, 
		TBL OutTable)
   {

   write_comment_field("START of DbvElectronicDeliveryService sequence", 
			OutTable, T_Return);

   if( ppsElectronicDeliveryService != NULL)
      {
      while( ppsElectronicDeliveryService && *ppsElectronicDeliveryService )
         {
         write_DbvElectronicDeliveryService( *ppsElectronicDeliveryService, 
					     OutTable );
         ppsElectronicDeliveryService++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "ElectronicDeliveryService", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvElectronicDeliveryService sequence",
			OutTable, T_Return );
     
   } /* End writeN_DbvElectronicDeliveryService() */

void writeN_DbvSupplyMediumInfo(DbvSupplyMediumInfo **ppsSupplyMediumInfo, 
				TBL OutTable)

   {

   write_comment_field("START of DbvSupplyMediumInfo sequence",
			OutTable, T_Return);
   if( ppsSupplyMediumInfo != NULL)
      {
      while( ppsSupplyMediumInfo && *ppsSupplyMediumInfo )
         {
         write_DbvSupplyMediumInfo( *ppsSupplyMediumInfo, OutTable );
         ppsSupplyMediumInfo++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "SupplyMediumInfo", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvSupplyMediumInfo sequence",
			OutTable, T_Return );
     
   } /* End writeN_DbvSupplyMediumInfo() */


void writeN_DbvSendToList(DbvSendToList **ppsSendToList, TBL OutTable)
   {

   write_comment_field("START of DbvSendToList sequence", OutTable, T_Return);
   if( ppsSendToList != NULL)
      {
      while( ppsSendToList && *ppsSendToList )
         {
         write_DbvSendToList( *ppsSendToList, OutTable );
         ppsSendToList++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "SendToList", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvSendToList sequence", OutTable, T_Return );
     
   } /* End writeN_DbvSendToList() */


void writeN_DbvExtension(DbvExtension **ppsExtension, TBL OutTable)
   {

   write_comment_field("START of DbvExtension sequence", OutTable, T_Return);
   if( ppsExtension != NULL)
      {
      while( ppsExtension && *ppsExtension )
         {
         write_DbvExtension( *ppsExtension, OutTable );
         ppsExtension++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "Extension", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvExtension sequence", OutTable, T_Return );
     
   } /* End writeN_DbvExtension() */


void writeN_DbvServiceType(DbvServiceType **ppsServiceType, TBL OutTable)
   {

   write_comment_field("START of DbvServiceType sequence", OutTable, T_Return);
   if( ppsServiceType != NULL)
      {
      while( ppsServiceType && *ppsServiceType )
         {
         write_DbvServiceType( *ppsServiceType, OutTable );
         ppsServiceType++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "ServiceType", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvServiceType sequence", OutTable, T_Return );
     
   } /* End writeN_DbvServiceType() */


void writeN_DbvASN1External(DbvASN1External **ppsASN1External, TBL OutTable)
   {

   write_comment_field("START of DbvASN1External sequence", OutTable, T_Return);
   if( ppsASN1External != NULL)
      {
      while( ppsASN1External && *ppsASN1External )
         {
         write_DbvASN1External( *ppsASN1External, OutTable );
         ppsASN1External++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "ASN1External", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvASN1External sequence", OutTable, T_Return );
     
   } /* End writeN_DbvASN1External() */


/* Explain Record Support */


void writeN_DbvHumanString( char *name, 
			    DbvHumanString **ppsHumanString, 
			    TBL OutTable)
   {

   write_comment_field("START of DbvHumanString sequence", OutTable, T_Return);
   if( ppsHumanString != NULL)
      {
      write_char_field( name, OutTable, T_Return );
      TBL_PutRecord(OutTable);

      while( ppsHumanString && *ppsHumanString )
         {
         write_DbvHumanString( *ppsHumanString, OutTable );
         ppsHumanString++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvHumanString", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvHumanString sequence", OutTable, T_Return );
     
   } /* End writeN_DbvHumanString() */

void writeN_DbvIconObject( DbvIconObject **ppsIconObject, TBL OutTable)
   {

   write_comment_field("START of DbvIconObject sequence", OutTable, T_Return);
   if( ppsIconObject != NULL)
      {
      while( ppsIconObject && *ppsIconObject )
         {
         write_DbvIconObject( *ppsIconObject, OutTable );
         ppsIconObject++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvIconObject", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvIconObject sequence", OutTable, T_Return );
     
   } /* End writeN_DbvIconObject() */

void writeN_DbvDatabaseList(DbvDatabaseList **ppsDatabaseList, TBL OutTable)
   {

   write_comment_field("START of DbvDatabaseList sequence", OutTable, T_Return);
   if( ppsDatabaseList != NULL)
      {
      while( ppsDatabaseList && *ppsDatabaseList )
         {
         write_DbvDatabaseList( *ppsDatabaseList, OutTable );
         ppsDatabaseList++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvDatabaseList", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvDatabaseList sequence", OutTable, T_Return );
     
   } /* End writeN_DbvDatabaseList() */

void writeN_DbvOperators(DbvOperators **ppsOperators, TBL OutTable)
   {

   write_comment_field("START of DbvOperators sequence", OutTable, T_Return);
   if( ppsOperators != NULL)
      {
      while( ppsOperators && *ppsOperators )
         {
         write_DbvOperators( *ppsOperators, OutTable );
         ppsOperators++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvOperators", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvOperators sequence", OutTable, T_Return );
     
   } /* End writeN_DbvOperators() */


void writeN_DbvSearchKey(DbvSearchKey **ppsSearchKey, TBL OutTable)
   {

   write_comment_field("START of DbvSearchKey sequence", OutTable, T_Return);
   if( ppsSearchKey != NULL)
      {
      while( ppsSearchKey && *ppsSearchKey )
         {
         write_DbvSearchKey( *ppsSearchKey, OutTable );
         ppsSearchKey++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvSearchKey", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvSearchKey sequence", OutTable, T_Return );
     
   } /* End writeN_DbvSearchKey() */



void writeN_DbvHumanStringSeq(DbvHumanStringSeq **ppsDescription, TBL OutTable)
   {

   write_comment_field("START of DbvHumanStringSeq sequence", OutTable, T_Return);
   if( ppsDescription != NULL)
      {
      while( ppsDescription && *ppsDescription )
         {
         write_DbvHumanStringSeq( *ppsDescription, OutTable );
         ppsDescription++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvHumanStringSeq", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvHumanStringSeq sequence", OutTable, T_Return );
     
   } /* End writeN_DbvHumanStringSeq() */



void writeN_DbvUnitsSupported(DbvUnitsSupported **ppsUnitsSupported, 
			      TBL OutTable)
   {

   write_comment_field("START of DbvUnitsSupported sequence", 
			OutTable, T_Return);
   if( ppsUnitsSupported != NULL)
      {
      while( ppsUnitsSupported && *ppsUnitsSupported )
         {
         write_DbvUnitsSupported( *ppsUnitsSupported, OutTable );
         ppsUnitsSupported++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvUnitsSupported", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvUnitsSupported sequence", 
			OutTable, T_Return );
     
   } /* End writeN_DbvUnitsSupported() */

void writeN_Ulong( char *name, Ulong **ppsUlong, TBL OutTable)
   {

   write_comment_field("START of integer sequence", OutTable, T_Return);
   if( ppsUlong != NULL)
      {
      write_char_field( name, OutTable, T_Return );
      TBL_PutRecord(OutTable);

      while( ppsUlong && *ppsUlong )
         {
         write_integer_string( "Integer", (int*)*ppsUlong, OutTable );
	 TBL_PutRecord( OutTable );
         ppsUlong++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "integer", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of integer sequence", OutTable, T_Return );
     
   } /* End writeN_Ulong() */

void writeN_DbvQueryTypeDetails(DbvQueryTypeDetails **ppsQueryTypeDetails, 
				TBL OutTable)
   {

   write_comment_field("START of DbvQueryTypeDetails sequence", OutTable, 
			T_Return);
   if( ppsQueryTypeDetails != NULL)
      {
      while( ppsQueryTypeDetails && *ppsQueryTypeDetails )
         {
         write_DbvQueryTypeDetails( *ppsQueryTypeDetails, OutTable );
         ppsQueryTypeDetails++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvQueryTypeDetails", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvQueryTypeDetails sequence", OutTable, 
			T_Return );
     
   } /* End writeN_DbvQueryTypeDetails() */

void writeN_DbvObjectIdentifier( char *name, 
			    DbvObjectIdentifier *ppcObjectIdentifier, 
			    TBL OutTable)
   {

   write_comment_field("START of DbvObjectIdentifier sequence", OutTable, T_Return);
   if( ppcObjectIdentifier != NULL)
      {
      while( ppcObjectIdentifier && *ppcObjectIdentifier )
         {
         write_DbvObjectIdentifier( name, *ppcObjectIdentifier, OutTable );
         ppcObjectIdentifier++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvObjectIdentifier", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvObjectIdentifier sequence", 
			OutTable, T_Return );
     
   } /* End writeN_DbvObjectIdentifier() */

void writeN_DbvOtherCharge(DbvOtherCharge **ppsOtherCharge, TBL OutTable)
   {

   write_comment_field("START of DbvOtherCharge sequence", OutTable, T_Return);
   if( ppsOtherCharge != NULL)
      {
      while( ppsOtherCharge && *ppsOtherCharge )
         {
         write_DbvOtherCharge( *ppsOtherCharge, OutTable );
         ppsOtherCharge++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvOtherCharge", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvOtherCharge sequence", OutTable, T_Return );
     
   } /* End writeN_DbvOtherCharge() */

void writeN_DbvElementSetNames(
		DbvElementSetNames **ppsElementSetNames, 
		TBL OutTable)
   {

   write_comment_field("START of DbvElementSetNames sequence", 
						OutTable, T_Return);
   if( ppsElementSetNames != NULL)
      {
      while( ppsElementSetNames && *ppsElementSetNames )
         {
         write_DbvElementSetNames( *ppsElementSetNames, OutTable );
         ppsElementSetNames++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvElementSetNames", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvElementSetNames sequence", 
						OutTable, T_Return );
     
   } /* End writeN_DbvElementSetNames() */

void writeN_DbvAccessInfo( DbvAccessInfo **ppsAccessInfo, TBL OutTable)
   {

   write_comment_field("START of DbvAccessInfo sequence", OutTable, T_Return);
   if( ppsAccessInfo != NULL)
      {
      while( ppsAccessInfo && *ppsAccessInfo )
         {
         write_DbvAccessInfo( *ppsAccessInfo, OutTable );
         ppsAccessInfo++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvAccessInfo", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvAccessInfo sequence", OutTable, T_Return );
     
   } /* End writeN_DbvAccessInfo() */

void writeN_DbvTagTypeMapping(DbvTagTypeMapping **ppsTagTypeMapping, 
			      TBL OutTable)
   {

   write_comment_field("START of DbvTagTypeMapping sequence", 
			OutTable, T_Return);
   if( ppsTagTypeMapping != NULL)
      {
      while( ppsTagTypeMapping && *ppsTagTypeMapping )
         {
         write_DbvTagTypeMapping( *ppsTagTypeMapping, OutTable );
         ppsTagTypeMapping++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvTagTypeMapping", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvTagTypeMapping sequence", 
			OutTable, T_Return );
     
   } /* End writeN_DbvTagTypeMapping() */

void writeN_DbvPath(DbvPath **ppsPath, TBL OutTable)
   {

   write_comment_field("START of DbvPath sequence", OutTable, T_Return);
   if( ppsPath != NULL)
      {
      while( ppsPath && *ppsPath )
         {
         write_DbvPath( *ppsPath, OutTable );
         ppsPath++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvPath", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvPath sequence", OutTable, T_Return );
     
   } /* End writeN_DbvPath() */

void writeN_DbvPathA(DbvPathA **ppsPathA, TBL OutTable)
   {

   write_comment_field("START of DbvPathA sequence", OutTable, T_Return);
   if( ppsPathA != NULL)
      {
      while( ppsPathA && *ppsPathA )
         {
         write_DbvPathA( *ppsPathA, OutTable );
         ppsPathA++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvPathA", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvPathA sequence", OutTable, T_Return );
     
   } /* End writeN_DbvPathA() */

void writeN_DbvElementInfo(DbvElementInfo **ppsElementInfo, TBL OutTable)
   {

   write_comment_field("START of DbvElementInfo sequence", OutTable, T_Return);
   if( ppsElementInfo != NULL)
      {
      while( ppsElementInfo && *ppsElementInfo )
         {
         write_DbvElementInfo( *ppsElementInfo, OutTable );
         ppsElementInfo++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvElementInfo", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvElementInfo sequence", OutTable, T_Return );
     
   } /* End writeN_DbvElementInfo() */

void writeN_DbvElements(DbvElements **ppsElements, TBL OutTable)
   {

   write_comment_field("START of DbvElements sequence", OutTable, T_Return);
   if( ppsElements != NULL)
      {
      while( ppsElements && *ppsElements )
         {
         write_DbvElements( *ppsElements, OutTable );
         ppsElements++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvElements", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvElements sequence", OutTable, T_Return );
     
   } /* End writeN_DbvElements() */

void writeN_DbvAttributeDescription(
		DbvAttributeDescription **ppsAttributeDescription, 
		TBL OutTable)
   {

   write_comment_field("START of DbvAttributeDescription sequence", 
			OutTable, T_Return);
   if( ppsAttributeDescription != NULL)
      {
      while( ppsAttributeDescription && *ppsAttributeDescription )
         {
         write_DbvAttributeDescription( *ppsAttributeDescription, OutTable );
         ppsAttributeDescription++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvAttributeDescription", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvAttributeDescription sequence", 
			OutTable, T_Return );
     
   } /* End writeN_DbvAttributeDescription() */

void writeN_DbvAttributeType( DbvAttributeType **ppsAttributeType, 
		TBL OutTable)
   {

   write_comment_field("START of DbvAttributeType sequence", 
			OutTable, T_Return);
   if( ppsAttributeType != NULL)
      {
      while( ppsAttributeType && *ppsAttributeType )
         {
         write_DbvAttributeType( *ppsAttributeType, OutTable );
         ppsAttributeType++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvAttributeType", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvAttributeType sequence", 
			OutTable, T_Return );
     
   } /* End writeN_DbvAttributeType() */

void writeN_DbvTermList(DbvTermList **ppsTermList, TBL OutTable)
   {

   write_comment_field("START of DbvTermList sequence", OutTable, T_Return);
   if( ppsTermList != NULL)
      {
      while( ppsTermList && *ppsTermList )
         {
         write_DbvTermList( *ppsTermList, OutTable );
         ppsTermList++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvTermList", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvTermList sequence", OutTable, T_Return );
     
   } /* End writeN_DbvTermList() */

void writeN_DbvAttributeValues(DbvAttributeValues **ppsAttributeValues, 
				TBL OutTable)
   {

   write_comment_field("START of DbvAttributeValues sequence", 
			OutTable, T_Return);
   if( ppsAttributeValues != NULL)
      {
      while( ppsAttributeValues && *ppsAttributeValues )
         {
         write_DbvAttributeValues( *ppsAttributeValues, OutTable );
         ppsAttributeValues++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvAttributeValues", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvAttributeValues sequence", 
			OutTable, T_Return );
     
   } /* End writeN_DbvAttributeValues() */

void writeN_DbvAttributesByType(DbvAttributesByType **ppsAttributesByType, 
				TBL OutTable)
   {

   write_comment_field("START of DbvAttributesByType sequence", 
			OutTable, T_Return);
   if( ppsAttributesByType != NULL)
      {
      while( ppsAttributesByType && *ppsAttributesByType )
         {
         write_DbvAttributesByType( *ppsAttributesByType, OutTable );
         ppsAttributesByType++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvAttributesByType", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvAttributesByType sequence", 
			OutTable, T_Return );
     
   } /* End writeN_DbvAttributesByType() */

void writeN_DbvAttributesBySet( DbvAttributesBySet **ppsAttributesBySet, 
		TBL OutTable)
   {

   write_comment_field("START of DbvAttributesBySet sequence", 
						OutTable, T_Return);
   if( ppsAttributesBySet != NULL)
      {
      while( ppsAttributesBySet && *ppsAttributesBySet )
         {
         write_DbvAttributesBySet( *ppsAttributesBySet, OutTable );
         ppsAttributesBySet++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvAttributesBySet", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvAttributesBySet sequence", 
						OutTable, T_Return );
     
   } /* End writeN_DbvAttributesBySet() */

void writeN_DbvAttributeOccurrence(
		DbvAttributeOccurrence **ppsAttributeOccurrence, TBL OutTable)
   {

   write_comment_field("START of DbvAttributeOccurrence sequence", 
							OutTable, T_Return);
   if( ppsAttributeOccurrence != NULL)
      {
      while( ppsAttributeOccurrence && *ppsAttributeOccurrence )
         {
         write_DbvAttributeOccurrence( *ppsAttributeOccurrence, OutTable );
         ppsAttributeOccurrence++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvAttributeOccurrence", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvAttributeOccurrence sequence",
							OutTable, T_Return );
     
   } /* End writeN_DbvAttributeOccurrence() */

void writeN_DbvAttributeCombinations(
			DbvAttributeCombinations **ppsAttributeCombinations, 
			TBL OutTable)
   {

   write_comment_field("START of DbvAttributeCombinations sequence", 
			OutTable, T_Return);
   if( ppsAttributeCombinations != NULL)
      {
      while( ppsAttributeCombinations && *ppsAttributeCombinations )
         {
         write_DbvAttributeCombinations( *ppsAttributeCombinations, OutTable );
         ppsAttributeCombinations++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvAttributeCombinations", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvAttributeCombinations sequence", 
			OutTable, T_Return );
     
   } /* End writeN_DbvAttributeCombinations() */

void writeN_DbvTerm( DbvTerm **ppsTerm, TBL OutTable)
   {

   write_comment_field("START of DbvTerm sequence", OutTable, T_Return);
   if( ppsTerm != NULL)
      {
      while( ppsTerm && *ppsTerm )
         {
         write_DbvTerm( *ppsTerm, OutTable );
         ppsTerm++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvTerm", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvTerm sequence", OutTable, T_Return );
     
   } /* End writeN_DbvTerm() */

void writeN_DbvDetailsPerElement( 
		DbvDetailsPerElement **ppsDetailsPerElement, 
		TBL OutTable)
   {

   write_comment_field("START of DbvDetailsPerElement sequence", 
						OutTable, T_Return);
   if( ppsDetailsPerElement != NULL)
      {
      while( ppsDetailsPerElement && *ppsDetailsPerElement )
         {
         write_DbvDetailsPerElement( *ppsDetailsPerElement, OutTable );
         ppsDetailsPerElement++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvDetailsPerElement", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvDetailsPerElement sequence",
						OutTable, T_Return );
     
   } /* End writeN_DbvDetailsPerElement() */

void writeN_DbvSortKeys( DbvSortKeys **ppsSortKeys, TBL OutTable)
   {

   write_comment_field("START of DbvSortKeys sequence", OutTable, T_Return);
   if( ppsSortKeys != NULL)
      {
      while( ppsSortKeys && *ppsSortKeys )
         {
         write_DbvSortKeys( *ppsSortKeys, OutTable );
         ppsSortKeys++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvSortKeys", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvSortKeys sequence", OutTable, T_Return );
     
   } /* End writeN_DbvSortKeys() */



void writeN_DbvValueDescription(DbvValueDescription **ppsValueDescription, 
				TBL OutTable)
   {

   write_comment_field("START of DbvValueDescription sequence", 
						OutTable, T_Return);
   if( ppsValueDescription != NULL)
      {
      while( ppsValueDescription && *ppsValueDescription )
         {
         write_DbvValueDescription( *ppsValueDescription, OutTable );
         ppsValueDescription++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvValueDescription", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvValueDescription sequence", 
						OutTable, T_Return );
     
   } /* End writeN_DbvValueDescription() */

void writeN_DbvVariantTypes( DbvVariantTypes **ppsVariantTypes, TBL OutTable)
   {

   write_comment_field("START of DbvVariantTypes sequence", OutTable, T_Return);
   if( ppsVariantTypes != NULL)
      {
      while( ppsVariantTypes && *ppsVariantTypes )
         {
         write_DbvVariantTypes( *ppsVariantTypes, OutTable );
         ppsVariantTypes++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvVariantTypes", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvVariantTypes sequence", OutTable, T_Return );
     
   } /* End writeN_DbvVariantTypes() */

void writeN_DbvVariantClass( DbvVariantClass **ppsVariantClass, TBL OutTable)
   {

   write_comment_field("START of DbvVariantClass sequence", OutTable, T_Return);
   if( ppsVariantClass != NULL)
      {
      while( ppsVariantClass && *ppsVariantClass )
         {
         write_DbvVariantClass( *ppsVariantClass, OutTable );
         ppsVariantClass++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvVariantClass", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvVariantClass sequence", OutTable, T_Return );
     
   } /* End writeN_DbvVariantClass() */

void writeN_DbvUnits( DbvUnits **ppsUnits, TBL OutTable)
   {

   write_comment_field("START of DbvUnits sequence", OutTable, T_Return);
   if( ppsUnits != NULL)
      {
      while( ppsUnits && *ppsUnits )
         {
         write_DbvUnits( *ppsUnits, OutTable );
         ppsUnits++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvUnits", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvUnits sequence", OutTable, T_Return );
     
   } /* End writeN_DbvUnits() */

void writeN_DbvUnitType(DbvUnitType **ppsUnitType, TBL OutTable)
   {

   write_comment_field("START of DbvUnitType sequence", OutTable, T_Return);
   if( ppsUnitType != NULL)
      {
      while( ppsUnitType && *ppsUnitType )
         {
         write_DbvUnitType( *ppsUnitType, OutTable );
         ppsUnitType++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvUnitType", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvUnitType sequence", OutTable, T_Return );
     
   } /* End writeN_DbvUnitType() */
void writeN_DbvUnit( DbvUnit **ppsUnit, TBL OutTable)
   {

   write_comment_field("START of DbvUnit sequence", OutTable, T_Return);
   if( ppsUnit != NULL)
      {
      while( ppsUnit && *ppsUnit )
         {
         write_DbvUnit( *ppsUnit, OutTable );
         ppsUnit++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvUnit", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvUnit sequence", OutTable, T_Return );
     
   } /* End writeN_DbvUnit() */

void writeN_DbvCategoryInfo( DbvCategoryInfo **ppsCategoryInfo, TBL OutTable)
   {

   write_comment_field("START of DbvCategoryInfo sequence", OutTable, T_Return);
   if( ppsCategoryInfo != NULL)
      {
      while( ppsCategoryInfo && *ppsCategoryInfo )
         {
         write_DbvCategoryInfo( *ppsCategoryInfo, OutTable );
         ppsCategoryInfo++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvCategoryInfo", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvCategoryInfo sequence", OutTable, T_Return );
     
   } /* End writeN_DbvCategoryInfo() */

void writeN_DbvStringOrNumeric( DbvStringOrNumeric **ppsStringOrNumeric, 
				TBL OutTable)
   {

   write_comment_field("START of DbvStringOrNumeric sequence", 
					OutTable, T_Return);
   if( ppsStringOrNumeric != NULL)
      {
      while( ppsStringOrNumeric && *ppsStringOrNumeric )
         {
         write_DbvStringOrNumeric( *ppsStringOrNumeric, OutTable );
         ppsStringOrNumeric++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvStringOrNumeric", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvStringOrNumeric sequence", 
						OutTable, T_Return );
     
   } /* End writeN_DbvStringOrNumeric() */

void writeN_DbvSpecification( DbvSpecification **ppsSpecification, TBL OutTable)
   {

   write_comment_field("START of DbvSpecification sequence", 
					OutTable, T_Return);
   if( ppsSpecification != NULL)
      {
      while( ppsSpecification && *ppsSpecification )
         {
         write_DbvSpecification( *ppsSpecification, OutTable );
         ppsSpecification++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvSpecification", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvSpecification sequence", 
						OutTable, T_Return );
     
   } /* End writeN_DbvSpecification() */

void writeN_DbvAccessRestrictions(
		DbvAccessRestrictions **ppsAccessRestrictions, TBL OutTable)
   {

   write_comment_field("START of DbvAccessRestrictions sequence", OutTable, T_Return);
   if( ppsAccessRestrictions != NULL)
      {
      while( ppsAccessRestrictions && *ppsAccessRestrictions )
         {
         write_DbvAccessRestrictions( *ppsAccessRestrictions, OutTable );
         ppsAccessRestrictions++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvAccessRestrictions", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvAccessRestrictions sequence", OutTable, T_Return );
     
   } /* End writeN_DbvAccessRestrictions() */

void writeN_DbvNetworkAddress(DbvNetworkAddress **ppsNetworkAddress,
			TBL OutTable)
   {

   write_comment_field("START of DbvNetworkAddress sequence", 
							OutTable, T_Return);
   if( ppsNetworkAddress != NULL)
      {
      while( ppsNetworkAddress && *ppsNetworkAddress )
         {
         write_DbvNetworkAddress( *ppsNetworkAddress, OutTable );
         ppsNetworkAddress++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvNetworkAddress", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvNetworkAddress sequence", 
							OutTable, T_Return );
     
   } /* End writeN_DbvNetworkAddress() */

void writeN_DbvInternationalString( char *name, DbvInternationalString 
				**ppsInternationalString, TBL OutTable)
   {

   write_comment_field("START of DbvInternationalString sequence", 
							OutTable, T_Return);
   if( ppsInternationalString != NULL)
      {
      while( ppsInternationalString && *ppsInternationalString )
         {
         write_DbvInternationalString( name,*ppsInternationalString, OutTable );
         ppsInternationalString++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvInternationalString", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvInternationalString sequence", 
							OutTable, T_Return );
     
   } /* End writeN_DbvInternationalString() */


#ifdef NOT_YET_IMPLEMENTED

/* Generic Record Support */

void writeN_DbvValue(DbvValue **ppsValue, TBL OutTable)
   {

   write_comment_field("START of DbvValue sequence", OutTable, T_Return);
   if( ppsValue != NULL)
      {
      while( ppsValue && *ppsValue )
         {
         write_DbvValue( *ppsValue, OutTable );
         ppsValue++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvValue", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvValue sequence", OutTable, T_Return );
     
   } /* End writeN_DbvValue() */

void writeN_DbvTriples(DbvTriples **ppsTriples, TBL OutTable)
   {

   write_comment_field("START of DbvTriples sequence", OutTable, T_Return);
   if( ppsTriples != NULL)
      {
      while( ppsTriples && *ppsTriples )
         {
         write_DbvTriples( *ppsTriples, OutTable );
         ppsTriples++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvTriples", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvTriples sequence", OutTable, T_Return );
     
   } /* End writeN_DbvTriples() */

void writeN_DbvTagPath(DbvTagPath **ppsTagPath, TBL OutTable)
   {

   write_comment_field("START of DbvTagPath sequence", OutTable, T_Return);
   if( ppsTagPath != NULL)
      {
      while( ppsTagPath && *ppsTagPath )
         {
         write_DbvTagPath( *ppsTagPath, OutTable );
         ppsTagPath++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvTagPath", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvTagPath sequence", OutTable, T_Return );
     
   } /* End writeN_DbvTagPath() */

void writeN_DbvTaggedElement(DbvTaggedElement **ppsTaggedElement, 
			TBL OutTable)
   {

   write_comment_field("START of DbvTaggedElement sequence", 
							OutTable, T_Return);
   if( ppsTaggedElement != NULL)
      {
      while( ppsTaggedElement && *ppsTaggedElement )
         {
         write_DbvTaggedElement( *ppsTaggedElement, OutTable );
         ppsTaggedElement++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvTaggedElement", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvTaggedElement sequence", 
							OutTable, T_Return );
     
   } /* End writeN_DbvTaggedElement() */

void writeN_DbvHits(DbvHits **ppsHits, TBL OutTable)
   {

   write_comment_field("START of DbvHits sequence", OutTable, T_Return);
   if( ppsHits != NULL)
      {
      while( ppsHits && *ppsHits )
         {
         write_DbvHits( *ppsHits, OutTable );
         ppsHits++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvHits", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvHits sequence", OutTable, T_Return );
     
   } /* End writeN_DbvHits() */

void writeN_DbvVariant(DbvVariant **ppsVariant, TBL OutTable)
   {

   write_comment_field("START of DbvVariant sequence", OutTable, T_Return);
   if( ppsVariant != NULL)
      {
      while( ppsVariant && *ppsVariant )
         {
         write_DbvVariant( *ppsVariant, OutTable );
         ppsVariant++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvVariant", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvVariant sequence", OutTable, T_Return );
     
   } /* End writeN_DbvVariant() */


#endif


void writeN_DbvAttributeCombination(
		DbvAttributeCombination **ppsAttributeCombination, 
		TBL OutTable)
   {

   write_comment_field("START of DbvAttributeCombination sequence",
							OutTable, T_Return);
   if( ppsAttributeCombination != NULL)
      {
      while( ppsAttributeCombination && *ppsAttributeCombination )
         {
         write_DbvAttributeCombination( *ppsAttributeCombination, OutTable );
         ppsAttributeCombination++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvAttributeCombination", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvAttributeCombination sequence", 
							OutTable, T_Return );
     
   } /* End writeN_DbvAttributeCombination() */

void writeN_DbvDataBaseInfoSeq(DbvDataBaseInfoSeq **ppsDataBaseInfoSeq, 
						TBL OutTable)
   {

   write_comment_field("START of DbvDataBaseInfoSeq sequence", 
							OutTable, T_Return);
   if( ppsDataBaseInfoSeq != NULL)
      {
      while( ppsDataBaseInfoSeq && *ppsDataBaseInfoSeq )
         {
         write_DbvDataBaseInfoSeq( *ppsDataBaseInfoSeq, OutTable );
         ppsDataBaseInfoSeq++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvDataBaseInfoSeq", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvDataBaseInfoSeq sequence", 
							OutTable, T_Return );
     
   } /* End writeN_DbvDataBaseInfoSeq() */





/* Access/Resource/TriggerResource  Control */


void writeN_DbvChallenge(DbvChallenge **ppsChallenge, TBL OutTable)
   {

   write_comment_field("START of DbvChallenge sequence", OutTable, T_Return);
   if( ppsChallenge != NULL)
      {
      while( ppsChallenge && *ppsChallenge )
         {
         write_DbvChallenge( *ppsChallenge, OutTable );
         ppsChallenge++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvChallenge", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvChallenge sequence", OutTable, T_Return );
   } /* End writeN_DbvChallenge() */



void writeN_DbvResponse(DbvResponse **ppsResponse, TBL OutTable)
   {

   write_comment_field("START of DbvResponse sequence", OutTable, T_Return);
   if( ppsResponse != NULL)
      {
      while( ppsResponse && *ppsResponse )
         {
         write_DbvResponse( *ppsResponse, OutTable );
         ppsResponse++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvResponse", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvResponse sequence", OutTable, T_Return );
   } /* End writeN_DbvResponse() */



