/*  Module Name: @(#)
    Version: 10/4/96
    Author: Dan Maskell/strdgen
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to write sequences of structure types to the result script 
	files.  Used by the origin and target.

    Modification History
    25-01-97  Dan Maskell Created
*/

#include "testy_calls.h"
extern TBL_Return T_Return;
/*+-----------------------------------------------+*/
/*! writeN_DbvCharSetAndLanguage                  !*/ 
/*+-----------------------------------------------+*/
void writeN_DbvCharSetAndLanguage( char *name,
	  DbvCharSetAndLanguage **ppsDbvCharSetAndLanguage, TBL OutTable)
   {
 
   write_comment_field("START of DbvCharSetAndLanguage sequence", OutTable, T_Return);
  
   if( ppsDbvCharSetAndLanguage != NULL)
      {
      while( ppsDbvCharSetAndLanguage && *ppsDbvCharSetAndLanguage )
         {
         write_DbvCharSetAndLanguage( name, *ppsDbvCharSetAndLanguage, OutTable );
         ppsDbvCharSetAndLanguage++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvCharSetAndLanguage", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */
  
   write_comment_field( "END of DbvCharSetAndLanguage sequence", OutTable, T_Return );
     
   } /* End writeN_DbvCharSetAndLanguage() */
    
/*+-----------------------------------------------+*/
/*! writeN_DbvTargetResponse                      !*/ 
/*+-----------------------------------------------+*/
void writeN_DbvTargetResponse( char *name,
	  DbvTargetResponse **ppsDbvTargetResponse, TBL OutTable)
   {
 
   write_comment_field("START of DbvTargetResponse sequence", OutTable, T_Return);
  
   if( ppsDbvTargetResponse != NULL)
      {
      while( ppsDbvTargetResponse && *ppsDbvTargetResponse )
         {
         write_DbvTargetResponse( name, *ppsDbvTargetResponse, OutTable );
         ppsDbvTargetResponse++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvTargetResponse", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */
  
   write_comment_field( "END of DbvTargetResponse sequence", OutTable, T_Return );
     
   } /* End writeN_DbvTargetResponse() */
    
/*+-----------------------------------------------+*/
/*! writeN_DbvSelectedCharSet                     !*/ 
/*+-----------------------------------------------+*/
void writeN_DbvSelectedCharSet( char *name,
	  DbvSelectedCharSet **ppsDbvSelectedCharSet, TBL OutTable)
   {
 
   write_comment_field("START of DbvSelectedCharSet sequence", OutTable, T_Return);
  
   if( ppsDbvSelectedCharSet != NULL)
      {
      while( ppsDbvSelectedCharSet && *ppsDbvSelectedCharSet )
         {
         write_DbvSelectedCharSet( name, *ppsDbvSelectedCharSet, OutTable );
         ppsDbvSelectedCharSet++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvSelectedCharSet", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */
  
   write_comment_field( "END of DbvSelectedCharSet sequence", OutTable, T_Return );
     
   } /* End writeN_DbvSelectedCharSet() */
    
/*+-----------------------------------------------+*/
/*! writeN_DbvOriginProposal                      !*/ 
/*+-----------------------------------------------+*/
void writeN_DbvOriginProposal( char *name,
	  DbvOriginProposal **ppsDbvOriginProposal, TBL OutTable)
   {
 
   write_comment_field("START of DbvOriginProposal sequence", OutTable, T_Return);
  
   if( ppsDbvOriginProposal != NULL)
      {
      while( ppsDbvOriginProposal && *ppsDbvOriginProposal )
         {
         write_DbvOriginProposal( name, *ppsDbvOriginProposal, OutTable );
         ppsDbvOriginProposal++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvOriginProposal", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */
  
   write_comment_field( "END of DbvOriginProposal sequence", OutTable, T_Return );
     
   } /* End writeN_DbvOriginProposal() */
    
/*+-----------------------------------------------+*/
/*! writeN_DbvProposedCharSet                     !*/ 
/*+-----------------------------------------------+*/
void writeN_DbvProposedCharSet( char *name,
	  DbvProposedCharSet **ppsDbvProposedCharSet, TBL OutTable)
   {
 
   write_comment_field("START of DbvProposedCharSet sequence", OutTable, T_Return);
  
   if( ppsDbvProposedCharSet != NULL)
      {
      while( ppsDbvProposedCharSet && *ppsDbvProposedCharSet )
         {
         write_DbvProposedCharSet( name, *ppsDbvProposedCharSet, OutTable );
         ppsDbvProposedCharSet++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvProposedCharSet", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */
  
   write_comment_field( "END of DbvProposedCharSet sequence", OutTable, T_Return );
     
   } /* End writeN_DbvProposedCharSet() */
    
/*+-----------------------------------------------+*/
/*! writeN_DbvPrivateCharacterSet                 !*/ 
/*+-----------------------------------------------+*/
void writeN_DbvPrivateCharacterSet( char *name,
	  DbvPrivateCharacterSet **ppsDbvPrivateCharacterSet, TBL OutTable)
   {
 
   write_comment_field("START of DbvPrivateCharacterSet sequence", OutTable, T_Return);
  
   if( ppsDbvPrivateCharacterSet != NULL)
      {
      while( ppsDbvPrivateCharacterSet && *ppsDbvPrivateCharacterSet )
         {
         write_DbvPrivateCharacterSet( name, *ppsDbvPrivateCharacterSet, OutTable );
         ppsDbvPrivateCharacterSet++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvPrivateCharacterSet", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */
  
   write_comment_field( "END of DbvPrivateCharacterSet sequence", OutTable, T_Return );
     
   } /* End writeN_DbvPrivateCharacterSet() */
    
/*+-----------------------------------------------+*/
/*! writeN_DbvIso10646)                           !*/ 
/*+-----------------------------------------------+*/
void writeN_DbvIso10646( char *name,
	  DbvIso10646 **ppsDbvIso10646, TBL OutTable)
   {
 
   write_comment_field("START of DbvIso10646 sequence", OutTable, T_Return);
  
   if( ppsDbvIso10646 != NULL)
      {
      while( ppsDbvIso10646 && *ppsDbvIso10646 )
         {
         write_DbvIso10646( name, *ppsDbvIso10646, OutTable );
         ppsDbvIso10646++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvIso10646", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */
  
   write_comment_field( "END of DbvIso10646 sequence", OutTable, T_Return );
     
   } /* End writeN_DbvIso10646() */
    
/*+-----------------------------------------------+*/
/*! writeN_DbvIso2022()                           !*/ 
/*+-----------------------------------------------+*/
void writeN_DbvIso2022( char *name,
	  DbvIso2022 **ppsDbvIso2022, TBL OutTable)
   {
 
   write_comment_field("START of DbvIso2022 sequence", OutTable, T_Return);
  
   if( ppsDbvIso2022 != NULL)
      {
      while( ppsDbvIso2022 && *ppsDbvIso2022 )
         {
         write_DbvIso2022( name, *ppsDbvIso2022, OutTable );
         ppsDbvIso2022++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvIso2022", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */
  
   write_comment_field( "END of DbvIso2022 sequence", OutTable, T_Return );
     
   } /* End writeN_DbvIso2022() */
    
/*+-----------------------------------------------+*/
/*! writeN_DbvIso2022Response                     !*/ 
/*+-----------------------------------------------+*/
void writeN_DbvIso2022Response( char *name,
	  DbvIso2022Response **ppsDbvIso2022Response, TBL OutTable)
   {
 
   write_comment_field("START of DbvIso2022Response sequence", OutTable, T_Return);
  
   if( ppsDbvIso2022Response != NULL)
      {
      while( ppsDbvIso2022Response && *ppsDbvIso2022Response )
         {
         write_DbvIso2022Response( name, *ppsDbvIso2022Response, OutTable );
         ppsDbvIso2022Response++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvIso2022Response", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */
  
   write_comment_field( "END of DbvIso2022Response sequence", OutTable, T_Return );
     
   } /* End writeN_DbvIso2022Response() */
    
/*+-----------------------------------------------+*/
/*! writeN_DbvIso2022Proposal                     !*/ 
/*+-----------------------------------------------+*/
void writeN_DbvIso2022Proposal( char *name,
	  DbvIso2022Proposal **ppsDbvIso2022Proposal, TBL OutTable)
   {
 
   write_comment_field("START of DbvIso2022Proposal sequence", OutTable, T_Return);
  
   if( ppsDbvIso2022Proposal != NULL)
      {
      while( ppsDbvIso2022Proposal && *ppsDbvIso2022Proposal )
         {
         write_DbvIso2022Proposal( name, *ppsDbvIso2022Proposal, OutTable );
         ppsDbvIso2022Proposal++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvIso2022Proposal", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */
  
   write_comment_field( "END of DbvIso2022Proposal sequence", OutTable, T_Return );
     
   } /* End writeN_DbvIso2022Proposal() */
    
/*+-----------------------------------------------+*/
/*! writeN_DbvLeftAndRight                        !*/ 
/*+-----------------------------------------------+*/
void writeN_DbvLeftAndRight( char *name,
	  DbvLeftAndRight **ppsDbvLeftAndRight, TBL OutTable)
   {
 
   write_comment_field("START of DbvLeftAndRight sequence", OutTable, T_Return);
  
   if( ppsDbvLeftAndRight != NULL)
      {
      while( ppsDbvLeftAndRight && *ppsDbvLeftAndRight )
         {
         write_DbvLeftAndRight( name, *ppsDbvLeftAndRight, OutTable );
         ppsDbvLeftAndRight++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvLeftAndRight", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */
  
   write_comment_field( "END of DbvLeftAndRight sequence", OutTable, T_Return );
     
   } /* End writeN_DbvLeftAndRight() */
    
/*+-----------------------------------------------+*/
/*! writeN_DbvInitialSet                          !*/ 
/*+-----------------------------------------------+*/
void writeN_DbvInitialSet( char *name,
	  DbvInitialSet **ppsDbvInitialSet, TBL OutTable)
   {
 
   write_comment_field("START of DbvInitialSet sequence", OutTable, T_Return);
  
   if( ppsDbvInitialSet != NULL)
      {
      while( ppsDbvInitialSet && *ppsDbvInitialSet )
         {
         write_DbvInitialSet( name, *ppsDbvInitialSet, OutTable );
         ppsDbvInitialSet++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvInitialSet", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */
  
   write_comment_field( "END of DbvInitialSet sequence", OutTable, T_Return );
     
   } /* End writeN_DbvInitialSet() */
    
/*+-----------------------------------------------+*/
/*! writeN_DbvEnvironment                         !*/ 
/*+-----------------------------------------------+*/
void writeN_DbvEnvironment( char *name,
	  DbvEnvironment **ppsDbvEnvironment, TBL OutTable)
   {
 
   write_comment_field("START of DbvEnvironment sequence", OutTable, T_Return);
  
   if( ppsDbvEnvironment != NULL)
      {
      while( ppsDbvEnvironment && *ppsDbvEnvironment )
         {
         write_DbvEnvironment( name, *ppsDbvEnvironment, OutTable );
         ppsDbvEnvironment++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvEnvironment", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */
  
   write_comment_field( "END of DbvEnvironment sequence", OutTable, T_Return );
     
   } /* End writeN_DbvEnvironment() */
    

void writeN_DbvLanguageCode(char *name, DbvLanguageCode **ppsProposedLanguages, TBL OutTable)  
   {
   
   write_comment_field("START of DbvLanguageCode sequence", OutTable, T_Return);
   if( ppsProposedLanguages != NULL)
      { 
      while( ppsProposedLanguages && *ppsProposedLanguages )
         {    
         write_DbvLanguageCode( name, *ppsProposedLanguages, OutTable );
         ppsProposedLanguages++;
         } /* End while */
      } /* End if */
   else
      {
      write_title_char("NULL", "DbvLanguageCode", OutTable);
      TBL_PutRecord(OutTable);
      } /* End else */

   write_comment_field( "END of DbvLanguageCode sequence", OutTable, T_Return );
   } /* End writeN_DbvLanguageCode() */

