/*  Module Name: @@(#)write_DbvFuncs.h	7.3
    Version: 4/28/97
    Author: Dan Maskell/Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to write structure types to the result script files.
        Used by the origin and target.
 
*/
 
#ifndef WRITE_DBVFUNCS_H
#define WRITE_DBVFUNCS_H
 
#include "testy_calls.h"


/* write_DbvFuncs.c */


void 
write_DbvAdditionalInfo (DbvAdditionalInfo * psAdditionalInfo, TBL OutTable);
void 
write_DbvDefaultDiagFormat (DbvDefaultDiagFormat * psDefaultDiagFormat,
			    TBL OutTable);
void 
write_DbvDiagRec (DbvDiagRec * psDiagRec, TBL OutTable);
void 
write_DbvElementSetNames (DbvElementSetNames * psElementSetNames,
			  TBL OutTable);
void 
write_DbvFragmentSyntax (DbvFragmentSyntax * psFragmentSyntax, TBL OutTable);
void 
write_DbvNamePlusRecord (DbvNamePlusRecord * psNamePlusRecord, TBL OutTable);
void 
write_DbvObjectIdentifier (char *name, DbvObjectIdentifier
			   psObjectIdentifier, TBL OutTable);
void 
write_DbvQuery (DbvQuery * psQuery, TBL OutTable);
void 
write_DbvRecords (DbvRecords * psRecords, TBL OutTable);
void 
write_DbvVisibleString (char *name, DbvVisibleString
			psVisibleString, TBL OutTable);
void 
write_DbvSortKeySpec (DbvSortKeySpec * psSortKeySpec, TBL OutTable);
void 
write_DbvSortElement (DbvSortElement * psSortElement, TBL OutTable);
void 
write_DbvSortKey (DbvSortKey * psSortKey, TBL OutTable);
void 
write_DbvSpecification (DbvSpecification * psSpecification, TBL OutTable);
void 
write_DbvElementSpec( DbvElementSpec *psElementSpec, TBL OutTable );
void 
write_DbvSortAttributes (DbvSortAttributes * psSortAttributes,
			 TBL OutTable);
void 
write_DbvAttributeElement (DbvAttributeElement * psAttributeElement,
			   TBL OutTable);
void 
write_DbvAttributeValue (DbvAttributeValue * psAttributeValue,
			 TBL OutTable);
void 
write_DbvComplexValue (DbvComplexValue * psComplexValue, TBL OutTable);
void 
write_DbvStringOrNumeric (DbvStringOrNumeric * psStringOrNumeric,
			  TBL OutTable);
void 
write_DbvDbSpecificSortKey (DbvDbSpecificSortKey * psDbSpecificSortKey,
			    TBL OutTable);
void 
write_DbvSortMVAction (DbvSortMVAction * psSortMVAction, TBL OutTable);
void 
write_integer_string (char *name, int *pul, TBL OutTable);
void 
write_DbvEntry (DbvEntry * psEntry, TBL OutTable);
void 
write_DbvListEntries (DbvListEntries * psListEntries, TBL OutTable);
void 
write_DbvTermInfo (DbvTermInfo * psTermInfo, TBL OutTable);
void 
write_DbvTerm (DbvTerm * psTerm, TBL OutTable);
void 
write_DbvGeneralizedTime (char *name, DbvGeneralizedTime
			  psGeneralizedTime, TBL OutTable);
void 
write_DbvIntUnit (DbvIntUnit * psIntUnit, TBL OutTable);
void 
write_DbvUnit (DbvUnit * psUnit, TBL OutTable);
void 
write_DbvAttributesPlusTerm (DbvAttributesPlusTerm * psAttributesPlusTerm,
			     TBL OutTable);
void 
write_DbvOccurrenceByAttributes (DbvOccurrenceByAttributes
				 * psOccurrenceByAttributes, TBL OutTable);
void 
write_DbvOccurrence (DbvOccurrence * psOccurrence, TBL OutTable);
void 
write_DbvOccurrenceByDb (DbvOccurrenceByDb * psOccurrenceByDb, TBL OutTable);
void 
write_DbvEsTaskPackage (DbvEsTaskPackage * psEsTaskPackage,
			TBL OutTable);
void 
write_DbvEstimate2 (DbvEstimate2 * psEstimate2,
		    TBL OutTable);
void 
write_DbvPermAllowableFunctions (DbvPermAllowableFunctions
				 * pePermAllowableFunctions, TBL OutTable);
void 
write_DbvPermissions (DbvPermissions * psPermissions, TBL OutTable);
void 
write_DbvResourceReport2 (DbvResourceReport2 * psResourceReport2,
			  TBL OutTable);
void 
write_DbvUpdateExtendedService (DbvUpdateExtendedService
				* psUpdateExtendedService,
				TBL OutTable);
void 
write_DbvUpdateRequestPackage (DbvUpdateRequestPackage * psUpdateRequest,
			       TBL OutTable);
void 
write_DbvOriginPartToKeep (DbvOriginPartToKeep * psOriginPartToKeep,
			   TBL OutTable);
void 
write_DbvSuppliedRecord (DbvSuppliedRecord * psSuppliedRecord, TBL OutTable);
void 
write_DbvUpdtRecordId (DbvUpdtRecordId * psUpdtRecordId, TBL OutTable);
void 
write_DbvUpdtSupplementalId (DbvUpdtSupplementalId * psUpdtSupplementalId,
			     TBL OutTable);
void 
write_DbvCorrelationInfo (DbvCorrelationInfo * psCorrelationInfo,
			  TBL OutTable);
void 
write_DbvUpdateTaskPackage (DbvUpdateTaskPackage * psUpdateResponse,
			    TBL OutTable);
void 
write_DbvUpdateTargetPart (DbvUpdateTargetPart * psTargetPart,
			   TBL OutTable);
void 
write_DbvTaskPackageRecord (DbvTaskPackageRecord * psTaskPackageRecord,
			    TBL OutTable);
void 
write_DbvUpdtRecordOrDiag (DbvUpdtRecordOrDiag * psUpdtRecordOrDiag,
			   TBL OutTable);
void 
write_DbvRange (DbvRange * psAdditionalRanges, TBL OutTable);
void 
write_DbvRecordComposition (DbvRecordComposition * psRecordComposition, TBL OutTable);
void 
write_DbvCompSpec (DbvCompSpec * psCompSpec, TBL OutTable);
void 
write_DbvDbSpecificComp (DbvDbSpecificComp * psDbSpecific, TBL OutTable);
void 
write_DbvRPNQuery (char *query_type, DbvRPNQuery * psDbvRPNQuery, TBL OutTable);
void 
write_DbvRPNStructure (DbvRPNStructure * psDbvRPNStructure, TBL OutTable);
void 
write_DbvRPNLopRopOperator (DbvRPNLopRopOperator * psDbvRPNLopRopOperator,
			    TBL OutTable);
void 
write_DbvOperator (DbvOperator sOperator, TBL OutTable);
void 
write_DbvOperand (DbvOperand * psRpnOperand, TBL OutTable);
void 
write_DbvProximityOperator (DbvProximityOperator * psProximityOperator,
			    TBL OutTable);
void 
write_DbvProximityUnitCode (DbvProximityUnitCode * psProximityUnitCode,
			    TBL OutTable);
void 
write_DbvGeneralString (char *name, DbvGeneralString
			* psGeneralString, TBL OutTable);
void 
write_DbvSystemId (DbvSystemId * psSystemId, TBL OutTable);
void 
write_DbvIllString (char *name, DbvIllString * psIllString, TBL OutTable);
void 
write_DbvPersonOrInstitutionSymbol (
		 DbvPersonOrInstitutionSymbol * psPersonOrInstitutionSymbol,
				     TBL OutTable);
void 
write_DbvNameOfPersonOrInstitution (
		 DbvNameOfPersonOrInstitution * psNameOfPersonOrInstitution,
				     TBL OutTable);
void 
write_DbvTransactionId (DbvTransactionId * psTransactionId, TBL OutTable);
void 
write_DbvDateTime (DbvDateTime * psDateTime, TBL OutTable);
void 
write_DbvServiceDateTime (DbvServiceDateTime * psServiceDateTime,
			  TBL OutTable);
void 
write_DbvPostalAddress (DbvPostalAddress * psPostalAddress,
			TBL OutTable);
void 
write_DbvSystemAddress (DbvSystemAddress * psSystemAddress,
			TBL OutTable);
void 
write_DbvDeliveryAddress (DbvDeliveryAddress * psDeliveryAddress,
			  TBL OutTable);
void 
write_DbvElDeliveryDetails (DbvElDeliveryDetails * psElDeliveryDetails,
			    TBL OutTable);
void 
write_DbvElDeliveryParameter (
			     DbvElDeliveryParameter * psElDeliveryParameter,
			       TBL OutTable);
void 
write_DbvDocumentTypeParameter (
			 DbvDocumentTypeParameter * psDocumentTypeParameter,
				 TBL OutTable);
void 
write_DbvElectronicDeliveryService (
		 DbvElectronicDeliveryService * psElectronicDeliveryService,
				     TBL OutTable);
void 
write_DbvDeliveryService (DbvDeliveryService * psDeliveryService,
			  TBL OutTable);
void 
write_DbvRequesterOptionalMessages (
		 DbvRequesterOptionalMessages * psRequesterOptionalMessages,
				     TBL OutTable);
void 
write_DbvSearchType (DbvSearchType * psSearchType, TBL OutTable);
void 
write_DbvSupplyMediumInfo (DbvSupplyMediumInfo * psSupplyMediumInfo,
			   TBL OutTable);
void 
write_DbvClientId (DbvClientId * psClientId, TBL OutTable);
void 
write_DbvItemId (DbvItemId * psItemId, TBL OutTable);
void 
write_DbvAmount (DbvAmount * psAmount, TBL OutTable);
void 
write_DbvCostInfo (DbvCostInfo * psCostInfo, TBL OutTable);
void 
write_DbvSendToList (DbvSendToList * psSendToList, TBL OutTable);
void 
write_DbvThirdPartyInfo (DbvThirdPartyInfo * psThirdPartyInfo, TBL OutTable);
void 
write_DbvAddRequesterInfo (DbvAddRequesterInfo * psAddRequesterInfo, TBL OutTable);
void 
write_DbvAddDeliveryInfo (DbvAddDeliveryInfo * psAddDeliveryInfo, TBL OutTable);
void 
write_DbvBillingBankInfo (DbvBillingBankInfo * psBillingBankInfo, TBL OutTable);
void 
write_DbvBillingCreditCardInfo (DbvBillingCreditCardInfo * psBillingCreditCardInfo, TBL OutTable);
void 
write_DbvAddBillingInfo (DbvAddBillingInfo * psAddBillingInfo, TBL OutTable);
void 
write_DbvSubitoAdditionalInfo (DbvSubitoAdditionalInfo * psAddIllReqInfo, TBL OutTable);
void 
write_DbvExtension (DbvExtension * psExtension, TBL OutTable);
void 
write_DbvIllRequest (DbvIllRequest * psIllRequest, TBL OutTable);
void 
write_DbvServiceType (DbvServiceType * peServiceType, TBL OutTable);
void 
write_DbvHistoryReport (DbvHistoryReport * psHistoryReport, TBL OutTable);
void 
write_DbvStateTransitionProhibited (
		 DbvStateTransitionProhibited * psStateTransitionProhibited,
				     TBL OutTable);
void 
write_DbvAlreadyForwarded (DbvAlreadyForwarded * psAlreadyForwarded,
			   TBL OutTable);
void 
write_DbvProviderErrorReport (
			     DbvProviderErrorReport * psProviderErrorReport,
			       TBL OutTable);
void 
write_DbvUserErrorReport (DbvUserErrorReport * psUserErrorReport,
			  TBL OutTable);
void 
write_DbvUserOrProviderErrorReport (
		 DbvUserOrProviderErrorReport * psUserOrProviderErrorReport,
				     TBL OutTable);
void 
write_DbvErrorReport (DbvErrorReport * psErrorReport, TBL OutTable);
void 
write_DbvStatusReport (DbvStatusReport * psStatusReport, TBL OutTable);
void 
write_DbvStatusOrErrorReport (
			     DbvStatusOrErrorReport * psStatusOrErrorReport,
			       TBL OutTable);
void 
write_DbvIllPdu (DbvIllPdu * psIllPdu, TBL OutTable);
void 
write_DbvPrintableString (char *name,
			  DbvPrintableString pcPrintableString,
			  TBL OutTable);
void 
write_DbvEsIoTargetPart (DbvEsIoTargetPart * psEsIoTargetPart,
			 TBL OutTable);
void 
write_DbvEsIoResultSetItem (DbvEsIoResultSetItem * psEsIoResultSetItem,
			    TBL OutTable);
void 
write_DbvEsIoOriginPartNotToKeep (
		     DbvEsIoOriginPartNotToKeep * psEsIoOriginPartNotToKeep,
				   TBL OutTable);
void 
write_DbvEsIoCreditCardInfo (DbvEsIoCreditCardInfo * psEsIoCreditCardInfo,
			     TBL OutTable);
void 
write_DbvEsIoPaymentMethod (
			     DbvEsIoPaymentMethod * psEsIoPaymentMethod,
			     TBL OutTable);
void 
write_DbvEsIoAdditionalBilling (
			 DbvEsIoAdditionalBilling * psEsIoAdditionalBilling,
				 TBL OutTable);
void 
write_DbvEsIoContact (DbvEsIoContact * psEsIoContact, TBL OutTable);
void 
write_DbvEsIoOriginPartToKeep (
			   DbvEsIoOriginPartToKeep * psEsIoOriginPartToKeep,
				TBL OutTable);
void 
write_DbvEsIoRequest (DbvEsIoRequest * psEsIoRequest, TBL OutTable);
void 
write_DbvEsIoTaskPackage (DbvEsIoTaskPackage * psEsIoTaskPackage,
			  TBL OutTable);
void 
write_DbvItemOrderExtendedService (
		   DbvItemOrderExtendedService * psItemOrderExtendedService,
				    TBL OutTable);

/* writeN_DbvFuncs.c */


void 
writeN_DbvEstimate2 (DbvEstimate2 ** ppsEstimate, TBL OutTable);
void 
writeN_DbvIntUnit (DbvIntUnit ** ppsIntUnit, TBL OutTable);
void 
writeN_DbvPermAllowableFunctions (DbvPermAllowableFunctions
				  ** ppsPermAllowableFunctions, TBL OutTable);
void 
writeN_DbvPermissions (DbvPermissions ** ppsPermissions, TBL OutTable);
void 
writeN_DbvDiagRec (DbvDiagRec ** ppsDiagRec, TBL OutTable);
void 
writeN_DbvOtherInformation (DbvOtherInformation ** ppsOtherInformation,
			    TBL OutTable);
void 
writeN_DbvOccurrenceByAttributes (DbvOccurrenceByAttributes
				  ** ppsOccurrenceByAttributes, TBL OutTable);
void 
writeN_DbvSuppliedRecord (DbvSuppliedRecord ** ppsSuppliedRecord,
			  TBL OutTable);
void 
writeN_DbvTaskPackageRecord (DbvTaskPackageRecord ** ppsTaskPackageRecord,
			     TBL OutTable);
void 
writeN_DbvSystemId (DbvSystemId ** ppsSystemId, TBL OutTable);
void 
writeN_DbvElectronicDeliveryService (
	       DbvElectronicDeliveryService ** ppsElectronicDeliveryService,
				      TBL OutTable);
void 
writeN_DbvSupplyMediumInfo (DbvSupplyMediumInfo ** ppsSupplyMediumInfo,
			    TBL OutTable);
void 
writeN_DbvSendToList (DbvSendToList ** ppsSendToList, TBL OutTable);
void 
writeN_DbvExtension (DbvExtension ** ppsExtension, TBL OutTable);
void 
writeN_DbvServiceType (DbvServiceType ** ppsServiceType, TBL OutTable);
void 
writeN_DbvASN1External (DbvASN1External ** ppsASN1External, TBL OutTable);
void 
writeN_DbvHumanString (char *name,
		       DbvHumanString ** ppsHumanString,
		       TBL OutTable);
void 
writeN_DbvIconObject (DbvIconObject ** ppsIconObject, TBL OutTable);
void 
writeN_DbvDatabaseList (DbvDatabaseList ** ppsDatabaseList, TBL OutTable);
void 
writeN_DbvOperators (DbvOperators ** ppsOperators, TBL OutTable);
void 
writeN_DbvSearchKey (DbvSearchKey ** ppsSearchKey, TBL OutTable);
void 
writeN_DbvHumanStringSeq (DbvHumanStringSeq ** ppsDescription, TBL OutTable);
void 
writeN_DbvUnitsSupported (DbvUnitsSupported ** ppsUnitsSupported,
			  TBL OutTable);
void 
writeN_Ulong (char *name, Ulong ** ppsUlong, TBL OutTable);
void 
writeN_DbvQueryTypeDetails (DbvQueryTypeDetails ** ppsQueryTypeDetails,
			    TBL OutTable);
void 
writeN_DbvObjectIdentifier (char *name,
			    DbvObjectIdentifier * ppcObjectIdentifier,
			    TBL OutTable);
void 
writeN_DbvOtherCharge (DbvOtherCharge ** ppsOtherCharge, TBL OutTable);
void 
writeN_DbvElementSetNames (
			    DbvElementSetNames ** ppsElementSetNames,
			    TBL OutTable);
void 
writeN_DbvAccessInfo (DbvAccessInfo ** ppsAccessInfo, TBL OutTable);
void 
writeN_DbvTagTypeMapping (DbvTagTypeMapping ** ppsTagTypeMapping,
			  TBL OutTable);
void 
writeN_DbvPath (DbvPath ** ppsPath, TBL OutTable);
void 
writeN_DbvPathA (DbvPathA ** ppsPathA, TBL OutTable);
void 
writeN_DbvElementInfo (DbvElementInfo ** ppsElementInfo, TBL OutTable);
void 
writeN_DbvElements (DbvElements ** ppsElements, TBL OutTable);
void 
writeN_DbvAttributeDescription (
			 DbvAttributeDescription ** ppsAttributeDescription,
				 TBL OutTable);
void 
writeN_DbvAttributeType (DbvAttributeType ** ppsAttributeType,
			 TBL OutTable);
void 
writeN_DbvTermList (DbvTermList ** ppsTermList, TBL OutTable);
void 
writeN_DbvAttributeValues (DbvAttributeValues ** ppsAttributeValues,
			   TBL OutTable);
void 
writeN_DbvAttributesByType (DbvAttributesByType ** ppsAttributesByType,
			    TBL OutTable);
void 
writeN_DbvAttributesBySet (DbvAttributesBySet ** ppsAttributesBySet,
			   TBL OutTable);
void 
writeN_DbvAttributeOccurrence (
	     DbvAttributeOccurrence ** ppsAttributeOccurrence, TBL OutTable);
void 
writeN_DbvAttributeCombinations (
		       DbvAttributeCombinations ** ppsAttributeCombinations,
				  TBL OutTable);
void 
writeN_DbvTerm (DbvTerm ** ppsTerm, TBL OutTable);
void 
writeN_DbvDetailsPerElement (
			      DbvDetailsPerElement ** ppsDetailsPerElement,
			      TBL OutTable);
void 
writeN_DbvSortKeys (DbvSortKeys ** ppsSortKeys, TBL OutTable);
void 
writeN_DbvValueDescription (DbvValueDescription ** ppsValueDescription,
			    TBL OutTable);
void 
writeN_DbvVariantTypes (DbvVariantTypes ** ppsVariantTypes, TBL OutTable);
void 
writeN_DbvVariantClass (DbvVariantClass ** ppsVariantClass, TBL OutTable);
void 
writeN_DbvUnits (DbvUnits ** ppsUnits, TBL OutTable);
void 
writeN_DbvUnitType (DbvUnitType ** ppsUnitType, TBL OutTable);
void 
writeN_DbvUnit (DbvUnit ** ppsUnit, TBL OutTable);
void 
writeN_DbvCategoryInfo (DbvCategoryInfo ** ppsCategoryInfo, TBL OutTable);
void 
writeN_DbvStringOrNumeric (DbvStringOrNumeric ** ppsStringOrNumeric,
			   TBL OutTable);
void 
writeN_DbvSpecification (DbvSpecification ** ppsSpecification, TBL OutTable);
void 
writeN_DbvAccessRestrictions (
	       DbvAccessRestrictions ** ppsAccessRestrictions, TBL OutTable);
void 
writeN_DbvNetworkAddress (DbvNetworkAddress ** ppsNetworkAddress,
			  TBL OutTable);
void 
writeN_DbvInternationalString (char *name, DbvInternationalString
			       ** ppsInternationalString, TBL OutTable);

#ifdef NOT_YET_IMPLEMENTED
void 
writeN_DbvValue (DbvValue ** ppsValue, TBL OutTable);
void 
writeN_DbvTriples (DbvTriples ** ppsTriples, TBL OutTable);
void 
writeN_DbvTagPath (DbvTagPath ** ppsTagPath, TBL OutTable);
void 
writeN_DbvTaggedElement (DbvTaggedElement ** ppsTaggedElement,
			 TBL OutTable);

void 
writeN_DbvHits (DbvHits ** ppsHits, TBL OutTable);
void 
writeN_DbvVariant (DbvVariant ** ppsVariant, TBL OutTable);

#endif


void 
writeN_DbvAttributeCombination (
			 DbvAttributeCombination ** ppsAttributeCombination,
				 TBL OutTable);
void 
writeN_DbvDataBaseInfoSeq (DbvDataBaseInfoSeq ** ppsDataBaseInfoSeq,
			   TBL OutTable);

void
writeN_DbvChallenge (DbvChallenge ** ppsChallenge, TBL OutTable);
void
writeN_DbvResponse (DbvResponse ** ppsResponse, TBL OutTable);




/* write_DbvFuncs1.c */


void 
write_DbvRequesterGroup (char *name,
			 DbvRequesterGroup * peRequesterGroup,
			 TBL OutTable);
void 
write_DbvStatusLevelUser (char *name,
			  DbvStatusLevelUser * peStatusLevelUser,
			  TBL OutTable);
void 
write_DbvStatusLevelRequester (char *name,
			   DbvStatusLevelRequester * peStatusLevelRequester,
			       TBL OutTable);
void 
write_DbvBillingInvoiceType (char *name,
			     DbvBillingInvoiceType * peBillingInvoiceType,
			     TBL OutTable);

/* write_DbvFuncs2.c */


void 
write_DbvCommonInfo (DbvCommonInfo * psCommonInfo, TBL OutTable);
void 
write_DbvHumanString (DbvHumanString * psHumanString, TBL OutTable);
void 
write_DbvBodyType (DbvBodyType * psBodyType, TBL OutTable);
void 
write_DbvIconObject (DbvIconObject * psIconObject, TBL OutTable);
void 
write_DbvContactInfo (DbvContactInfo * psContactInfo, TBL OutTable);
void 
write_DbvDatabaseList (DbvDatabaseList * psDatabaseList, TBL OutTable);
void 
write_DbvInterAddress (DbvInterAddress * psInterAddress, TBL OutTable);
void 
write_DbvOsiPresentationAddress (
		       DbvOsiPresentationAddress * psOsiPresentationAddress,
				  TBL OutTable);
void 
write_DbvOtherAddress (DbvOtherAddress * psOtherAddress, TBL OutTable);
void 
write_DbvNetworkAddress (DbvNetworkAddress * psNetworkAddress, TBL OutTable);
void 
write_DbvOperators (DbvOperators * psOperators, TBL OutTable);
void 
write_DbvSearchKey (DbvSearchKey * psSearchKey, TBL OutTable);
void 
write_DbvHumanStringSeq (DbvHumanStringSeq * psDescription, TBL OutTable);
void 
write_DbvPrivateCapabilities (
	       DbvPrivateCapabilities * psPrivateCapabilities, TBL OutTable);
void 
write_DbvPrivate (DbvPrivate * psPrivate, TBL OutTable);
void 
write_DbvUnitsSupported (DbvUnitsSupported * psUnitsSupported,
			 TBL OutTable);
void 
write_DbvProximitySupport (DbvProximitySupport * psProximitySupport, TBL OutTable);
void 
write_DbvRpnCapabilities (DbvRpnCapabilities * psRpnCapabilities,
			  TBL OutTable);
void 
write_DbvIso8777Capabilities (
			     DbvIso8777Capabilities * psIso8777Capabilities,
			       TBL OutTable);
void 
write_DbvQueryTypeDetails (
			    DbvQueryTypeDetails * psQueryTypeDetails,
			    TBL OutTable);
void 
write_DbvAccessRestrictions (DbvAccessRestrictions * psAccessRestrictions,
			     TBL OutTable);
void 
write_DbvCharge (DbvCharge * psCharge, TBL OutTable);
void 
write_DbvOtherCharge (DbvOtherCharge * psOtherCharge, TBL OutTable);
void 
write_DbvCosts (DbvCosts * psCosts, TBL OutTable);
void 
write_DbvAccessInfo (DbvAccessInfo * psAccessInfo, TBL OutTable);
void 
write_DbvTargetInfo (DbvTargetInfo * psTargetInfo, TBL OutTable);
void 
write_DbvRecordCount (DbvRecordCount * psRecordCount, TBL OutTable);
void 
write_DbvDatabaseInfo (DbvDatabaseInfo * psDatabaseInfo, TBL OutTable);
void 
write_DbvTagTypeMapping (DbvTagTypeMapping * psTagTypeMapping, TBL OutTable);
void 
write_DbvPath (DbvPath * psPath, TBL OutTable);
void 
write_DbvPathA (DbvPathA * psPathA, TBL OutTable);
void 
write_DbvElementInfo (DbvElementInfo * psElementInfo, TBL OutTable);
void 
write_DbvElementDataType (DbvElementDataType * psElementDataType,
			  TBL OutTable);
void 
write_DbvSchemaInfo (DbvSchemaInfo * psSchemaInfo, TBL OutTable);
void 
write_DbvElements (DbvElements * psElements, TBL OutTable);
void 
write_DbvPrimitiveDataType (char *name,
			    DbvPrimitiveDataType * pePrimitiveDataType,
			    TBL OutTable);
void 
write_DbvTagSetInfo (DbvTagSetInfo * psTagSetInfo, TBL OutTable);
void 
write_DbvRecordSyntaxInfo (DbvRecordSyntaxInfo * psRecordSyntaxInfo,
			   TBL OutTable);
void 
write_DbvAttributeDescription (
			   DbvAttributeDescription * psAttributeDescription,
				TBL OutTable);
void 
write_DbvAttributeType (DbvAttributeType * psAttributeType, TBL OutTable);
void 
write_DbvAttributeSetInfo (DbvAttributeSetInfo * psAttributeSetInfo,
			   TBL OutTable);
void 
write_DbvTermList (DbvTermList * psTermList, TBL OutTable);
void 
write_DbvTermListInfo (DbvTermListInfo * psTermListInfo, TBL OutTable);
void 
write_DbvExtendedServicesInfo (
			   DbvExtendedServicesInfo * psExtendedServicesInfo,
				TBL OutTable);
void 
write_DbvExtendedServicesInfoInt (
       DbvExtendedServicesInfoInt * peExtendedServicesInfoInt, TBL OutTable);
void 
write_DbvOmittedAttributeInterpretation (
       DbvOmittedAttributeInterpretation * psOmittedAttributeInterpretation,
					  TBL OutTable);
void 
write_DbvSearchCost (char *name, DbvSearchCost * peSearchCost, TBL OutTable);
void 
write_DbvAttributeValues (DbvAttributeValues * psAttributeValues,
			  TBL OutTable);
void 
write_DbvAttributesByType (DbvAttributesByType * psAttributesByType,
			   TBL OutTable);
void 
write_DbvAttributesBySet (DbvAttributesBySet * psAttributesBySet,
			  TBL OutTable);
void 
write_DbvAttributeOccurrenceChoice (
		 DbvAttributeOccurrenceChoice * psAttributeOccurrenceChoice,
				     TBL OutTable);
void 
write_DbvAttributeOccurrence (
			     DbvAttributeOccurrence * psAttributeOccurrence,
			       TBL OutTable);
void 
write_DbvAttributeCombination (
	     DbvAttributeCombination * psAttributeCombination, TBL OutTable);
void 
write_DbvAttributeCombinations (
			 DbvAttributeCombinations * psAttributeCombinations,
				 TBL OutTable);
void 
write_DbvAttributeDetails (DbvAttributeDetails * psAttributeDetails,
			   TBL OutTable);
void 
write_DbvScanInfo (DbvScanInfo * psScanInfo, TBL OutTable);
void 
write_DbvTermListDetails (DbvTermListDetails * psTermListDetails,
			  TBL OutTable);
void 
write_DbvRecordTag (DbvRecordTag * psRecordTag, TBL OutTable);
void 
write_DbvDetailsPerElement (DbvDetailsPerElement * psDetailsPerElement,
			    TBL OutTable);
void 
write_DbvElementSetDetails (DbvElementSetDetails * psElementSetDetails,
			    TBL OutTable);
void 
write_DbvRetrievalRecordDetails (
		       DbvRetrievalRecordDetails * psRetrievalRecordDetails,
				  TBL OutTable);
void 
write_DbvSortType (DbvSortType * psSortType, TBL OutTable);
void 
write_DbvSortKeys (DbvSortKeys * psSortKeys, TBL OutTable);
void 
write_DbvSortDetails (DbvSortDetails * psSortDetails, TBL OutTable);
void 
write_DbvProcessingInformation (
			 DbvProcessingInformation * psProcessingInformation,
				 TBL OutTable);
void 
write_DbvValueDescription (DbvValueDescription * psValueDescription,
			   TBL OutTable);
void 
write_DbvValueRange (DbvValueRange * psValueRange, TBL OutTable);
void 
write_DbvValueSet (DbvValueSet * psValueSet, TBL OutTable);
void 
write_DbvVariantValue (DbvVariantValue * psVariantValue, TBL OutTable);
void 
write_DbvVariantTypes (DbvVariantTypes * psVariantTypes, TBL OutTable);
void 
write_DbvVariantClass (DbvVariantClass * psVariantClass, TBL OutTable);
void 
write_DbvVariantSetInfo (DbvVariantSetInfo * psVariantSetInfo, TBL OutTable);
void 
write_DbvUnits (DbvUnits * psUnits, TBL OutTable);
void 
write_DbvUnitType (DbvUnitType * psUnitType, TBL OutTable);
void 
write_DbvUnitInfo (DbvUnitInfo * psUnitInfo, TBL OutTable);
void 
write_DbvCategoryInfo (DbvCategoryInfo * psCategoryInfo, TBL OutTable);
void 
write_DbvCategoryList (DbvCategoryList * psCategoryList, TBL OutTable);
void 
write_DbvExplainRecord (DbvExplainRecord * psExplainRecord, TBL OutTable);
void 
write_DbvLanguageCode (char *name, DbvLanguageCode * psLanguageCode,
		       TBL OutTable);
void 
write_DbvNull (char *name, DbvNull * pvNull, TBL OutTable);
void 
write_DbvDataBaseInfoSeq (DbvDataBaseInfoSeq * psDataBaseInfoSeq,
			  TBL OutTable);

/* write_DbvFuncs3.c */


#ifdef NOT_YET_IMPLEMENTED

void 
write_DbvUsageIntType (char *name, DbvUsageIntType * peUsageIntType,
		       TBL OutTable);
void 
write_DbvOrder (DbvOrder * psOrder, TBL OutTable);
void 
write_DbvUsage (DbvUsage * psUsage, TBL OutTable);
void 
write_DbvHits (DbvHits * psHits, TBL OutTable);
void 
write_DbvValue (DbvValue * psValue, TBL OutTable);
void 
write_DbvTriples (DbvTriples * psTriples, TBL OutTable);
void 
write_DbvVariant (DbvVariant * psVariant, TBL OutTable);
void 
write_DbvTagPath (DbvTagPath * psTagPath, TBL OutTable);
void 
write_DbvElementMetaData (DbvElementMetaData * psElementMetaData,
			  TBL OutTable);
void 
write_DbvElementDataG (DbvElementDataG * psElementDataG, TBL OutTable);
void 
write_DbvTaggedElement (DbvTaggedElement * psTaggedElement, TBL OutTable);
void 
write_DbvGenericRecord (DbvGenericRecord * psGenericRecord, TBL OutTable);

#endif




/* write_DbvFuncs4.c */


void 
write_DbvSecurityChallengeReq (DbvSecurityChallengeReq * psSecurityChallengeReq, TBL OutTable);
void 
write_DbvSecurityChallengeRsp (DbvSecurityChallengeRsp * psSecurityChallengeRsp, TBL OutTable);
void 
write_DbvEPromptIdType (char *name, DbvEPromptIdType * peEPromptIdType, TBL OutTable);
void 
write_DbvEnumeratedPrompt (DbvEnumeratedPrompt * psEnumeratedPrompt, TBL OutTable);
void 
write_DbvPromptId (DbvPromptId * psPromptId, TBL OutTable);
void 
write_DbvEncryption (DbvEncryption * psEncryption, TBL OutTable);
void 
write_DbvPromptInfo (DbvPromptInfo * psPromptInfo, TBL OutTable);
void 
write_DbvDataType (char *name, DbvDataType * peDataType, TBL OutTable);
void 
write_DbvChallenge (DbvChallenge * psChallenge, TBL OutTable);
void 
write_DbvPromptResponse (DbvPromptResponse * psPromptResponse, TBL OutTable);
void 
write_DbvResponse (DbvResponse * psResponse, TBL OutTable);
void 
write_DbvPromptObject (DbvPromptObject * psPromptObject, TBL OutTable);
void 
write_DbvPartialResultsAvailable( char* name, DbvPartialResultsAvailable *pePartialResultsAvailable, TBL OutTable);
void 
write_DbvRequestedAction (char *name,
			  DbvRequestedAction * peRequestedAction,
			  TBL OutTable);

void write_DbvAccessControlResponse( DbvAccessControlRsp *psAccessControlRsp, TBL OutTable);
void write_DbvResourceControlResponse( DbvResourceControlRsp *psResourceControlRsp, TBL OutTable);
void write_DbvAccessControlRequest( DbvAccessControlReq *psAccessControlReq, TBL OutTable);
void write_DbvResourceControlRequest( DbvResourceControlReq *psResourceControlReq, TBL OutTable);

/* write_DbvFuncs5.h */


void write_DbvCharSetAndLanguage( char *name, 
	   DbvCharSetAndLanguage *psDbvCharSetAndLanguage,
	   TBL OutTable);
void write_DbvTargetResponse( char *name, 
	   DbvTargetResponse *psDbvTargetResponse,
	   TBL OutTable);
void write_DbvSelectedCharSet( char *name, 
	   DbvSelectedCharSet *psDbvSelectedCharSet,
	   TBL OutTable);
void write_DbvOriginProposal( char *name, 
	   DbvOriginProposal *psDbvOriginProposal,
	   TBL OutTable);
void write_DbvProposedCharSet( char *name, 
	   DbvProposedCharSet *psDbvProposedCharSet,
	   TBL OutTable);
void write_DbvPrivateCharacterSet( char *name, 
	   DbvPrivateCharacterSet *psDbvPrivateCharacterSet,
	   TBL OutTable);
void write_DbvIso10646( char *name, 
	   DbvIso10646 *psDbvIso10646,
	   TBL OutTable);
void write_DbvIso2022( char *name, 
	   DbvIso2022 *psDbvIso2022,
	   TBL OutTable);
void write_DbvIso2022Response( char *name, 
	   DbvIso2022Response *psDbvIso2022Response,
	   TBL OutTable);
void write_DbvIso2022Proposal( char *name, 
	   DbvIso2022Proposal *psDbvIso2022Proposal,
	   TBL OutTable);
void write_DbvLeftAndRight( char *name, 
	   DbvLeftAndRight *psDbvLeftAndRight,
	   TBL OutTable);
void write_DbvInitialSet( char *name, 
	   DbvInitialSet *psDbvInitialSet,
	   TBL OutTable);
void write_DbvEnvironment( char *name, 
	   DbvEnvironment *psDbvEnvironment,
	   TBL OutTable);


void writeN_DbvCharSetAndLanguage( char *name,
	  DbvCharSetAndLanguage **ppsDbvCharSetAndLanguage, TBL OutTable);
void writeN_DbvTargetResponse( char *name,
	  DbvTargetResponse **ppsDbvTargetResponse, TBL OutTable);
void writeN_DbvSelectedCharSet( char *name,
	  DbvSelectedCharSet **ppsDbvSelectedCharSet, TBL OutTable);
void writeN_DbvOriginProposal( char *name,
	  DbvOriginProposal **ppsDbvOriginProposal, TBL OutTable);
void writeN_DbvProposedCharSet( char *name,
	  DbvProposedCharSet **ppsDbvProposedCharSet, TBL OutTable);
void writeN_DbvPrivateCharacterSet( char *name,
	  DbvPrivateCharacterSet **ppsDbvPrivateCharacterSet, TBL OutTable);
void writeN_DbvIso10646( char *name,
	  DbvIso10646 **ppsDbvIso10646, TBL OutTable);
void writeN_DbvIso2022( char *name,
	  DbvIso2022 **ppsDbvIso2022, TBL OutTable);
void writeN_DbvIso2022Response( char *name,
	  DbvIso2022Response **ppsDbvIso2022Response, TBL OutTable);
void writeN_DbvIso2022Proposal( char *name,
	  DbvIso2022Proposal **ppsDbvIso2022Proposal, TBL OutTable);
void writeN_DbvLeftAndRight( char *name,
	  DbvLeftAndRight **ppsDbvLeftAndRight, TBL OutTable);
void writeN_DbvInitialSet( char *name,
	  DbvInitialSet **ppsDbvInitialSet, TBL OutTable);
void writeN_DbvEnvironment( char *name,
	  DbvEnvironment **ppsDbvEnvironment, TBL OutTable);
void writeN_DbvLanguageCode( char *name,
	  DbvLanguageCode **ppsDbvLanguageCode, TBL OutTable);
#endif



