/*  Module Name: @(#)write_DbvFuncs1.c	7.1
    Version: 11/15/96
    Author: Dan Maskell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to write structure types to the result script files.
        Used by the origin and target.
 
*/

#include "write_DbvFuncs.h"



extern TBL_Return T_Return;


void write_DbvRequesterGroup( char *name, 
			      DbvRequesterGroup *peRequesterGroup, 
			      TBL OutTable)
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;

#ifdef DEBUG
   printf( "D - write_DbvRequesterGroup()\n" );
#endif
   /* Write the title out */ 
   if(peRequesterGroup == NULL)
      {
      write_title_char("NULL","DbvRequesterGroup", OutTable);
      TBL_PutRecord(OutTable);
      return;
      } /* End if */

   /* eRequesterGroupType */
   convert_DbvRequesterGroup( &pc_string, peRequesterGroup );
   sprintf( temp, "%s: %s", name, pc_string );
   write_char_field(temp, OutTable, T_Return);
   TBL_PutRecord( OutTable );
   DbvFree( pc_string );

   } /* End write_DbvRequesterGroup() */


void write_DbvStatusLevelUser( char *name,
				DbvStatusLevelUser *peStatusLevelUser, 
				TBL OutTable)
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;
#ifdef DEBUG
   printf( "D - write_DbvStatusLevelUser()\n" );
#endif

   /* Write the title out */ 
   if(peStatusLevelUser == NULL)
      {
      write_title_char("NULL", name, OutTable);
      TBL_PutRecord(OutTable);
      return;
      } /* End if */

   /* eType */
   convert_DbvStatusLevelUser( &pc_string, peStatusLevelUser);
   sprintf( temp, "%s : %s", name, pc_string );
   write_char_field(temp, OutTable, T_Return);
   TBL_PutRecord( OutTable );
   DbvFree( pc_string );

   } /* End write_DbvStatusLevelUser() */

void write_DbvStatusLevelRequester( char *name,
			DbvStatusLevelRequester *peStatusLevelRequester, 
			TBL OutTable)
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;
#ifdef DEBUG
   printf( "D - write_DbvStatusLevelRequester()\n" );
#endif

   /* Write the title out */ 
   if(peStatusLevelRequester == NULL)
      {
      write_title_char("NULL", name, OutTable);
      TBL_PutRecord(OutTable);
      return;
      } /* End if */

   /* DbvStatusLevelRequester */
   convert_DbvStatusLevelRequester( &pc_string, peStatusLevelRequester);
   sprintf( temp, "%s : %s", name, pc_string );
   write_char_field(temp, OutTable, T_Return);
   TBL_PutRecord( OutTable );
   DbvFree( pc_string );

   } /* End write_DbvStatusLevelRequester() */



void write_DbvBillingInvoiceType( char *name,
			DbvBillingInvoiceType *peBillingInvoiceType, 
			TBL OutTable)
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;
#ifdef DEBUG
   printf( "D - write_DbvBillingInvoiceType()\n" );
#endif

   /* Write the title out */ 
   if(peBillingInvoiceType == NULL)
      {
      write_title_char("NULL", name, OutTable);
      TBL_PutRecord(OutTable);
      return;
      } /* End if */

   /* DbvBillingInvoiceType */
   convert_DbvBillingInvoiceType( &pc_string, peBillingInvoiceType);
   sprintf( temp, "%s : %s", name, pc_string );
   write_char_field(temp, OutTable, T_Return);
   TBL_PutRecord( OutTable );
   DbvFree( pc_string );

   } /* End write_DbvBillingInvoiceType() */


