/*  Module Name: @(#)z3950_externals2.c	7.2
    Version: 4/16/97
    Author: John Hough
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description: More DBV-OSI II externals setup/get code
*/



#include "z3950_externals2.h"


/***********************************************************************

To test an unknown Extension Any:
1) #ifdef out relevant 'if' in DBVunknown_any_int() in this file (NOTE:
   make sure that the function returns 1 for an unknown !)
2) #ifdef out relevant 'if' in DBVsnacc_to_dbv_anytype_int() 
   in this file


##################################################################

To test NULL e_delivery_mode and document_type_id 
OBJECT IDENTIFER fields in Electronic_Delivery_Service

1) #ifdef out code fragments

if (NOT_NULL((v->document_type_id.octs)))
{
itemLen = BEncAsnOidContent( b, (&v->document_type_id));
itemLen += BEncDefLen( b, itemLen);
itemLen += BEncTag1(b, CNTX, PRIM, 2);

totalLen += itemLen;
}


and

if (NOT_NULL((v->e_delivery_mode.octs)))
{
itemLen = BEncAsnOidContent( b, (&v->e_delivery_mode));
itemLen += BEncDefLen( b, itemLen);
itemLen += BEncTag1(b, CNTX, PRIM, 0);

totalLen += itemLen;
}


in file iso_10161_ill_1_2.c 


To test unknown oid e_delivery_mode and document_type_id 
OBJECT IDENTIFER fields in Electronic_Delivery_Service 


1) #ifdef out relevant 'if' in DBVunknown_external() in file z3950_externals.c
2) #ifdef out relevant 'if' in DBVsnacc_to_dbv_anytype() in file z3950_externals.c


***********************************************************************/


/* Unlike for all other externals, the int->any Extension 
   external mapping and checking is embedded within the
   ILL code because its the most logical place for it */

/* Check to see if an int used for any mapping is unknown. int->Any
   mapping is used in the ILL Extension structure (Doh) */

int DBVunknown_any_int(unsigned long intval)
{

/****************
 No longer used
	if (intval != INTMAPTEST)
*****************/

        if (intval != SUBITO_ADDITIONAL_INFO)

		/* then we have an unknown external */
                return 1;

        /* else we have found an external we can decode by snacc hash tables */
        return 0;
}


/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/

/* Item Order Extended Service */

/* dbv -> snacc ansi Item Order Extended Service external */

int DBVdbv_to_snacc_itemorder_any(AsnAnyDefinedBy *any_type, DbvASN1External *dbv_external, jmp_buf env)
{
	/* Arrays of externals are used because snacc only generates code
	to free the contents of AnyDefinedBy types, not the types themselves */
	static ItemOrder itemorder_external[STRING_LEN];
 
        ItemOrder *itemorder_ptr;

	/* Set up the Item Order external */
	itemorder_ptr = &itemorder_external[current_itemorder];

	/* Clear the location (may have been used by the last PDU) */
	memset(itemorder_ptr, 0, sizeof(ItemOrder));

	DBVdbv_to_snacc_itemorder_main(itemorder_ptr, dbv_external->uExternalValue.psSingleASN1Type->uASN1.psItemOrderExtendedService, env);

	/* Now add the external we have just defined to the external field 
	   in the PDU. single_ASN1_type is used for all V3 externals */
	any_type->value = (void *) &itemorder_external[current_itemorder];

	/* Only if not at end of array */
	if (current_itemorder < (STRING_LEN - 1)) {

		/* Increment current_itemorder for the next external 
		  (remember that there can be more than one external 
		  of the same type in searchResponse PDUs) */ 
		current_itemorder++;
	}
}



/* dbv -> snacc iso Item Order Extended Service external */


int DBVdbv_to_snacc_isoitemorder_any(AsnAnyDefinedBy *any_type, DbvASN1External *dbv_external, jmp_buf env)
{
	static IsoItemOrder isoitemorder_external[STRING_LEN];
        IsoItemOrder *isoitemorder_ptr;

	isoitemorder_ptr = &isoitemorder_external[current_isoitemorder];
	memset(isoitemorder_ptr, 0, sizeof(IsoItemOrder));
	DBVdbv_to_snacc_itemorder_main(isoitemorder_ptr, dbv_external->uExternalValue.psSingleASN1Type->uASN1.psItemOrderExtendedService, env);
	any_type->value = (void *) &isoitemorder_external[current_isoitemorder];

	if (current_isoitemorder < (STRING_LEN - 1)) {
		current_isoitemorder++;
	}
}




int DBVdbv_to_snacc_itemorder_main(ItemOrder *itemorder_ptr, struct DbvItemOrderExtendedService *psItemOrderExtendedService, jmp_buf env)
{

	switch (psItemOrderExtendedService->eItemOrderReqRsp) {
	case IOROR_Request:
		itemorder_ptr->choiceId = ITEMORDER_ESREQUEST;
		itemorder_ptr->a.esRequest = (struct ItemOrderSeq *) Asn1Alloc (sizeof(struct ItemOrderSeq));
		CheckAsn1Alloc(itemorder_ptr->a.esRequest, env);

		DBVdbv_to_snacc_itemorder_esreq(itemorder_ptr->a.esRequest, psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderRequest, env);
		break;
	case IOROR_Response:
		itemorder_ptr->choiceId = ITEMORDER_TASKPACKAGE;
		itemorder_ptr->a.taskPackage = (struct ItemOrderSeq1 *) Asn1Alloc (sizeof(struct ItemOrderSeq1));
		CheckAsn1Alloc(itemorder_ptr->a.taskPackage, env);

		DBVdbv_to_snacc_itemorder_taspack(itemorder_ptr->a.taskPackage, psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderResponse, env);
		break;
	}
}



int DBVdbv_to_snacc_itemorder_esreq(struct ItemOrderSeq* esRequest, DbvEsIoRequest *psItemOrderRequest, jmp_buf env)
{

	if (psItemOrderRequest->psToKeep != NULL) {
		esRequest->toKeep = (struct OriginPartToKeep4 *) Asn1Alloc (sizeof (struct OriginPartToKeep4));
		CheckAsn1Alloc(esRequest->toKeep, env);

		DBVdbv_to_snacc_io_parttokeep5(esRequest->toKeep, psItemOrderRequest->psToKeep, env);
	}

	/* sTargetPart is compulsory */
	esRequest->notToKeep = (struct OriginPartNotToKeep4*) Asn1Alloc (sizeof (struct OriginPartNotToKeep4));
	CheckAsn1Alloc(esRequest->notToKeep, env);
	DBVdbv_to_snacc_io_partnottokeep5(esRequest->notToKeep, &psItemOrderRequest->sNotToKeep, env);
}


int DBVdbv_to_snacc_io_parttokeep5(struct OriginPartToKeep4* toKeep, DbvEsIoOriginPartToKeep *psOriginPart, jmp_buf env)
{
	/* All optional */

	if (psOriginPart->psSupplementalDescription != NULL) {
		toKeep->supplDescription = (struct NEWEXTERNAL *) Asn1Alloc (sizeof (struct NEWEXTERNAL));
		CheckAsn1Alloc(toKeep->supplDescription, env);
		DBVdbv_to_snacc_external(toKeep->supplDescription, psOriginPart->psSupplementalDescription, env);
	}

	if (psOriginPart->psContact != NULL) {
		toKeep->contact = (struct OriginPartToKeep4Seq *) Asn1Alloc (sizeof (struct OriginPartToKeep4Seq));
		CheckAsn1Alloc(toKeep->contact, env);
		DBVdbv_to_snacc_contact(toKeep->contact, psOriginPart->psContact, env);
	}
		
	if (psOriginPart->psAdditionalBilling != NULL) {
		toKeep->addlBilling = (struct OriginPartToKeep4Seq1 *) Asn1Alloc (sizeof (struct OriginPartToKeep4Seq1));
		CheckAsn1Alloc(toKeep->addlBilling, env);
		DBVdbv_to_snacc_addbilling(toKeep->addlBilling, psOriginPart->psAdditionalBilling, env);
	}
}



int DBVdbv_to_snacc_contact(struct OriginPartToKeep4Seq* contact, DbvEsIoContact *psContact, jmp_buf env)
{
	/* All optional */
	DBVdbv_to_snacc_inter_string(&contact->name, psContact->psName, env);
	DBVdbv_to_snacc_inter_string(&contact->phone, psContact->psPhone, env);
	DBVdbv_to_snacc_inter_string(&contact->email, psContact->psEmail, env);
}




int DBVdbv_to_snacc_addbilling(struct OriginPartToKeep4Seq1* addlBilling, DbvEsIoAdditionalBilling *psAdditionalBilling, jmp_buf env)
{
	addlBilling->paymentMethod = (struct OriginPartToKeep4Seq1Choice*) Asn1Alloc (sizeof (struct OriginPartToKeep4Seq1Choice));
	CheckAsn1Alloc(addlBilling->paymentMethod, env);
	DBVdbv_to_snacc_paymentmethod(addlBilling->paymentMethod, &psAdditionalBilling->sPaymentMethod, env);


	/* Remaining optional */

	DBVdbv_to_snacc_inter_string(&addlBilling->customerReference, psAdditionalBilling->psCustomerReference, env);


	DBVdbv_to_snacc_inter_string(&addlBilling->customerPONumber, psAdditionalBilling->psCustomerPONumber, env);
}




int DBVdbv_to_snacc_paymentmethod(struct OriginPartToKeep4Seq1Choice* paymentMethod, DbvEsIoPaymentMethod *psPaymentMethod, jmp_buf env)
{
	switch (psPaymentMethod->ePaymentMethodType) {
	case IOPM_BillInvoice:
		paymentMethod->choiceId = ORIGINPARTTOKEEP4SEQ1CHOICE_BILLINVOICE; 
		break;
	case IOPM_Prepay:
		paymentMethod->choiceId = ORIGINPARTTOKEEP4SEQ1CHOICE_PREPAY; 
		break;
	case IOPM_DepositAccount:
		paymentMethod->choiceId = ORIGINPARTTOKEEP4SEQ1CHOICE_DEPOSITACCOUNT; 
		break;
	case IOPM_CreditCard:
		paymentMethod->choiceId = ORIGINPARTTOKEEP4SEQ1CHOICE_CREDITCARD; 
		paymentMethod->a.creditCard = (struct CreditCardInfo*) Asn1Alloc (sizeof (struct CreditCardInfo));
		CheckAsn1Alloc(paymentMethod->a.creditCard, env);

		/* Note: pointer to a union here */
		DBVdbv_to_snacc_creditcard(paymentMethod->a.creditCard, psPaymentMethod->puPaymentMethod->psCreditCardInfo, env);
		break;
	case IOPM_CardInfoPrevSupplied:
		paymentMethod->choiceId = ORIGINPARTTOKEEP4SEQ1CHOICE_CARDINFOPREVIOUSLYSUPPLIED; 
		break;
	case IOPM_PrivateKnown:
		paymentMethod->choiceId = ORIGINPARTTOKEEP4SEQ1CHOICE_PRIVATEKNOWN; 
		break;
	case IOPM_PrivateNotKnown:
		paymentMethod->choiceId = ORIGINPARTTOKEEP4SEQ1CHOICE_PRIVATENOTKNOWN; 
		paymentMethod->a.privateNotKnown = (struct NEWEXTERNAL*) Asn1Alloc (sizeof (struct NEWEXTERNAL));
		CheckAsn1Alloc(paymentMethod->a.privateNotKnown, env);
		DBVdbv_to_snacc_external(paymentMethod->a.privateNotKnown,  psPaymentMethod->puPaymentMethod->psPrivateNotKnown, env); 
		break;
	}
}



int DBVdbv_to_snacc_creditcard(struct CreditCardInfo* creditCard, DbvEsIoCreditCardInfo *psCreditCardInfo, jmp_buf env)
{

	/* All compulsory */

	DBVdbv_to_snacc_inter_string(&creditCard->nameOnCard, &psCreditCardInfo->sNameOnCard, env);
	DBVdbv_to_snacc_inter_string(&creditCard->expirationDate, &psCreditCardInfo->sExpirationDate, env);
	DBVdbv_to_snacc_inter_string(&creditCard->cardNumber, &psCreditCardInfo->sCardNumber, env);

}



int DBVdbv_to_snacc_io_partnottokeep5(struct OriginPartNotToKeep4* notToKeep, DbvEsIoOriginPartNotToKeep *psNotToKeep, jmp_buf env)
{
	/* Both optional */
	if (psNotToKeep->psResultSetItem != NULL) {
		notToKeep->resultSetItem = (struct OriginPartNotToKeep4Seq *) Asn1Alloc (sizeof (struct OriginPartNotToKeep4Seq));
		CheckAsn1Alloc(notToKeep->resultSetItem, env);

		DBVdbv_to_snacc_resset(notToKeep->resultSetItem, psNotToKeep->psResultSetItem, env);
	}

	if (psNotToKeep->psItemRequest != NULL) {
		notToKeep->itemRequest = (struct NEWEXTERNAL*) Asn1Alloc (sizeof (struct NEWEXTERNAL));
		CheckAsn1Alloc(notToKeep->itemRequest, env);

		DBVdbv_to_snacc_external(notToKeep->itemRequest, psNotToKeep->psItemRequest, env);
	}
}




int DBVdbv_to_snacc_resset(struct OriginPartNotToKeep4Seq* resultSetItem, DbvEsIoResultSetItem *psResultSetitem, jmp_buf env)
{
	/* Both compulosry */
	DBVdbv_to_snacc_inter_string(&resultSetItem->resultSetId, &psResultSetitem->sResultSetId, env);
	
	resultSetItem->item = psResultSetitem->ulItem;
}



int DBVdbv_to_snacc_itemorder_taspack(struct ItemOrderSeq1* taskPackage, DbvEsIoTaskPackage *psItemOrderResponse, jmp_buf env)
{
	/* First optional */
	if (psItemOrderResponse->psOriginPart != NULL) {
		taskPackage->originPart = (struct OriginPartToKeep4*) Asn1Alloc (sizeof (struct OriginPartToKeep4));
		CheckAsn1Alloc(taskPackage->originPart, env);

		/* Following function defined erlier */
		DBVdbv_to_snacc_io_parttokeep5(taskPackage->originPart, psItemOrderResponse->psOriginPart, env);
	}


	
	taskPackage->targetPart = (struct TargetPart4*) Asn1Alloc (sizeof (struct TargetPart4));
	CheckAsn1Alloc(taskPackage->targetPart, env);
	Dbvdbv_to_snacc_io_targetpart(taskPackage->targetPart, &psItemOrderResponse->sTargetPart, env);
	

}




int Dbvdbv_to_snacc_io_targetpart(struct TargetPart4 *targetPart, DbvEsIoTargetPart *psTargetPart, jmp_buf env)
{
	/* All optional */


	if (psTargetPart->psItemRequest != NULL) {
		targetPart->itemRequest = (struct NEWEXTERNAL*) Asn1Alloc (sizeof (struct NEWEXTERNAL));
		CheckAsn1Alloc(targetPart->itemRequest, env);
		DBVdbv_to_snacc_external(targetPart->itemRequest, psTargetPart->psItemRequest, env);
	}


	if (psTargetPart->psStatusOrErrorReport != NULL) {
		targetPart->statusOrErrorReport = (struct NEWEXTERNAL*) Asn1Alloc (sizeof (struct NEWEXTERNAL));
		CheckAsn1Alloc(targetPart->statusOrErrorReport, env);
		DBVdbv_to_snacc_external(targetPart->statusOrErrorReport, psTargetPart->psStatusOrErrorReport, env);
	}


	if (psTargetPart->peAuxiliaryStatus != NULL) {
		targetPart->auxiliaryStatus = (TargetPart4Int *) Asn1Alloc (sizeof (TargetPart4Int));
		CheckAsn1Alloc(targetPart->auxiliaryStatus, env);
		DBVdbv_to_snacc_auxstat(targetPart->auxiliaryStatus, psTargetPart->peAuxiliaryStatus);
	}
}



int DBVdbv_to_snacc_auxstat(TargetPart4Int *auxiliaryStatus, DbvEsIoAuxiliaryStatus *peAuxiliaryStatus)
{
	switch (*peAuxiliaryStatus) {
	case IOAS_NotReceived:
		*auxiliaryStatus = NOTRECEIVED;
		break;
	case IOAS_LoanQueue:
		*auxiliaryStatus = LOANQUEUE;
		break;
	case IOAS_Forwarded:
		*auxiliaryStatus = FORWARDED;
		break;
	case IOAS_UnfilledCopyright:
		*auxiliaryStatus = UNFILLEDCOPYRIGHT;
		break;
	case IOAS_FilledCopyright:
		*auxiliaryStatus = FILLEDCOPYRIGHT;
		break;
	}
}



/* snacc -> dbv ansi Item Order  Extended Service external */
int DBVsnacc_to_dbv_itemorder_any(DbvSingleASN1Type *psSingleASN1Type, AsnAnyDefinedBy *any_type, jmp_buf env)
{
	ItemOrder *itemorder_ptr;
 
	itemorder_ptr = (ItemOrder *) any_type->value;

        psSingleASN1Type->eASN1Type = AT_ItemOrderExtendedService;
        psSingleASN1Type->uASN1.psItemOrderExtendedService = (struct DbvItemOrderExtendedService *) DbvAlloc (sizeof(struct DbvItemOrderExtendedService));
	CheckDbvAlloc(psSingleASN1Type->uASN1.psItemOrderExtendedService, env);

	DBVsnacc_to_dbv_itemorder_main(psSingleASN1Type->uASN1.psItemOrderExtendedService, itemorder_ptr, env);
}



int DBVsnacc_to_dbv_isoitemorder_any(DbvSingleASN1Type *psSingleASN1Type, AsnAnyDefinedBy *any_type, jmp_buf env)
{
	IsoItemOrder *isoitemorder_ptr;
 
	isoitemorder_ptr = (ItemOrder *) any_type->value;

        psSingleASN1Type->eASN1Type = AT_ItemOrderExtendedService;
        psSingleASN1Type->uASN1.psItemOrderExtendedService = (struct DbvItemOrderExtendedService *) DbvAlloc (sizeof(struct DbvItemOrderExtendedService));
	CheckDbvAlloc(psSingleASN1Type->uASN1.psItemOrderExtendedService, env);

	DBVsnacc_to_dbv_itemorder_main(psSingleASN1Type->uASN1.psItemOrderExtendedService, isoitemorder_ptr, env);
}





int DBVsnacc_to_dbv_itemorder_main(struct DbvItemOrderExtendedService *psItemOrderExtendedService, ItemOrder *itemorder_ptr, jmp_buf env)
{
	switch (itemorder_ptr->choiceId) {
	case ITEMORDER_ESREQUEST:
		psItemOrderExtendedService->eItemOrderReqRsp = IOROR_Request;
		psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderRequest = (DbvEsIoRequest *) DbvAlloc (sizeof(DbvEsIoRequest));
		CheckDbvAlloc(psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderRequest, env);

		DBVsnacc_to_dbv_itemorderreq(psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderRequest, itemorder_ptr->a.esRequest, env);
		break;
	case ITEMORDER_TASKPACKAGE:
		psItemOrderExtendedService->eItemOrderReqRsp = IOROR_Response;
		psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderResponse = (DbvEsIoTaskPackage *) DbvAlloc (sizeof(DbvEsIoTaskPackage));
		CheckDbvAlloc(psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderResponse, env);

		DBVsnacc_to_dbv_itemorderrsp(psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderResponse, itemorder_ptr->a.taskPackage, env);
		break;
	}
}



int DBVsnacc_to_dbv_itemorderreq(DbvEsIoRequest *psItemOrderRequest, struct ItemOrderSeq *esRequest, jmp_buf env)
{
	/* First optional */
	if (esRequest->toKeep != NULL) {
		psItemOrderRequest->psToKeep = (DbvEsIoOriginPartToKeep *) DbvAlloc (sizeof (DbvEsIoOriginPartToKeep));
		CheckDbvAlloc(psItemOrderRequest->psToKeep, env);

		DBVsnacc_to_dbv_itemorder_keep(psItemOrderRequest->psToKeep, esRequest->toKeep, env);
	}

	DBVsnacc_to_dbv_itemorder_notkeep(&psItemOrderRequest->sNotToKeep, esRequest->notToKeep, env);
	
}



int DBVsnacc_to_dbv_itemorder_keep(DbvEsIoOriginPartToKeep *psToKeep, struct OriginPartToKeep4* toKeep, jmp_buf env)
{
	/* All optional */
	if (toKeep->supplDescription != NULL) {
		psToKeep->psSupplementalDescription = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));
		CheckDbvAlloc(psToKeep->psSupplementalDescription, env);

		DBVsnacc_to_dbv_external(psToKeep->psSupplementalDescription, toKeep->supplDescription, env);
	}


	if (toKeep->contact != NULL) {
		psToKeep->psContact = (DbvEsIoContact *) DbvAlloc (sizeof (DbvEsIoContact));
		CheckDbvAlloc(psToKeep->psContact, env);
		DBVsnacc_to_dbv_contact(psToKeep->psContact, toKeep->contact, env);
	}


	if (toKeep->addlBilling != NULL) {
		psToKeep->psAdditionalBilling = (DbvEsIoAdditionalBilling *) DbvAlloc (sizeof (DbvEsIoAdditionalBilling));
		CheckDbvAlloc(psToKeep->psAdditionalBilling, env);
		DBVsnacc_to_dbv_addbilling(psToKeep->psAdditionalBilling, toKeep->addlBilling, env);
	}
}



int DBVsnacc_to_dbv_contact(DbvEsIoContact *psContact, struct OriginPartToKeep4Seq* contact, jmp_buf env)
{
	/* All these dudes optional */

	if (contact->name.octetLen != 0) {
		psContact->psName = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
		CheckDbvAlloc(psContact->psName, env);
		DBVsnacc_to_dbv_inter_string(psContact->psName, &contact->name, env);	
	}

	if (contact->phone.octetLen != 0) {
		psContact->psPhone = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
		CheckDbvAlloc(psContact->psPhone, env);
		DBVsnacc_to_dbv_inter_string(psContact->psPhone, &contact->phone, env);	
	}


	if (contact->email.octetLen != 0) {
		psContact->psEmail = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
		CheckDbvAlloc(psContact->psEmail, env);
		DBVsnacc_to_dbv_inter_string(psContact->psEmail, &contact->email, env);	
	}
}



int DBVsnacc_to_dbv_addbilling(DbvEsIoAdditionalBilling *psAdditionalBilling, struct OriginPartToKeep4Seq1* addlBilling, jmp_buf env)
{
	/* First compulsory */
	DBVsnacc_to_dbv_payment(&psAdditionalBilling->sPaymentMethod, addlBilling->paymentMethod, env);

	/* Remaining optional */

	if (addlBilling->customerReference.octetLen != 0) {
		psAdditionalBilling->psCustomerReference = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
		CheckDbvAlloc(psAdditionalBilling->psCustomerReference, env);
		DBVsnacc_to_dbv_inter_string(psAdditionalBilling->psCustomerReference, &addlBilling->customerReference, env);
	}


	if (addlBilling->customerPONumber.octetLen != 0) {
		psAdditionalBilling->psCustomerPONumber = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
		CheckDbvAlloc(psAdditionalBilling->psCustomerPONumber, env);
		DBVsnacc_to_dbv_inter_string(psAdditionalBilling->psCustomerPONumber, &addlBilling->customerPONumber, env);
	}


}



int DBVsnacc_to_dbv_payment(DbvEsIoPaymentMethod *psPaymentMethod, struct OriginPartToKeep4Seq1Choice* paymentMethod, jmp_buf env)
{
	switch (paymentMethod->choiceId) {
	case ORIGINPARTTOKEEP4SEQ1CHOICE_BILLINVOICE:
		psPaymentMethod->ePaymentMethodType = IOPM_BillInvoice;
		break;
	case ORIGINPARTTOKEEP4SEQ1CHOICE_PREPAY:
		psPaymentMethod->ePaymentMethodType = IOPM_Prepay;
		break;
	case ORIGINPARTTOKEEP4SEQ1CHOICE_DEPOSITACCOUNT:
		psPaymentMethod->ePaymentMethodType = IOPM_DepositAccount;
		break;
	case ORIGINPARTTOKEEP4SEQ1CHOICE_CREDITCARD:
		psPaymentMethod->ePaymentMethodType = IOPM_CreditCard;
		psPaymentMethod->puPaymentMethod = (union uPaymentMethod *) DbvAlloc (sizeof (union uPaymentMethod));
		CheckDbvAlloc(psPaymentMethod->puPaymentMethod, env);

		psPaymentMethod->puPaymentMethod->psCreditCardInfo = (DbvEsIoCreditCardInfo *) DbvAlloc(sizeof(DbvEsIoCreditCardInfo));
		CheckDbvAlloc(psPaymentMethod->puPaymentMethod->psCreditCardInfo, env);
		DBVsnacc_to_dbv_creditcard(psPaymentMethod->puPaymentMethod->psCreditCardInfo, paymentMethod->a.creditCard, env);

		
		break;
	case ORIGINPARTTOKEEP4SEQ1CHOICE_CARDINFOPREVIOUSLYSUPPLIED:
		psPaymentMethod->ePaymentMethodType = IOPM_CardInfoPrevSupplied;
		break;
	case ORIGINPARTTOKEEP4SEQ1CHOICE_PRIVATEKNOWN:
		psPaymentMethod->ePaymentMethodType = IOPM_PrivateKnown;
		break;
	case ORIGINPARTTOKEEP4SEQ1CHOICE_PRIVATENOTKNOWN:
		psPaymentMethod->ePaymentMethodType = IOPM_PrivateNotKnown;
		psPaymentMethod->puPaymentMethod = (union uPaymentMethod *) DbvAlloc (sizeof (union uPaymentMethod));
		CheckDbvAlloc(psPaymentMethod->puPaymentMethod, env);

		psPaymentMethod->puPaymentMethod->psPrivateNotKnown = (DbvASN1External *) DbvAlloc(sizeof(DbvASN1External));
		CheckDbvAlloc(psPaymentMethod->puPaymentMethod->psPrivateNotKnown, env);
		DBVsnacc_to_dbv_external(psPaymentMethod->puPaymentMethod->psPrivateNotKnown, paymentMethod->a.privateNotKnown, env);

		break;
	default:
		psPaymentMethod->ePaymentMethodType = IOPM_Invalid;
		break;
	}

		
	
}



int DBVsnacc_to_dbv_creditcard(DbvEsIoCreditCardInfo *psCreditCardInfo, struct CreditCardInfo* creditCard, jmp_buf env)
{
	/* All the following compulsory */
	DBVsnacc_to_dbv_inter_string(&psCreditCardInfo->sNameOnCard, &creditCard->nameOnCard, env);
	DBVsnacc_to_dbv_inter_string(&psCreditCardInfo->sExpirationDate, &creditCard->expirationDate, env);
	DBVsnacc_to_dbv_inter_string(&psCreditCardInfo->sCardNumber, &creditCard->cardNumber, env);
}



int DBVsnacc_to_dbv_itemorder_notkeep(DbvEsIoOriginPartNotToKeep *psNotToKeep, struct OriginPartNotToKeep4* notToKeep, jmp_buf env)
{
	/* Both optional */
	if (notToKeep->resultSetItem != NULL) {
		psNotToKeep->psResultSetItem = (DbvEsIoResultSetItem *) DbvAlloc (sizeof (DbvEsIoResultSetItem));
		CheckDbvAlloc(psNotToKeep->psResultSetItem, env);

		Dbvsnacc_to_dbv_resset(psNotToKeep->psResultSetItem, notToKeep->resultSetItem, env);
	}


	if (notToKeep->itemRequest != NULL) {
		psNotToKeep->psItemRequest = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));
		CheckDbvAlloc(psNotToKeep->psItemRequest, env);

		DBVsnacc_to_dbv_external(psNotToKeep->psItemRequest, notToKeep->itemRequest, env);
	}
}



int Dbvsnacc_to_dbv_resset(DbvEsIoResultSetItem *psResultSetitem,  struct OriginPartNotToKeep4Seq *resultSetItem, jmp_buf env)
{
	DBVsnacc_to_dbv_inter_string(&psResultSetitem->sResultSetId, &resultSetItem->resultSetId, env);

	psResultSetitem->ulItem = resultSetItem->item;
}



int DBVsnacc_to_dbv_itemorderrsp(DbvEsIoTaskPackage *psItemOrderResponse, struct ItemOrderSeq1 *taskPackage, jmp_buf env)
{
	if (taskPackage->originPart != NULL) {
		psItemOrderResponse->psOriginPart = (DbvEsIoOriginPartToKeep *) DbvAlloc (sizeof (DbvEsIoOriginPartToKeep));
		CheckDbvAlloc(psItemOrderResponse->psOriginPart, env);

		DBVsnacc_to_dbv_itemorder_keep(psItemOrderResponse->psOriginPart, taskPackage->originPart, env);
	}
 
	DBVsnacc_to_dbv_io_target(&psItemOrderResponse->sTargetPart, taskPackage->targetPart, env);
	
}



int DBVsnacc_to_dbv_io_target(DbvEsIoTargetPart *psTargetPart, struct TargetPart4* targetPart, jmp_buf env)
{
	/* All optional */
	if (targetPart->itemRequest != NULL) {
		psTargetPart->psItemRequest = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));
		CheckDbvAlloc(psTargetPart->psItemRequest,env);

		DBVsnacc_to_dbv_external(psTargetPart->psItemRequest, targetPart->itemRequest, env);
	}


	if (targetPart->statusOrErrorReport != NULL) {
		psTargetPart->psStatusOrErrorReport = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));
		CheckDbvAlloc(psTargetPart->psStatusOrErrorReport,env);

		DBVsnacc_to_dbv_external(psTargetPart->psStatusOrErrorReport, targetPart->statusOrErrorReport, env);
	}

	
	if (targetPart->auxiliaryStatus != NULL) {
		psTargetPart->peAuxiliaryStatus = (DbvEsIoAuxiliaryStatus *) DbvAlloc(sizeof (DbvEsIoAuxiliaryStatus));
		CheckDbvAlloc(psTargetPart->peAuxiliaryStatus, env);

		DBVsnacc_to_dbv_auxstat(psTargetPart->peAuxiliaryStatus, targetPart->auxiliaryStatus, env);
	}

}



int DBVsnacc_to_dbv_auxstat(DbvEsIoAuxiliaryStatus *peAuxiliaryStatus, TargetPart4Int *auxiliaryStatus, jmp_buf env)
{
	switch (*auxiliaryStatus) {
	case NOTRECEIVED:
		*peAuxiliaryStatus = IOAS_NotReceived;
		break;
	case LOANQUEUE:
		*peAuxiliaryStatus = IOAS_LoanQueue;
		break;
	case FORWARDED:
		*peAuxiliaryStatus = IOAS_Forwarded;
		break;
	case UNFILLEDCOPYRIGHT:
		*peAuxiliaryStatus = IOAS_UnfilledCopyright;
		break;
	case FILLEDCOPYRIGHT:
		*peAuxiliaryStatus = IOAS_FilledCopyright;
		break;
	default:
		*peAuxiliaryStatus = IOAS_Invalid;
		break;
	}
}






/***************************************************************************/
/***************************************************************************/
/**************************************************************************/
/***************************************************************************/
/***************************************************************************/

/* ILL report */


/* dbv -> snacc iso ill external */

int DBVdbv_to_snacc_isoillrequest_any(AsnAnyDefinedBy *any_type, DbvASN1External *dbv_external, jmp_buf env)
{
	/* Arrays of externals are used because snacc only generates code
	to free the contents of AnyDefinedBy types, not the types themselves */
	static ILL_APDU ill_external[STRING_LEN];
 
        ILL_APDU *ill_ptr;

	/* Set up the Item Order external */
	ill_ptr = &ill_external[current_isoill];

	/* Clear the location (may have been used by the last PDU) */
	memset(ill_ptr, 0, sizeof(ILL_APDU));

	DBVdbv_to_snacc_ill_main(ill_ptr, dbv_external->uExternalValue.psSingleASN1Type->uASN1.psIllPdu, env);

	/* Now add the external we have just defined to the external field 
	   in the PDU. single_ASN1_type is used for all V3 externals */
	any_type->value = (void *) &ill_external[current_isoill];

	/* Only if not at end of array */
	if (current_isoill < (STRING_LEN - 1)) {

		/* Increment current_ill for the next external 
		  (remember that there can be more than one external 
		  of the same type in searchResponse PDUs) */ 
		current_isoill++;
	}
}



int DBVdbv_to_snacc_ill_main(ILL_APDU *ill_ptr, struct DbvIllPdu *psIllPdu, jmp_buf env)
{
	switch (psIllPdu->eIllPduType) {
	case ILL_IllRequest:
		ill_ptr->choiceId = ILL_APDU_ILL_REQUEST;
		ill_ptr->a.iLL_Request = (struct ILL_Request*) Asn1Alloc (sizeof (struct ILL_Request));
		CheckAsn1Alloc(ill_ptr->a.iLL_Request, env);
		DBVdbv_to_snacc_illreq(ill_ptr->a.iLL_Request, psIllPdu->uIllPdu.psIllRequest, env);
		break;
	case ILL_StatusOrErrorReport:
		ill_ptr->choiceId = ILL_APDU_STATUS_OR_ERROR_REPORT;
		ill_ptr->a.status_Or_Error_Report = (struct Status_Or_Error_Report*) Asn1Alloc (sizeof (struct Status_Or_Error_Report));
		CheckAsn1Alloc(ill_ptr->a.status_Or_Error_Report, env);
		DBVdbv_to_snacc_illstaterror(ill_ptr->a.status_Or_Error_Report, psIllPdu->uIllPdu.psStatusOrErrorReport, env);
		break;
	}
}



int DBVdbv_to_snacc_illreq(struct ILL_Request *iLL_Request, struct DbvIllRequest *psIllRequest, jmp_buf env)
{
	/* First three compulsory */
	DBVdbv_to_snacc_prover(&iLL_Request->protocol_version_num, &psIllRequest->eProtocolVersion, env);

	iLL_Request->transaction_id = (struct Transaction_Id*) Asn1Alloc (sizeof (struct Transaction_Id));
	CheckAsn1Alloc(iLL_Request->transaction_id, env);
	DBVdbv_to_snacc_transid(iLL_Request->transaction_id, &psIllRequest->sTransactionId, env); 

	iLL_Request->service_date_time = (struct Service_Date_Time*) Asn1Alloc (sizeof (struct Service_Date_Time));
	CheckAsn1Alloc(iLL_Request->service_date_time, env);
	DBVdbv_to_snacc_servdt(iLL_Request->service_date_time, &psIllRequest->sServiceDateTime, env);
	

	/* optional */
	if (psIllRequest->psRequesterId != NULL) {
		iLL_Request->requester_id = (struct System_Id*) Asn1Alloc(sizeof(struct System_Id));
		CheckAsn1Alloc(iLL_Request->requester_id, env);
		DBVdbv_to_snacc_systemid(iLL_Request->requester_id, psIllRequest->psRequesterId, env);
	}


	/* optional */
	if (psIllRequest->psResponderId != NULL) {
		iLL_Request->responder_id = (struct System_Id*) Asn1Alloc(sizeof(struct System_Id));
		CheckAsn1Alloc(iLL_Request->responder_id, env);
		DBVdbv_to_snacc_systemid(iLL_Request->responder_id, psIllRequest->psResponderId, env);
	}


	/* default so optional */
	if (psIllRequest->peTransactionType) {
		iLL_Request->transaction_type = (Transaction_Type*) Asn1Alloc(sizeof(Transaction_Type));
		CheckAsn1Alloc(iLL_Request->transaction_type, env);
		DBVdbv_to_snacc_transaction_type(iLL_Request->transaction_type, psIllRequest->peTransactionType, env);
	}



	/* optional */
	if (psIllRequest->psDeliveryAddress != NULL) {
		iLL_Request->delivery_address = (struct Delivery_Address*) Asn1Alloc (sizeof (struct Delivery_Address));
		CheckAsn1Alloc(iLL_Request->delivery_address, env);
		DBVdbv_to_snacc_delivaddr(iLL_Request->delivery_address, psIllRequest->psDeliveryAddress, env);
	}
		

	/* optional */
	if (psIllRequest->psDeliveryService != NULL) {
		iLL_Request->delivery_service = (struct Delivery_Service*) Asn1Alloc (sizeof (struct Delivery_Service));
		CheckAsn1Alloc(iLL_Request->delivery_service, env);
		DBVdbv_to_snacc_delivserv(iLL_Request->delivery_service, psIllRequest->psDeliveryService, env);
	}
		
		
	/* optional */
	if (psIllRequest->psBillingAddress != NULL) {
		iLL_Request->billing_address = (struct Delivery_Address*) Asn1Alloc (sizeof (struct Delivery_Address));
		CheckAsn1Alloc(iLL_Request->billing_address, env);
		DBVdbv_to_snacc_delivaddr(iLL_Request->billing_address, psIllRequest->psBillingAddress, env);
	}
	

	/* compulsory */
	iLL_Request->iLL_service_type = AsnListNew(sizeof(void *));
        CheckAsn1Alloc(iLL_Request->iLL_service_type, env);
	DBVdbv_to_snacc_servtypelist(iLL_Request->iLL_service_type, psIllRequest->ppeServiceType, env);



	/* optional */
	if (psIllRequest->psResponderSpecificService != NULL) {
		iLL_Request->responder_specific_service = (struct NEWEXTERNAL* ) Asn1Alloc (sizeof (struct NEWEXTERNAL));
		CheckAsn1Alloc(iLL_Request->responder_specific_service, env);
		DBVdbv_to_snacc_external(iLL_Request->responder_specific_service, psIllRequest->psResponderSpecificService, env);
	}


	/* compulsory */
	iLL_Request->requester_optional_messages = (struct Requester_Optional_Messages_Type*) Asn1Alloc (sizeof(struct Requester_Optional_Messages_Type));
	CheckAsn1Alloc(iLL_Request->requester_optional_messages, env);
	DBVdbv_to_snacc_reqopmes(iLL_Request->requester_optional_messages, &psIllRequest->sRequesterOptionalMessages, env);


	/* optional */
	if (psIllRequest->psSearchType != NULL) {
		iLL_Request->search_type = (struct Search_Type*) Asn1Alloc (sizeof (struct Search_Type));
		CheckAsn1Alloc(iLL_Request->search_type, env);
		DBVdbv_to_snacc_searchtype(iLL_Request->search_type, psIllRequest->psSearchType, env);
	}

	/* optional */
	if (psIllRequest->ppsSupplyMediumInfo != NULL) {
		iLL_Request->supply_medium_info_type = AsnListNew(sizeof(void *));
        	CheckAsn1Alloc(iLL_Request->supply_medium_info_type, env);
		DBVdbv_to_snacc_suppmedinfolist(iLL_Request->supply_medium_info_type, psIllRequest->ppsSupplyMediumInfo, env);
	}
	

	/* default so optional */
	if (psIllRequest->pePlaceOnHold) {
		iLL_Request->place_on_hold = (Place_On_Hold_Type *) Asn1Alloc (sizeof (Place_On_Hold_Type));
		CheckAsn1Alloc(iLL_Request->place_on_hold, env);
		DBVdbv_to_snacc_ponhold(iLL_Request->place_on_hold, psIllRequest->pePlaceOnHold, env);
	}


	/* optional */
	if (psIllRequest->psClientId != NULL) {
		iLL_Request->client_id = (struct Client_Id*) Asn1Alloc (sizeof (struct Client_Id));
		CheckAsn1Alloc(iLL_Request->client_id, env);
		DBVdbv_to_snacc_clientid(iLL_Request->client_id, psIllRequest->psClientId, env);
	}


	/* compulsory */
	iLL_Request->item_id = (struct Item_Id*) Asn1Alloc (sizeof(struct Item_Id));
	CheckAsn1Alloc(iLL_Request->item_id, env);
	DBVdbv_to_snacc_itemid(iLL_Request->item_id, &psIllRequest->sItemId, env);


	/* optional */
	if (psIllRequest->ppsSupplementalItemDescription != NULL) {
		iLL_Request->supplemental_item_description =  AsnListNew(sizeof(void *));
		CheckAsn1Alloc(iLL_Request->supplemental_item_description, env);
		DBVdbv_to_snacc_suppdesc(iLL_Request->supplemental_item_description, psIllRequest->ppsSupplementalItemDescription, env);
	}


	/* optional */
	if (psIllRequest->psCostInfo != NULL) {
		iLL_Request->cost_info_type = (struct Cost_Info_Type*) Asn1Alloc (sizeof (struct Cost_Info_Type));
		CheckAsn1Alloc(iLL_Request->cost_info_type, env);
		DBVdbv_to_snacc_costinfo(iLL_Request->cost_info_type, psIllRequest->psCostInfo, env);
	}



		
	/* optional */
	if (psIllRequest->psCopyrightCompliance != NULL) {
		iLL_Request->copyright_compliance = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(iLL_Request->copyright_compliance, env);
		DBVdbv_to_snacc_illstring(iLL_Request->copyright_compliance, psIllRequest->psCopyrightCompliance, env);
	}


	/* optional */
	if (psIllRequest->psThirdPartyInfo != NULL) {
		iLL_Request->third_party_info_type = (struct Third_Party_Info_Type*) Asn1Alloc (sizeof (struct Third_Party_Info_Type));
		CheckAsn1Alloc(iLL_Request->third_party_info_type, env);
		DBVdbv_to_snacc_thirdparty(iLL_Request->third_party_info_type, psIllRequest->psThirdPartyInfo, env);
	}
		

	/* default so optional */
	if (psIllRequest->pfRetry) {
		iLL_Request->retry_flag = (AsnBool*) Asn1Alloc (sizeof (AsnBool));
		CheckAsn1Alloc(iLL_Request->retry_flag, env);
		DBVdbv_to_snacc_DbvBool(iLL_Request->retry_flag, psIllRequest->pfRetry, env);
	}

	
	/* default so optional */
	if (psIllRequest->pfForward) {
		iLL_Request->forward_flag = (AsnBool*) Asn1Alloc (sizeof (AsnBool));
		CheckAsn1Alloc(iLL_Request->forward_flag, env);
		DBVdbv_to_snacc_DbvBool(iLL_Request->forward_flag, psIllRequest->pfForward, env);
	}
	

	
	/* rest optional ... */
	if (psIllRequest->psRequesterNote != NULL) {
		iLL_Request->requester_note = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(iLL_Request->requester_note, env);
		DBVdbv_to_snacc_illstring(iLL_Request->requester_note, psIllRequest->psRequesterNote, env);
	}
		
	
	if (psIllRequest->psForwardNote != NULL) {
		iLL_Request->forward_note = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(iLL_Request->forward_note, env);
		DBVdbv_to_snacc_illstring(iLL_Request->forward_note, psIllRequest->psForwardNote, env);
	}


	if (psIllRequest->ppsRequestExtension != NULL) {
		iLL_Request->iLL_request_extensions = AsnListNew(sizeof(void *));
		CheckAsn1Alloc(iLL_Request->iLL_request_extensions, env);
		DBVdbv_to_snacc_requestext(iLL_Request->iLL_request_extensions, psIllRequest->ppsRequestExtension, env);
	}
		

}



int DBVdbv_to_snacc_prover(ILL_RequestInt *protocol_version_num, DbvIllProtocolVersion *eProtocolVersion, jmp_buf env)
{
	switch (*eProtocolVersion) {
	case PV_Version1:
		*protocol_version_num = VERSION_122;
		break;
	case PV_Version2:
		*protocol_version_num = VERSION_222;
		break;
	}
}



/* DbvTransactionId */

int DBVdbv_to_snacc_transid(struct Transaction_Id *transaction_id, DbvTransactionId *psTransactionId, jmp_buf env) 
{
	/* First optional */
	if (psTransactionId->psInitialRequesterId != NULL) {
		transaction_id->initial_requester_id = (struct System_Id*) Asn1Alloc (sizeof(struct System_Id));
		CheckAsn1Alloc(transaction_id->initial_requester_id, env);
		DBVdbv_to_snacc_systemid(transaction_id->initial_requester_id, psTransactionId->psInitialRequesterId, env);
	}
	

	/* Two compulsorys */
	transaction_id->transaction_group_qualifier = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String)); 
	CheckAsn1Alloc(transaction_id->transaction_group_qualifier, env);
	DBVdbv_to_snacc_illstring(transaction_id->transaction_group_qualifier, &psTransactionId->sTransactionGroupQualifier, env);

	transaction_id->transaction_qualifier = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String)); 
	CheckAsn1Alloc(transaction_id->transaction_qualifier, env);
	DBVdbv_to_snacc_illstring(transaction_id->transaction_qualifier, &psTransactionId->sTransactionQualifier, env);


	/* And an optional */

	if (psTransactionId->psSubTransactionQualifier != NULL) {
		transaction_id->sub_transaction_qualifier = (struct ILL_String*) Asn1Alloc (sizeof(struct ILL_String));
		CheckAsn1Alloc(transaction_id->sub_transaction_qualifier, env);
		DBVdbv_to_snacc_illstring(transaction_id->sub_transaction_qualifier, psTransactionId->psSubTransactionQualifier, env);
	}
}



int DBVdbv_to_snacc_systemid(struct System_Id* initial_requester_id, DbvSystemId *psInitialRequesterId, jmp_buf env)
{
	/* Both optional */
	if (psInitialRequesterId->psSymbol != NULL) {
		initial_requester_id->person_or_institution_symbol = (struct Person_Or_Institution_Symbol*) Asn1Alloc (sizeof(struct Person_Or_Institution_Symbol));
		CheckAsn1Alloc(initial_requester_id->person_or_institution_symbol, env);
		DBVdbv_to_snacc_person_or_inst_symb(initial_requester_id->person_or_institution_symbol, psInitialRequesterId->psSymbol, env);
	}

	if (psInitialRequesterId->psName != NULL) {
		initial_requester_id->name_of_person_or_institution = (struct Name_Of_Person_Or_Institution*) Asn1Alloc (sizeof(struct Name_Of_Person_Or_Institution));
		CheckAsn1Alloc(initial_requester_id->name_of_person_or_institution, env);
		DBVdbv_to_snacc_person_or_inst_name(initial_requester_id->name_of_person_or_institution, psInitialRequesterId->psName, env);
	}
}



int DBVdbv_to_snacc_person_or_inst_symb(struct Person_Or_Institution_Symbol *person_or_institution_symbol, DbvPersonOrInstitutionSymbol *psSymbol, jmp_buf env)
{

	/* A bit different here between dbv and snacc !! */

	switch (psSymbol->eSymbolType) {
	case SPI_PersonSymbol:
		person_or_institution_symbol->choiceId = PERSON_OR_INSTITUTION_SYMBOL_PERSON_SYMBOL;
		person_or_institution_symbol->a.person_symbol = (struct ILL_String*) Asn1Alloc (sizeof(struct ILL_String));
		CheckAsn1Alloc(person_or_institution_symbol->a.person_symbol, env);
		DBVdbv_to_snacc_illstring(person_or_institution_symbol->a.person_symbol, &psSymbol->sSymbol, env);
		break;
	case SPI_InstitutionSymbol:
		person_or_institution_symbol->choiceId = PERSON_OR_INSTITUTION_SYMBOL_INSTITUTION_SYMBOL;
		person_or_institution_symbol->a.institution_symbol = (struct ILL_String*) Asn1Alloc (sizeof(struct ILL_String));
		CheckAsn1Alloc(person_or_institution_symbol->a.institution_symbol, env);
		DBVdbv_to_snacc_illstring(person_or_institution_symbol->a.institution_symbol, &psSymbol->sSymbol, env);
		break;
	}
}



int DBVdbv_to_snacc_illstring(struct ILL_String* transaction_group_qualifier, DbvIllString *psTransactionGroupQualifier, jmp_buf env)
{
	switch (psTransactionGroupQualifier->eStringType) {
	case ST_GeneralString:
		transaction_group_qualifier->choiceId = ILL_STRING_GENERALSTRING;
		transaction_group_qualifier->a.generalString = (GeneralString *) Asn1Alloc (sizeof (GeneralString));
		CheckAsn1Alloc(transaction_group_qualifier->a.generalString, env);
		DBVdbv_to_snacc_general_string(transaction_group_qualifier->a.generalString, psTransactionGroupQualifier->uString.psGeneralString, env);
		break;
	case ST_EdifactString:
		transaction_group_qualifier->choiceId = ILL_STRING_EDIFACTSTRING;
		transaction_group_qualifier->a.eDIFACTString = (EDIFACTString *) Asn1Alloc (sizeof (EDIFACTString));
		CheckAsn1Alloc(transaction_group_qualifier->a.eDIFACTString, env);
		DBVdbv_to_snacc_vis_string(transaction_group_qualifier->a.generalString, psTransactionGroupQualifier->uString.pcVisibleString, env);
		break;
	}
}



int DBVdbv_to_snacc_general_string(GeneralString *generalString, DbvGeneralString *psGeneralString, jmp_buf env)
{
	DBVdbv_to_snacc_inter_string((InternationalString *) generalString, (DbvInternationalString *) psGeneralString, env);
}



int DBVdbv_to_snacc_person_or_inst_name(struct Name_Of_Person_Or_Institution* name_of_person_or_institution, DbvNameOfPersonOrInstitution *psName, jmp_buf env)
{
	switch (psName->eNameType) {
	case NPI_NameOfPerson:
		name_of_person_or_institution->choiceId = NAME_OF_PERSON_OR_INSTITUTION_NAME_OF_PERSON;
		name_of_person_or_institution->a.name_of_person = (struct ILL_String*) Asn1Alloc (sizeof(struct ILL_String));
		CheckAsn1Alloc(name_of_person_or_institution->a.name_of_person, env);
		DBVdbv_to_snacc_illstring(name_of_person_or_institution->a.name_of_person, &psName->sName, env);
		break;
	case NPI_NameOfInstitution:
		name_of_person_or_institution->choiceId = NAME_OF_PERSON_OR_INSTITUTION_NAME_OF_INSTITUTION;
		name_of_person_or_institution->a.name_of_institution = (struct ILL_String*) Asn1Alloc (sizeof(struct ILL_String));
		CheckAsn1Alloc(name_of_person_or_institution->a.name_of_institution, env);
		DBVdbv_to_snacc_illstring(name_of_person_or_institution->a.name_of_institution, &psName->sName, env);
		break;
	}
}



/* DbvServiceDateTime */
int DBVdbv_to_snacc_servdt(struct Service_Date_Time* service_date_time, DbvServiceDateTime *psServiceDateTime, jmp_buf env)
{
	/* compulsory */
	service_date_time->date_time_of_this_service = (struct Service_Date_TimeSeq*) Asn1Alloc (sizeof (struct Service_Date_TimeSeq));
	CheckAsn1Alloc(service_date_time->date_time_of_this_service, env);
	DBVdbv_to_snacc_datetime(service_date_time->date_time_of_this_service,  &psServiceDateTime->sThisService, env);

	/* optional */
	if (psServiceDateTime->psOriginalService != NULL)  {
		service_date_time->date_time_of_original_service = (struct Service_Date_TimeSeq1 *) Asn1Alloc (sizeof (struct Service_Date_TimeSeq1));
		DBVdbv_to_snacc_datetime((struct Service_Date_TimeSeq*) service_date_time->date_time_of_original_service, psServiceDateTime->psOriginalService, env);
	}

}



/* Note that in the following two functions the ISO date/time structure are 
the same although named differently !!  */

int DBVdbv_to_snacc_datetime(struct Service_Date_TimeSeq* date_time_of_this_service, DbvDateTime *psThisService, jmp_buf env)
{
	/* ISO_Date and ISO_Time are visible string */
	
	/* compulsory */
	DBVdbv_to_snacc_vis_string(&date_time_of_this_service->date, psThisService->pcDate, env);
	

	/* optional */
	if (psThisService->pcTime != NULL) 
		DBVdbv_to_snacc_vis_string(&date_time_of_this_service->time, psThisService->pcTime, env);
	
}



/* DbvTransactionType */
int DBVdbv_to_snacc_transaction_type(Transaction_Type *transaction_type, DbvTransactionType *peTransactionType, jmp_buf env)
{
	/* Default 1 */
	switch (*peTransactionType) {
	case TT_Simple:
		*transaction_type = SIMPLE;
		break;
	case TT_Chained:
		*transaction_type = CHAINED;
		break;
	case TT_Partitioned:
		*transaction_type = PARTITIONED;
		break;
	default:
		*transaction_type = SIMPLE;
		break;
	}
}


/* DbvDeliveryAddress */
int DBVdbv_to_snacc_delivaddr(struct Delivery_Address* delivery_address, DbvDeliveryAddress *psDeliveryAddress, jmp_buf env)
{
	/* Both optional */
	if (psDeliveryAddress->psPostalAddress != NULL) {
		delivery_address->postal_address = (struct Postal_Address*) Asn1Alloc (sizeof (struct Postal_Address));
		CheckAsn1Alloc(delivery_address->postal_address, env);
		DBVdbv_to_snacc_postaladdress(delivery_address->postal_address, psDeliveryAddress->psPostalAddress, env);
	}


	if (psDeliveryAddress->psElectronicAddress != NULL) {
		delivery_address->electronic_address = (struct System_Address*) Asn1Alloc (sizeof (struct System_Address));
		CheckAsn1Alloc(delivery_address->electronic_address, env);
		DBVdbv_to_snacc_electaddress(delivery_address->electronic_address, psDeliveryAddress->psElectronicAddress, env);
	}
}



int DBVdbv_to_snacc_postaladdress(struct Postal_Address* postal_address, DbvPostalAddress* psPostalAddress, jmp_buf env)
{
	/* All these dudes optional */

	if (psPostalAddress->psNameOfPersonOrInstitution != NULL) {
		postal_address->name_of_person_or_institution = (struct Name_Of_Person_Or_Institution* ) Asn1Alloc (sizeof (struct Name_Of_Person_Or_Institution));
		CheckAsn1Alloc(postal_address->name_of_person_or_institution, env);
		DBVdbv_to_snacc_person_or_inst_name(postal_address->name_of_person_or_institution, psPostalAddress->psNameOfPersonOrInstitution, env);
	}


	if (psPostalAddress->psExtendedPostalDeliveryAddress != NULL) {
		postal_address->extended_postal_delivery_address = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(postal_address->extended_postal_delivery_address, env);
		DBVdbv_to_snacc_illstring(postal_address->extended_postal_delivery_address, psPostalAddress->psExtendedPostalDeliveryAddress, env);
	}


		
	if (psPostalAddress->psStreetAndNumber != NULL) {
		postal_address->street_and_number = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(postal_address->street_and_number, env);
		DBVdbv_to_snacc_illstring(postal_address->street_and_number, psPostalAddress->psStreetAndNumber, env);
	}


		
	if (psPostalAddress->psPostOfficeBox != NULL) {
		postal_address->post_office_box = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(postal_address->post_office_box, env);
		DBVdbv_to_snacc_illstring(postal_address->post_office_box, psPostalAddress->psPostOfficeBox, env);
	}


		
	if (psPostalAddress->psCity != NULL) {
		postal_address->city = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(postal_address->city, env);
		DBVdbv_to_snacc_illstring(postal_address->city, psPostalAddress->psCity, env);
	}


		
	if (psPostalAddress->psRegion != NULL) {
		postal_address->region = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(postal_address->region, env);
		DBVdbv_to_snacc_illstring(postal_address->region, psPostalAddress->psRegion, env);
	}


		
	if (psPostalAddress->psCountry != NULL) {
		postal_address->country = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(postal_address->country, env);
		DBVdbv_to_snacc_illstring(postal_address->country, psPostalAddress->psCountry, env);
	}


	if (psPostalAddress->psPostalCode != NULL) {
		postal_address->postal_code = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(postal_address->postal_code, env);
		DBVdbv_to_snacc_illstring(postal_address->postal_code, psPostalAddress->psPostalCode, env);
	}
}



int DBVdbv_to_snacc_electaddress(struct System_Address* electronic_address, DbvSystemAddress *psElectronicAddress, jmp_buf env)
{
	/* Both optional */

	if (psElectronicAddress->psTelecomServiceIdentifier != NULL) {
		electronic_address->telecom_service_identifier = (struct ILL_String* ) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(electronic_address->telecom_service_identifier, env);
		DBVdbv_to_snacc_illstring(electronic_address->telecom_service_identifier, psElectronicAddress->psTelecomServiceIdentifier, env);
	}


	if (psElectronicAddress->psTelecomServiceAddress != NULL) {
		electronic_address->telecom_service_address = (struct ILL_String* ) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(electronic_address->telecom_service_address, env);
		DBVdbv_to_snacc_illstring(electronic_address->telecom_service_address, psElectronicAddress->psTelecomServiceAddress, env);
	}
}



/* DbvDeliveryService */
int DBVdbv_to_snacc_delivserv(struct Delivery_Service *delivery_service, DbvDeliveryService *psDeliveryService, jmp_buf env)
{
	switch (psDeliveryService->eDeliveryServiceType) {
	case DST_PhysicalDelivery:
		delivery_service->choiceId = DELIVERY_SERVICE_PHYSICAL_DELIVERY;
		delivery_service->a.physical_delivery = (Transportation_Mode *) Asn1Alloc (sizeof (Transportation_Mode));
		CheckAsn1Alloc(delivery_service->a.physical_delivery, env);
		DBVdbv_to_snacc_illstring(delivery_service->a.physical_delivery, psDeliveryService->uDeliveryService.psPhysicalDelivery, env);
		break;
	case DST_ElectronicDelivery:
		delivery_service->choiceId = DELIVERY_SERVICE_ELECTRONIC_DELIVERY;
		delivery_service->a.electronic_delivery = AsnListNew(sizeof(void *));
		CheckAsn1Alloc(delivery_service->a.electronic_delivery, env);
		DBVdbv_to_snacc_elecdelivlist(delivery_service->a.electronic_delivery, psDeliveryService->uDeliveryService.ppsElectronicDelivery, env);
		break;
	}
}



int DBVdbv_to_snacc_elecdelivlist(Delivery_ServiceSeqOf *electronic_delivery, DbvElectronicDeliveryService **ppsElectronicDelivery, jmp_buf env)
{
	Electronic_Delivery_Service *data_ptr;
	Electronic_Delivery_Service **data_ptr_address;
	
	int current_listnode = 0;	

	while (ppsElectronicDelivery[current_listnode] != NULL) {
                data_ptr_address = AsnListAppend(electronic_delivery);
                CheckAsn1Alloc(data_ptr_address, env);

                *data_ptr_address = Asn1Alloc(sizeof(Electronic_Delivery_Service));
                CheckAsn1Alloc(*data_ptr_address, env);

                data_ptr = *data_ptr_address;

                DBVdbv_to_snacc_elecdeliv(data_ptr, ppsElectronicDelivery[current_listnode], env);
                current_listnode++;
        }
}



int DBVdbv_to_snacc_elecdeliv(Electronic_Delivery_Service *data_ptr, DbvElectronicDeliveryService *psElectronicDelivery, jmp_buf env)
{
	/* First three optional */

	/* set up the dirties */
	if (psElectronicDelivery->psDeliveryParameter != NULL) 
		if (psElectronicDelivery->psDeliveryParameter->pcDeliveryMode != NULL) {
			ASN_MakeOid((char *) psElectronicDelivery->psDeliveryParameter->pcDeliveryMode, &data_ptr->e_delivery_mode, env);
			if (psElectronicDelivery->psDeliveryParameter->puDeliveryParameter != NULL)
				if (psElectronicDelivery->psDeliveryParameter->puDeliveryParameter->psDummy != NULL)
					DBVdbv_to_snacc_anytype(psElectronicDelivery->psDeliveryParameter->pcDeliveryMode, &data_ptr->e_delivery_parameters, psElectronicDelivery->psDeliveryParameter->puDeliveryParameter->psDummy, env);
		}

	
	
	if (psElectronicDelivery->psDocumentTypeParameter != NULL) 
		if (psElectronicDelivery->psDocumentTypeParameter->pcDocumentTypeId != NULL) {
			ASN_MakeOid((char *) psElectronicDelivery->psDocumentTypeParameter->pcDocumentTypeId, &data_ptr->document_type_id, env);
			if (psElectronicDelivery->psDocumentTypeParameter->puDocumentTypeParameter != NULL)
				if (psElectronicDelivery->psDocumentTypeParameter->puDocumentTypeParameter->psDummy != NULL)
					DBVdbv_to_snacc_anytype(psElectronicDelivery->psDocumentTypeParameter->pcDocumentTypeId, &data_ptr->document_type_parameters, psElectronicDelivery->psDocumentTypeParameter->puDocumentTypeParameter->psDummy, env);
		}
	
	
	if (psElectronicDelivery->psDeliveryDescription != NULL) {
		data_ptr->e_delivery_description = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(data_ptr->e_delivery_description, env);
		DBVdbv_to_snacc_illstring(data_ptr->e_delivery_description, psElectronicDelivery->psDeliveryDescription, env);
	}
	
	
	data_ptr->e_delivery_details = (struct Electronic_Delivery_ServiceChoice*) Asn1Alloc(sizeof (struct Electronic_Delivery_ServiceChoice));
	CheckAsn1Alloc(data_ptr->e_delivery_details, env);
	DBVdbv_to_snacc_delivdet(data_ptr->e_delivery_details, &psElectronicDelivery->sDeliveryDetails, env);


	/* optional */
	if (psElectronicDelivery->psNameOrCode != NULL) {
		data_ptr->name_or_code = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(data_ptr->name_or_code, env);
		DBVdbv_to_snacc_illstring(data_ptr->name_or_code, psElectronicDelivery->psNameOrCode, env);
	}
	
	/* optional */
	if (psElectronicDelivery->pcDeliveryTime != NULL) {
		DBVdbv_to_snacc_vis_string(&data_ptr->delivery_time, psElectronicDelivery->pcDeliveryTime, env);
	}
}



int DBVdbv_to_snacc_delivdet(struct Electronic_Delivery_ServiceChoice *e_delivery_details, DbvElDeliveryDetails *psDeliveryDetails, jmp_buf env)
{
	switch (psDeliveryDetails->eDeliveryDetailsType) {
	case DDT_SystemAddress:
		e_delivery_details->choiceId = ELECTRONIC_DELIVERY_SERVICECHOICE_E_DELIVERY_ADDRESS;
		e_delivery_details->a.e_delivery_address = (struct System_Address*) Asn1Alloc (sizeof (struct System_Address));
		CheckAsn1Alloc(e_delivery_details->a.e_delivery_address, env);
		DBVdbv_to_snacc_electaddress(e_delivery_details->a.e_delivery_address, psDeliveryDetails->uDeliveryDetails.psSystemAddress, env);
		break;
	case DDT_SystemId:
		e_delivery_details->choiceId = ELECTRONIC_DELIVERY_SERVICECHOICE_E_DELIVERY_ID;
		e_delivery_details->a.e_delivery_id = (struct System_Id*) Asn1Alloc (sizeof (struct System_Id));
		CheckAsn1Alloc(e_delivery_details->a.e_delivery_id, env);
		DBVdbv_to_snacc_systemid(e_delivery_details->a.e_delivery_id, psDeliveryDetails->uDeliveryDetails.psSystemId, env);
		break;
	}
	
}


int DBVdbv_to_snacc_servtypelist(ILL_RequestSetOf *iLL_service_type, DbvServiceType **ppeServiceType, jmp_buf env)
{
	ILL_Service_Type *data_ptr;
	ILL_Service_Type **data_ptr_address;
	
	int current_listnode = 0;	

	while (ppeServiceType[current_listnode] != NULL) {
                data_ptr_address = AsnListAppend(iLL_service_type);
                CheckAsn1Alloc(data_ptr_address, env);

                *data_ptr_address = Asn1Alloc(sizeof(ILL_Service_Type));
                CheckAsn1Alloc(*data_ptr_address, env);

                data_ptr = *data_ptr_address;

                DBVdbv_to_snacc_servtype(data_ptr, ppeServiceType[current_listnode], env);
                current_listnode++;
        }
}



int DBVdbv_to_snacc_servtype(ILL_Service_Type *data_ptr, DbvServiceType *peServiceType, jmp_buf env)
{
	switch (*peServiceType) {
	case ST_Loan:
		*data_ptr = LOAN;
		break;
	case ST_CopyNonReturnable:
		*data_ptr = COPY_NON_RETURNABLE;
		break;
	case ST_Locations:
		*data_ptr = LOCATIONS;
		break;
	case ST_Estimate:
		*data_ptr = ESTIMATE;
		break;
	case ST_ResponderSpecific:
		*data_ptr = RESPONDER_SPECIFIC3;
		break;
	}
}



int DBVdbv_to_snacc_reqopmes(struct Requester_Optional_Messages_Type *requester_optional_messages, DbvRequesterOptionalMessages *psRequesterOptionalMessages, jmp_buf env)
{
	/* Compulsory bools */
	DBVdbv_to_snacc_DbvBool(&requester_optional_messages->can_send_RECEIVED, &psRequesterOptionalMessages->fCanSendReceived, env);
	DBVdbv_to_snacc_DbvBool(&requester_optional_messages->can_send_RETURNED, &psRequesterOptionalMessages->fCanSendReturned, env);

	/* and some compulsory enumerations */
	DBVdbv_to_snacc_optmsgreq(&requester_optional_messages->requester_SHIPPED, &psRequesterOptionalMessages->eRequesterShipped, env);
	DBVdbv_to_snacc_optmsgreq(&requester_optional_messages->requester_CHECKED_IN, &psRequesterOptionalMessages->eRequesterCheckedIn, env);
}



int DBVdbv_to_snacc_optmsgreq(Requester_Optional_Messages_TypeEnum *requester_CHECKED_IN, DbvOptionalMsgRequirements *peRequesterCheckedIn, jmp_buf env)
{
	switch (*peRequesterCheckedIn) {
	case OMR_Requires:
		*requester_CHECKED_IN = REQUIRES3;
		break;
	case OMR_Desires:
		*requester_CHECKED_IN = DESIRES3;
		break;
	case OMR_Neither:
		*requester_CHECKED_IN = NEITHER3;
		break;
	}
}



int DBVdbv_to_snacc_searchtype(struct Search_Type* search_type, DbvSearchType *psSearchType, jmp_buf env)
{
	/* First two optional */
	if (psSearchType->psLevelOfService != NULL) {
		search_type->level_of_service = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(search_type->level_of_service, env);
		DBVdbv_to_snacc_illstring(search_type->level_of_service, psSearchType->psLevelOfService, env);
	}


	if (psSearchType->pcNeedBeforeDate != NULL) 
		DBVdbv_to_snacc_vis_string(&search_type->need_before_date, psSearchType->pcNeedBeforeDate, env);


	/* default so optional  */
	if (psSearchType->peExpiryFlag) {
		search_type->expiry_flag = (Search_TypeEnum*) Asn1Alloc (sizeof (Search_TypeEnum));
		CheckAsn1Alloc(search_type->expiry_flag, env);

		DBVdbv_to_snacc_expiflag(search_type->expiry_flag, psSearchType->peExpiryFlag, env);
	}


	/* o */
	if (psSearchType->pcExpiryDate != NULL) 
		DBVdbv_to_snacc_vis_string(&search_type->expiry_date, psSearchType->pcExpiryDate, env);



}



int DBVdbv_to_snacc_expiflag(Search_TypeEnum *expiry_flag, DbvExpiry *peExpiryFlag, jmp_buf env)
{
	switch (*peExpiryFlag) {
	case EXP_NeedBeforeDate:
		*expiry_flag = NEED_BEFORE_DATE;
		break;
	case EXP_OtherDate:
		*expiry_flag = OTHER_DATE;
		break;
	case EXP_NoExpiry:
		*expiry_flag = NO_EXPIRY;
		break;
	}
}



int DBVdbv_to_snacc_suppmedinfolist(ILL_RequestSetOf1* supply_medium_info_type, DbvSupplyMediumInfo **ppsSupplyMediumInfo, jmp_buf env)
{
	Supply_Medium_Info_Type *data_ptr;
	Supply_Medium_Info_Type **data_ptr_address;
	
	int current_listnode = 0;	

	while (ppsSupplyMediumInfo[current_listnode] != NULL) {
                data_ptr_address = AsnListAppend(supply_medium_info_type);
                CheckAsn1Alloc(data_ptr_address, env);

                *data_ptr_address = Asn1Alloc(sizeof(Supply_Medium_Info_Type));
                CheckAsn1Alloc(*data_ptr_address, env);

                data_ptr = *data_ptr_address;

                DBVdbv_to_snacc_suppmedinfo(data_ptr, ppsSupplyMediumInfo[current_listnode], env);
                current_listnode++;
        }
}



int DBVdbv_to_snacc_suppmedinfo(Supply_Medium_Info_Type *data_ptr, DbvSupplyMediumInfo *psSupplyMediumInfo, jmp_buf env)
{
	/* First compulsory */
	DBVdbv_to_snacc_suppmed(&data_ptr->supply_medium_type, &psSupplyMediumInfo->eSupplyMediumType, env);


	/* Second optional */
	if (psSupplyMediumInfo->psMediumCharacteristics != NULL) {
		data_ptr->medium_characteristics = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(data_ptr->medium_characteristics, env);
		DBVdbv_to_snacc_illstring(data_ptr->medium_characteristics, psSupplyMediumInfo->psMediumCharacteristics, env);
	}
	
}



int DBVdbv_to_snacc_suppmed(Supply_Medium_Type *supply_medium_type, DbvSupplyMediumType *peSupplyMediumType, jmp_buf env)
{
	switch (*peSupplyMediumType) {
	case SMT_Printed:
		*supply_medium_type = PRINTED1;
		break;
	case SMT_Photocopy:
		*supply_medium_type = PHOTOCOPY;
		break;
	case SMT_Microform:
		*supply_medium_type = MICROFORM1;
		break;
	case SMT_FilmOrVideoRecording:
		*supply_medium_type = FILM_OR_VIDEO_RECORDING1;
		break;
	case SMT_AudioRecording:
		*supply_medium_type = AUDIO_RECORDING1;
		break;
	case SMT_MachineReadable:
		*supply_medium_type = MACHINE_READABLE1;
		break;
	case SMT_Other:
		*supply_medium_type = OTHER11;
		break;
	}
}



int DBVdbv_to_snacc_ponhold(Place_On_Hold_Type* place_on_hold, DbvPlaceOnHold *pePlaceOnHold, jmp_buf env)
{
	switch (*pePlaceOnHold) {
	case POH_Yes:
		*place_on_hold = YES;
		break;	
	case POH_No:
		*place_on_hold = NO;
		break;
	case POH_ResponderPolicy:
		*place_on_hold = ACCORDING_TO_RESPONDER_POLICY;
		break;
	default:
		*place_on_hold = ACCORDING_TO_RESPONDER_POLICY;
		break;
	}
}



int DBVdbv_to_snacc_clientid(struct Client_Id* client_id, DbvClientId *psClientId, jmp_buf env)
{
	/* All dudes optional */
	if (psClientId->psClientName != NULL) {
		client_id->client_name = (struct ILL_String *) Asn1Alloc(sizeof (struct ILL_String));
		CheckAsn1Alloc(client_id->client_name, env);
		DBVdbv_to_snacc_illstring(client_id->client_name, psClientId->psClientName, env);
	}


	if (psClientId->psClientStatus != NULL) {
		client_id->client_status = (struct ILL_String *) Asn1Alloc(sizeof (struct ILL_String));
		CheckAsn1Alloc(client_id->client_status, env);
		DBVdbv_to_snacc_illstring(client_id->client_status, psClientId->psClientStatus, env);
	}


	if (psClientId->psClientIdentifier != NULL) {
		client_id->client_identifier = (struct ILL_String *) Asn1Alloc(sizeof (struct ILL_String));
		CheckAsn1Alloc(client_id->client_identifier, env);
		DBVdbv_to_snacc_illstring(client_id->client_identifier, psClientId->psClientIdentifier, env);
	}
}



int DBVdbv_to_snacc_itemid(struct Item_Id* item_id, DbvItemId *psItemId, jmp_buf env)
{
	/* Everything here optional */
	if (psItemId->peItemType != NULL) {
		item_id->item_type = (Item_IdEnum *) Asn1Alloc (sizeof(Item_IdEnum));
		CheckAsn1Alloc(item_id->item_type, env);
		DBVdbv_to_snacc_itemtype(item_id->item_type, psItemId->peItemType, env);
	}
	
	if (psItemId->peMediumType != NULL) {
		item_id->held_medium_type = (Medium_Type *) Asn1Alloc(sizeof (Medium_Type));
		CheckAsn1Alloc(item_id->held_medium_type, env);
		DBVdbv_to_snacc_medtype(item_id->held_medium_type, psItemId->peMediumType, env);
	}

	
	if (psItemId->psCallNumber != NULL) {
		item_id->call_number = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(item_id->call_number, env);
		DBVdbv_to_snacc_illstring(item_id->call_number, psItemId->psCallNumber, env);
	}


	if (psItemId->psAuthor != NULL) {
		item_id->author = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(item_id->author, env);
		DBVdbv_to_snacc_illstring(item_id->author, psItemId->psAuthor, env);
	}


	if (psItemId->psTitle != NULL) {
		item_id->title = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(item_id->title, env);
		DBVdbv_to_snacc_illstring(item_id->title, psItemId->psTitle, env);
	}


	if (psItemId->psSubTitle != NULL) {
		item_id->sub_title = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(item_id->sub_title, env);
		DBVdbv_to_snacc_illstring(item_id->sub_title, psItemId->psSubTitle, env);
	}


	if (psItemId->psSponsoringBody != NULL) {
		item_id->sponsoring_body = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(item_id->sponsoring_body, env);
		DBVdbv_to_snacc_illstring(item_id->sponsoring_body, psItemId->psSponsoringBody, env);
	}


	if (psItemId->psPlaceOfPublication != NULL) {
		item_id->place_of_publication = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(item_id->place_of_publication, env);
		DBVdbv_to_snacc_illstring(item_id->place_of_publication, psItemId->psPlaceOfPublication, env);
	}


	if (psItemId->psPublisher != NULL) {
		item_id->publisher = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(item_id->publisher , env);
		DBVdbv_to_snacc_illstring(item_id->publisher, psItemId->psPublisher, env);
	}


	if (psItemId->psSeriesTitleNumber != NULL) {
		item_id->series_title_number = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(item_id->series_title_number, env);
		DBVdbv_to_snacc_illstring(item_id->series_title_number, psItemId->psSeriesTitleNumber, env);
	}


	if (psItemId->psVolumeIssue != NULL) {
		item_id->volume_issue = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(item_id->volume_issue, env);
		DBVdbv_to_snacc_illstring(item_id->volume_issue, psItemId->psVolumeIssue, env);
	}


	if (psItemId->psEdition != NULL) {
		item_id->edition = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(item_id->edition, env);
		DBVdbv_to_snacc_illstring(item_id->edition, psItemId->psEdition, env);
	}


	if (psItemId->psPublicationDate != NULL) {
		item_id->publication_date = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(item_id->publication_date, env);
		DBVdbv_to_snacc_illstring(item_id->publication_date, psItemId->psPublicationDate, env);
	}


	if (psItemId->psPublicationDateOfComponent != NULL) {
		item_id->publication_date_of_component = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(item_id->publication_date_of_component, env);
		DBVdbv_to_snacc_illstring(item_id->publication_date_of_component, psItemId->psPublicationDateOfComponent, env);
	}


	if (psItemId->psAuthorOfArticle != NULL) {
		item_id->author_of_article = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(item_id->author_of_article, env);
		DBVdbv_to_snacc_illstring(item_id->author_of_article, psItemId->psAuthorOfArticle, env);
	}


	if (psItemId->psTitleOfArticle != NULL) {
		item_id->title_of_article = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(item_id->title_of_article, env);
		DBVdbv_to_snacc_illstring(item_id->title_of_article, psItemId->psTitleOfArticle, env);
	}


	if (psItemId->psPagination != NULL) {
		item_id->pagination = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(item_id->pagination , env);
		DBVdbv_to_snacc_illstring(item_id->pagination, psItemId->psPagination, env);
	}

	if (psItemId->psNationalBibliographyNo != NULL) {
		item_id->national_bibliography_no = (struct NEWEXTERNAL*) Asn1Alloc (sizeof (struct NEWEXTERNAL));
		CheckAsn1Alloc(item_id->national_bibliography_no, env); 
		DBVdbv_to_snacc_external(item_id->national_bibliography_no, psItemId->psNationalBibliographyNo, env);
	}


	if (psItemId->psIsbn != NULL) {
		item_id->iSBN = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(item_id->iSBN, env);
		DBVdbv_to_snacc_illstring(item_id->iSBN, psItemId->psIsbn, env);
	}


	if (psItemId->psIssn != NULL) {
		item_id->iSSN = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(item_id->iSSN, env);
		DBVdbv_to_snacc_illstring(item_id->iSSN, psItemId->psIssn, env);
	}


	if (psItemId->psSystemNo != NULL) {
		item_id->system_no = (struct NEWEXTERNAL*) Asn1Alloc (sizeof (struct NEWEXTERNAL));
		CheckAsn1Alloc(item_id->system_no, env); 
		DBVdbv_to_snacc_external(item_id->system_no, psItemId->psSystemNo, env);
	}


	if (psItemId->psAdditionalNoLetters != NULL) {
		item_id->additional_no_letters = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(item_id->additional_no_letters, env);
		DBVdbv_to_snacc_illstring(item_id->additional_no_letters, psItemId->psAdditionalNoLetters, env);
	}


	if (psItemId->psVerificationReferenceSource != NULL) {
		item_id->verification_reference_source = (struct ILL_String *) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(item_id->verification_reference_source, env);
		DBVdbv_to_snacc_illstring(item_id->verification_reference_source, psItemId->psVerificationReferenceSource, env);
	}
}



int DBVdbv_to_snacc_itemtype(Item_IdEnum *item_type, DbvItemType *peItemType, jmp_buf env)
{
	switch (*peItemType) {
	case IT_Monograph:
		*item_type = MONOGRAPH;
		break;
	case IT_Serial:
		*item_type = SERIAL;
		break;
	case IT_Other:
		*item_type = OTHER4;
		break;
	}
}



int DBVdbv_to_snacc_medtype(Medium_Type *held_medium_type, DbvMediumType *peMediumType, jmp_buf env)
{
	switch (*peMediumType) {
	case MT_Printed:
		*held_medium_type = PRINTED;
		break;
	case MT_Microform:
		*held_medium_type = MICROFORM;
		break;
	case MT_FilmOrVideoRecording:
		*held_medium_type = FILM_OR_VIDEO_RECORDING;
		break;
	case MT_AudioRecording:
		*held_medium_type = AUDIO_RECORDING;
		break;
	case MT_MachineReadable:
		*held_medium_type = MACHINE_READABLE ;
		break;
	case MT_Other:
		*held_medium_type = OTHER7;
		break;
	}
}



int DBVdbv_to_snacc_suppdesc(Supplemental_Item_Description* supplemental_item_description, DbvASN1External **ppsSupplementalItemDescription, jmp_buf env)
{
	
	/* A list of externals - wow !! */

	NEWEXTERNAL *data_ptr;
	NEWEXTERNAL **data_ptr_address;
	
	int current_listnode = 0;	

	while (ppsSupplementalItemDescription[current_listnode] != NULL) {
                data_ptr_address = AsnListAppend(supplemental_item_description);
                CheckAsn1Alloc(data_ptr_address, env);

                *data_ptr_address = Asn1Alloc(sizeof(NEWEXTERNAL));
                CheckAsn1Alloc(*data_ptr_address, env);

                data_ptr = *data_ptr_address;

                DBVdbv_to_snacc_external(data_ptr, ppsSupplementalItemDescription[current_listnode], env);
                current_listnode++;
        }
}



int DBVdbv_to_snacc_costinfo(struct Cost_Info_Type* cost_info_type, DbvCostInfo *psCostInfo, jmp_buf env)
{
	/* optional */
	if (psCostInfo->psAccountNumber != NULL) {
		cost_info_type->account_number = (Account_Number *) Asn1Alloc (sizeof (Account_Number));	
		CheckAsn1Alloc(cost_info_type->account_number, env);

		/* account number is a typdefed illstring */ 
		DBVdbv_to_snacc_illstring(cost_info_type->account_number, psCostInfo->psAccountNumber, env);
	}

	if (psCostInfo->psMaximumCost != NULL) {
		cost_info_type->maximum_cost = (struct Amount*) Asn1Alloc (sizeof (struct Amount));
		CheckAsn1Alloc(cost_info_type->maximum_cost, env);
		DBVdbv_to_snacc_maxcost(cost_info_type->maximum_cost, psCostInfo->psMaximumCost, env);
	}

	/* All following default so optional */
	if (psCostInfo->pfReciprocalAgreement) {
		cost_info_type->reciprocal_agreement = (AsnBool *) Asn1Alloc (sizeof (AsnBool));
		CheckAsn1Alloc(cost_info_type->reciprocal_agreement, env);

		DBVdbv_to_snacc_DbvBool(cost_info_type->reciprocal_agreement, psCostInfo->pfReciprocalAgreement, env);
	}

	
	if (psCostInfo->pfWillPayFee) {
		cost_info_type->will_pay_fee = (AsnBool *) Asn1Alloc (sizeof (AsnBool));
		CheckAsn1Alloc(cost_info_type->will_pay_fee, env);

		DBVdbv_to_snacc_DbvBool(cost_info_type->will_pay_fee, psCostInfo->pfWillPayFee, env);
	}


	
	if (psCostInfo->pfPaymentProvided) {
		cost_info_type->payment_provided = (AsnBool *) Asn1Alloc (sizeof (AsnBool));
		CheckAsn1Alloc(cost_info_type->payment_provided, env);
		DBVdbv_to_snacc_DbvBool(cost_info_type->payment_provided, psCostInfo->pfPaymentProvided, env);
	}
}



int DBVdbv_to_snacc_maxcost(struct Amount *maximum_cost, DbvAmount *psMaximumCost, jmp_buf env)
{
	/* optional */
	if (psMaximumCost->pcCurrencyCode != NULL) 
		DBVdbv_to_snacc_printstring(&maximum_cost->currency_code, psMaximumCost->pcCurrencyCode, env);


	/* and compulsory */
	if (psMaximumCost->pcMonetaryValue != NULL) 
		DBVdbv_to_snacc_printstring(&maximum_cost->monetary_value, psMaximumCost->pcMonetaryValue, env);

	
}



/* Dont need DbvPrintableStrig * cos DbvPrintableStrig is a char * */
int DBVdbv_to_snacc_printstring(PrintableString *currency_code, DbvPrintableString pcCurrencyCode, jmp_buf env)
{
	/* Encode as a visible string - (why not.. both are octet strings
	   although with different tags) */
	DBVdbv_to_snacc_vis_string(currency_code, pcCurrencyCode, env);
}



int  DBVdbv_to_snacc_thirdparty(struct Third_Party_Info_Type* third_party_info_type, DbvThirdPartyInfo *psThirdPartyInfo, jmp_buf env)
{
	/* default so optional */
	if (psThirdPartyInfo->pfPermissionToForward) {
		third_party_info_type->permission_to_forward = (AsnBool *) Asn1Alloc (sizeof (AsnBool));
		CheckAsn1Alloc(third_party_info_type->permission_to_forward, env);
		DBVdbv_to_snacc_DbvBool(third_party_info_type->permission_to_forward, psThirdPartyInfo->pfPermissionToForward, env);
	}


	/* default so optional */
	if (psThirdPartyInfo->pfPermissionToChain) {
		third_party_info_type->permission_to_chain = (AsnBool *) Asn1Alloc (sizeof (AsnBool));
		CheckAsn1Alloc(third_party_info_type->permission_to_chain, env);
		DBVdbv_to_snacc_DbvBool(third_party_info_type->permission_to_chain, psThirdPartyInfo->pfPermissionToChain, env);
	}


	/* default so optional */
	if (psThirdPartyInfo->pfPermissionToPartition) {
		third_party_info_type->permission_to_partition = (AsnBool *) Asn1Alloc (sizeof (AsnBool));
		CheckAsn1Alloc(third_party_info_type->permission_to_partition, env);
		DBVdbv_to_snacc_DbvBool(third_party_info_type->permission_to_partition, psThirdPartyInfo->pfPermissionToPartition, env);
	}


	/* default so optional */
	if (psThirdPartyInfo->pfPermissionToChangeSendToList) {
		third_party_info_type->permission_to_change_send_to_list = (AsnBool *) Asn1Alloc (sizeof (AsnBool));
		CheckAsn1Alloc(third_party_info_type->permission_to_change_send_to_list, env);
		DBVdbv_to_snacc_DbvBool(third_party_info_type->permission_to_change_send_to_list, psThirdPartyInfo->pfPermissionToChangeSendToList, env);
	}


	/* an optional */
	if (psThirdPartyInfo->psInitialRequesterAddress != NULL) {
		third_party_info_type->initial_requester_address = (struct System_Address*) Asn1Alloc (sizeof (struct System_Address));
		CheckAsn1Alloc(third_party_info_type->initial_requester_address, env);
		DBVdbv_to_snacc_electaddress(third_party_info_type->initial_requester_address, psThirdPartyInfo->psInitialRequesterAddress, env);
	}	
		

	/* default so optional */
	if (psThirdPartyInfo->pePreference) {
		third_party_info_type->preference = (Third_Party_Info_TypeEnum*) Asn1Alloc (sizeof (Third_Party_Info_TypeEnum));
		CheckAsn1Alloc(third_party_info_type->preference, env);
		DBVdbv_to_snacc_thirdparenum(third_party_info_type->preference, psThirdPartyInfo->pePreference, env);
	}

	/* optional */
	if (psThirdPartyInfo->ppsSendToList != NULL) {
		third_party_info_type->send_to_list = AsnListNew(sizeof(void *));
		CheckAsn1Alloc(third_party_info_type, env);
		DBVdbv_to_snacc_sendtolist(third_party_info_type->send_to_list, psThirdPartyInfo->ppsSendToList, env);
	}
	

	/* optional */
	if (psThirdPartyInfo->ppsAlreadyTriedList != NULL) {
		third_party_info_type->already_tried_list = AsnListNew(sizeof(void *));
		CheckAsn1Alloc(third_party_info_type->already_tried_list, env);
		DBVdbv_to_snacc_alreadtriedlist(third_party_info_type->already_tried_list, psThirdPartyInfo->ppsAlreadyTriedList, env);
	}

}



int DBVdbv_to_snacc_sendtolist(Send_To_List_Type *send_to_list, DbvSendToList **ppsSendToList, jmp_buf env)
{

	Send_To_List_TypeSeq  *data_ptr;
	Send_To_List_TypeSeq **data_ptr_address;

	int current_listnode = 0;	

	while (ppsSendToList[current_listnode] != NULL) {
                data_ptr_address = AsnListAppend(send_to_list);
                CheckAsn1Alloc(data_ptr_address, env);

                *data_ptr_address = Asn1Alloc(sizeof(Send_To_List_TypeSeq));
                CheckAsn1Alloc(*data_ptr_address, env);

                data_ptr = *data_ptr_address;

                DBVdbv_to_snacc_sendtolistel(data_ptr, ppsSendToList[current_listnode], env);
                current_listnode++;
        }
}



int DBVdbv_to_snacc_sendtolistel(Send_To_List_TypeSeq *data_ptr, DbvSendToList *psSendToList, jmp_buf env)
{
	/* comp */
	data_ptr->system_id = (struct System_Id *) Asn1Alloc (sizeof (struct System_Id));
	CheckAsn1Alloc(data_ptr->system_id, env);
	DBVdbv_to_snacc_systemid(data_ptr->system_id, &psSendToList->sSystemId, env);
	

	/* opt */
	if (psSendToList->psAccountNumber != NULL) {
		data_ptr->account_number = (Account_Number *) Asn1Alloc (sizeof (Account_Number));
		CheckAsn1Alloc (data_ptr->account_number, env);
		DBVdbv_to_snacc_illstring(data_ptr->account_number, psSendToList->psAccountNumber, env);
	}


	/* opt */
	if (psSendToList->psSystemAddress != NULL) {
		data_ptr->system_address = (struct System_Address*) Asn1Alloc (sizeof (struct System_Address));
		CheckAsn1Alloc(data_ptr->system_address, env);
		DBVdbv_to_snacc_electaddress(data_ptr->system_address, psSendToList->psSystemAddress, env);
	}
}



int DBVdbv_to_snacc_thirdparenum(Third_Party_Info_TypeEnum *preference, DbvPreference *pePreference, jmp_buf env)
{
	switch (*pePreference) {
	case PRE_Ordered:
		*preference = ORDERED;
		break;
	case PRE_Unordered:
		*preference = UNORDERED;
		break;
	}
}



int DBVdbv_to_snacc_alreadtriedlist(Already_Tried_List_Type *already_tried_list, DbvSystemId **ppsAlreadyTriedList, jmp_buf env)
{
	System_Id  *data_ptr;
	System_Id **data_ptr_address;

	int current_listnode = 0;	

	while (ppsAlreadyTriedList[current_listnode] != NULL) {
                data_ptr_address = AsnListAppend(already_tried_list);
                CheckAsn1Alloc(data_ptr_address, env);

                *data_ptr_address = Asn1Alloc(sizeof(System_Id));
                CheckAsn1Alloc(*data_ptr_address, env);

                data_ptr = *data_ptr_address;

                DBVdbv_to_snacc_systemid(data_ptr, ppsAlreadyTriedList[current_listnode], env);
                current_listnode++;
        }
}



int DBVdbv_to_snacc_requestext(ILL_RequestSeqOf* iLL_request_extensions, DbvExtension **ppsRequestExtension, jmp_buf env)
{
	Extension  *data_ptr;
	Extension **data_ptr_address;
	
	int current_listnode = 0;	

	while (ppsRequestExtension[current_listnode] != NULL) {
                data_ptr_address = AsnListAppend(iLL_request_extensions);
                CheckAsn1Alloc(data_ptr_address, env);

                *data_ptr_address = Asn1Alloc(sizeof(Extension));
                CheckAsn1Alloc(*data_ptr_address, env);

                data_ptr = *data_ptr_address;

                DBVdbv_to_snacc_extension(data_ptr, ppsRequestExtension[current_listnode], env);
                current_listnode++;
        }
}



int DBVdbv_to_snacc_extension(Extension *data_ptr, DbvExtension *psRequestExtension, jmp_buf env)
{
	/* comp */
	data_ptr->identifier = psRequestExtension->ulIdentifier;

	/* default so optional */
	if (psRequestExtension->pfCritical) {
		data_ptr->critical = (AsnBool *) Asn1Alloc (sizeof (AsnBool));
		CheckAsn1Alloc(data_ptr->critical, env);
		DBVdbv_to_snacc_DbvBool(data_ptr->critical, psRequestExtension->pfCritical, env);
	}

	/* o */
	DBVdbv_to_snacc_extension_item(psRequestExtension->ulIdentifier, &data_ptr->item, psRequestExtension, env);

}


/* Item order Ill extension externals defined by int */

int DBVdbv_to_snacc_extension_item(Ulong ulIdentifier, AsnAnyDefinedBy *item, DbvExtension *psRequestExtension, jmp_buf env)
{
	switch (ulIdentifier) {


/***************************
 No longer used currently

	case INTMAPTEST:
		DBVdbv_to_snacc_anytype_int(ulIdentifier, item, psRequestExtension->uItem.psAddIllReqInfo);
		break;
***************************/

	case SUBITO_ADDITIONAL_INFO:
		DBVdbv_to_snacc_subito(item, psRequestExtension->uItem.psAddIllReqInfo, env);
		break;
	}
}



/* Map from a DBV-OSI II int defined external to a snacc any.
int -> external mapping is only used by ISO ILL (ISO swines!) */
int DBVdbv_to_snacc_anytype_int(Ulong *intval, AsnAnyDefinedBy *any_type, DbvASN1External *dbv_external, jmp_buf env)
{
        switch(dbv_external->uExternalValue.psSingleASN1Type->eASN1Type) {

/**************
 No longer used

        case AT_IntMapTest:
                if ((int) (*intval) == INTMAPTEST)
                        DBVdbv_to_snacc_silintmaptest_any(any_type, dbv_external, env);
                break;
**************/
	}
}



/* dbv -> snacc intmaptest external */

int DBVdbv_to_snacc_silintmaptest_any(AsnAnyDefinedBy *any_type, DbvASN1External *dbv_external, jmp_buf env)
{
       /* Arrays of externals are used because snacc only generates code
        to free the contents of AnyDefinedBy types, not the types themselves */
        static SilIntMapTest silintmaptest_external[STRING_LEN];

        SilIntMapTest *silintmaptest_ptr;

        /* Set up the SilIntMapTest external */
        silintmaptest_ptr = &silintmaptest_external[current_silintmaptest];

        /* Clear the location (may have been used by the last PDU) */
        memset(silintmaptest_ptr, 0, sizeof(SilIntMapTest));

        /* Convert a dbv silintmaptest into a snacc silintmaptest */

/****************
 no longer used

	switch (dbv_external->uExternalValue.psSingleASN1Type->uASN1.psIntMapTest->eIntMapTestType) {
	case IMT_FirstString:
		silintmaptest_ptr->choiceId = SILINTMAPTEST_THEABYSS;
		silintmaptest_ptr->a.theabyss = (InternationalString *) Asn1Alloc (sizeof (InternationalString));
		CheckDbvAlloc(silintmaptest_ptr->a.theabyss, env);

        	DBVdbv_to_snacc_inter_string(silintmaptest_ptr->a.theabyss, dbv_external->uExternalValue.psSingleASN1Type->uASN1.psIntMapTest->uIntMapTest.psFirstString, env);
		break;


	case IMT_SecondString:
		silintmaptest_ptr->choiceId = SILINTMAPTEST_LAUNCHFACILITY;
		silintmaptest_ptr->a.launchfacility = (InternationalString *) Asn1Alloc (sizeof (InternationalString));
		CheckDbvAlloc(silintmaptest_ptr->a.launchfacility, env);

        	DBVdbv_to_snacc_inter_string(silintmaptest_ptr->a.launchfacility, dbv_external->uExternalValue.psSingleASN1Type->uASN1.psIntMapTest->uIntMapTest.psSecondString, env);
		break;
	}


        ** Now add the external we have just defined to the external field
           in the PDU. single_ASN1_type is used for all V3 externals **
        any_type->value = (void *) &silintmaptest_external[current_silintmaptest];

        ** Only if not at end of array **
        if (current_silintmaptest < (STRING_LEN - 1)) {

                ** Increment current_sutrs for the next external
                  (remember that there can be more than one external
                  of the same type in searchResponse PDUs) **
                current_silintmaptest++;
        }

****************/
}




/* dbv -> snacc subito info */
/* Bernd's SUBITO_ADDITIONAL_INFO in iord_ext.h */
int DBVdbv_to_snacc_subito(AsnAnyDefinedBy *any_type, DbvSubitoAdditionalInfo *psAddIllReqInfo, jmp_buf env)
{
       /* Arrays of externals are used because snacc only generates code
        to free the contents of AnyDefinedBy types, not the types themselves */
        static SubitoAdditionalInfo subito_external[STRING_LEN];

        SubitoAdditionalInfo *subito_ptr = NULL;

        /* Set up the SilIntMapTest external */
        subito_ptr = &subito_external[current_subito];

        /* Clear the location (may have been used by the last PDU) */
        memset(subito_ptr, 0, sizeof(SubitoAdditionalInfo));

        /* Convert a dbv DbvSubitoAdditionalInfo into a snacc SubitoAdditionalInfo */

	subito_ptr->choiceId = SUBITOADDITIONALINFO_JOHNFIX;
	subito_ptr->a.johnfix = (struct OrigSubitoAdditionalInfo *) Asn1Alloc (sizeof (OrigSubitoAdditionalInfo));
	CheckAsn1Alloc(subito_ptr->a.johnfix, env);
	
       	DBVdbv_to_snacc_subito_main(subito_ptr->a.johnfix, psAddIllReqInfo, env);

        /* Now add the external we have just defined to the external field
           in the PDU. single_ASN1_type is used for all V3 externals */
        any_type->value = (void *) &subito_external[current_subito];

        /* Only if not at end of array */
        if (current_subito < (STRING_LEN - 1)) {

                /* Increment current_subito for the next external
                  (remember that there can be more than one external
                  of the same type in searchResponse PDUs) */
                current_subito++;
        }
}



int DBVdbv_to_snacc_subito_main(OrigSubitoAdditionalInfo *subito_ptr, DbvSubitoAdditionalInfo *psAddIllReqInfo, jmp_buf env)
{
	/* default so optional */
	if (psAddIllReqInfo->pfCustomerInfoToKeep) {
		subito_ptr->customerInfoToKeep = (AsnBool *) Asn1Alloc (sizeof (AsnBool));
		CheckAsn1Alloc(subito_ptr->customerInfoToKeep, env);
		DBVdbv_to_snacc_DbvBool(subito_ptr->customerInfoToKeep, psAddIllReqInfo->pfCustomerInfoToKeep, env);
	}
	
	/* o */
	if (psAddIllReqInfo->psAddRequesterInfo) {
		subito_ptr->addRequesterInfo = (struct AddRequesterInfo*) Asn1Alloc (sizeof (struct AddRequesterInfo));
		CheckAsn1Alloc(subito_ptr->addRequesterInfo, env);
		DBVdbv_to_snacc_addrequesterinfo(subito_ptr->addRequesterInfo, psAddIllReqInfo->psAddRequesterInfo, env);
	}

	/* o */
	if (psAddIllReqInfo->psAddDeliveryInfo) {
		subito_ptr->addDeliveryInfo = (struct AddDeliveryInfo*) Asn1Alloc (sizeof (struct AddDeliveryInfo));
		CheckAsn1Alloc(subito_ptr->addDeliveryInfo, env);
		DBVdbv_to_snacc_adddeliveryinfo(subito_ptr->addDeliveryInfo, psAddIllReqInfo->psAddDeliveryInfo, env);
	}


	/* o */
	if (psAddIllReqInfo->psAddBillingInfo) {
		subito_ptr->addBillingInfo = (struct AddBillingInfo*) Asn1Alloc (sizeof (struct AddBillingInfo));
		CheckAsn1Alloc(subito_ptr->addBillingInfo, env);
		DBVdbv_to_snacc_addbillinginfo(subito_ptr->addBillingInfo, psAddIllReqInfo->psAddBillingInfo, env);
	}
}



int DBVdbv_to_snacc_addrequesterinfo(struct AddRequesterInfo* addRequesterInfo, DbvAddRequesterInfo *psAddRequesterInfo, jmp_buf env)
{
	/* default so optional */
	if (psAddRequesterInfo->peRequesterGroup) {
		addRequesterInfo->requesterGroup = (AddRequesterInfoEnum *) Asn1Alloc (sizeof (AddRequesterInfoEnum));
		CheckAsn1Alloc(addRequesterInfo->requesterGroup, env);
		DBVdbv_to_snacc_requestergroup(addRequesterInfo->requesterGroup, psAddRequesterInfo->peRequesterGroup, env);
	}

	/* o */
	if (psAddRequesterInfo->pcRequesterEmailAddress)
		DBVdbv_to_snacc_vis_string(&addRequesterInfo->requesterEmailAddress, psAddRequesterInfo->pcRequesterEmailAddress, env);
}



int DBVdbv_to_snacc_requestergroup(AddRequesterInfoEnum *requesterGroup, DbvRequesterGroup *peRequesterGroup, jmp_buf env)
{
	switch (*peRequesterGroup) {
	case RG_UserGroup1:
		*requesterGroup = USERGROUP1;
		break;
	case RG_UserGroup2:
		*requesterGroup = USERGROUP2;
		break;
	}

}



int DBVdbv_to_snacc_adddeliveryinfo(struct AddDeliveryInfo* addDeliveryInfo, DbvAddDeliveryInfo *psAddDeliveryInfo, jmp_buf env)
{
	/* default so optional */
	if (psAddDeliveryInfo->peStatusLevelUser) {
		addDeliveryInfo->statusLevelUser = (AddDeliveryInfoEnum* ) Asn1Alloc (sizeof (AddDeliveryInfoEnum));
		CheckAsn1Alloc(addDeliveryInfo->statusLevelUser, env);
		DBVdbv_to_snacc_addeliveryenum(addDeliveryInfo->statusLevelUser, psAddDeliveryInfo->peStatusLevelUser, env);
	}

	
	/* default so optional */
	if (psAddDeliveryInfo->peStatusLevelOrigin) {
		addDeliveryInfo->statusLevelRequester = (AddDeliveryInfoEnum1* ) Asn1Alloc (sizeof (AddDeliveryInfoEnum1));
		CheckAsn1Alloc(addDeliveryInfo->statusLevelRequester, env);
		DBVdbv_to_snacc_addeliveryenum1(addDeliveryInfo->statusLevelRequester, psAddDeliveryInfo->peStatusLevelOrigin, env);
	}
	
	/* o */
	DBVdbv_to_snacc_vis_string(&addDeliveryInfo->deliveryNotes, psAddDeliveryInfo->pcDeliveryNotes, env);

	/* o */
	DBVdbv_to_snacc_vis_string(&addDeliveryInfo->countryDeliveryTarget, psAddDeliveryInfo->pcCountryDeliveryTarget, env);


	/* default so optional */
	if (psAddDeliveryInfo->pfAlternativePostalDelivery) {
		addDeliveryInfo->alternativePostalDelivery = (AsnBool *) DbvAlloc (sizeof (AsnBool));
		CheckDbvAlloc(addDeliveryInfo->alternativePostalDelivery, env);
		DBVdbv_to_snacc_DbvBool(addDeliveryInfo->alternativePostalDelivery, psAddDeliveryInfo->pfAlternativePostalDelivery, env);
	}

	
}


int DBVdbv_to_snacc_addeliveryenum(AddDeliveryInfoEnum *statusLevelUser, DbvStatusLevelUser *peStatusLevelUser, jmp_buf env)
{
	switch (*peStatusLevelUser) {
	case SLU_All:
		*statusLevelUser = ALL2;
		break;
	case SLU_Negative:
		*statusLevelUser = NEGATIVE1;
		break;
	case SLU_None:
		*statusLevelUser = NONE4;
		break;
	}
}


int DBVdbv_to_snacc_addeliveryenum1(AddDeliveryInfoEnum1 *statusLevelRequester, DbvStatusLevelRequester *peStatusLevelOrigin, jmp_buf env)
{
	switch (*peStatusLevelOrigin) {
	case SLO_All:
		*statusLevelRequester = ALL1;
		break;
	case SLO_Negative:
		*statusLevelRequester = NEGATIVE;
		break;
	case SLO_None:
		*statusLevelRequester = NONE3;
		break;
	}
}



int DBVdbv_to_snacc_addbillinginfo(struct AddBillingInfo* addBillingInfo, DbvAddBillingInfo *psAddBillingInfo, jmp_buf env)
{
	switch (psAddBillingInfo->eAddBillingType) {
	case ABT_BankInfo:
		addBillingInfo->choiceId = ADDBILLINGINFO_BILLINGBANKINFO;
		addBillingInfo->a.billingBankInfo = (struct BillingBankInfo*) Asn1Alloc (sizeof (struct BillingBankInfo));
		CheckAsn1Alloc(addBillingInfo->a.billingBankInfo, env);
		DBVdbv_to_snacc_billingbankinfo(addBillingInfo->a.billingBankInfo, psAddBillingInfo->uAddBillingInfo.psBillingBankInfo, env);
		break;

	case ABT_CreditCardInfo:
		addBillingInfo->choiceId = ADDBILLINGINFO_BILLINGCREDITCARDINFO;
		addBillingInfo->a.billingCreditCardInfo = (struct BillingCreditCardInfo*) Asn1Alloc (sizeof (struct BillingCreditCardInfo));
		CheckAsn1Alloc(addBillingInfo->a.billingCreditCardInfo, env);
		DBVdbv_to_snacc_billingcreditcardinfo(addBillingInfo->a.billingCreditCardInfo, psAddBillingInfo->uAddBillingInfo.psBillingCreditCardInfo, env);
		break;

	case ABT_InvoiceType:
		addBillingInfo->choiceId = ADDBILLINGINFO_BILLINGINVOICETYPE;
		DBVdbv_to_snacc_billinginvoicetype(&addBillingInfo->a.billingInvoiceType, &psAddBillingInfo->uAddBillingInfo.eBillingInvoiceType, env);
		break;

	case ABT_PrepaidType:
		addBillingInfo->choiceId = ADDBILLINGINFO_BILLINGPREPAIDID;
		addBillingInfo->a.billingPrepaidId = (VisibleString *) Asn1Alloc (sizeof (VisibleString));
		CheckAsn1Alloc(addBillingInfo->a.billingPrepaidId, env);
		DBVdbv_to_snacc_vis_string(addBillingInfo->a.billingPrepaidId, psAddBillingInfo->uAddBillingInfo.pcPrepaidId, env);
		break;

	case ABT_DepositType:
		addBillingInfo->choiceId = ADDBILLINGINFO_BILLINGDEPOSITID;
		addBillingInfo->a.billingDepositId = (VisibleString *) Asn1Alloc (sizeof (VisibleString));
		CheckAsn1Alloc(addBillingInfo->a.billingDepositId, env);
		DBVdbv_to_snacc_vis_string(addBillingInfo->a.billingDepositId, psAddBillingInfo->uAddBillingInfo.pcDepositId, env);
		break;


	}

	
}



int DBVdbv_to_snacc_billingbankinfo(struct BillingBankInfo* billingBankInfo, DbvBillingBankInfo *psBillingBankInfo, jmp_buf env)
{
	/* c */
	DBVdbv_to_snacc_vis_string(&billingBankInfo->bankAccountHouse, psBillingBankInfo->pcBankAccountHouse, env);
	
	/* c */
	DBVdbv_to_snacc_vis_string(&billingBankInfo->bankAccountRoutingSymbol, psBillingBankInfo->pcBankAccountRoutingSymbol, env);

	/* c */
	DBVdbv_to_snacc_vis_string(&billingBankInfo->bankAccountNo, psBillingBankInfo->pcBankAccountNo, env);

	/* c */
	DBVdbv_to_snacc_DbvBool(&billingBankInfo->bankAuthority, &psBillingBankInfo->fBankAuthority, env);
}



int DBVdbv_to_snacc_billingcreditcardinfo(struct BillingCreditCardInfo* billingCreditCardInfo, DbvBillingCreditCardInfo *psBillingCreditCardInfo, jmp_buf env)
{
	/* c */
	DBVdbv_to_snacc_vis_string(&billingCreditCardInfo->cardCompany, psBillingCreditCardInfo->pcCardCompany, env);

	/* c */
	DBVdbv_to_snacc_vis_string(&billingCreditCardInfo->cardNo, psBillingCreditCardInfo->pcCardNo, env);
	
	/* ISO_Date and ISO_Time are visible string */
	
	/* o */
   	if (psBillingCreditCardInfo->pcCardValidFrom)
		DBVdbv_to_snacc_vis_string(&billingCreditCardInfo->cardValidFrom, psBillingCreditCardInfo->pcCardValidFrom, env);
		
	/* c */
	DBVdbv_to_snacc_vis_string(&billingCreditCardInfo->cardValidThru, psBillingCreditCardInfo->pcCardValidThru, env);


}



int DBVdbv_to_snacc_billinginvoicetype(AddBillingInfoEnum *billingInvoiceType, DbvBillingInvoiceType *peBillingInvoiceType, jmp_buf env)
{
	switch (*peBillingInvoiceType) {
	case BIT_Single:
		*billingInvoiceType = SINGLE;
		break;
	case BIT_Collective:
		*billingInvoiceType = COLLECTIVE;
		break;
	}
}

/****************/

/* second element in ILL - phew */



int DBVdbv_to_snacc_illstaterror(struct Status_Or_Error_Report* status_Or_Error_Report, struct DbvStatusOrErrorReport *psStatusOrErrorReport, jmp_buf env)
{
	/* compulsory */
	DBVdbv_to_snacc_prover(&status_Or_Error_Report->protocol_version_num, &psStatusOrErrorReport->eProtocolVersion, env);


	/* compy */
	status_Or_Error_Report->transaction_id = (struct Transaction_Id*) Asn1Alloc (sizeof (struct Transaction_Id));
	CheckAsn1Alloc(status_Or_Error_Report->transaction_id, env);
	DBVdbv_to_snacc_transid(status_Or_Error_Report->transaction_id, &psStatusOrErrorReport->sTransactionId, env);


	/* compy */
	status_Or_Error_Report->service_date_time = (struct Service_Date_Time*) Asn1Alloc (sizeof (struct Service_Date_Time));
	CheckAsn1Alloc(status_Or_Error_Report->service_date_time, env);
	DBVdbv_to_snacc_servdt(status_Or_Error_Report->service_date_time, &psStatusOrErrorReport->sServiceDateTime, env);

	/* opty */
	if (psStatusOrErrorReport->psRequesterId != NULL) {
		status_Or_Error_Report->requester_id = (struct System_Id*) Asn1Alloc (sizeof (struct System_Id));
		CheckAsn1Alloc(status_Or_Error_Report->requester_id, env);
		DBVdbv_to_snacc_systemid(status_Or_Error_Report->requester_id, psStatusOrErrorReport->psRequesterId, env);
	}

	/* oh opty */
	if (psStatusOrErrorReport->psResponderId != NULL) {
		status_Or_Error_Report->responder_id = (struct System_Id*) Asn1Alloc (sizeof (struct System_Id));
		CheckAsn1Alloc(status_Or_Error_Report->responder_id, env);
		DBVdbv_to_snacc_systemid(status_Or_Error_Report->responder_id, psStatusOrErrorReport->psResponderId, env);
	}

	
	/* yes opty */
	if (psStatusOrErrorReport->peReasonNoReport != NULL) {
		status_Or_Error_Report->reason_no_report = (Reason_No_Report*) Asn1Alloc (sizeof(Reason_No_Report));
		CheckAsn1Alloc(status_Or_Error_Report->reason_no_report, env);
		DBVdbv_to_snacc_reasonno(status_Or_Error_Report->reason_no_report, psStatusOrErrorReport->peReasonNoReport, env);
	}


	/* opty */
	if (psStatusOrErrorReport->psStatusReport != NULL) {
		status_Or_Error_Report->status_report = (struct Status_Report*) Asn1Alloc (sizeof(struct Status_Report));
		CheckAsn1Alloc(status_Or_Error_Report->status_report, env);
		DBVdbv_to_snacc_statusrep(status_Or_Error_Report->status_report, psStatusOrErrorReport->psStatusReport, env);
	}

	
	/* opty */
	if (psStatusOrErrorReport->psErrorReport != NULL) {
		status_Or_Error_Report->error_report = (struct Error_Report*) Asn1Alloc (sizeof (struct Error_Report));
		CheckAsn1Alloc(status_Or_Error_Report->error_report, env);
		DBVdbv_to_snacc_errorrep(status_Or_Error_Report->error_report, psStatusOrErrorReport->psErrorReport, env);
	}

	
	/* opty */
	if (psStatusOrErrorReport->psNote != NULL) {
		status_Or_Error_Report->note = (struct ILL_String*) Asn1Alloc (sizeof(struct ILL_String));
		CheckAsn1Alloc(status_Or_Error_Report->note, env);
		DBVdbv_to_snacc_illstring(status_Or_Error_Report->note, psStatusOrErrorReport->psNote, env);
	}


	/* opty */
	if (psStatusOrErrorReport->ppsStOrErReportExtension != NULL) {
		status_Or_Error_Report->status_or_error_report_extensions = AsnListNew (sizeof(void *));
		CheckAsn1Alloc(status_Or_Error_Report->status_or_error_report_extensions, env);

		/* Use previously declared extension set up function */
		DBVdbv_to_snacc_requestext(status_Or_Error_Report->status_or_error_report_extensions, psStatusOrErrorReport->ppsStOrErReportExtension, env);
	}
	
}



int DBVdbv_to_snacc_reasonno(Reason_No_Report* reason_no_report, DbvReasonNoReport *peReasonNoReport, jmp_buf env)
{
	switch (*peReasonNoReport) {
	case RNR_Temporary:
		*reason_no_report = TEMPORARY;
		break;
	case RNR_Permanent:
		*reason_no_report = PERMANENT;
		break;
	}
}



int DBVdbv_to_snacc_statusrep(struct Status_Report* status_report, DbvStatusReport *psStatusReport, jmp_buf env)
{
	/* Both comp */
	status_report->user_status_report = (struct History_Report*) Asn1Alloc (sizeof (struct History_Report));
	CheckAsn1Alloc(status_report->user_status_report, env);
	DBVdbv_to_snacc_userstatrep(status_report->user_status_report, &psStatusReport->sUserStatusReport, env);
	
	DBVdbv_to_snacc_provstatrep(&status_report->provider_status_report, &psStatusReport->eProviderStatusReport, env);

}



int DBVdbv_to_snacc_userstatrep(struct History_Report* user_status_report, DbvHistoryReport *psStatusReport, jmp_buf env)
{
	/* opt */
	if (psStatusReport->pcDateRequested != NULL)
		DBVdbv_to_snacc_vis_string(&user_status_report->date_requested, psStatusReport->pcDateRequested, env);

	/* opt */
	if (psStatusReport->psAuthor != NULL) {
		user_status_report->author = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(user_status_report->author, env);
		DBVdbv_to_snacc_illstring(user_status_report->author, psStatusReport->psAuthor, env);
	}


	/* o */
	if (psStatusReport->psTitle != NULL) {
		user_status_report->title = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(user_status_report->title, env);
		DBVdbv_to_snacc_illstring(user_status_report->title, psStatusReport->psTitle, env);
	}

	
	/* o */
	if (psStatusReport->psAuthorOfArticle != NULL) {
		user_status_report->author_of_article = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(user_status_report->author_of_article, env);
		DBVdbv_to_snacc_illstring(user_status_report->author_of_article, psStatusReport->psAuthorOfArticle, env);
	}


	/* o */
	if (psStatusReport->psTitleOfArticle != NULL) {
		user_status_report->title_of_article = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(user_status_report->title_of_article, env);
		DBVdbv_to_snacc_illstring(user_status_report->title_of_article, psStatusReport->psTitleOfArticle, env);
	}


	/* c */
	DBVdbv_to_snacc_vis_string(&user_status_report->date_of_last_transition, psStatusReport->pcDateOfLastTransition, env);

	

	/* c */
	DBVdbv_to_snacc_ill_mostrecent(&user_status_report->most_recent_service, &psStatusReport->eMostRecentService, env);

	/* c */
	DBVdbv_to_snacc_vis_string(&user_status_report->date_of_most_recent_service, psStatusReport->pcDateOfMostRecentService, env);


	/* c */
	user_status_report->initiator_of_most_recent_service = (struct System_Id*) Asn1Alloc (sizeof (struct System_Id));
	CheckAsn1Alloc(user_status_report->initiator_of_most_recent_service, env);
	DBVdbv_to_snacc_systemid(user_status_report->initiator_of_most_recent_service, &psStatusReport->sSystemId, env);
	


	/* o */
	if (psStatusReport->peShippedServiceType != NULL) {
		user_status_report->shipped_service_type = (Shipped_Service_Type*) Asn1Alloc (sizeof (Shipped_Service_Type));
		CheckAsn1Alloc(user_status_report->shipped_service_type, env);
		DBVdbv_to_snacc_ill_shippedserv(user_status_report->shipped_service_type, psStatusReport->peShippedServiceType, env);
	}
	

	/* o */
	if (psStatusReport->peTransactionResults != NULL) {
		user_status_report->transaction_results = (Transaction_Results*) Asn1Alloc (sizeof (Transaction_Results));
		CheckAsn1Alloc(user_status_report->transaction_results, env);
		DBVdbv_to_snacc_ill_transres(user_status_report->transaction_results, psStatusReport->peTransactionResults, env);
	}
	

	/* o */
	if (psStatusReport->psMostRecentServiceNote != NULL) {
		user_status_report->most_recent_service_note = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String));
		CheckAsn1Alloc(user_status_report->most_recent_service_note, env);
		DBVdbv_to_snacc_illstring(user_status_report->most_recent_service_note, psStatusReport->psMostRecentServiceNote, env);
	}
}



int DBVdbv_to_snacc_ill_mostrecent(History_ReportEnum *most_recent_service, DbvMostRecentService *peMostRecentService, jmp_buf env)
{
	switch (*peMostRecentService) {
	case MRS_IllRequest:
		*most_recent_service = ILL_REQUEST;
		break;
	case MRS_Forward:
		*most_recent_service = FORWARD;
		break;
	case MRS_ForwardNotification:
		*most_recent_service = FORWARD_NOTIFICATION;
		break;
	case MRS_Shipped:
		*most_recent_service = SHIPPED;
		break;
	case MRS_IllAnswer:
		*most_recent_service = ILL_ANSWER;
		break;
	case MRS_ConditionalReply:
		*most_recent_service = CONDITIONAL_REPLY;
		break;
	case MRS_Cancel:
		*most_recent_service = CANCEL1;
		break;
	case MRS_CancelReply:
		*most_recent_service = CANCEL_REPLY;
		break;
	case MRS_Received:
		*most_recent_service = RECEIVED;
		break;
	case MRS_Recall:
		*most_recent_service = RECALL;
		break;
	case MRS_Returned:
		*most_recent_service = RETURNED;
		break;
	case MRS_CheckedIn:
		*most_recent_service = CHECKED_IN;
		break;
	case MRS_Overdue:
		*most_recent_service = OVERDUE;
		break;
	case MRS_Renew:
		*most_recent_service = RENEW;
		break;
	case MRS_RenewAnswer:
		*most_recent_service = RENEW_ANSWER;
		break;
	case MRS_Lost:
		*most_recent_service = LOST;
		break;
	case MRS_Damaged:
		*most_recent_service = DAMAGED;
		break;
	case MRS_Message:
		*most_recent_service = MESSAGE;
		break;
	case MRS_StatusQuery:
		*most_recent_service = STATUS_QUERY;
		break;
	case MRS_StatusOrErrorReport:
		*most_recent_service = STATUS_OR_ERROR_REPORT;
		break;
	case MRS_Expired:
		*most_recent_service = EXPIRED;
		break;
	}
}



int DBVdbv_to_snacc_ill_shippedserv(Shipped_Service_Type *shipped_service_type, DbvShippedServiceType *peShippedServiceType, jmp_buf env)
{
	/* The Dbv structure only has 2 of the 5 possible shipped service
	   types specified in the ASN.1 !!*/

	switch (*peShippedServiceType) {
	case SST_Loan:
		*shipped_service_type = LOAN;
		break;
	case SST_CopyNonReturnable:
		*shipped_service_type = COPY_NON_RETURNABLE;
		break;
	}
}



int DBVdbv_to_snacc_ill_transres(Transaction_Results *transaction_results, DbvTransactionResults *peTransactionResults, jmp_buf env)
{
	switch (*peTransactionResults) {
	case TR_Conditional:
		*transaction_results = CONDITIONAL1;
		break;
	case TR_Retry:
		*transaction_results = RETRY;
		break;
	case TR_Unfilled:
		*transaction_results = UNFILLED;
		break;
	case TR_LocationsProvided:
		*transaction_results = LOCATIONS_PROVIDED;
		break;
	case TR_WillSupply:
		*transaction_results = WILL_SUPPLY;
		break;
	case TR_HoldPlaced:
		*transaction_results = HOLD_PLACED;
		break;
	case TR_Estimate:
		*transaction_results = ESTIMATE1;
		break;
	}
}



int DBVdbv_to_snacc_provstatrep(Current_State *provider_status_report, DbvCurrentState *peProviderStatusReport, jmp_buf env)
{
	switch (*peProviderStatusReport) {
	case CS_NotSupplied:
		*provider_status_report = NOT_SUPPLIED;
		break;
	case CS_Pending:
		*provider_status_report = PENDING1;
		break;
	case CS_InProcess:
		*provider_status_report = IN_PROCESS2;
		break;
	case CS_Forward:
		*provider_status_report = FORWARD1;
		break;
	case CS_Conditional:
		*provider_status_report = CONDITIONAL;
		break;
	case CS_CancelPending:
		*provider_status_report = CANCEL_PENDING;
		break;
	case CS_Cancelled:
		*provider_status_report = CANCELLED;
		break;
	case CS_Shipped:
		*provider_status_report = SHIPPED1;
		break;
	case CS_Received:
		*provider_status_report = RECEIVED1;
		break;
	case CS_RenewPending:
		*provider_status_report = RENEW_PENDING;
		break;
	case CS_NotReceivedOverdue:
		*provider_status_report = NOT_RECEIVED_OVERDUE;
		break;
	case CS_RenewOverdue:
		*provider_status_report = RENEW_OVERDUE;
		break;
	case CS_Overdue:
		*provider_status_report = OVERDUE1;
		break;
	case CS_Returned:
		*provider_status_report = RETURNED1;
		break;
	case CS_CheckedIn:
		*provider_status_report = CHECKED_IN1;
		break;
	case CS_Recall:
		*provider_status_report = RECALL1;
		break;
	case CS_Lost:
		*provider_status_report = LOST1;
		break;
	case CS_Unknown:
		*provider_status_report = UNKNOWN;
		break;
	}
}



int DBVdbv_to_snacc_errorrep(struct Error_Report* error_report, DbvErrorReport *psErrorReport, jmp_buf env)
{
	/* comp */
	error_report->correlation_information = (struct ILL_String*) Asn1Alloc (sizeof (struct ILL_String));
	CheckAsn1Alloc(error_report->correlation_information, env);
	DBVdbv_to_snacc_illstring(error_report->correlation_information, &psErrorReport->sCorrelationInfo, env);
	
	
	/* The mapping is not 1:1 for the rest of the fields  .. */

	switch (psErrorReport->sReport.eReportSource) {
	case RS_User:
		error_report->report_source = USER;
		error_report->user_error_report = (struct User_Error_Report*) Asn1Alloc (sizeof (struct User_Error_Report));
		CheckAsn1Alloc(error_report->user_error_report, env);
		DBVdbv_to_snacc_userreport(error_report->user_error_report, psErrorReport->sReport.uReport.psUserErrorReport, env);
		break;
	case RS_Provider:
		error_report->report_source = PROVIDER;
		error_report->provider_error_report = (struct Provider_Error_Report*) Asn1Alloc (sizeof (struct Provider_Error_Report));
		CheckAsn1Alloc(error_report->provider_error_report, env);
		DBVdbv_to_snacc_provreport(error_report->provider_error_report, psErrorReport->sReport.uReport.psProviderErrorReport, env);
		break;
	}
}



int DBVdbv_to_snacc_userreport(struct User_Error_Report* user_error_report, DbvUserErrorReport *psUserErrorReport, jmp_buf env)
{
	switch (psUserErrorReport->eReportType) {
	case UER_AlreadyForwarded:
		user_error_report->choiceId = USER_ERROR_REPORT_ALREADY_FORWARDED;
		user_error_report->a.already_forwarded = (struct Already_Forwarded*) Asn1Alloc (sizeof (struct Already_Forwarded));
		CheckAsn1Alloc(user_error_report->a.already_forwarded, env);
		DBVdbv_to_snacc_alreadforward(user_error_report->a.already_forwarded, psUserErrorReport->uUserErrorReport.psAlreadyForwarded, env);
		break;
	case UER_IntermediaryProblem:
		user_error_report->choiceId = USER_ERROR_REPORT_INTERMEDIARY_PROBLEM;
		DBVdbv_to_snacc_intermprob(&user_error_report->a.intermediary_problem, &psUserErrorReport->uUserErrorReport.eIntermediaryProblem, env);
		break;
	case UER_SecurityProblem:
		user_error_report->choiceId = USER_ERROR_REPORT_SECURITY_PROBLEM;
		user_error_report->a.security_problem = (Security_Problem*) Asn1Alloc (sizeof (Security_Problem));
		CheckAsn1Alloc(user_error_report->a.security_problem, env);
		DBVdbv_to_snacc_illstring(user_error_report->a.security_problem, psUserErrorReport->uUserErrorReport.psSecurityProblem, env);
		break;
	case UER_UnableToPerform:
		user_error_report->choiceId = USER_ERROR_REPORT_UNABLE_TO_PERFORM;
		DBVdbv_to_snacc_unableperf(&user_error_report->a.unable_to_perform, &psUserErrorReport->uUserErrorReport.eUnableToPerform, env);
		break;
	}
}



int DBVdbv_to_snacc_alreadforward(struct Already_Forwarded *already_forwarded, DbvAlreadyForwarded *psAlreadyForwarded, jmp_buf env)
{
	/* comp */
	already_forwarded->responder_id = (struct System_Id*) Asn1Alloc (sizeof (struct System_Id));	
	CheckAsn1Alloc(already_forwarded->responder_id, env);
	DBVdbv_to_snacc_systemid(already_forwarded->responder_id, &psAlreadyForwarded->sResponderId, env);

	/* opt */
	if (psAlreadyForwarded->psResponderAddress != NULL) {
		already_forwarded->responder_address = (struct System_Address*) Asn1Alloc (sizeof (struct System_Address));
		CheckAsn1Alloc(already_forwarded->responder_address, env);
		DBVdbv_to_snacc_electaddress(already_forwarded->responder_address, psAlreadyForwarded->psResponderAddress, env);
	}
}


int DBVdbv_to_snacc_intermprob(Intermediary_Problem *intermediary_problem, DbvIntermediaryProblem *peIntermediaryProblem, jmp_buf env)
{

	/* short but sweet */

	switch (*peIntermediaryProblem) {
	case IP_CannotSendOnward:
		*intermediary_problem = CANNOT_SEND_ONWARD;
		break;
	}
}



int DBVdbv_to_snacc_unableperf(Unable_To_Perform *unable_to_perform, DbvUnableToPerform *peUnableToPerform, jmp_buf env)
{
	switch (*peUnableToPerform) {
	case UTP_NotAvailable:
		*unable_to_perform = NOT_AVAILABLE;
		break;
	case UTP_ResourceLimitation:
		*unable_to_perform = RESOURCE_LIMITATION;
		break;
	case UTP_Other:
		*unable_to_perform = OTHER12;
		break;
	}
	
}



int DBVdbv_to_snacc_provreport(struct Provider_Error_Report *provider_error_report, DbvProviderErrorReport *psProviderErrorReport, jmp_buf env)
{
	switch (psProviderErrorReport->eReportType) {
	case PER_GeneralProblem:
		provider_error_report->choiceId = PROVIDER_ERROR_REPORT_GENERAL_PROBLEM; 
		DBVdbv_to_snacc_generalprob(&provider_error_report->a.general_problem, &psProviderErrorReport->uProviderErrorReport.eGeneralProblem, env);
		break;
	case PER_TransactionIdProblem:
		provider_error_report->choiceId = PROVIDER_ERROR_REPORT_TRANSACTION_ID_PROBLEM; 
		DBVdbv_to_snacc_transidprob(&provider_error_report->a.transaction_id_problem, &psProviderErrorReport->uProviderErrorReport.eTransactionIdProblem, env);
		break;
	case PER_StateTransitionProhibited:
		provider_error_report->choiceId = PROVIDER_ERROR_REPORT_STATE_TRANSITION_PROHIBITED; 
		provider_error_report->a.state_transition_prohibited = (struct State_Transition_Prohibited*) Asn1Alloc (sizeof (struct State_Transition_Prohibited));
		CheckAsn1Alloc(provider_error_report->a.state_transition_prohibited, env);
		DBVdbv_to_snacc_statetrans(provider_error_report->a.state_transition_prohibited, psProviderErrorReport->uProviderErrorReport.psStateTransitionProblem, env);
		break;
	}
}



int DBVdbv_to_snacc_generalprob(General_Problem *general_problem, DbvGeneralProblem *peGeneralProblem, jmp_buf env)
{
	switch (*peGeneralProblem) {
	case GP_UnrecognizedAPDU:
		*general_problem = UNRECOGNIZED_APDU;
		break;
	case GP_MistypedAPDU:
		*general_problem = MISTYPED_APDU;
		break;
	case GP_BadlyStructuredAPDU:
		*general_problem = BADLY_STRUCTURED_APDU;
		break;
	case GP_ProtocolVersionNotSupported:
		*general_problem = PROTOCOL_VERSION_NOT_SUPPORTED;
		break;
	case GP_Other:
		*general_problem = OTHER6;
		break;
	}
	
}



int DBVdbv_to_snacc_transidprob(Transaction_Id_Problem *transaction_id_problem, DbvTransactionIdProblem *peTransactionIdProblem, jmp_buf env)
{
	switch (*peTransactionIdProblem) {
	case TIP_DuplicateTransactionId:
		*transaction_id_problem = DUPLICATE_TRANSACTION_ID;
		break;
	case TIP_InvalidTransactionId:
		*transaction_id_problem = INVALID_TRANSACTION_ID;
		break;
	case TIP_UnknownTransactionId:
		*transaction_id_problem = UNKNOWN_TRANSACTION_ID;
		break;
	}
}



int DBVdbv_to_snacc_statetrans(struct State_Transition_Prohibited* state_transition_prohibited, DbvStateTransitionProhibited *psStateTransitionProblem, jmp_buf env)
{
	/* Both comp, both enums */
	DBVdbv_to_snacc_illpdutype(&state_transition_prohibited->aPDU_type, &psStateTransitionProblem->eAPDUType, env);
	DBVdbv_to_snacc_currstate(&state_transition_prohibited->current_state, &psStateTransitionProblem->eCurrentState, env);
	
}



int DBVdbv_to_snacc_illpdutype(ILL_APDU_Type *aPDU_type, DbvIllAPDUType *peAPDUType, jmp_buf env)
{
	switch (*peAPDUType) {
	case IAT_IllRequest:
		*aPDU_type = ILL_REQUEST1;
		break;
	case IAT_ForwardNotification:
		*aPDU_type = FORWARD_NOTIFICATION1;
		break;
	case IAT_Shipped:
		*aPDU_type = SHIPPED2;
		break;
	case IAT_IllAnswer:
		*aPDU_type = ILL_ANSWER1;
		break;
	case IAT_ConditionalReply:
		*aPDU_type = CONDITIONAL_REPLY1;
		break;
	case IAT_Cancel:
		*aPDU_type = CANCEL2;
		break;
	case IAT_CancelReply:
		*aPDU_type = CANCEL_REPLY1;
		break;
	case IAT_Received:
		*aPDU_type = RECEIVED2;
		break;
	case IAT_Recall:
		*aPDU_type = RECALL2;
		break;
	case IAT_Returned:
		*aPDU_type = RETURNED2;
		break;
	case IAT_CheckedIn:
		*aPDU_type = CHECKED_IN2;
		break;
	case IAT_Overdue:
		*aPDU_type = OVERDUE2;
		break;
	case IAT_Renew:
		*aPDU_type = RENEW1;
		break;
	case IAT_RenewAnswer:
		*aPDU_type = RENEW_ANSWER1;
		break;
	case IAT_Lost:
		*aPDU_type = LOST2;
		break;
	case IAT_Damaged:
		*aPDU_type = DAMAGED1;
		break;
	case IAT_Message:
		*aPDU_type = MESSAGE1;
		break;
	case IAT_StatusQuery:
		*aPDU_type = STATUS_QUERY1;
		break;
	case IAT_StatusOrErrorReport:
		*aPDU_type = STATUS_OR_ERROR_REPORT1;
		break;
	case IAT_Expired:
		*aPDU_type = EXPIRED1;
		break;
	}
}



int DBVdbv_to_snacc_currstate(Current_State *current_state, DbvCurrentState *peCurrentState, jmp_buf env)
{
	switch (*peCurrentState) {
	case CS_NotSupplied:
		*current_state = NOT_SUPPLIED;
		break;
	case CS_Pending:
		*current_state = PENDING1;
		break;
	case CS_InProcess:
		*current_state = IN_PROCESS2;
		break;
	case CS_Forward:
		*current_state = FORWARD1;
		break;
	case CS_Conditional:
		*current_state = CONDITIONAL;
		break;
	case CS_CancelPending:
		*current_state = CANCEL_PENDING;
		break;
	case CS_Cancelled:
		*current_state = CANCELLED;
		break;
	case CS_Shipped:
		*current_state = SHIPPED1;
		break;
	case CS_Received:
		*current_state = RECEIVED1;
		break;
	case CS_RenewPending:
		*current_state = RENEW_PENDING;
		break;
	case CS_NotReceivedOverdue:
		*current_state = NOT_RECEIVED_OVERDUE;
		break;
	case CS_RenewOverdue:
		*current_state = RENEW_OVERDUE;
		break;
	case CS_Overdue:
		*current_state = OVERDUE1;
		break;
	case CS_Returned:
		*current_state = RETURNED1;
		break;
	case CS_CheckedIn:
		*current_state = CHECKED_IN1;
		break;
	case CS_Recall:
		*current_state = RECALL1;
		break;
	case CS_Lost:
		*current_state = LOST1;
		break;
	case CS_Unknown:
		*current_state = UNKNOWN;
		break;
	}
	
}




/* snacc -> dbv iso ill external */
int DBVsnacc_to_dbv_isoillrequest_any(DbvSingleASN1Type *psSingleASN1Type, AsnAnyDefinedBy *any_type, jmp_buf env)
{
	ILL_APDU *ill_ptr;

        ill_ptr = (ILL_APDU *) any_type->value;

        psSingleASN1Type->eASN1Type = AT_IllPdu;
        psSingleASN1Type->uASN1.psIllPdu = (struct DbvIllPdu *) DbvAlloc (sizeof(struct DbvIllPdu));
        CheckDbvAlloc(psSingleASN1Type->uASN1.psIllPdu, env);


        /* snacc inter str to dbv inter str */
        DBVsnacc_to_dbv_illmain(psSingleASN1Type->uASN1.psIllPdu, ill_ptr, env);

}



int DBVsnacc_to_dbv_illmain(struct DbvIllPdu *psIllPdu, ILL_APDU *ill_ptr, jmp_buf env)
{
	switch (ill_ptr->choiceId) {
	case ILL_APDU_ILL_REQUEST:
		psIllPdu->eIllPduType = ILL_IllRequest;
		psIllPdu->uIllPdu.psIllRequest = (struct DbvIllRequest *) DbvAlloc (sizeof (struct DbvIllRequest));
		CheckDbvAlloc(psIllPdu->uIllPdu.psIllRequest, env);
		DBVsnacc_to_dbv_illrequest(psIllPdu->uIllPdu.psIllRequest, ill_ptr->a.iLL_Request, env);
		break;
	case ILL_APDU_STATUS_OR_ERROR_REPORT:
		psIllPdu->eIllPduType = ILL_StatusOrErrorReport;
		psIllPdu->uIllPdu.psStatusOrErrorReport = (struct DbvStatusOrErrorReport *) DbvAlloc (sizeof (struct DbvStatusOrErrorReport));
		CheckDbvAlloc(psIllPdu->uIllPdu.psStatusOrErrorReport, env);
		DBVsnacc_to_dbv_statorerr(psIllPdu->uIllPdu.psStatusOrErrorReport, ill_ptr->a.status_Or_Error_Report, env);
		break;

	/* Unknown ILL report type received */
	default:
		psIllPdu->eIllPduType = ILL_Invalid;
	}
}



int DBVsnacc_to_dbv_illrequest(struct DbvIllRequest *psIllRequest,  struct ILL_Request* iLL_Request, jmp_buf env)
{
	/* Variables used for extracting from AsnList */
	int num_elements, index;

	/* comp */
	DBVsnacc_to_dbv_prover(&psIllRequest->eProtocolVersion, &iLL_Request->protocol_version_num, env);
	
	/* comp */
	DBVsnacc_to_dbv_transid(&psIllRequest->sTransactionId, iLL_Request->transaction_id, env); 

	/* comp */
	DBVsnacc_to_dbv_servdati(&psIllRequest->sServiceDateTime, iLL_Request->service_date_time, env); 
		

	if (iLL_Request->requester_id != NULL) {
		psIllRequest->psRequesterId = (DbvSystemId *) DbvAlloc (sizeof (DbvSystemId));
		CheckDbvAlloc(psIllRequest->psRequesterId, env);
		DBVsnacc_to_dbv_systemid(psIllRequest->psRequesterId, iLL_Request->requester_id, env);
	}
	

	if (iLL_Request->responder_id != NULL) {
		psIllRequest->psResponderId = (DbvSystemId *) DbvAlloc (sizeof (DbvSystemId));
		CheckDbvAlloc(psIllRequest->psResponderId, env);
		DBVsnacc_to_dbv_systemid(psIllRequest->psResponderId, iLL_Request->responder_id, env);
	}
	
	
	/* default so optional */
	if (iLL_Request->transaction_type) {
		psIllRequest->peTransactionType = (DbvTransactionType *) DbvAlloc (sizeof (DbvTransactionType));
		CheckDbvAlloc(psIllRequest->peTransactionType, env);
		DBVsnacc_to_dbv_transtype(psIllRequest->peTransactionType, iLL_Request->transaction_type, env);
	}


	/* opt */
	if (iLL_Request->delivery_address != NULL) {
		psIllRequest->psDeliveryAddress = (DbvDeliveryAddress *) DbvAlloc (sizeof (DbvDeliveryAddress)); 
		CheckDbvAlloc(psIllRequest->psDeliveryAddress, env);
		DBVsnacc_to_dbv_delivaddr(psIllRequest->psDeliveryAddress, iLL_Request->delivery_address, env);
	}
	

	/* opt */
	if (iLL_Request->delivery_service != NULL) {
		psIllRequest->psDeliveryService = (DbvDeliveryService *) DbvAlloc (sizeof (DbvDeliveryService)); 
		CheckDbvAlloc(psIllRequest->psDeliveryService, env);
		DBVsnacc_to_dbv_delivserv(psIllRequest->psDeliveryService, iLL_Request->delivery_service, env);
	}
	
	/* opt */
	if (iLL_Request->billing_address != NULL) {
		psIllRequest->psBillingAddress = (DbvDeliveryAddress *) DbvAlloc (sizeof (DbvDeliveryAddress)); 
		CheckDbvAlloc(psIllRequest->psBillingAddress, env);
		DBVsnacc_to_dbv_delivaddr(psIllRequest->psBillingAddress, iLL_Request->billing_address, env);
	}
	

	/* comp */

	num_elements = 0;
        index = 0;
        num_elements = AsnListCount(iLL_Request->iLL_service_type);
	psIllRequest->ppeServiceType = (DbvServiceType **) DbvAlloc (sizeof (DbvServiceType *) * (num_elements + 1));
        CheckDbvAlloc(psIllRequest->ppeServiceType, env);
	DBVsnacc_to_dbv_servtypelist(psIllRequest->ppeServiceType, iLL_Request->iLL_service_type, env);

	
	/* opt */
	if (iLL_Request->responder_specific_service != NULL) {
		psIllRequest->psResponderSpecificService = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));
		CheckDbvAlloc(iLL_Request->responder_specific_service, env);
		DBVsnacc_to_dbv_external(psIllRequest->psResponderSpecificService, iLL_Request->responder_specific_service, env);
	}

	/* comp */
	DBVsnacc_to_dbv_requestopt(&psIllRequest->sRequesterOptionalMessages, iLL_Request->requester_optional_messages, env);

	/* opt */
	if (iLL_Request->search_type != NULL) {
		psIllRequest->psSearchType = (DbvSearchType *) DbvAlloc (sizeof (DbvSearchType));
		CheckDbvAlloc(psIllRequest->psSearchType, env);
		DBVsnacc_to_dbv_searchtype(psIllRequest->psSearchType, iLL_Request->search_type, env);
	}	

	/* opt */
	if (iLL_Request->supply_medium_info_type != NULL) {
		num_elements = 0;
        	index = 0;
        	num_elements = AsnListCount(iLL_Request->supply_medium_info_type);
		psIllRequest->ppsSupplyMediumInfo = (DbvSupplyMediumInfo **) DbvAlloc (sizeof (DbvSupplyMediumInfo *) * (num_elements + 1));
        	CheckDbvAlloc(psIllRequest->ppsSupplyMediumInfo, env);
		DBVsnacc_to_dbv_suppmedinfolist(psIllRequest->ppsSupplyMediumInfo, iLL_Request->supply_medium_info_type, env);
	}
	

	/* default so optional */
	if (iLL_Request->place_on_hold != NULL) {
		psIllRequest->pePlaceOnHold = (DbvPlaceOnHold *) DbvAlloc (sizeof (DbvPlaceOnHold));
		CheckDbvAlloc(psIllRequest->pePlaceOnHold , env);
		DBVsnacc_to_dbv_placehold(psIllRequest->pePlaceOnHold, iLL_Request->place_on_hold, env);
	}

	/* opt */
	if (iLL_Request->client_id != NULL) {
		psIllRequest->psClientId = (DbvClientId *) DbvAlloc (sizeof (DbvClientId));
		CheckDbvAlloc(psIllRequest->psClientId, env);
		DBVsnacc_to_dbv_clientid(psIllRequest->psClientId, iLL_Request->client_id, env);
	}

	/* comp */
	DBVsnacc_to_dbv_itemid(&psIllRequest->sItemId, iLL_Request->item_id, env);
	/* opt */
	if (iLL_Request->supplemental_item_description != NULL) {
		num_elements = 0;
        	index = 0;
        	num_elements = AsnListCount(iLL_Request->supplemental_item_description);
		psIllRequest->ppsSupplementalItemDescription = (DbvASN1External **) DbvAlloc (sizeof (DbvASN1External *) * (num_elements + 1));
        	CheckDbvAlloc(psIllRequest->ppsSupplementalItemDescription, env);
		DBVsnacc_to_dbv_suppitemlist(psIllRequest->ppsSupplementalItemDescription, iLL_Request->supplemental_item_description, env);
	}



	/* opty */
	if (iLL_Request->cost_info_type != NULL) {
		psIllRequest->psCostInfo = (DbvCostInfo *) DbvAlloc (sizeof (DbvCostInfo));
		CheckDbvAlloc(psIllRequest->psCostInfo, env);
		DBVsnacc_to_dbv_costinfo(psIllRequest->psCostInfo, iLL_Request->cost_info_type, env);
	}

	
	/* opty */
	if (iLL_Request->copyright_compliance != NULL) {
		psIllRequest->psCopyrightCompliance = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psIllRequest->psCopyrightCompliance, env);
		DBVsnacc_to_dbv_illstring(psIllRequest->psCopyrightCompliance, iLL_Request->copyright_compliance, env);
	}
		
	
	/* another opty */
	if (iLL_Request->third_party_info_type != NULL) {
		psIllRequest->psThirdPartyInfo = (DbvThirdPartyInfo *) DbvAlloc (sizeof (DbvThirdPartyInfo));
		CheckDbvAlloc(psIllRequest->psThirdPartyInfo, env);
		DBVsnacc_to_dbv_thirdparty(psIllRequest->psThirdPartyInfo, iLL_Request->third_party_info_type, env);
	}


	/* default so optional */
	if (iLL_Request->retry_flag) {
		psIllRequest->pfRetry = (DbvBool *) DbvAlloc (sizeof (DbvBool));
		CheckDbvAlloc(psIllRequest->pfRetry, env);
		DBVsnacc_to_dbv_DbvBool(psIllRequest->pfRetry, iLL_Request->retry_flag, env);
	}


	/* default so optional */
	if (iLL_Request->forward_flag) {
		psIllRequest->pfForward = (DbvBool *) DbvAlloc (sizeof (DbvBool));
		CheckDbvAlloc(psIllRequest->pfForward, env);
		DBVsnacc_to_dbv_DbvBool(psIllRequest->pfForward, iLL_Request->forward_flag, env);
	}


	/* opty */
	if (iLL_Request->requester_note != NULL) {
		psIllRequest->psRequesterNote = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		DBVsnacc_to_dbv_illstring(psIllRequest->psRequesterNote, iLL_Request->requester_note, env);
	}


	/* opty */
	if (iLL_Request->forward_note != NULL) {
		psIllRequest->psForwardNote = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		DBVsnacc_to_dbv_illstring(psIllRequest->psForwardNote, iLL_Request->forward_note, env);
	}






	/* opty */
	if (iLL_Request->iLL_request_extensions != NULL) {
		num_elements = 0;
        	index = 0;
        	num_elements = AsnListCount(iLL_Request->iLL_request_extensions);
		psIllRequest->ppsRequestExtension = (DbvExtension **) DbvAlloc (sizeof (DbvExtension *) * (num_elements + 1));
        	CheckDbvAlloc(psIllRequest->ppsRequestExtension, env);
		DBVsnacc_to_dbv_extensionlist(psIllRequest->ppsRequestExtension, iLL_Request->iLL_request_extensions, env);
	}
}



int DBVsnacc_to_dbv_prover(DbvIllProtocolVersion *peProtocolVersion, ILL_RequestInt *protocol_version_num, jmp_buf env)
{
	switch (*protocol_version_num) {
	case VERSION_122:
		*peProtocolVersion = PV_Version1;
		break;
	case VERSION_222:
		*peProtocolVersion = PV_Version2;
		break;
	default:
		*peProtocolVersion = PV_Invalid;
	}
	
}



int DBVsnacc_to_dbv_transid(DbvTransactionId *psTransactionId, struct Transaction_Id* transaction_id, jmp_buf env) 
{
	/* opt */
	if (transaction_id->initial_requester_id != NULL) {
		psTransactionId->psInitialRequesterId = (DbvSystemId*) DbvAlloc (sizeof (DbvSystemId));
		CheckDbvAlloc(psTransactionId->psInitialRequesterId, env);
		DBVsnacc_to_dbv_systemid(psTransactionId->psInitialRequesterId, transaction_id->initial_requester_id, env);
	}

	/* Two comp */
	DBVsnacc_to_dbv_illstring(&psTransactionId->sTransactionGroupQualifier, transaction_id->transaction_group_qualifier, env);
	DBVsnacc_to_dbv_illstring(&psTransactionId->sTransactionQualifier, transaction_id->transaction_qualifier, env);

	/* an opty */
	if (transaction_id->sub_transaction_qualifier != NULL) {
		psTransactionId->psSubTransactionQualifier = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psTransactionId->psSubTransactionQualifier, env);
		DBVsnacc_to_dbv_illstring(psTransactionId->psSubTransactionQualifier, transaction_id->sub_transaction_qualifier, env);
	}
	
	
}


int DBVsnacc_to_dbv_systemid(DbvSystemId *psInitialRequesterId, struct System_Id* initial_requester_id, jmp_buf env)
{
	/* Two opties here */
	if (initial_requester_id->person_or_institution_symbol != NULL) {
		psInitialRequesterId->psSymbol = (DbvPersonOrInstitutionSymbol *) DbvAlloc (sizeof (DbvPersonOrInstitutionSymbol));
		CheckDbvAlloc(psInitialRequesterId->psSymbol, env);
		DBVsnacc_to_dbv_perorsym(psInitialRequesterId->psSymbol, initial_requester_id->person_or_institution_symbol, env);
	}

		
	if (initial_requester_id->name_of_person_or_institution != NULL) {
		psInitialRequesterId->psName = (DbvNameOfPersonOrInstitution *) DbvAlloc (sizeof (DbvNameOfPersonOrInstitution));
		CheckDbvAlloc(psInitialRequesterId->psName, env);
		DBVsnacc_to_dbv_perorinst(psInitialRequesterId->psName, initial_requester_id->name_of_person_or_institution, env);
	}
}
	


int DBVsnacc_to_dbv_perorsym(DbvPersonOrInstitutionSymbol *psSymbol, struct Person_Or_Institution_Symbol* person_or_institution_symbol, jmp_buf env)
{

	/* Not exact mapping here */

	switch (person_or_institution_symbol->choiceId) {
	case PERSON_OR_INSTITUTION_SYMBOL_PERSON_SYMBOL:
		psSymbol->eSymbolType = SPI_PersonSymbol;
		DBVsnacc_to_dbv_illstring(&psSymbol->sSymbol, person_or_institution_symbol->a.person_symbol, env);
		
		break;
	case PERSON_OR_INSTITUTION_SYMBOL_INSTITUTION_SYMBOL:
		psSymbol->eSymbolType = SPI_InstitutionSymbol;
		DBVsnacc_to_dbv_illstring(&psSymbol->sSymbol, person_or_institution_symbol->a.institution_symbol, env);
		break;
	}
}



int DBVsnacc_to_dbv_illstring(DbvIllString *psSymbol, struct ILL_String* person_symbol, jmp_buf env)
{
	switch (person_symbol->choiceId) {
	case ILL_STRING_GENERALSTRING:
		psSymbol->eStringType = ST_GeneralString;
		psSymbol->uString.psGeneralString = (DbvGeneralString *) DbvAlloc (sizeof (DbvGeneralString));
		CheckDbvAlloc(psSymbol->uString.psGeneralString, env);
		DBVsnacc_to_dbv_general_string(psSymbol->uString.psGeneralString, person_symbol->a.generalString, env);
		break;
	case ILL_STRING_EDIFACTSTRING:
		psSymbol->eStringType = ST_EdifactString;
		DBVsnacc_to_dbv_vis_string(&psSymbol->uString.pcVisibleString, person_symbol->a.eDIFACTString, env);
		break;
	}
}


int DBVsnacc_to_dbv_general_string(DbvGeneralString *psGeneralString, GeneralString *generalString, jmp_buf env)
{
	DBVsnacc_to_dbv_inter_string((DbvInternationalString *) psGeneralString, (InternationalString *) generalString, env);
}


int DBVsnacc_to_dbv_perorinst(DbvNameOfPersonOrInstitution *psName, struct Name_Of_Person_Or_Institution* name_of_person_or_institution, jmp_buf env)
{
	/* No direct mapping here */
	switch (name_of_person_or_institution->choiceId) {
	case NAME_OF_PERSON_OR_INSTITUTION_NAME_OF_PERSON:
		psName->eNameType = NPI_NameOfPerson;
		DBVsnacc_to_dbv_illstring(&psName->sName, name_of_person_or_institution->a.name_of_person, env);
		break;
	case NAME_OF_PERSON_OR_INSTITUTION_NAME_OF_INSTITUTION:
		psName->eNameType = NPI_NameOfInstitution;
		DBVsnacc_to_dbv_illstring(&psName->sName, name_of_person_or_institution->a.name_of_institution, env);
		break;
	}
}



/* snacc Service_Date_TimeSeq and Service_Date_TimeSeq1 have the same definiton */

int DBVsnacc_to_dbv_servdati(DbvServiceDateTime *psServiceDateTime, struct Service_Date_Time* service_date_time, jmp_buf env) 
{
	/* comp */
	DBVsnacc_to_dbv_datetime(&psServiceDateTime->sThisService, service_date_time->date_time_of_this_service, env);
	
	/* opt */
	if (service_date_time->date_time_of_original_service != NULL) {
		psServiceDateTime->psOriginalService = (DbvDateTime *) DbvAlloc (sizeof (DbvDateTime));
		CheckDbvAlloc(psServiceDateTime->psOriginalService, env);
		DBVsnacc_to_dbv_datetime(psServiceDateTime->psOriginalService, (struct Service_Date_TimeSeq *) service_date_time->date_time_of_original_service, env);
	}
	
}



int DBVsnacc_to_dbv_datetime(DbvDateTime *psThisService, struct Service_Date_TimeSeq* date_time_of_this_service, jmp_buf env)
{

	/* ISO_Date and ISO_Time are visible string */

	/* a scrumpy compy */
	DBVsnacc_to_dbv_vis_string(&psThisService->pcDate, &date_time_of_this_service->date, env);

	/* a scrawny opty */
	if (date_time_of_this_service->time.octetLen != 0)
		DBVsnacc_to_dbv_vis_string(&psThisService->pcTime, &date_time_of_this_service->time, env);
	
}



int DBVsnacc_to_dbv_transtype(DbvTransactionType *peTransactionType, Transaction_Type *transaction_type, jmp_buf env)
{
	switch (*transaction_type) {
	case SIMPLE:
		*peTransactionType = TT_Simple;
		break;
	case CHAINED:
		*peTransactionType = TT_Chained;
		break;
	case PARTITIONED:
		*peTransactionType = TT_Partitioned;
		break;
	default:
		*peTransactionType = TT_Invalid;
		break;

	}
}


int DBVsnacc_to_dbv_delivaddr(DbvDeliveryAddress *psDeliveryAddress, struct Delivery_Address *delivery_address, jmp_buf env)
{
	/* both optional */

	if (delivery_address->postal_address != NULL) {
		psDeliveryAddress->psPostalAddress = (DbvPostalAddress *) DbvAlloc (sizeof (DbvPostalAddress));
		CheckDbvAlloc(psDeliveryAddress->psPostalAddress, env);
		DBVsnacc_to_dbv_postaddr(psDeliveryAddress->psPostalAddress, delivery_address->postal_address, env);
	}

	if (delivery_address->electronic_address != NULL) {
		psDeliveryAddress->psElectronicAddress = (DbvSystemAddress *) DbvAlloc (sizeof (DbvSystemAddress));
		CheckDbvAlloc(psDeliveryAddress->psElectronicAddress, env);
		DBVsnacc_to_dbv_electaddr(psDeliveryAddress->psElectronicAddress, delivery_address->electronic_address, env);
	}

}



int DBVsnacc_to_dbv_postaddr(DbvPostalAddress *psPostalAddress, struct Postal_Address* postal_address, jmp_buf env)
{
	/* opt */
	if (postal_address->name_of_person_or_institution != NULL) {
		psPostalAddress->psNameOfPersonOrInstitution = (DbvNameOfPersonOrInstitution *) DbvAlloc (sizeof (DbvNameOfPersonOrInstitution));
		CheckDbvAlloc(psPostalAddress->psNameOfPersonOrInstitution, env);
		DBVsnacc_to_dbv_nameofpersinst(psPostalAddress->psNameOfPersonOrInstitution, postal_address->name_of_person_or_institution, env);
	}
	

	/* A bunch of optional illstring */
	if (postal_address->extended_postal_delivery_address != NULL) {
		psPostalAddress->psExtendedPostalDeliveryAddress = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psPostalAddress->psExtendedPostalDeliveryAddress, env);
		DBVsnacc_to_dbv_illstring(psPostalAddress->psExtendedPostalDeliveryAddress, postal_address->extended_postal_delivery_address, env);
	}



	if (postal_address->street_and_number != NULL) {
		psPostalAddress->psStreetAndNumber = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psPostalAddress->psStreetAndNumber, env);
		DBVsnacc_to_dbv_illstring(psPostalAddress->psStreetAndNumber, postal_address->street_and_number, env);
	}



	if (postal_address->post_office_box != NULL) {
		psPostalAddress->psPostOfficeBox = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psPostalAddress->psPostOfficeBox, env);
		DBVsnacc_to_dbv_illstring(psPostalAddress->psPostOfficeBox, postal_address->post_office_box, env);
	}



	if (postal_address->city != NULL) {
		psPostalAddress->psCity = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psPostalAddress->psCity, env);
		DBVsnacc_to_dbv_illstring(psPostalAddress->psCity, postal_address->city, env);
	}



	if (postal_address->region != NULL) {
		psPostalAddress->psRegion = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psPostalAddress->psRegion, env);
		DBVsnacc_to_dbv_illstring(psPostalAddress->psRegion, postal_address->region, env);
	}



	if (postal_address->country != NULL) {
		psPostalAddress->psCountry = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psPostalAddress->psCountry, env);
		DBVsnacc_to_dbv_illstring(psPostalAddress->psCountry, postal_address->country, env);
	}



	if (postal_address->postal_code != NULL) {
		psPostalAddress->psPostalCode = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psPostalAddress->psPostalCode, env);
		DBVsnacc_to_dbv_illstring(psPostalAddress->psPostalCode, postal_address->postal_code, env);
	}

}



int DBVsnacc_to_dbv_nameofpersinst(DbvNameOfPersonOrInstitution *psNameOfPersonOrInstitution, struct Name_Of_Person_Or_Institution* name_of_person_or_institution, jmp_buf env)
{
	/* No direct mapping here */
	switch (name_of_person_or_institution->choiceId) {
	case NAME_OF_PERSON_OR_INSTITUTION_NAME_OF_PERSON:
		psNameOfPersonOrInstitution->eNameType = NPI_NameOfPerson;
		DBVsnacc_to_dbv_illstring(&psNameOfPersonOrInstitution->sName, name_of_person_or_institution->a.name_of_person, env);
		break;
	case NAME_OF_PERSON_OR_INSTITUTION_NAME_OF_INSTITUTION:
		psNameOfPersonOrInstitution->eNameType = NPI_NameOfInstitution;
		DBVsnacc_to_dbv_illstring(&psNameOfPersonOrInstitution->sName, name_of_person_or_institution->a.name_of_institution, env);
		break;
	}
}



int DBVsnacc_to_dbv_electaddr(DbvSystemAddress *psElectronicAddress, struct System_Address* electronic_address, jmp_buf env)
{
	/* A couple of opties */

	if (electronic_address->telecom_service_identifier != NULL) {
		psElectronicAddress->psTelecomServiceIdentifier = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psElectronicAddress->psTelecomServiceIdentifier, env);
		DBVsnacc_to_dbv_illstring(psElectronicAddress->psTelecomServiceIdentifier, electronic_address->telecom_service_identifier, env);
	}


	if (electronic_address->telecom_service_address != NULL) {
		psElectronicAddress->psTelecomServiceAddress = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psElectronicAddress->psTelecomServiceAddress, env);
		DBVsnacc_to_dbv_illstring(psElectronicAddress->psTelecomServiceAddress, electronic_address->telecom_service_address, env);
	}
}



int DBVsnacc_to_dbv_delivserv(DbvDeliveryService *psDeliveryService, struct Delivery_Service* delivery_service, jmp_buf env)
{
	/* Variables used for extracting from AsnList */
	int num_elements, index;

	switch (delivery_service->choiceId) {
	case DELIVERY_SERVICE_PHYSICAL_DELIVERY:
		psDeliveryService->eDeliveryServiceType = DST_PhysicalDelivery;		
		psDeliveryService->uDeliveryService.psPhysicalDelivery = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psDeliveryService->uDeliveryService.psPhysicalDelivery, env);
		DBVsnacc_to_dbv_illstring(psDeliveryService->uDeliveryService.psPhysicalDelivery, delivery_service->a.physical_delivery, env);
		break;
	case DELIVERY_SERVICE_ELECTRONIC_DELIVERY:
		psDeliveryService->eDeliveryServiceType = DST_ElectronicDelivery;		
		num_elements = 0;
        	index = 0;
        	num_elements = AsnListCount(delivery_service->a.electronic_delivery);
		psDeliveryService->uDeliveryService.ppsElectronicDelivery = (DbvElectronicDeliveryService **) DbvAlloc (sizeof (DbvIllString *) * (num_elements + 1));
		CheckDbvAlloc(psDeliveryService->uDeliveryService.ppsElectronicDelivery, env);
		DBVsnacc_to_dbv_elecdelivlist(psDeliveryService->uDeliveryService.ppsElectronicDelivery, delivery_service->a.electronic_delivery, env);


		break;
	default:
		psDeliveryService->eDeliveryServiceType = DST_Invalid;		
	}
}



int DBVsnacc_to_dbv_elecdelivlist(DbvElectronicDeliveryService **ppsElectronicDelivery, Delivery_ServiceSeqOf *electronic_delivery, jmp_buf env)
{
	Electronic_Delivery_Service *data_ptr;
	int index = 0;

        FOR_EACH_LIST_ELMT(data_ptr, electronic_delivery) {
                ppsElectronicDelivery[index] = (DbvElectronicDeliveryService *) DbvAlloc (sizeof(DbvElectronicDeliveryService));
                CheckDbvAlloc(ppsElectronicDelivery[index], env);
		DBVsnacc_to_dbv_elecdelivserv(ppsElectronicDelivery[index], data_ptr, env);
                index++;
        }
        ppsElectronicDelivery[index] = NULL;
}



int DBVsnacc_to_dbv_elecdelivserv(DbvElectronicDeliveryService *psElectronicDelivery, Electronic_Delivery_Service *data_ptr, jmp_buf env)
{
	char direct_reference[SA_ARRAY_SIZE];
	char *oid = NULL;


	/* START OF THE DIRTIES */	
	/* Strange mapping here */

	/* o */
	if (data_ptr->e_delivery_mode.octetLen != 0) {
		psElectronicDelivery->psDeliveryParameter = (DbvElDeliveryParameter *) DbvAlloc(sizeof (DbvElDeliveryParameter));
		CheckDbvAlloc(psElectronicDelivery->psDeliveryParameter, env);


		oid = (char *) ASN_EncodedToString(&(data_ptr->e_delivery_mode));
		psElectronicDelivery->psDeliveryParameter->pcDeliveryMode = (DbvObjectIdentifier) DbvAlloc(strlen(oid) + 1);
		CheckDbvAlloc(psElectronicDelivery->psDeliveryParameter->pcDeliveryMode, env);
		memcpy(psElectronicDelivery->psDeliveryParameter->pcDeliveryMode, oid, strlen(oid));
	}


	/* o */
	if (data_ptr->e_delivery_parameters.value != NULL) {

		/* If psDeliveryParameter not allocated for pcDeliveryMode above */
		if (psElectronicDelivery->psDeliveryParameter == NULL) {
			psElectronicDelivery->psDeliveryParameter = (DbvElDeliveryParameter *) DbvAlloc(sizeof (DbvElDeliveryParameter));
			CheckDbvAlloc(psElectronicDelivery->psDeliveryParameter, env);
		}
		
		/* union */
		psElectronicDelivery->psDeliveryParameter->puDeliveryParameter = (union uDeliveryParameter *) DbvAlloc (sizeof(union uDeliveryParameter));
		CheckDbvAlloc(psElectronicDelivery->psDeliveryParameter->puDeliveryParameter, env);

		/* union member */
		psElectronicDelivery->psDeliveryParameter->puDeliveryParameter->psDummy = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
		CheckDbvAlloc(psElectronicDelivery->psDeliveryParameter->puDeliveryParameter->psDummy, env);

		/* If the ANY was decoded then e_delivery_mode specifed the
		   decoding. Only the ANY comes across in the BER, hence
		   we have no way of knowing what the service user put in
		   his DbvASN1External ObjectIdentifier at the origin end. 
		   In the ASN.1, e-delivery-parameters is an ANY, not
		   an EXTERNAL. 
		*/

		/* Set up the oid of the DbvASN1External to be that used
		   for decoding - what else can it be set to ? */


		/* Clear the oid to be used for external mapping */
		memset(direct_reference, 0, sizeof (direct_reference));

		if (oid) {
			DBVsetup_dbv_externaloid(psElectronicDelivery->psDeliveryParameter->puDeliveryParameter->psDummy, oid, env);
			strcpy(direct_reference, oid);
		}

		DBVsnacc_to_dbv_anytype(direct_reference, psElectronicDelivery->psDeliveryParameter->puDeliveryParameter->psDummy, &data_ptr->e_delivery_parameters, env);
	}



	/* o */
	if (data_ptr->document_type_id.octetLen != 0) {

		psElectronicDelivery->psDocumentTypeParameter = (DbvDocumentTypeParameter *) DbvAlloc(sizeof (DbvDocumentTypeParameter));
		CheckDbvAlloc(psElectronicDelivery->psDocumentTypeParameter, env);

		oid = (char *) ASN_EncodedToString(&(data_ptr->document_type_id));
		psElectronicDelivery->psDocumentTypeParameter->pcDocumentTypeId = (DbvObjectIdentifier) DbvAlloc(strlen(oid) + 1);
		CheckDbvAlloc(psElectronicDelivery->psDocumentTypeParameter->pcDocumentTypeId, env);
		memcpy(psElectronicDelivery->psDocumentTypeParameter->pcDocumentTypeId, oid, strlen(oid));
	}


	/* o */
	if (data_ptr->document_type_parameters.value != NULL) {

		/* If psDocumentTypeParameter not allocated for pcDocumentTypeId above */
		if (psElectronicDelivery->psDocumentTypeParameter == NULL) {
			psElectronicDelivery->psDocumentTypeParameter = (DbvDocumentTypeParameter *) DbvAlloc(sizeof (DbvDocumentTypeParameter));
			CheckDbvAlloc(psElectronicDelivery->psDocumentTypeParameter, env);
		}

		/* union */
		psElectronicDelivery->psDocumentTypeParameter->puDocumentTypeParameter = (union uDocumentTypeParameter *) DbvAlloc (sizeof(union uDocumentTypeParameter));
		CheckDbvAlloc(psElectronicDelivery->psDocumentTypeParameter->puDocumentTypeParameter, env);

		/* union member */
		psElectronicDelivery->psDocumentTypeParameter->puDocumentTypeParameter->psDummy = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
		CheckDbvAlloc(psElectronicDelivery->psDocumentTypeParameter->puDocumentTypeParameter->psDummy, env);

		/* If the ANY was decoded then document_type_id specifed the
		   decoding. Only the ANY comes across in the BER, hence
		   we have no way of knowing what the service user put in
		   his DbvASN1External ObjectIdentifier at the origin end. 
		   In the ASN.1, e-delivery-parameters is an ANY, not
		   an EXTERNAL. 
		*/

		/* Clear the oid to be used for external mapping */
		memset(direct_reference, 0, sizeof (direct_reference));

		/* Set up the oid of the DbvASN1External to be that used
		   for decoding - what else can it be set to ? */

		if (oid) {
			DBVsetup_dbv_externaloid(psElectronicDelivery->psDocumentTypeParameter->puDocumentTypeParameter->psDummy, oid, env);
			strcpy(direct_reference, oid);
		}

		DBVsnacc_to_dbv_anytype(direct_reference, psElectronicDelivery->psDocumentTypeParameter->puDocumentTypeParameter->psDummy, &data_ptr->document_type_parameters, env);
	}


	/* END OF THE DIRTIES */	

	/* opt */
	if (data_ptr->e_delivery_description != NULL) {
		psElectronicDelivery->psDeliveryDescription = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psElectronicDelivery->psDeliveryDescription, env);
		DBVsnacc_to_dbv_illstring(psElectronicDelivery->psDeliveryDescription, data_ptr->e_delivery_description, env);
	}


	/* comp */
	DBVsnacc_to_dbv_delivdetails(&psElectronicDelivery->sDeliveryDetails, data_ptr->e_delivery_details, env);

	/* opt */
	if (data_ptr->name_or_code != NULL) {
		psElectronicDelivery->psNameOrCode = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psElectronicDelivery->psNameOrCode, env);
		DBVsnacc_to_dbv_illstring(psElectronicDelivery->psNameOrCode, data_ptr->name_or_code, env);
	}


	/* opt */


	if (data_ptr->delivery_time.octetLen != 0) 
		DBVsnacc_to_dbv_vis_string(&psElectronicDelivery->pcDeliveryTime, &data_ptr->delivery_time, env); 


	
}



int DBVsnacc_to_dbv_delivdetails(DbvElDeliveryDetails *psDeliveryDetails, struct Electronic_Delivery_ServiceChoice* e_delivery_details, jmp_buf env)
{
	switch (e_delivery_details->choiceId) {
	case ELECTRONIC_DELIVERY_SERVICECHOICE_E_DELIVERY_ADDRESS:
		psDeliveryDetails->eDeliveryDetailsType = DDT_SystemAddress;
		psDeliveryDetails->uDeliveryDetails.psSystemAddress = (DbvSystemAddress *) DbvAlloc (sizeof (DbvSystemAddress));

		DBVsnacc_to_dbv_electaddr(psDeliveryDetails->uDeliveryDetails.psSystemAddress, e_delivery_details->a.e_delivery_address, env);

		
		break;
	case ELECTRONIC_DELIVERY_SERVICECHOICE_E_DELIVERY_ID:
		psDeliveryDetails->eDeliveryDetailsType = DDT_SystemId;
		psDeliveryDetails->uDeliveryDetails.psSystemId = (DbvSystemId *) DbvAlloc (sizeof (DbvSystemId));
		DBVsnacc_to_dbv_systemid(psDeliveryDetails->uDeliveryDetails.psSystemId, e_delivery_details->a.e_delivery_id, env);

		break;
	}
}



int DBVsnacc_to_dbv_servtypelist(DbvServiceType **ppeServiceType, ILL_RequestSetOf *iLL_service_type, jmp_buf env)
{
	ILL_Service_Type *data_ptr;
	int index = 0;

        FOR_EACH_LIST_ELMT(data_ptr, iLL_service_type) {
                ppeServiceType[index] = (DbvServiceType *) DbvAlloc(sizeof(DbvServiceType));
                CheckDbvAlloc(ppeServiceType[index], env);
		DBVsnacc_to_dbv_servtype(ppeServiceType[index], data_ptr, env);
                index++;
        }
        ppeServiceType[index] = NULL;
}



int DBVsnacc_to_dbv_servtype(DbvServiceType *peServiceType, ILL_Service_Type *data_ptr, jmp_buf env)
{
	switch (*data_ptr) {
	case LOAN:
		*peServiceType = ST_Loan;
		break;
	case COPY_NON_RETURNABLE:
		*peServiceType = ST_CopyNonReturnable;
		break;
	case LOCATIONS:
		*peServiceType = ST_Locations;
		break;
	case ESTIMATE:
		*peServiceType = ST_Estimate;
		break;
	case RESPONDER_SPECIFIC3:
		*peServiceType = ST_ResponderSpecific;
		break;
	default:
		*peServiceType = ST_Invalid;
		break;
	}
	
}



int DBVsnacc_to_dbv_requestopt(DbvRequesterOptionalMessages *psRequesterOptionalMessages, struct Requester_Optional_Messages_Type* requester_optional_messages, jmp_buf env)
{
	/* comp */
	DBVsnacc_to_dbv_DbvBool(&psRequesterOptionalMessages->fCanSendReceived, &requester_optional_messages->can_send_RECEIVED, env);

	/* comp */
	DBVsnacc_to_dbv_DbvBool(&psRequesterOptionalMessages->fCanSendReturned, &requester_optional_messages->can_send_RETURNED, env);

	/* comp */
	DBVsnacc_to_dbv_optmsgreq(&psRequesterOptionalMessages->eRequesterShipped, &requester_optional_messages->requester_SHIPPED, env);

	/* comp */
	DBVsnacc_to_dbv_optmsgreq(&psRequesterOptionalMessages->eRequesterCheckedIn, &requester_optional_messages->requester_CHECKED_IN, env);
}



int DBVsnacc_to_dbv_optmsgreq(DbvOptionalMsgRequirements *peRequesterShipped, Requester_Optional_Messages_TypeEnum *requester_SHIPPED, jmp_buf env)
{
	switch (*requester_SHIPPED) {
	case REQUIRES3:
		*peRequesterShipped = OMR_Requires;
		break;
	case DESIRES3:
		*peRequesterShipped = OMR_Desires;
		break;
	case NEITHER3:
		*peRequesterShipped = OMR_Neither;
		break;
	default:
		*peRequesterShipped = OMR_Invalid;
	}
}



int DBVsnacc_to_dbv_searchtype(DbvSearchType *psSearchType, struct Search_Type* search_type, jmp_buf env)
{
	/* opt */
	if (search_type->level_of_service != NULL) {
		psSearchType->psLevelOfService = (DbvIllString *) DbvAlloc (sizeof (DbvIllString)); 
		CheckDbvAlloc(psSearchType->psLevelOfService, env);
		DBVsnacc_to_dbv_illstring(psSearchType->psLevelOfService, search_type->level_of_service, env);
	}


	/* opt */
	if (search_type->need_before_date.octetLen != 0) 

		/* DBVsnacc_to_dbv_vis_string() allocs space for the visible
		   string */
		DBVsnacc_to_dbv_vis_string(&psSearchType->pcNeedBeforeDate, &search_type->need_before_date, env); 


	/* default so optional */
	if (search_type->expiry_flag) {
		psSearchType->peExpiryFlag = (DbvExpiry *) DbvAlloc (sizeof (DbvExpiry));
		CheckDbvAlloc(psSearchType->peExpiryFlag, env);
		DBVsnacc_to_dbv_expflag(psSearchType->peExpiryFlag, search_type->expiry_flag, env); 
	}


	/* opt */
	if (search_type->expiry_date.octetLen != 0) 
		DBVsnacc_to_dbv_vis_string(&psSearchType->pcExpiryDate, &search_type->expiry_date, env); 

}



int DBVsnacc_to_dbv_expflag(DbvExpiry *peExpiryFlag, Search_TypeEnum *expiry_flag, jmp_buf env) 
{
	switch (*expiry_flag) {
	case NEED_BEFORE_DATE:
		*peExpiryFlag = EXP_NeedBeforeDate;
		break;
	case OTHER_DATE:
		*peExpiryFlag = EXP_OtherDate;
		break;
	case NO_EXPIRY:
		*peExpiryFlag = EXP_NoExpiry;
		break;
	default:
		*peExpiryFlag = EXP_Invalid;
		break;
	}
}



int DBVsnacc_to_dbv_suppmedinfolist(DbvSupplyMediumInfo **ppsSupplyMediumInfo, ILL_RequestSetOf1 *supply_medium_info_type, jmp_buf env)
{
	Supply_Medium_Info_Type *data_ptr;
	int index = 0;

        FOR_EACH_LIST_ELMT(data_ptr, supply_medium_info_type) {
                ppsSupplyMediumInfo[index] = (DbvSupplyMediumInfo *) DbvAlloc(sizeof(DbvSupplyMediumInfo));
                CheckDbvAlloc(ppsSupplyMediumInfo[index], env);
		DBVsnacc_to_dbv_suppmedinfo(ppsSupplyMediumInfo[index], data_ptr, env);
                index++;
        }
        ppsSupplyMediumInfo[index] = NULL;
}


int DBVsnacc_to_dbv_suppmedinfo(DbvSupplyMediumInfo *psSupplyMediumInfo, Supply_Medium_Info_Type *data_ptr, jmp_buf env)
{
	/* comp */
	DBVsnacc_to_dbv_suppmedtype(&psSupplyMediumInfo->eSupplyMediumType, &data_ptr->supply_medium_type, env);

	/* opt */
	if (data_ptr->medium_characteristics != NULL) {
		psSupplyMediumInfo->psMediumCharacteristics = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psSupplyMediumInfo->psMediumCharacteristics, env);
		DBVsnacc_to_dbv_illstring(psSupplyMediumInfo->psMediumCharacteristics, data_ptr->medium_characteristics, env);
	}
}



int DBVsnacc_to_dbv_suppmedtype(DbvSupplyMediumType *peSupplyMediumType, Supply_Medium_Type *supply_medium_type, jmp_buf env)
{
	switch (*supply_medium_type) {
	case PRINTED1:
		*peSupplyMediumType = SMT_Printed;
		break;
	case PHOTOCOPY:
		*peSupplyMediumType = SMT_Photocopy;
		break;
	case MICROFORM1:
		*peSupplyMediumType = SMT_Microform;
		break;
	case FILM_OR_VIDEO_RECORDING1:
		*peSupplyMediumType = SMT_FilmOrVideoRecording;
		break;
	case AUDIO_RECORDING1:
		*peSupplyMediumType = SMT_AudioRecording;
		break;
	case MACHINE_READABLE1:
		*peSupplyMediumType = SMT_MachineReadable;
		break;
	case OTHER11:
		*peSupplyMediumType = SMT_Other;
		break;
	default:
		*peSupplyMediumType = SMT_Invalid;
		break;
	}
}



int DBVsnacc_to_dbv_placehold(DbvPlaceOnHold *pePlaceOnHold, Place_On_Hold_Type *place_on_hold, jmp_buf env)
{
	switch (*place_on_hold) {
	case YES:
		*pePlaceOnHold = POH_Yes;
		break;
	case NO:
		*pePlaceOnHold = POH_No;
		break;
	case ACCORDING_TO_RESPONDER_POLICY:
		*pePlaceOnHold = POH_ResponderPolicy;
		break;
	default:
		*pePlaceOnHold = POH_Invalid;
		break;
	}
}


int DBVsnacc_to_dbv_clientid(DbvClientId *psClientId, struct Client_Id* client_id, jmp_buf env)
{
	/* all optionals */
	if (client_id->client_name != NULL) {
		psClientId->psClientName = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psClientId->psClientName, env);
		DBVsnacc_to_dbv_illstring(psClientId->psClientName, client_id->client_name, env);
	}


	if (client_id->client_status != NULL) {
		psClientId->psClientStatus = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psClientId->psClientStatus, env);
		DBVsnacc_to_dbv_illstring(psClientId->psClientStatus, client_id->client_status, env);
	}


	if (client_id->client_identifier != NULL) {
		psClientId->psClientIdentifier = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psClientId->psClientIdentifier, env);
		DBVsnacc_to_dbv_illstring(psClientId->psClientIdentifier, client_id->client_identifier, env);
	}
}


int DBVsnacc_to_dbv_itemid(DbvItemId *psItemId, struct Item_Id* item_id, jmp_buf env)
{
	/* opt */
	if (item_id->item_type != NULL) {
		psItemId->peItemType = (DbvItemType *) DbvAlloc (sizeof (DbvItemType));
		CheckDbvAlloc(psItemId->peItemType, env);
		DBVsnacc_to_dbv_itemtype(psItemId->peItemType, item_id->item_type, env);
	}

	if (item_id->held_medium_type != NULL) {
		psItemId->peMediumType = (DbvMediumType *) DbvAlloc (sizeof (DbvMediumType));
		CheckDbvAlloc(psItemId->peMediumType, env);
		DBVsnacc_to_dbv_medtype(psItemId->peMediumType, item_id->held_medium_type, env);
	}

	/* All remaining dudes optional */
	if (item_id->call_number != NULL) {
		psItemId->psCallNumber = (DbvIllString *) DbvAlloc(sizeof (DbvIllString));
		CheckDbvAlloc(psItemId->psCallNumber, env);
		DBVsnacc_to_dbv_illstring(psItemId->psCallNumber, item_id->call_number, env);
	}

	if (item_id->author != NULL) {
		psItemId->psAuthor = (DbvIllString *) DbvAlloc(sizeof (DbvIllString));
		CheckDbvAlloc(psItemId->psAuthor, env);
		DBVsnacc_to_dbv_illstring(psItemId->psAuthor, item_id->author, env);
	}

	if (item_id->title != NULL) {
		psItemId->psTitle = (DbvIllString *) DbvAlloc(sizeof (DbvIllString));
		CheckDbvAlloc(psItemId->psTitle, env);
		DBVsnacc_to_dbv_illstring(psItemId->psTitle, item_id->title, env);
	}

	if (item_id->sub_title != NULL) {
		psItemId->psSubTitle = (DbvIllString *) DbvAlloc(sizeof (DbvIllString));
		CheckDbvAlloc(psItemId->psSubTitle, env);
		DBVsnacc_to_dbv_illstring(psItemId->psSubTitle, item_id->sub_title, env);
	}

	if (item_id->sponsoring_body != NULL) {
		psItemId->psSponsoringBody = (DbvIllString *) DbvAlloc(sizeof (DbvIllString));
		CheckDbvAlloc(psItemId->psSponsoringBody, env);
		DBVsnacc_to_dbv_illstring(psItemId->psSponsoringBody, item_id->sponsoring_body, env);
	}

	if (item_id->place_of_publication != NULL) {
		psItemId->psPlaceOfPublication = (DbvIllString *) DbvAlloc(sizeof (DbvIllString));
		CheckDbvAlloc(psItemId->psPlaceOfPublication, env);
		DBVsnacc_to_dbv_illstring(psItemId->psPlaceOfPublication, item_id->place_of_publication, env);
	}

	if (item_id->publisher != NULL) {
		psItemId->psPublisher = (DbvIllString *) DbvAlloc(sizeof (DbvIllString));
		CheckDbvAlloc(psItemId->psPublisher, env);
		DBVsnacc_to_dbv_illstring(psItemId->psPublisher, item_id->publisher, env);
	}

	if (item_id->series_title_number != NULL) {
		psItemId->psSeriesTitleNumber = (DbvIllString *) DbvAlloc(sizeof (DbvIllString));
		CheckDbvAlloc(psItemId->psSeriesTitleNumber, env);
		DBVsnacc_to_dbv_illstring(psItemId->psSeriesTitleNumber, item_id->series_title_number, env);
	}

	if (item_id->volume_issue != NULL) {
		psItemId->psVolumeIssue = (DbvIllString *) DbvAlloc(sizeof (DbvIllString));
		CheckDbvAlloc(psItemId->psVolumeIssue, env);
		DBVsnacc_to_dbv_illstring(psItemId->psVolumeIssue, item_id->volume_issue, env);
	}

	if (item_id->edition != NULL) {
		psItemId->psEdition = (DbvIllString *) DbvAlloc(sizeof (DbvIllString));
		CheckDbvAlloc(psItemId->psEdition, env);
		DBVsnacc_to_dbv_illstring(psItemId->psEdition, item_id->edition, env);
	}

	if (item_id->publication_date != NULL) {
		psItemId->psPublicationDate = (DbvIllString *) DbvAlloc(sizeof (DbvIllString));
		CheckDbvAlloc(psItemId->psPublicationDate, env);
		DBVsnacc_to_dbv_illstring(psItemId->psPublicationDate, item_id->publication_date, env);
	}

	if (item_id->publication_date_of_component != NULL) {
		psItemId->psPublicationDateOfComponent = (DbvIllString *) DbvAlloc(sizeof (DbvIllString));
		CheckDbvAlloc(psItemId->psPublicationDateOfComponent, env);
		DBVsnacc_to_dbv_illstring(psItemId->psPublicationDateOfComponent, item_id->publication_date_of_component, env);
	}

	if (item_id->author_of_article != NULL) {
		psItemId->psAuthorOfArticle = (DbvIllString *) DbvAlloc(sizeof (DbvIllString));
		CheckDbvAlloc(psItemId->psAuthorOfArticle, env);
		DBVsnacc_to_dbv_illstring(psItemId->psAuthorOfArticle, item_id->author_of_article, env);
	}


	if (item_id->title_of_article != NULL) {
		psItemId->psTitleOfArticle = (DbvIllString *) DbvAlloc(sizeof (DbvIllString));
		CheckDbvAlloc(psItemId->psTitleOfArticle, env);
		DBVsnacc_to_dbv_illstring(psItemId->psTitleOfArticle, item_id->title_of_article, env);
	}


	if (item_id->pagination != NULL) {
		psItemId->psPagination = (DbvIllString *) DbvAlloc(sizeof (DbvIllString));
		CheckDbvAlloc(psItemId->psPagination, env);
		DBVsnacc_to_dbv_illstring(psItemId->psPagination, item_id->pagination, env);
	}


	if (item_id->national_bibliography_no != NULL) {
		psItemId->psNationalBibliographyNo = (DbvASN1External *) DbvAlloc(sizeof (DbvASN1External));
		CheckDbvAlloc(psItemId->psNationalBibliographyNo, env);
		DBVsnacc_to_dbv_external(psItemId->psNationalBibliographyNo, item_id->national_bibliography_no, env);
	}


	if (item_id->iSBN != NULL) {
		psItemId->psIsbn = (DbvIllString *) DbvAlloc(sizeof (DbvIllString));
		CheckDbvAlloc(psItemId->psIsbn, env);
		DBVsnacc_to_dbv_illstring(psItemId->psIsbn, item_id->iSBN, env);
	}


	if (item_id->iSSN != NULL) {
		psItemId->psIssn = (DbvIllString *) DbvAlloc(sizeof (DbvIllString));
		CheckDbvAlloc(psItemId->psIssn, env);
		DBVsnacc_to_dbv_illstring(psItemId->psIssn, item_id->iSSN, env);
	}


	
	if (item_id->system_no != NULL) {
		psItemId->psSystemNo = (DbvASN1External *) DbvAlloc(sizeof (DbvASN1External));
		CheckDbvAlloc(psItemId->psSystemNo, env);
		DBVsnacc_to_dbv_external(psItemId->psSystemNo, item_id->system_no, env);
	}


	
	if (item_id->additional_no_letters != NULL) {
		psItemId->psAdditionalNoLetters = (DbvIllString *) DbvAlloc(sizeof (DbvIllString));
		CheckDbvAlloc(psItemId->psAdditionalNoLetters, env);
		DBVsnacc_to_dbv_illstring(psItemId->psAdditionalNoLetters, item_id->additional_no_letters, env);
	}


	
	if (item_id->verification_reference_source != NULL) {
		psItemId->psVerificationReferenceSource = (DbvIllString *) DbvAlloc(sizeof (DbvIllString));
		CheckDbvAlloc(psItemId->psVerificationReferenceSource, env);
		DBVsnacc_to_dbv_illstring(psItemId->psVerificationReferenceSource, item_id->verification_reference_source, env);
	}
}



int DBVsnacc_to_dbv_itemtype(DbvItemType *peItemType, Item_IdEnum *item_type, jmp_buf env)
{
	switch (*item_type) {
	case MONOGRAPH:
		*peItemType = IT_Monograph;
		break;
	case SERIAL:
		*peItemType = IT_Serial;
		break;
	case OTHER4:
		*peItemType = IT_Other;
		break;
	default:
		*peItemType = IT_Invalid;
		break;
	}
}



int DBVsnacc_to_dbv_medtype(DbvMediumType *peMediumType, Medium_Type *held_medium_type, jmp_buf env)
{
	switch (*held_medium_type) {
	case PRINTED:
		*peMediumType = MT_Printed;
		break;
	case MICROFORM:
		*peMediumType = MT_Microform;
		break;
	case FILM_OR_VIDEO_RECORDING:
		*peMediumType = MT_FilmOrVideoRecording;
		break;
	case AUDIO_RECORDING:
		*peMediumType = MT_AudioRecording;
		break;
	case MACHINE_READABLE:
		*peMediumType = MT_MachineReadable;
		break;
	case OTHER7:
		*peMediumType = MT_Other;
		break;
	default:
		*peMediumType = MT_Invalid;
		break;
	}
}



int DBVsnacc_to_dbv_suppitemlist(DbvASN1External **ppsSupplementalItemDescription, Supplemental_Item_Description *supplemental_item_description, jmp_buf env)
{
	NEWEXTERNAL *data_ptr;
	int index = 0;

        FOR_EACH_LIST_ELMT(data_ptr, supplemental_item_description) {
                ppsSupplementalItemDescription[index] = (DbvASN1External *) DbvAlloc(sizeof(DbvASN1External));
                CheckDbvAlloc(ppsSupplementalItemDescription[index], env);
		DBVsnacc_to_dbv_external(ppsSupplementalItemDescription[index], data_ptr, env);
                index++;
        }
        ppsSupplementalItemDescription[index] = NULL;
}



int DBVsnacc_to_dbv_costinfo(DbvCostInfo *psCostInfo, struct Cost_Info_Type* cost_info_type, jmp_buf env)
{
	/* opt */
	if (cost_info_type->account_number != NULL) {
		psCostInfo->psAccountNumber = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psCostInfo->psAccountNumber, env);
		DBVsnacc_to_dbv_illstring(psCostInfo->psAccountNumber, cost_info_type->account_number, env);
	}
		

	/* opt */
	if (cost_info_type->maximum_cost != NULL) {
		psCostInfo->psMaximumCost = (DbvAmount *) DbvAlloc (sizeof(DbvAmount));
		CheckDbvAlloc(psCostInfo->psMaximumCost, env);		
		DBVsnacc_to_dbv_maxcost(psCostInfo->psMaximumCost, cost_info_type->maximum_cost, env);
	}


	/* Three default (so optional) bools */
	if (cost_info_type->reciprocal_agreement) {
		psCostInfo->pfReciprocalAgreement = (DbvBool *) DbvAlloc (sizeof (DbvBool));
		CheckDbvAlloc(psCostInfo->pfReciprocalAgreement, env);		
		DBVsnacc_to_dbv_DbvBool(psCostInfo->pfReciprocalAgreement, cost_info_type->reciprocal_agreement, env);
	}


	if (cost_info_type->will_pay_fee) {
		psCostInfo->pfWillPayFee = (DbvBool *) DbvAlloc (sizeof (DbvBool));
		CheckDbvAlloc(psCostInfo->pfWillPayFee, env);		
		DBVsnacc_to_dbv_DbvBool(psCostInfo->pfWillPayFee, cost_info_type->will_pay_fee, env);
	}


	if (cost_info_type->payment_provided) {
		psCostInfo->pfPaymentProvided = (DbvBool *) DbvAlloc (sizeof (DbvBool));
		CheckDbvAlloc(psCostInfo->pfPaymentProvided, env);		
		DBVsnacc_to_dbv_DbvBool(psCostInfo->pfPaymentProvided, cost_info_type->payment_provided, env);
	}


}



int DBVsnacc_to_dbv_maxcost(DbvAmount *psMaximumCost, struct Amount* maximum_cost, jmp_buf env)
{
	/* optional */
	if (maximum_cost->currency_code.octetLen != 0) 
		DBVsnacc_to_dbv_vis_string(&psMaximumCost->pcCurrencyCode, &maximum_cost->currency_code, env);

	/* compulsory */
	DBVsnacc_to_dbv_vis_string(&psMaximumCost->pcMonetaryValue, &maximum_cost->monetary_value, env);
	
	
}


int DBVsnacc_to_dbv_thirdparty(DbvThirdPartyInfo *psThirdPartyInfo, struct Third_Party_Info_Type* third_party_info_type, jmp_buf env)
{
	/* Variables used for extracting from AsnList */
	int num_elements, index;

	/* 4 default so optional bools */
	if (third_party_info_type->permission_to_forward) {
		psThirdPartyInfo->pfPermissionToForward = (DbvBool *) DbvAlloc (sizeof (DbvBool));
		CheckDbvAlloc(psThirdPartyInfo->pfPermissionToForward, env);
		DBVsnacc_to_dbv_DbvBool(psThirdPartyInfo->pfPermissionToForward, third_party_info_type->permission_to_forward, env);
	}


	
	if (third_party_info_type->permission_to_chain) {
		psThirdPartyInfo->pfPermissionToChain = (DbvBool *) DbvAlloc (sizeof (DbvBool));
		CheckDbvAlloc(psThirdPartyInfo->pfPermissionToChain, env);
		DBVsnacc_to_dbv_DbvBool(psThirdPartyInfo->pfPermissionToChain, third_party_info_type->permission_to_chain, env);
	}


	
	if (third_party_info_type->permission_to_partition) {
		psThirdPartyInfo->pfPermissionToPartition = (DbvBool *) DbvAlloc (sizeof (DbvBool));
		CheckDbvAlloc(psThirdPartyInfo->pfPermissionToPartition, env);
		DBVsnacc_to_dbv_DbvBool(psThirdPartyInfo->pfPermissionToPartition, third_party_info_type->permission_to_partition, env);
	}


	
	if (third_party_info_type->permission_to_change_send_to_list) {
		psThirdPartyInfo->pfPermissionToChangeSendToList = (DbvBool *) DbvAlloc (sizeof (DbvBool));
		CheckDbvAlloc(psThirdPartyInfo->pfPermissionToChangeSendToList, env);
		DBVsnacc_to_dbv_DbvBool(psThirdPartyInfo->pfPermissionToChangeSendToList, third_party_info_type->permission_to_change_send_to_list, env);
	}


	
	/* opt */
	if (third_party_info_type->initial_requester_address != NULL) {
		psThirdPartyInfo->psInitialRequesterAddress = (DbvSystemAddress *) DbvAlloc (sizeof (DbvSystemAddress));
		CheckDbvAlloc(psThirdPartyInfo->psInitialRequesterAddress, env);
		DBVsnacc_to_dbv_electaddr(psThirdPartyInfo->psInitialRequesterAddress, third_party_info_type->initial_requester_address, env);
	}


	/* default so optional */
	if (third_party_info_type->preference) {
		psThirdPartyInfo->pePreference = (DbvPreference *) DbvAlloc (sizeof (DbvPreference));
		CheckDbvAlloc(psThirdPartyInfo->pePreference, env);
		DBVsnacc_to_dbv_preference(psThirdPartyInfo->pePreference, third_party_info_type->preference, env);
	}


	/* opt */
	if (third_party_info_type->send_to_list != NULL) {
		num_elements = 0;
        	index = 0;
        	num_elements = AsnListCount(third_party_info_type->send_to_list);
		psThirdPartyInfo->ppsSendToList = (DbvSendToList **) DbvAlloc (sizeof (DbvSendToList *) * (num_elements + 1));
		CheckDbvAlloc(psThirdPartyInfo->ppsSendToList, env);
		DBVsnacc_to_dbv_sendtolistlist(psThirdPartyInfo->ppsSendToList, third_party_info_type->send_to_list, env);
	}

	/* opt */
	if (third_party_info_type->already_tried_list != NULL) {
		num_elements = 0;
        	index = 0;
        	num_elements = AsnListCount(third_party_info_type->already_tried_list);
		psThirdPartyInfo->ppsAlreadyTriedList = (DbvSystemId **) DbvAlloc (sizeof (DbvSystemId *) * (num_elements + 1));
		CheckDbvAlloc(psThirdPartyInfo->ppsAlreadyTriedList, env);
		DBVsnacc_to_dbv_systemidlist(psThirdPartyInfo->ppsAlreadyTriedList, third_party_info_type->already_tried_list, env);
	}

}

int DBVsnacc_to_dbv_preference(DbvPreference *pePreference, Third_Party_Info_TypeEnum *preference, jmp_buf env)
{
	switch (*preference) {
	case ORDERED:
		*pePreference = PRE_Ordered;
		break;
	case UNORDERED:
		*pePreference = PRE_Unordered;
		break;
	default:
		*pePreference = PRE_Invalid;
		break;
		
	}
	
}



int DBVsnacc_to_dbv_sendtolistlist(DbvSendToList **ppsSendToList, Send_To_List_Type *send_to_list, jmp_buf env)
{
	Send_To_List_TypeSeq *data_ptr;
	int index = 0;

        FOR_EACH_LIST_ELMT(data_ptr, send_to_list) {
                ppsSendToList[index] = (DbvSendToList *) DbvAlloc(sizeof(DbvSendToList));
                CheckDbvAlloc(ppsSendToList[index], env);
		DBVsnacc_to_dbv_sendtolist(ppsSendToList[index], data_ptr, env);
                index++;
        }
        ppsSendToList[index] = NULL;
}



int DBVsnacc_to_dbv_sendtolist(DbvSendToList *psSendToList, Send_To_List_TypeSeq *data_ptr, jmp_buf env)
{
	/* comp */
	DBVsnacc_to_dbv_systemid(&psSendToList->sSystemId, data_ptr->system_id, env);
	
	
	/* opt */
	if (data_ptr->account_number != NULL) {
		psSendToList->psAccountNumber = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psSendToList->psAccountNumber, env);
		DBVsnacc_to_dbv_illstring(psSendToList->psAccountNumber, data_ptr->account_number, env);
	}

	/* opt */
	if (data_ptr->system_address != NULL) {
		psSendToList->psSystemAddress = (DbvSystemAddress *) DbvAlloc (sizeof (DbvSystemAddress));
		CheckDbvAlloc(psSendToList->psSystemAddress, env);
		DBVsnacc_to_dbv_electaddr(psSendToList->psSystemAddress, data_ptr->system_address, env);
	}
}



int DBVsnacc_to_dbv_systemidlist(DbvSystemId **ppsAlreadyTriedList, Already_Tried_List_Type *already_tried_list, jmp_buf env)
{
	System_Id *data_ptr;
	int index = 0;

        FOR_EACH_LIST_ELMT(data_ptr, already_tried_list) {
                ppsAlreadyTriedList[index] = (DbvSystemId *) DbvAlloc(sizeof(DbvSystemId));
                CheckDbvAlloc(ppsAlreadyTriedList[index], env);
		DBVsnacc_to_dbv_systemid(ppsAlreadyTriedList[index], data_ptr, env);
                index++;
        }
        ppsAlreadyTriedList[index] = NULL;
}


int DBVsnacc_to_dbv_extensionlist(DbvExtension **ppsRequestExtension, ILL_RequestSeqOf *iLL_request_extensions, jmp_buf env)
{
	Extension *data_ptr;
	int index = 0;

        FOR_EACH_LIST_ELMT(data_ptr, iLL_request_extensions) {
                ppsRequestExtension[index] = (DbvExtension *) DbvAlloc(sizeof(DbvExtension));
                CheckDbvAlloc(ppsRequestExtension[index], env);
		DBVsnacc_to_dbv_extension(ppsRequestExtension[index], data_ptr, env);
                index++;
        }
        ppsRequestExtension[index] = NULL;
}


int DBVsnacc_to_dbv_extension(DbvExtension *psRequestExtension, Extension *data_ptr, jmp_buf env)
{
	/* comp */
	psRequestExtension->ulIdentifier = data_ptr->identifier;

	/* default so optional */
	if (data_ptr->critical) {
		psRequestExtension->pfCritical = (DbvBool *) DbvAlloc (sizeof (DbvBool));
		CheckDbvAlloc(psRequestExtension->pfCritical, env);
	
		DBVsnacc_to_dbv_DbvBool(psRequestExtension->pfCritical, data_ptr->critical, env);
	}


	psRequestExtension->uItem.psAddIllReqInfo = (DbvSubitoAdditionalInfo *) DbvAlloc (sizeof (DbvSubitoAdditionalInfo));
	CheckDbvAlloc(psRequestExtension->uItem.psAddIllReqInfo, env);

	DBVsnacc_to_dbv_extension_item(&data_ptr->identifier, psRequestExtension, &data_ptr->item, env);


}


/****************************************************************/
/* The strange extension */


int DBVsnacc_to_dbv_extension_item(AsnInt *identifier, DbvExtension *psRequestExtension, AsnAnyDefinedBy *item, jmp_buf env)
{
	switch (*identifier) {

/***************************
  No longer used 
 
       case INTMAPTEST:
               DBVsnacc_to_dbv_anytype_int(&data_ptr->identifier, psRequestExtension->uItem.psAddIllReqInfo, &data_ptr->item, env);
               break;
 ***************************/

	case SUBITO_ADDITIONAL_INFO:
		DBVsnacc_to_dbv_subito(psRequestExtension->uItem.psAddIllReqInfo, item, env);
		break;
	}
}


/* Convert snacc external to dbv external */

/* Always map from a snacc any to a DBV-OSI II external */
int DBVsnacc_to_dbv_anytype_int(AsnInt *intval, DbvASN1External *dbv_external, AsnAnyDefinedBy *any_type, jmp_buf env)
{
        dbv_external->eValueType = EVT_SingleASN1Type;
        dbv_external->uExternalValue.psSingleASN1Type = (DbvSingleASN1Type *) DbvAlloc (sizeof (DbvSingleASN1Type));
        CheckDbvAlloc(dbv_external->uExternalValue.psSingleASN1Type, env);

/*****************
 No longer used

        if ((int) (*intval) == INTMAPTEST)
                DBVsnacc_to_dbv_silintmaptest_any(dbv_external->uExternalValue.psSingleASN1Type, any_type, env);
	else

*****************/

		/* any_type is prepared as hex in the snacc decoding functions 
		   if it is unknown */
		DBVsnacc_to_dbv_unknown_any(dbv_external->uExternalValue.psSingleASN1Type, any_type, env);
}



/* snacc -> dbv silintmaptest external */

int DBVsnacc_to_dbv_silintmaptest_any(DbvSingleASN1Type *psSingleASN1Type, AsnAnyDefinedBy *any_type, jmp_buf env)
{
        SilIntMapTest *silintmaptest_ptr;

        silintmaptest_ptr = (SilIntMapTest *) any_type->value;

/******************
 No longer used

        psSingleASN1Type->eASN1Type = AT_IntMapTest;
        psSingleASN1Type->uASN1.psIntMapTest = (struct DbvIntMapTest *) DbvAlloc (sizeof(struct DbvIntMapTest));
        CheckDbvAlloc(psSingleASN1Type->uASN1.psIntMapTest, env);

        ** snacc silintmaptest to dbv silintmaptest **
	switch (silintmaptest_ptr->choiceId) {
	case SILINTMAPTEST_THEABYSS:
		psSingleASN1Type->uASN1.psIntMapTest->eIntMapTestType = IMT_FirstString;
		psSingleASN1Type->uASN1.psIntMapTest->uIntMapTest.psFirstString = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
		CheckDbvAlloc(psSingleASN1Type->uASN1.psIntMapTest->uIntMapTest.psFirstString, env);
		DBVsnacc_to_dbv_inter_string(psSingleASN1Type->uASN1.psIntMapTest->uIntMapTest.psFirstString, silintmaptest_ptr->a.theabyss, env);
		break;
	case SILINTMAPTEST_LAUNCHFACILITY:
		psSingleASN1Type->uASN1.psIntMapTest->eIntMapTestType = IMT_SecondString;
		psSingleASN1Type->uASN1.psIntMapTest->uIntMapTest.psSecondString = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
		CheckDbvAlloc(psSingleASN1Type->uASN1.psIntMapTest->uIntMapTest.psSecondString, env);
		DBVsnacc_to_dbv_inter_string(psSingleASN1Type->uASN1.psIntMapTest->uIntMapTest.psSecondString, silintmaptest_ptr->a.launchfacility, env);
		break;
	}
******************/

}



int DBVsnacc_to_dbv_subito(DbvSubitoAdditionalInfo *psAddIllReqInfo, AsnAnyDefinedBy *item, jmp_buf env)
	
{
        SubitoAdditionalInfo *subito_ptr;

       	subito_ptr = (SubitoAdditionalInfo *) item->value;

	/* Dont need to set up related Dbv external cos there aint one !! */

        /* 
	psSingleASN1Type->eASN1Type = AT_IntMapTest;
        psSingleASN1Type->uASN1.psIntMapTest = (struct DbvIntMapTest *) DbvAlloc (sizeof(struct DbvIntMapTest));
        CheckDbvAlloc(psSingleASN1Type->uASN1.psIntMapTest, env);
	*/

	DBVsnacc_to_dbv_subito_main(psAddIllReqInfo, subito_ptr->a.johnfix, env);
}



int DBVsnacc_to_dbv_subito_main(DbvSubitoAdditionalInfo *psAddIllReqInfo, OrigSubitoAdditionalInfo *subito_ptr, jmp_buf env)
{
	/* default so optional */
	if (subito_ptr->customerInfoToKeep) {
		psAddIllReqInfo->pfCustomerInfoToKeep = (DbvBool *) Asn1Alloc (sizeof(DbvBool));
		CheckDbvAlloc(psAddIllReqInfo->pfCustomerInfoToKeep, env);
		DBVsnacc_to_dbv_DbvBool(psAddIllReqInfo->pfCustomerInfoToKeep, subito_ptr->customerInfoToKeep, env);
	}
	
	/* o */
	if (subito_ptr->addRequesterInfo) {
		psAddIllReqInfo->psAddRequesterInfo = (DbvAddRequesterInfo *) DbvAlloc (sizeof (DbvAddRequesterInfo));
		CheckDbvAlloc(psAddIllReqInfo->psAddRequesterInfo, env);
		DBVsnacc_to_dbv_addrequesterinfo(psAddIllReqInfo->psAddRequesterInfo, subito_ptr->addRequesterInfo, env);
	}

	/* o */
	if (subito_ptr->addDeliveryInfo) {
		psAddIllReqInfo->psAddDeliveryInfo = (DbvAddDeliveryInfo *) DbvAlloc (sizeof (DbvAddDeliveryInfo));
		CheckDbvAlloc(psAddIllReqInfo->psAddDeliveryInfo, env);
		DBVsnacc_to_dbv_adddeliveryinfo(psAddIllReqInfo->psAddDeliveryInfo, subito_ptr->addDeliveryInfo, env);
	}

	/* o */
	if (subito_ptr->addBillingInfo) {
		psAddIllReqInfo->psAddBillingInfo = (DbvAddBillingInfo *) DbvAlloc (sizeof (DbvAddBillingInfo));
		CheckDbvAlloc(psAddIllReqInfo->psAddBillingInfo, env);
		DBVsnacc_to_dbv_addbillinginfo(psAddIllReqInfo->psAddBillingInfo, subito_ptr->addBillingInfo, env);
	}

}



int DBVsnacc_to_dbv_addrequesterinfo(DbvAddRequesterInfo *psAddRequesterInfo, struct AddRequesterInfo* addRequesterInfo, jmp_buf env)
{
	/* default so optional */
	if (addRequesterInfo->requesterGroup) {
		psAddRequesterInfo->peRequesterGroup = (DbvRequesterGroup *) DbvAlloc (sizeof (DbvRequesterGroup));
		CheckDbvAlloc(psAddRequesterInfo->peRequesterGroup, env);
		DBVsnacc_to_dbv_requestergroup(psAddRequesterInfo->peRequesterGroup, addRequesterInfo->requesterGroup, env);
	}
	

	/* o */
	if (addRequesterInfo->requesterEmailAddress.octetLen != 0) {
		DBVsnacc_to_dbv_vis_string(&psAddRequesterInfo->pcRequesterEmailAddress, &addRequesterInfo->requesterEmailAddress, env);
	}
}



int DBVsnacc_to_dbv_requestergroup(DbvRequesterGroup *peRequesterGroup, AddRequesterInfoEnum *requesterGroup, jmp_buf env)
{
	switch (*requesterGroup) {
	case USERGROUP1:
		*peRequesterGroup = RG_UserGroup1;
		break;
	case USERGROUP2:
		*peRequesterGroup = RG_UserGroup2;
		break;
	default:
		*peRequesterGroup = RG_UserGroup1;
		break;

	}
}



int DBVsnacc_to_dbv_adddeliveryinfo(DbvAddDeliveryInfo *psAddDeliveryInfo, struct AddDeliveryInfo* addDeliveryInfo, jmp_buf env)
{
	/* default so optional */
	if (addDeliveryInfo->statusLevelUser) {
		psAddDeliveryInfo->peStatusLevelUser = (DbvStatusLevelUser *) DbvAlloc (sizeof (DbvStatusLevelUser));
		CheckDbvAlloc(psAddDeliveryInfo->peStatusLevelUser, env);
		DBVsnacc_to_dbv_statusleveluser(psAddDeliveryInfo->peStatusLevelUser, addDeliveryInfo->statusLevelUser, env);
	}
	
	/* default so optional */
	if (addDeliveryInfo->statusLevelRequester) {
		psAddDeliveryInfo->peStatusLevelOrigin = (DbvStatusLevelRequester *) DbvAlloc (sizeof (DbvStatusLevelRequester));
		CheckDbvAlloc(psAddDeliveryInfo->peStatusLevelOrigin, env);
		DBVsnacc_to_dbv_statuslevelrequester(psAddDeliveryInfo->peStatusLevelOrigin, addDeliveryInfo->statusLevelRequester, env);
	}

	/* o  - right, for some Visiblestring cases we must check octetLen. 
    	   For other
	   types (such as InternationalString name) we can check octs
	   or octetLen   */
	if (addDeliveryInfo->deliveryNotes.octetLen != 0) 
		DBVsnacc_to_dbv_vis_string(&psAddDeliveryInfo->pcDeliveryNotes, &addDeliveryInfo->deliveryNotes, env);


	/* o */
	if (addDeliveryInfo->countryDeliveryTarget.octetLen != 0) 
		DBVsnacc_to_dbv_vis_string(&psAddDeliveryInfo->pcCountryDeliveryTarget, &addDeliveryInfo->countryDeliveryTarget, env);


	/* default so optional */
	if (addDeliveryInfo->alternativePostalDelivery) {
		psAddDeliveryInfo->pfAlternativePostalDelivery = (DbvBool *) DbvAlloc (sizeof (DbvBool));
		CheckDbvAlloc(psAddDeliveryInfo->pfAlternativePostalDelivery, env);
		DBVsnacc_to_dbv_DbvBool(psAddDeliveryInfo->pfAlternativePostalDelivery, addDeliveryInfo->alternativePostalDelivery, env);
	}
	 
}


int DBVsnacc_to_dbv_statusleveluser(DbvStatusLevelUser *peStatusLevelUser, AddDeliveryInfoEnum *statusLevelUser, jmp_buf env)
{
	switch (*statusLevelUser) {
	case ALL1:
		*peStatusLevelUser = SLU_All;
		break;
	case NEGATIVE:
		*peStatusLevelUser = SLU_Negative;
		break;
	case NONE3:
		*peStatusLevelUser = SLU_None;
		break;
	default:
		*peStatusLevelUser = SLU_Negative;
		break;
	}

}


int DBVsnacc_to_dbv_statuslevelrequester(DbvStatusLevelRequester *peStatusLevelOrigin, AddDeliveryInfoEnum1 *statusLevelRequester, jmp_buf env)
{
	switch (*statusLevelRequester) {
	case ALL1:
		*peStatusLevelOrigin = SLO_All;
		break;
	case NEGATIVE:
		*peStatusLevelOrigin = SLO_Negative;
		break;
	case NONE3:
		*peStatusLevelOrigin = SLO_None;
		break;
	default:
		*peStatusLevelOrigin = SLO_None;
		break;
	}
}



int DBVsnacc_to_dbv_addbillinginfo(DbvAddBillingInfo *psAddBillingInfo, struct AddBillingInfo* addBillingInfo, jmp_buf env)
{
	switch (addBillingInfo->choiceId) {
	case ADDBILLINGINFO_BILLINGBANKINFO:
		psAddBillingInfo->eAddBillingType = ABT_BankInfo;
		psAddBillingInfo->uAddBillingInfo.psBillingBankInfo = (DbvBillingBankInfo *) DbvAlloc (sizeof (DbvBillingBankInfo));
		CheckDbvAlloc(psAddBillingInfo->uAddBillingInfo.psBillingBankInfo, env);
		DBVsnacc_to_dbv_billingbankinfo(psAddBillingInfo->uAddBillingInfo.psBillingBankInfo, addBillingInfo->a.billingBankInfo, env);
		break;

	case ADDBILLINGINFO_BILLINGCREDITCARDINFO:
		psAddBillingInfo->eAddBillingType = ABT_CreditCardInfo;
		psAddBillingInfo->uAddBillingInfo.psBillingCreditCardInfo = (DbvBillingCreditCardInfo *) DbvAlloc (sizeof (DbvBillingCreditCardInfo));
		CheckDbvAlloc(psAddBillingInfo->uAddBillingInfo.psBillingCreditCardInfo, env);
		DBVsnacc_to_dbv_billingcreditcardinfo(psAddBillingInfo->uAddBillingInfo.psBillingCreditCardInfo, addBillingInfo->a.billingCreditCardInfo, env);
		break;

	case ADDBILLINGINFO_BILLINGINVOICETYPE:
		psAddBillingInfo->eAddBillingType = ABT_InvoiceType;
		DBVsnacc_to_dbv_billinginvoicetype(&psAddBillingInfo->uAddBillingInfo.eBillingInvoiceType, &addBillingInfo->a.billingInvoiceType, env);
		break;

	case ADDBILLINGINFO_BILLINGPREPAIDID:
		psAddBillingInfo->eAddBillingType = ABT_PrepaidType;
		DBVsnacc_to_dbv_vis_string(&psAddBillingInfo->uAddBillingInfo.pcPrepaidId, addBillingInfo->a.billingPrepaidId, env);
		break;

	case ADDBILLINGINFO_BILLINGDEPOSITID:
		psAddBillingInfo->eAddBillingType = ABT_DepositType;
		DBVsnacc_to_dbv_vis_string(&psAddBillingInfo->uAddBillingInfo.pcDepositId, addBillingInfo->a.billingDepositId, env);
		break;



	}
}



int DBVsnacc_to_dbv_billingbankinfo(DbvBillingBankInfo *psBillingBankInfo, struct BillingBankInfo *billingBankInfo, jmp_buf env)
{
	/* c */
	DBVsnacc_to_dbv_vis_string(&psBillingBankInfo->pcBankAccountHouse, &billingBankInfo->bankAccountHouse, env);

	/* c */
	DBVsnacc_to_dbv_vis_string(&psBillingBankInfo->pcBankAccountRoutingSymbol, &billingBankInfo->bankAccountRoutingSymbol, env);

	/* c */
	DBVsnacc_to_dbv_vis_string(&psBillingBankInfo->pcBankAccountNo, &billingBankInfo->bankAccountNo, env);

	/* c */
	DBVsnacc_to_dbv_DbvBool(&psBillingBankInfo->fBankAuthority, &billingBankInfo->bankAuthority, env);
	
}



int DBVsnacc_to_dbv_billingcreditcardinfo(DbvBillingCreditCardInfo *psBillingCreditCardInfo, struct BillingCreditCardInfo* billingCreditCardInfo, jmp_buf env)
{
	/* c */
	DBVsnacc_to_dbv_vis_string(&psBillingCreditCardInfo->pcCardCompany, &billingCreditCardInfo->cardCompany, env);

	/* c */
	DBVsnacc_to_dbv_vis_string(&psBillingCreditCardInfo->pcCardNo, &billingCreditCardInfo->cardNo, env);
	

	/* ISO_Date are visible string */

	/* o */
	if (billingCreditCardInfo->cardValidFrom.octetLen != 0) 
		DBVsnacc_to_dbv_vis_string(&psBillingCreditCardInfo->pcCardValidFrom, &billingCreditCardInfo->cardValidFrom, env);

	/* c */
	DBVsnacc_to_dbv_vis_string(&psBillingCreditCardInfo->pcCardValidThru, &billingCreditCardInfo->cardValidThru, env);

}



int DBVsnacc_to_dbv_billinginvoicetype(DbvBillingInvoiceType *peBillingInvoiceType, AddBillingInfoEnum *billingInvoiceType, jmp_buf env)
{
	switch (*billingInvoiceType) {
	case SINGLE:
		*peBillingInvoiceType = BIT_Single;
		break;
	case COLLECTIVE:
		*peBillingInvoiceType = BIT_Collective;
		break;
	}
}











/* second part of ill */
int DBVsnacc_to_dbv_statorerr(struct DbvStatusOrErrorReport *psStatusOrErrorReport, struct Status_Or_Error_Report* status_Or_Error_Report, jmp_buf env)
{
	/* Variables used for extracting from AsnList */
	int num_elements, index;

	/* comp */
	DBVsnacc_to_dbv_prover(&psStatusOrErrorReport->eProtocolVersion, &status_Or_Error_Report->protocol_version_num, env);

	/* comp */
	DBVsnacc_to_dbv_transid(&psStatusOrErrorReport->sTransactionId, status_Or_Error_Report->transaction_id, env);
	
	/* comp */
	DBVsnacc_to_dbv_servdati(&psStatusOrErrorReport->sServiceDateTime, status_Or_Error_Report->service_date_time, env);

	/* opt */ 
	if (status_Or_Error_Report->requester_id != NULL) {
		psStatusOrErrorReport->psRequesterId = (DbvSystemId *) DbvAlloc (sizeof (DbvSystemId));
		CheckDbvAlloc(psStatusOrErrorReport->psRequesterId, env);
		DBVsnacc_to_dbv_systemid(psStatusOrErrorReport->psRequesterId, status_Or_Error_Report->requester_id, env);
	}
	

	/* opt */ 
	if (status_Or_Error_Report->responder_id != NULL) {
		psStatusOrErrorReport->psResponderId = (DbvSystemId *) DbvAlloc (sizeof (DbvSystemId));
		CheckDbvAlloc(psStatusOrErrorReport->psResponderId, env);
		DBVsnacc_to_dbv_systemid(psStatusOrErrorReport->psResponderId, status_Or_Error_Report->responder_id, env);
	}
	
	/* opt */
	if (status_Or_Error_Report->reason_no_report != NULL) {
		psStatusOrErrorReport->peReasonNoReport = (DbvReasonNoReport *) DbvAlloc (sizeof (DbvReasonNoReport));
		CheckDbvAlloc(psStatusOrErrorReport->peReasonNoReport, env);
		DBVsnacc_to_dbv_reasonnorep(psStatusOrErrorReport->peReasonNoReport, status_Or_Error_Report->reason_no_report, env);
	}

	/* opt */
	if (status_Or_Error_Report->status_report != NULL) {
		psStatusOrErrorReport->psStatusReport = (DbvStatusReport *) DbvAlloc (sizeof (DbvStatusReport));
		CheckDbvAlloc(psStatusOrErrorReport->psStatusReport, env);
		DBVsnacc_to_dbv_statrep(psStatusOrErrorReport->psStatusReport, status_Or_Error_Report->status_report, env);
	}

	/* opt */
	if (status_Or_Error_Report->error_report != NULL) {
		psStatusOrErrorReport->psErrorReport = (DbvErrorReport *) DbvAlloc (sizeof (DbvErrorReport));
		CheckDbvAlloc(psStatusOrErrorReport->psErrorReport, env);
		DBVsnacc_to_dbv_errrep(psStatusOrErrorReport->psErrorReport, status_Or_Error_Report->error_report, env);
	}

	
	/* opt */
	if (status_Or_Error_Report->note != NULL) {
		psStatusOrErrorReport->psNote = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psStatusOrErrorReport->psNote, env);
		DBVsnacc_to_dbv_illstring(psStatusOrErrorReport->psNote, status_Or_Error_Report->note, env);
	}
		

	/* opt */
	if (status_Or_Error_Report->status_or_error_report_extensions != NULL) {
		num_elements = 0;
        	index = 0;
        	num_elements = AsnListCount(status_Or_Error_Report->status_or_error_report_extensions);
		psStatusOrErrorReport->ppsStOrErReportExtension = (DbvExtension **) DbvAlloc (sizeof (DbvExtension *) * (num_elements + 1));
		CheckDbvAlloc(psStatusOrErrorReport->ppsStOrErReportExtension, env);
		DBVsnacc_to_dbv_extensionlist(psStatusOrErrorReport->ppsStOrErReportExtension, status_Or_Error_Report->status_or_error_report_extensions, env);
	}
}



int DBVsnacc_to_dbv_reasonnorep(DbvReasonNoReport *peReasonNoReport, Reason_No_Report *reason_no_report, jmp_buf env)
{
	switch (*reason_no_report) {
	case TEMPORARY:
		*peReasonNoReport = RNR_Temporary;
		break;
	case PERMANENT:
		*peReasonNoReport = RNR_Temporary;
		break;
	default:
		*peReasonNoReport = RNR_Invalid;
		break;
	}
}



int DBVsnacc_to_dbv_statrep(DbvStatusReport *psStatusReport, struct Status_Report* status_report, jmp_buf env)
{
	/* Two compys */
	DBVsnacc_to_dbv_userstat(&psStatusReport->sUserStatusReport, status_report->user_status_report, env); 
		
	DBVsnacc_to_dbv_currstate(&psStatusReport->eProviderStatusReport, &status_report->provider_status_report, env);
	
}



int DBVsnacc_to_dbv_userstat(DbvHistoryReport *psUserStatusReport, struct History_Report* user_status_report, jmp_buf env)
{
	/* opt */
	if (user_status_report->date_requested.octetLen != 0) 
		DBVsnacc_to_dbv_vis_string(&psUserStatusReport->pcDateRequested, &user_status_report->date_requested, env);
	
	/* opt */
	if (user_status_report->author != NULL) {
		psUserStatusReport->psAuthor = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psUserStatusReport->psAuthor, env);
		DBVsnacc_to_dbv_illstring(psUserStatusReport->psAuthor, user_status_report->author, env);
	}


	if (user_status_report->title != NULL) {
		psUserStatusReport->psTitle = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psUserStatusReport->psTitle, env);
		DBVsnacc_to_dbv_illstring(psUserStatusReport->psTitle, user_status_report->title, env);
	}


	if (user_status_report->author_of_article != NULL) {
		psUserStatusReport->psAuthorOfArticle = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psUserStatusReport->psAuthorOfArticle, env);
		DBVsnacc_to_dbv_illstring(psUserStatusReport->psAuthorOfArticle, user_status_report->author_of_article, env);
	}

	if (user_status_report->title_of_article != NULL) {
		psUserStatusReport->psTitleOfArticle = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psUserStatusReport->psTitleOfArticle, env);
		DBVsnacc_to_dbv_illstring(psUserStatusReport->psTitleOfArticle, user_status_report->title_of_article, env);
	}

	/* opt */
	if (user_status_report->date_of_last_transition.octetLen != 0) 
		DBVsnacc_to_dbv_vis_string(&psUserStatusReport->pcDateOfLastTransition, &user_status_report->date_of_last_transition, env);

	/* compy */
	DBVsnacc_to_dbv_mostrecserv(&psUserStatusReport->eMostRecentService, &user_status_report->most_recent_service, env);

	/* comp */
	DBVsnacc_to_dbv_vis_string(&psUserStatusReport->pcDateOfMostRecentService, &user_status_report->date_of_most_recent_service, env);


	/* comp */
	DBVsnacc_to_dbv_systemid(&psUserStatusReport->sSystemId, user_status_report->initiator_of_most_recent_service, env);

	/* opt */
	if (user_status_report->shipped_service_type != NULL) {
		psUserStatusReport->peShippedServiceType = (DbvShippedServiceType *) DbvAlloc (sizeof (DbvShippedServiceType));
		CheckDbvAlloc(psUserStatusReport->peShippedServiceType, env);
		DBVsnacc_to_dbv_shippedservice(psUserStatusReport->peShippedServiceType, user_status_report->shipped_service_type, env);
	}


	/* opt */
	if (user_status_report->transaction_results != NULL) {
		psUserStatusReport->peTransactionResults = (DbvTransactionResults *)DbvAlloc (sizeof (DbvTransactionResults));
		CheckDbvAlloc(psUserStatusReport->peTransactionResults, env);
		DBVsnacc_to_dbv_transres(psUserStatusReport->peTransactionResults, user_status_report->transaction_results, env);
	}

	/* opt */
	if (user_status_report->most_recent_service_note != NULL) {
		psUserStatusReport->psMostRecentServiceNote = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psUserStatusReport->psMostRecentServiceNote, env); 
		DBVsnacc_to_dbv_illstring(psUserStatusReport->psMostRecentServiceNote, user_status_report->most_recent_service_note, env);
	}	
}


int DBVsnacc_to_dbv_mostrecserv(DbvMostRecentService *peMostRecentService, History_ReportEnum *most_recent_service, jmp_buf env)
{
	switch (*most_recent_service) {
	case ILL_REQUEST:
		*peMostRecentService = MRS_IllRequest;
		break;
	case FORWARD:
		*peMostRecentService = MRS_Forward;
		break;
	case FORWARD_NOTIFICATION:
		*peMostRecentService = MRS_ForwardNotification;
		break;
	case SHIPPED:
		*peMostRecentService = MRS_Shipped;
		break;
	case ILL_ANSWER:
		*peMostRecentService = MRS_IllAnswer;
		break;
	case CONDITIONAL_REPLY:
		*peMostRecentService = MRS_ConditionalReply;
		break;
	case CANCEL1:
		*peMostRecentService = MRS_Cancel;
		break;
	case CANCEL_REPLY:
		*peMostRecentService = MRS_CancelReply;
		break;
	case RECEIVED:
		*peMostRecentService = MRS_Received;
		break;
	case RECALL:
		*peMostRecentService = MRS_Recall;
		break;
	case RETURNED:
		*peMostRecentService = MRS_Returned;
		break;
	case CHECKED_IN:
		*peMostRecentService = MRS_CheckedIn;
		break;
	case OVERDUE:
		*peMostRecentService = MRS_Overdue;
		break;
	case RENEW:
		*peMostRecentService = MRS_Renew;
		break;
	case RENEW_ANSWER:
		*peMostRecentService = MRS_RenewAnswer;
		break;
	case LOST:
		*peMostRecentService = MRS_Lost;
		break;
	case DAMAGED:
		*peMostRecentService = MRS_Damaged;
		break;
	case MESSAGE:
		*peMostRecentService = MRS_Message;
		break;
	case STATUS_QUERY:
		*peMostRecentService = MRS_StatusQuery;
		break;
	case STATUS_OR_ERROR_REPORT:
		*peMostRecentService = MRS_StatusOrErrorReport;
		break;
	case EXPIRED:
		*peMostRecentService = MRS_Expired;
		break;
	default:
		*peMostRecentService = MRS_Invalid;
		break;
	}
}



int DBVsnacc_to_dbv_shippedservice(DbvShippedServiceType *peShippedServiceType, Shipped_Service_Type *shipped_service_type, jmp_buf env)
{

	/* only Loan and CopyNonReturnable required by DBV */

	switch (*shipped_service_type) {
	case LOAN:
		*peShippedServiceType = SST_Loan;
		break;
	case COPY_NON_RETURNABLE:
		*peShippedServiceType = SST_CopyNonReturnable;
		break;
	case LOCATIONS:
		*peShippedServiceType = SST_Invalid;
		break;
	case ESTIMATE:
		*peShippedServiceType = SST_Invalid;
		break;
	case RESPONDER_SPECIFIC3:
		*peShippedServiceType = SST_Invalid;
		break;
	default:
		*peShippedServiceType = SST_Invalid;
		break;
	}
}



int DBVsnacc_to_dbv_transres(DbvTransactionResults *peTransactionResults, Transaction_Results *transaction_results, jmp_buf env)
{
	switch (*transaction_results) {
	case CONDITIONAL1:
		*peTransactionResults = TR_Conditional;
		break;
	case RETRY:
		*peTransactionResults = TR_Retry;
		break;
	case UNFILLED:
		*peTransactionResults = TR_Unfilled;
		break;
	case LOCATIONS_PROVIDED:
		*peTransactionResults = TR_LocationsProvided;
		break;
	case WILL_SUPPLY:
		*peTransactionResults = TR_WillSupply;
		break;
	case HOLD_PLACED:
		*peTransactionResults = TR_HoldPlaced;
		break;
	case ESTIMATE1:
		*peTransactionResults = TR_Estimate;
		break;
	default:
		*peTransactionResults = TR_Invalid;
		break;
	}
}




int DBVsnacc_to_dbv_errrep(DbvErrorReport *psErrorReport, struct Error_Report* error_report, jmp_buf env)
{
	/* comp */
	DBVsnacc_to_dbv_illstring(&psErrorReport->sCorrelationInfo, error_report->correlation_information, env);

	
	/* mapping not 1:1 here */
	
	/* comp */
	switch (error_report->report_source) {
	case USER:
		psErrorReport->sReport.eReportSource = RS_User;
		psErrorReport->sReport.uReport.psUserErrorReport = (DbvUserErrorReport *) DbvAlloc (sizeof (DbvUserErrorReport));
		CheckDbvAlloc(psErrorReport->sReport.uReport.psUserErrorReport, env);
		DBVsnacc_to_dbv_userrep(psErrorReport->sReport.uReport.psUserErrorReport, error_report->user_error_report, env);

		break;
	case PROVIDER:
		psErrorReport->sReport.eReportSource = RS_Provider;
		psErrorReport->sReport.uReport.psUserErrorReport = (DbvUserErrorReport *) DbvAlloc (sizeof (DbvUserErrorReport));
		CheckDbvAlloc(psErrorReport->sReport.uReport.psUserErrorReport, env);
		DBVsnacc_to_dbv_provrrep(psErrorReport->sReport.uReport.psProviderErrorReport, error_report->provider_error_report, env);

		break;
	}
}


int DBVsnacc_to_dbv_userrep(DbvUserErrorReport *psUserErrorReport, struct User_Error_Report* user_error_report, jmp_buf env)
{
	switch (user_error_report->choiceId) {
	case USER_ERROR_REPORT_ALREADY_FORWARDED:
		psUserErrorReport->eReportType = UER_AlreadyForwarded;
		psUserErrorReport->uUserErrorReport.psAlreadyForwarded = (DbvAlreadyForwarded *) DbvAlloc (sizeof (DbvAlreadyForwarded));
		CheckDbvAlloc(psUserErrorReport->uUserErrorReport.psAlreadyForwarded, env);
		DBVsnacc_to_dbv_alreadyfor(psUserErrorReport->uUserErrorReport.psAlreadyForwarded, user_error_report->a.already_forwarded, env);
		break;
	case USER_ERROR_REPORT_INTERMEDIARY_PROBLEM:
		psUserErrorReport->eReportType = UER_IntermediaryProblem;
		DBVsnacc_to_dbv_interprob(&psUserErrorReport->uUserErrorReport.eIntermediaryProblem, &user_error_report->a.intermediary_problem, env);
		break;
	case USER_ERROR_REPORT_SECURITY_PROBLEM:
		psUserErrorReport->eReportType = UER_SecurityProblem;
		psUserErrorReport->uUserErrorReport.psSecurityProblem = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		CheckDbvAlloc(psUserErrorReport->uUserErrorReport.psSecurityProblem, env);
		DBVsnacc_to_dbv_illstring(psUserErrorReport->uUserErrorReport.psSecurityProblem, user_error_report->a.security_problem, env);
		break;
	case USER_ERROR_REPORT_UNABLE_TO_PERFORM:
		psUserErrorReport->eReportType = UER_UnableToPerform;
		DBVsnacc_to_dbv_unableperform(&psUserErrorReport->uUserErrorReport.eUnableToPerform, &user_error_report->a.unable_to_perform, env);
		break;
	}
}



int DBVsnacc_to_dbv_alreadyfor(DbvAlreadyForwarded *psAlreadyForwarded, struct Already_Forwarded* already_forwarded, jmp_buf env)
{
	/* comp */
	DBVsnacc_to_dbv_systemid(&psAlreadyForwarded->sResponderId, already_forwarded->responder_id, env);
	
	/* opt */
	if (already_forwarded->responder_address != NULL) {
		psAlreadyForwarded->psResponderAddress = (DbvSystemAddress *) DbvAlloc (sizeof (DbvSystemAddress));
		CheckDbvAlloc(psAlreadyForwarded->psResponderAddress, env);
		DBVsnacc_to_dbv_electaddr(psAlreadyForwarded->psResponderAddress, already_forwarded->responder_address, env);
	}
		
}



int DBVsnacc_to_dbv_interprob(DbvIntermediaryProblem *peIntermediaryProblem, Intermediary_Problem *intermediary_problem, jmp_buf env)
{
	switch (*intermediary_problem) {
	case CANNOT_SEND_ONWARD:
		*peIntermediaryProblem = IP_CannotSendOnward;
		break;
	default:
		*peIntermediaryProblem = IP_Invalid;
		break;
	}
}


	
int DBVsnacc_to_dbv_unableperform(DbvUnableToPerform *peUnableToPerform, Unable_To_Perform *unable_to_perform, jmp_buf env)
{
	switch (*unable_to_perform) {
	case NOT_AVAILABLE:
		*peUnableToPerform = UTP_NotAvailable;
		break;
	case RESOURCE_LIMITATION:
		*peUnableToPerform = UTP_ResourceLimitation;
		break;
	case OTHER12:
		*peUnableToPerform = UTP_Other;
		break;
	default:
		*peUnableToPerform = UTP_Invalid;
		break;
	}
}



int DBVsnacc_to_dbv_provrrep(DbvProviderErrorReport *psProviderErrorReport, struct Provider_Error_Report* provider_error_report, jmp_buf env)
{
	switch (provider_error_report->choiceId) {
	case PROVIDER_ERROR_REPORT_GENERAL_PROBLEM:
		psProviderErrorReport->eReportType = PER_GeneralProblem;
		DBVsnacc_to_dbv_genprob(&psProviderErrorReport->uProviderErrorReport.eGeneralProblem, &provider_error_report->a.general_problem, env);
		break;
	case PROVIDER_ERROR_REPORT_TRANSACTION_ID_PROBLEM:
		psProviderErrorReport->eReportType = PER_TransactionIdProblem;
		DBVsnacc_to_dbv_transidprob(&psProviderErrorReport->uProviderErrorReport.eTransactionIdProblem, &provider_error_report->a.transaction_id_problem, env);
		break;
	case PROVIDER_ERROR_REPORT_STATE_TRANSITION_PROHIBITED:
		psProviderErrorReport->eReportType = PER_StateTransitionProhibited;
		psProviderErrorReport->uProviderErrorReport.psStateTransitionProblem = (DbvStateTransitionProhibited *) DbvAlloc (sizeof (DbvStateTransitionProhibited));
		CheckDbvAlloc(psProviderErrorReport->uProviderErrorReport.psStateTransitionProblem, env);
		DBVsnacc_to_dbv_statetrans(psProviderErrorReport->uProviderErrorReport.psStateTransitionProblem, provider_error_report->a.state_transition_prohibited, env);
		break;
	}
}



int DBVsnacc_to_dbv_genprob(DbvGeneralProblem *peGeneralProblem, General_Problem *general_problem, jmp_buf env)
{
	switch (*general_problem) {
	case UNRECOGNIZED_APDU:
		*peGeneralProblem = GP_UnrecognizedAPDU;
		break;
	case MISTYPED_APDU:
		*peGeneralProblem = GP_MistypedAPDU;
		break;
	case BADLY_STRUCTURED_APDU:
		*peGeneralProblem = GP_BadlyStructuredAPDU;
		break;
	case PROTOCOL_VERSION_NOT_SUPPORTED:
		*peGeneralProblem = GP_ProtocolVersionNotSupported;
		break;
	case OTHER6:
		*peGeneralProblem = GP_Other;
		break;
	default:
		*peGeneralProblem = GP_Invalid;
		break;
	}
}


int DBVsnacc_to_dbv_transidprob(DbvTransactionIdProblem *peTransactionIdProblem, Transaction_Id_Problem *transaction_id_problem, jmp_buf env)
{
	switch (*transaction_id_problem) {
	case DUPLICATE_TRANSACTION_ID:
		*peTransactionIdProblem = TIP_DuplicateTransactionId;
		break;
	case INVALID_TRANSACTION_ID:
		*peTransactionIdProblem = TIP_InvalidTransactionId;
		break;
	case UNKNOWN_TRANSACTION_ID:
		*peTransactionIdProblem = TIP_UnknownTransactionId;
		break;
	default:
		*peTransactionIdProblem = TIP_Invalid;
		break;
	}
		
}



int DBVsnacc_to_dbv_statetrans(DbvStateTransitionProhibited *psStateTransitionProblem, struct State_Transition_Prohibited* state_transition_prohibited, jmp_buf env)
{
	/* Both comp */
	DBVsnacc_to_dbv_apdutype(&psStateTransitionProblem->eAPDUType, &state_transition_prohibited->aPDU_type, env);

	DBVsnacc_to_dbv_currstate(&psStateTransitionProblem->eCurrentState, &state_transition_prohibited->current_state, env);
}


int DBVsnacc_to_dbv_apdutype(DbvIllAPDUType *peAPDUType, ILL_APDU_Type *aPDU_type, jmp_buf env)
{
	switch (*aPDU_type) {
	case ILL_REQUEST1:
		*peAPDUType = IAT_IllRequest;
		break;
	case FORWARD_NOTIFICATION1:
		*peAPDUType = IAT_ForwardNotification;
		break;
	case SHIPPED2:
		*peAPDUType = IAT_Shipped;
		break;
	case ILL_ANSWER1:
		*peAPDUType = IAT_IllAnswer;
		break;
	case CONDITIONAL_REPLY1:
		*peAPDUType = IAT_ConditionalReply;
		break;
	case CANCEL2:
		*peAPDUType = IAT_Cancel;
		break;
	case CANCEL_REPLY1:
		*peAPDUType = IAT_CancelReply;
		break;
	case RECEIVED2:
		*peAPDUType = IAT_Received;
		break;
	case RECALL2:
		*peAPDUType = IAT_Recall;
		break;
	case RETURNED2:
		*peAPDUType = IAT_Returned;
		break;
	case CHECKED_IN2:
		*peAPDUType = IAT_CheckedIn;
		break;
	case OVERDUE2:
		*peAPDUType = IAT_Overdue;
		break;
	case RENEW1:
		*peAPDUType = IAT_Renew;
		break;
	case RENEW_ANSWER1:
		*peAPDUType = IAT_RenewAnswer;
		break;
	case LOST2:
		*peAPDUType = IAT_Lost;
		break;
	case DAMAGED1:
		*peAPDUType = IAT_Damaged;
		break;
	case MESSAGE1:
		*peAPDUType = IAT_Message;
		break;
	case STATUS_QUERY1:
		*peAPDUType = IAT_StatusQuery;
		break;
	case STATUS_OR_ERROR_REPORT1:
		*peAPDUType = IAT_StatusOrErrorReport;
		break;
	case EXPIRED1:
		*peAPDUType = IAT_Expired;
		break;
	default:
		*peAPDUType = IAT_Invalid;
		break;
	}
}


int DBVsnacc_to_dbv_currstate(DbvCurrentState *peCurrentState, Current_State *current_state, jmp_buf env)
{
	switch (*current_state) {
	case NOT_SUPPLIED:
		*peCurrentState = CS_NotSupplied;
		break;
	case PENDING1:
		*peCurrentState = CS_Pending;
		break;
	case IN_PROCESS2:
		*peCurrentState = CS_InProcess;
		break;
	case FORWARD1:
		*peCurrentState = CS_Forward;
		break;
	case CONDITIONAL:
		*peCurrentState = CS_Conditional;
		break;
	case CANCEL_PENDING:
		*peCurrentState = CS_CancelPending;
		break;
	case CANCELLED:
		*peCurrentState = CS_Cancelled;
		break;
	case SHIPPED1:
		*peCurrentState = CS_Shipped;
		break;
	case RECEIVED1:
		*peCurrentState = CS_Received;
		break;
	case RENEW_PENDING:
		*peCurrentState = CS_RenewPending;
		break;
	case NOT_RECEIVED_OVERDUE:
		*peCurrentState = CS_NotReceivedOverdue;
		break;
	case RENEW_OVERDUE:
		*peCurrentState = CS_RenewOverdue;
		break;
	case OVERDUE1:
		*peCurrentState = CS_Overdue;
		break;
	case RETURNED1:
		*peCurrentState = CS_Returned;
		break;
	case CHECKED_IN1:
		*peCurrentState = CS_CheckedIn;
		break;
	case RECALL1:
		*peCurrentState = CS_Recall;
		break;
	case LOST1:
		*peCurrentState = CS_Lost;
		break;
	case UNKNOWN:
		*peCurrentState = CS_Unknown;
		break;
	default:
		*peCurrentState = CS_Invalid;
		break;
	}
	
}



/*******************************************************************/
/*******************************************************************/
/* Structure checking routines */


/* Check the DBV item order external structure for validity */

int DBVcheck_at_itemorderextendedservice(DbvAssocId lAssocId, DbvSingleASN1Type *psSingleASN1Type, char *oid, char *error_buffer, DbvError **ppsSIError)
{
        char local_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);


        /* If external object identifier is not valid for the external */

        if ( (strcmp(oid, ANSI_ITEMORDER_EXTENDED_SERVICE) != 0) &&
             (strcmp(oid, ISO_ITEMORDER_EXTENDED_SERVICE) != 0) ) {

		DBVsa_strcat(local_error_buffer, "eASN1Type");
                return(DBVdbv_external_oid_error(lAssocId, oid, local_error_buffer, ppsSIError));
        }

	DBVsa_strcat(local_error_buffer, "uASN1.psItemOrderExtendedService");
        if (psSingleASN1Type->uASN1.psItemOrderExtendedService == NULL)
                return(DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));


	DBVsa_strcat(local_error_buffer, "->");
        return(DBVcheck_dbv_itemorder(lAssocId, psSingleASN1Type->uASN1.psItemOrderExtendedService, local_error_buffer, ppsSIError));
}



int DBVcheck_dbv_itemorder(DbvAssocId lAssocId, struct DbvItemOrderExtendedService *psItemOrderExtendedService, char *error_buffer, DbvError **ppsSIError)
{
        char local_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

        switch (psItemOrderExtendedService->eItemOrderReqRsp) {
        case IOROR_Request:

		DBVsa_strcat(local_error_buffer, "uItemOrderReqOrRsp.psItemOrderRequest");

        	if (psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderRequest == NULL) 
                	return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
		

		DBVsa_strcat(local_error_buffer, "->");
                return(DBVcheck_dbv_itemorderreq(lAssocId, psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderRequest, local_error_buffer, ppsSIError));
                break;
        case IOROR_Response:

                DBVsa_strcat(local_error_buffer, "uItemOrderReqOrRsp.psItemOrderResponse");
        	if (psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderResponse == NULL) 
                	return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
		
                DBVsa_strcat(local_error_buffer, "->");
                return(DBVcheck_dbv_itemorderrsp(lAssocId, psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderResponse, local_error_buffer, ppsSIError));
                break;
        default:
                DBVsa_strcat(local_error_buffer, "eItemOrderReqRsp");
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
                break;
        }

        return SI_OK;
}



int DBVcheck_dbv_itemorderreq(DbvAssocId lAssocId, DbvEsIoRequest *psItemOrderRequest, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

        /* psToKeep is optional so can be NULL */
        if (psItemOrderRequest->psToKeep != NULL) {
        	DBVsa_strcat(local_error_buffer, "psToKeep->");
        	if (DBVcheck_dbv_io_originpartkeep(lAssocId, psItemOrderRequest->psToKeep, local_error_buffer, ppsSIError) == SI_NOTOK)
                	return SI_NOTOK;
	}


        DBVsa_strcat(local_error_buffer, "sNotToKeep.");
        return(DBVcheck_dbv_io_originpartnokeep(lAssocId, &psItemOrderRequest->sNotToKeep, local_error_buffer, ppsSIError));

}



int DBVcheck_dbv_io_originpartkeep(DbvAssocId lAssocId, DbvEsIoOriginPartToKeep *psToKeep, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
	char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);
       

	/* All optional */
	if (psToKeep->psSupplementalDescription != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psSupplementalDescription->");
        	if (DBVcheck_dbv_external(lAssocId, psToKeep->psSupplementalDescription, temp_error_buffer, ppsSIError) == SI_NOTOK) 
			return SI_NOTOK;
	}


	if (psToKeep->psContact != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psContact->");
        	if (DBVcheck_dbv_io_contact(lAssocId, psToKeep->psContact, temp_error_buffer, ppsSIError) == SI_NOTOK) 
			return SI_NOTOK;
	}
	

	if (psToKeep->psAdditionalBilling != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psAdditionalBilling->");
        	if (DBVcheck_dbv_io_addbilling(lAssocId, psToKeep->psAdditionalBilling, temp_error_buffer, ppsSIError) == SI_NOTOK) 
			return SI_NOTOK;
	}
	

	return SI_OK;
}



int DBVcheck_dbv_io_contact(DbvAssocId lAssocId, DbvEsIoContact *psContact, char *error_buffer, DbvError **ppsSIError) 
{
	char local_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* All contact DbvInternationalString optional  - don't have to check */
	
	return SI_OK;
}



int DBVcheck_dbv_io_addbilling(DbvAssocId lAssocId, DbvEsIoAdditionalBilling *psAdditionalBilling, char *error_buffer, DbvError **ppsSIError) 
{
	char local_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);
       
        DBVsa_strcat(local_error_buffer, "sPaymentMethod." );
	if (DBVcheck_dbv_io_paymethod(lAssocId, &psAdditionalBilling->sPaymentMethod, local_error_buffer, ppsSIError) == SI_NOTOK)
		return SI_NOTOK;
	
	/* Remaining fields are optional DbvInternationalString which dont
	  need checking */
	return SI_OK;
}



int DBVcheck_dbv_io_paymethod(DbvAssocId lAssocId, DbvEsIoPaymentMethod *psPaymentMethod, char *error_buffer, DbvError **ppsSIError) 
{
	char local_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	switch (psPaymentMethod->ePaymentMethodType) {
	case IOPM_BillInvoice:
		return SI_OK;
		break;
	case IOPM_Prepay:
		return SI_OK;
		break;
	case IOPM_DepositAccount:
		return SI_OK;
		break;

	case IOPM_CreditCard:
		DBVsa_strcat(local_error_buffer, "puPaymentMethod->psCreditCardInfo");
                if (psPaymentMethod->puPaymentMethod->psCreditCardInfo == NULL) 
                        return(DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));

		DBVsa_strcat(local_error_buffer, "->");
                return(DBVcheck_dbv_io_creditinfo(lAssocId, psPaymentMethod->puPaymentMethod->psCreditCardInfo, local_error_buffer, ppsSIError));
                break;

	case IOPM_CardInfoPrevSupplied:
		return SI_OK;
		break;
	case IOPM_PrivateKnown:
		return SI_OK;
		break;

	case IOPM_PrivateNotKnown:
		DBVsa_strcat(local_error_buffer, "puPaymentMethod->psPrivateNotK");

                if (psPaymentMethod->puPaymentMethod->psPrivateNotKnown == NULL) 
                        return(DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));


                DBVsa_strcat(local_error_buffer, "->");
                return(DBVcheck_dbv_external(lAssocId, psPaymentMethod->puPaymentMethod->psPrivateNotKnown, local_error_buffer, ppsSIError));
		break;
	default:
                DBVsa_strcat(local_error_buffer, "ePaymentMethodType");
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
                break;

	}
	
	return SI_OK;
}



int DBVcheck_dbv_io_creditinfo(DbvAssocId lAssocId, DbvEsIoCreditCardInfo *psCreditCardInfo, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* All compulsory - no need to test */
	
	return SI_OK;
}



int DBVcheck_dbv_io_originpartnokeep(DbvAssocId lAssocId, DbvEsIoOriginPartNotToKeep *psNotToKeep, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* Both optional */
	if (psNotToKeep->psResultSetItem != NULL) {
		DBVsa_strcat(local_error_buffer, "psResultSetItem->");
		if (DBVcheck_dbv_io_resset(lAssocId, psNotToKeep->psResultSetItem, local_error_buffer, ppsSIError) == SI_NOTOK)
			return SI_NOTOK;
	}
	
	/* Both optional */
	if (psNotToKeep->psItemRequest != NULL) {
		DBVsa_strcat(local_error_buffer, "psItemRequest->");
		return(DBVcheck_dbv_external(lAssocId, psNotToKeep->psItemRequest, local_error_buffer, ppsSIError));
	}

	return SI_OK;
}



int DBVcheck_dbv_io_resset(DbvAssocId lAssocId, DbvEsIoResultSetItem *psResultSetItem, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* Both optional but dont need to check DbvInternationalString 
	   or Ulong */
	
	return SI_OK;
}



int DBVcheck_dbv_itemorderrsp(DbvAssocId lAssocId, DbvEsIoTaskPackage *psItemOrderResponse, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
	char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* First optional */

	if (psItemOrderResponse->psOriginPart != NULL) {
       		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
       		DBVsa_strcat(temp_error_buffer, "psOriginPart->");
       		if (DBVcheck_dbv_io_originpartkeep(lAssocId, psItemOrderResponse->psOriginPart, temp_error_buffer, ppsSIError) == SI_NOTOK)
			return SI_NOTOK;
	}


       	DBVsa_strcat(local_error_buffer, "sTargetPart.");
	return(DBVcheck_dbv_io_targetpart(lAssocId, &psItemOrderResponse->sTargetPart, local_error_buffer, ppsSIError));
}



int DBVcheck_dbv_io_targetpart(DbvAssocId lAssocId, DbvEsIoTargetPart *psTargetPart, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
	char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* All these optional */

	if (psTargetPart->psItemRequest != NULL) {
       		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
       		DBVsa_strcat(temp_error_buffer, "psItemRequest->");
       		if (DBVcheck_dbv_external(lAssocId, psTargetPart->psItemRequest, temp_error_buffer, ppsSIError) == SI_NOTOK)
			return SI_NOTOK;
	}
	


	/* optional */
	if (psTargetPart->psStatusOrErrorReport) {
       		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
       		DBVsa_strcat(temp_error_buffer, "psStatusOrErrorReport");
       		DBVsa_strcat(temp_error_buffer, "->");
       		if (DBVcheck_dbv_external(lAssocId, psTargetPart->psStatusOrErrorReport, temp_error_buffer, ppsSIError) == SI_NOTOK)
			return SI_NOTOK;
	}

	


	if (psTargetPart->peAuxiliaryStatus != NULL) 
		if (DBVcheck_dbv_enum(*psTargetPart->peAuxiliaryStatus, IOAS_NotReceived, IOAS_FilledCopyright) == SI_NOTOK) {
       			DBVsa_strcat(local_error_buffer, "peAuxiliaryStatus");
                	return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
		}
       

	return SI_OK;
}


/********************************************************************/

/* Check the Inter Library Loan (ILL)  external structure for validity */

int DBVcheck_at_isoill(DbvAssocId lAssocId, DbvSingleASN1Type *psSingleASN1Type, char *oid, char *error_buffer, DbvError **ppsSIError)
{
        char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);


        /* If external object idenifier is not valid for the external */
        if ( (strcmp(oid, ISO_ILL_PDU) != 0) ) {

                DBVsa_strcat(local_error_buffer, "eASN1Type");
                return(DBVdbv_external_oid_error(lAssocId, oid, local_error_buffer, ppsSIError));
        }


        DBVsa_strcat(local_error_buffer, "uASN1.psIllPdu");
        if (psSingleASN1Type->uASN1.psIllPdu == NULL)
                return(DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));


        DBVsa_strcat(local_error_buffer, "->");
        return(DBVcheck_dbv_ill(lAssocId, psSingleASN1Type->uASN1.psIllPdu, local_error_buffer, ppsSIError));
}



int DBVcheck_dbv_ill(DbvAssocId lAssocId, struct DbvIllPdu *psIllPdu, char *error_buffer, DbvError **ppsSIError)
{
        char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

        switch (psIllPdu->eIllPduType) {
        case ILL_IllRequest:

                DBVsa_strcat(local_error_buffer, "uIllPdu.psIllRequest");

        	if (psIllPdu->uIllPdu.psIllRequest == NULL)
                	return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));

		DBVsa_strcat(local_error_buffer, "->");
                return(DBVcheck_dbv_ill_request(lAssocId, psIllPdu->uIllPdu.psIllRequest, local_error_buffer, ppsSIError));
                break;
        case ILL_StatusOrErrorReport:

                DBVsa_strcat(local_error_buffer, "uIllPdu.psStatusOrErrorReport");

        	if (psIllPdu->uIllPdu.psStatusOrErrorReport == NULL)
                	return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));

		DBVsa_strcat(local_error_buffer, "->");

                return(DBVcheck_dbv_ill_statorerr(lAssocId, psIllPdu->uIllPdu.psStatusOrErrorReport, local_error_buffer, ppsSIError));
                break;
        default:
                DBVsa_strcat(local_error_buffer, "eIllPduType");
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
                break;
        }

        return SI_OK;
}



int DBVcheck_dbv_ill_request(DbvAssocId lAssocId, DbvIllRequest *psIllRequest, char *error_buffer, DbvError **ppsSIError)
{
	int index = 0;
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];
	char index_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* c */
	if (DBVcheck_dbv_enum(psIllRequest->eProtocolVersion, PV_Version1, PV_Version2) == SI_NOTOK) {
		DBVsa_strcat(local_error_buffer, "eProtocolVersion");
		return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
        }


	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "sTransactionId.");
	if (DBVcheck_dbv_ill_transid(lAssocId, &psIllRequest->sTransactionId, temp_error_buffer, ppsSIError) == SI_NOTOK)
		return SI_NOTOK;


	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "sServiceDateTime.");
	if (DBVcheck_dbv_ill_servdatatime(lAssocId, &psIllRequest->sServiceDateTime, temp_error_buffer, ppsSIError) == SI_NOTOK)
		return SI_NOTOK;


	/* optional so can be NULL */
        if (psIllRequest->psRequesterId != NULL) {

                DBVsa_strcpy(temp_error_buffer, local_error_buffer);
                DBVsa_strcat(temp_error_buffer, "psRequesterId->");

                if (DBVcheck_dbv_ill_systemid(lAssocId, psIllRequest->psRequesterId, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */
	if (psIllRequest->psResponderId != NULL) {
                DBVsa_strcpy(temp_error_buffer, local_error_buffer);
                DBVsa_strcat(temp_error_buffer, "psResponderId->");

                if (DBVcheck_dbv_ill_systemid(lAssocId, psIllRequest->psResponderId, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* default so optional */	
       	if (psIllRequest->peTransactionType) {
        	DBVsa_strcpy(temp_error_buffer, "*");
        	DBVsa_strcat(temp_error_buffer, local_error_buffer);
        	DBVsa_strcat(temp_error_buffer, "peTransactionType");
		if (DBVcheck_dbv_ill_transtype(lAssocId, psIllRequest->peTransactionType, temp_error_buffer, ppsSIError) == SI_NOTOK)
			return SI_NOTOK;
	}


		
	/* o */
	if (psIllRequest->psDeliveryAddress != NULL) {
                DBVsa_strcpy(temp_error_buffer, local_error_buffer);
                DBVsa_strcat(temp_error_buffer, "psDeliveryAddress->");

                if (DBVcheck_dbv_ill_delivaddr(lAssocId, psIllRequest->psDeliveryAddress, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */	
	if (psIllRequest->psDeliveryService != NULL) {
                DBVsa_strcpy(temp_error_buffer, local_error_buffer);
                DBVsa_strcat(temp_error_buffer, "psDeliveryService->");

                if (DBVcheck_dbv_ill_delivserv(lAssocId, psIllRequest->psDeliveryService, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */
	if (psIllRequest->psBillingAddress != NULL) {
                DBVsa_strcpy(temp_error_buffer, local_error_buffer);
                DBVsa_strcat(temp_error_buffer, "psBillingAddress->");

                if (DBVcheck_dbv_ill_delivaddr(lAssocId, psIllRequest->
psBillingAddress, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* comp */

       	if (psIllRequest->ppeServiceType == NULL) {
		DBVsa_strcat(local_error_buffer, "ppeServiceType");
              	return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
	}

	index = 0;
        while (psIllRequest->ppeServiceType[index] != NULL) {

                DBVsa_strcpy(temp_error_buffer, local_error_buffer);
                DBVsa_strcat(temp_error_buffer, "ppeServiceType[");

		if (index < MAX_INDEX)
                	sprintf(index_buffer, "%d", index);
                DBVsa_strcat(temp_error_buffer, index_buffer);
                DBVsa_strcat(temp_error_buffer, "]->");

                if (DBVcheck_dbv_ill_servtype(lAssocId, psIllRequest->ppeServiceType[index], temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
                index++;
        }


	/* o */
	if (psIllRequest->psResponderSpecificService != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
        	DBVsa_strcat(temp_error_buffer, "psResponderSpecificService->");
        	if (DBVcheck_dbv_external(lAssocId, psIllRequest->psResponderSpecificService, temp_error_buffer, ppsSIError) == SI_NOTOK)
			return SI_NOTOK;
	}
	

	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
        DBVsa_strcat(temp_error_buffer, "sRequesterOptionalMessages.");
        if (DBVcheck_dbv_ill_reqoptmsg(lAssocId, &psIllRequest->sRequesterOptionalMessages, temp_error_buffer, ppsSIError) == SI_NOTOK)
		return SI_NOTOK;


	/* o */
	if (psIllRequest->psSearchType != NULL) {
                DBVsa_strcpy(temp_error_buffer, local_error_buffer);
                DBVsa_strcat(temp_error_buffer, "psSearchType->");

                if (DBVcheck_dbv_ill_srchtype(lAssocId, psIllRequest->psSearchType, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */

	if (psIllRequest->ppsSupplyMediumInfo) {
		index = 0;
        	while (psIllRequest->ppsSupplyMediumInfo[index] != NULL) {
	
                	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
                	DBVsa_strcat(temp_error_buffer, "ppsSupplyMediumInfo[");

			if (index < MAX_INDEX)
                		sprintf(index_buffer, "%d", index);
                	DBVsa_strcat(temp_error_buffer, index_buffer);
                	DBVsa_strcat(temp_error_buffer, "]->");
	
                	if (DBVcheck_dbv_ill_suppmedinfo(lAssocId, psIllRequest->ppsSupplyMediumInfo[index], temp_error_buffer, ppsSIError) == SI_NOTOK)
                        	return SI_NOTOK;
                	index++;
        	}
	}



	/* default so optional */

	if (psIllRequest->pePlaceOnHold) {
                DBVsa_strcpy(temp_error_buffer, "*");
                DBVsa_strcat(temp_error_buffer, local_error_buffer);
                DBVsa_strcat(temp_error_buffer, "pePlaceOnHold");

		/* No -> here ! because checking an enumeration */
        	if (DBVcheck_dbv_ill_placehold(lAssocId, psIllRequest->pePlaceOnHold, temp_error_buffer, ppsSIError) == SI_NOTOK)
        		return SI_NOTOK;
	}


	/* o */
	if (psIllRequest->psClientId != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
                DBVsa_strcat(temp_error_buffer, "psClientId->");

                if (DBVcheck_dbv_ill_clientid(lAssocId, psIllRequest->psClientId, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "sItemId.");
	if (DBVcheck_dbv_ill_itemid(lAssocId, &psIllRequest->sItemId, temp_error_buffer, ppsSIError) == SI_NOTOK)
		return SI_NOTOK;


	/* opt */
	if (psIllRequest->ppsSupplementalItemDescription) {
		index = 0;
        	while (psIllRequest->ppsSupplementalItemDescription[index] != NULL) {

                	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
                	DBVsa_strcat(temp_error_buffer, "ppsSupplementalItemDescription[");

			if (index < MAX_INDEX)
                		sprintf(index_buffer, "%d", index);
                	DBVsa_strcat(temp_error_buffer, index_buffer);
                	DBVsa_strcat(temp_error_buffer, "]->");

                	if (DBVcheck_dbv_external(lAssocId, psIllRequest->ppsSupplementalItemDescription[index], temp_error_buffer, ppsSIError) == SI_NOTOK)
                        	return SI_NOTOK;
                	index++;
        	}
	}


	/* o */
	if (psIllRequest->psCostInfo != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
                DBVsa_strcat(temp_error_buffer, "psCostInfo->");

                if (DBVcheck_dbv_ill_costinfo(lAssocId, psIllRequest->psCostInfo, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */
	if (psIllRequest->psCopyrightCompliance != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
                DBVsa_strcat(temp_error_buffer, "psCopyrightCompliance->");

                if (DBVcheck_dbv_ill_illstring(lAssocId, psIllRequest->psCopyrightCompliance, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* o */
	if (psIllRequest->psThirdPartyInfo != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
                DBVsa_strcat(temp_error_buffer, "psThirdPartyInfo->");

                if (DBVcheck_dbv_ill_thirdparty(lAssocId, psIllRequest->psThirdPartyInfo, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* default so optional */
       	if (psIllRequest->pfRetry) {
        	if (DBVcheck_dbv_bool(*psIllRequest->pfRetry) == SI_NOTOK) {
			DBVsa_strcat(local_error_buffer, "pfRetry");
			return(DBVdbv_bool_error(lAssocId, local_error_buffer, ppsSIError));
		}
	}
	

	/* default */
       	if (psIllRequest->pfForward) {
        	if (DBVcheck_dbv_bool(*psIllRequest->pfForward) == SI_NOTOK) {
			DBVsa_strcat(local_error_buffer, "pfForward");
			return(DBVdbv_bool_error(lAssocId, local_error_buffer, ppsSIError));
       		}
	}
	



	/* o */
	if (psIllRequest->psRequesterNote != NULL)  {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
                DBVsa_strcat(temp_error_buffer, "psRequesterNote->");

                if (DBVcheck_dbv_ill_illstring(lAssocId, psIllRequest->psRequesterNote, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */
	if (psIllRequest->psForwardNote != NULL)  {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
                DBVsa_strcat(temp_error_buffer, "psForwardNote->");

                if (DBVcheck_dbv_ill_illstring(lAssocId, psIllRequest->psForwardNote, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */
	if (psIllRequest->ppsRequestExtension) {
		index = 0;
		while (psIllRequest->ppsRequestExtension[index] != NULL)  {
                	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
                	DBVsa_strcat(temp_error_buffer, "ppsRequestExtension[");

			if (index < MAX_INDEX)
                		sprintf(index_buffer, "%d", index);
                	DBVsa_strcat(temp_error_buffer, index_buffer);
                	DBVsa_strcat(temp_error_buffer, "]->");
	
                	if (DBVcheck_dbv_ill_extension(lAssocId, psIllRequest->ppsRequestExtension[index], temp_error_buffer, ppsSIError) == SI_NOTOK)
                        	return SI_NOTOK;
                	index++;
        	}
	}

	return SI_OK;
}



int DBVcheck_dbv_ill_transid(DbvAssocId lAssocId, DbvTransactionId *psTransactionId, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* o */
	if (psTransactionId->psInitialRequesterId != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
                DBVsa_strcat(temp_error_buffer, "psInitialRequesterId->");

                if (DBVcheck_dbv_ill_systemid(lAssocId, psTransactionId->psInitialRequesterId, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
        DBVsa_strcat(temp_error_buffer, "sTransactionGroupQualifier.");
	if (DBVcheck_dbv_ill_illstring(lAssocId, &psTransactionId->sTransactionGroupQualifier, temp_error_buffer, ppsSIError) == SI_NOTOK)
		return SI_NOTOK;


	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
        DBVsa_strcat(temp_error_buffer, "sTransactionQualifier.");
	if (DBVcheck_dbv_ill_illstring(lAssocId, &psTransactionId->sTransactionQualifier, temp_error_buffer, ppsSIError) == SI_NOTOK)
		return SI_NOTOK;


	/* o */	
	if (psTransactionId->psSubTransactionQualifier != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
                DBVsa_strcat(temp_error_buffer, "psSubTransactionQualifier->");

                if (DBVcheck_dbv_ill_illstring(lAssocId, psTransactionId->psSubTransactionQualifier, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	return SI_OK;
}



int DBVcheck_dbv_ill_servdatatime(DbvAssocId lAssocId, DbvServiceDateTime *psServiceDateTime, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "sThisService.");

	if (DBVcheck_dbv_ill_datetime(lAssocId, &psServiceDateTime->sThisService, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
	

	/* o */
	if (psServiceDateTime->psOriginalService != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psOriginalService->");

		if (DBVcheck_dbv_ill_datetime(lAssocId, psServiceDateTime->psOriginalService, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }
	

	return SI_OK;
}



int DBVcheck_dbv_ill_datetime(DbvAssocId lAssocId, DbvDateTime *psThisService, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* c */
	
	if (psThisService->pcDate == NULL) {
		DBVsa_strcat(local_error_buffer, "pcDate");
              	return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
	}
	

	/* o */

	return SI_OK;
}



int DBVcheck_dbv_ill_systemid(DbvAssocId lAssocId, DbvSystemId *psRequesterId, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* o */
	if (psRequesterId->psSymbol != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psSymbol->");

		if (DBVcheck_dbv_ill_perorinstsymb(lAssocId, psRequesterId->psSymbol, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }
	

	/* o */
	if (psRequesterId->psName != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psName->");

		if (DBVcheck_dbv_ill_nameofperorinst(lAssocId, psRequesterId->psName, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }
	
	return SI_OK;
}



int DBVcheck_dbv_ill_perorinstsymb(DbvAssocId lAssocId, DbvPersonOrInstitutionSymbol *psSymbol, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	if (DBVcheck_dbv_enum(psSymbol->eSymbolType, SPI_PersonSymbol, SPI_InstitutionSymbol) == SI_NOTOK) {
                DBVsa_strcat(local_error_buffer, "eSymbolType");
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
        }


	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "sSymbol.");

	if (DBVcheck_dbv_ill_illstring(lAssocId, &psSymbol->sSymbol, temp_error_buffer, ppsSIError) == SI_NOTOK)
		return SI_NOTOK;
        

	return SI_OK;
}




int DBVcheck_dbv_ill_nameofperorinst(DbvAssocId lAssocId, DbvNameOfPersonOrInstitution *psName, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	if (DBVcheck_dbv_enum(psName->eNameType, NPI_NameOfPerson, NPI_NameOfInstitution) == SI_NOTOK) {
                DBVsa_strcat(local_error_buffer, "eNameType");
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
        }


	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "sName.");

	if (DBVcheck_dbv_ill_illstring(lAssocId, &psName->sName, temp_error_buffer, ppsSIError) == SI_NOTOK)
		return SI_NOTOK;

	return SI_OK;
}



int DBVcheck_dbv_ill_transtype(DbvAssocId lAssocId, DbvTransactionType *peTransactionType, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	if (DBVcheck_dbv_enum(*peTransactionType, TT_Simple, TT_Partitioned) == SI_NOTOK) 
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
        
	
	return SI_OK;
}



int DBVcheck_dbv_ill_delivaddr(DbvAssocId lAssocId, DbvDeliveryAddress *psDeliveryAddress, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* o */
	if (psDeliveryAddress->psPostalAddress != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psPostalAddress->");

		if (DBVcheck_dbv_ill_postaladdr(lAssocId, psDeliveryAddress->psPostalAddress, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }
	
	

	/* o */
	if (psDeliveryAddress->psElectronicAddress != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psElectronicAddress->");

		if (DBVcheck_dbv_ill_systemaddr(lAssocId, psDeliveryAddress->psElectronicAddress, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }
	
	return SI_OK;
}



int DBVcheck_dbv_ill_postaladdr(DbvAssocId lAssocId, DbvPostalAddress *psPostalAddress, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* o */
	if (psPostalAddress->psNameOfPersonOrInstitution != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psNameOfPersonOrInstitution->");

		if (DBVcheck_dbv_ill_nameofperorinst(lAssocId, psPostalAddress->psNameOfPersonOrInstitution, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	/* o */
	if (psPostalAddress->psExtendedPostalDeliveryAddress != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psExtendedPostalDeliveryAddress->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psPostalAddress->psExtendedPostalDeliveryAddress, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */
	if (psPostalAddress->psStreetAndNumber != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psStreetAndNumber->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psPostalAddress->psStreetAndNumber, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	
	/* o */
	if (psPostalAddress->psPostOfficeBox != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psPostOfficeBox->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psPostalAddress->psPostOfficeBox, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }



	/* o */
	if (psPostalAddress->psCity != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psCity->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psPostalAddress->psCity, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }



	/* o */
	if (psPostalAddress->psRegion != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psRegion->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psPostalAddress->psRegion, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }



	/* o */
	if (psPostalAddress->psCountry != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psCountry->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psPostalAddress->psCountry, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }



	/* o */
	if (psPostalAddress->psPostalCode != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psPostalCode->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psPostalAddress->psPostalCode, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	return SI_OK;
}



int DBVcheck_dbv_ill_systemaddr(DbvAssocId lAssocId, DbvSystemAddress *psElectronicAddress, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* o */
	if (psElectronicAddress->psTelecomServiceIdentifier != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psTelecomServiceIdentifier->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psElectronicAddress->psTelecomServiceIdentifier, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */
	if (psElectronicAddress->psTelecomServiceAddress != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psTelecomServiceAddress->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psElectronicAddress->psTelecomServiceAddress, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	

	return SI_OK;
}



int DBVcheck_dbv_ill_delivserv(DbvAssocId lAssocId, DbvDeliveryService *psDeliveryService, char *error_buffer, DbvError **ppsSIError)
{
	int index = 0;
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];
	char index_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	switch (psDeliveryService->eDeliveryServiceType) {
	case DST_PhysicalDelivery:

		DBVsa_strcat(local_error_buffer, "uDeliveryService.psPhysicalDelivery");
       		if (psDeliveryService->uDeliveryService.psPhysicalDelivery == NULL) 
              		return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));

		DBVsa_strcat(local_error_buffer, "->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psDeliveryService->uDeliveryService.psPhysicalDelivery, local_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
		break;


	case DST_ElectronicDelivery:

		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "uDeliveryService.ppsElectronicDelivery");
	       	if (psDeliveryService->uDeliveryService.ppsElectronicDelivery == NULL) 
       		       	return (DBVdbv_field_missing_error(lAssocId, temp_error_buffer, ppsSIError));
		

		index = 0;
        	while (psDeliveryService->uDeliveryService.ppsElectronicDelivery[index] != NULL) {

                	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
                	DBVsa_strcat(temp_error_buffer, "uDeliveryService.ppsElectronicDelivery[");

			if (index < MAX_INDEX)
                		sprintf(index_buffer, "%d", index);
                	DBVsa_strcat(temp_error_buffer, index_buffer);
                	DBVsa_strcat(temp_error_buffer, "]->");

                	if (DBVcheck_dbv_ill_elecdeliv(lAssocId, psDeliveryService->uDeliveryService.ppsElectronicDelivery[index], temp_error_buffer, ppsSIError) == SI_NOTOK)
                        	return SI_NOTOK;
                	index++;
        	}
		break;
	default:
                DBVsa_strcat(local_error_buffer, "eDeliveryServiceType");
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
		break;
	}

	return SI_OK;
}



int DBVcheck_dbv_ill_elecdeliv(DbvAssocId lAssocId, DbvElectronicDeliveryService *psElectronicDelivery, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);


	/* NOTE: no direct dbv -> snacc mapping */
	/* o */
	if (psElectronicDelivery->psDeliveryParameter != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psDeliveryParameter->");

		if (DBVcheck_dbv_ill_delivparam(lAssocId, psElectronicDelivery->psDeliveryParameter, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }



	/* o */

	if (psElectronicDelivery->psDocumentTypeParameter != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psDocumentTypeParameter->");

		if (DBVcheck_dbv_ill_doctypeparam(lAssocId, psElectronicDelivery->psDocumentTypeParameter, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	
	/* o */
	if (psElectronicDelivery->psDeliveryDescription != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psDeliveryDescription->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psElectronicDelivery->psDeliveryDescription, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }



	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "sDeliveryDetails.");

	if (DBVcheck_dbv_ill_eldelivdet(lAssocId, &psElectronicDelivery->sDeliveryDetails, temp_error_buffer, ppsSIError) == SI_NOTOK)
		return SI_NOTOK;
        

	/* o */
	if (psElectronicDelivery->psNameOrCode != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psNameOrCode->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psElectronicDelivery->psNameOrCode, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */

	return SI_OK;
}


int DBVcheck_dbv_ill_delivparam(DbvAssocId lAssocId, DbvElDeliveryParameter *psDeliveryParameter, char *error_buffer, DbvError **ppsSIError)
{

	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];


	/* If this point is reached, psDeliveryParameter is != NULL and the
	   service user wants to use the DbvExternal */

	/* According to the ASN.1 (illasn96.txt) :
	   1) We can have an optional e-delivery-mode OBJECT IDENTIFIER
	   2) We can have an optional e-delivery-parameters ANY. If we want 
	      this ANY then it is encoded/decoded using
              e-delivery-mode. Hence if e-delivery-parameters != NULL,
              e-delivery-mode MUST NOT BE NULL to allow us to
	      encode and decode.	
	*/


        DBVsa_strcpy(local_error_buffer, error_buffer);
	
	/* If the external is not NULL but the object identifier is */
	if (psDeliveryParameter->puDeliveryParameter != NULL)
      		if (psDeliveryParameter->puDeliveryParameter->psDummy != NULL) {
			if (psDeliveryParameter->pcDeliveryMode == NULL) {
				DBVsa_strcat(local_error_buffer, "pcDeliveryMode (required for encoding psDeliveryParameter->puDeliveryParameter->psDummy)");
          			return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
			}


			/* At this point we've got an external and an oid to encode/decode it
	   		   by - right. Now check the external */	

			DBVsa_strcpy(temp_error_buffer, local_error_buffer);
			DBVsa_strcat(temp_error_buffer, "puDeliveryParameter->psDummy->");

			return(DBVcheck_dbv_disjoint(lAssocId, psDeliveryParameter->puDeliveryParameter->psDummy->eValueType, psDeliveryParameter->puDeliveryParameter->psDummy, temp_error_buffer, ppsSIError));
		}

	return SI_OK;
}




int DBVcheck_dbv_disjoint(DbvAssocId lAssocId, DbvExternalValueType eValueType, DbvASN1External *psDummy, char *error_buffer, DbvError **ppsSIError)
{

	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];


        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* We can only have a single ASN.1 type external here
	   so check that eValueType is EVT_SingleASN1Type 
	   Function check_external() will check if
	   the SingleASN1Type external is valid */


        DBVsa_strcpy(temp_error_buffer, local_error_buffer);
        DBVsa_strcat(temp_error_buffer, "eValueType MUST BE EVT_SingleASN1Type");
	if (eValueType != EVT_SingleASN1Type)
       		return (DBVdbv_general_error(lAssocId, temp_error_buffer, ppsSIError));


	/* Now do normal external checking */
	if (DBVcheck_dbv_external(lAssocId, psDummy, local_error_buffer, ppsSIError) == SI_NOTOK)
		return SI_NOTOK;

	return SI_OK;
}




int DBVcheck_dbv_ill_doctypeparam(DbvAssocId lAssocId, DbvDocumentTypeParameter *psDocumentTypeParameter, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        /* If this point is reached, psDocumentTypeParameter is != NULL and the
           service user wants to use the DbvExternal */

        /* According to the ASN.1 (illasn96.txt) :
           1) We can have an optional document-type-id OBJECT IDENTIFIER
           2) We can have an optional document-type-parameters ANY. If we want
              this ANY then it is encoded/decoded using
              document-type-id. Hence if document-type-parameters != NULL,
              document-type-id MUST NOT BE NULL to allow us to
              encode and decode.
        */


	DBVsa_strcpy(local_error_buffer, error_buffer);

	/* If the external is not NULL but the object identifier is */
      	if (psDocumentTypeParameter->puDocumentTypeParameter != NULL) 
		if (psDocumentTypeParameter->puDocumentTypeParameter->psDummy != NULL) {
			if (psDocumentTypeParameter->pcDocumentTypeId == NULL) {
				DBVsa_strcat(local_error_buffer, "pcDocumentTypeId (required for encoding psDocumentTypeParameter->puDocumentTypeParameter->psDummy) ");
          		return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
			}


			/* At this point we've got an external and an oid to encode/decode it
	   		   by - right. Now check the external */	

			DBVsa_strcpy(temp_error_buffer, local_error_buffer);
			DBVsa_strcat(temp_error_buffer, "puDocumentTypeParameter->psDummy->");

			return(DBVcheck_dbv_disjoint(lAssocId, psDocumentTypeParameter->puDocumentTypeParameter->psDummy->eValueType, psDocumentTypeParameter->puDocumentTypeParameter->psDummy, temp_error_buffer, ppsSIError));
		}


	return SI_OK;
}



int DBVcheck_dbv_ill_eldelivdet(DbvAssocId lAssocId, DbvElDeliveryDetails *psDeliveryDetails, char *error_buffer, DbvError **ppsSIError)
{
	int index = 0;
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];
	char index_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	
	switch (psDeliveryDetails->eDeliveryDetailsType) {
	case DDT_SystemAddress:

		DBVsa_strcat(local_error_buffer, "uDeliveryDetails.psSystemAddress");
       		if (psDeliveryDetails->uDeliveryDetails.psSystemAddress == NULL) 
              		return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
		

		DBVsa_strcat(local_error_buffer, "->");
		if (DBVcheck_dbv_ill_sysaddr(lAssocId, psDeliveryDetails->uDeliveryDetails.psSystemAddress, local_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
		break;
	case DDT_SystemId:

		DBVsa_strcat(local_error_buffer, "uDeliveryDetails.psSystemId");
	       	if (psDeliveryDetails->uDeliveryDetails.psSystemId == NULL) 
       		       	return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));


		DBVsa_strcat(local_error_buffer, "->");
		if (DBVcheck_dbv_ill_systemid(lAssocId, psDeliveryDetails->uDeliveryDetails.psSystemId, local_error_buffer, ppsSIError) == SI_NOTOK)
                       	return SI_NOTOK;
		break;
	default:
		DBVsa_strcat(local_error_buffer, "eDeliveryDetailsType");
		return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
	}

	return SI_OK;
}



int DBVcheck_dbv_ill_sysaddr(DbvAssocId lAssocId, DbvSystemAddress *psSystemAddress, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);
	
	/* o */
	if (psSystemAddress->psTelecomServiceIdentifier != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psTelecomServiceIdentifier->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psSystemAddress->psTelecomServiceIdentifier, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	

	/* o */
	if (psSystemAddress->psTelecomServiceAddress != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psTelecomServiceAddress->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psSystemAddress->psTelecomServiceAddress, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }



	return SI_OK;
}



int DBVcheck_dbv_ill_servtype(DbvAssocId lAssocId, DbvServiceType *peServiceType, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);
	
	if (DBVcheck_dbv_enum(*peServiceType, ST_Loan, ST_ResponderSpecific) == SI_NOTOK) {
                DBVsa_strcat(local_error_buffer, "peServiceType");
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
        }
	

	return SI_OK;
}


int DBVcheck_dbv_ill_reqoptmsg(DbvAssocId lAssocId, DbvRequesterOptionalMessages *psRequesterOptionalMessages, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);


	/* c */

	if (DBVcheck_dbv_bool(psRequesterOptionalMessages->fCanSendReceived) == SI_NOTOK) {
                DBVsa_strcat(local_error_buffer, "fCanSendReceived");
                return(DBVdbv_bool_error(lAssocId, local_error_buffer, ppsSIError));
        }


	/* c */
	if (DBVcheck_dbv_bool(psRequesterOptionalMessages->fCanSendReturned) == SI_NOTOK) {
                DBVsa_strcat(local_error_buffer, "fCanSendReturned");
                return(DBVdbv_bool_error(lAssocId, local_error_buffer, ppsSIError));
        }

	/* c */
	if (DBVcheck_dbv_enum(psRequesterOptionalMessages->eRequesterShipped, OMR_Requires, OMR_Neither) == SI_NOTOK) {
                DBVsa_strcat(local_error_buffer, "eRequesterShipped");
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
        }
	

	/* c */
	if (DBVcheck_dbv_enum(psRequesterOptionalMessages->eRequesterCheckedIn, OMR_Requires, OMR_Neither) == SI_NOTOK) {
                DBVsa_strcat(local_error_buffer, "eRequesterCheckedIn");
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
        }
	

	return SI_OK;
}



int DBVcheck_dbv_ill_srchtype(DbvAssocId lAssocId, DbvSearchType *psSearchType, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* o */
	if (psSearchType->psLevelOfService != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psLevelOfService->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psSearchType->psLevelOfService, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* o */
	/* no checking needed */

	
	/* default so optional */
	if (psSearchType->peExpiryFlag) {

		if (DBVcheck_dbv_enum(*psSearchType->peExpiryFlag, EXP_NeedBeforeDate, EXP_NoExpiry) == SI_NOTOK) {
               		DBVsa_strcat(local_error_buffer, "peExpiryFlag");
                	return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
        	}
	}

	/* o */
	/* no checking needed */

	return SI_OK;
}



int DBVcheck_dbv_ill_suppmedinfo(DbvAssocId lAssocId, DbvSupplyMediumInfo *psSupplyMediumInfo, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* c */
	if (DBVcheck_dbv_enum(psSupplyMediumInfo->eSupplyMediumType, SMT_Printed, SMT_Other) == SI_NOTOK) {
                DBVsa_strcat(local_error_buffer, "eSupplyMediumType");
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
        }

	/* o */
	if (psSupplyMediumInfo->psMediumCharacteristics != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psMediumCharacteristics->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psSupplyMediumInfo->psMediumCharacteristics, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	return SI_OK;
}



int DBVcheck_dbv_ill_placehold(DbvAssocId lAssocId, DbvPlaceOnHold *pePlaceOnHold, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* c */
	if (DBVcheck_dbv_enum(*pePlaceOnHold, POH_Yes, POH_ResponderPolicy) == SI_NOTOK) 
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
        
	
	
	return SI_OK;
}



int DBVcheck_dbv_ill_clientid(DbvAssocId lAssocId, DbvClientId *psClientId, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* o */
	if (psClientId->psClientName != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psClientName->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psClientId->psClientName, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */
	if (psClientId->psClientStatus != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psClientStatus->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psClientId->psClientStatus, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }



	/* o */
	if (psClientId->psClientIdentifier != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psClientIdentifier->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psClientId->psClientIdentifier, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	
	return SI_OK;
}


int DBVcheck_dbv_ill_itemid(DbvAssocId lAssocId, DbvItemId *psItemId, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* o */
	if (psItemId->peItemType != NULL) 
		if (DBVcheck_dbv_enum(*psItemId->peItemType, SMT_Printed, SMT_Other) == SI_NOTOK) {
                	DBVsa_strcat(local_error_buffer, "peItemType");
                	return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
        	}
	

	/* o */
	if (psItemId->peMediumType != NULL) 
		if (DBVcheck_dbv_enum(*psItemId->peMediumType, MT_Printed, MT_Other) == SI_NOTOK) {
                	DBVsa_strcat(local_error_buffer, "peMediumType");
                	return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
        	}
	
	
	/* o */
	if (psItemId->psCallNumber != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psCallNumber->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psItemId->psCallNumber, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* o */
	if (psItemId->psAuthor != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psAuthor->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psItemId->psAuthor, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	

	
	/* o */
	if (psItemId->psTitle != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psTitle->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psItemId->psTitle, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	
	/* o */
	if (psItemId->psSubTitle != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psSubTitle->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psItemId->psSubTitle, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* o */
	if (psItemId->psSponsoringBody != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psSponsoringBody->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psItemId->psSponsoringBody, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* o */
	if (psItemId->psPlaceOfPublication != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psPlaceOfPublication->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psItemId->psPlaceOfPublication, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* o */
	if (psItemId->psPublisher != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psPublisher->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psItemId->psPublisher, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* o */
	if (psItemId->psSeriesTitleNumber != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psSeriesTitleNumber->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psItemId->psSeriesTitleNumber, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* o */
	if (psItemId->psVolumeIssue != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psVolumeIssue->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psItemId->psVolumeIssue, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* o */
	if (psItemId->psEdition != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psEdition->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psItemId->psEdition, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* o */
	if (psItemId->psPublicationDate != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psPublicationDate->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psItemId->psPublicationDate, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* o */
	if (psItemId->psPublicationDateOfComponent != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psPublicationDateOfComponent->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psItemId->psPublicationDateOfComponent, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* o */
	if (psItemId->psAuthorOfArticle != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psAuthorOfArticle->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psItemId->psAuthorOfArticle, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* o */
	if (psItemId->psTitleOfArticle != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psTitleOfArticle->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psItemId->psTitleOfArticle, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* o */
	if (psItemId->psPagination != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psPagination->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psItemId->psPagination, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* o */
	if (psItemId->psNationalBibliographyNo != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psNationalBibliographyNo->");

		if (DBVcheck_dbv_external(lAssocId, psItemId->psNationalBibliographyNo, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	
	/* o */
	if (psItemId->psIsbn != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psIsbn->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psItemId->psIsbn, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* o */
	if (psItemId->psIssn != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psIssn->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psItemId->psIssn, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* o */
	if (psItemId->psSystemNo != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psSystemNo->");

		if (DBVcheck_dbv_external(lAssocId, psItemId->psSystemNo, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* o */
	if (psItemId->psAdditionalNoLetters != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psAdditionalNoLetters->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psItemId->psAdditionalNoLetters, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	/* o */
	
	return SI_OK;
}



int DBVcheck_dbv_ill_costinfo(DbvAssocId lAssocId, DbvCostInfo *psCostInfo, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);
	
	/* o */
	if (psCostInfo->psAccountNumber != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psAccountNumber->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psCostInfo->psAccountNumber, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */
	if (psCostInfo->psMaximumCost != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psMaximumCost->");

		if (DBVcheck_dbv_ill_amount(lAssocId, psCostInfo->psMaximumCost, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* default so optional */
       	if (psCostInfo->pfReciprocalAgreement) {

        	if (DBVcheck_dbv_bool(*psCostInfo->pfReciprocalAgreement) == SI_NOTOK) {
			DBVsa_strcat(local_error_buffer, "pfReciprocalAgreement");
			return(DBVdbv_bool_error(lAssocId, local_error_buffer, ppsSIError));
		}
	}


	/* default so optional */
       	if (psCostInfo->pfWillPayFee) {
        	if (DBVcheck_dbv_bool(*psCostInfo->pfWillPayFee) == SI_NOTOK) {
			DBVsa_strcat(local_error_buffer, "pfWillPayFee");
			return(DBVdbv_bool_error(lAssocId, local_error_buffer, ppsSIError));
		}
	}	


	/* default so optional */
       	if (psCostInfo->pfPaymentProvided) {
        	if (DBVcheck_dbv_bool(*psCostInfo->pfPaymentProvided) == SI_NOTOK) {
			DBVsa_strcat(local_error_buffer, "pfPaymentProvided");
			return(DBVdbv_bool_error(lAssocId, local_error_buffer, ppsSIError));
		}
	}


	return SI_OK;
}



int DBVcheck_dbv_ill_amount(DbvAssocId lAssocId, DbvAmount *psMaximumCost, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	
	/* o */


	/* c */
       	if (psMaximumCost->pcMonetaryValue == NULL) {
		DBVsa_strcat(local_error_buffer, "pcMonetaryValue");
              	return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
	}



	return SI_OK;
}



int DBVcheck_dbv_ill_illstring(DbvAssocId lAssocId, DbvIllString *psCopyrightCompliance, char *error_buffer, DbvError **ppsSIError) 
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	
	/* No more checking required than seeing if compulsory strings are 
	   NULL */

	switch (psCopyrightCompliance->eStringType) {
	case ST_GeneralString:
		DBVsa_strcat(local_error_buffer, "uString.psGeneralString");
       		if (psCopyrightCompliance->uString.psGeneralString == NULL) 
              		return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
		break;
	case ST_EdifactString:
		DBVsa_strcat(local_error_buffer, "uString.pcVisibleString");
       		if (psCopyrightCompliance->uString.pcVisibleString == NULL) 
       	       		return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
		break;
	default:
                DBVsa_strcat(local_error_buffer, "eStringType");
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));

		break;
	}


	return SI_OK;
}
 

int DBVcheck_dbv_ill_thirdparty(DbvAssocId lAssocId, DbvThirdPartyInfo *psThirdPartyInfo, char *error_buffer, DbvError **ppsSIError)
{
	int index = 0;
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];
	char index_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* default so optional */
       	if (psThirdPartyInfo->pfPermissionToForward) {
        	if (DBVcheck_dbv_bool(*psThirdPartyInfo->pfPermissionToForward) == SI_NOTOK) {
			DBVsa_strcat(local_error_buffer, "pfPermissionToForward");
			return(DBVdbv_bool_error(lAssocId, local_error_buffer, ppsSIError));
		}
	}
	

	/* default so optional */
       	if (psThirdPartyInfo->pfPermissionToChain) {
        	if (DBVcheck_dbv_bool(*psThirdPartyInfo->pfPermissionToChain) == SI_NOTOK) {
			DBVsa_strcat(local_error_buffer, "pfPermissionToChain");
			return(DBVdbv_bool_error(lAssocId, local_error_buffer, ppsSIError));
		}
	}


	/* default so optional */
       	if (psThirdPartyInfo->pfPermissionToPartition) {
        	if (DBVcheck_dbv_bool(*psThirdPartyInfo->pfPermissionToPartition) == SI_NOTOK) {
			DBVsa_strcat(local_error_buffer, "pfPermissionToPartition");
			return(DBVdbv_bool_error(lAssocId, local_error_buffer, ppsSIError));
		}
	}

	
	/* default so optional */
       	if (psThirdPartyInfo->pfPermissionToChangeSendToList) {
        	if (DBVcheck_dbv_bool(*psThirdPartyInfo->pfPermissionToChangeSendToList) == SI_NOTOK) {
			DBVsa_strcat(local_error_buffer, "pfPermissionToChangeSendToList");
			return(DBVdbv_bool_error(lAssocId, local_error_buffer, ppsSIError));
		}
	}


	/* o */
	if (psThirdPartyInfo->psInitialRequesterAddress != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psInitialRequesterAddress->");

		if (DBVcheck_dbv_ill_sysaddr(lAssocId, psThirdPartyInfo->psInitialRequesterAddress, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

		

	/* default so optional */
       	if (psThirdPartyInfo->pePreference) {
	
		DBVsa_strcpy(temp_error_buffer, "*");
		DBVsa_strcat(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "pePreference");
		if (DBVcheck_dbv_enum(*psThirdPartyInfo->pePreference, PRE_Ordered, PRE_Unordered) == SI_NOTOK) {
                	return(DBVdbv_invalid_enum_error(lAssocId, temp_error_buffer, ppsSIError));
        	}
	}


	/* o */
	if (psThirdPartyInfo->ppsSendToList) {
		index = 0;
       		while (psThirdPartyInfo->ppsSendToList[index] != NULL) {
	
               		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
               		DBVsa_strcat(temp_error_buffer, "ppsSendToList[");

			if (index < MAX_INDEX)
               			sprintf(index_buffer, "%d", index);
               		DBVsa_strcat(temp_error_buffer, index_buffer);
               		DBVsa_strcat(temp_error_buffer, "]->");
	
               		if (DBVcheck_dbv_ill_sendtolist(lAssocId, psThirdPartyInfo->ppsSendToList[index], temp_error_buffer, ppsSIError) == SI_NOTOK)
                       		return SI_NOTOK;
               		index++;
       		}
	}


	/* o */
	if (psThirdPartyInfo->ppsAlreadyTriedList) {
		index = 0;
       		while (psThirdPartyInfo->ppsAlreadyTriedList[index] != NULL) {
	
               		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
               		DBVsa_strcat(temp_error_buffer, "ppsAlreadyTriedList[");

			if (index < MAX_INDEX)
               			sprintf(index_buffer, "%d", index);
               		DBVsa_strcat(temp_error_buffer, index_buffer);
               		DBVsa_strcat(temp_error_buffer, "]->");
	
               		if (DBVcheck_dbv_ill_systemid(lAssocId, psThirdPartyInfo->ppsAlreadyTriedList[index], temp_error_buffer, ppsSIError) == SI_NOTOK)
                       		return SI_NOTOK;
               		index++;
       		}
	}
	
	return SI_OK;
}




int DBVcheck_dbv_ill_sendtolist(DbvAssocId lAssocId, DbvSendToList *psSendToList, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);
	
	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "sSystemId.");
	if (DBVcheck_dbv_ill_systemid(lAssocId, &psSendToList->sSystemId, temp_error_buffer, ppsSIError) == SI_NOTOK)
		return SI_NOTOK;

	/* o */
	if (psSendToList->psAccountNumber != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psAccountNumber->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psSendToList->psAccountNumber, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */
	if (psSendToList->psSystemAddress != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psSystemAddress->");

		if (DBVcheck_dbv_ill_sysaddr(lAssocId, psSendToList->psSystemAddress, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

		

	return SI_OK;

	
}



int DBVcheck_dbv_ill_extension(DbvAssocId lAssocId, DbvExtension *psRequestExtension, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	
	/* default so optional */
	if (psRequestExtension->pfCritical) {
		DBVsa_strcpy(temp_error_buffer, "*");
		DBVsa_strcat(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "pfCritical");
        	if (DBVcheck_dbv_bool(*psRequestExtension->pfCritical) == SI_NOTOK) 
			return(DBVdbv_bool_error(lAssocId, temp_error_buffer, ppsSIError));
	}

	
	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "uItem.");

	/* pass psRequestExtension in so that we can access the union ok */
	if (DBVcheck_dbv_extension_uitem(lAssocId, psRequestExtension->ulIdentifier, psRequestExtension, temp_error_buffer, ppsSIError) == SI_NOTOK) 
		return SI_NOTOK;
	
	return SI_OK;
}



int DBVcheck_dbv_extension_uitem(DbvAssocId lAssocId, Ulong ulIdentifier, DbvExtension *psDbvExtension, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

	DBVsa_strcpy(local_error_buffer, error_buffer);
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);

	switch (ulIdentifier) {

/***************
 No longer used

	case INTMAPTEST:
		DBVsa_strcat(temp_error_buffer, "psDummy");
       		if (uItem.psDummy == NULL) 
              		return (DBVdbv_field_missing_error(lAssocId, temp_error_buffer, ppsSIError));
		DBVcheck_at_intmaptest(lAssocId, DbvSingleASN1Type *psSingleASN1Type, char *oid, temp_error_buffer, ppsSIError)
		break;
************/

	case SUBITO_ADDITIONAL_INFO:
		DBVsa_strcat(temp_error_buffer, "psAddIllReqInfo");
		if (psDbvExtension->uItem.psAddIllReqInfo == NULL)
            		return (DBVdbv_field_missing_error(lAssocId, temp_error_buffer, ppsSIError));

		DBVsa_strcat(temp_error_buffer, "->");
 		return(DBVcheck_dbv_extension_subito(lAssocId, psDbvExtension->uItem.psAddIllReqInfo, temp_error_buffer, ppsSIError));

		break;

	default:
                DBVsa_strcat(local_error_buffer, "ulIdentifier");
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));

		break;
	}

	return SI_OK;
}



/*********************
 No longer used

int DBVcheck_at_intmaptest(DbvAssocId lAssocId, DbvSingleASN1Type *psSingleASN1Type, char *error_buffer, DbvError **ppsSIError)
{

        char local_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

        DBVsa_strcat(local_error_buffer, "uASN1.psIntMapTest");
        if (psSingleASN1Type->uASN1.psIntMapTest == NULL)
                return(DBVdbv_field_missing_error(lAssocId, local_error_buffer,
ppsSIError));

	DBVsa_strcat(local_error_buffer, "->");
	return(DBVcheck_dbv_intmap(lAssocId, psSingleASN1Type->uASN1.psIntMapTest, local_error_buffer, ppsSIError));
}



int DBVcheck_dbv_intmap(DbvAssocId lAssocId, DbvIntMapTest *psIntMapTest, char *error_buffer, DbvError **ppsSIError)
{
        char local_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);


	switch (psIntMapTest->eIntMapTestType) {
	case IMT_FirstString:
		DBVsa_strcat(local_error_buffer, "uIntMapTest.psFirstString");
                if (psIntMapTest->uIntMapTest.psFirstString == NULL)
                        return(DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
                break;
	case IMT_SecondString:
		DBVsa_strcat(local_error_buffer, "uIntMapTest.psSecondString");
                if (psIntMapTest->uIntMapTest.psSecondString == NULL)
                        return(DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));

		break;
	default:
		DBVsa_strcat(local_error_buffer, "eIntMapTestType");
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
                break;
	}

	return SI_OK;
}

*********************/



int DBVcheck_dbv_extension_subito(DbvAssocId lAssocId, DbvSubitoAdditionalInfo *psAddIllReqInfo, char *error_buffer, DbvError **ppsSIError)
{
	
        char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);


	/* default so optional */
	if (psAddIllReqInfo->pfCustomerInfoToKeep) {
        	if (DBVcheck_dbv_bool(*psAddIllReqInfo->pfCustomerInfoToKeep) == SI_NOTOK) {
			DBVsa_strcpy(temp_error_buffer, "*");
			DBVsa_strcat(temp_error_buffer, local_error_buffer);
			DBVsa_strcat(temp_error_buffer, "pfCustomerInfoToKeep");
	
			return(DBVdbv_bool_error(lAssocId, temp_error_buffer, ppsSIError));
		}
	}
	
	/* o */
	if (psAddIllReqInfo->psAddRequesterInfo) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psAddRequesterInfo->");
		if (DBVcheck_dbv_addrequesterinfo(lAssocId, psAddIllReqInfo->psAddRequesterInfo, temp_error_buffer, ppsSIError) == SI_NOTOK)
			return SI_NOTOK;
	}


	/* o */
	if (psAddIllReqInfo->psAddDeliveryInfo) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psAddDeliveryInfo->");
		if (DBVcheck_dbv_adddeliveryinfo(lAssocId, psAddIllReqInfo->psAddDeliveryInfo, temp_error_buffer, ppsSIError) == SI_NOTOK)
			return SI_NOTOK;
	}


	/* o */
	if (psAddIllReqInfo->psAddBillingInfo) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psAddBillingInfo->");
		if (DBVcheck_dbv_addbillinginfo(lAssocId, psAddIllReqInfo->psAddBillingInfo, temp_error_buffer, ppsSIError) == SI_NOTOK)
			return SI_NOTOK;
	}

	return SI_OK;
}



int DBVcheck_dbv_addrequesterinfo(DbvAssocId lAssocId, DbvAddRequesterInfo *psAddRequesterInfo, char *error_buffer, DbvError **ppsSIError)
{
        char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);


	/* default so optional */
	if (psAddRequesterInfo->peRequesterGroup) {
		if (DBVcheck_dbv_enum(*psAddRequesterInfo->peRequesterGroup, RG_UserGroup1, RG_UserGroup2) == SI_NOTOK) {
			DBVsa_strcpy(temp_error_buffer, "*");
			DBVsa_strcat(temp_error_buffer, local_error_buffer);
			DBVsa_strcat(temp_error_buffer, "peRequesterGroup");
               	 return(DBVdbv_invalid_enum_error(lAssocId, temp_error_buffer, ppsSIError));
		}
	}


	/* o */
	/* No need to check visible string here */
	
	return SI_OK;
}



int DBVcheck_dbv_adddeliveryinfo(DbvAssocId lAssocId, DbvAddDeliveryInfo *psAddDeliveryInfo, char *error_buffer, DbvError **ppsSIError)
{
	
        char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);
	
	/* default so optioanl */
	if (psAddDeliveryInfo->peStatusLevelUser) {
		if (DBVcheck_dbv_enum(*psAddDeliveryInfo->peStatusLevelUser, SLU_All, SLU_None) == SI_NOTOK) {
        		DBVsa_strcpy(temp_error_buffer, "*");
        		DBVsa_strcat(temp_error_buffer, local_error_buffer);
			DBVsa_strcat(temp_error_buffer, "peStatusLevelUser");
               	 return(DBVdbv_invalid_enum_error(lAssocId, temp_error_buffer, ppsSIError));
		}
	}



	/* default so optional */
	if (psAddDeliveryInfo->peStatusLevelOrigin) {
		if (DBVcheck_dbv_enum(*psAddDeliveryInfo->peStatusLevelOrigin, SLO_All, SLO_None) == SI_NOTOK) {
        		DBVsa_strcpy(temp_error_buffer, "*");
        		DBVsa_strcat(temp_error_buffer, local_error_buffer);
			DBVsa_strcat(temp_error_buffer, "peStatusLevelOrigin");
	
       	         	return(DBVdbv_invalid_enum_error(lAssocId, temp_error_buffer, ppsSIError));
		}
	}



	/* pcDeliveryNotes - optional so dont need to check */

	/* pcCountryDeliveryTarget - optional so dont need to check */


	/* default so optional */
	if (psAddDeliveryInfo->pfAlternativePostalDelivery) {
        	if (DBVcheck_dbv_bool(*psAddDeliveryInfo->pfAlternativePostalDelivery) == SI_NOTOK) {
			DBVsa_strcpy(temp_error_buffer, "*");
			DBVsa_strcat(temp_error_buffer, local_error_buffer);
			DBVsa_strcat(temp_error_buffer, "pfAlternativePostalDelivery");
			return(DBVdbv_bool_error(lAssocId, temp_error_buffer, ppsSIError));
		}
	}
	
	

	return SI_OK;
}



int DBVcheck_dbv_addbillinginfo(DbvAssocId lAssocId, DbvAddBillingInfo *psAddBillingInfo, char *error_buffer, DbvError **ppsSIError)
{
        char local_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	switch (psAddBillingInfo->eAddBillingType) {
	case ABT_BankInfo:
		DBVsa_strcat(local_error_buffer, "uAddBillingInfo.psBillingBankInfo");
		if (psAddBillingInfo->uAddBillingInfo.psBillingBankInfo == NULL) 
              		return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
		
		DBVsa_strcat(local_error_buffer, "->");
		if (DBVcheck_dbv_billingbankinfo(lAssocId, psAddBillingInfo->uAddBillingInfo.psBillingBankInfo, local_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;

		break;

	case ABT_CreditCardInfo:
		DBVsa_strcat(local_error_buffer, "uAddBillingInfo.psBillingCreditCardInfo");
		if (psAddBillingInfo->uAddBillingInfo.psBillingCreditCardInfo == NULL) 
              		return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
		
		DBVsa_strcat(local_error_buffer, "->");
		if (DBVcheck_dbv_billingcreditcardinfo(lAssocId, psAddBillingInfo->uAddBillingInfo.psBillingCreditCardInfo, local_error_buffer, ppsSIError) == SI_NOTOK)
			return SI_NOTOK;
		break;

	case ABT_InvoiceType:
		DBVsa_strcat(local_error_buffer, "uAddBillingInfo.eBillingInvoiceType");
		if (DBVcheck_dbv_enum(psAddBillingInfo->uAddBillingInfo.eBillingInvoiceType, BIT_Single, BIT_Collective) == SI_NOTOK) 
                	return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
		break;

	case ABT_PrepaidType:
		DBVsa_strcat(local_error_buffer, "uAddBillingInfo.pcPrepaidId");
		if (psAddBillingInfo->uAddBillingInfo.pcPrepaidId == NULL) 
              		return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
		
		break;
	case ABT_DepositType:
		DBVsa_strcat(local_error_buffer, "uAddBillingInfo.pcDepositId");
		if (psAddBillingInfo->uAddBillingInfo.pcDepositId == NULL) 
              		return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
		
		break;

	default:
                DBVsa_strcat(local_error_buffer, "eAddBillingType");
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
                break;
	}


	return SI_OK;
}



int DBVcheck_dbv_billingbankinfo(DbvAssocId lAssocId, DbvBillingBankInfo *psBillingBankInfo, char *error_buffer, DbvError **ppsSIError)
{
        char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "pcBankAccountHouse");
	if (psBillingBankInfo->pcBankAccountHouse == NULL) {
		return(DBVdbv_field_missing_error(lAssocId, temp_error_buffer, ppsSIError));
		return SI_NOTOK;
	}

	/* c */
        DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "pcBankAccountRoutingSymbol");
	if (psBillingBankInfo->pcBankAccountRoutingSymbol == NULL) {
		return(DBVdbv_field_missing_error(lAssocId, temp_error_buffer, ppsSIError));
		return SI_NOTOK;
	}



	/* c */
        DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "pcBankAccountNo");
	if (psBillingBankInfo->pcBankAccountNo == NULL) {
		return(DBVdbv_field_missing_error(lAssocId, temp_error_buffer, ppsSIError));
		return SI_NOTOK;
	}



	/* c */
        DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "fBankAuthority");
        if (DBVcheck_dbv_bool(psBillingBankInfo->fBankAuthority) == SI_NOTOK) 
		return(DBVdbv_bool_error(lAssocId, temp_error_buffer, ppsSIError));
	
	
	return SI_OK;
}



int DBVcheck_dbv_billingcreditcardinfo(DbvAssocId lAssocId, DbvBillingCreditCardInfo *psBillingCreditCardInfo, char *error_buffer, DbvError **ppsSIError)
{
        char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "pcCardCompany");
	if (psBillingCreditCardInfo->pcCardCompany == NULL) 
		return(DBVdbv_field_missing_error(lAssocId, temp_error_buffer, ppsSIError));
	

	/* c */
        DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "pcCardNo");
	if (psBillingCreditCardInfo->pcCardNo == NULL) {
		return(DBVdbv_field_missing_error(lAssocId, temp_error_buffer, ppsSIError));
		return SI_NOTOK;
	}


	/* ISO_Date are visible strings */

	/* o pcCardValidFrom so dont have to check */
	
	/* c */
        DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "pcCardValidThru");
	if (psBillingCreditCardInfo->pcCardValidThru == NULL) {
		return(DBVdbv_field_missing_error(lAssocId, temp_error_buffer, ppsSIError));
		return SI_NOTOK;
	}

	
	return SI_OK;
}



int DBVcheck_dbv_ill_statorerr(DbvAssocId lAssocId, DbvStatusOrErrorReport *psStatusOrErrorReport, char *error_buffer, DbvError **ppsSIError)
{
	int index = 0;
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];
	char index_buffer[SA_ARRAY_SIZE];


        DBVsa_strcpy(local_error_buffer, error_buffer);

	
	/* c */
	if (DBVcheck_dbv_enum(psStatusOrErrorReport->eProtocolVersion, PV_Version1, PV_Version2) == SI_NOTOK) {
                DBVsa_strcat(local_error_buffer, "eProtocolVersion");
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
        }

	

	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "sTransactionId.");
	if (DBVcheck_dbv_ill_transid(lAssocId, &psStatusOrErrorReport->sTransactionId, temp_error_buffer, ppsSIError) == SI_NOTOK)
		return SI_NOTOK;
      
	
	
	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "sServiceDateTime.");
	if (DBVcheck_dbv_ill_servdatatime(lAssocId, &psStatusOrErrorReport->sServiceDateTime, temp_error_buffer, ppsSIError) == SI_NOTOK)
		return SI_NOTOK;
     
	
	
	/* o */
	if (psStatusOrErrorReport->psRequesterId != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psRequesterId->");

		if (DBVcheck_dbv_ill_systemid(lAssocId, psStatusOrErrorReport->psRequesterId, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */
	if (psStatusOrErrorReport->psResponderId != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psResponderId->");

		if (DBVcheck_dbv_ill_systemid(lAssocId, psStatusOrErrorReport->psResponderId, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */
       	if (psStatusOrErrorReport->peReasonNoReport != NULL) 
		if (DBVcheck_dbv_enum(*psStatusOrErrorReport->peReasonNoReport, RNR_Temporary, RNR_Permanent) == SI_NOTOK) {
                DBVsa_strcpy(temp_error_buffer, "*");
                DBVsa_strcat(temp_error_buffer, local_error_buffer);
                DBVsa_strcat(temp_error_buffer, "peReasonNoReport");
                return(DBVdbv_invalid_enum_error(lAssocId, temp_error_buffer, ppsSIError));
	}
        

	/* o */
	if (psStatusOrErrorReport->psStatusReport != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psStatusReport->");

		if (DBVcheck_dbv_ill_statrep(lAssocId, psStatusOrErrorReport->psStatusReport, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */
	if (psStatusOrErrorReport->psErrorReport != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psErrorReport->");

		if (DBVcheck_dbv_ill_errrep(lAssocId, psStatusOrErrorReport->psErrorReport, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */
	if (psStatusOrErrorReport->psNote != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psNote->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psStatusOrErrorReport->psNote, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */

	if (psStatusOrErrorReport->ppsStOrErReportExtension != NULL) {
		index = 0;
       		while (psStatusOrErrorReport->ppsStOrErReportExtension[index] != NULL) {

               		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
               		DBVsa_strcat(temp_error_buffer, "ppsStOrErReportExtension[");

			if (index < MAX_INDEX)
               			sprintf(index_buffer, "%d", index);
               		DBVsa_strcat(temp_error_buffer, index_buffer);
               		DBVsa_strcat(temp_error_buffer, "]->");

               		if (DBVcheck_dbv_ill_extension(lAssocId, psStatusOrErrorReport->ppsStOrErReportExtension[index], temp_error_buffer, ppsSIError) == SI_NOTOK)
                       		return SI_NOTOK;
               		index++;
       		}
	}

	return SI_OK;


}



int DBVcheck_dbv_ill_statrep(DbvAssocId lAssocId, DbvStatusReport *psStatusReport, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	
	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "sUserStatusReport.");
	if (DBVcheck_dbv_ill_histrep(lAssocId, &psStatusReport->sUserStatusReport, temp_error_buffer, ppsSIError) == SI_NOTOK)
		return SI_NOTOK;
	
	
	/* c */
	if (DBVcheck_dbv_enum(psStatusReport->eProviderStatusReport, CS_NotSupplied, CS_Unknown) == SI_NOTOK) {
		DBVsa_strcat(local_error_buffer, "eProviderStatusReport");
		return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
	}	
        
	

	return SI_OK;
}



int DBVcheck_dbv_ill_histrep(DbvAssocId lAssocId, DbvHistoryReport *psUserStatusReport, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	/* o */
	
	
	/* o */
	if (psUserStatusReport->psAuthor != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psAuthor->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psUserStatusReport->psAuthor, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }



	/* o */
	if (psUserStatusReport->psTitle != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psTitle->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psUserStatusReport->psTitle, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */
	if (psUserStatusReport->psAuthorOfArticle != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psAuthorOfArticle->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psUserStatusReport->psAuthorOfArticle, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* o */
	if (psUserStatusReport->psTitleOfArticle != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psTitleOfArticle->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psUserStatusReport->psTitleOfArticle, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "pcDateOfLastTransition");
	if (psUserStatusReport->pcDateOfLastTransition == NULL)
              	return (DBVdbv_field_missing_error(lAssocId, temp_error_buffer, ppsSIError));



	/* c */
	if (DBVcheck_dbv_enum(psUserStatusReport->eMostRecentService, MRS_IllRequest, MRS_Expired) == SI_NOTOK) {
		DBVsa_strcat(local_error_buffer, "eMostRecentService");
		return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
	}
        
	

	/* c */
       	if (psUserStatusReport->pcDateOfMostRecentService == NULL) {
		DBVsa_strcat(local_error_buffer, "pcDateOfMostRecentService");
              	return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
	}


	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "sSystemId.");

	if (DBVcheck_dbv_ill_systemid(lAssocId, &psUserStatusReport->sSystemId, temp_error_buffer, ppsSIError) == SI_NOTOK)
		return SI_NOTOK;
	


	/* o */
	if (psUserStatusReport->peShippedServiceType != NULL) 
		if (DBVcheck_dbv_enum(*psUserStatusReport->peShippedServiceType, SST_Loan, SST_CopyNonReturnable) == SI_NOTOK) {
			DBVsa_strcpy(temp_error_buffer, "*");
			DBVsa_strcat(temp_error_buffer, local_error_buffer);
			DBVsa_strcat(temp_error_buffer, "peShippedServiceType");
			return(DBVdbv_invalid_enum_error(lAssocId, temp_error_buffer, ppsSIError));
		}
        
	

	/* o */
	if (psUserStatusReport->peTransactionResults != NULL) 
		if (DBVcheck_dbv_enum(*psUserStatusReport->peTransactionResults, TR_Conditional, TR_Estimate) == SI_NOTOK) {
			DBVsa_strcpy(temp_error_buffer, "*");
			DBVsa_strcat(temp_error_buffer, local_error_buffer);
			DBVsa_strcat(temp_error_buffer, "peTransactionResults");
			return(DBVdbv_invalid_enum_error(lAssocId, temp_error_buffer, ppsSIError));
		}
        
	

	/* o */
	if (psUserStatusReport->psMostRecentServiceNote != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psMostRecentServiceNote->");

		if (DBVcheck_dbv_ill_illstring(lAssocId, psUserStatusReport->psMostRecentServiceNote, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }


	return SI_OK;
}



int DBVcheck_dbv_ill_errrep(DbvAssocId lAssocId, DbvErrorReport *psErrorReport, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	
	/* No direct mapping here - bichin */

	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "sCorrelationInfo.");
	if (DBVcheck_dbv_ill_illstring(lAssocId, &psErrorReport->sCorrelationInfo, temp_error_buffer, ppsSIError) == SI_NOTOK)
		return SI_NOTOK;
	

	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "sReport.");
	if (DBVcheck_dbv_ill_userorproverrrep(lAssocId, &psErrorReport->sReport, temp_error_buffer, ppsSIError) == SI_NOTOK)
		return SI_NOTOK;
	

	return SI_OK;
}



int DBVcheck_dbv_ill_userorproverrrep(DbvAssocId lAssocId, DbvUserOrProviderErrorReport *psReport, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);
	
	switch (psReport->eReportSource) {
	case RS_User:
		DBVsa_strcat(local_error_buffer, "uReport.psUserErrorReport");
		if (psReport->uReport.psUserErrorReport == NULL) 
              		return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
		

		DBVsa_strcat(local_error_buffer, "->");
		if (DBVcheck_dbv_ill_usererrrep(lAssocId, psReport->uReport.psUserErrorReport, local_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
		break;
	case RS_Provider:
		DBVsa_strcat(local_error_buffer, "uReport.psProviderErrorReport");
		if (psReport->uReport.psProviderErrorReport == NULL) 
              		return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
		

		DBVsa_strcat(local_error_buffer, "->");
		if (DBVcheck_dbv_ill_proverrrep(lAssocId, psReport->uReport.psProviderErrorReport, local_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
		break;
	default:
                DBVsa_strcat(local_error_buffer, "eReportSource");
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
                break;
	}

	
	return SI_OK;
}



int DBVcheck_dbv_ill_usererrrep(DbvAssocId lAssocId, DbvUserErrorReport *psUserErrorReport, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	switch (psUserErrorReport->eReportType) {
	case UER_AlreadyForwarded:
		DBVsa_strcat(local_error_buffer, "uUserErrorReport.psAlreadyForwarded");
		if (psUserErrorReport->uUserErrorReport.psAlreadyForwarded == NULL) 
              		return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
		

		DBVsa_strcat(local_error_buffer, "->");
		if (DBVcheck_dbv_ill_alreadyfor(lAssocId, psUserErrorReport->uUserErrorReport.psAlreadyForwarded, local_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
		break;
	case UER_IntermediaryProblem:
		DBVsa_strcat(local_error_buffer, "uUserErrorReport.eIntermediaryProblem");
		if (DBVcheck_dbv_enum(psUserErrorReport->uUserErrorReport.eIntermediaryProblem, IP_CannotSendOnward, IP_CannotSendOnward ) == SI_NOTOK) 
			return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
		break;
	case UER_SecurityProblem:
		DBVsa_strcat(local_error_buffer, "uUserErrorReport.psSecurityProblem");
		if (psUserErrorReport->uUserErrorReport.psSecurityProblem == NULL) 
              		return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
		
		DBVsa_strcat(local_error_buffer, "->");
		if (DBVcheck_dbv_ill_illstring(lAssocId, psUserErrorReport->uUserErrorReport.psSecurityProblem, local_error_buffer, ppsSIError) == SI_NOTOK)
                       		return SI_NOTOK;
        	
		break;
	case UER_UnableToPerform:
		DBVsa_strcat(local_error_buffer, "uUserErrorReport.eUnableToPerform");
		if (DBVcheck_dbv_enum(psUserErrorReport->uUserErrorReport.eUnableToPerform, UTP_NotAvailable, UTP_Other ) == SI_NOTOK) 
			return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
		break;
	default:
                DBVsa_strcat(local_error_buffer, "eReportType");
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
		break;
	}

	
	return SI_OK;
}


int DBVcheck_dbv_ill_alreadyfor(DbvAssocId lAssocId, DbvAlreadyForwarded *psAlreadyForwarded, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	
	/* c */
	DBVsa_strcpy(temp_error_buffer, local_error_buffer);
	DBVsa_strcat(temp_error_buffer, "sResponderId.");
	if (DBVcheck_dbv_ill_systemid(lAssocId, &psAlreadyForwarded->sResponderId, temp_error_buffer, ppsSIError) == SI_NOTOK)
		return SI_NOTOK;
	

	/* o */
	if (psAlreadyForwarded->psResponderAddress != NULL) {
		DBVsa_strcpy(temp_error_buffer, local_error_buffer);
		DBVsa_strcat(temp_error_buffer, "psResponderAddress->");

		if (DBVcheck_dbv_ill_sysaddr(lAssocId, psAlreadyForwarded->psResponderAddress, temp_error_buffer, ppsSIError) == SI_NOTOK)
                        return SI_NOTOK;
        }

	
	return SI_OK;
}



int DBVcheck_dbv_ill_proverrrep(DbvAssocId lAssocId, DbvProviderErrorReport *psProviderErrorReport, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	switch (psProviderErrorReport->eReportType) {
	case PER_GeneralProblem:
		DBVsa_strcat(local_error_buffer, "uProviderErrorReport.eGeneralProblem");
		if (DBVcheck_dbv_enum(psProviderErrorReport->uProviderErrorReport.eGeneralProblem, GP_UnrecognizedAPDU, GP_Other ) == SI_NOTOK) 
			return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
		break;

	case PER_TransactionIdProblem:
		DBVsa_strcat(local_error_buffer, "uProviderErrorReport.eTransactionIdProblem");
		if (DBVcheck_dbv_enum(psProviderErrorReport->uProviderErrorReport.eTransactionIdProblem, TIP_DuplicateTransactionId, TIP_UnknownTransactionId ) == SI_NOTOK) 
			return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
		break;

	case PER_StateTransitionProhibited:
		DBVsa_strcat(local_error_buffer, "uProviderErrorReport.psStateTransitionProblem");
		if (psProviderErrorReport->uProviderErrorReport.psStateTransitionProblem == NULL) 
              		return (DBVdbv_field_missing_error(lAssocId, local_error_buffer, ppsSIError));
		
		DBVsa_strcat(local_error_buffer, "->");
		if (DBVcheck_dbv_ill_statetrans(lAssocId, psProviderErrorReport->uProviderErrorReport.psStateTransitionProblem, local_error_buffer, ppsSIError) == SI_NOTOK)
                       	return SI_NOTOK;
        	
		break;
	default:
                DBVsa_strcat(local_error_buffer, "eReportType");
                return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
		break;
	}
	
	return SI_OK;
}



int DBVcheck_dbv_ill_statetrans(DbvAssocId lAssocId, DbvStateTransitionProhibited *psStateTransitionProblem, char *error_buffer, DbvError **ppsSIError)
{
	char local_error_buffer[SA_ARRAY_SIZE];
        char temp_error_buffer[SA_ARRAY_SIZE];

        DBVsa_strcpy(local_error_buffer, error_buffer);

	
	/* c */
	if (DBVcheck_dbv_enum(psStateTransitionProblem->eAPDUType, IAT_IllRequest, IAT_Expired ) == SI_NOTOK) {
		DBVsa_strcat(local_error_buffer, "eAPDUType");
		return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
	}

	/* c */
	if (DBVcheck_dbv_enum(psStateTransitionProblem->eCurrentState, CS_NotSupplied, CS_Unknown ) == SI_NOTOK) {
		DBVsa_strcat(local_error_buffer, "eCurrentState");
		return(DBVdbv_invalid_enum_error(lAssocId, local_error_buffer, ppsSIError));
	}

	
	return SI_OK;
}











